%  TINEREAD reads data from the control system  
%
% In the call VAL = TINEREAD(DEVPROPSTR) DEVPROPSTR is a string composed 
% of the server context CONTEXT, server name SERVER, the device name DEV 
% and the device properties PROP1, PROP2,... etc.
% where the server context (e.g. HERA, PETRA, etc.) is optional.
% The command returns the data in a structure composed of 
% an error string VAL.ERRROR and the property information as 
% elements of the structure VAL. In case of no error 
% ERROR is empty; otherwise it contains an error value number.
%
% Syntax:
%   tineread('/<CONTEXT>/<SERVER>/<DEV>[<PROP1>;<PROP2>;...]')
% Or:
%   tineread('<SERVER>/<DEV>[<PROP1>;<PROP2>;...]')
%
% Example:
%   val = tineread('/HERA/HeEOrbit/WL   791[ORBIT.X;ORBIT.Z]')
%
% Listener:    @rate   [msec]   @0  no listener
%
%