/* tinewrite.cpp   Interface zur Tine-Library          */
/* last modified   MH 1.10.2002                      */
/*                 MH, JK 18.6.2003                  */


#include <iostream.h>
#include <math.h>
#include "mex.h"
#include <windows.h>

#define DEBUG 0
#define	PROPMAX	1024
#define	PROPMAX1 512
/* changed from 24000 to 65000     MH */
#define	MAX_TINE_BUFFER 65000
#include "win32rpctypes.h"
short ftoi(char *fmt)
{
  char *c,fmtstr[64];
  short ifmt;
  strncpy(fmtstr,fmt,64);
  if ((c=strchr(fmtstr,'.')) != NULL) *c = 0;
  strupr(fmtstr);
  if ((ifmt=getSimpleFormatType(fmtstr)) != CF_NULL) return ifmt;
  return getCompoundFormatType(fmtstr);
}
int fastExecLink(char *devName,char *devProperty,
             DTYPE *dout,DTYPE *din,short access,int timeout)
{
  int cc,retry=2;
  DBLK dbout,dbin, *dboutptr = &dbout, *dbinptr = &dbin;
  void *dataout, *datain;

  if (dout != NULL)
  {  
    dbout.dFormat = dout->dFormat;
    dbout.dArrayLength = dout->dArrayLength;
    memcpy(dbout.dTag,dout->dTag,8);
    dataout = dout->data.vptr;
  }
  else
  {
    dboutptr = NULL;
    dataout = NULL;
  }
  if (din != NULL)
  {
    dbin.dFormat = din->dFormat;
    dbin.dArrayLength = din->dArrayLength;
    memcpy(dbin.dTag,din->dTag,8);
    datain = din->data.vptr;
  }
  else
  { 
    dbinptr = NULL;
    datain = NULL;
  }
  if (timeout < 100) timeout = 100;
  while (retry--)
  {
    if ((cc=EXECLINKEx(devName,devProperty,dboutptr,dataout,dbinptr,datain,access,timeout)) == 0) break;
  }
  return cc;
}

int	read_prop(char *dev, char *prop, int* size)
{
  PropertyQueryStruct	svrProp;
	DTYPE dout, din;
	int cc;

	dout.dFormat = CF_STRUCT;
	dout.dArrayLength = PROPERTYQUERYSTRUCT_SIZE;
	dout.data.vptr = &svrProp;
	dout.dTag[0] = '\0';

	din.dFormat = CF_TEXT;
	din.dArrayLength = strlen(prop);
	din.data.vptr = prop;
	din.dTag[0] = '\0';
	svrProp.prpName[0] = '\0';
	if ((cc=fastExecLink(dev, "PROPS", &dout, &din, CA_READ,500)) !=0)
  {
		*size = 0;
		return -1;
	}
	if (svrProp.prpName[0] == 0 ) 
  {
		*size = 0;
		return -1;
	}
	*size = svrProp.prpSize;
	return LFMT(svrProp.prpFormat);
}

int	write_data(char *dev, char *prop, int type, int size, char *buf,int timeout)
{
  DTYPE	din;
  int	cc;

  din.dFormat = type;
  din.dArrayLength = size;
  din.data.vptr = (void *)&buf[0];
  din.dTag[0] = 0;
  cc = fastExecLink(dev, prop, NULL, &din, CA_WRITE,timeout);
  if(cc && cc != -141)
  {
    GetRPCLastError(cc,buf);
    return 1;
  }
  return 0;
}

void mexFunction(int lcnt, mxArray *lsp[], int rcnt, const mxArray *rsp[]) 
{
	char Buffer[MAX_TINE_BUFFER];
	double *lp;
	DTYPE	dout,din;
	char *name;
	char *p;
	char buf[1024];
	char bf1[1024],*c=NULL, *c1=NULL, *c2=NULL, *c3=NULL;
  char dtstr[32];
	char dev[80];
	int	len,type,size,fmtsiz,readsize = -1,ln,rate=500,datatype = -1;
	int	i,j,k,err,count,n;
	float fl;
	char *pf;
	
  if ((rcnt < 1) || (rsp == NULL)) 
  {
    lsp[0] = mxCreateString("Usage: error=heraw(value,\'<SERVER>/<DEV>[<PROP>]\')");
    return;
  }

  if (rcnt != 2 || !mxIsChar(rsp[1]))
  {
    if (rcnt == 1 || !mxIsChar(rsp[0]))
    {
      len = mxGetN(rsp[0]) + 1;
      name = (char *)mxCalloc(len, sizeof(char));
      mxGetString(rsp[0],name,len);
      lsp[0] = mxCreateString("Usage: error=heraw(value,\'<SERVER>/<DEV>[<PROP>]\');\n where value - string or double Nx1 array\nThe error contains error message!!!");
      mxFree(name);
    }
    else
    {
      lsp[0] = mxCreateString("Input argument error !!!");
    }
    return;
  }
	
  len = mxGetN(rsp[1]) + 1;
  name = (char *)mxCalloc(len, sizeof(char));
  mxGetString(rsp[1],name,len);
  strcpy(buf,name);
  if((p=strchr(name,'[')) == NULL || (p=strchr(name,']')) == NULL)
  {
    lsp[0] = mxCreateString("using: error = heraw(A,'dev/loc[prop]')");
    mxFree(name);
    return;
  }
  mxFree(name);

  if ((c1=strchr(buf,'<')) != NULL)
  {
    c = c1; c++;
	  strncpy(bf1,c,sizeof(bf1));
    for (c2=bf1; *c2 == ' '; c2++);  // any leading blanks?
    readsize = atoi(c2);
    if ((c2=strchr(c2,' ')) != NULL) // is the datatype left to parse out ?
    {
      while (*c2 == ' ') c2++;       // remove all leading blanks
      if ((c3=strchr(c2,'>')) != NULL) *c3 = 0;
      strncpy(dtstr,c2,32);
      strupr(dtstr);
      if (dtstr[strlen(dtstr)-1] == 'S') dtstr[strlen(dtstr)-1] = 0;
      datatype = ftoi(dtstr);
    }
  }
  if ((c=strchr(buf,'@')) != NULL)
  {
    *c++ = 0; // peel it off before we start tokenizing
    rate = atoi(c);
  }
  if (c1 != NULL) *c1 = 0; // peel this one off too, if it's there
  
  strcpy(dev,strtok(buf,"["));
	strncpy(bf1,"",sizeof(bf1));
	strcpy(bf1,strtok(NULL,"]"));
  if (readsize < 0 || datatype < 0)
  {
		type = read_prop(dev, bf1, &size);
  }
  if (readsize > 0) size = readsize;
  if (datatype > 0) type = datatype;

#if DEBUG
	printf("heraw: dev='%s', bfl='%s', parameter type=%d size=%d\n", dev, bf1, type, size);
#endif

  switch(type)
  {
/* Eingefuegt   MH 01.10.2002   */
    default:
#if DEBUG	  
      printf("heraw: default parametertyp %d \n",type);
      printf("Size %d \n",size);
#endif
      if(!mxIsChar(rsp[0]))
      {
        lsp[0] = mxCreateString("Input argument error !!!");
        return;
      }
      len = mxGetN(rsp[0]);
#if DEBUG			
      printf("len %d \n",len);
#endif
      mxGetString(rsp[0],Buffer,len);
      if(getFormatSize(type)) 
      {  
	      size=len/getFormatSize(type);
      } 
      else 
      {
	      size=len;
      } 
#if DEBUG			
      printf("Size now %d \n",size);
      printf("Bufferinhalt:  \n");
      for(i=0;i<len;i++) 
      {
	      printf(" %02x",Buffer[i] & 255);
	      if(((i+1)%24)==0) printf("\n");
      }
      printf("\n");
#endif	
    	break;    
/*  ---   */        
    case CF_TEXT:
      if(!mxIsChar(rsp[0]))
      {
	      lsp[0] = mxCreateString("Input argument error !!!");
	      return;
      }
      len = mxGetN(rsp[0]) + 1;
      mxGetString(rsp[0],Buffer,len);
      break;
      // this below is wrong ...
    case CF_CHAR8:
    case CF_CHAR16:
    case CF_CHAR32:
    case CF_CHAR48:
    case CF_USTRING:
      if(!mxIsChar(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			len = mxGetN(rsp[0]) + 1;
			mxGetString(rsp[0],Buffer,len);
  		break;
		case CF_BYTE:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if(n < size)	
			    size = n;
			for(i = 0; i < size; i++) 
			    Buffer[i] = (char)lp[i];
		  break;
		
		case CF_SHORT:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if (n < size)	
			    size = n;
			for (i = 0; i < size; i++) 
			    *(short *)&Buffer[2*i] = (short)lp[i];
		break;
		
		case CF_UINT32:
		case CF_BOOLEAN:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if (n < size)	
			    size = n;
			for(i = 0; i < size; i++) 
			    *(u_int *)&Buffer[4*i] = (u_int)lp[i];
		  break;
		
		case CF_FLOAT:
			if (!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if (n < size)
			    size = n;
			for (i = 0; i < size; i++) 
      {
#if DEBUG
			  printf("#%d: %f\n", i, lp[i]);
#endif
				*(float *)&Buffer[4*i] = (float)lp[i];
			}
#if DEBUG
			for (i = 0; i < 4*size; i++) 
      {
			  printf("%02x ", Buffer[i]);
			}
			printf("\n");
#endif
		  break;
		
		case CF_DOUBLE:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if(n < size)
			    size = n;
			for(i = 0; i < size; i++) 
      {
			  printf("#%d: %f\n", i, lp[i]);
			  *(double *)&Buffer[i] = (double)lp[i];
			}
		  break;
		
		case CF_FI:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if(n < size)	size = n;
			for(i = 0; i < size; i+=2)
      {
				*(float *)&Buffer[4*i] = (float)lp[i];
				*(int *)&Buffer[4*i+4] = (int)lp[i+1];
			}
		  break;
		
		case CF_II:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if(n < size)	size = n;
			for(i = 0; i < size; i+=2)
      {
				*(int *)&Buffer[4*i]   = (int)lp[i];
				*(int *)&Buffer[4*i+4] = (int)lp[i+1];
			}
		  break;
		
		case CF_IFFF:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if(n < size)	size = n;
			for(i = 0; i < size; i+=4)
      {
				*(int *)&Buffer[4*i]      = (int)lp[i];
				*(float *)&Buffer[4*i+4]  = (float)lp[i+1];
				*(float *)&Buffer[4*i+8]  = (float)lp[i+2];
				*(float *)&Buffer[4*i+16] = (float)lp[i+3];
			}
      break;
		
		case CF_IIII:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if(n < size)	size = n;
			for(i = 0; i < size; i+=4)
      {
				*(int *)&Buffer[4*i]    = (int)lp[i];
				*(int *)&Buffer[4*i+4]  = (int)lp[i+1];
				*(int *)&Buffer[4*i+8]  = (int)lp[i+2];
				*(int *)&Buffer[4*i+16] = (int)lp[i+3];
			}
		  break;
		
		case CF_TTII:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			n = mxGetM(rsp[0]);
			if(n < size)	size = n;
			for(i = 0; i < size; i+=4)
      {
				*(time_t *)Buffer[4*i]   = (time_t)lp[i];
				*(time_t *)Buffer[4*i+4] = (time_t)lp[i+1];
				*(int *)Buffer[4*i+8]	 = (int)lp[i+2];
				*(int *)Buffer[4*i+16]	 = (int)lp[i+3];
			}
		  break;
/*
		case CF_SPECTRUM:
		need 3 call
		break;
		case CF_TDS:
		write hist ????????
		break;
*/
	}
	err = write_data(dev,bf1,type,size,Buffer,rate);
	if(err)	lsp	[0] = mxCreateString(Buffer);
	else	lsp	[0] = mxCreateString("");
}