/*========================= Fast Current DATA FROM PKTR NET ========================*/
#ifndef CMFLVER

#define CMFLVER 101

#ifndef MSDOS
#define INT_32 unsigned int
#else
#define INT_32 unsigned long
#endif
#define CF_INT_32 CF_LONG


/*

The information from HERAP.H or HERADATA.H pertaining to the 2 GHz Bunch Shape Measurement
namely:

NETKEY HPINJDL={ "HERADATA","HPINJDL",CF_SHORT,1,1,RC_INI,T_INIT,ST_INI,HPVER,(void*)HPINJDL_s };
NETKEY HPBUCKT={ "HERADATA","HPBUCKT",CF_SHORT,1,1,RC_INI,T_INIT,ST_INI,HPVER,(void*)HPBUCKT_s };
NETKEY HPflags={ "HERADATA","HPflags",CF_SHORT,1,1,RC_INI,T_INIT,ST_INI,HPVER,(void*)HPINJDL_s };
NETKEY HPlastT={ "HERADATA","HPlastT",CF_INT_32,1,1,RC_INI,T_INIT,ST_INI,HPVER,(void*)HPlastT_i };
NETKEY HPFWHM={ "HERADATA","HPFWHM",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HPVER,(void*)HPFWHM_f };
NETKEY HPphase={ "HERADATA","HPphase",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HPVER,(void*)HPphase_f };
NETKEY HParea={ "HERADATA","HParea",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HPVER,(void*)HParea_f };

is largely duplicated in the CMFL structure below.  If there is no interest in obtaining the
scope trace, it is suggested to remain in contact with "HERADATA" for this
information.  The designated server below is in fact the source machine.

*/
struct CMFL
{
  short npnts;        /* length of trace in points */
  short timle;        /* length of trace in nsec */
  short trigd;        /* length of scope trigger delay in nsec */
  short atten;        /* attenuation factor in dB */
  short injdl;        /* Delay in turns*64 after injection */
  short buckt;        /* HIT RF Bucket # */
  short flags;        /* 0=Normal 1=1rst Trace 2=Background */
  short lastt;        /* Time of most recent Injection - sec (low word - to be ANDed with timeh */
  short fwhml;        /* fwhm in psec (low word) */
  short fwhmh;        /* fwhm in psec (high word) */
  short phasl;        /* phase in psec from trigger (low word) */
  short phash;        /* phase in psec from trigger (high word) */
  short areal;        /* area under trace in nAmp (low word) */
  short areah;        /* area under trace in nAmp (high word) */
  short timel;        /* time stamp in sec since 1970 (low word) */
  short timeh;        /* time stamp in sec since 1970 (high word) */
  short trace[256];   /* Scope trace */
} cmfl;

NETKEY HPCMFL={ "CMFL","TRACE",CF_SHORT,272,1,RC_INI,T_INIT,ST_INI,CMFLVER,(void *)&cmfl };

#endif /* CMFLVER */
