/*=========================  DATA FROM PKTR NET ========================*/
#ifndef HERABVDSVER
#define VER 301
/*

  HPVER 301: first release February 9, 2000  V.Rybnikov


*/

#ifndef MSDOS
#define INT_32 unsigned int
#else
#define INT_32 unsigned long
#endif
#define CF_INT_32 CF_LONG

/****** HERA-B VDS pots position server data **update rate 0.5 Hz unless otherwise noted ****/

/*      Timestamps categories:

          T0 - Timestamp refers to the time the data were taken.

          T1 - Timestamp refers to the time the data were last 
               requested from the source server.  For most volatile
               parameters, this will still be a good reflection of the
               value at that time.


          T2 - Timestamp refers to the time the data are being 
               requested from the (data) server.  
                
*/ 

/**************************************************************************/

#define NOSS 1
long int HBVDSstatus_i[NOSS]; /* Status of the local HERA-B VDS position server
			       1 - one can trust the data;
			       0 - data can be invalid
			       Timestamp:  Category  T2 
			     */
             
NETKEY HBVDSstatus={ "MEX-HBVD","HBVDSSTS",CF_LONG,NOSS,0,RC_INI,T_INIT,ST_INI,VER,(void*)HBVDSstatus_i };

/**************************************************************************/

#define NOSR 16
float HBVDSRadial_f[NOSR]; /* Radial position of the pots (in mm) 
			      as the following:
			      station 10x above, outer, bellow, inner;
			      station 30x above, outer, bellow, inner; 	
			      station 40x above, outer, bellow, inner;
			      station 50x above, outer, bellow, inner;
			      Timestamp:  Category  T1 
			   */

                
NETKEY HBVDSRadial={ "MEX-HBVD","HBVDSRADPOS",CF_FLOAT,NOSR,0,RC_INI,T_INIT,ST_INI,VER,(void*)HBVDSRadial_f };

/**************************************************************************/

#define NOSL 16 
float HBVDSLateral_f[NOSL]; /* Lateral position of the pots (in mm) 
			       as the following:
			       station 10x above, outer, bellow, inner;
			       station 30x above, outer, bellow, inner;
			       station 40x above, outer, bellow, inner;
			       station 50x above, outer, bellow, inner;
			       Timestamp:  Category  T1
			    */

NETKEY HBVDSLateral={ "MEX-HBVD","HBVDSLATPOS",CF_FLOAT,NOSL,0,RC_INI,T_INIT,ST_INI,VER,(void*)HBVDSLateral_f };

/**************************************************************************/

#define NOFL  2
short HBVDSflags_s[NOFL];    /* Status flags  for axis data validation
			       bit/axis
			       1 - data valid
			       0 - data invalid
			       bits mapping as the following:
			       radial axis: see radial position of the pots
			       lateral axis: see lateral position of the pots
			       Timestamp:  Category  T1 
			     */
        
NETKEY HBVDSflags={ "MEX-HBVD","HBVDSFLS",CF_SHORT, NOFL,0,RC_INI,T_INIT,ST_INI,VER,(void*)&HBVDSflags_s };

/**************************************************************************/

#define NORF  4
unsigned char HBVDSrf_c[NORF];  /* RF shields status 
			       
			       1 - touched by the pot
			       0 - in other case

			       bytes mapping as the following:
			       0 - 10x above pot
			       1 - 10x outer pot
			       2 - 10x bellow pot
			       3 - 10x inner pot
			       Timestamp:  Category  T1 
			     */
              
NETKEY HBVDSrf={ "MEX-HBVD","HBVDSRFS",CF_UINT8,NORF,0,RC_INI,T_INIT,ST_INI,VER,(void*)&HBVDSrf_c };

/**************************************************************************/
#endif /* HERABVDSVER */

