/*========================= HERAE DATA FROM MKI3 NET ========================*/

#ifndef HEVER
#define HEVER 107

/*
	HEVER 107: relocate HEbpmXH1, HEbpmYH1, HEbpmXZU, HEbpmYZU, 
		   HEbpmXHB, HEbpmYHB, HEbpmXHE, HEbpmYHE, 
		   HEcolPH1, HEcolPH1, HEcolPZU, HEcolPZU, 
		   HEcolPHB, HEcolPHB, HEcolPHE, HEcolPHE,
		   HEMSTH1, HEMSTH1, HEMSTZU, HEMSTZU to HERAP.H

	HEVER 106: relocate HEMAGEN, HPMAGEN keywords to HERAP.H

	HEVER 105: add keywords:
	HEcolPHB

	HEVER 104: add keywords:
	HEbpmXB and HEbpmYB

	HEVER 103: add keywords:
  HEinjPh, HPinjPh, HP208Ph, HEinjSt, HPinjSt

  HEVER 102: add keywords:
  HEmstZU, HEmstH1, HPbpmXWW, HPbpmYWW, HEbpmXWW, HEbpmYWW

*/

#ifndef MSDOS
#define INT_32 unsigned int
#else
#define INT_32 unsigned long
#endif
#define CF_INT_32 CF_LONG


/****** HERA Proton Machine data ** nominal update rate 1 second ****/


/* the following values are generally updated at 1 Hz from the MKI3 NET. */
/* These values are also read from MKI NETMEX DISK FILE, which acts as a */
/* backup mechanism in case the front ends are temporarily set to the NORDs */

/* NOTE: the keyword indicates that these are the summed bunched currents */
/*       but they are not.  They are the DC Current values (identical with */
/*       HEDCCur and HPDCCur from herap.h */

float HPSUCURR_f[1];        /* mki file value for summed proton beam current - ma */
float HESUCURR_f[1];        /* mki file value for summed electron beam current - ma */
float HPSULIFE_f[1];        /* mki file value for proton lifetime - hours */
float HESULIFE_f[1];        /* mki file value for electron lifetime - hours */
NETKEY HPSUCURR={ "MKIDATA","HPSUCURR",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HPSUCURR_f };
NETKEY HESUCURR={ "MKIDATA","HESUCURR",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HESUCURR_f };
NETKEY HPSULIFE={ "MKIDATA","HPSULIFE",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HPSULIFE_f };
NETKEY HESULIFE={ "MKIDATA","HESULIFE",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HESULIFE_f };

/* more data from MKI, added 25.04.95 */

double HEHFREQ_d[1];         /* mki file value for Hera-E RF frequency, MHz */
double HPHFREQ_d[1];         /* mki file value for hera-P RF frequency, MHz */
NETKEY HEHFREQ={ "MKIDATA","HEHFREQ",CF_DOUBLE,1,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HEHFREQ_d };
NETKEY HPHFREQ={ "MKIDATA","HPHFREQ",CF_DOUBLE,1,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HPHFREQ_d };

			   /* bpms at 7m see both E & P : unreliable when both beams present */
			   /* when no E beam present (HESUCURR=0) monitors read 0.000 !!     */
float HEvacAPR_f[1];        /* mki file value for Hera-E avg. pressure, mBar */
NETKEY HEvacAPR={ "MKIDATA","HEvacAPR",CF_FLOAT,1,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HEvacAPR_f };

#define HERATXT_NO 48
char  HERATXT1_c[HERATXT_NO];       /* mki file Hera Text status line 1 */
char  HERATXT2_c[HERATXT_NO];       /* mki file Hera Text status line 2 */
NETKEY HERATXT1={ "MKIDATA","HERATXT1",CF_TEXT,HERATXT_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HERATXT1_c };
NETKEY HERATXT2={ "MKIDATA","HERATXT2",CF_TEXT,HERATXT_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HERATXT2_c };

#define HERARUN_NO 1
short HERUNNUM_s[HERARUN_NO];
NETKEY HERUNNUM={ "MKIDATA","HERUNNUM",CF_SHORT,HERARUN_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HERUNNUM_s };
short HPRUNNUM_s[HERARUN_NO];
NETKEY HPRUNNUM={ "MKIDATA","HPRUNNUM",CF_SHORT,HERARUN_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HPRUNNUM_s };

#define WWBPM_NO 4
float HPbpmXWW_f[WWBPM_NO];       /* Hera-P X BPM at ZEUS/H1 Interaction */
float HPbpmYWW_f[WWBPM_NO];       /* Hera-P Y BPM at ZEUS/H1 Interaction */
float HEbpmXWW_f[WWBPM_NO];       /* Hera-E X BPM at ZEUS/H1 Interaction */
float HEbpmYWW_f[WWBPM_NO];       /* Hera-E Y BPM at ZEUS/H1 Interaction */

#define HEINJ_NO 1
float HEinjPh_f[HEINJ_NO];        /* Hera-E Injection Phase */
NETKEY HEinjPh={ "MKIDATA","HEinjPh",CF_FLOAT,HEINJ_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HEinjPh_f };
#define HPINJ_NO 1             
float HPinjPh_f[HPINJ_NO];       /* Hera-P Injection Phase */
NETKEY HPinjPh={ "MKIDATA","HPinjPh",CF_FLOAT,HPINJ_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HPinjPh_f };
float HP208Ph_f[HPINJ_NO];       /* Hera-P 208 Hz Injection Phase */
NETKEY HP208Ph={ "MKIDATA","HP208Ph",CF_FLOAT,HPINJ_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HP208Ph_f };
short HPinjSt_s[HPINJ_NO];       /* Hera-P Injection Status */
NETKEY HPinjSt={ "MKIDATA","HPinjSt",CF_SHORT,HPINJ_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HPinjSt_s };
short HEinjSt_s[HEINJ_NO];       /* Hera-E Injection Status */
NETKEY HEinjSt={ "MKIDATA","HEinjSt",CF_SHORT,HEINJ_NO,1,RC_INI,T_INIT,ST_INI,HEVER,(void*)HEinjSt_s };

#endif /* HEVER */
