#ifndef HMAGCUR_H
#define HMAGCUR_H
#define HMAGVER 203  /* new file for Sun data structs  23.07.98, s. herb */
/* --------------- HERA PSC CURRENTS (Magnet Settings) 23.07.98 -------------------------
updates:

   version 203 (12.4.01 pd):
     changed float HPMAINO_n[HPMAINO_NO]  to   NAME8 HPMAINO_n[HPMAINO_NO];
   version 202 (9.4.01 pd):
     changed HEHCORO_NO to 68 instead of 70
   version 201 (19.4.99 ): 
     added keyword HPMAINHB and HPMAINHBQ (Hera-B magnets)
 
The magnets are organized by machine, type, and quadrant into about 20 groups:
HEHCORW,N,O,S = Hera E Horizontal Correctors in West,North,East,South
HEVCORW,N,O,S = Hera E Vertical Correctors
HPCORW,N,O,S = Hera P Horiz AND Vert Correctors
HEMAINW,N,O,S = Hera E 'Main' (large bends, quads, sextupoles)
HPMAINW,N,O,S = Hera P 'Main'
HEDIPOL = Hera E Dipol
HPDIPOL = Hera P Dipol

HPMAINHB = Hera P Main magnets in Hera-B area

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DATA DESCRIPTION:
HEHCORW, etc (magnet current call)
- Type, Units: Float value for Amperes
- Update Rate 1 sec (???)
- Source 'HMAGSERV' = Hera Magnet Server (also source for E,P energy)
HEHCORWQ, etc (name query call)
- Type, Units:  8 char names with MPY Optics Name for Machine Element (may be different from last year!!)
- Update Rate: Change of Hera Magnet Configuration (ie at least once per year)\
- Source 'HMAGSERV' = Hera Magnet Server
NOTES for USERS:
- It will be possible in the future to modify the group structures to better suit user needs, but
  not this year.  What do you want ??
- We don't yet know what data rates from the Hera Machine DataServer will be practical
*/
#define HEHCORW_NO 78
float HEHCORW_f[HEHCORW_NO];
NAME8 HEHCORW_n[HEHCORW_NO];
NETKEY HEHCORW = { "HERADATA","HEHCORW",CF_FLOAT,HEHCORW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORW_f }; 
NETKEY HEHCORWQ = { "HERADATA","HEHCORWQ",CF_STRING8,HEHCORW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORW_n }; 
#define HEHCORN_NO 64
float HEHCORN_f[HEHCORN_NO];
NAME8 HEHCORN_n[HEHCORN_NO];
NETKEY HEHCORN = { "HERADATA","HEHCORN",CF_FLOAT,HEHCORN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORN_f }; 
NETKEY HEHCORNQ = { "HERADATA","HEHCORNQ",CF_STRING8,HEHCORN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORN_n }; 
#define HEHCORO_NO 68
float HEHCORO_f[HEHCORO_NO];
NAME8 HEHCORO_n[HEHCORO_NO];
NETKEY HEHCORO = { "HERADATA","HEHCORO",CF_FLOAT,HEHCORO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORO_f }; 
NETKEY HEHCOROQ = { "HERADATA","HEHCOROQ",CF_STRING8,HEHCORO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORO_n }; 
#define HEHCORS_NO 64
float HEHCORS_f[HEHCORS_NO];
NAME8 HEHCORS_n[HEHCORS_NO];
NETKEY HEHCORS = { "HERADATA","HEHCORS",CF_FLOAT,HEHCORS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORS_f }; 
NETKEY HEHCORSQ = { "HERADATA","HEHCORSQ",CF_STRING8,HEHCORS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEHCORS_n }; 
#define HEVCORW_NO 76
float HEVCORW_f[HEVCORW_NO];
NAME8 HEVCORW_n[HEVCORW_NO];
NETKEY HEVCORW = { "HERADATA","HEVCORW",CF_FLOAT,HEVCORW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORW_f }; 
NETKEY HEVCORWQ = { "HERADATA","HEVCORWQ",CF_STRING8,HEVCORW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORW_n }; 
#define HEVCORN_NO 65
float HEVCORN_f[HEVCORN_NO];
NAME8 HEVCORN_n[HEVCORN_NO];
NETKEY HEVCORN = { "HERADATA","HEVCORN",CF_FLOAT,HEVCORN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORN_f }; 
NETKEY HEVCORNQ = { "HERADATA","HEVCORNQ",CF_STRING8,HEVCORN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORN_n }; 
#define HEVCORO_NO 67
float HEVCORO_f[HEVCORO_NO];
NAME8 HEVCORO_n[HEVCORO_NO];
NETKEY HEVCORO = { "HERADATA","HEVCORO",CF_FLOAT,HEVCORO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORO_f }; 
NETKEY HEVCOROQ = { "HERADATA","HEVCOROQ",CF_STRING8,HEVCORO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORO_n }; 
#define HEVCORS_NO 65
float HEVCORS_f[HEVCORS_NO];
NAME8 HEVCORS_n[HEVCORS_NO];
NETKEY HEVCORS = { "HERADATA","HEVCORS",CF_FLOAT,HEVCORS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORS_f }; 
NETKEY HEVCORSQ = { "HERADATA","HEVCORSQ",CF_STRING8,HEVCORS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEVCORS_n }; 
#define HPCORW_NO 62
float HPCORW_f[HPCORW_NO];
NAME8 HPCORW_n[HPCORW_NO];
NETKEY HPCORW = { "HERADATA","HPCORW",CF_FLOAT,HPCORW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORW_f }; 
NETKEY HPCORWQ = { "HERADATA","HPCORWQ",CF_STRING8,HPCORW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORW_n }; 
#define HPCORN_NO 66
float HPCORN_f[HPCORN_NO];
NAME8 HPCORN_n[HPCORN_NO];
NETKEY HPCORN = { "HERADATA","HPCORN",CF_FLOAT,HPCORN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORN_f }; 
NETKEY HPCORNQ = { "HERADATA","HPCORNQ",CF_STRING8,HPCORN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORN_n }; 
#define HPCORO_NO 60
float HPCORO_f[HPCORO_NO];
NAME8 HPCORO_n[HPCORO_NO];
NETKEY HPCORO = { "HERADATA","HPCORO",CF_FLOAT,HPCORO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORO_f }; 
NETKEY HPCOROQ = { "HERADATA","HPCOROQ",CF_STRING8,HPCORO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORO_n }; 
#define HPCORS_NO 66
float HPCORS_f[HPCORS_NO];
NAME8 HPCORS_n[HPCORS_NO];
NETKEY HPCORS = { "HERADATA","HPCORS",CF_FLOAT,HPCORS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORS_f }; 
NETKEY HPCORSQ = { "HERADATA","HPCORSQ",CF_STRING8,HPCORS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPCORS_n }; 
#define HEMAINW_NO 43
float HEMAINW_f[HEMAINW_NO];
NAME8 HEMAINW_n[HEMAINW_NO];
NETKEY HEMAINW = { "HERADATA","HEMAINW",CF_FLOAT,HEMAINW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINW_f }; 
NETKEY HEMAINWQ = { "HERADATA","HEMAINWQ",CF_STRING8,HEMAINW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINW_n }; 
#define HEMAINN_NO 77
float HEMAINN_f[HEMAINN_NO];
NAME8 HEMAINN_n[HEMAINN_NO];
NETKEY HEMAINN = { "HERADATA","HEMAINN",CF_FLOAT,HEMAINN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINN_f }; 
NETKEY HEMAINNQ = { "HERADATA","HEMAINNQ",CF_STRING8,HEMAINN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINN_n }; 
#define HEMAINO_NO 49
float HEMAINO_f[HEMAINO_NO];
NAME8 HEMAINO_n[HEMAINO_NO];
NETKEY HEMAINO = { "HERADATA","HEMAINO",CF_FLOAT,HEMAINO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINO_f }; 
NETKEY HEMAINOQ = { "HERADATA","HEMAINOQ",CF_STRING8,HEMAINO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINO_n }; 
#define HEMAINS_NO 78
float HEMAINS_f[HEMAINS_NO];
NAME8 HEMAINS_n[HEMAINS_NO];
NETKEY HEMAINS = { "HERADATA","HEMAINS",CF_FLOAT,HEMAINS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINS_f }; 
NETKEY HEMAINSQ = { "HERADATA","HEMAINSQ",CF_STRING8,HEMAINS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEMAINS_n }; 
#define HPMAINW_NO 31
float HPMAINW_f[HPMAINW_NO];
NAME8 HPMAINW_n[HPMAINW_NO];
NETKEY HPMAINW = { "HERADATA","HPMAINW",CF_FLOAT,HPMAINW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINW_f }; 
NETKEY HPMAINWQ = { "HERADATA","HPMAINWQ",CF_STRING8,HPMAINW_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINW_n }; 
#define HPMAINN_NO 38
float HPMAINN_f[HPMAINN_NO];
NAME8 HPMAINN_n[HPMAINN_NO];
NETKEY HPMAINN = { "HERADATA","HPMAINN",CF_FLOAT,HPMAINN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINN_f }; 
NETKEY HPMAINNQ = { "HERADATA","HPMAINNQ",CF_STRING8,HPMAINN_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINN_n }; 
#define HPMAINO_NO 29
float HPMAINO_f[HPMAINO_NO];
NAME8 HPMAINO_n[HPMAINO_NO];
NETKEY HPMAINO = { "HERADATA","HPMAINO",CF_FLOAT,HPMAINO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINO_f }; 
NETKEY HPMAINOQ = { "HERADATA","HPMAINOQ",CF_STRING8,HPMAINO_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINO_n }; 
#define HPMAINS_NO 38
float HPMAINS_f[HPMAINS_NO];
NAME8 HPMAINS_n[HPMAINS_NO];
NETKEY HPMAINS = { "HERADATA","HPMAINS",CF_FLOAT,HPMAINS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINS_f }; 
NETKEY HPMAINSQ = { "HERADATA","HPMAINSQ",CF_STRING8,HPMAINS_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINS_n }; 
#define HEDIPOL_NO 1
float HEDIPOL_f[HEDIPOL_NO];
NAME8 HEDIPOL_n[HEDIPOL_NO];
NETKEY HEDIPOL = { "HERADATA","HEDIPOL",CF_FLOAT,HEDIPOL_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEDIPOL_f }; 
NETKEY HEDIPOLQ = { "HERADATA","HEDIPOLQ",CF_STRING8,HEDIPOL_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HEDIPOL_n }; 
#define HPDIPOL_NO 1
float HPDIPOL_f[HPDIPOL_NO];
NAME8 HPDIPOL_n[HPDIPOL_NO];
NETKEY HPDIPOL = { "HERADATA","HPDIPOL",CF_FLOAT,HPDIPOL_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPDIPOL_f }; 
NETKEY HPDIPOLQ = { "HERADATA","HPDIPOLQ",CF_STRING8,HPDIPOL_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPDIPOL_n }; 

#define HPMAINHB_NO 2
float HPMAINHB_f[HPMAINHB_NO];
NAME8 HPMAINHB_n[HPMAINHB_NO];
NETKEY HPMAINHB = { "HERADATA","HPMAINW",CF_FLOAT,HPMAINHB_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINHB_f }; 
NETKEY HPMAINHBQ = { "HERADATA","HPMAINWQ",CF_STRING8,HPMAINHB_NO,1,RC_INI,T_INIT,ST_INI,HMAGVER,(void*)HPMAINHB_n }; 

/*----------------------------------------------------------------------------------------------------------*/
#endif
