/*========================= DATA FROM PKTR NET ========================*/
#ifndef PCOLVER
#define PCOLVER 101

/*
*/

#ifndef MSDOS
#define INT_32 unsigned int
#else
#define INT_32 unsigned long
#endif
#define CF_INT_32 CF_LONG


/****** HERA Proton Collimator data ** nominal update rate 1 Hz unless otherwise noted ****/

/*      Timestamps categories:

          T0 - Timestamp refers to the time the data were taken.

                e.g. HPEmit is calculated only when the BKR operators
                initiate a wire scan.  Its timestamp refers to the
                time of the scan, and it can never be assumed that 
                by merely reading this value one has the present emittance.

          T1 - Timestamp refers to the time the data were last 
               requested from the source server.  For most volatile
               parameters, this will still be a good reflection of the
               value at that time.

                e.g. A request from the HERAP dataserver to get the
                collimator positions retrieves the collimator positions
                and a timestamp from the collimator server indicating
                when the call was made, which should be within milliseconds
                of when the position data were actually obtained.

          T2 - Timestamp refers to the time the data are being 
               requested from the (data) server.  
                
                e.g. If the HERAP dataserver does not explicitly set
                the timestamp for a keyword entry, the timestamp will 
                automatically be set to the time of the call (i.e. now).
                There is NO such case for keywords on the HERAP dataserver.

*/ 


/* Hera P Collimator rates in the following order (30 total values) */
/* [Aussen,Innen,Oben,Unten,Max.,Sum] WR094 - 6 values*/
/* [Aussen,Innen,Oben,Unten,Max.,Sum] WL105 - 6 values*/
/* [Aussen,Innen,Oben,Unten,Max.,Sum] WL150 - 6 values*/
/* [Aussen,Innen,Oben,Unten,Max.,Sum] WL019 - 6 values*/
/* [Aussen,Innen,Oben,Unten,Max.,Sum] WR033 - 6 values*/

#define KOLRATE_NO 30                     /* Timestamp:  Category  T1 */
                                          
float KOLRATES_f[KOLRATE_NO];               
NETKEY KOLRATES={ "SCRAPERS","RATES",CF_FLOAT,KOLRATE_NO,0,RC_INI,T_INIT,ST_INI,PCOLVER,(void*)KOLRATES_f };
                           
#endif /* PCOLVER */
