#ifndef ZLPSVER

#define ZLPSVER 103

/*
   Version 103 (24.08.98):
     LPS data now provided by ZEUS Netmex gateway,
     element2 of ZRates changed
*/
/*
  Version 102: Added keywords
     ZRates  Zeus LPS Rates (3 floats)
     ZStatus Zeus LPS Data-taking Status word (32 bits)
*/

/*      Timestamps categories:

          T0 - Timestamp refers to the time the data were taken.


          T1 - Timestamp refers to the time the data were last 
               requested from the source server.  For most volatile
               parameters, this will still be a good reflection of the
               value at that time.

          T2 - Timestamp refers to the time the data are being 
               requested from the (data) server.  

*/ 

#ifndef MSDOS
#define INT_32 unsigned int
#else
#define INT_32 unsigned long
#endif
#define CF_INT_32 CF_LONG

/*
An array of 20 floats yields:
element      0: LPS status = 1 if everything is okay
element      1: LPS panic  = 0 if there's no reason to panic
elements  2-10: the 9 Roman Pot positions in mm (S1 S2 S3 S4 SL63 S5 SL81 S6 SL90) 
elements 11-19: the 9 Roman Pot offsets in mm

Timestamp Category: T1
*/
#define NUM_ZRomanP 20
float ZRomanP_f[NUM_ZRomanP];
NETKEY ZRomanP={
"ZEUSDATA","ZLpsRomanP",CF_FLOAT,NUM_ZRomanP,1,RC_INI,T_INIT,ST_INI,ZLPSVER,(void
*)&ZRomanP_f[0]};

/*
   element    0: S4 UP Trigger rate in Hz
   element    1: S6 UP Trigger rate in Hz
   element    2: LPS BLM at SL116   in Hz <= S5 UP Trigger rate in Hz at the moment    

  Timestamp Category: T1
*/
#define NUM_ZRates 3
float ZRates_f[NUM_ZRates];
NETKEY ZRates={
"ZEUSDATA","ZLpsRates",CF_FLOAT,NUM_ZRates,0,RC_INI,T_INIT,ST_INI,ZLPSVER,(void
*)&ZRates_f[0]};

/*
  NOTE: this keyword will be implemented soon (currently unreliable - 24.9.96 )
  32 -bit data-taking status word
  bits 0-8: on  = corresponding pot is in data-taking position
            off = corresponding pot is out or moving

  Timestamp Category: T1
*/
#define NUM_ZStatus 1
INT_32 ZStatus_l[NUM_ZStatus];
NETKEY ZStatus={
"ZEUSDATA","ZLpsStatus",CF_LONG,NUM_ZStatus,0,RC_INI,T_INIT,ST_INI,ZLPSVER,(void
*)&ZStatus_l[0]};

#endif /* ZLPSVER */
