#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "toolkit.h"
#ifdef MSDOS
# include "doscmd.h"
# include "fecdef.h"
#endif
#ifdef SEDAC
# include "sedac.h"
#endif

extern int BroadcastServer;

void PostSystemInit(void);

int main(int argc, char *argv[])
{
	int cc;
	switch (argc)                           /* initial debug level */
	{           /* on UNIX or DOS stations: set debug = 1 (2,or 3) */
		case 2:              /* will dynamically set the debug level */
			NGdebug = atoi(argv[1]);
			break;
		default:
			NGdebug = 0;                              /* default level */
	}
	printf("Server running (debug level %d)\n",NGdebug);

# ifdef BROADCAST
	BroadcastServer = TRUE;
# endif
	MaxNumConnections = 10;

	/* init RPC server: */
	if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",erlst[cc]); exit(1); }

	/* if SEDAC FEC, initialize SEDAC */
# ifdef SEDAC
	SedacPortAddress = SEDAC_PORTADDR;
	nSedacLines = SEDAC;
//  SedacSimulate = 1;
	initSedac();
# endif
# ifdef WATCHDOG
	watchdogBaseAddress = WATCHDOG;
# endif

	AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
	/* call FEC specific initialization: */
	PostSystemInit();

	for(;;)
	{
		SystemCycle(TRUE);
	}
	return 0;
}
