#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#ifdef MSDOS
# include "doscmd.h"
# include "fecdef.h"
#endif
#ifdef SEDAC
# include "sedac.h"
#endif

void preSystemInit(void);
void postSystemInit(void);

#ifndef VXWORKS
int main(int argc, char *argv[])
{
  int cc;
  switch (argc)                           /* initial debug level */
  {           /* on UNIX or DOS stations: set debug = 1 (2,or 3) */
    case 2:              /* will dynamically set the debug level */
      NGdebug = atoi(argv[1]);
      break;
    default:
      NGdebug = 0;                              /* default level */
  }
#else
int RPCServer(void)
{
  int cc;
#endif
  printf("Server running (debug level %d)\n",NGdebug);

  /* call FEC specific initialization: */
  /*
     we include both preSystemInit() and postSystemInit() below to keep the
     symmetry with the server example.  A simple client application without
     server components should not make a call to SystemInit(), however.  
     Therefore the following 2 init routines could easily be combined into 1
  */

  preSystemInit();
  postSystemInit();

  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
