# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI     CC = cc         CCL = cc         LM = -lm
# OSF     CC = cc         CCL = cc         LM = -lm
# LINUX   CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

CC = cc -Aa
CCL = cc
LM = -lM

clnlib.a: coversrv.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o syslib.o 
	ar r $@ coversrv.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o syslib.o 

coversrv.o:  coversrv.c servdef.h prolog.h errors.h brdcast.h swaplib.h project.def
	${CC} coversrv.c

client.o: client.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} client.c

clnip.o: clnip.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} clnip.c

clnipx.o: clnipx.c prolog.h cprolog.h srvipx.h srvip.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} clnipx.c

iplib.o: iplib.c servdef.h prolog.h srvip.h errors.h project.def 
	${CC} iplib.c

dblib.o:  dblib.c database.h errors.h prolog.h project.def
	${CC} dblib.c

database.o: database.c prolog.h cprolog.h database.h servdef.h errors.h project.def
	${CC} database.c

err_list.o: err_list.c errors.h
	${CC} err_list.c

swaplib.o: swaplib.c swaplib.h prolog.h servdef.h errors.h
	${CC} swaplib.c 

syslib.o: syslib.c prolog.h servdef.h project.def
	${CC} syslib.c

clean:
	rm *.o
