package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public final class DevAddr
{
  public String FecName = new String(new StringBuffer(16));
  public byte[] reserved = new byte[3];
  public byte[] Port = new byte[2];
  public String TagName = new String(new StringBuffer(16));
  public String EqName = new String(new StringBuffer(7));
  public String Context = new String(new StringBuffer(16));
  public short alarmSystem;
  public String Info = new String(new StringBuffer(14));
  public byte[] Network = new byte[4];
  public byte[] Node = new byte[6];
  public byte[] ImmediateAddress = new byte[6];
  public String IP = new String(new StringBuffer(16));
  public byte PortOffset;
  public byte[] IPh_addr = new byte[4];
  public short  Prot;
  public static int sizeInBytes = (21+16+7+4+14) + (21+16+21+2);
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public short getPortOffset()
  {
    short poff;
    poff = (short)((Port[1] << 8) | Port[0]);
    if (poff == 0) poff = PortOffset;
    return poff;
  }
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      // Export Name information
      byte[] bstr = new byte[16];
      byte[] tmp  = FecName.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      for (int i=0; i<5; i++) bstr[i] = 0;
      ds.write(bstr,0,5);  // ignore reserved field
      tmp  = TagName.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      tmp  = EqName.getBytes();
      for (int i=0; i<7; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,7);
      tmp  = Context.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      ds.writeShort(Swap.Short(alarmSystem));
      // FEC Name information
      tmp  = FecName.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      ds.write(reserved,0,3);
      ds.write(Port,0,2);
      ds.write(Network,0,4);
      ds.write(Node,0,6);
      ds.write(ImmediateAddress,0,6);
      tmp = IP.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      ds.writeByte(PortOffset);
      ds.write(IPh_addr,0,4);
      ds.writeShort(Swap.Short(Prot));
      ds.close();	
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      // Export resolution information:
      byte[] bstr = new byte[16];
      ds.read(bstr,0,16);
      // fill in FecName with RPCFec structure below 
      bstr = new byte[5];
      ds.read(bstr,0,5);
      // ignore reserved field for now
      bstr = new byte[16];
      ds.read(bstr,0,16);
      TagName = new String(bstr);
      bstr = new byte[7];
      ds.read(bstr,0,7);
      EqName = new String(bstr);
      bstr = new byte[16];
      ds.read(bstr,0,16);
      Context = new String(bstr);
      alarmSystem = Swap.Short(ds.readShort());
      // FEC address information:
      bstr = new byte[16];
      ds.read(bstr,0,16);
      FecName = new String(bstr);
      bstr = new byte[3];
      ds.read(bstr,0,3);
      // ignore reserved field for now
      ds.read(Port,0,2);    
      ds.read(Network,0,4);
      ds.read(Node,0,6);
      ds.read(ImmediateAddress,0,6);
      bstr = new byte[16];
      ds.read(bstr,0,16);
      IP = new String(bstr);
      PortOffset = ds.readByte();
      ds.read(IPh_addr,0,4);
      Prot = Swap.Short(ds.readShort());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
  }  
}