/**
 * Title:        Instant Client<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Piotr Karol Bartkiewicz<p>
 * Company:      DESY<p>
 * @author Piotr Karol Bartkiewicz
 * @version 1.0
 */
package TINE;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class PropertyQuery
{
  //  Simple Property Query structure
  public  String    name;       // property name
  public  String    prpDesc;    //
  public  short     prpSize;    //
  public  byte      prpFormat;  //
  public  byte      prpAccess;  // ----------------------------
  
  public static int sizeInBytes = 68;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public PropertyQuery()
  {
    name = new String(new StringBuffer(32));
    prpDesc = new String(new StringBuffer(32));
  }  
  public byte[] toByteArray()
  {
    try
    {
    	dBuffer.reset();
    	DataOutputStream ds = new DataOutputStream(dBuffer);
    	byte[] bname = name.getBytes();
    	byte[] b = new byte[sizeInBytes];
    	for (int i=0; i<32 && i<bname.length; i++) b[i] = bname[i];
    	ds.write(b,0,32);
    	bname = prpDesc.getBytes();
    	for (int i=0; i<32 && i<bname.length; i++) b[i] = bname[i];
    	ds.write(b,0,32);
    	ds.writeShort(Swap.Short(prpSize));
    	ds.writeByte( prpFormat );
    	ds.writeByte( prpAccess );
    	ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toStruct()
  {
    int len;
    try
    {
    	ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
    	DataInputStream ds = new DataInputStream(dis);
    	byte[] b = new byte[32];
    	ds.read(b,0,32);
    	len = 0; for (int i=0; i<32 && b[i] != 0; i++, len++);
    	name = new String(b,0,len);
			ds.read(b,0,32);
    	len = 0; for (int i=0; i<32 && b[i] != 0; i++, len++);
    	prpDesc = new String(b,0,len);
    	prpSize = Swap.Short(ds.readShort());
  		prpFormat = ds.readByte();
  		prpAccess = ds.readByte();
    	ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }
  }  
}