package TINE;
/**
 * @version 	1.0
 * @author
 */
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class PropertyQueryEx
{
  //  Extended Property Query structure
  public  String    prpName;       // 32 character Property Name
  public  String    prpDescription;// 64 character Property Description
  public  String    prpRedirection;// 32 character Property redirection string
  public  String    prpTag;        // 8 character data tag (outbound)
  public  String    prpTagIn;      // 8 character data tag (inbound)
  public  String    prpUnits;      // 16 character engineering units
  public  float     prpMinValue;  // minimum value
  public  float     prpMaxValue;  // maximum value
  public  int       prpSize;      // Property dimension (outbound)
  public  int       prpSizeIn;    // Property dimension (inbound)
  public  int       prpNumOverloads;// number of overloads for Property Name
  public  short     prpHistoryDepthShort;// Short term history depth (ring buffer size)
  public  short     prpHistoryDepthLong; // Long term history depth in months
  public  byte      prpFormat;    // Datatype (outbound)  
  public  byte      prpFormatIn;  // Datatype (inbound)
  public  byte      prpAccess;    // Access mode(s) for Proptery
  public  byte      prpGraphType; // Graph stype for Property
  
  public static int sizeInBytes = 188;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public PropertyQueryEx()
  {
    prpName = new String(new StringBuffer(32));
    prpDescription = new String(new StringBuffer(64));
    prpRedirection = new String(new StringBuffer(32));
    prpTag = new String(new StringBuffer(8));
    prpTagIn = new String(new StringBuffer(8));
    prpUnits = new String(new StringBuffer(16));
  }  
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      // prpName
      byte[] bname = prpName.getBytes();
      byte[] b = new byte[sizeInBytes];
      for (int i=0; i<32 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,32);
      // prpDescription
      bname = prpDescription.getBytes();
      for (int i=0; i<64 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,64);
      // prpRedirection
      bname = prpRedirection.getBytes();
      for (int i=0; i<32 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,32);
      // prpTag
      bname = prpTag.getBytes();
      for (int i=0; i<8 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,8);
      // prpTagIn
      bname = prpTagIn.getBytes();
      for (int i=0; i<8 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,8);
      // prpUnits
      bname = prpUnits.getBytes();
      for (int i=0; i<16 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,16);
      // prpMinValue;
      ds.write(Swap.Float(prpMinValue),0,4);
      // prpMaxValue;
      ds.write(Swap.Float(prpMaxValue),0,4);
      // prpSize;
      ds.writeInt(Swap.Long(prpSize));
      // prpSizeIn;
      ds.writeInt(Swap.Long(prpSizeIn));
      // prpNumOverloads;
      ds.writeInt(Swap.Long(prpNumOverloads));
      // prpHistoryDepthShort;
      ds.writeInt(Swap.Short(prpHistoryDepthShort));
      // prpHistoryDepthLong;
      ds.writeInt(Swap.Short(prpHistoryDepthLong));
      // prpFormat;   
      ds.writeByte(prpFormat);
      // prpFormatIn; 
      ds.writeByte(prpFormatIn);
      // prpAccess;   
      ds.writeByte(prpAccess);
      // prpGraphType;
      ds.writeByte(prpGraphType);
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toStruct()
  {
    int len;
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      // prpName
      byte[] b = new byte[64];
      ds.read(b,0,32);
      len = 0; for (int i=0; i<32 && b[i] != 0; i++, len++);
      prpName = new String(b,0,len);
      // prpDescription      
      ds.read(b,0,64);
      len = 0; for (int i=0; i<64 && b[i] != 0; i++, len++);
      prpDescription = new String(b,0,len);
      // prpRedirection
      ds.read(b,0,32);
      len = 0; for (int i=0; i<32 && b[i] != 0; i++, len++);
      prpRedirection = new String(b,0,len);
      // prpTag
      ds.read(b,0,8);
      len = 0; for (int i=0; i<8 && b[i] != 0; i++, len++);
      prpTag = new String(b,0,len);
      // prpTagIn
      ds.read(b,0,8);
      len = 0; for (int i=0; i<8 && b[i] != 0; i++, len++);
      prpTagIn = new String(b,0,len);
      // prpUnits
      ds.read(b,0,16);
      len = 0; for (int i=0; i<16 && b[i] != 0; i++, len++);
      prpUnits = new String(b,0,len);
      // prpMinValue
      ds.read(b,0,4);
      prpMinValue = Swap.Float(b);
      // prpMaxValue
      ds.read(b,0,4);
      prpMaxValue = Swap.Float(b);
      // prpSize
      prpSize = Swap.Long(ds.readInt());
      // prpSizeIn
      prpSizeIn = Swap.Long(ds.readInt());
      // prpNumOverloads
      prpNumOverloads = Swap.Long(ds.readInt());
      // prpHistoryDepthShort
      prpHistoryDepthShort = Swap.Short(ds.readShort());
      // prpHistoryDepthLong
      prpHistoryDepthLong = Swap.Short(ds.readShort());
      // prpFormat
      prpFormat = ds.readByte();
      // prpFormatIn
      prpFormatIn = ds.readByte();
      // prpAccess
      prpAccess = ds.readByte();
      // prpGraphType
      prpGraphType = ds.readByte();
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }
  }  
}