package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class SPECTRUM
{
  public String comment;
  public int tm;
  public float s_start;
  public float s_inc;
  public int status;
  public float[] d_spect_array = new float[4096];
  public static int sizeInBytes = 4096 * 4 + 96;
  public int length;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public SPECTRUM() {s_start = 0; s_inc = 0; status = 0; tm  = 0; comment = "";}  
  public byte[] toByteArray()
  {
	try
	{
		dBuffer.reset();
		DataOutputStream ds = new DataOutputStream(dBuffer);
		byte[] b = new byte[80];
		ds.write(comment.getBytes());
		ds.write(b,0,80-comment.length());
		ds.writeInt(Swap.Long(tm));
		b = Swap.Float(s_start); ds.write(b,0,4);
		b = Swap.Float(s_inc); ds.write(b,0,4);
		ds.writeInt(Swap.Long(status));
		for (int i=0; i<d_spect_array.length; i++)
		{
		  b = Swap.Float(d_spect_array[i]); ds.write(b,0,4);
		}
		ds.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
//	  System.exit(1);
	}
	hByteArray = dBuffer.toByteArray();
	return hByteArray;
  }  
  public void toStruct()
  {
    try
    {
    	ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
    	DataInputStream ds = new DataInputStream(dis);
    	byte[] b = new byte[4096 * 4];
    	ds.read(b,0,80);
    	comment = (new String(b)).trim();
    	tm = Swap.Long(ds.readInt());
    	ds.read(b,0,4); s_start = Swap.Float(b);
    	ds.read(b,0,4); s_inc = Swap.Float(b);
    	status = Swap.Long(ds.readInt());
    	for (int i=0; i<d_spect_array.length && i<length; i++)
    	{
    	  if (ds.read(b,0,4) < 0) break;
    	  d_spect_array[i] = Swap.Float(b);
    	}
    	ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    //	  System.exit(1);
    }	 
  }  
}