//: TLink.java
package TINE;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
final class TContract
{

  //TLink eqmCall;
  static final int hdrSizeInBytes = (32+16+8+2*4+4*1+2*8);
  int totalSizeInBytes;
  ByteArrayOutputStream dBuffer;
  TContract(TLink eqm)
  {
    int i;
    // get 6-character module name
    TModAddress mod;
    if (eqm.expName.compareTo("ENS") == 0)
    {
    //	  mod = new TModAddress("",eqm.expName,eqm.cntName);
      mod = new TModAddress(eqm.tf,eqm.expName,eqm.cntName);
    }
    else
    {
      mod = new TModAddress(eqm.tf,eqm.expName,eqm.cntName);
    }
    if (mod.srvAddress == null) return;
    if (eqm.modAddress != null) 
    {
      eqm.modAddress.srvAddress = mod.srvAddress;
      eqm.modAddress.modName = mod.modName;
    }
    try
    {
      dBuffer = new ByteArrayOutputStream(hdrSizeInBytes);
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] bstr = new byte[32];
      byte[] tmp  = eqm.devProperty.getBytes();
      byte[] tmp2  = eqm.devName.getBytes();
      if (tmp2.length > 16 && tmp.length < 16)  // the Channel Access Long device names trick ...
      {
        for (i=0; i<16; i++) bstr[i] =  i < tmp.length ? tmp[i] : 0; bstr[16] = 0;
        for (i=0; i<15; i++) bstr[i+17] = i < tmp2.length - 15 ? tmp2[i+15] : 0;
        byte[] amp = "&".getBytes();
        tmp2[15] = amp[0];
      }
      else
      {
        for (i=0; i<32; i++) bstr[i] =  i < tmp.length ? tmp[i] : 0;
      }
      ds.write(bstr,0,32);
    //	  tmp = eqm.devName.getBytes();
      for (i=0; i<16; i++) bstr[i] = i < tmp2.length ? tmp2[i] : 0;
      ds.write(bstr,0,16);
      tmp = mod.modName.getBytes();
      for (i=0; i<8; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,8);
      ds.writeInt(Swap.Long(eqm.dInput.getArrayLength()));
      ds.writeInt(Swap.Long(eqm.dOutput.getArrayLength()));
      ds.writeByte(0);
      ds.writeByte(eqm.devAccess);
      ds.writeByte((byte)eqm.dInput.getFormat());
      ds.writeByte((byte)eqm.dOutput.getFormat());
      tmp = eqm.dInput.getTag().getBytes();
      for (i=0; i<8; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,8);
      tmp = eqm.dOutput.getTag().getBytes();
      for (i=0; i<8; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,8);
      totalSizeInBytes = hdrSizeInBytes + eqm.dInput.getSizeInBytes();
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }	 
  }                        
}