package TINE;

public abstract class TInitializerFactory
{
	private static TInitializerFactory factory = null;
	private TInitializer initializer = null;
	
	protected TInitializerFactory()
	{
	}
	
	public synchronized static TInitializerFactory getInstance()
	{
		if (factory != null) return factory;
		String className = System.getProperty("TINE.TInitializerFactory");
		if (className == null) factory = new DefaultTInitializerFactory();
		else
		{
			try
			{
				factory = (TInitializerFactory)Class.forName(className).newInstance();
			} catch (Exception e)
			{
				throw new IllegalStateException("Could not instantiate TINE Initializer Factory, reason: " + e);
			}
		} 
		return factory;
	}
	
	public abstract TInitializer getInitializer();
}
