//: TLink.java
package TINE;
import java.io.BufferedReader;
import java.io.IOException;
final class TModAddress
{
  private static BufferedReader addrR = null;
  private static BufferedReader hostsR = null;
  private static BufferedReader eqpR = null;
  private static boolean initialized = false;
  String devName;
  String modName;
  String srvName;
  String cntName;
//  static String tineHome;
//  static String addrFileLocation;
//  static String eqpFileLocation;
//  static String cshostsFileLocation;
  static NameCache[] devNameCache = new NameCache[200];
  static String[] modNameCache = new String[200];
  static TSrvAddress[] srvAddrCache = new TSrvAddress[200];
  static int modNameCacheLength = 0;
  static int srvAddrCacheLength = 0;
  static int NameCacheLength = 0;
  static int numConfiguredNameServers = 0;
  static int currentConfiguredNameServer = 0;
  static String currentConfiguredNameServerTag;
  TSrvAddress srvAddress;
  static csv modFile;
  static String modDBFileName;
  int debugLevel = 0;
  private class NameCache
  {
     String cntName;
     String devName;
     int modNameIndex;
     int srvNameIndex;
  }
  void StaticAddress(String dname,String cname)
  {
    int i;
    for (i=0; i<NameCacheLength; i++) 
    {
      if (cname.length() > 0 && 
          cname.compareTo("DEFAULT") != 0 &&
    	  cname.compareTo(devNameCache[i].cntName) != 0) continue;
      if (dname.compareTo(devNameCache[i].devName) == 0)
      {
    	modName = modNameCache[devNameCache[i].modNameIndex];
    	srvName = srvAddrCache[devNameCache[i].srvNameIndex].srvName;
        srvAddress = srvAddrCache[devNameCache[i].srvNameIndex];
    	return;
      }
    }
    // acquire name info from ens or file:
    if (dname.compareTo("ENS") == 0)
    {
      modName = new String("ENSEQM");
      srvName = new String("ENS");
      cntName = new String("SERVICE");
    }
    if (dname.compareTo("NAMEQRY") == 0)
    {
      modName = new String("ENSEQM");
      srvName = new String("ENS");
      cntName = new String("SERVICE");
    }
    if (modNameCacheLength >= 200) return;
    if (srvAddrCacheLength >= 200) return;
    if (NameCacheLength < 200) devNameCache[NameCacheLength] = new NameCache();
    for (i=0; i<modNameCacheLength; i++) 
      if (modName.compareTo(modNameCache[i]) == 0) break;
    if (i == modNameCacheLength) modNameCache[modNameCacheLength++] = modName;
    devNameCache[NameCacheLength].modNameIndex = i;
    for (i=0; i<srvAddrCacheLength; i++) 
      if (srvName.compareTo(srvAddrCache[i].srvName) == 0) break;
    if (i == srvAddrCacheLength)
    {
      //
      // Moved functionality to DefaultTInitializerFactory
      //
      //srvAddrCache[srvAddrCacheLength] = new TSrvAddress("fecaddr.csv",srvName);
      //srvAddrCache[srvAddrCacheLength] = new TSrvAddress(System.getProperty("user.home")+"/fecaddr.csv",srvName);
      srvAddrCache[srvAddrCacheLength] = new TSrvAddress(srvName);
      srvAddress = srvAddrCache[srvAddrCacheLength++];
      if (srvName.compareTo("ENS") == 0) numConfiguredNameServers++;
    }
    devNameCache[NameCacheLength].srvNameIndex = i;
    devNameCache[NameCacheLength].devName = dname;
    devNameCache[NameCacheLength].cntName = cntName;
    if (NameCacheLength < 200) NameCacheLength++;
  }
  int addNameServerToServerCache(TSrvAddress sa)
  {
    if (srvAddrCacheLength > 100 || NameCacheLength > 100 || numConfiguredNameServers > 10)
      return -1;
    if (debugLevel > 1) System.out.println("Adding ENS " + numConfiguredNameServers + " to address cache");
    srvAddrCache[srvAddrCacheLength] = sa;
    devNameCache[NameCacheLength] = new NameCache();
    devNameCache[NameCacheLength].srvNameIndex = srvAddrCacheLength;
    devNameCache[NameCacheLength].modNameIndex = modNameCacheLength;
    devNameCache[NameCacheLength].devName = sa.srvName;
    devNameCache[NameCacheLength].cntName = "SERVICE";
    modNameCache[modNameCacheLength] = "ENSEQM";
    srvAddrCacheLength++;
    NameCacheLength++;
    modNameCacheLength++;
    numConfiguredNameServers++;
    if (numConfiguredNameServers == 1)  // been called at least once ...
    {
      currentConfiguredNameServerTag = new String(sa.srvName);
    }
    return 0;
  }
  int addNameServer(String ip)
  {
    TSrvAddress sa;
    DevAddr da;
    da = new DevAddr();
    da.FecName = new String("ENS#" + numConfiguredNameServers);
    da.Context = new String("SERVICE");
    da.EqName = new String("ENSEQM");
    da.IP = new String(ip);
    da.PortOffset = 0;
    da.Prot = 2;
    sa = new TSrvAddress(da);
    if (!sa.srvRegistered) return -1;
    addNameServerToServerCache(sa);
    return 0;
  }

//// mkadunc
//// Moved functionality to DefaultTInitializerFactory
// 
//
//  public String getTineHome()
//  {
//    String thome;
//    if (tineHome == null)
//    {
//      if ((thome=System.getProperty("tine.home")) != null)
//      {
//        tineHome = new String(thome);
//      }
//      else
//      {
//        tineHome = new String(System.getProperty("java.home")+"/tine/database");
//      }
//    }
//    if (debugLevel > 0) System.out.println("CSHOSTS Location : " + tineHome);
//    return tineHome;
//  }
  void SetAddrFileLocation()
  {
      if (initialized) return;
      initialized=true;

      TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
      addrR = initializer.getAddressResource();
      eqpR = initializer.getEquipmentResource();

//// mkadunc
//// Moved functionality to DefaultTInitializerFactory
//    if (tineHome == null) tineHome  = getTineHome();
//    addrFileLocation = new String(getTineHome() + "/fecaddr.csv");
//    eqpFileLocation = new String(getTineHome() + "/eqpdbase.csv");
//    cshostsFileLocation = new String(getTineHome() + "/cshosts.csv");
    String ensName;
    TSrvAddress sa;
    currentConfiguredNameServerTag = new String("ENS");  // default
    
    for (int i=0; i<5; i++)  // don't allow more than 5 configured name servers ...
    {
      ensName = new String("ENS#" + i);	
//        sa = new TSrvAddress(cshostsFileLocation,ensName);
      if (debugLevel > 1) System.out.println("ENS: looking for " + ensName);
      hostsR = initializer.getHostsResource();
      sa = new TSrvAddress(hostsR,ensName);
      if (!sa.srvRegistered) 
      { 
        if (debugLevel > 1) System.out.println(ensName + " Not Registered");
        continue;
      } 
      addNameServerToServerCache(sa);
    }
  }
  TModAddress(String fname,String dname,String cname)
  {
    String lkupname;
    SetAddrFileLocation();
    if (debugLevel > 1) System.out.println("FILE lookup: looking for \\" + cname + "\\" + dname);
    if (dname.compareTo("ENS") == 0 && numConfiguredNameServers > 0)
    {
      lkupname = currentConfiguredNameServerTag;
    }
    else
    {
      lkupname = dname;
    }
    for (int i=0; i<NameCacheLength; i++)
    {
      if (cname.length() > 0 && 
          cname.compareTo("DEFAULT") != 0 &&
          cname.compareTo(devNameCache[i].cntName) != 0) continue;
      if (lkupname.compareTo(devNameCache[i].devName) == 0)
      {
        modName = modNameCache[devNameCache[i].modNameIndex];
        srvName = srvAddrCache[devNameCache[i].srvNameIndex].srvName;
        srvAddress = srvAddrCache[devNameCache[i].srvNameIndex];
        return;
      }
    }
    if (fname.length() == 0) 
    {
      StaticAddress(dname,cname);
      return;
    }
//    modFile = new csv(eqpFileLocation);
    modFile = new csv(eqpR);
    try
    {
      String s, hdr;
      int i, nam_col = -1,eqn_col = -1 ,srv_col = -1,ctxt_col = -1;
      boolean done = false;
      while((s=modFile.in.readLine()) != null)
      {
        if (s.length() == 0) continue;
        if (s.startsWith("#") || s.startsWith(";") || s.startsWith("%")) continue;
        if (!done)
        {
            hdr = s;
            if ((nam_col=modFile.findcol(hdr,"NAME")) < 0) throw new NoSuchFieldException();
            if ((eqn_col=modFile.findcol(hdr,"EQPMODULE")) < 0) throw new NoSuchFieldException();
            if ((srv_col=modFile.findcol(hdr,"FECNAME")) < 0) throw new NoSuchFieldException();
            if ((ctxt_col=modFile.findcol(hdr,"CONTEXT")) < 0) throw new NoSuchFieldException();
            done = true;
            continue;
        }
        if (modFile.namcmp(dname,s,nam_col) == 0)
        {
            modName = modFile.colptr(eqn_col,s);
            srvName = modFile.colptr(srv_col,s);
            cntName = modFile.colptr(ctxt_col,s);
            if (modNameCacheLength >= 200) break;
            if (srvAddrCacheLength >= 200) break;
            if (NameCacheLength < 200) devNameCache[NameCacheLength] = new NameCache();
            for (i=0; i<modNameCacheLength; i++) 
              if (modName.compareTo(modNameCache[i]) == 0) break;
            if (i == modNameCacheLength) modNameCache[modNameCacheLength++] = modName;
            devNameCache[NameCacheLength].modNameIndex = i;
            for (i=0; i<srvAddrCacheLength; i++) 
              if (srvName.compareTo(srvAddrCache[i].srvName) == 0) break;
            if (i == srvAddrCacheLength)
            {
//              srvAddrCache[srvAddrCacheLength] = new TSrvAddress(addrFileLocation,srvName);
              srvAddrCache[srvAddrCacheLength] = new TSrvAddress(addrR,srvName);
              srvAddress = srvAddrCache[srvAddrCacheLength++];
            }
            devNameCache[NameCacheLength].srvNameIndex = i;
            devNameCache[NameCacheLength].devName = dname;
            devNameCache[NameCacheLength].cntName = cname;
            if (NameCacheLength < 200) NameCacheLength++;
            modFile.close();
            return;
            // found it
        }
      }
      modFile.close();
    }
    catch (NoSuchFieldException e)
    {
  	  // database corrupt
    }
    catch (IOException e)
    {
	    // End of File ...
    }
  }  
  
  TModAddress(TFactory tf,String dname,String cname)
  {
  	int i;
    debugLevel = tf.debugLevel;
    if (tf.debugLevel > 1) System.out.println("TModAddress() has been called from factory");
    if (dname.compareTo("GLOBAL") == 0) return;
    SetAddrFileLocation();
    
    if (tf.debugLevel > 1) System.out.println("looking for \\" + cname + "\\" + dname);
    if (dname.compareTo("ENS") == 0 && numConfiguredNameServers == 0)
    {
      if (tf.debugLevel > 1) System.out.println("add static ENS address");
      StaticAddress(dname,cname);
      return;
    }
    for (i=0; i<NameCacheLength; i++) 
    {
      if (cname.length() > 0 && 
          cname.compareTo("DEFAULT") != 0 &&
          cname.compareTo(devNameCache[i].cntName) != 0) continue;
      if (dname.compareTo(devNameCache[i].devName) == 0)
      {
        modName = modNameCache[devNameCache[i].modNameIndex];
        srvName = srvAddrCache[devNameCache[i].srvNameIndex].srvName;
        srvAddress = srvAddrCache[devNameCache[i].srvNameIndex];
        if (tf.debugLevel > 1) System.out.println("found it in cache");
        return;
      }
    }
    if (numConfiguredNameServers == 0)
    {
      if (tf.debugLevel > 1) System.out.println("No configured ENS");
      return;
    } 
    String tagName;
    int n = 0;
    do
    {
        tagName = new String(currentConfiguredNameServerTag + "/");
        if (cname.length() > 0) tagName.concat(cname); else tagName.concat("#2");	
        DevAddr da = new DevAddr();
        TDataType d_null = new TDataType();
        TDataType d_da = new TDataType(da.toByteArray(),"");
        TLink ma = tf.createTLink(tagName,dname,d_da,d_null,(short)1);
        if (ma == null)
        {
          if (tf.debugLevel > 1) System.out.println("cannot create link to ENS");
          return;          
        }
        if (ma.execute(200,true) == 0)
        {
          da.toStruct();
          if (modNameCacheLength >= 200) return;
          if (srvAddrCacheLength >= 200) return;
          if (NameCacheLength < 200) devNameCache[NameCacheLength] = new NameCache();
          modName = da.EqName;
          for (i=0; i<modNameCacheLength; i++) 
            if (modName.compareTo(modNameCache[i]) == 0) break;
          if (i == modNameCacheLength) modNameCache[modNameCacheLength++] = modName;
          devNameCache[NameCacheLength].modNameIndex = i;
          srvName = da.FecName;
          for (i=0; i<srvAddrCacheLength; i++) 
            if (srvName.compareTo(srvAddrCache[i].srvName) == 0) break;
          if (i == srvAddrCacheLength)
          {
            srvAddrCache[srvAddrCacheLength++] = new TSrvAddress(da);
          }
          srvAddress = srvAddrCache[i];
          devNameCache[NameCacheLength].srvNameIndex = i;
          devNameCache[NameCacheLength].devName = dname;
          devNameCache[NameCacheLength].cntName = cname;
          if (NameCacheLength < 200) NameCacheLength++;
          ma.cancel();
          if (tf.debugLevel > 1) System.out.println("ENS success");
          return;
        }
        ma.cancel();
        currentConfiguredNameServer = (currentConfiguredNameServer+1) % numConfiguredNameServers;
        currentConfiguredNameServerTag = new String("ENS#" + currentConfiguredNameServer);
        if (tf.debugLevel > 1) System.out.println("trying ENS " + currentConfiguredNameServerTag);
    } while (++n < numConfiguredNameServers);
    if (tf.debugLevel > 1) System.out.println("ens failure");
  } 
}