//: TLink.java
package TINE;
import java.io.BufferedReader;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
final class TSrvAddress
{
  String srvName;
//
////  Not used (mkadunc)
//
//  String srvLocation;
//  String srvDescription;
//
  csv srvFile;
  static final short BCAST_ID = 255;
  
/*
  static final String mcastAddr = new String("238.1.1.1");
  static final String gcastAddr = new String("238.1.1.0");
  static final int mcastTTL = 16;
*/
  short srvPortOffset;
  boolean srvRegistered;
  InetAddress srvHost;

  TSrvAddress(DevAddr da)
  {
    try 
    {
      srvName = da.FecName;
      srvHost = InetAddress.getByName(da.IP.trim());
//      srvPortOffset = da.PortOffset;
      srvPortOffset = da.getPortOffset();
      srvRegistered = true;
    }
    catch (UnknownHostException e)
    {
      System.err.println("cannot find host");
      srvRegistered = false;
    }
  }  

  TSrvAddress(String name)
  {
    srvName = new String(name);
    try 
    {
      // acquire address from ens or file:
      if (name.compareTo("ENS") == 0)
      {
        srvHost = InetAddress.getByName(TInitializerFactory.getInstance().getInitializer().getENSAddress());
        srvPortOffset = 0;
        srvRegistered = true;
      }
    }
    catch (UnknownHostException e)
    {
      System.err.println("cannot find host");
      srvRegistered = false;
    }
  }          
  TSrvAddress(BufferedReader in,String name)
  {
    srvFile = new csv(in);
    if (srvFile.in == null) 
    { 
      System.out.println("looking for " + name + " in null file !");
      return;
    } 
    try
    {
      String s, hdr;
      int i, nam_col = -1,net_col = -1 ,nod_col = -1, ip_col = -1,po_col = -1;
      boolean done = false;
      while((s=srvFile.in.readLine()) != null)
      {
        if (s.length() == 0) continue;
        if (s.startsWith("#") || s.startsWith(";") || s.startsWith("%")) continue;
        if (!done)
        {
        	hdr = s;
        	if ((nam_col=srvFile.findcol(hdr,"FECNAME")) < 0) throw new NoSuchFieldException();
        	if ((net_col=srvFile.findcol(hdr,"FECNETWORK")) < 0) throw new NoSuchFieldException();
        	if ((nod_col=srvFile.findcol(hdr,"FECNODE")) < 0) throw new NoSuchFieldException();
        	if ((ip_col=srvFile.findcol(hdr,"IPADDR")) < 0) throw new NoSuchFieldException();
        	po_col = srvFile.findcol(hdr,"PORTOFFSET");
        	done = true;
        	continue;
        }
        if (srvFile.namcmp(name,s,nam_col) == 0)
        {
           srvName = new String(name);	
           String tmp;
           tmp = srvFile.colptr(ip_col,s);
           srvHost = InetAddress.getByName(tmp);
           if (po_col >= 0)
           {
           	  tmp = srvFile.colptr(po_col,s);
              Integer itmp = new Integer(tmp);
              srvPortOffset = (short)itmp.intValue();
           }
           else
           {
              srvPortOffset = 0;
           }
           srvRegistered = true;
           srvFile.close();
           return;
       	}
      }
      srvFile.close();
    }
    catch (NoSuchFieldException e)
    {
      // database corrupt
      System.out.println("looking for " + name + " in corrupt file !");
      srvFile.close();
    }
    catch (IOException e)
    {
      // End of File ...
      System.out.println("found end of file while looking for " + name );
      srvFile.close();
    }
  }  
}