//: TLink.java
package TINE;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Date;
final class TSubscription
{
  short msgSizeInBytes;
  short mtu;
  byte  numblks;
  byte  blknum;
  short id;
  short mode;
  short blkid;
  int   pollingRate;
  int   starttime;
  long linkStartTime;
  long linkLastTime;
  int dataSizeInBytes = 0;
  int nextDataSizeInBytes = 0;
  static final int hdrSizeInBytes = (6*2 + 2*4);
  TContract contract;
  TLink link;
  ByteArrayOutputStream dBuffer;

  void prepare(short Mode)
  {
    short m = Mode;
    try
    {
      msgSizeInBytes = (short)(hdrSizeInBytes + contract.hdrSizeInBytes);
      if (link.dInput.blknum == link.dInput.numblks) // finished
      {
        msgSizeInBytes += (short)(dataSizeInBytes % mtu);
        link.dInput.blkid = (link.dInput.blkid++) % 1000;
      }
      else                   // move along ...
      { 
        msgSizeInBytes += mtu;
        link.dInput.blknum++;
      }
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.writeShort(Swap.Short(msgSizeInBytes));
      ds.writeShort(Swap.Short(mtu));
      ds.writeByte(numblks);
      ds.writeByte(blknum);
      ds.writeShort(Swap.Short(id));
      ds.writeShort(Swap.Short(m));
      ds.writeShort(Swap.Short(blkid));
      ds.writeInt(Swap.Long(pollingRate));
      ds.writeInt(Swap.Long(starttime));
      ds.close();
      nextDataSizeInBytes = dataSizeInBytes - mtu > mtu ? mtu : (dataSizeInBytes-mtu) % mtu; 
      blknum = (byte)link.dInput.blknum; 
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }	 
  }    
  Date  date = new Date();
  TSubscription(TContract c, TLink eqm)
  {
	 contract = c;
   link = eqm;
   msgSizeInBytes = (short)(hdrSizeInBytes + contract.hdrSizeInBytes);
   mtu = (short)eqm.dInput.mtu;
   numblks = (byte)(eqm.dInput.numblks);
   blknum = (byte)(eqm.dInput.blknum);
	 id = (short)eqm.linkId;
	 mode = TMode.CM_REGISTER;
   dataSizeInBytes = eqm.dInput.getSizeInBytes();
   nextDataSizeInBytes = blknum == numblks ? dataSizeInBytes : mtu;
   blkid = (short)(eqm.dInput.blkid);
	 pollingRate = eqm.devTimeout;
   linkStartTime = date.getTime();
   linkLastTime = linkStartTime;
	 starttime = (int)(linkStartTime/1000);
	 dBuffer = new ByteArrayOutputStream(msgSizeInBytes);
  }
}