# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC -c      CCL = CC         LM = 
# SGI,OSF CC = cc -c      CCL = cc         LM = -lm
# LINUX   CC = cc -c      CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -c -Aa  CCL = cc         LM = -lM
# SOL 2.4 CC = CC -c      CCL = CC         LM = -lsocket -lnsl

CPP = g++
CC = cc -c -g
CCL = cc
LM = -lm

globalsd: rpcserv.o globcln.o coversrv.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o unixcmd.o syslib.o 
	${CCL} -o globalsd rpcserv.o globcln.o coversrv.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o unixcmd.o syslib.o ${LM}

rpcserv.o: rpcserv.c servdef.h prolog.h errors.h project.def
	${CC} rpcserv.c

globcln.o: globcln.c servdef.h prolog.h errors.h project.def
	${CC} globcln.c

coversrv.o: coversrv.c
	${CC} coversrv.c

client.o: client.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} client.c

clnip.o: clnip.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} clnip.c

iplib.o: iplib.c servdef.h prolog.h srvip.h errors.h project.def 
	${CC} iplib.c

dblib.o:  dblib.c database.h errors.h prolog.h project.def
	${CC} dblib.c

database.o: database.c prolog.h cprolog.h database.h servdef.h errors.h project.def
	${CC} database.c

unixcmd.o: unixcmd.c prolog.h servdef.h unixcmd.h project.def
	${CC} unixcmd.c 

err_list.o: err_list.c errors.h
	${CC} err_list.c

swaplib.o: swaplib.c swaplib.h prolog.h servdef.h errors.h
	${CC} swaplib.c 

syslib.o: syslib.c prolog.h servdef.h project.def
	${CC} syslib.c

clean:
	rm server.o srvip.o client.o clnip.o iplib.o dblib.o database.o unixcmd.o err_list.o swaplib.o almsrv.o syslib.o
