# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC -c      CCL = CC         LM = 
# SGI     CC = cc -c      CCL = cc         LM = -lm
# OSF     CC = cc -c      CCL = cc         LM = -lm
# LINUX   CC = cc -c      CCL = cc         LM = -lm
# ULT     CC = gcc -c     CCL = gcc        LM = 
# HP:     CC = cc -c -Aa  CCL = cc         LM = -lM
# SOL 2.4 CC = CC -c      CCL = CC         LM = -lsocket -lnsl

CPP = CC -c
CC = CC -c
CCL = CC
LM = -lm

rpcserv: rpcserv.o sinsrv.o server.o srvip.o srvdbase.o srvquery.o history.o toolkit.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o almsrv.o unixcmd.o syslib.o 
	${CCL} -o rpcserv rpcserv.o sinsrv.o server.o srvip.o srvdbase.o srvquery.o history.o toolkit.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o almsrv.o unixcmd.o syslib.o ${LM}

rpcserv.o: rpcserv.c servdef.h prolog.h errors.h project.def
	${CC} rpcserv.c

sinsrv.o: sinsrv.c servdef.h prolog.h errors.h project.def
	${CC} sinsrv.c 

server.o:  server.c servdef.h prolog.h errors.h brdcast.h swaplib.h project.def
	${CC} server.c

srvip.o: srvip.c servdef.h prolog.h srvip.h errors.h project.def
	${CC} srvip.c

srvdbase.o: srvdbase.c database.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} srvdbase.c

srvquery.o: srvquery.c database.h servdef.h prolog.h history.h srvip.h errors.h project.def
	${CC} srvquery.c

history.o: history.c history.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} history.c

toolkit.o: toolkit.c toolkit.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} toolkit.c

client.o: client.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} client.c

clnip.o: clnip.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} clnip.c

iplib.o: iplib.c servdef.h prolog.h srvip.h errors.h project.def 
	${CC} iplib.c

dblib.o:  dblib.c database.h errors.h prolog.h project.def
	${CC} dblib.c

database.o: database.c prolog.h cprolog.h database.h servdef.h errors.h project.def
	${CC} database.c

almsrv.o:  almsrv.c almsrv.h database.h errors.h prolog.h project.def
	${CC} almsrv.c

unixcmd.o: unixcmd.c prolog.h servdef.h unixcmd.h project.def
	${CC} unixcmd.c 

err_list.o: err_list.c errors.h
	${CC} err_list.c

swaplib.o: swaplib.c swaplib.h prolog.h servdef.h errors.h
	${CC} swaplib.c 

syslib.o: syslib.c prolog.h servdef.h project.def
	${CC} syslib.c

clean:
	rm server.o srvip.o client.o clnip.o iplib.o dblib.o database.o unixcmd.o err_list.o swaplib.o almsrv.o syslib.o
