Attribute VB_Name = "CASfunctions"
Global Const MAXALARMS = 1000
Global Const MAXSUBS = 20
Global Const MAXSERVERS = 100
'Global cqs As CASQS
Global subs() As String, nsubs As Integer
Global srvs(MAXSERVERS) As String, nsrvs As Integer
Global casServer$, casServerContext$

Global gAlarmTable(MAXALARMS) As AMS
Global gAlarmHRT(MAXALARMS) As Single

Type SUBINFO
  sub As String
  srvs() As String
  cqs() As CASQS
  nsrvs As Integer
  nalms As Integer
  timestamp As Long
End Type
Global SubData(MAXSUBS) As SUBINFO
Global DisplayData(3) As SUBINFO
Global g_timestampAppend As String

Type ALARMINFOSET
  tag As String
  nalm As Integer
  nalms_id As Long
  alms_id As Long
End Type
Global almInfo(MAXSUBS) As ALARMINFOSET

Function CASGetServerInfo(ByVal srv As String, cqs As CASQS) As Integer
Dim devName$, rc%, i%, n%
Dim dout As DBLK, din As DBLK
Static done As Boolean
If Not done Then
  done = True
  FILLSTRUCT "CASQS", Len(cqs), 1, CF_NULL
End If
'AlarmStatus.deviceName = srv
'AlarmStatus.deviceProperty = "SERVERINFO"
'rc% = AlarmStatus.Execute(cqs.devContext(0), 1, "STRUCT/CASQS")
devName$ = casServer$ & "/" + srv
dout.dArrayLength = 1: dout.dFormat = CF_STRUCT: BARR dout.dTag(), "CASQS"
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(devName, "SERVERINFO", dout, cqs, din, 0, 1, 1000)
If rc% Then GoTo CASGetServerInfoError

CASGetServerInfoError:
CASGetServerInfo = rc%
End Function
Function CASGetServers(ByVal subsys As String, s() As String) As Integer
Dim devName$, rc%, i%, n%
Dim sn(100) As NAME16
Dim dout As DBLK, din As DBLK
If Len(subsys) > 0 Then ss$ = subsys Else ss$ = "ALL"
devName$ = casServer$ & "/" + ss$
dout.dArrayLength = 100: dout.dFormat = CF_NAME16
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(devName, "SERVERS", dout, sn(0), din, 0, 1, 1000)
If rc% Then GoTo CASGetServersError
n% = dout.dArrayLength
ReDim s(n% - 1)
For i% = 0 To n% - 1
  s(i%) = BSTR(sn(i%).nam())
Next
CASGetServersError:
CASGetServers = rc%
End Function
Function CASGetSubsystems(s() As String) As Integer
Dim devName$, rc%, i%, n%
Dim sn(100) As NAME16
Dim dout As DBLK, din As DBLK
devName$ = casServer$ & "/ALL"
dout.dArrayLength = 100: dout.dFormat = CF_NAME16
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(devName, "SUBSYSTEMS", dout, sn(0), din, 0, 1, 1000)
If rc% Then GoTo CASGetSubsystemsError
n% = dout.dArrayLength
ReDim s(n% - 1)
For i% = 0 To n% - 1
  s(i%) = BSTR(sn(i%).nam())
Next
CASGetSubsystemsError:
CASGetSubsystems = rc%
End Function

Function CASGetNumAlarms(ByVal tgt As String, num As Integer, starttime As Long, stoptime As Long, severity As Long) As Integer
Dim devName$, rc%, i%, n%
Dim dout As DBLK, din As DBLK
Dim stst(2) As Long
stst(0) = starttime: stst(1) = stoptime: stst(2) = severity
If Len(tgt) > 0 Then ss$ = tgt Else ss$ = "ALL"
devName$ = casServer$ & "/" + ss$
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc% = T_EXECLINK(devName, "NUMALARMS", dout, n%, din, stst(0), CA_READ, 1000)
If rc% Then GoTo CASGetNumAlarmsError
CASGetNumAlarmsError:
num = n%
CASGetNumAlarms = rc%
End Function

Public Function almdatastr(a As AMS) As String
  Dim i As Integer, k As Integer
  Dim iVal(3) As Integer
  Dim lval As Long
  Dim fval As Single
  Dim s As String
  s = " ": g_timestampAppend = ""
  Select Case a.alarmDataFormat + CF_DOUBLE
    Case CF_BYTE:
      For i = 0 To a.alarmDataArraySize - 1
        s = s + Hex$(a.alarmData(i)) + " "
      Next
    Case CF_SHORT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(iVal(0), a.alarmData(0), a.alarmDataArraySize * 2)
        s = s + str$(iVal(i)) + " "
      Next
    Case CF_LONG:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(lval, a.alarmData(0), 4)
        s = s + str$(lval) + " "
      Next
    Case CF_FLOAT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(fval, a.alarmData(0), 4)
        s = s + str$(fval) + " "
      Next
      If a.AlarmSystem = 750 Then g_timestampAppend = str$(fval)
    Case CF_HITTS:
'      Call MEMCPY(fval, a.alarmData(0), 4)
'      s = s + str$(fval) + " "
      For i = 0 To 5
        s = s + Hex$(a.alarmData(i))
      Next
      s = s + " "
    Case CF_BIT:
      For i = 0 To 5 ' go thru all 6 bytes
        If i * 8 > a.alarmDataArraySize Then Exit For
        For k = 0 To 7
          If i * 8 + k > a.alarmDataArraySize Then Exit For
          s = s + str$(GetBit(a.alarmData(i), k))
        Next
      Next
    Case CF_TEXT:
      s = BSTR(a.alarmData()) + " "
  End Select
almdatastr = s
End Function

