Attribute VB_Name = "ARCH1"
Option Explicit

Global CSVPropInfo(200) As HistDisplayType, NOCXCSVProps%
Global ServerPropInfo() As HistDisplayType, NOCXServerProps%
Global OCXPropertyListFlag%, OCXFormCaption$

Type ArchiveServerInfo
  HistoryServerName As String
  DataServerName As String
  ConfigFileName As String
  MachineName As String
  ConfigFilePath As String
End Type

Global Const NUMEQP = 1000
Global Const NUMDEV = 100
Global Const MaxStrings = 500
Global Const MaxPoints = 4000 '20000 ' 4000
Global Const MaxCurves = 10
Global Const MaxPlots = 10
Global Const MaxDevices = 10000
Global NMachines

Global ComJob$, ComFacility$, FormLoaded As Boolean
Global Const CommandArchiver$ = "ARCHIVER"
Global Const CommandLHistChooser$ = "LHCHOOSER"
Global Const CommandLHistClient$ = "LHCLIENT"

Global Const OpMinus = "-"
Global Const OpPlus = "+"
Global Const OpMult = "*"
Global Const OpDiv = "/"
Global Const ErrorValue! = 1E+20
Global DisplayModes$(8), DisplayModeIndexes%(8), NDisplayModes%

Global Const CArchivers = 0
Global Const LHistoryChooser = 1
Global Const LHistoryClient = 2

Global Const RelativeScale = 0
Global Const AbsoluteScale = 1
Global ArchiveMode%, ScalingMode%, SwitchingScalingFlag As Boolean
Global SkipLoading%

Global Const OneHour& = 3600
Global Const OneDay& = 24 * OneHour

Global devNames() As String, NDevs%
Global devNameBuff(MaxDevices, MaxCurves) As String

Global Const CopyOffset = MaxCurves

Global Const NTDBunches = 12 ' Number of bunches in TTF-TD Archives...
Global SwitchingWindows As Boolean
Global LiveData As Boolean

Global Const MaxZooms = 10
Global NZooms%, ZoomLimits#(MaxZooms, 3)
Global ArchiveStart&, ArchiveStop&, KeepZoom#(3)
Global SelectedTrace%(1), SelectedTracePlotIndex&(1), SelectedPlotArrayTrace%

Global ArchStringDataBuffer(MaxStrings, MaxCurves * 2) As NAME32I
Global ArchDataBuffer(MaxPoints, MaxCurves * 2) As FLTINT
Global ArchData(MaxPoints, MaxCurves * 2) As FLTINT
Global ArchTimeBins#(MaxPoints, MaxCurves * 2)
Global PlotData(MaxPoints, MaxCurves * 2) As FLTINT

Global ArrayData!(), ArrayRefData!(), PlotArrayData!(), RefAxisData!()
Global ArrayDataSize&, ArrayDataTimeStamp&, ArrayDataKeyword$
Global ArrayINTData%(), ArrayProp$, ArrayServerDevName$, ArrayLinkIndex&

Global ActivePlot%, ArchiveTS&, ReferenceTS&
Global ArchiveTSIndex%, KinoIndex%, KinoFrames%, KinoCursor%, ChubbyFactor!
Global KinoFlag As Boolean

Global filterDataBuffer(MaxPoints, 10) As FLTINT
Global filterTextBuffer(MaxPoints / 10, 10) As NAME32I
Global filterAcquired As Boolean
Global filterString As String

Global YCursorArray!(1), XCursorArray&(1), DNameToIndex%(MaxCurves * 2), IndexToDName%(MaxCurves * 2)
Global ACOPDefaultMode&, ACOPDefaultWidth&, ACOPDisplayModes&(10), ACOPBarModeFlag As Boolean
Global gArchiveServer$, gDataServer$, SelectedMachine%, SelectedConfig%

Global gArchiveServerInfo() As ArchiveServerInfo ' ReDim in getArchiveServerInfo()
Global nConfiguredArchiveServers As Integer
Global Const ConfFiles = 500
Global SetFile$(), SetHelp$(), SetDir$()     ' ReDim in getArchiveServerInfo()
Global NElem%(), NSet%()          ' ReDim in getArchiveServerInfo()

'Global fdat(MaxPoints, MaxCurves) As Single
'Global ltim(MaxPoints, MaxCurves) As Long
'Global xdat(MaxPoints, MaxCurves) As Long
Global ydat(MaxPoints, MaxCurves) As Single
Global xdat0&(MaxPoints), ydat0!(MaxPoints)
Global xdat1&(MaxPoints), ydat1!(MaxPoints)
Global xdat2(MaxPoints) As Long
Global ydat2(MaxPoints) As Single
Global ydat3(MaxPoints) As Single


Global Nmax_last(MaxCurves) As Integer
Global ih_last(MaxCurves) As Integer
Global xIndex As Integer, OptXIndex%
Global yIndex As Integer, OptYIndex%
Global saveConfigCanceled As Boolean
Global saveConfigFileName As String
Global saveConfigDescription As String

Global nl$
Global Win_Sec&(10)
Global datstr As String * 32
Global param%, index%, iplotable%
Global StartUp%
Global TargetYear As Integer

Global F_load As Integer

Global col_field(10) As Long
Global SelectBits&(16)

Global nparam%
Global Const DBPATH$ = "l:\database\archive\"
Global ConfPath$, UserConfPath$, HelpFilePath$, HistoryPath$, UserHistoryPath$, HistoryOCXPath$
Global UserConfigSubDirectory$
Global rtyp As String * 1
Type FECSTRUCT: eqm As String
                prop As String
                dev As String
                EqNo As Integer
                len As Integer
                fmt As String
                reclen As Integer
                rectyp As Integer
                tstamp As Integer
                vnum As Integer
                Comment As String
                responsible As String
                recIndex As Integer
End Type
Global fec(NUMEQP) As FECSTRUCT
Global vname$(NUMEQP, NUMDEV), vfmt$(NUMEQP, NUMDEV), vcmt$(NUMEQP, NUMDEV), VPlot$(NUMEQP, NUMDEV)
Global VMax#(NUMEQP, NUMDEV), VMin#(NUMEQP, NUMDEV), VUnit$(NUMEQP, NUMDEV), vsize%(NUMEQP, NUMDEV)
Global fref%(NUMEQP), pref%(NUMEQP), VOffset#(NUMEQP, NUMDEV), Nexti%, Nextp%, Nextf%, NextSubi%
Global correlate%, lg%

Global MKIoffset%

Type FECSLCT: ' structure for selected properties:
              'PropIndex As Integer
'
              ArchiveSourceFlag As Boolean ' From Central archiver, or a history?
              ContextName As String
              ServerName As String
              PropName As String
              deviceName As String
              DeviceIndex As Integer
              DeviceSubIndex As Integer ' for TD properties,...
              PropUnits As String
              PropSize As Long
              PropFormat As Byte
              PropFormatStr As String
              PropDesc As String
              NPropDevices As Integer ' if the number of DEVICES for the property is not its SIZE
              
              ' Which has been used to select this channel? Device NAME or INDEX?
              ValidDeviceName As Boolean
              ValidDeviceIndex As Boolean
              
              'ArchiveServer As String
              'FecName As String ' Archiver-Keyword....
              'fecNo As Integer are these really NOT needed? (pref and fref....)
              'pNo As Integer
              'helpText As String
              '
              ' Need for Local History Stuff
              ArchiveDataServer As String
              ArchiveHistoryServer As String
              ArchiveProperty As String
              ' Flag that data is from archiver....
              LHDataDochFromArchiver As Boolean
              '
              NumPoints As Integer
              TotalPoints As Long
              ' Total History Points
              TotalLHPoints As Long
              ' Total Archive Points
              TotalArchPoints As Long
              '
              '
              DataServer As String
              LinkIndex As Long
              ACOPPlotIndex As Long
              DrawWidth As Integer
              DispColor As Long
              '
              Scale As Integer
              PListIndex As Integer
              VMax As Double ' Default Values
              VMin As Double ' for scaling
              VScale As Double
              VOffset As Double
              VPlot As String
              VUnit As String
              Active As Boolean
              Acquire As Boolean
              ReFilter As Boolean
              ReScale As Boolean
              RePlot As Boolean
              MaxValue As Double
              MinValue As Double
              'Offset As Integer
              '
              SelectedMaxValue As Double ' When reading in TextBox stuff...
              SelectedMinValue As Double ' For scaling....
              SelectedOffset As Double ' For scaling....
              SelectedVMode As String ' Plotted as Log/Lin...
              SelectedVModeIndex As Integer ' Plotted as Log/Lin...
              PlotMaxValue As Double ' Actual Values (especially for AUTOSCALE, needed for ARRAY mode)
              PlotMinValue As Double ' for scaling
              PlotOffset As Double ' for scaling
              PlotZeroOffset As Double ' for calculating BACK
              PlotDelta As Double '
              PlotScale As Double '
              PlotAutoScale As Boolean
End Type
Global FSlct(MaxCurves * 2) As FECSLCT

Type SETSLCT: name As String
              ContextName As String
              ServerName As String
              EqnIndex As Integer
              deviceName As String
              DeviceIndex As Integer
              DeviceSubIndex As Integer
              AxScale As Double
              AxOffset As Double
              min As Double
              max As Double
              plottype As String
              Units As String
              Help As String
End Type
Global CSet() As SETSLCT ' ReDim in getArchiveServerInfo()

Global NPlots%(1)
Global fecKeywords() As String, ttfKeywords() As String

Type KeywordInfo
  server As String
  keyword As String
  max As Single
  min As Single
  egu As String
  plot As String
  desc As String
  size As Integer
  fmt As String
End Type

Global archivedKeywords() As KeywordInfo
Global filterKeywords(10) As KeywordInfo
Global nFilterKeywords As Integer
Global TmpConfigKeyword As KeywordInfo

Type HistoryConfigType
    name As String
    Description As String
    LocationProps As String
    LocationConfigs As String
    NClientOcxProps As Integer
    NClientCSVProps As Integer
    OCXFlag As Boolean
End Type
Global HistoryConfigs(20) As HistoryConfigType
Global NHistoryConfigs%, MaxNHistoryConfigs%, SelectedHistoryConfig%, SelectedHistoryConfigDescription$

Global gSubSystems() As String
Global gArchiveSubSystem$
Global gNumSubSystems As Integer
'Global cslct(2) As FECSLCT
'Global typ$(3)
Global extraArchiveServer(10) As String
Global nExtraArchiveServers As Integer
Global Const MaxnExtraArchiveServers = 5


' REDUCE for Kaul's slow PC....
Global Const MaxPlotPoints = 3000
Global Const MaxGetDataPointsARCH = 2000
Global Const MaxGetDataPointsHIST = 2000
Global Const MaxDataPointsAPPEND = MaxPlotPoints - MaxGetDataPointsHIST - 2
Global AppendTimeIncrement%, AppendTimeCounter%, AppendTotalCounter%


' Registry function declarations:
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" _
        (ByVal hKey As Long, ByVal lpctstr As String, phKey As Long) _
        As Long
        
Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, _
         lpcbValue As Long) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpdwReserved As Long, _
         lpdwType As Long, lpbData As Byte, lpcbValue As Long) As Long

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Sub makeLegacyArrays(ByVal histType As String, ByVal index As Integer, npoints As Integer)
Dim i As Integer
Select Case histType
  Case "ArchStringDataBuffer":
    If ArchStringDataBuffer(0, index).iVal <= MaxStrings Then
      npoints = npoints - 1
      Exit Sub
    End If
    If npoints > 200 Then
      npoints = npoints - 1
    Else
      For i = npoints - 1 To 0 Step -1
        ArchStringDataBuffer(i + 1, index) = ArchStringDataBuffer(i, index)
      Next
    End If
    ArchStringDataBuffer(0, index).iVal = npoints
  Case "ArchDataBuffer":
    If ArchDataBuffer(0, index).iVal <= MaxPoints Then
      npoints = npoints - 1
      Exit Sub
    End If
    If npoints > 200 Then
      npoints = npoints - 1
    Else
      For i = npoints - 1 To 0 Step -1
        ArchDataBuffer(i + 1, index) = ArchDataBuffer(i, index)
      Next
    End If
    ArchDataBuffer(0, index).iVal = npoints
    ArchDataBuffer(0, index).fval = npoints
  Case "ArchData":
    If ArchData(0, index).iVal <= MaxPoints Then
      npoints = npoints - 1
      Exit Sub
    End If
    If npoints > 200 Then
      npoints = npoints - 1
    Else
      For i = npoints - 1 To 0 Step -1
        ArchData(i + 1, index) = ArchData(i, index)
      Next
    End If
    ArchData(0, index).iVal = npoints
    ArchData(0, index).fval = npoints
End Select
End Sub

Public Sub PlotTheData(flag%)
Dim i%, ii%, n%, StartLabel%, StopLabel%, TmpPlots%, tmpIndex%, TmpMin#, TmpMax#

ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0
' Mode from OptPlot

ArchiveForm.ComSelect(2).BackColor = &HE0E0E0
For i% = 0 To 2
    ArchiveForm.TxtSelect(i%).BackColor = &HE0E0E0
Next i%

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).RePlot = False
        End If
    Next i%
    
    
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
    
    ArchiveForm.ACOPPlot(ActivePlot%).Visible = True
    'ArchiveForm.ACOPPlot(ActivePlot%).GraphStyle = TIME_LIN
ElseIf flag = 1 Then
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
End If

If NZooms% > 0 Then
    'ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits&(NZooms%, 2)
    'ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits&(NZooms%, 3)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmin = ZoomLimits&(NZooms%, 0)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmax = ZoomLimits&(NZooms%, 1)
Else
    ZoomLimits#(0, 0) = CDbl(ArchiveStart&)
    ZoomLimits#(0, 1) = CDbl(ArchiveStop&)
    
    If ScalingMode% = RelativeScale Then
        ZoomLimits#(0, 2) = 0
        ZoomLimits#(0, 3) = 100
    Else
        ' Do the same check in ScaleData ?
        TmpMin# = 1000000#
        TmpMax# = -1000000#
        For i% = StartLabel% To StopLabel%
            With FSlct(i%)
                If FSlct(i%).RePlot = True Then
                    If .PlotMaxValue > TmpMax# Then TmpMax# = .PlotMaxValue
                    If .PlotMinValue < TmpMin# Then TmpMin# = .PlotMinValue
                End If
            End With
        Next i%
        ZoomLimits#(0, 2) = TmpMin#
        ZoomLimits#(0, 3) = TmpMax#
    End If
End If

ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits#(NZooms%, 2)
ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits#(NZooms%, 3)
ArchiveForm.ACOPPlot(ActivePlot%).xmin = CLng(ZoomLimits#(NZooms%, 0))
ArchiveForm.ACOPPlot(ActivePlot%).xmax = CLng(ZoomLimits#(NZooms%, 1))

' Get more points than one thinks one needs (x-min and max are set to ZOOM limits not to ArchiveStart and -Stop
'ArchiveStart& = ArchiveStart& - 3600 * 1
'ArchiveStop& = ArchiveStop& + 3600 * 1

' Get an overview of what is to be plotted?
Call DrawCaption

For i% = StartLabel% To StopLabel%
    ArchiveForm.dnam(i%).BorderStyle = 0
    'ArchiveForm.Text1(i%).text = ""
Next i%

'For i% = 0 To 3
'    ArchiveForm.ComSelect(i%).Enabled = False
'Next i%

ArchiveForm.ChkAuto(1).Enabled = False

For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).RePlot = True Then
        n% = FSlct(i%).NumPoints
        ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = ACOPDefaultMode&
        ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = FSlct(i%).DispColor
        ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + ACOPDefaultWidth&
            
        FSlct(i%).ACOPPlotIndex = ArchiveForm.ACOPPlot(ActivePlot%).Draw(PlotData(1, i%).fval, PlotData(1, i%).iVal, , , n%, "FLTINT", MaxPoints)
    
        FSlct(i%).RePlot = False
    Else
        FSlct(i%).RePlot = False
    End If
Next i%

' Check if automatic AUTOSCALE (for ABSOLUTE scaling) is on?
If ArchiveForm.ChkScale.Value = vbUnchecked And ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPPlot(0).AutoScale False, False, True, True
    ArchiveForm.ACOPPlot(1).AutoScale False, False, True, True
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
End If

ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 1

TmpPlots% = NPlots%(ActivePlot%)
If ActivePlot% = 1 Then TmpPlots% = TmpPlots% + CopyOffset
For i% = StartLabel% To TmpPlots% - 1
    ArchiveForm.OptX(i%).Visible = True
    ArchiveForm.OptY(i%).Visible = True
Next i%
For i% = TmpPlots% To StopLabel%
    ArchiveForm.OptX(i%).Visible = False
    ArchiveForm.OptY(i%).Visible = False
Next i%

'ArchiveForm.ACOPPlot(ActivePlot%).AutoScale True, True, False, False

If SelectedTrace%(ActivePlot%) <> -1 Then
    tmpIndex% = SelectedTrace%(ActivePlot%)
    Call SelectATrace(tmpIndex%)
End If
ArchiveForm.LabelMisc(3).Visible = False

' ALSO REFRESH CORRELATE PLOT?
If ArchiveForm.ChkDouble(2).Value = vbChecked Or ArchiveForm.ChkDouble(3).Value = vbChecked Then
    Call DrawCorr
End If

End Sub

Public Sub OLDReadTheArchiveData(flag%)
Dim i%, ii%, n%, j%, k%, kk%, StartLabel%, StopLabel%, MsgRC%, rc%, rcc&
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), tStr$, tmpTotalPoints&, TmpText$
Dim useStringBuffer As Boolean, scratchTotalPoints As FLTINT

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1


If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).Acquire = True
            FSlct(i%).ReFilter = True
            FSlct(i%).ReScale = True
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).Acquire = False
            FSlct(i%).ReFilter = False
            FSlct(i%).ReScale = False
            FSlct(i%).RePlot = False
        End If
        'ArchiveForm.acopplot(0).LockScreen 0, fslct(i%).ACOPPlotIndex
        FSlct(i%).ACOPPlotIndex = -1
    Next
'ElseIf Flag = 1 Then
'    For i% = StartLabel% To StopLabel%
'    '   THIS NEEDS TO BE FIXED !!!! The ArchData() buffer gets reassigned inside the drawing logic to
'    '   accomplish some sort of scaling, etc.  That's why it needs to be reacquired for the autoscale to
'    '   work properly.  The solution is to use a second drawing buffer
'        'If FSlct(i%).Active = True Then FSlct(i%).Acquire = True ' Testing! shouldn't be here - but AUTOSCALE plots wrong without it....
'
'        If FSlct(i%).Active = True Then
'            FSlct(i%).RePlot = True
'        Else
'        End If
'    Next
End If



For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).Acquire = True Then
        If NZooms% = 0 Then
            ' get an extra hour each side.....
            tmpSide& = 3600
        Else
            ' What if the data are in ONE SECOND raster - then don't add too much....
            If FSlct(i%).NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
        End If
        
        TmpStartStop&(0) = ArchiveStart& - tmpSide&
        TmpStartStop&(1) = ArchiveStop& + tmpSide&
        
        If ActivePlot% = 1 Then
            ' Don't do anything.... don't need to read data for "copy-buffer"
        ElseIf (FSlct(i%).PropName = OpMinus) Or (FSlct(i%).PropName = OpPlus) Or (FSlct(i%).PropName = OpMult) Or (FSlct(i%).PropName = OpDiv) Then
            ' Doing mathematical operations (subtracting coasting beam....)
            Call OperateOnTheData(i%)
        Else
            If Not filterAcquired Then
retrieveFilterData:
                If nFilterKeywords > 0 Then
                    ArchiveForm.ACOPData.Caption = filterString
                    For j% = 0 To nFilterKeywords - 1
                        If filterKeywords(j%).fmt = "NAME32" Then
                            ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                            ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                            rcc& = ArchiveForm.ACOPData.Execute(filterTextBuffer(0, j%).nam, MaxPoints / 10, "NAME32I", TmpStartStop)
                        Else
                            ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                            ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                            rcc& = ArchiveForm.ACOPData.Execute(filterDataBuffer(0, j%).fval, MaxPoints, "FLTINT", TmpStartStop)
                        End If
                        If rcc& Then
                            MsgRC = MsgBox(" Error acquiring filter! " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Archive Retrieval")
                            n% = 0
                            If MsgRC = vbRetry Then GoTo retrieveFilterData
                          End If
                    Next j%
                Else
                    ArchiveForm.ACOPData.Caption = ""
                End If
                filterAcquired = True
            End If
            
            ' get the data out of the archive
retrieveArchiveData:
            ArchiveForm.LabelMisc(3).Caption = "Data loading...."
            ArchiveForm.LabelMisc(3).Visible = True
            ArchiveForm.Refresh
            
            ' give it a longer timeout in case there's a bunch of data :
            If ArchiveForm.timeoutText.Visible Then
                ArchiveForm.ACOPData.AccessRate = ArchiveForm.timeoutText.text '3000
            Else
                ArchiveForm.ACOPData.AccessRate = 3000
            End If
            
            If FSlct(i%).DeviceIndex < 0 And FSlct(i%).deviceName = "#0" And Mid(FSlct(i%).PropName, 1, 3) <> "TTF" Then
                ' For the HTC: get the BUNCH CURRENTS for the INDEX of the HE_HTC_BUNCH!
                ArchiveForm.ACOPData.deviceName = FSlct(i%).ServerName
                Call GetHTCStuff(i%)
            Else
                If Mid(FSlct(i%).PropName, 1, 3) = "TTF" Then
                    ArchiveForm.ACOPData.deviceName = "TTFHISTORY"
                
                    ' Kludge for the HTC Bunch-Selection....
                    If FSlct(i%).DeviceIndex < 0 Then FSlct(i%).DeviceIndex = 0
                    
                    ' Is this a TD Property?
                    If FSlct(i%).VPlot = "TD" Then
                        TmpStartStop&(2) = FSlct(i%).DeviceIndex * NTDBunches + FSlct(i%).DeviceSubIndex
                    Else
                        TmpStartStop&(2) = FSlct(i%).DeviceIndex
                    End If
                Else
                    If FSlct(i%).DeviceIndex >= 0 Then TmpStartStop&(2) = FSlct(i%).DeviceIndex
                End If
            
                ArchiveForm.ACOPData.deviceProperty = FSlct(i%).PropName
                ArchiveForm.ACOPData.deviceName = FSlct(i%).ServerName + "/" + FSlct(i%).deviceName
                If FSlct(i%).Acquire = True Then
                    tStr = Left(UCase(FSlct(i%).PropFormatStr), 4)
                    If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
                        rcc& = ArchiveForm.ACOPData.Execute(ArchStringDataBuffer(0, i%).nam, MaxStrings, "NAME32I", TmpStartStop, 2)
                        ArchDataBuffer(0, i%).iVal = ArchStringDataBuffer(0, i%).iVal
                        useStringBuffer = True
                    Else
                        rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, i%).fval, MaxPoints, "FLTINT", TmpStartStop, 2)
                    End If
                End If

                kk% = 1
                For k% = 1 To ArchDataBuffer(0, i%).iVal
                    If (nFilterKeywords = 0) Or (filerArchiveData(ArchDataBuffer(k%, i%).iVal) > 0) Then
                        If useStringBuffer Then
                            ArchData(kk%, i%).iVal = ArchStringDataBuffer(k%, i%).iVal
                        Else
                            ArchData(kk%, i%) = ArchDataBuffer(k%, i%)
                        End If
                        kk% = kk% + 1
                    End If
                Next k%
                ArchData(0, i%).iVal = kk% - 1
            End If
            
            
            If rcc& Then
                MsgRC% = MsgBox(" Error! " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Archive Retrieval")
                n% = 0
                tmpTotalPoints& = 0
                If MsgRC = vbRetry Then
                    GoTo retrieveArchiveData
                ElseIf MsgRC = vbAbort Then
                    FSlct(i%).ReFilter = False
                    FSlct(i%).ReScale = False
                    FSlct(i%).RePlot = False
                    Exit Sub
                Else
                End If
            Else
                n% = ArchData(0, i%).iVal
            
                ' Get the total number of points in the interval
                rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
                If rcc& Then
                    tmpTotalPoints& = -1
                Else
                    tmpTotalPoints& = scratchTotalPoints.iVal
                End If
            End If
            
            FSlct(i%).NumPoints = n%
            FSlct(i%).TotalPoints = tmpTotalPoints&
        
            For ii% = 1 To n% - 1
                ArchTimeBins#(ii%, i%) = CDbl((ArchData(ii%, i%).iVal) + CDbl((ArchData(ii% + 1, i%).iVal - ArchData(ii%, i%).iVal)) / 2)
            Next ii%
            ArchTimeBins#(0, i%) = ArchData(1, i%).iVal - 100
            ArchTimeBins#(n% + 1, i%) = ArchData(n%, i%).iVal + 100
        End If
        
        ' Which row is the data in?
        tmpIndex% = IndexToDName%(i%)
        'ArchiveForm.LinLog(TmpIndex%) = FSlct(i%).VPlot
'        If FSlct(i%).TotalPoints > 1000000# Then
'            tmpText$ = Format$(n%, "0") + "/" + Format$(FSlct(i%).TotalPoints, "0")
'        Else
'            tmpText$ = Format$(n%, "0") + " / " + Format$(FSlct(i%).TotalPoints, "0")
'        End If
'        ArchiveForm.Text1(tmpIndex%) = tmpText$
        
        
        FSlct(i%).Acquire = False
        
        FSlct(i%).ReFilter = True
        FSlct(i%).ReScale = True
        FSlct(i%).RePlot = True
    End If
Next i%

End Sub

Public Sub ScaleTheData(flag%)
Dim i%, ii%, j%, n%, StartLabel%, StopLabel%, tmpFaktor!, TmpOffset!, tmpMask&
Dim ScaleMax!, ScaleMin!, ScaleOffset!, tmpPlotRange!, tmpPlotOffset!
Dim Delta!, ZeroOffset!, InvDelta!, tmpCopyBytes&

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

' How to do the scaling? 0-100, or absolute, or ACOP-YScale?
'If ScalingMode% = 0 Then

If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).ReScale = True
        Else
            FSlct(i%).ReScale = False
        End If
    Next i%
End If

'Need to do anything? Check if RELATIVE scale....
If ArchiveForm.ChkScale.Value Then
    'Need to do the re-scaling
Else
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).ReScale = True Then
            'FSlct(i%).ReScale = False
            'FSlct(i%).RePlot = True
        Else
            ''FSlct(i%).ReScale = False
        End If
    Next i%
End If

For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).ReScale = True And FSlct(i%).NumPoints > 0 Then
        n% = FSlct(i%).NumPoints
        
        ' What is this for?
        For j% = 0 To NDisplayModes% - 1
            If UCase$(FSlct(i%).SelectedVMode) = DisplayModes$(j%) Then
                FSlct(i%).SelectedVModeIndex = DisplayModeIndexes%(j%)
                Exit For
            End If
        Next j%
                
        
        ' A bit of data-verarbeiting...
        ' Check if the DATA is meant to be scaled...
        tmpFaktor! = FSlct(i%).VScale
        If Not (tmpFaktor! = 0 Or tmpFaktor! = 1) Then
            TmpOffset! = FSlct(i%).VOffset
            For ii% = 1 To n%
               ArchData(ii%, i%).fval = ArchData(ii%, i%).fval * tmpFaktor! + TmpOffset!
            Next ii%
        ElseIf (FSlct(i%).VPlot = "BIT") Or (FSlct(i%).VPlot = "BITS") Then
            'FSlct(i%).VMax = 16.1
            'FSlct(i%).VMin = -0.05
            FSlct(i%).SelectedMaxValue = FSlct(i%).VMax
            FSlct(i%).SelectedMinValue = FSlct(i%).VMin
           
            ' ScaleForBits
            'tmpFaktor! = 1
            'tmpMask& = SelectBits&(FSlct(i%).DeviceSubIndex - 1)
            For ii% = 1 To n%
               ArchData(ii%, i%).fval = ScaleForBits(i%, CLng(ArchData(ii%, i%).fval)) '2 * i% + (CLng(ArchData(ii%, i%).fval) And TmpMask&) / TmpMask&
            Next ii%
        ElseIf UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
            ' Do this check HERE, and do it only ONCE....
            For ii% = 1 To n%
               If ArchData(ii%, i%).fval <= 0 Then ArchData(ii%, i%).fval = 0.0000001
            Next ii%
            tmpFaktor! = 1
        End If
                
        FSlct(i%).PlotScale = tmpFaktor!
        
        FSlct(i%).MaxValue = -1
        FSlct(i%).MinValue = -1
                                                      
        
        If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
            ' Scale to the Max and Min values IN THE DATA....
            If FSlct(i%).MaxValue = -1 And FSlct(i%).MinValue = -1 Then
                ' Must find NEW max and min values
                ScaleMax! = ArchData(1, i%).fval
                ScaleMin! = ScaleMax!
                For ii% = 2 To n%
                    ' Only look at points being DISPLAYED!
                    If ArchData(ii%, i%).iVal > ZoomLimits#(NZooms%, 0) And ArchData(ii%, i%).iVal < ZoomLimits#(NZooms%, 1) Then
                        If ArchData(ii%, i%).fval > ScaleMax! Then
                            ScaleMax! = ArchData(ii%, i%).fval
                        ElseIf ArchData(ii%, i%).fval < ScaleMin! Then
                            ScaleMin! = ArchData(ii%, i%).fval
                        End If
                    End If
                Next ii%
                ' make sure an array of "all the same thing" goes down the middle:
                If ScaleMax! = ScaleMin! Then
                  ScaleMax! = ScaleMax! + ScaleMax! * 0.1 + 1
                  ScaleMin! = ScaleMin! - ScaleMin! * 0.1 - 1
                End If
                FSlct(i%).MaxValue = ScaleMax!
                FSlct(i%).MinValue = ScaleMin!
            End If
            ' Put them 5% away from the edge?
            ScaleMax! = FSlct(i%).MaxValue + (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
            ScaleMin! = FSlct(i%).MinValue - (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
        
            ScaleMax! = ScaleMax! * 1
            ScaleMin! = ScaleMin!
        
            ScaleOffset! = 0
        Else
            FSlct(i%).MaxValue = -1: FSlct(i%).MinValue = -1
            ScaleMax! = FSlct(i%).SelectedMaxValue
            ScaleMin! = FSlct(i%).SelectedMinValue
            ScaleOffset! = FSlct(i%).SelectedOffset
        End If
                
        FSlct(i%).PlotMaxValue = ScaleMax!
        FSlct(i%).PlotMinValue = ScaleMin!
        FSlct(i%).PlotOffset = ScaleOffset!
    
        If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
            tmpPlotRange! = ZoomLimits#(NZooms%, 3) - ZoomLimits#(NZooms%, 2)
            tmpPlotOffset! = ZoomLimits#(NZooms%, 2)
        Else
            tmpPlotRange! = 100
            tmpPlotOffset! = 0
        End If
        
        If n% <= 1 Then
            Delta! = ScaleMax! - ScaleMin!
            ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
            FSlct(i%).PlotDelta = Delta! / 100
            FSlct(i%).PlotZeroOffset = ZeroOffset!
        Else
            ' To scale the data properly....
            If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                If ScaleMin <= 0 Then ScaleMin = 0.01
                If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
                Delta! = (Log(ScaleMax!) - Log(ScaleMin!)) '/ Log(10#)
                If FSlct(i%).VMin = 0 Then FSlct(i%).VMin = 1E-20
                ZeroOffset! = Log(ScaleMin) 'Log(FSlct(i%).VMin) '/ Log(10#)
            Else
                Delta! = ScaleMax! - ScaleMin!
                ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
            End If
        
            ' Use the scale-factor in the form for the GRAPHICS!
            If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = tmpPlotRange! / Delta!
        
            ' For re-scaling
            If tmpPlotRange! = 0 Then tmpPlotRange! = 100
            FSlct(i%).PlotDelta = Delta! / tmpPlotRange!
            FSlct(i%).PlotZeroOffset = ZeroOffset!
        
            ' The number of points in the array...
            PlotData(0, i%).iVal = ArchData(0, i%).iVal
            
            Select Case ScalingMode%
            Case AbsoluteScale:
                    tmpCopyBytes& = (PlotData(0, i%).iVal + 1) * 8
                    Call MEMCPYL(PlotData(0, i%), ArchData(0, i%), tmpCopyBytes&)
            
            Case RelativeScale:
                
                ' Plotting "mode"
                If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                    'Call ARRLOG(ydat(0, i%), ydat(0, i%), n%)
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        If ArchData(ii%, i%).fval > 0 Then
                            PlotData(ii%, i%).fval = (Log(ArchData(ii%, i%).fval) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                            'PlotData(ii%, i%).fval = (Log(ArchData(ii%, i%).fval) - ZeroOffset!) * InvDelta!
                        Else
                            PlotData(ii%, i%).fval = 0
                        End If
                    Next ii%
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "ABS" Then
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        PlotData(ii%, i%).fval = (Abs(ArchData(ii%, i%).fval) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii%
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "SLOG" Then
                    'Call ARRMULT(CF_FLOAT, ydat(0, i%), 1 / fslct(i%).VMax, n%)
                    tmpFaktor! = 1 '/ FSlct(i%).VMax
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        If ArchData(ii%, i%).fval > 0 Then
                            ii% = ii%
                        End If
                        PlotData(ii%, i%).fval = (ArchData(ii%, i%).fval * tmpFaktor! - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii%
                Else
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        PlotData(ii%, i%).fval = (ArchData(ii%, i%).fval - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                        'Debug.Print ii%, PlotData(ii%, i%).ival, PlotData(ii%, i%).fval, ArchData(ii%, i%).fval
                    Next ii%
                End If
            End Select
        End If
    
        FSlct(i%).ReScale = False
        FSlct(i%).ReFilter = True
        FSlct(i%).RePlot = True
    Else
        ' Nothing to do?
        FSlct(i%).ReScale = False
    End If
Next i%
End Sub


Public Sub DoTheData(flag%)

'   flag=0  alle daten neu
'   flag=1  nur plotten ohne daten holen

' OLD
'Call DrawData(Flag%)


' NEW
Call ReadTheData(flag%)

'If ArchiveMode% = CArchivers Then
'    Call ReadTheArchiveData(Flag%)
'Else
'    Call ReadTheHistoryData(Flag%)
'End If

' Throw out points?

Call FilterTheData(flag%)

'
Call ScaleTheData(flag%)

'
Call PlotTheData(0) '(Flag%)

End Sub

Function getArchiveServerInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim hst_col%, dat_col%, mac_col%, cfg_col%
Dim fn$

'fn$ = App.Path + "\" + fname
fn$ = ConfPath$ + "\" + fname

NMachines = getDatabaseSize(fn$)
If NMachines = 0 Then
  getArchiveServerInfo = 0
  Exit Function
End If

' put USER files in NMACHINES +1
ReDim gArchiveServerInfo(NMachines + 1)
ReDim SetFile$(NMachines + 1, ConfFiles)
ReDim SetDir$(NMachines + 1, ConfFiles)
ReDim SetHelp$(NMachines + 1, ConfFiles)
ReDim NElem%(NMachines + 1, ConfFiles)
ReDim NSet%(NMachines + 1)
ReDim CSet(NMachines + 1, ConfFiles, 30)

Open fn$ For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      hst_col = colptr(a$, "ARCHIVE SERVER")
      dat_col = colptr(a$, "DATA SERVER")
      mac_col = colptr(a$, "MACHINE")
      cfg_col = colptr(a$, "CONFIG FILE")
      done = True
    Else
      gArchiveServerInfo(i%).ConfigFileName = getcol(a$, cfg_col)
      gArchiveServerInfo(i%).DataServerName = getcol(a$, dat_col)
      gArchiveServerInfo(i%).HistoryServerName = getcol(a$, hst_col)
      gArchiveServerInfo(i%).MachineName = getcol(a$, mac_col)
      i% = i% + 1
      If i% >= NMachines Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1
getArchiveServerInfo = i%
End Function
Function getKeywordNames(server As String, keyword As String, keywordNames() As String) As Integer
Dim rc%, i%
Dim dbout As DBLK
Dim dbin As DBLK
Dim dbinbuf(1) As Long
Dim size As Integer
Dim kwd As String
Dim bKeywordNames() As NAME16
Dim bkwd(32) As Byte
Dim prp As PropertyQuery

kwd = keyword + ".NAM"

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR bkwd(), kwd
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)
If prp.prpSize = 0 Then rc = illegal_property
If rc = 0 Then
  size = prp.prpSize
  ReDim bKeywordNames(size)
  dbout.dArrayLength = size: dbout.dFormat = CF_NAME16
  If ArchiveStart& > 0 And ArchiveStop& > 0 Then
    dbin.dArrayLength = 2: dbin.dFormat = CF_LONG
    dbinbuf(0) = ArchiveStart&: dbinbuf(1) = ArchiveStop&
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, dbinbuf(0), CA_READ, 1000)
  Else
    dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, 0, CA_READ, 1000)
  End If
Else
  size = UBound(keywordNames) - LBound(keywordNames) + 1
End If

If size = 8000 Then size = 1 ' force extra archive servers to register names
For i% = 0 To size - 1
  If rc Then
    keywordNames(i%) = "#" + Trim(str(i%))
  Else
    keywordNames(i%) = BSTR(bKeywordNames(i%).nam)
  End If
Next
getKeywordNames = size
End Function

Sub getKeywordInfo(server As String, keyword As String, minimum As Single, maximum As Single, _
                   egu As String, plot As String, desc As String, size As Integer, datatype As String)
Dim rc%, fmt%, ptype As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim prp As PropertyQuery
Dim denom As Single
Dim bkwd(32) As Byte

If datatype <> "" Then Exit Sub ' already done
rc% = GetEquipmentExtEGU(server, keyword, minimum, maximum, egu, ptype)
If rc% Then Exit Sub
denom = Abs(minimum)
If denom = 0 Then denom = 1
Select Case ptype
  Case 0: plot = "LIN"
  Case 1: plot = "LOG"
  Case 2: plot = "SLOG"
  Case 3: plot = "TD"
  Case 4: plot = "BITS"
  Case 5: plot = "TEXT"
  Case 6: plot = "ABS"
  Case Else: plot = "LIN"
End Select

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR bkwd(), keyword$
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)
desc = BSTR(prp.prpDesc())
size = prp.prpSize
fmt% = prp.prpFormat + 512
Select Case fmt
 Case CF_TEXT: datatype = "NAME32": plot = "LUMI"
 Case CF_NAME32: datatype = "NAME32": plot = "LUMI"
 Case CF_NAME16: datatype = "NAME16": plot = "LUMI"
 Case CF_NAME48: datatype = "NAME48": plot = "LUMI"
 Case CF_FLOAT: datatype = "float"
 Case CF_LONG: datatype = "long"
 Case CF_SHORT: datatype = "short"
 Case CF_DOUBLE: datatype = "double"
 Case Else: datatype = "float"
End Select
End Sub
Sub DrawCaption()
Dim i%, nm$, tmpIndex%, idx%, TmpText$, TmpDNameIndex%

'ArchiveForm.FrameMisc(0).Visible = True
'ArchiveForm.FrameMisc(1).Visible = False

' Clear everything first....
'For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
'    ArchiveForm.dunit(i%).Caption = ""
'    ArchiveForm.dnam(i%).Caption = ""
'    ArchiveForm.dhelp(i%).Caption = ""
'    ArchiveForm.dlab(i%).Caption = ""
'    'ArchiveForm.dNow(i%).Caption = ""
'    ArchiveForm.dhelp(i%).ToolTipText = ""
'
'    'ArchiveForm.dhelp(i%).AutoSize = False
'    'ArchiveForm.dhelp(i%).WordWrap = False
'Next i%

'If SelectedTrace%(ActivePlot%) <> -1 Then
'    TmpDNameIndex% = IndexToDName%(SelectedTrace%(ActivePlot%))
'    'ArchiveForm.dhelp(TmpDNameIndex%).AutoSize = True
'ElseIf SelectedPlotArrayTrace% <> -1 Then
'    TmpDNameIndex% = SelectedPlotArrayTrace%
'End If
'SelectedPlotArrayTrace%

For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    With FSlct(i%)
        tmpIndex% = IndexToDName%(i%)
        If .Active = True Then
            ArchiveForm.dlab(tmpIndex%).ForeColor = .DispColor
            ArchiveForm.dunit(tmpIndex%).ForeColor = .DispColor
            'ArchiveForm.dNow(tmpIndex%).ForeColor = FSlct(i%).DispColor
          
            nm$ = .PropName
            If nm$ = "H1LUMI" Then
                If .DeviceIndex = 5 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "E+31"
                ElseIf .DeviceIndex = 6 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "E+30"
                ElseIf .DeviceIndex = 3 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "kHz"
                End If
            Else
                ArchiveForm.dunit(tmpIndex%).Caption = .VUnit
            End If
            idx% = .PListIndex
            If .PropSize > 1 Then
                nm$ = nm$ + "[" + Format$(.DeviceIndex, "###0") + "]"
            End If
            If (UCase$(.VPlot) = "TD") Or (UCase$(.VPlot) = "T.D.") Or (UCase$(.VPlot) = "BIT") Or (UCase$(.VPlot) = "BITS") Then
                nm$ = nm$ + "(" + Format$(.DeviceSubIndex - 1, "###0") + ")"
            End If
        
            ArchiveForm.dnam(tmpIndex%).ForeColor = .DispColor
            ArchiveForm.dnam(tmpIndex%).Caption = nm$
            
            ArchiveForm.dhelp(tmpIndex%).ForeColor = .DispColor
            If .NPropDevices > 1 Then
                If InStr(1, .deviceName, "#") <> 0 Then
                    TmpText$ = .PropDesc + " [" + Trim(str$(.DeviceIndex)) + "]"
                Else
                    TmpText$ = .PropDesc + " [" + .deviceName + "]"
                End If
            Else
                TmpText$ = .PropDesc
            End If
            If .VPlot = "BIT" Then
                TmpText$ = TmpText$ + " (Bit" + str$(.DeviceSubIndex - 1) + ")"
            End If
            
            If ArchiveForm.dhelp(tmpIndex%).Caption <> TmpText$ Then
                ArchiveForm.dhelp(tmpIndex%).Caption = TmpText$
            End If
            
            'ArchiveForm.dhelp(tmpIndex%).Caption = tmpText$
            ArchiveForm.dhelp(tmpIndex%).ToolTipText = TmpText$
        
        Else
'            ArchiveForm.dunit(tmpIndex%).Caption = ""
'            ArchiveForm.dnam(tmpIndex%).Caption = ""
'            ArchiveForm.dhelp(tmpIndex%).Caption = ""
'            ArchiveForm.dlab(tmpIndex%).Caption = ""
'            'ArchiveForm.dNow(tmpIndex%).Caption = ""
'            ArchiveForm.dhelp(tmpIndex%).ToolTipText = ""
        End If
     End With
Next i%

End Sub

Function filerArchiveData(d As Long) As Integer
Dim i%, j%
Dim iStart As Integer, iStop As Integer
Dim latched As Boolean
Dim foundCnt As Integer

If nFilterKeywords = 0 Then
  filerArchiveData = 0
  Exit Function
End If
For j% = 0 To nFilterKeywords - 1
  If foundCnt < j% Then Exit For
  If filterKeywords(j%).fmt = "NAME32" Then
  ' latch timestamp
    If filterTextBuffer(0, j%).iVal = 0 Then
      filerArchiveData = 0
      Exit Function
    End If
    iStart = 1: iStop = filterTextBuffer(0, j%).iVal - 1
    While Not ((latched) Or (iStop = iStart) Or (iStop = iStart + 1))
      i% = iStart + ((iStop - iStart) / 2)
      If filterTextBuffer(i%, j%).iVal < d Then
        iStart = i%
      ElseIf filterTextBuffer(i%, j%).iVal > d Then
        iStop = i%
      ElseIf filterTextBuffer(i%, j%).iVal = d Then
        latched = True
      End If
    Wend
    If UCase(filterKeywords(j%).plot) = UCase(BSTR(filterTextBuffer(i%, j%).nam)) Then
      foundCnt = foundCnt + 1
'      filerArchiveData = 1
'      Exit Function
    End If
  Else
  ' latch timestamp
    If filterDataBuffer(0, j%).iVal = 0 Then
      filerArchiveData = 0
      Exit Function
    End If
    iStart = 1: iStop = filterDataBuffer(0, j%).iVal - 1
    While Not ((latched) Or (iStop = iStart) Or (iStop = iStart + 1))
      i% = iStart + ((iStop - iStart) / 2)
      If filterDataBuffer(i%, j%).iVal < d Then
        iStart = i%
      ElseIf filterDataBuffer(i%, j%).iVal > d Then
        iStop = i%
      ElseIf filterDataBuffer(i%, j%).iVal = d Then
        latched = True
      End If
    Wend
    If filterDataBuffer(i%, j%).fval >= filterKeywords(j%).min And _
       filterDataBuffer(i%, j%).fval <= filterKeywords(j%).max Then
      foundCnt = foundCnt + 1
'      filerArchiveData = 1
'      Exit Function
    End If
  End If
Next
If foundCnt = nFilterKeywords Then filerArchiveData = 1 Else filerArchiveData = 0
End Function

Sub DrawData(flag As Integer)
Dim TmpYData!(MaxPoints), TmpXData0&(MaxPoints), TmpXData1&(MaxPoints), NTmp0%, NTmp1%
Dim TmpStartStop&(3), tmpData(MaxPoints) As FLTINT
Dim tmpFaktor!, TmpOffset!, tmpValue!, TmpWindowWidth&, tmpAutoFlag As Boolean
Dim i%, j%, ii%, k%, kk%, n%, rc%, rcc&
Dim Delta!, InvDelta!, ZeroOffset!, TmpLength%, tmpMask&, tmpIndex%
Dim ScaleMax!, ScaleMin!, ScaleOffset!
Dim StartLabel%, StopLabel%, TmpPlots%
Dim ErrorCount%, OKCount%, MsgRC%, tmpSide&, tmpPlotRange!, tmpPlotOffset!
Dim tStr As String, tmpTotalPoints&, TmpText$
Dim scratchTotalPoints As FLTINT
Dim useStringBuffer As Boolean

'   flag=0  alle daten neu
'   flag=1  nur plotten ohne daten holen
'   flag=2  Update (live data-refresh?)
Dim xf As Single

On Error GoTo DataProblems

ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0
' Mode from OptPlot

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

If flag = 0 Then
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then FSlct(i%).Acquire = True Else FSlct(i%).Acquire = False
        'ArchiveForm.acopplot(0).LockScreen 0, fslct(i%).ACOPPlotIndex
        FSlct(i%).ACOPPlotIndex = -1
    Next
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
    
    ArchiveForm.ACOPPlot(ActivePlot%).Visible = True
    'ArchiveForm.ACOPPlot(ActivePlot%).GraphStyle = TIME_LIN
        
ElseIf flag = 1 Then
    For i% = StartLabel% To StopLabel%
    '   THIS NEEDS TO BE FIXED !!!! The ArchData() buffer gets reassigned inside the drawing logic to
    '   accomplish some sort of scaling, etc.  That's why it needs to be reacquired for the autoscale to
    '   work properly.  The solution is to use a second drawing buffer
        'If FSlct(i%).Active = True Then FSlct(i%).Acquire = True ' Testing! shouldn't be here - but AUTOSCALE plots wrong without it....
        If FSlct(i%).Active = True Then FSlct(i%).RePlot = True
    Next
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
End If

If NZooms% > 0 Then
    'ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits&(NZooms%, 2)
    'ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits&(NZooms%, 3)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmin = ZoomLimits&(NZooms%, 0)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmax = ZoomLimits&(NZooms%, 1)
Else
    ZoomLimits#(0, 0) = CDbl(ArchiveStart&)
    ZoomLimits#(0, 1) = CDbl(ArchiveStop&)
    ZoomLimits#(0, 2) = 0
    ZoomLimits#(0, 3) = 100
End If

ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits#(NZooms%, 2)
ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits#(NZooms%, 3)
ArchiveForm.ACOPPlot(ActivePlot%).xmin = CLng(ZoomLimits#(NZooms%, 0))
ArchiveForm.ACOPPlot(ActivePlot%).xmax = CLng(ZoomLimits#(NZooms%, 1))

' Get more points than one thinks one needs (x-min and max are set to ZOOM limits not to ArchiveStart and -Stop
'ArchiveStart& = ArchiveStart& - 3600 * 1
'ArchiveStop& = ArchiveStop& + 3600 * 1

' Get an overview of what is to be plotted?
Call DrawCaption

For i% = StartLabel% To StopLabel%
    ArchiveForm.dnam(i%).BorderStyle = 0
    'ArchiveForm.Text1(i%).text = ""
Next i%

For i% = 0 To 3
    ArchiveForm.ComSelect(i%).Enabled = False
Next i%
ArchiveForm.ChkAuto(1).Enabled = False

For i% = StartLabel% To StopLabel%
'    If FSlct(i%).Acquire = True Then
        FSlct(i%).MaxValue = -1
        FSlct(i%).MinValue = -1
        
      If FSlct(i%).Active Then
        
        If NZooms% = 0 Then
            ' get an extra hour each side.....
            tmpSide& = 3600
        Else
            ' What if the data are in ONE SECOND raster - then don't add too much....
            If FSlct(i%).NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
        End If
        
        TmpStartStop&(0) = ArchiveStart& - tmpSide&
        TmpStartStop&(1) = ArchiveStop& + tmpSide&
        
        If ActivePlot% = 1 Then
            ' Don't do anything....
        ElseIf (FSlct(i%).PropName = OpMinus) Or (FSlct(i%).PropName = OpPlus) Or (FSlct(i%).PropName = OpMult) Or (FSlct(i%).PropName = OpDiv) Then
            ' try to do an operation on two of the arrays which are already loaded.....
            If i% < 2 Then
                MsgBox " error in operation! not enough arrays!"
                Exit Sub
            End If
            
            ' use the time stamps of the last to get the data points for the SECOND-to-LAST....
            NTmp0% = FSlct(i% - 2).NumPoints
            For ii% = 0 To NTmp0% - 1
                TmpXData0&(ii%) = ArchData(ii% + 1, i% - 2).iVal
                TmpYData!(ii%) = ArchData(ii% + 1, i% - 2).fval
            Next ii%
            
            NTmp1% = FSlct(i% - 1).NumPoints
            For ii% = 0 To NTmp1% - 1
                TmpXData1&(ii%) = ArchData(ii% + 1, i% - 1).iVal
            Next ii%
            
            ' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
            rc% = INTERP(TmpYData!(0), TmpXData0&(0), NTmp0%, TmpXData1&(0), NTmp1%)
            ' assume it is MINUS...
            If FSlct(i%).PropName = OpMinus Then
                If FSlct(i% - 1).PropName = "HPBunCur" Then
                    ' Just so the plot looks good for the proton-current plot....
                    For ii% = 1 To FSlct(i% - 1).NumPoints
                        ArchData(ii%, i%).iVal = ArchData(ii%, i% - 1).iVal
                        If TmpYData(ii% - 1) > 5 Then ' Check how much proton current.....
                            ArchData(ii%, i%).fval = TmpYData(ii% - 1) - ArchData(ii%, i% - 1).fval
                        Else
                            ArchData(ii%, i%).fval = 0
                        End If
                    Next ii%
                Else
                    For ii% = 1 To FSlct(i% - 1).NumPoints
                        ArchData(ii%, i%).iVal = ArchData(ii%, i% - 1).iVal
                        'If TmpYData(ii% - 1) > 40 Then
                            ArchData(ii%, i%).fval = TmpYData(ii% - 1) - ArchData(ii%, i% - 1).fval
                        'Else
                        '    ArchData(ii%, i%).fval = 0
                        'End If
                    Next ii%
                End If
            ElseIf FSlct(i%).PropName = OpPlus Then
                For ii% = 1 To FSlct(i% - 1).NumPoints
                    ArchData(ii%, i%).iVal = ArchData(ii%, i% - 1).iVal
                    'If TmpYData(ii% - 1) > 40 Then
                        ArchData(ii%, i%).fval = TmpYData(ii% - 1) + ArchData(ii%, i% - 1).fval
                    'Else
                    '    ArchData(ii%, i%).fval = 0
                    'End If
                Next ii%
            ElseIf FSlct(i%).PropName = OpMult Then
                For ii% = 1 To FSlct(i% - 1).NumPoints
                    ArchData(ii%, i%).iVal = ArchData(ii%, i% - 1).iVal
                    'If TmpYData(ii% - 1) > 40 Then
                        ArchData(ii%, i%).fval = TmpYData(ii% - 1) * ArchData(ii%, i% - 1).fval
                    'Else
                    '    ArchData(ii%, i%).fval = 0
                    'End If
                Next ii%
            ElseIf FSlct(i%).PropName = OpDiv Then
                If FSlct(i% - 1).PropName = "D3IBottom" Then
                    ' Just so the plot looks good for the proton-current plot....
                    For ii% = 1 To FSlct(i% - 1).NumPoints
                        ArchData(ii%, i%).iVal = ArchData(ii%, i% - 1).iVal
                        If (TmpYData(ii% - 1) > 1) And (ArchData(ii%, i% - 1).fval <> 0) Then
                            ArchData(ii%, i%).fval = TmpYData(ii% - 1) / ArchData(ii%, i% - 1).fval
                        Else
                            ArchData(ii%, i%).fval = 0
                        End If
                    Next ii%
                Else
                    For ii% = 1 To FSlct(i% - 1).NumPoints
                        ArchData(ii%, i%).iVal = ArchData(ii%, i% - 1).iVal
                        If ArchData(ii%, i% - 1).fval <> 0 Then
                            ArchData(ii%, i%).fval = TmpYData(ii% - 1) / ArchData(ii%, i% - 1).fval
                        Else
                            ArchData(ii%, i%).fval = 0
                        End If
                    Next ii%
                End If
            End If
            FSlct(i%).NumPoints = FSlct(i% - 1).NumPoints
            FSlct(i%).TotalPoints = FSlct(i% - 1).TotalPoints
            ArchData(0, i%).iVal = FSlct(i%).NumPoints
        Else
            If Not filterAcquired Then
retrieveFilterData:
              If nFilterKeywords > 0 Then
                ArchiveForm.ACOPData.Caption = filterString
                For j% = 0 To nFilterKeywords - 1
                  If filterKeywords(j%).fmt = "NAME32" Then
                    ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                    ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                    rcc& = ArchiveForm.ACOPData.Execute(filterTextBuffer(0, j%).nam, MaxPoints / 10, "NAME32I", TmpStartStop)
                  Else
                    ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                    ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                    rcc& = ArchiveForm.ACOPData.Execute(filterDataBuffer(0, j%).fval, MaxPoints, "FLTINT", TmpStartStop)
                  End If
                  If rcc& Then
                    MsgRC = MsgBox(" Error acquiring filter! " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Archive Retrieval")
                    n% = 0
                    If MsgRC = vbRetry Then GoTo retrieveFilterData
                  End If
                Next
              Else
                ArchiveForm.ACOPData.Caption = ""
              End If
              filterAcquired = True
            End If
            ' get the data out of the archive
retrieveArchiveData:
            ArchiveForm.LabelMisc(3).Caption = "Data loading...."
            ArchiveForm.LabelMisc(3).Visible = True
            ArchiveForm.Refresh
            ' give it a longer timeout in case there's a bunch of data :
            If ArchiveForm.timeoutText.Visible Then
              ArchiveForm.ACOPData.AccessRate = ArchiveForm.timeoutText.text '3000
            Else
              ArchiveForm.ACOPData.AccessRate = 3000
            End If
            
            If Mid(FSlct(i%).PropName, 1, 3) = "TTF" Then
                ArchiveForm.ACOPData.deviceName = "TTFHISTORY"
                ' Kludge for the HTC Bunch-Selection....
                If FSlct(i%).DeviceIndex < 0 Then FSlct(i%).DeviceIndex = 0
                
                ' Is this a TD Property?
                If FSlct(i%).VPlot = "TD" Then
                    TmpStartStop&(2) = FSlct(i%).DeviceIndex * NTDBunches + FSlct(i%).DeviceSubIndex
                Else
                    TmpStartStop&(2) = FSlct(i%).DeviceIndex
                End If
                ArchiveForm.ACOPData.deviceProperty = FSlct(i%).PropName
'                ArchiveForm.ACOPData.deviceName = ArchiveForm.ACOPData.deviceName + "/" + Trim$(str(FSlct(i%).DeviceIndex))
                ArchiveForm.ACOPData.deviceName = ArchiveForm.ACOPData.deviceName + "/" + FSlct(i%).deviceName
                If FSlct(i%).Acquire = True Then
                    tStr = Left(UCase(FSlct(i%).PropFormatStr), 4)
                    If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
                      rcc& = ArchiveForm.ACOPData.Execute(ArchStringDataBuffer(0, i%).nam, MaxStrings, "NAME32I", TmpStartStop)
                      ArchDataBuffer(0, i%).iVal = ArchStringDataBuffer(0, i%).iVal
                      useStringBuffer = True
                    Else
                      rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, i%).fval, MaxPoints, "FLTINT", TmpStartStop)
                    End If
                End If
                kk% = 1
                For k% = 1 To ArchDataBuffer(0, i%).iVal
                  If (nFilterKeywords = 0) Or (filerArchiveData(ArchDataBuffer(k%, i%).iVal) > 0) Then
                    If useStringBuffer Then
                      ArchData(kk%, i%).iVal = ArchStringDataBuffer(k%, i%).iVal
                    Else
                      ArchData(kk%, i%) = ArchDataBuffer(k%, i%)
                    End If
                    kk% = kk% + 1
                  End If
                Next
                ArchData(0, i%).iVal = kk% - 1
            Else
                ArchiveForm.ACOPData.deviceName = FSlct(i%).ServerName
                
                ' For the HTC: get the BUNCH CURRENTS for the INDEX of the HE_HTC_BUNCH!
                If FSlct(i%).DeviceIndex < 0 And FSlct(i%).deviceName = "#0" Then
                    Call GetHTCStuff(i%)
                    'TmpStartStop&(2) = 0
                Else
                    If FSlct(i%).DeviceIndex >= 0 Then TmpStartStop&(2) = FSlct(i%).DeviceIndex
                    ArchiveForm.ACOPData.deviceProperty = FSlct(i%).PropName
'                    ArchiveForm.ACOPData.deviceName = FSlct(i%).ServerName + "/#" + Trim$(str(FSlct(i%).DeviceIndex))
                    ArchiveForm.ACOPData.deviceName = FSlct(i%).ServerName + "/" + FSlct(i%).deviceName
'                    rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, i%).fval, MaxPoints, "FLTINT", TmpStartStop)
                    If FSlct(i%).Acquire = True Then
                      tStr = Left(UCase(archivedKeywords(FSlct(i%).PListIndex).fmt), 4)
                      If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
                        rcc& = ArchiveForm.ACOPData.Execute(ArchStringDataBuffer(0, i%).nam, MaxStrings, "NAME32I", TmpStartStop, 2)
                        ArchDataBuffer(0, i%).iVal = ArchStringDataBuffer(0, i%).iVal
                        useStringBuffer = True
                      Else
                        rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, i%).fval, MaxPoints, "FLTINT", TmpStartStop, 2)
                      End If
                    End If
                    kk% = 1
                    For k% = 1 To ArchDataBuffer(0, i%).iVal
                      If (nFilterKeywords = 0) Or (filerArchiveData(ArchDataBuffer(k%, i%).iVal) > 0) Then
                        If useStringBuffer Then
                          ArchData(kk%, i%).iVal = ArchStringDataBuffer(k%, i%).iVal
                        Else
                          ArchData(kk%, i%) = ArchDataBuffer(k%, i%)
                        End If
                        kk% = kk% + 1
                      End If
                    Next
                    ArchData(0, i%).iVal = kk% - 1
                End If
            End If
                        
            If rcc& Then
                MsgRC = MsgBox(" Error! " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Archive Retrieval")
                n% = 0
                tmpTotalPoints& = 0
                If MsgRC = vbRetry Then GoTo retrieveArchiveData
            Else
                ' for comparison....
                'rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, i%).fval, MaxPoints, "FLTINT", TmpStartStop, 2)
                'Debug.Print ArchDataBuffer(0, i%).ival
                
                n% = ArchData(0, i%).iVal
            
                ' Get the total number of points in the interval
                rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
                If rcc& Then
                    tmpTotalPoints& = -1
                Else
                    tmpTotalPoints& = scratchTotalPoints.iVal
                End If
            End If
            
            
            FSlct(i%).NumPoints = n%
            FSlct(i%).TotalPoints = tmpTotalPoints&
            
            If n% > 1 Then
                ' A bit of data-verarbeiting...
                ' Check if the DATA is meant to be scaled...
                tmpFaktor! = FSlct(i%).VScale
                If Not (tmpFaktor! = 0 Or tmpFaktor! = 1) Then
                    TmpOffset! = FSlct(i%).VOffset
                    For ii% = 1 To n%
                       ArchData(ii%, i%).fval = ArchData(ii%, i%).fval * tmpFaktor! + TmpOffset!
                    Next ii%
                ElseIf (FSlct(i%).VPlot = "BIT") Or (FSlct(i%).VPlot = "BITS") Then
                    FSlct(i%).VMax = 16.1
                    FSlct(i%).VMin = -0.05
                    FSlct(i%).SelectedMaxValue = FSlct(i%).VMax
                    FSlct(i%).SelectedMinValue = FSlct(i%).VMin
                   
                    tmpFaktor! = 1
                    tmpMask& = SelectBits&(FSlct(i%).DeviceSubIndex - 1)
                    For ii% = 1 To n%
                       ArchData(ii%, i%).fval = 2 * i% + (CLng(ArchData(ii%, i%).fval) And tmpMask&) / tmpMask&
                    Next ii%
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                    ' Do this check HERE, and do it only ONCE....
                    For ii% = 1 To n%
                       If ArchData(ii%, i%).fval <= 0 Then ArchData(ii%, i%).fval = 0.0000001
                    Next ii%
                    tmpFaktor! = 1
                End If
                
                FSlct(i%).PlotScale = tmpFaktor!
                
                 For ii% = 1 To n% - 1
                    ArchTimeBins#(ii%, i%) = CDbl((ArchData(ii%, i%).iVal) + CDbl((ArchData(ii% + 1, i%).iVal - ArchData(ii%, i%).iVal)) / 2)
                Next ii%
                ArchTimeBins#(0, i%) = ArchData(1, i%).iVal - 100
                ArchTimeBins#(n% + 1, i%) = ArchData(n%, i%).iVal + 100
               
                If ArchiveForm.MenuBADData.Checked Then
                    OKCount% = 1
                    For ii% = 1 To n%
                        If ArchData(ii%, i%).fval < ErrorValue! Then
                            ArchData(OKCount%, i%).fval = ArchData(ii%, i%).fval
                            ArchData(OKCount%, i%).iVal = ArchData(ii%, i%).iVal
                            OKCount% = OKCount% + 1
                        End If
                    Next ii%
                    n% = OKCount% - 1
                    FSlct(i%).NumPoints = n%
                    ArchData(0, i%).iVal = n%
                End If
                
                If FSlct(i%).PropName = "HPFWHM" Then
                    ' Bad data from the CMFL FEC....
                    For ii% = 1 To n%
                        If ArchData(ii%, i%).fval > 10000# Then ArchData(ii%, i%).fval = 0
                    Next ii%
                ElseIf FSlct(i%).PropName = "H1SLumi" Then
                    ' Bad data from H1-Lumi....
                    For ii% = 1 To n%
                        'If Not (IsNumeric(ArchData(ii%, i%).fval)) Then ArchData(ii%, i%).fval = 0
                        ArchData(ii%, i%).fval = Val(ArchData(ii%, i%).fval)
                    Next ii%
                ElseIf FSlct(i%).PropName = "HE_H_HTC_PSC" Or FSlct(i%).PropName = "HE_V_HTC_PSC" Then
                    ' Signed Integers read as UNSIGNED...
                    For ii% = 1 To n%
                        If ArchData(ii%, i%).fval > 32767 Then ArchData(ii%, i%).fval = ArchData(ii%, i%).fval - 65536
                    Next ii%
                ElseIf (FSlct(i%).PropName = "TTFAcc2TCoup4KB" And FSlct(i%).DeviceIndex = 4) Or (FSlct(i%).PropName = "TTFAcc1THOM2" And FSlct(i%).DeviceIndex = 2) Then
                    ' IS there bad data here?
                    ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
                    'For ii% = 1 To n%
                    '    If ArchData(ii%, i%).fval > 10000 Then ArchData(ii%, i%).fval = 0
                    'Next ii%
                ElseIf InStr(1, FSlct(i%).PropName, "L3") <> 0 Then '"L3Que"
                    ' IS there bad data here?
                    ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
                    OKCount% = 1
                    For ii% = 1 To n%
                        If ArchData(ii%, i%).fval < ErrorValue! Then
                            ArchData(OKCount%, i%).fval = ArchData(ii%, i%).fval
                            ArchData(OKCount%, i%).iVal = ArchData(ii%, i%).iVal
                            OKCount% = OKCount% + 1
                        End If
                    Next ii%
                    n% = OKCount% - 1
                    FSlct(i%).NumPoints = n%
                    ArchData(0, i%).iVal = n%
                End If
            End If
        End If
    '    FSlct(i%).Active = True
    '    FSlct(i%).RePlot = True
        If FSlct(i%).Active Then FSlct(i%).RePlot = True
    'End If
    
    
        If FSlct(i%).RePlot = True Then
            For j% = 0 To NDisplayModes% - 1
                If UCase$(FSlct(i%).SelectedVMode) = DisplayModes$(j%) Then
                    FSlct(i%).SelectedVModeIndex = DisplayModeIndexes%(j%)
                    Exit For
                End If
            Next j%
                
            'If fslct(i%).ACOPPlotIndex <> -1 Then ArchiveForm.acopplot(0).LockScreen 0, fslct(i%).ACOPPlotIndex
            
            ArchiveForm.LabelMisc(3).Visible = False
            n% = FSlct(i%).NumPoints
        
            ' Which row is the data in?
            tmpIndex% = IndexToDName%(i%)
            'ArchiveForm.LinLog(TmpIndex%) = FSlct(i%).VPlot
'            If FSlct(i%).TotalPoints > 1000000# Then
'                tmpText$ = Format$(n%, "0") + "/" + Format$(FSlct(i%).TotalPoints, "0")
'            Else
'                tmpText$ = Format$(n%, "0") + " / " + Format$(FSlct(i%).TotalPoints, "0")
'            End If
'            ArchiveForm.Text1(tmpIndex%) = tmpText$
        
            If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
                ' Scale to the Max and Min values IN THE DATA....
                If FSlct(i%).MaxValue = -1 And FSlct(i%).MinValue = -1 Then
                    ' Must find NEW max and min values
                    ScaleMax! = ArchData(1, i%).fval
                    ScaleMin! = ScaleMax!
                    For ii% = 2 To n%
                        ' Only look at points being DISPLAYED!
                        If ArchData(ii%, i%).iVal > ZoomLimits#(NZooms%, 0) And ArchData(ii%, i%).iVal < ZoomLimits#(NZooms%, 1) Then
                            If ArchData(ii%, i%).fval > ScaleMax! Then
                                ScaleMax! = ArchData(ii%, i%).fval
                            ElseIf ArchData(ii%, i%).fval < ScaleMin! Then
                                ScaleMin! = ArchData(ii%, i%).fval
                            End If
                        End If
                    Next ii%
                    ' make sure an array of "all the same thing" goes down the middle:
                    If ScaleMax! = ScaleMin! Then
                      ScaleMax! = ScaleMax! + ScaleMax! * 0.1 + 1
                      ScaleMin! = ScaleMin! - ScaleMin! * 0.1 - 1
                    End If
                    FSlct(i%).MaxValue = ScaleMax!
                    FSlct(i%).MinValue = ScaleMin!
                End If
                ' Put them 5% away from the edge?
                ScaleMax! = FSlct(i%).MaxValue + (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
                ScaleMin! = FSlct(i%).MinValue - (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
            
                ScaleMax! = ScaleMax! * 1
                ScaleMin! = ScaleMin!
            
                ScaleOffset! = 0
            Else
                FSlct(i%).MaxValue = -1: FSlct(i%).MinValue = -1
                ScaleMax! = FSlct(i%).SelectedMaxValue
                ScaleMin! = FSlct(i%).SelectedMinValue
                ScaleOffset! = FSlct(i%).SelectedOffset
            End If
                
            FSlct(i%).PlotMaxValue = ScaleMax!
            FSlct(i%).PlotMinValue = ScaleMin!
            FSlct(i%).PlotOffset = ScaleOffset!
        
            If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
                tmpPlotRange! = ZoomLimits#(NZooms%, 3) - ZoomLimits#(NZooms%, 2)
                tmpPlotOffset! = ZoomLimits#(NZooms%, 2)
            Else
                tmpPlotRange! = 100
                tmpPlotOffset! = 0
            End If
        
            If n% <= 1 Then
                Delta! = ScaleMax! - ScaleMin!
                ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
                FSlct(i%).PlotDelta = Delta! / 100
                FSlct(i%).PlotZeroOffset = ZeroOffset!
            Else
                ' To scale the data properly....
                If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                    If ScaleMin <= 0 Then ScaleMin = 0.01
                    If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
                    Delta! = (Log(ScaleMax!) - Log(ScaleMin!)) '/ Log(10#)
                    If FSlct(i%).VMin = 0 Then FSlct(i%).VMin = 1E-20
                    ZeroOffset! = Log(ScaleMin) 'Log(FSlct(i%).VMin) '/ Log(10#)
                Else
                    Delta! = ScaleMax! - ScaleMin!
                    ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
                End If
            
                ' Use the scale-factor in the form for the GRAPHICS!
                InvDelta! = InvDelta! * 1 'Val(ArchiveForm.Faktor(TmpIndex%).text)
                If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = tmpPlotRange! / Delta!
            
                ' For re-scaling
                FSlct(i%).PlotDelta = Delta! / tmpPlotRange!
                FSlct(i%).PlotZeroOffset = ZeroOffset!
            
                ' The number of points in the array...
                PlotData(0, i%).iVal = ArchData(0, i%).iVal
                ' Plotting "mode"
                If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                    'Call ARRLOG(ydat(0, i%), ydat(0, i%), n%)
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        If ArchData(ii%, i%).fval > 0 Then
                            PlotData(ii%, i%).fval = (Log(ArchData(ii%, i%).fval) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                            'PlotData(ii%, i%).fval = (Log(ArchData(ii%, i%).fval) - ZeroOffset!) * InvDelta!
                        Else
                            PlotData(ii%, i%).fval = 0
                        End If
                    Next ii%
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "ABS" Then
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        PlotData(ii%, i%).fval = (Abs(ArchData(ii%, i%).fval) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii%
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "SLOG" Then
                    'Call ARRMULT(CF_FLOAT, ydat(0, i%), 1 / fslct(i%).VMax, n%)
                    tmpFaktor! = 1 '/ FSlct(i%).VMax
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        If ArchData(ii%, i%).fval > 0 Then
                            ii% = ii%
                        End If
                        PlotData(ii%, i%).fval = (ArchData(ii%, i%).fval * tmpFaktor! - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii%
                Else
                    For ii% = 1 To n%
                        PlotData(ii%, i%).iVal = ArchData(ii%, i%).iVal
                        PlotData(ii%, i%).fval = (ArchData(ii%, i%).fval - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                        'Debug.Print ii%, PlotData(ii%, i%).ival, PlotData(ii%, i%).fval, ArchData(ii%, i%).fval
                    Next ii%
                End If
                    
                ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = ACOPDefaultMode& ' = FSlct(i%).DispColor
                ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = FSlct(i%).DispColor
                ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + ACOPDefaultWidth&
            
                FSlct(i%).ACOPPlotIndex = ArchiveForm.ACOPPlot(ActivePlot%).Draw(PlotData(1, i%).fval, PlotData(1, i%).iVal, , , n%, "FLTINT", MaxPoints)
            End If
        End If
        FSlct(i%).Acquire = False
        FSlct(i%).RePlot = False

    End If
Next i%

ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 1

TmpPlots% = NPlots%(ActivePlot%)
If ActivePlot% = 1 Then TmpPlots% = TmpPlots% + CopyOffset
For i% = StartLabel% To TmpPlots% - 1
    ArchiveForm.OptX(i%).Visible = True
    ArchiveForm.OptY(i%).Visible = True
Next i%
For i% = TmpPlots% To StopLabel%
    ArchiveForm.OptX(i%).Visible = False
    ArchiveForm.OptY(i%).Visible = False
Next i%

'ArchiveForm.ACOPPlot(ActivePlot%).AutoScale True, True, False, False

If SelectedTrace%(ActivePlot%) <> -1 Then
    tmpIndex% = SelectedTrace%(ActivePlot%)
    Call SelectATrace(tmpIndex%)
End If
ArchiveForm.LabelMisc(3).Visible = False
Exit Sub

DataProblems:
Debug.Print " Data Problems!"
Resume Next

End Sub


Sub OLDdrawdata(flag As Integer, ih%)
''Dim TmpYData!(MaxPoints), TmpXData0&(MaxPoints), TmpXData1&(MaxPoints), NTmp0%, NTmp1%
''Dim TmpStartStop&(3), TmpData(5000) As FLTINT
''
''
''Const OpMinus = "-"
''Const OpPlus = "+"
''Const OpMult = "*"
''Const OpDiv = "/"
''
'''   flag=0  alle daten neu
'''   flag=1  nur plotten ohne daten holen
'''   flag=2  Update
''Dim xf As Single
''Dim ZeroOffset!
''
'''    archiveform.Command3.Enabled = True
''ArchiveForm.acopplot(0).Width = ArchiveForm.Width '12240
''ArchiveForm.Command1.Enabled = True
''For i% = 0 To MaxPlots - 1
''    ArchiveForm.Text1(i%).BackColor = LGREY
''    ArchiveForm.Text1(i%) = " "
''    ArchiveForm.LinLog(i%).text = " "
''    ArchiveForm.OptX(i%).Enabled = False
''    ArchiveForm.OptY(i%).Enabled = False
''Next i%
''
''ArchiveForm.AcopCorrelate.Visible = False
''ArchiveForm.acopplot(0).Visible = True
''ArchiveForm.acopplot(0).ClearScreen
''ArchiveForm.acopplot(0).GraphStyle = TIME_LIN
''ArchiveForm.acopplot(0).xmin = time_0&
''ArchiveForm.acopplot(0).xmax = time_0& + 86400
''
''LastTime = 0
''
''For i% = 0 To NPlots% - 1
''    ArchiveForm.LinLog(i%) = fslct(i%).VPlot
''    ArchiveForm.OptX(i%).Enabled = True
''    ArchiveForm.OptY(i%).Enabled = True
'''    fa = fslct(i%).vscale
''    fNr = fslct(i%).fecNo: pNr = fslct(i%).pNo
''    ts& = time_0&
''    Call CTIME(datstr, ts&)
''    np% = 0
''
''    g% = 0
''
''    If flag = 2 Then
''        g% = ih_last(i%)
''        np% = Nmax_last(i%)
''    End If
''
''    If (flag = 0 Or flag = 2) And fslct(i%).Acquire Then
''        If flag = 0 Then
''            fa = fslct(i%).VScale
''            ArchiveForm.Faktor(i%).text = fa
''        End If
''
''        If (fslct(i%).PropName = OpMinus) Or (fslct(i%).PropName = OpPlus) Or (fslct(i%).PropName = OpMult) Or (fslct(i%).PropName = OpDiv) Then
''            ' try to do an operation on two of the arrays which are already loaded.....
''            If i% < 2 Then
''                MsgBox " error in operation! not enough arrays!"
''                Exit Sub
''            End If
''
''            ' use the time stamps of the last to get the data points for the SECOND-to-LAST....
''            NTmp0% = fslct(i% - 2).NumPoints
''            For ii% = 0 To NTmp0% - 1
''                TmpXData0&(ii%) = ltim(ii%, i% - 2)
''                TmpYData!(ii%) = fdat(ii%, i% - 2)
''            Next ii%
''
''            NTmp1% = fslct(i% - 1).NumPoints
''            For ii% = 0 To NTmp1% - 1
''                TmpXData1&(ii%) = ltim(ii%, i% - 1)
''            Next ii%
''
''            ' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
''            rc% = INTERP(TmpYData!(0), TmpXData0&(0), NTmp0%, TmpXData1&(0), NTmp1%)
''            ' assume it is MINUS...
''            For ii% = 0 To fslct(i% - 1).NPoints% - 1
''                ltim(ii%, i%) = ltim(ii%, i% - 1)
''                If TmpYData(ii%) > 40 Then
''                    fdat(ii%, i%) = TmpYData(ii%) - fdat(ii%, i% - 1)
''                Else
''                    fdat(ii%, i%) = 0
''                End If
''            Next ii%
''            fslct(i%).NPoints% = fslct(i% - 1).NPoints%
''        Else
''            ' get the data out of the archive
''            ArchiveForm.labelmisc(3).Caption = "Data loading...."
''            ArchiveForm.labelmisc(3).Visible = True
''            ArchiveForm.Refresh
''    '        archiveform.Faktor(i%).text = fa
''
''            'P.D. - at least do this in 6-hour blocks until someone has time to
''            '       to make sure that a single call works:
''            'P.D. - 24 hours doesn't seem to cause a problem
''            'If ih% <> 23 Then ih% = 23 ' why use this at all ?
''
''            'ih_last(i%) = (ih% + 1) / 24
''            'For M& = g% To ih_last(i%) - 1
''                ts& = time_0& '+ 3600 * M& * 24
''                ver2& = CLng(60) * CLng(Win_Sec(ArchiveForm.Comb_Win.ListIndex)) '60 * 24
''                Call CTIME(datstr, ts&)
''
''                'Nmax_last(i%) = np%
''                'Sleep (100)
''                'n% = FETCH(fslct(i%).PropName, fslct(i%).DeviceIndex, _
''                'ts&, ver2&, (MaxPoints - np%) * 4, fdat(np%, i%), ltim(np%, i%))
''
''                TmpStartStop&(0) = ts&
''                TmpStartStop&(1) = TmpStartStop&(0) + ver2& * 60
''
''                TmpStartStop&(2) = fslct(i%).DeviceIndex
''                If Mid(fslct(i%).PropName, 1, 3) = "TTF" Then
''                    ArchiveForm.ACOPData.deviceName = "TTFHISTORY"
''                Else
''                    ArchiveForm.ACOPData.deviceName = "HERAARCH"
''                End If
''                ArchiveForm.ACOPData.deviceProperty = fslct(i%).PropName
''                rcc& = ArchiveForm.ACOPData.Execute(TmpData(0).fval, MaxPoints, "FLTINT", TmpStartStop)
''                If rcc& Then
''                    MsgBox " Error! " + ArchiveForm.ACOPData.Status
''                    n% = 0
''                Else
''                    n% = TmpData(0).ival
''                End If
''
''                If n% < 2 Then n% = 0
''                For ii% = 0 To n% - 1
''                   ltim(ii%, i%) = TmpData(ii% + 1).ival
''                   fdat(ii%, i%) = TmpData(ii% + 1).fval
''                Next ii%
''
''                np% = np% + n%
''                If np% >= MaxPoints Then
''                    ArchiveForm.Text1(i%).BackColor = RED
''                End If
''            'Next M&
''            n% = np%
''            fslct(i%).NPoints% = n%
''
''            If fslct(i%).PropName = "HPFWHM" Then
''                For ii% = 0 To n% - 1
''                    If fdat(ii%, i%) > 10000# Then fdat(ii%, i%) = 0
''                Next ii%
''            End If
''        End If
''
''        fslct(i%).Acquire = False
''    End If
''    ArchiveForm.labelmisc(3).Visible = False
''    n% = fslct(i%).NPoints%
''    ArchiveForm.Text1(i%) = n%
''
''    If n% > 1 Then
''   '     Call MEMCPY(xdat(0, i%), ltim(0, i%), n% * 8)
''    '    Call MEMCPY(ydat(0, i%), fdat(0, i%), n% * 4)
''
''        For ii% = 0 To n% - 1
''           xdat(ii%, i%) = ltim(ii%, i%)
''           ydat(ii%, i%) = fdat(ii%, i%)
''        Next ii%
''
''
''        If fslct(i%).VPlot = "LOG" Then
''            Call ARRLOG(ydat(0, i%), ydat(0, i%), n%)
''        ElseIf fslct(i%).VPlot = "ABS" Then
''            For ii% = 0 To n% - 1
''               ydat(ii%, i%) = Abs(ydat(ii%, i%))
''            Next ii%
''        End If
''        If fslct(i%).VPlot = "SLOG" Then
''            Call ARRMULT(CF_FLOAT, ydat(0, i%), 1 / fslct(i%).VMax, n%)
''        End If
''
''        If fslct(i%).VScale <> 0 Then xf = 1 Else xf = fslct(i%).VScale
''        xf = xf * Val(ArchiveForm.Faktor(i%).text)
''        Debug.Print xf, i%
''        Call ARRMULT(CF_FLOAT, ydat(0, i%), xf, n%)
''
''        If ArchiveForm.ChkAuto.Value = 1 Then
''            For ii% = 0 To n% - 1
''               xdat0(ii%) = xdat(ii%, i%)
''               ydat0(ii%) = ydat(ii%, i%)
''            Next ii%
''        Else
''            If fslct(i%).VPlot = "LOG" Then
''                If fslct(i%).VMin <= 0 Then fslct(i%).VMin = 0.01
''                If fslct(i%).VMax <= 0 Then fslct(i%).VMax = fslct(i%).VMin * 100000
''                delta! = (Log(fslct(i%).VMax) - Log(fslct(i%).VMin)) / Log(10#)
''                ZeroOffset! = Log(fslct(i%).VMin) / Log(10#)
''            Else
''                delta! = fslct(i%).VMax - fslct(i%).VMin
''                ZeroOffset! = fslct(i%).VMin
''            End If
''            If delta! = 0 Then invdelta! = 1 Else invdelta! = 100 / delta!
''            For ii% = 0 To n% - 1
''                xdat0(ii%) = xdat(ii%, i%)
''                ydat0(ii%) = (ydat(ii%, i%) - ZeroOffset!) * invdelta!
''            Next ii%
''        End If
''
'''        miny! = 1E+38
'''        maxy! = -1E+38
'''        For ii% = 0 To n% - 1
'''            If ydat(ii%, i%) < miny! Then miny! = ydat(ii%, i%)
'''            If ydat(ii%, i%) > maxy! Then maxy! = ydat(ii%, i%)
'''        Next ii%
'''Debug.Print i%, miny!, maxy!
''
''
''        Call CTIME(datstr, time_0&)
'''        archiveform.xmin.Caption = Mid$(datstr, 11, 10)
''        If ltim(n% - 1, i%) > LastTime Then LastTime = ltim(n% - 1, i%)
''        Call CTIME(datstr, LastTime)
'''        archiveform.xmax.Caption = Mid$(datstr, 11, 10)
''
''        ArchiveForm.acopplot(0).ForeColor = fslct(i%).DispColor
''        ArchiveForm.acopplot(0).DrawWidth = fslct(i%).DrawWidth
''        ArchiveForm.acopplot(0).Draw ydat0, xdat0, , , n%
''    End If
''Next i%
''
''For i% = 0 To NPlots% - 1
''    ArchiveForm.OptX(i%).Enabled = True
''    ArchiveForm.OptY(i%).Enabled = True
''Next i%
''
''If ArchiveForm.ChkAuto.Value = 1 Then
''    ArchiveForm.acopplot(0).AutoScale True, True, True, True
''Else
''    ArchiveForm.acopplot(0).ymin = 0
''    ArchiveForm.acopplot(0).ymax = 100
''    ArchiveForm.acopplot(0).AutoScale True, True, False, False
''End If
''
End Sub

Sub Main()
ArchiveForm.Show
End Sub
Sub DrawCorr()
Dim n%, ii%, n2%, rc%, rcc&
Dim TmpTextX$, TmpTextY$
Dim tmpIndex%

On Error Resume Next

tmpIndex% = ActivePlot%

'TmpTextX$ = ArchiveForm.LinLog(xIndex)
'TmpTextY$ = ArchiveForm.LinLog(yIndex)
If TmpTextX$ = "LOG" And TmpTextY$ = "LIN" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LOG_LIN
ElseIf TmpTextY$ = "LIN" And TmpTextY$ = "LOG" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LIN_LOG
Else 'If TmpTextY$ = "LIN" And TmpTextY$ = "LIN" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LIN_LIN
End If
 
OptXIndex% = DNameToIndex%(xIndex)
n% = FSlct(OptXIndex%).NumPoints
If n% > 1 Then
    For ii% = 0 To n% - 1
        ydat0!(ii%) = ArchData(ii% + 1, OptXIndex%).fval
        'Debug.Print ArchData(ii% + 1, OptXIndex%).fval
        
        'ydat0!(ii%) = 0
        ' What about these 10^30? - CAN'T USE BECAUSE OF LUMI!!!
        'If ydat0!(ii%) > 10000000000# Then ydat0!(ii%) = 0
         
         'ydat1(ii%) = ArchData(ii% + 1, TmpXSelect%).fval
         'xdat0(ii%) = xdat(ii%, TmpXSelect%)
         xdat0&(ii%) = ArchData(ii% + 1, OptXIndex%).iVal
    Next ii%
End If
       
OptYIndex% = DNameToIndex%(yIndex)
n2% = FSlct(OptYIndex%).NumPoints
If n2% > 1 Then
    For ii% = 0 To n2% - 1
        ydat1!(ii%) = ArchData(ii% + 1, OptYIndex%).fval
        
         ' What about these 10^30? - CAN'T USE BECAUSE OF LUMI!!!
         'If ydat1!(ii%) > 10000000000# Then ydat1!(ii%) = 0
        
        'ydat2(ii%) = ArchData(ii% + 1, TmpYSelect%).fval
        'xdat0(ii%) = xdat(ii%, TmpYSelect%)
        xdat1&(ii%) = ArchData(ii% + 1, OptYIndex%).iVal
    Next ii%

    rc% = INTERP(ydat1!(0), xdat1&(0), n2%, xdat0&(0), n%)
End If

'For ii% = 0 To 1 'n2% - 1
'    Debug.Print ydat1!(ii%)
'Next ii%

' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
'rc% = INTERP(TmpYData!(1), TmpXData0&(1), PEne(0).ival, TmpXData1&(1), CMFLBunch(0, 2).ival)

If ArchiveForm.ChkChubby.Value = vbChecked Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).DrawWidth = 5
    'ArchiveForm.ACOPCorrelate(tmpIndex%).XExtent = 4
    'ArchiveForm.ACOPCorrelate(tmpIndex%).DisplayMode = Dots
Else
    ArchiveForm.ACOPCorrelate(tmpIndex%).DrawWidth = 1
End If
ArchiveForm.ACOPCorrelate(tmpIndex%).ClearScreen
ArchiveForm.ACOPCorrelate(tmpIndex%).ForeColor = BLACK 'FSlct(TmpYSelect%).DispColor
rcc& = ArchiveForm.ACOPCorrelate(tmpIndex%).Draw(ydat1, ydat0, , , n%)

If ArchiveForm.ChkAuto(0).Value = vbChecked Or ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).AutoScale True, True, True, True
Else
    ArchiveForm.ACOPCorrelate(tmpIndex%).AutoScale False, False, False, False
    ArchiveForm.ACOPCorrelate(tmpIndex%).xmax = FSlct(OptXIndex%).PlotMaxValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).xmin = FSlct(OptXIndex%).PlotMinValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).ymax = FSlct(OptYIndex%).PlotMaxValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).ymin = FSlct(OptYIndex%).PlotMinValue
End If

ArchiveForm.ACOPCorrelate(tmpIndex%).XAxisLabel = ArchiveForm.dnam(xIndex) + "  (" + FSlct(OptXIndex%).VUnit + ") "
ArchiveForm.ACOPCorrelate(tmpIndex%).YAxisLabel = ArchiveForm.dnam(yIndex) + "  (" + FSlct(OptYIndex%).VUnit + ") "
    
End Sub

Sub INTERP1(X() As Long, Y() As Single, n As Integer, _
    xr() As Long, yr() As Single, M As Integer)
    
    'calculates (interpolates) yr based on x,y at xr

Dim i1 As Integer
Dim i As Integer
Dim j As Integer
Dim a As Double
Dim B As Double
Dim denom As Single

'Debug.Print n, M
For j = 0 To M - 1
    i1 = n
    For i = 0 To n - 1
        If X(i) > xr(j) Then
            i1 = i
            Exit For
        End If
    Next i
    
    If i1 = 0 Then i1 = 1
    If i1 = n Then i1 = n - 1
    
    denom = (X(i1) - X(i1 - 1))
    If denom = 0 Then denom = 0.001
    B = (Y(i1) - Y(i1 - 1)) / denom
    a = Y(i1) - B * X(i1)
 '   Debug.Print a, b, i1
    yr(j) = a + B * xr(j)

Next j

End Sub

Public Sub RemoveTrace(tmpIndex As Integer)
Dim i%, TmpPosition%, TmpCount%, StartLabel%, StopLabel%

' -10: delete EVERYTHING

'Index is the fslct array index...
If tmpIndex = -1 Then Exit Sub
If NPlots%(ActivePlot%) <= 0 Then Exit Sub

SelectedPlotArrayTrace% = -1
If ArchiveForm.ChkDouble(4).Value = vbChecked Then
    ArchiveForm.ACOPPlot(2).ClearScreen
End If

StartLabel% = ActivePlot% * CopyOffset
StopLabel% = ActivePlot% * CopyOffset + MaxPlots - 1
For i% = StartLabel% To StopLabel%
    ArchiveForm.dnam(i%).BorderStyle = 0
Next i%

If tmpIndex% = -10 Then
    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen

    For i% = StartLabel% To StopLabel%
        FSlct(i%).Active = False
    Next i%
    'For i% = 0 To MaxPlots - 1
    '    FSlct(i%).ACOPPlotIndex = -1
    'Next i%
Else
    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, FSlct(tmpIndex).ACOPPlotIndex
    If SelectedTrace%(ActivePlot%) > -1 Then ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, SelectedTracePlotIndex&(ActivePlot%)
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen FSlct(tmpIndex).ACOPPlotIndex, 0

    FSlct(tmpIndex).Active = False
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
    FSlct(tmpIndex).ACOPPlotIndex = -1

    For i% = 0 To MaxPlots - 1
        If FSlct(i%).Active Then ArchiveForm.ACOPPlot(ActivePlot%).RecallScreen FSlct(i%).ACOPPlotIndex
    Next i%
End If


' Can ONLY REMOVE SELECTED TRACE!!!
SelectedTrace%(ActivePlot%) = -1

'' Be sure array-plot is not elected?
'ArchiveForm.ChkDouble(4).Value = 0

StartUp% = 1
' Correlation-Plot Stuff
If tmpIndex% = -10 Then
    For i% = StartLabel% To StopLabel%
        'FSlct(i%).Active = False
        ArchiveForm.OptX(i%).Value = False
        ArchiveForm.OptY(i%).Value = False
    Next i%
    ArchiveForm.ACOPCorrelate(0).ClearScreen
    ArchiveForm.ACOPCorrelate(0).XAxisLabel = ""
    ArchiveForm.ACOPCorrelate(0).YAxisLabel = ""
Else
    ' Change the pointers for all captions AFTER the one removed...
    TmpPosition% = IndexToDName%(tmpIndex)
    If ArchiveForm.OptX(TmpPosition%).Value = True Then
        ArchiveForm.OptX(TmpPosition%).Value = False
        ArchiveForm.ACOPCorrelate(0).XAxisLabel = ""
        ArchiveForm.ACOPCorrelate(0).ClearScreen
    End If
    If ArchiveForm.OptY(TmpPosition%).Value = True Then
        ArchiveForm.OptY(TmpPosition%).Value = False
        ArchiveForm.ACOPCorrelate(0).YAxisLabel = ""
        ArchiveForm.ACOPCorrelate(0).ClearScreen
    End If
    
    For i% = StartLabel% To StopLabel%
        If (FSlct(i%).Active = True) Then
            If IndexToDName%(i%) > TmpPosition% Then
                ' For this index, the previous DName-Label
                IndexToDName%(i%) = IndexToDName%(i%) - 1
                ' For this DName-Label, this index...
                DNameToIndex%(IndexToDName%(i%)) = i%
            End If
        
            If IndexToDName%(i%) >= TmpPosition% Then
                tmpIndex% = IndexToDName%(i%)
                ArchiveForm.dlab(tmpIndex%).Caption = ArchiveForm.dlab(tmpIndex% + 1).Caption
            End If
        
        Else
'            ArchiveForm.dunit(i%).Caption = ""
'            ArchiveForm.dnam(i%).Caption = ""
'            ArchiveForm.dhelp(i%).Caption = ""
'            ArchiveForm.dlab(i%).Caption = ""
'            ArchiveForm.dNow(i%).Caption = ""
'            ArchiveForm.dhelp(i%).ToolTipText = ""
        End If
    Next i%
End If

If tmpIndex% = -10 Then
    NPlots%(ActivePlot%) = 0
Else
    NPlots%(ActivePlot%) = NPlots%(ActivePlot%) - 1
End If
TmpCount% = NPlots%(ActivePlot%)
If ActivePlot% = 1 Then TmpCount% = TmpCount% + CopyOffset

If tmpIndex% <> -10 Then
    ' Move the TEXT up....
    For i% = TmpPosition% To TmpCount% - 1
        'ArchiveForm.Text1(i%).text = ArchiveForm.Text1(i% + 1).text
        
        ArchiveForm.OptX(i%).Value = ArchiveForm.OptX(i% + 1).Value
        ArchiveForm.OptY(i%).Value = ArchiveForm.OptY(i% + 1).Value
    Next i%
    For i% = TmpCount% To StopLabel%
        'ArchiveForm.Text1(i%).text = ""
        ArchiveForm.OptX(i%).Visible = False
        ArchiveForm.OptY(i%).Visible = False
        DNameToIndex%(i%) = -1
    
    
        ArchiveForm.dunit(i%).Caption = ""
        ArchiveForm.dnam(i%).Caption = ""
        ArchiveForm.dhelp(i%).Caption = ""
        ArchiveForm.dlab(i%).Caption = ""
        ArchiveForm.dNow(i%).Caption = ""
        ArchiveForm.dhelp(i%).ToolTipText = ""
    Next i%
Else
    ' CLEAR the text
    For i% = TmpCount% To StopLabel%
        'ArchiveForm.Text1(i%).text = ""
        ArchiveForm.OptX(i%).Visible = False
        ArchiveForm.OptY(i%).Visible = False
        DNameToIndex%(i%) = -1
    
        ArchiveForm.dunit(i%).Caption = ""
        ArchiveForm.dnam(i%).Caption = ""
        ArchiveForm.dhelp(i%).Caption = ""
        ArchiveForm.dlab(i%).Caption = ""
        ArchiveForm.dNow(i%).Caption = ""
        ArchiveForm.dhelp(i%).ToolTipText = ""
    Next i%
End If



' And disable all the buttons and stuff...
For i% = 0 To 3
    ArchiveForm.ComSelect(i%).Enabled = False
Next i%

ArchiveForm.ChkAuto(1).Enabled = False
'ArchiveForm.ChkDouble(4).Visible = False

StartUp% = 0

' "Absolute" Scale: need to re-draw.
Call PlotTheData(0)
'Call DrawCaption

DoEvents

Exit Sub


'
'
'
'For i% = Index% To NPlots% - 2 Step 1
'  fslct(i%).PropName = fslct(i% + 1).PropName
'
'  fslct(i%).fecNo = fslct(i% + 1).fecNo
'  fslct(i%).pNo = fslct(i% + 1).pNo
'  fslct(i%).DeviceIndex = fslct(i% + 1).DeviceIndex
'  fslct(i%).PListIndex = fslct(i% + 1).PListIndex
'  fslct(i%).helpText = fslct(i% + 1).helpText
'
'  fslct(i%).VMax = fslct(i% + 1).VMax
'  fslct(i%).VMin = fslct(i% + 1).VMin
'  fslct(i%).VScale = fslct(i% + 1).VScale
'  fslct(i%).VUnit = fslct(i% + 1).VUnit
'  fslct(i%).VPlot = fslct(i% + 1).VPlot
'  fslct(i%).npoints = fslct(i% + 1).npoints
'  fslct(i%).DrawWidth = fslct(i% + 1).DrawWidth
'  ArchiveForm.Faktor(i%).text = ArchiveForm.Faktor(i% + 1).text
'
'  n% = fslct(i%).npoints%
'
'    If n% > 1 Then
'        For ii% = 0 To n% - 1
'           'ltim(ii%, i%) = ltim(ii%, i% + 1)
'           'fdat(ii%, i%) = fdat(ii%, i% + 1)
'            ArchData(ii%, i%).fval = ArchData(ii%, i% + 1).fval
'            ArchData(ii%, i%).ival = ArchData(ii%, i% + 1).ival
'        Next ii%
'    End If
'Next
'
'NPlots% = NPlots% - 1

End Sub

Public Sub SelectATrace(dataIndex%)
Dim i%, TmpDNameIndex%, tmpIndex%, TmpTxtMin$, TmpTxtMax$, TmpTxtOffset$, TmpText$
If dataIndex% = -1 Then
    Exit Sub
End If

' need to do this here?
ArrayPlotIndex& = -1

' May need to replotted (with dots...)
If (SelectedTrace%(ActivePlot%) <> -1) Then
    ArchiveForm.dnam(IndexToDName%(SelectedTrace%(ActivePlot%))).BorderStyle = 0
    
    If FSlct(SelectedTrace%(ActivePlot%)).NumPoints > 1 Then
'LOCK        ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, SelectedTracePlotIndex&(ActivePlot%)
        ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen SelectedTracePlotIndex&(ActivePlot%)
    End If

'    If (ArchiveForm.ChkDouble(4).Value = 1) And (FSlct(SelectedTrace%(ActivePlot%)).PropSize = 1) Then
'        ' Array mode has been selected... MUST DE-SELECT....
'        ArchiveForm.ChkDouble(4).Value = 0
'    End If
End If

SelectedTrace%(ActivePlot%) = dataIndex%
SelectedPlotArrayTrace% = dataIndex%

TmpDNameIndex% = IndexToDName%(dataIndex)
ArchiveForm.dnam(TmpDNameIndex%).BorderStyle = 1
'ArchiveForm.dhelp(TmpDNameIndex%).AutoSize = False
'ArchiveForm.dhelp(TmpDNameIndex%).WordWrap = False

'ArchiveForm.dhelp(TmpDNameIndex%).ZOrder 0

'For i% = 0 To 6
'    ArchiveForm.dhelp(i%).ZOrder 1
'Next i%
'ArchiveForm.dhelp(TmpDNameIndex%).ZOrder 0

For i% = 0 To 2
    ArchiveForm.TxtSelect(i%).Enabled = True
    ArchiveForm.TxtSelect(i%).BackColor = &HE0E0E0
Next i%

tmpIndex% = SelectedTrace%(ActivePlot%)

ArchiveForm.FrameSelect.Caption = "Selected Trace: #" + Format$(tmpIndex%, "0")

With FSlct(tmpIndex%)
    StartUp% = 1
    If .PlotAutoScale Then ArchiveForm.ChkAuto(1).Value = vbChecked Else ArchiveForm.ChkAuto(1).Value = vbUnchecked
    
    ArchiveForm.ComboSelect(0).Enabled = True
    
    ' Log or Linear?
    'ArchiveForm.ComboSelect.text = FSlct(tmpIndex%).SelectedVMode
    ArchiveForm.ComboSelect(0).ListIndex = .SelectedVModeIndex
    StartUp% = 0
    
    If .PlotMinValue = 0 Then
        TmpTxtMin$ = Format(.PlotMinValue, "0.0") '"0.0"
    ElseIf Abs(.PlotMinValue) < 0.01 Or Abs(.PlotMinValue) > 1000 Then
        TmpTxtMin$ = Format(.PlotMinValue, "scientific")
    Else
        TmpTxtMin$ = Format(.PlotMinValue, "###0.00##") '"standard")
    End If
    
    If .PlotMaxValue = 0 Then
        TmpTxtMax$ = Format(.PlotMaxValue, "0.0") '"0.0"
    ElseIf Abs(.PlotMaxValue) < 0.01 Or Abs(.PlotMaxValue) > 1000 Then
        TmpTxtMax$ = Format(.PlotMaxValue, "scientific")
    Else
        TmpTxtMax$ = Format(.PlotMaxValue, "###0.00##") '"standard")
    End If
    
    If .PlotOffset = 0 Then
        TmpTxtOffset$ = Format(.PlotOffset, "0.0") '"0.0"
    ElseIf Abs(.PlotOffset) < 0.01 Or Abs(.PlotOffset) > 1000 Then
        TmpTxtOffset$ = Format(.PlotOffset, "scientific")
    Else
        TmpTxtOffset$ = Format(.PlotOffset, "###0.00##") '"standard")
    End If
    
    
    If .TotalPoints > 1000000# Then
        TmpText$ = Format$(.NumPoints, "0") + "/" + Format$(.TotalPoints, "0")
    Else
        TmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
    End If
    ArchiveForm.LabelPoints(0) = TmpText$
    ArchiveForm.LabelPoints(1) = Format$(.NumPoints, "0")
    ArchiveForm.LabelMisc(2).Visible = True
    
    ' If local history, and there is an archive server, then...
    If Not (.ArchiveSourceFlag) And .ArchiveDataServer <> "" Then
        ArchiveForm.LabelPoints(2).Visible = True
        ArchiveForm.LabelPoints(3).Visible = True
    
        'If .TotalLHPoints > 1000000# Then
            TmpText$ = "L.Hist: " + Format$(.TotalLHPoints, "0")
        'Else
        '    TmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
        'End If
        ArchiveForm.LabelPoints(2) = TmpText$
        TmpText$ = "C.Arch: " + Format$(.TotalArchPoints, "0")
        ArchiveForm.LabelPoints(3) = TmpText$
    Else
        ArchiveForm.LabelPoints(2).Visible = False
        ArchiveForm.LabelPoints(3).Visible = False
    End If
    
    StartUp% = 1
    ArchiveForm.TxtSelect(0).text = TmpTxtMin$ ' Min
    ArchiveForm.TxtSelect(1).text = TmpTxtMax$ ' Max
    ArchiveForm.TxtSelect(2).text = TmpTxtOffset$ ' Offset
    StartUp% = 0
    
    If FSlct(SelectedTrace%(ActivePlot%)).NumPoints > 1 Then
        ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = FSlct(dataIndex%).DispColor
        ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 3 * ChubbyFactor! / 2 + 2
        ' Use the selected type:
        If ACOPDefaultMode& = Dots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = PolyLine
        Else
            ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = Dots
        End If
        
        If ACOPDefaultMode& = Dots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 1 + ACOPDefaultWidth&
        ElseIf ACOPDefaultMode& = PolyLineDots Or ACOPDefaultMode& = BarLineDots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 5 + ACOPDefaultWidth&
        Else
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 3 + ACOPDefaultWidth&
        End If
        SelectedTracePlotIndex&(ActivePlot%) = ArchiveForm.ACOPPlot(ActivePlot%).Draw(PlotData(1, dataIndex%).fval, PlotData(1, dataIndex%).iVal, , , PlotData(0, dataIndex%).iVal, "FLTINT")
    'LOCK    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 1, SelectedTracePlotIndex&(ActivePlot%)
    End If
    
    'For i% = 0 To 3
    '    ArchiveForm.ComSelect(i%).Enabled = False
    'Next i%
    If ScalingMode% = RelativeScale Then
        ArchiveForm.ChkAuto(1).Visible = True
    Else
        ArchiveForm.ChkAuto(1).Visible = False
    End If
    
    ArchiveForm.ChkAuto(1).Enabled = True
    
    ' Need to allow array plotting?
    
    If FSlct(SelectedTrace%(ActivePlot%)).PropSize > 1 Then
        ' should this check-box be displayed?
        If ArchiveForm.MExtraDisplay.Checked = True Then
        'If ArchiveForm.ChkDouble(1).Visible = True Then
            ArchiveForm.TxtSelect(2).Visible = False
            ArchiveForm.LabelSelect(2).Visible = False
        Else
        End If
                
        'ArchiveForm.ChkDouble(4).Visible = True
        
        ' is there already a TS selected?
        KinoFrames% = FSlct(SelectedTrace%(ActivePlot%)).NumPoints
        KinoIndex% = 0
        If ArchiveTS& > 0 Then
            For i% = 2 To KinoFrames%
                If ArchiveTS& < ArchData(i%, SelectedTrace%(ActivePlot%)).iVal Then
                    KinoIndex% = i%
                    Exit For
                End If
            Next i%
        End If
        If KinoIndex% = 0 Then KinoIndex% = KinoFrames% / 2
        
        ArchiveTS& = ArchData(KinoIndex%, SelectedTrace%(ActivePlot%)).iVal
        'KinoIndex% = 1
        ArchiveForm.TextTS.text = str$(KinoIndex%)
        
        StartingUp = True
        ArchiveForm.HScrollTS.max = KinoFrames%
        StartingUp = False
    
        If ArchiveForm.ChkDouble(4).Value = 1 Then Call DoTheArrayData
    Else
        'ArchiveForm.ChkDouble(4).Visible = False
    End If
End With

End Sub


Public Sub GetHTCStuff(CurrIndex%)
                    
Dim TmpStartStop&(3), TmpBunches%(220), TmpI%, BunchData(MaxPoints, 9) As FLTINT
Dim i%, n%, ii%, rcc&, TmpNBunches%, BIndex%(10), BtoDataIndex%(220), HTC_Index%
Dim BTS&, BTSIndex%, Bunch%, BDataIndex%
Dim TmpHTCIndex%(MaxPoints - 1)
TmpStartStop&(0) = ArchiveStart&
TmpStartStop&(1) = ArchiveStop&
                    
' Find out which data has the HTC-Bunch number....
' (Don't bother to AUTOMATICALLY load it....)
HTC_Index% = -1
For i% = 0 To MaxCurves - 1
    If FSlct(i%).PropName = "HE_HTC_BUNCH" Then
        HTC_Index% = i%
        Exit For
    End If
Next i%
If HTC_Index% = -1 Then
    MsgBox "HTC-Bunch Not Found!"
    ArchData(0, CurrIndex%).iVal = 0
    Exit Sub
End If
'Debug.Print " HE_HTC_BUNCH Index: ", HTC_Index%

' Loop through the data from the "HE_HTC_BUNCH" property, and find
' out WHICH BUNCHES WERE USED....
If ArchData(0, HTC_Index%).iVal = 0 Then
    TmpNBunches% = 0
Else
    Erase TmpBunches%
    For i% = 1 To ArchData(0, HTC_Index%).iVal
        ' Because the -1 gets read-back as 65535....
        If (ArchData(i%, HTC_Index%).fval < 0) Or (ArchData(i%, HTC_Index%).fval > 219) Then
            ' A bug? have gotten 65535 as bunch number....
            Debug.Print " Hit-Bunch: ", ArchData(i%, HTC_Index%).fval
            'ArchData(i%, HTC_Index%).fval = 0
            TmpHTCIndex%(i%) = 0
        Else
            TmpI% = CInt(ArchData(i%, HTC_Index%).fval) - 1
            TmpBunches%(TmpI%) = TmpBunches%(TmpI%) + 1
            TmpHTCIndex%(i%) = TmpI%
        End If
        'If Not (TmpI% < 0 Or TmpI% > 219) Then TmpBunches%(TmpI%) = TmpBunches%(TmpI%) + 1
        'Debug.Print " HE_HTC_BUNCH Search ", TmpI%
    Next i%

    TmpI% = 0
    ' Get the data for ALL BUNCHES which have been "selected"....
    ArchiveForm.ACOPData.deviceProperty = FSlct(CurrIndex%).PropName
    For i% = 0 To 219
        If TmpBunches%(i%) > 0 Then
            BIndex%(TmpI%) = i%
            TmpStartStop&(2) = i%
            rcc& = ArchiveForm.ACOPData.Execute(BunchData(0, TmpI%).fval, MaxPoints, "FLTINT", TmpStartStop)
            BtoDataIndex%(i%) = TmpI%
            ' Check if enough data....
            TmpI% = TmpI% + 1
            If TmpI% > 9 Then
                MsgBox " Only 10 Bunch-Currents collected!"
                Exit For
            End If
        Else
            BtoDataIndex%(i%) = -1
        End If
    Next i%
    If TmpI% = 0 Then
        ' No useful data in the array?
        TmpNBunches% = 0
    Else
        TmpNBunches% = TmpI%
    End If
End If

' How many bunches were used for the HTC?
If TmpNBunches% = 0 Then
    ' No Bunches found? Just get the data for Bunch-0 and return....
    ArchiveForm.ACOPData.deviceProperty = FSlct(CurrIndex%).PropName
    TmpStartStop&(2) = 0
    rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, CurrIndex%).fval, MaxPoints, "FLTINT", TmpStartStop)
    Exit Sub
End If

' Transfer all the Bunch Data into ONE array....
ArchData(0, CurrIndex%).iVal = BunchData(0, 0).iVal
ArchData(0, CurrIndex%).fval = BunchData(0, 0).fval

' Get the right starting conditions....
BTSIndex% = 1
'Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).fval) - 1
'If (Bunch% < 0 Or Bunch% > 219) Then Bunch% = 0
Bunch% = TmpHTCIndex%(BTSIndex%)
BDataIndex% = BtoDataIndex%(Bunch%)
' Set time-stamp to NEXT
BTS& = ArchData(BTSIndex% + 1, HTC_Index%).iVal

For i% = 1 To BunchData(0, 0).iVal
    ' Check each time stamp, to get the current of the right bunch....
    If BunchData(i%, 0).iVal > BTS& Then
        ' Move to the bunch at the NEXT TS....
        BTSIndex% = BTSIndex% + 1
'        If (ArchData(BTSIndex%, HTC_Index%).fval < 0) Or (ArchData(BTSIndex%, HTC_Index%).fval > 219) Then
'            ' Kludge: just try to SKIP one?
'            BTSIndex% = BTSIndex% + 1
'            'Bunch% = 0
'            Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).fval) - 1
'        Else
'            Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).fval) - 1
'        End If
        Bunch% = TmpHTCIndex%(BTSIndex%)
        BDataIndex% = BtoDataIndex%(Bunch%)
        If (BTSIndex% + 1) > ArchData(0, HTC_Index%).iVal Then
            ' No More Timestamps.... so keep this bunch....
            BTS& = ArchiveStop& + 100
        Else
            BTS& = ArchData(BTSIndex% + 1, HTC_Index%).iVal
        End If
    End If
    ArchData(i%, CurrIndex%).fval = BunchData(i%, BDataIndex%).fval
    ArchData(i%, CurrIndex%).iVal = BunchData(i%, 0).iVal
Next i%

End Sub

Public Sub DrawArray()
Dim rcc&, i%, ii%, TmpStartStop&(3), TempIndex%, TempSize%
Dim Delta!, InvDelta!, ZeroOffset!, tmpFaktor!
Dim ScaleMax!, ScaleMin!, TempDNameIndex%
Dim tmpstr$


ArchiveForm.ACOPPlot(2).ClearScreen


' Draw an ARRAY in the second window...
' Get the data from the SelectedTrace, at the selected Time-Stamp
TempDNameIndex% = IndexToDName%(SelectedTrace%(0))
TempIndex% = SelectedTrace%(0)

TmpStartStop&(0) = ArchiveTS&
TmpStartStop&(1) = 0

' For TD, need also the SubIndex (the BUNCH)
If UCase$(FSlct(TempIndex%).VPlot) = "TD" Then
'    TmpStartStop&(2) = NextSubi% ' the START INDEX of the "property"
'    TmpStartStop&(3) = NTDBunches ' SAMPLE Interval
    
    TmpStartStop&(2) = 0 ' the START INDEX of the "property"
    TmpStartStop&(3) = 1 ' SAMPLE Interval
Else
    TmpStartStop&(2) = 0 ' the START INDEX of the "property"
    TmpStartStop&(3) = 1 ' SAMPLE Interval
End If

TempSize% = FSlct(TempIndex%).PropSize
ArchiveForm.ACOPData.deviceName = FSlct(TempIndex%).ServerName
ArchiveForm.ACOPData.deviceProperty = FSlct(TempIndex%).PropName
rcc& = ArchiveForm.ACOPData.Execute(ArrayData!(0), TempSize%, "SINGLE", TmpStartStop&, 4)

If rcc& = 0 Then ArrayDataSize = TempSize% Else ArrayDataSize = 0
ArrayDataTimeStamp = ArchiveTS&: ArrayDataKeyword = FSlct(TempIndex%).PropName





' Need to scale the data consistent with MainPlot....
ScaleMax! = FSlct(TempIndex%).PlotMaxValue
ScaleMin! = FSlct(TempIndex%).PlotMinValue

' To scale the data properly....
If FSlct(TempIndex%).VPlot = "LOG" Then
    If ScaleMin! <= 0 Then ScaleMin! = 0.01
    If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
    Delta! = (Log(ScaleMax!) - Log(ScaleMin!))
    If FSlct(TempIndex%).VMin = 0 Then FSlct(TempIndex%).VMin = 1E-20
    ZeroOffset! = Log(ScaleMin!)
Else
    Delta! = ScaleMax! - ScaleMin!
    ZeroOffset! = ScaleMin!
End If

If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = 100 / Delta!
' Use the scale-factor in the form for the GRAPHICS!
InvDelta! = InvDelta! * 1 'Val(ArchiveForm.Faktor(TempDNameIndex%).text)
            
' Plotting "mode"
If FSlct(TempIndex%).VPlot = "LOG" Then
    For ii% = 0 To TempSize% - 1
        If ArrayData!(ii%) > 0 Then
            PlotArrayData!(ii%) = (Log(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
        Else
            PlotArrayData!(ii%) = 0
        End If
    Next ii%
ElseIf FSlct(TempIndex%).VPlot = "ABS" Then
    For ii% = 0 To TempSize% - 1
        PlotArrayData!(ii%) = (Abs(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
    Next ii%
ElseIf FSlct(TempIndex%).VPlot = "SLOG" Then
    tmpFaktor! = 1
    For ii% = 0 To TempSize% - 1
        If PlotArrayData!(ii%) > 0 Then
            ii% = ii%
        End If
        PlotArrayData!(ii%) = (ArrayData!(ii%) * tmpFaktor! - ZeroOffset!) * InvDelta!
    Next ii%
Else
    For ii% = 0 To TempSize% - 1
       PlotArrayData!(ii%) = (ArrayData!(ii%) - ZeroOffset!) * InvDelta!
    Next ii%
End If
                    
If ArchiveForm.OptDisplayArray(0).Value = True Then
    If TempSize% > 100 Then ArchiveForm.ACOPPlot(2).DrawWidth = 1 Else ArchiveForm.ACOPPlot(2).DrawWidth = 3
Else
    ArchiveForm.ACOPPlot(2).DrawWidth = 2
End If

ArchiveForm.ACOPPlot(2).ForeColor = FSlct(TempIndex%).DispColor
ArchiveForm.ACOPPlot(2).Draw PlotArrayData!, , , , TempSize%
ArchiveForm.ACOPPlot(2).xmin = 0
ArchiveForm.ACOPPlot(2).xmax = FSlct(TempIndex%).PropSize

If (ArchiveForm.ChkAuto(0).Value + ArchiveForm.ChkAuto(1).Value + ArchiveForm.ChkAuto(2).Value) > 0 Then
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
Else
    ArchiveForm.ACOPPlot(2).AutoScale False, False, False, False
    ArchiveForm.ACOPPlot(2).ymin = 0
    ArchiveForm.ACOPPlot(2).ymax = 100
End If

Call CTIME(datstr, ArchiveTS&)
tmpstr$ = ArchiveForm.ACOPPlot(0).CTIME(ArchiveTS&)
tmpstr$ = Mid(tmpstr$, 1, Len(tmpstr$) - 2)

ArchiveForm.ACOPPlot(2).ForeColor = BLACK
ArchiveForm.ACOPPlot(2).YAxisLabel = FSlct(TempIndex%).VUnit
ArchiveForm.ACOPPlot(2).XAxisLabel = "Array Index"
ArchiveForm.ACOPPlot(2).Caption = FSlct(TempIndex%).PropName + "  at  " + tmpstr$

ArchiveForm.tlab(1).Caption = Left(datstr, Len(datstr) - 2) + "   UTC: " + str$(ArchiveTS&)

ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
'For i% = 0 To MaxPlots% - 1
'    If FSlct(i%).Active Then ArchiveForm.ACOPPlot(0).RecallScreen FSlct(i%).ACOPPlotIndex
'Next i%

ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = PolyLine
ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = -3
XCursorArray&(0) = ArchiveTS&
XCursorArray&(1) = ArchiveTS&
ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = BLUE
ArchiveForm.ACOPPlot(ActivePlot%).Draw YCursorArray!(0), XCursorArray&(0), , , 2, "SINGLE"

' Set markers on array plot?
ArchiveForm.ACOPPlot(2).Tagging = True
ArchiveForm.ACOPPlot(2).ClearTags
For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    If FSlct(i%).Active = True Then
        If FSlct(TempIndex%).PropName = FSlct(i%).PropName Then
            'Set a marker
            If FSlct(i%).DispColor = 0 Then
                ArchiveForm.ACOPPlot(2).TagColor = LGREY
            Else
                ArchiveForm.ACOPPlot(2).TagColor = FSlct(i%).DispColor
            End If
            ArchiveForm.ACOPPlot(2).IsTagged FSlct(i%).DeviceIndex, True
        End If
    End If
Next i%

End Sub

Public Sub DrawMarker()
Dim TempX&(1), TempY!(1)

If ArchiveTS& > 0 Then
    ' Draw a marker
    ArchiveForm.ACOPPlot(0).ClearScreen
    ArchiveForm.ACOPPlot(0).DisplayMode = PolyLine
    ArchiveForm.ACOPPlot(0).DrawWidth = 2
    ArchiveForm.ACOPPlot(0).ForeColor = DGREEN
    TempX&(0) = ArrayDataTimeStamp&
    TempX&(1) = TempX&(0)
    
    TempY!(0) = ArchiveForm.ACOPPlot(0).ymin - 100
    TempY!(1) = ArchiveForm.ACOPPlot(0).ymax + 100
    
    MarkerPlotIndex& = ArchiveForm.ACOPPlot(0).Draw(TempY!(0), TempX&(0), , , 2)
    
    ' Draw a REFERENCE marker
    If (ReferenceTS& > 0) And ((ArchiveForm.CheckRef(0).Value + ArchiveForm.CheckRef(1).Value) > 0) Then
        'ACOPPlot(0).ClearScreen
        ArchiveForm.ACOPPlot(0).DisplayMode = PolyLine
        ArchiveForm.ACOPPlot(0).DrawWidth = 2
        ArchiveForm.ACOPPlot(0).ForeColor = BLUE
        TempX&(0) = ReferenceTS&
        TempX&(1) = TempX&(0)
        
        TempY!(0) = ArchiveForm.ACOPPlot(0).ymin - 100
        TempY!(1) = ArchiveForm.ACOPPlot(0).ymax + 100
        
        RefMarkerPlotIndex& = ArchiveForm.ACOPPlot(0).Draw(TempY!(0), TempX&(0), , , 2)
    End If
End If
End Sub

Function getSelectedName(n As Integer) As String
Dim i As Integer
Dim nm$
If n > 15 Then
  getSelectedName = ""
  Exit Function
End If
i = FSlct(n).PListIndex
nm$ = FSlct(n).PropName 'archivedKeywords(i).keyword
If FSlct(n).PropSize > 1 Then
  nm$ = nm$ + "[" + Trim$(str$(FSlct(n).DeviceIndex)) + "]"
  If FSlct(n).DeviceSubIndex > 0 Then nm$ = nm$ + "[" + Trim$(str$(FSlct(n).DeviceSubIndex)) + "]"
End If
getSelectedName = nm$
End Function


Public Sub FilterTheData(flag%)
Dim i%, ii%, n%, OKCount%, StartLabel%, StopLabel%

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1
                                
If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).ReFilter = True
        Else
            FSlct(i%).ReFilter = False
        End If
    Next i%
End If
                                
For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).ReFilter = True Then
        n% = FSlct(i%).NumPoints
        
        If FSlct(i%).PropName = "HPFWHM" Then
            ' Bad data from the CMFL FEC....
            For ii% = 1 To n%
                If ArchData(ii%, i%).fval > 10000# Then ArchData(ii%, i%).fval = 0
            Next ii%
        'ElseIf FSlct(i%).PropName = "H1SLumi" Then
        '    ' Bad data from H1-Lumi....
        '    For ii% = 1 To n%
        '        'If Not (IsNumeric(ArchData(ii%, i%).fval)) Then ArchData(ii%, i%).fval = 0
        '        ArchData(ii%, i%).fval = Val(ArchData(ii%, i%).fval)
        '    Next ii%
        ElseIf FSlct(i%).PropName = "HE_H_HTC_PSC" Or FSlct(i%).PropName = "HE_V_HTC_PSC" Then
            ' Signed Integers read as UNSIGNED...
            For ii% = 1 To n%
                If ArchData(ii%, i%).fval > 32767 Then ArchData(ii%, i%).fval = ArchData(ii%, i%).fval - 65536
            Next ii%
        ElseIf (FSlct(i%).PropName = "TTFAcc2TCoup4KB" And FSlct(i%).DeviceIndex = 4) Or (FSlct(i%).PropName = "TTFAcc1THOM2" And FSlct(i%).DeviceIndex = 2) Then
            ' IS there bad data here?
            ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
            'For ii% = 1 To n%
            '    If ArchData(ii%, i%).fval > 10000 Then ArchData(ii%, i%).fval = 0
            'Next ii%
        ElseIf InStr(1, FSlct(i%).PropName, "L3") <> 0 Then '"L3Que"
            ' IS there bad data here?
            ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
            OKCount% = 1
            For ii% = 1 To n%
                If ArchData(ii%, i%).fval < ErrorValue! Then
                    ArchData(OKCount%, i%).fval = ArchData(ii%, i%).fval
                    ArchData(OKCount%, i%).iVal = ArchData(ii%, i%).iVal
                    OKCount% = OKCount% + 1
                End If
            Next ii%
            n% = OKCount% - 1
            FSlct(i%).NumPoints = n%
            ArchData(0, i%).iVal = n%
        End If
    
        If ArchiveForm.MenuBADData.Checked Then
            OKCount% = 1
            For ii% = 1 To n%
                If ArchData(ii%, i%).fval < ErrorValue! Then
                    ArchData(OKCount%, i%).fval = ArchData(ii%, i%).fval
                    ArchData(OKCount%, i%).iVal = ArchData(ii%, i%).iVal
                    OKCount% = OKCount% + 1
                End If
            Next ii%
            n% = OKCount% - 1
            FSlct(i%).NumPoints = n%
            ArchData(0, i%).iVal = n%
        End If
        FSlct(i%).ReFilter = False
        FSlct(i%).RePlot = True
    Else
        ' Nothing to do?
        FSlct(i%).ReFilter = False
    End If
Next i%

End Sub

Public Sub OperateOnTheData(index%)
Dim i%, ii%, rc%
Dim TmpYData!(MaxPoints), TmpXData0&(MaxPoints), TmpXData1&(MaxPoints), NTmp0%, NTmp1%

' try to do an operation on two of the arrays which are already loaded.....
If index% < 2 Then
    MsgBox " error in operation! not enough arrays!"
    Exit Sub
End If

' use the time stamps of the last to get the data points for the SECOND-to-LAST....
NTmp0% = FSlct(index% - 2).NumPoints
For ii% = 0 To NTmp0% - 1
    TmpXData0&(ii%) = ArchData(ii% + 1, index% - 2).iVal
    TmpYData!(ii%) = ArchData(ii% + 1, index% - 2).fval
Next ii%

NTmp1% = FSlct(index% - 1).NumPoints
For ii% = 0 To NTmp1% - 1
    TmpXData1&(ii%) = ArchData(ii% + 1, index% - 1).iVal
Next ii%

' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
rc% = INTERP(TmpYData!(0), TmpXData0&(0), NTmp0%, TmpXData1&(0), NTmp1%)
' assume it is MINUS...
If FSlct(index%).PropName = OpMinus Then
    If FSlct(index% - 1).PropName = "HPBunCur" Then
        ' Just so the plot looks good for the proton-current plot....
        For ii% = 1 To FSlct(index% - 1).NumPoints
            ArchData(ii%, index%).iVal = ArchData(ii%, index% - 1).iVal
            If TmpYData(ii% - 1) > 5 Then ' Check how much proton current.....
                ArchData(ii%, index%).fval = TmpYData(ii% - 1) - ArchData(ii%, index% - 1).fval
            Else
                ArchData(ii%, index%).fval = 0
            End If
        Next ii%
    Else
        For ii% = 1 To FSlct(index% - 1).NumPoints
            ArchData(ii%, index%).iVal = ArchData(ii%, index% - 1).iVal
            'If TmpYData(ii% - 1) > 40 Then
                ArchData(ii%, index%).fval = TmpYData(ii% - 1) - ArchData(ii%, index% - 1).fval
            'Else
            '    ArchData(ii%, Index%).fval = 0
            'End If
        Next ii%
    End If
ElseIf FSlct(index%).PropName = OpPlus Then
    For ii% = 1 To FSlct(index% - 1).NumPoints
        ArchData(ii%, index%).iVal = ArchData(ii%, index% - 1).iVal
        'If TmpYData(ii% - 1) > 40 Then
            ArchData(ii%, index%).fval = TmpYData(ii% - 1) + ArchData(ii%, index% - 1).fval
        'Else
        '    ArchData(ii%, Index%).fval = 0
        'End If
    Next ii%
ElseIf FSlct(index%).PropName = OpMult Then
    For ii% = 1 To FSlct(index% - 1).NumPoints
        ArchData(ii%, index%).iVal = ArchData(ii%, index% - 1).iVal
        'If TmpYData(ii% - 1) > 40 Then
            ArchData(ii%, index%).fval = TmpYData(ii% - 1) * ArchData(ii%, index% - 1).fval
        'Else
        '    ArchData(ii%, Index%).fval = 0
        'End If
    Next ii%
ElseIf FSlct(index%).PropName = OpDiv Then
    If FSlct(index% - 1).PropName = "D3IBottom" Then
        ' Just so the plot looks good for the proton-current plot....
        For ii% = 1 To FSlct(index% - 1).NumPoints
            ArchData(ii%, index%).iVal = ArchData(ii%, index% - 1).iVal
            If (TmpYData(ii% - 1) > 1) And (ArchData(ii%, index% - 1).fval <> 0) Then
                ArchData(ii%, index%).fval = TmpYData(ii% - 1) / ArchData(ii%, index% - 1).fval
            Else
                ArchData(ii%, index%).fval = 0
            End If
        Next ii%
    Else
        For ii% = 1 To FSlct(index% - 1).NumPoints
            ArchData(ii%, index%).iVal = ArchData(ii%, index% - 1).iVal
            If ArchData(ii%, index% - 1).fval <> 0 Then
                ArchData(ii%, index%).fval = TmpYData(ii% - 1) / ArchData(ii%, index% - 1).fval
            Else
                ArchData(ii%, index%).fval = 0
            End If
        Next ii%
    End If
End If
FSlct(index%).NumPoints = FSlct(index% - 1).NumPoints
FSlct(index%).TotalPoints = FSlct(index% - 1).TotalPoints
ArchData(0, index%).iVal = FSlct(index%).NumPoints

' Need the time-bins, too...
For ii% = 1 To FSlct(index%).NumPoints - 1
    ArchTimeBins#(ii%, index%) = CDbl(ArchData(ii%, index%).iVal)
Next ii%
ArchTimeBins#(0, index%) = ArchData(1, index%).iVal - 100
ArchTimeBins#(FSlct(index%).NumPoints + 1, index%) = ArchData(FSlct(index%).NumPoints, index%).iVal + 100

End Sub

Sub OLDReadTheHistoryData(flag%)
Dim devName$, devProperty$, devIndex&, tmpSelected%, tmpTotalPoints&, TmpText$
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), StartLabel%, StopLabel%
Dim lStartStopArray(2) As Long
Dim npts As Long, n As Long
Dim rc&, i%, ii%, j%
Dim dout As DBLK, din As DBLK
Dim iAnswer%, tmpEnabled As Boolean



StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).Acquire = True
            FSlct(i%).ReFilter = True
            FSlct(i%).ReScale = True
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).Acquire = False
            FSlct(i%).ReFilter = False
            FSlct(i%).ReScale = False
            FSlct(i%).RePlot = False
        End If
        FSlct(i%).ACOPPlotIndex = -1
    Next
End If

For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).Acquire = True Then
        With FSlct(i%)
            If NZooms% = 0 Then
                ' get an extra hour each side.....
                tmpSide& = 3600
            Else
                ' What if the data are in ONE SECOND raster - then don't add too much....
                If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
            End If
            
            TmpStartStop&(0) = ArchiveStart& - tmpSide&
            TmpStartStop&(1) = ArchiveStop& + tmpSide&


'            If ArchiveForm.ChkDeviceInc.Value = vbChecked Then
'                'devName$ = "#" + Format$(hstDisplay(i%).devIndex + 1, "###0")
'                devName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex + 1, "###0")
'            Else
'                devName$ = .deviceName
'            End If
'
'            devName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")


            devProperty$ = .PropName
            devIndex& = 0 '.devIndex
            TmpStartStop&(2) = devIndex&
    
LaunchPointsLink:
    
            ' First find out how many points
            dout.dArrayLength = 1: dout.dFormat = CF_LONG
            din.dArrayLength = 3: din.dFormat = CF_LONG
            rc& = T_EXECLINK(devName, devProperty & ".HIST", dout, tmpTotalPoints&, din, TmpStartStop&(0), 1, 5000)
            If rc& Then
                iAnswer% = MsgBox(" Error Reading Total Points for" + devProperty + " from " + devName$ + ":  " + RPCERROR(rc&), vbAbortRetryIgnore, "Reading Histories")
                ArchData(0, i%).iVal = 0
                If iAnswer% = vbRetry Then GoTo LaunchPointsLink
                If iAnswer% = vbAbort Then Exit Sub 'For
            Else
            End If
            .TotalPoints = tmpTotalPoints&
    
LaunchHistoryLink:
            dout.dArrayLength = MaxPoints: dout.dFormat = CF_FLTINT
            din.dArrayLength = 3: din.dFormat = CF_LONG
            rc& = T_EXECLINK(devName, devProperty & ".HIST", dout, ArchData(0, i%), din, TmpStartStop&(0), 1, 10000)
            If rc& Then
                iAnswer% = MsgBox(" Error Reading " + devProperty + " from " + devName$ + ":  " + RPCERROR(rc&), vbAbortRetryIgnore, "Reading Histories")
                If iAnswer% = vbRetry Then GoTo LaunchHistoryLink
                If iAnswer% = vbAbort Then
                    ArchData(0, i%).iVal = 0
                    .NumPoints = 0
                    .TotalPoints = 0
                    Exit Sub
                End If
            Else
            End If
            .NumPoints = ArchData(0, i%).iVal
         
        
            For ii% = 1 To .NumPoints - 1
                ArchTimeBins#(ii%, i%) = CDbl((ArchData(ii%, i%).iVal) + CDbl((ArchData(ii% + 1, i%).iVal - ArchData(ii%, i%).iVal)) / 2)
            Next ii%
            ArchTimeBins#(0, i%) = ArchData(1, i%).iVal - 100
            ArchTimeBins#(.NumPoints + 1, i%) = ArchData(.NumPoints, i%).iVal + 100
            
            ' Which row is the data in?
            tmpIndex% = IndexToDName%(i%)
            'ArchiveForm.LinLog(TmpIndex%) = FSlct(i%).VPlot
'            If .TotalPoints > 1000000# Then
'                tmpText$ = Format$(.NumPoints, "0") + "/" + Format$(.TotalPoints, "0")
'            Else
'                tmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
'            End If
'            ArchiveForm.Text1(tmpIndex%) = tmpText$
            
            
            .Acquire = False
            
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End With
    End If
Next i%


'' Save movie status....
'tmpEnabled = ArchiveForm.TimerMovie.Enabled
'ArchiveForm.TimerMovie.Enabled = False
'
'tmpSelected% = NDisplays% - 1 ' which to use? First, or last, or selected....
'If FSlct(tmpSelected%).NumPoints > 0 Then
'    StartingUp = True
'    ArchiveForm.HScrollTS.max = FSlct(tmpSelected%).NumPoints
'    ArchiveForm.LabelTS(0).Caption = str$(FSlct(tmpSelected%).NumPoints)
'    ArchiveForm.LabelTS(1).Caption = str$(FSlct(tmpSelected%).TotalPoints)
'    ArchiveForm.HScrollTS.Value = 1
'
'    If ArchiveTS& > 0 Then
'        For j% = 1 To ArchData(0, tmpSelected%).ival
'            If ArchData(j%, tmpSelected%).ival > ArchiveTS& Then Exit For
'        Next j%
'        If j% = ArchData(0, tmpSelected%).ival + 1 Then ArchiveTSIndex% = 1 Else ArchiveTSIndex% = j%
'    Else
'        ArchiveTSIndex% = 1
'    End If
'    StartingUp = False
'Else
'End If
'
'' Restart movie
'ArchiveForm.TimerMovie.Enabled = tmpEnabled

End Sub




Public Sub ReadTheData(flag%)
Dim i%, ii%, n%, j%, k%, kk%, StartLabel%, StopLabel%, MsgRC%, rc%, rcc&
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), tStr$, tmpTotalPoints&, TmpText$
Dim useStringBuffer As Boolean, scratchTotalPoints As FLTINT

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1


If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).Acquire = True
            FSlct(i%).ReFilter = True
            FSlct(i%).ReScale = True
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).Acquire = False
            FSlct(i%).ReFilter = False
            FSlct(i%).ReScale = False
            FSlct(i%).RePlot = False
        End If
        'ArchiveForm.acopplot(0).LockScreen 0, fslct(i%).ACOPPlotIndex
        FSlct(i%).ACOPPlotIndex = -1
    Next
'ElseIf Flag = 1 Then
'    For i% = StartLabel% To StopLabel%
'    '   THIS NEEDS TO BE FIXED !!!! The ArchData() buffer gets reassigned inside the drawing logic to
'    '   accomplish some sort of scaling, etc.  That's why it needs to be reacquired for the autoscale to
'    '   work properly.  The solution is to use a second drawing buffer
'        'If FSlct(i%).Active = True Then FSlct(i%).Acquire = True ' Testing! shouldn't be here - but AUTOSCALE plots wrong without it....
'
'        If FSlct(i%).Active = True Then
'            FSlct(i%).RePlot = True
'        Else
'        End If
'    Next
End If



For i% = StartLabel% To StopLabel%
    With FSlct(i%)
        If .Active And .Acquire = True Then
            If NZooms% = 0 Then
                ' get an extra hour each side.....
                tmpSide& = 3600
            Else
                ' What if the data are in ONE SECOND raster - then don't add too much....
                If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
            End If
            
            TmpStartStop&(0) = ArchiveStart& - tmpSide&
            TmpStartStop&(1) = ArchiveStop& + tmpSide&
            
            If ActivePlot% = 1 Then
                ' Don't do anything.... don't need to read data for "copy-buffer"
            ElseIf (.PropName = OpMinus) Or (.PropName = OpPlus) Or (.PropName = OpMult) Or (.PropName = OpDiv) Then
                ' Doing mathematical operations (subtracting coasting beam....)
                Call OperateOnTheData(i%)
            Else
                
                If .ArchiveSourceFlag = True Then
                    rc% = ReadArchiveData(i%)
                Else
                    rc% = ReadHistoryData(i%)
                End If
                
                If rc% = -10001 Then
                    ' ABORT from the read routine
                    TmpText$ = "ERROR"
                    tmpIndex% = IndexToDName%(i%)
                    .NumPoints = 0
                    'ArchiveForm.Text1(tmpIndex%) = tmpText$
                    Exit Sub
                Else
                End If
                                
                For ii% = 1 To .NumPoints - 1
                    ArchTimeBins#(ii%, i%) = CDbl((ArchData(ii%, i%).iVal) + CDbl((ArchData(ii% + 1, i%).iVal - ArchData(ii%, i%).iVal)) / 2)
                Next ii%
                ArchTimeBins#(0, i%) = ArchData(1, i%).iVal - 100
                ArchTimeBins#(n% + 1, i%) = ArchData(n%, i%).iVal + 100
            End If
            
            ' Which row is the data in?
            tmpIndex% = IndexToDName%(i%)
            'ArchiveForm.LinLog(TmpIndex%) = FSlct(i%).VPlot
'            If .TotalPoints > 1000000# Then
'                tmpText$ = Format$(.NumPoints, "0") + "/" + Format$(.TotalPoints, "0")
'            Else
'                tmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
'            End If
'            ArchiveForm.Text1(tmpIndex%) = tmpText$
            
            .Acquire = False
            
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
    End With
Next i%

End Sub

Public Function ReadHistoryData(index%) As Integer
Dim devProperty$, devIndex&, tmpSelected%, tmpTotalPoints&, TmpText$
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), StartLabel%, StopLabel%, TmpDevName$
Dim lStartStopArray(2) As Long, tmpTimeOut&, scratchTotalPoints As FLTINT
Dim npts As Long, n As Long
Dim rcc&, i%, ii%, j%, nread As Integer
Dim dout As DBLK, din As DBLK
Dim iAnswer%, tmpEnabled As Boolean
Dim tmpSaveDevName$

With FSlct(index%)
    .ReFilter = False
    .ReScale = False
    .RePlot = False
    
    If .Active And .Acquire = True Then
        If NZooms% = 0 Then
            ' get an extra hour each side.....
            tmpSide& = 3600
        Else
            ' What if the data are in ONE SECOND raster - then don't add too much....
            If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
        End If
        'tmpSide& = 0
        
        TmpStartStop&(0) = ArchiveStart& - tmpSide&
        TmpStartStop&(1) = ArchiveStop& + tmpSide&



        If .ContextName = "" Then
            TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
            'devName$ = .ServerName + "/" + .deviceName
        Else
            TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
            'devName$ = "/" + .ContextName + "/" + .ServerName + "/" + .deviceName
        End If
        
        devProperty$ = .PropName
        devIndex& = 0 '.devIndex
        TmpStartStop&(2) = 0 'devIndex&


'        ' Check if there is a device name...
'        If .deviceName = "" Or .deviceName = "?" Then
'            ' Only an index...
'            If .ContextName = "" Then
'                TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'            Else
'                TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'            End If
'        ElseIf InStr(1, .deviceName, "/") <> 0 Then
'            ' Vakuum Servers: some devices have a SLASH!
'            If .ContextName = "" Then
'                TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'            Else
'                TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'            End If
'        Else
'            If .ContextName = "" Then
'                TmpDevName$ = .ServerName + "/" + .deviceName
'            Else
'                TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/" + .deviceName
'            End If
'        End If

        ' Check if there is a device name...
        If .deviceName = "" Or .deviceName = "?" Then
            ' Only an index...
            tmpSaveDevName$ = "#" + Format$(.DeviceIndex, "###0")
        ElseIf InStr(1, .deviceName, "/") <> 0 Then
            ' Vakuum Servers: some devices have a SLASH!
            tmpSaveDevName$ = "#" + Format$(.DeviceIndex, "###0")
        Else
            tmpSaveDevName$ = .deviceName
        End If
        
        
        If .ContextName = "" Then
            TmpDevName$ = .ServerName + "/" + tmpSaveDevName$
        Else
            TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/" + tmpSaveDevName$
        End If

' Need to add one to the device index?
'        If ArchiveForm.ChkDeviceInc.Value = vbChecked Then
'            'devName$ = "#" + Format$(hstDisplay(i%).devIndex + 1, "###0")
'            devName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex + 1, "###0")
'        Else
'            devName$ = .deviceName
'        End If


' OLD METHOD - using INDEX....
'        If ArchiveForm.ChkDeviceInc.Value = vbChecked Then
'            'devName$ = "#" + Format$(hstDisplay(i%).devIndex + 1, "###0")
'            devName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex + 1, "###0")
'        Else
'            devName$ = .deviceName
'        End If
'
'        If .ContextName = "" Then
'            devName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'        Else
'            devName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'        End If
'
'        devProperty$ = .PropName
'        devIndex& = 0 '.devIndex
'        TmpStartStop&(2) = devIndex&

LaunchPointsLink:

''       Method from CENTRAL ARCHIVER
'        ArchiveForm.ACOPData.AccessMode = "READ"
'        ArchiveForm.ACOPData.deviceName = TmpDevName$
'        ArchiveForm.ACOPData.deviceProperty = devProperty
'        rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
'        Debug.Print scratchTotalPoints.ival
'        tmpTotalPoints& = scratchTotalPoints.ival
''       OLD METHOD for Local Histories (Doesn't work with central archiver)
'        dout.dArrayLength = 1: dout.dFormat = CF_LONG
'        din.dArrayLength = 3: din.dFormat = CF_LONG
'        rcc& = T_EXECLINK(TmpDevName$, devProperty & ".HIST", dout, tmpTotalPoints&, din, TmpStartStop&(0), 1, tmpTimeOut&)


        ' First find out how many points
        tmpTimeOut& = 1000
        ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
        ArchiveForm.ACOPData.accessMode = "READ"
        ArchiveForm.ACOPData.deviceName = TmpDevName$
        ArchiveForm.ACOPData.deviceProperty = devProperty + ".HIST"
        rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
        tmpTimeOut& = 1000 ' This should go fast....
        If rcc& = out_of_range% Or rcc& = device_not_connected% Then
            ' Invalid device name - not registered (only a .NAM property?)
            If .ContextName = "" Then
                TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
            Else
                TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
            End If
        
            ArchiveForm.ACOPData.deviceName = TmpDevName$
            ArchiveForm.ACOPData.deviceProperty = devProperty + ".HIST"
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
        End If
        
        ReadHistoryData = rcc&
        If rcc& Then
            iAnswer% = MsgBox(" Error Reading Total-History-POINTS for " + devProperty + " from " + TmpDevName$ + ":  " + RPCERROR(rcc&), vbAbortRetryIgnore, "Reading Histories")
            ArchData(0, index%).iVal = 0
            If iAnswer% = vbRetry Then
                GoTo LaunchPointsLink
            ElseIf iAnswer% = vbAbort Then
                ReadHistoryData = -10001
                Exit Function
            Else
                ' Ignore...
            End If
        End If
        .TotalLHPoints = scratchTotalPoints.iVal 'tmpTotalPoints&
        
        If .ArchiveDataServer <> "" Then
            tmpTimeOut& = 1000
            ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
            ArchiveForm.ACOPData.accessMode = "READ"
            ArchiveForm.ACOPData.deviceName = .ArchiveHistoryServer + "/" + tmpSaveDevName$
            ArchiveForm.ACOPData.deviceProperty = .ArchiveProperty
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
            If rcc& Then
                MsgBox "Error reading from central archiver! " + ArchiveForm.ACOPData.Status
            Else
            End If
            .TotalArchPoints = scratchTotalPoints.iVal
        Else
            .TotalArchPoints = -1
        End If
        
        If .TotalArchPoints > 500 Or .TotalArchPoints > .TotalLHPoints Then
            ' Get the data out of the CENTRAL ARCHIVER
            ArchiveForm.ACOPData.deviceName = .ArchiveHistoryServer + "/" + tmpSaveDevName$
            ArchiveForm.ACOPData.deviceProperty = .ArchiveProperty
            .TotalPoints = .TotalArchPoints
            tmpTimeOut& = 1000
        Else
            ' Get the Local History Data
            ArchiveForm.ACOPData.deviceName = TmpDevName$
            ArchiveForm.ACOPData.deviceProperty = devProperty + ".HIST"
            .TotalPoints = .TotalLHPoints
            If .TotalPoints > 10000 Then
                tmpTimeOut& = 5000
            Else
                tmpTimeOut& = 2000
            End If
        End If
        
        
        ' Show something while reading?
        'If .TotalPoints > 1000000# Then
        '    tmpText$ = Format$(.NumPoints, "0") + "/" + Format$(.TotalPoints, "0")
        'Else
        '    tmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
        'End If
        TmpText$ = "Total: " + Format$(.TotalPoints, "0")
        ArchiveForm.LabelPoints(0) = TmpText$


LaunchHistoryLink:
'        ' OLD METHOD Local Histories
'        dout.dArrayLength = MaxPoints: dout.dFormat = CF_FLTINT
'        din.dArrayLength = 4: din.dFormat = CF_LONG
'        rcc& = T_EXECLINK(TmpDevName$, devProperty & ".HIST", dout, ArchData(0, index%), din, TmpStartStop&(0), 1, tmpTimeOut&)
        
'       ' Central Archiver
'        rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, index%).fval, MaxPoints, "FLTINT", TmpStartStop, 2)
        
        TmpStartStop&(3) = -1
        
        ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
        rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, index%).fval, MaxGetDataPointsHIST, "FLTINT", TmpStartStop, 2)
        
        ReadHistoryData = rcc&
        
        If rcc& Then
            iAnswer% = MsgBox(" Error Reading History Data for " + devProperty + " from " + TmpDevName$ + ":  " + RPCERROR(rcc&), vbAbortRetryIgnore, "Reading Histories")
            If iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 2000
                GoTo LaunchHistoryLink
            ElseIf iAnswer% = vbAbort Then
                ArchData(0, index%).iVal = 0
                .NumPoints = 0
                .TotalPoints = 0
                ReadHistoryData = -10001
                Exit Function
            Else
                ' Ignore....
            End If
            nread = 0          'P.D  allow for the new way !
        Else
            ArchiveForm.ACOPData.GetDataSize nread                             'P.D  allow for the new way !
            makeLegacyArrays "ArchData", index%, nread                         'P.D  allow for the new way !
            
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
        
        .NumPoints = nread
    End If
    
End With

' Set back to "nothing"
ArchiveForm.LabelPoints(0).Caption = "-"
ArchiveForm.LabelPoints(2).Visible = False
ArchiveForm.LabelPoints(3).Visible = False

End Function

Public Function ReadArchiveData(index%) As Integer
Dim i%, ii%, n%, j%, k%, kk%, StartLabel%, StopLabel%, MsgRC%, rc%, rcc&
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), tStr$, tmpTotalPoints&, TmpText$
Dim useStringBuffer As Boolean, scratchTotalPoints As FLTINT, TmpDevName$
Dim iAnswer%
Dim nread As Integer

With FSlct(index%)
    .ReFilter = False
    .ReScale = False
    .RePlot = False
    
    If .Active And .Acquire = True Then
        If NZooms% = 0 Then
            ' get an extra hour each side.....
            tmpSide& = 3600
        Else
            ' What if the data are in ONE SECOND raster - then don't add too much....
            If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
        End If
        
        TmpStartStop&(0) = ArchiveStart& - tmpSide&
        TmpStartStop&(1) = ArchiveStop& + tmpSide&
        
        If Not filterAcquired Then
retrieveFilterData:
            If nFilterKeywords > 0 Then
                ArchiveForm.ACOPData.Caption = filterString
                For j% = 0 To nFilterKeywords - 1
                    If filterKeywords(j%).fmt = "NAME32" Then
                        ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                        ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                        rcc& = ArchiveForm.ACOPData.Execute(filterTextBuffer(0, j%).nam, MaxPoints / 10, "NAME32I", TmpStartStop)
                    Else
                        ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                        ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                        rcc& = ArchiveForm.ACOPData.Execute(filterDataBuffer(0, j%).fval, MaxPoints, "FLTINT", TmpStartStop)
                    End If
                    If rcc& Then
                        MsgRC = MsgBox(" Error acquiring filter! " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Archive Retrieval")
                        n% = 0
                        If MsgRC = vbRetry Then GoTo retrieveFilterData
                    End If
                    ArchiveForm.ACOPData.GetDataSize nread
                Next j%
            Else
                ArchiveForm.ACOPData.Caption = ""
            End If
            filterAcquired = True
        End If
        
        ' get the data out of the archive
retrieveArchiveData:
        ArchiveForm.LabelMisc(3).Caption = "Data loading...."
        ArchiveForm.LabelMisc(3).Visible = True
        ArchiveForm.Refresh
        
        ' give it a longer timeout in case there's a bunch of data :
        If ArchiveForm.timeoutText.Visible Then
            ArchiveForm.ACOPData.AccessRate = ArchiveForm.timeoutText.text '3000
        Else
            ArchiveForm.ACOPData.AccessRate = 3000
        End If
        
        If .DeviceIndex < 0 And .deviceName = "#0" And Mid(.PropName, 1, 3) <> "TTF" Then
            ' For the HTC: get the BUNCH CURRENTS for the INDEX of the HE_HTC_BUNCH!
            ArchiveForm.ACOPData.deviceName = .ServerName
            Call GetHTCStuff(index%)
        Else
            If Mid(.PropName, 1, 3) = "TTF" Then
                ArchiveForm.ACOPData.deviceName = "TTFHISTORY"
            
                ' Kludge for the HTC Bunch-Selection....
                If .DeviceIndex < 0 Then .DeviceIndex = 0
                
                ' Is this a TD Property?
                If .VPlot = "TD" Then
                    TmpStartStop&(2) = .DeviceIndex * NTDBunches + .DeviceSubIndex
                Else
                    TmpStartStop&(2) = .DeviceIndex
                End If
            Else
                If .DeviceIndex >= 0 Then TmpStartStop&(2) = .DeviceIndex
            End If
        
            
LaunchPointsLink:
            ' Check if there is a device name...
            If .deviceName = "" Or .deviceName = "?" Then
                ' Only an index...
                If .ContextName = "" Then
                    TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                Else
                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                End If
            ElseIf InStr(1, .deviceName, "/") <> 0 Then
                ' Vakuum Servers: some devices have a SLASH!
                If .ContextName = "" Then
                    TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                Else
                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                End If
            Else
                If .ContextName = "" Then
                    TmpDevName$ = .ServerName + "/" + .deviceName
                Else
                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/" + .deviceName
                End If
            End If
            ArchiveForm.ACOPData.deviceName = TmpDevName$
            ArchiveForm.ACOPData.deviceProperty = .PropName
            
            
            '' Get the total number of points in the interval
            'ArchiveForm.ACOPData.deviceName = .ServerName + "/" + .deviceName
            'If .ContextName <> "" Then
            '  ArchiveForm.ACOPData.deviceName = "/" + .ContextName + "/" + ArchiveForm.ACOPData.deviceName
            'End If
            
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
            If rcc& Then '= out_of_range% Then
'                ' Invalid device name - not registered (only a .NAM property?)
'                'MsgBox " error reading device name history for " + devProperty + ": " + RPCERROR(rcc&)
'                If .ContextName = "" Then
'                    TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'                Else
'                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'                End If
'                ArchiveForm.ACOPData.deviceName = TmpDevName$
'                rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
            End If
                             
            If rcc& Then
                iAnswer% = MsgBox(" Error Reading Total Points for " + .PropName + " from " + TmpDevName$ + ":  " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
                ArchData(0, index%).iVal = 0
                If iAnswer% = vbRetry Then
                    GoTo LaunchPointsLink
                ElseIf iAnswer% = vbAbort Then
                    ReadArchiveData = -10001
                    Exit Function
                Else
                    ' Ignore....
                End If
            End If
            tmpTotalPoints& = scratchTotalPoints.iVal
            .TotalPoints = tmpTotalPoints&
            
LaunchDataLink:
            ArchiveForm.ACOPData.deviceProperty = .PropName
            ArchiveForm.ACOPData.deviceName = TmpDevName$ '.ServerName + "/" + .deviceName
            'If .ContextName <> "" Then
            '  ArchiveForm.ACOPData.deviceName = "/" + .ContextName + "/" + ArchiveForm.ACOPData.deviceName
            'End If
            If .Acquire = True Then
                tStr = Left(UCase(.PropFormatStr), 4)
                If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
                    rcc& = ArchiveForm.ACOPData.Execute(ArchStringDataBuffer(0, index%).nam, MaxStrings, "NAME32I", TmpStartStop, 2)
                    ArchDataBuffer(0, index%).iVal = ArchStringDataBuffer(0, index%).iVal
                    useStringBuffer = True
                Else
                    rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, index%).fval, MaxGetDataPointsARCH, "FLTINT", TmpStartStop, 2)
                End If
                If rcc& Then
                  iAnswer% = MsgBox(" Error Reading Archived Data for " + .PropName + " from " + TmpDevName$ + ":  " + " " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
                  ArchData(0, index%).iVal = 0
                  If iAnswer% = vbRetry Then
                      GoTo LaunchDataLink
                  ElseIf iAnswer% = vbAbort Then
                      ReadArchiveData = -10001
                      Exit Function
                  Else
                      ' Ignore....
                  End If
                  nread = 0                                 'P.D  allow for the new way !
                Else
                  ArchiveForm.ACOPData.GetDataSize nread    'P.D  allow for the new way !
                  If useStringBuffer Then
                    makeLegacyArrays "ArchStringDataBuffer", index%, nread   'P.D  allow for the new way !
                    ArchDataBuffer(0, index%).iVal = ArchStringDataBuffer(0, index%).iVal
                  Else
                    makeLegacyArrays "ArchDataBuffer", index%, nread   'P.D  allow for the new way !
                  End If
                End If
            End If

            .NumPoints = nread
            kk% = 1
            For k% = 1 To ArchDataBuffer(0, index%).iVal
                If (nFilterKeywords = 0) Or (filerArchiveData(ArchDataBuffer(k%, index%).iVal) > 0) Then
                    If useStringBuffer Then
                        ArchData(kk%, index%).iVal = ArchStringDataBuffer(k%, index%).iVal
                    Else
                        ArchData(kk%, index%) = ArchDataBuffer(k%, index%)
                    End If
                    kk% = kk% + 1
                End If
            Next k%
            ArchData(0, index%).iVal = kk% - 1
        End If
        ReadArchiveData = rcc&
        ' .NumPoints = ArchDataBuffer(0, index%).iVal  ' < why is (was) this necessary ?
                
        If rcc& Then
        
        Else
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
    End If
End With
End Function

Public Sub ReadArrayData()
Dim i%, TmpDName$, tmpDefaultDName$, TmpPName$, rcc&, TmpStartStop&(3)
Dim tmpTS&, TmpSize&, tmpTSArray&(1), TempIndex%, TempDNameIndex%, tmpTimeOut&
Dim iAnswer%

If SelectedTrace%(0) < 0 Then SelectedTrace%(0) = 0

If ArchiveTS& <= 0 Then
    ArchiveTS& = ArchiveStart& + (ArchiveStop& - ArchiveStart&) / 2
End If

'LabelTime(0).Caption = ACOPPlot(0).CTIME(ArchiveTS&)

' Get the data from the SelectedTrace, at the selected Time-Stamp
TempDNameIndex% = IndexToDName%(SelectedTrace%(0))
TempIndex% = SelectedTrace%(0)

If FSlct(TempIndex%).PropSize = 1 Then
    MsgBox " Selected Property is NOT an array!"
    Exit Sub
End If

If ArchiveMode% = CArchivers Then
    
    TmpStartStop&(0) = ArchiveTS&
    TmpStartStop&(1) = ArchiveTS&
    
    With FSlct(TempIndex%)
        ' For TD, need also the SubIndex (the BUNCH)
        If UCase$(.VPlot) = "TD" Then
        '    TmpStartStop&(2) = NextSubi% ' the START INDEX of the "property"
        '    TmpStartStop&(3) = NTDBunches ' SAMPLE Interval
            
            TmpStartStop&(2) = 0 ' the START INDEX of the "property"
            TmpStartStop&(3) = 1 ' SAMPLE Interval
        Else
            TmpStartStop&(2) = 0 ' the START INDEX of the "property"
            TmpStartStop&(3) = 1 ' SAMPLE Interval
        End If
        
        TmpSize& = .PropSize
        
        TmpDName$ = .ServerName
        TmpPName$ = .PropName
    End With
    
    ReDim ArrayData!(TmpSize& - 1)
    ReDim PlotArrayData!(TmpSize& - 1)
    
    ArchiveForm.ACOPData.deviceName = TmpDName$
    ArchiveForm.ACOPData.deviceProperty = TmpPName$
    
    rcc& = ArchiveForm.ACOPData.Execute(ArrayData!(0), TmpSize&, "SINGLE", TmpStartStop&, 4)
    
Else
    ' What to read?
    ' Pump-ish data: data is stored with DeviceNumber #0 = only ONE Array
    ' Vibration Data - one array is stored for each DEVICE....
    
    With FSlct(TempIndex%)
        TmpPName$ = .PropName
        TmpSize& = .PropSize
        
        'If ChkDeviceInc.Value = vbChecked Then
        '    TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#1"
        'Else
        
            ' Better use the given device name if you can ......
            TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + .deviceName
            'TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#" + Format$(.DeviceIndex, "0")
            tmpDefaultDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#0"
        'End If
    End With
    
    ReDim ArrayData!(TmpSize& - 1)
    ReDim PlotArrayData!(TmpSize& - 1)
    
    TmpStartStop&(0) = ArchiveTS&
    TmpStartStop&(1) = TmpStartStop&(0)
    TmpStartStop&(2) = 0
    TmpStartStop&(3) = -1
    
    ' First try with "device index"?
    tmpTimeOut& = 1000
    ArchiveForm.ACOPData.deviceProperty = TmpPName$ + ".HIST"
    
    ArchiveForm.ACOPData.accessMode = "READ"
    'rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", ArchiveTS&, 1, "LONG")
    
ReadArrayAgain:
    ArchiveForm.ACOPData.deviceName = TmpDName$
    ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
    rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop&, 4, "LONG")

    If rcc& = 12 Or rcc& = 32 Then
        ' NOT ALLOCATED! Try with device zero....
        ArchiveForm.ACOPData.deviceName = tmpDefaultDName$
        rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop&, 4, "LONG")
    End If
    
    If rcc& Then
        iAnswer% = MsgBox(" Error Reading History Data for " + ArchiveForm.ACOPData.deviceProperty + " from " + ArchiveForm.ACOPData.deviceName + _
                        ":  " + RPCERROR(rcc&), vbAbortRetryIgnore, "Reading Histories")
        If iAnswer% = vbRetry Then
            tmpTimeOut& = tmpTimeOut& + 2000
            GoTo ReadArrayAgain
        ElseIf iAnswer% = vbAbort Then
            Exit Sub
        Else
        End If
    End If


'    With FSlct(TempIndex%)
'        TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#1"
'        ArchiveForm.ACOPData.deviceName = TmpDName$
'        ArchiveForm.ACOPData.deviceProperty = TmpPName$ + ".HIST"
'        ReDim ArrayINTData%(TmpSize& - 1)
'        rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop&, 4, "LONG")
'        'rcc& = ArchiveForm.ACOPData.Execute(ArrayINTData%, TmpSize&, "INTEGER", TmpStartStop&, 4, "LONG")
'    End With
End If

ArrayProp$ = TmpPName$
ArrayServerDevName$ = TmpDName$

If rcc& = 0 Then
    ArrayDataSize& = TmpSize&
Else
    ArrayDataSize = 0
    MsgBox "error! " + ArchiveForm.ACOPData.Status
End If
ArrayDataTimeStamp& = ArchiveForm.ACOPData.timestamp
ArrayDataKeyword$ = FSlct(TempIndex%).PropName

' compare the REQUESTED and the RETURNED time stamps...
Debug.Print ArchiveTS& - ArrayDataTimeStamp&, ArchiveForm.ACOPPlot(0).CTIME(ArchiveTS&), _
                    ArchiveForm.ACOPPlot(0).CTIME(ArrayDataTimeStamp&)

' Show difference in the stamps....
ArchiveForm.LabelTime(2).Caption = str$(ArrayDataTimeStamp& - ArchiveTS&)

' prepare axis for reference display.....
ReDim RefAxisData!(TmpSize&)
RefAxisData!(0) = -0.5
For i% = 1 To TmpSize&
    RefAxisData!(i%) = RefAxisData!(i% - 1) + 1
Next i%

End Sub

Public Sub PlotTheArrayData()
Dim rcc&
Dim i%, TmpSelectedIndex%, TempIndex%

ArchiveForm.ACOPPlot(2).ClearScreen

If ArrayPlotIndex& < 0 Then
    ArchiveForm.ACOPPlot(2).DisplayMode = SimpleHistogram
    ArchiveForm.ACOPPlot(2).DrawWidth = 2
    ArchiveForm.ACOPPlot(2).ClearScreen
    ArchiveForm.ACOPPlot(2).xmin = -0.5
    ArchiveForm.ACOPPlot(2).xmax = ArrayDataSize&
    If ArchiveForm.SyncZoom.Value = vbChecked Then
        ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
        ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
    Else
        ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
        ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
    End If
    ArrayPlotIndex& = ArchiveForm.ACOPPlot(2).Draw(PlotArrayData!, , , , ArrayDataSize&)
    'ArrayPlotIndex& = ArchiveForm.ACOPPlot(2).Draw(PlotArrayData!, ArrayXAxis!, , , ArrayDataSize&)
Else
    rcc& = ArchiveForm.ACOPPlot(2).RefreshScreen(PlotArrayData!, ArrayPlotIndex&, ArrayDataSize&)
End If

' Set markers on array plot?
TmpSelectedIndex% = SelectedTrace%(0)
TempIndex% = IndexToDName%(TmpSelectedIndex%)

ArchiveForm.ACOPPlot(2).Tagging = True
ArchiveForm.ACOPPlot(2).ClearTags
For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    If FSlct(i%).Active = True Then
        If (FSlct(TempIndex%).PropName = FSlct(i%).PropName) And (FSlct(TempIndex%).ServerName = FSlct(i%).ServerName) Then
            'Set a marker
            If FSlct(i%).DispColor = 0 Then
                ArchiveForm.ACOPPlot(2).TagColor = Gray
            Else
                ArchiveForm.ACOPPlot(2).TagColor = FSlct(i%).DispColor
            End If
            ArchiveForm.ACOPPlot(2).IsTagged FSlct(i%).DeviceIndex, True
        End If
    End If
Next i%

'ArrayDataTimeStamp& , ArrayDataKeyword$

ACOPCaptionText$(2) = FSlct(SelectedTrace%(0)).PropDesc ' ArrayDataKeyword$
ArchiveForm.ACOPPlot(2).ForeColor = vbBlack
ArchiveForm.ACOPPlot(2).Caption = ACOPCaptionText$(2) + " at " + ArchiveForm.ACOPPlot(2).CTIME(ArrayDataTimeStamp&)

ArchiveForm.ACOPPlot(2).YAxisLabel = FSlct(SelectedTrace%(0)).PropUnits

'ArchiveForm.ACOPPlot(2).ClearTags
'ArchiveForm.ACOPPlot(2).TagColor = vbGreen

If ArchiveForm.ChkAuto(0).Value = vbChecked Or ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
Else
    'ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
    'ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
End If

If ReferenceTS& = 0 Then
    ArchiveForm.LabelTime(1).Caption = "No Reference"
End If

Call DrawMarker

End Sub

Public Sub ScaleArrayData()
Dim ii%, Delta!, InvDelta!, ZeroOffset!, tmpFaktor!
Dim ScaleMax!, ScaleMin!, TempSize%
Dim TempIndex%, tmpCopyBytes&

TempIndex% = SelectedTrace%(0)
TempSize% = FSlct(TempIndex%).PropSize

Select Case ScalingMode%
Case AbsoluteScale:
        tmpCopyBytes& = TempSize% * 4
        Call MEMCPYL(PlotArrayData(0), ArrayData(0), tmpCopyBytes&)

Case RelativeScale:
        ' Need to scale the data consistent with MainPlot....
        ScaleMax! = FSlct(TempIndex%).PlotMaxValue
        ScaleMin! = FSlct(TempIndex%).PlotMinValue
                
        ' To scale the data properly....
        If FSlct(TempIndex%).VPlot = "LOG" Then
            If ScaleMin! <= 0 Then ScaleMin! = 0.01
            If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
            Delta! = (Log(ScaleMax!) - Log(ScaleMin!))
            If FSlct(TempIndex%).VMin = 0 Then FSlct(TempIndex%).VMin = 1E-20
            ZeroOffset! = Log(ScaleMin!)
        Else
            Delta! = ScaleMax! - ScaleMin!
            ZeroOffset! = ScaleMin!
        End If
        
        
        If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = 100 / Delta!
        ' Use the scale-factor in the form for the GRAPHICS!
        InvDelta! = InvDelta! * 1 'Val(ArchiveForm.Faktor(TempDNameIndex%).text)
                    
        ' Plotting "mode"
        If FSlct(TempIndex%).VPlot = "LOG" Then
            For ii% = 0 To TempSize% - 1
                If ArrayData!(ii%) > 0 Then
                    PlotArrayData!(ii%) = (Log(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
                Else
                    PlotArrayData!(ii%) = 0
                End If
            Next ii%
        ElseIf FSlct(TempIndex%).VPlot = "ABS" Then
            For ii% = 0 To TempSize% - 1
                PlotArrayData!(ii%) = (Abs(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
            Next ii%
        ElseIf FSlct(TempIndex%).VPlot = "SLOG" Then
            tmpFaktor! = 1
            For ii% = 0 To TempSize% - 1
                If PlotArrayData!(ii%) > 0 Then
                    ii% = ii%
                End If
                PlotArrayData!(ii%) = (ArrayData!(ii%) * tmpFaktor! - ZeroOffset!) * InvDelta!
            Next ii%
        Else
            For ii% = 0 To TempSize% - 1
               PlotArrayData!(ii%) = (ArrayData!(ii%) - ZeroOffset!) * InvDelta!
            Next ii%
        End If
End Select

End Sub

Public Sub DoTheArrayData()

' Is it necessary to do anything?
If SelectedTrace%(ActivePlot%) = -1 Then Exit Sub
If FSlct(SelectedTrace%(ActivePlot%)).PropSize < 2 Then Exit Sub

Call ReadArrayData
Call ScaleArrayData
Call PlotTheArrayData

End Sub

Function HistoryConfigLoad(filename$) As Integer
Dim col_Context%, col_Server%, col_Property%, col_DeviceName%, col_Desc%
Dim col_Units%, col_PlotMin%, col_PlotMax%, tmpDeviceName$
'Dim filename$
Dim i%, a$, p%, tok$, nparam%, type_done, rc%
Dim tmpPrpQueryEx As PropertyQueryEx, TmpDName$, TmpValStr$

Dim col_ArchData%, col_ArchHistory%, col_ArchProperty%

type_done = False
'filename$ = App.Path + "\HistoryConfig.csv" 'fname$
If Dir(filename$) = "" Then
  HistoryConfigLoad = 0
  Exit Function
End If
'Name, Context, Server, Property, DeviceName, Description, Units, PlotMin, PlotMax

Open filename$ For Input Access Read Shared As #1
nparam% = 8
i% = 0: p% = nparam%
Do
    Line Input #1, a$
    tok$ = Left$(a$, 1)
    If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
        If Not type_done Then
            col_Context% = colptr(a$, "Context")
            col_Server% = colptr(a$, "Server")
            col_Property% = colptr(a$, "Property")
            col_DeviceName% = colptr(a$, "DeviceName")
            col_Desc% = colptr(a$, "Description")
            col_Units% = colptr(a$, "Units")
            col_PlotMin% = colptr(a$, "PlotMin")
            col_PlotMax% = colptr(a$, "PlotMax")
            
'col_ArchData%, col_ArchHistory%, col_ArchProperty%
            
            col_ArchData% = colptr(a$, "ArchiveDataServer")
            col_ArchHistory% = colptr(a$, "ArchiveHistoryServer")
            col_ArchProperty% = colptr(a$, "ArchiveProperty")
            type_done = True
        Else
            With CSVPropInfo(i%)
                .ContextName = Trim(getcol(a$, col_Context%))
                .ServerName = Trim(getcol(a$, col_Server%))
                .prpName = Trim(getcol(a$, col_Property%))
                tmpDeviceName$ = Trim((getcol(a$, col_DeviceName%)))
                
                tmpDeviceName$ = Trim((getcol(a$, col_DeviceName%)))
                'If .deviceName <> "" Then .devIndex = Val(Right$(.deviceName, Len(.deviceName) - 1))
                If tmpDeviceName$ = "" Then
                    .deviceName = "#0"
                ElseIf str$(Val(tmpDeviceName$)) = .deviceName Then
                    ' Check if just a number....
                    .deviceName = "#" + Format$(tmpDeviceName$, "0")
                Else
                    .deviceName = tmpDeviceName$
                End If
                
                ' WHY DO THIS HERE???? _ takes so long....
                
                ' Get the "default data" for this property....
                TmpDName$ = "/" + .ContextName + "/" + .ServerName
                'rc% = GetPropertyInformationEx(TmpDName$, .prpName, tmpPrpQueryEx)
                
                .PropDesc = Trim(getcol(a$, col_Desc%))
                If .PropDesc = "" Then .PropDesc = BSTR$(tmpPrpQueryEx.prpDesc)
                
                .PropUnits = Trim(getcol(a$, col_Units%))
                If .PropUnits = "" Then .PropUnits = BSTR$(tmpPrpQueryEx.prpUnits)
                
                TmpValStr$ = Trim(getcol(a$, col_PlotMin%))
                If TmpValStr$ = "" Then .PropMin = tmpPrpQueryEx.prpMinValue Else _
                                        .PropMin = Val(TmpValStr$)
                
                TmpValStr$ = Trim(getcol(a$, col_PlotMax%))
                If TmpValStr$ = "" Then .PropMax = tmpPrpQueryEx.prpMaxValue Else _
                                        .PropMax = Val(TmpValStr$)
            
                .PropSize = tmpPrpQueryEx.prpSize
            
                ' Is there and archive server?
                If col_ArchData% > -1 Then
                    .ArchiveDataServer = Trim(getcol(a$, col_ArchData%))
                    .ArchiveHistoryServer = Trim(getcol(a$, col_ArchHistory%))
                    .ArchiveProperty = Trim(getcol(a$, col_ArchProperty%))
                Else
                    .ArchiveDataServer = ""
                    .ArchiveHistoryServer = ""
                    .ArchiveProperty = ""
                End If
            End With
            i% = i% + 1
      End If
    End If
Loop While Not EOF(1)
Close 1

HistoryConfigLoad = i%
Close 1

End Function



Public Function ScaleForBits(index%, StatusValue&) As Single
Dim tmpMask&, tmpFaktor!, tmpValue!

' Convert statusvalue to LONG and THEN do bist-mask/scaling?
tmpFaktor! = 1
tmpMask& = SelectBits&(FSlct(index%).DeviceSubIndex - 1)

tmpValue! = 2 * index% + (StatusValue& And tmpMask&) / tmpMask&

ScaleForBits! = tmpValue!
End Function
