// =============================================================
// ==
// ==   Dataserver routine: herastatebase.c
// ==
// =============================================================
#include "prolog.h"
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <malloc.h>
#include <ctype.h>
#include <signal.h>
#include <dirent.h>
#include "fecerr.h"
#include "rpctypes.h"
#include "database.h"
#include "almsrv.h"
#include "errors.h"
#include "archive.h"
#include "toolkit.h"

extern FEC *fec;

// important initialization:
int iHPenergy;
double HPCur = -1,HPTau = -1,HECur = -1,HETau = -1;
float fminus = -1;
float *HPenergy = &fminus,*HEenergy = &fminus;
float dccur = -1;
float energy = -1;

// state variables:
extern int ramping, running, beam, lumi;
extern int Pramping, Eramping, Pbeam, Ebeam;
extern int Prunning, Erunning;
extern int DclEramping, DclPramping, DclLumi;
extern int DclEInj, DclPInj; 

void updateStateInfo(int i, int j,int cc)
{
  static int lastPEnergy;
  static float lastEEnergy;
  static int DCpanic = 0; // monitor curcial parameters  
  static int Epanic = 0;
  float *fptr;
  int k;
  
  if (!strcmp(fec[i].fecdata[j].param,"DoDCCur"))
  {
    dccur = *(float *)(fec[i].data+fec[i].fecdata[j].offset);
    if (cc)            // there's something wrong
    {
      if (++DCpanic > 3)
      {
        dccur = -1;
        SetAlarm("FILER",0,current_undefined,NULL);
      }
    }
    else DCpanic = 0;
    beam = dccur > 1 ? -1 : 0;
    goto fixstate;
  }
  if (!strcmp(fec[i].fecdata[j].param,"DoEnergy"))
  {
    energy = *(float *)(fec[i].data+fec[i].fecdata[j].offset);
    if (cc)            // there's something wrong
    {
      if (++Epanic > 3)
      {
        energy = -1;
        SetAlarm("FILER",0,energy_undefined,NULL);
      }
    }
    else               // everything's okay
    {
      if (abs(energy - lastPEnergy) > 1)
      {
        ramping = (int)(energy - lastPEnergy);
        lastPEnergy = energy;
      }
      else ramping = 0;
      Epanic = 0;
      ClearAlarm("FILER",0);            
    }
    running =  energy > 1 ? 1 : 0;
    goto fixstate;
  }
fixstate:
}

int overloadEqpmod(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int cc, i, j, n;
  char prop[32], *c;
  short stateArray[7];
  short dsize,EqNo = 0,fmt;                                                     

  return illegal_property;
}
extern void cbackBrdsrv(int id,int cc);
int GlobalsRegistrationEx(void)
{
  DTYPE din;   
  // for historical reasons:
}

