# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI,OSF CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

INCL = /usr/include/tine
LIBS = /usr/lib
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h

CC = g++ -c -g -I${INCL}
CC = cc -c -g -I${INCL}
CCL = cc -g
LM = -lm

rpcserv: rpcserv-archiver.o herastatebase.o filer.o archbase.o archlib.o ${LIBS}/libtinexg.a
	${CCL} -o rpcserv rpcserv-archiver.o herastatebase.o filer.o archbase.o archlib.o ${LIBS}/libtinexg.a ${LM}
	chmod a+s rpcserv

rpcserv-archiver.o: rpcserv-archiver.c ${HDRS}
	${CC} rpcserv-archiver.c

herastatebase.o: herastatebase.c archive.h fecdef.h ${HDRS}
	${CC} herastatebase.c 

filer.o: filer.c archive.h fecdef.h ${HDRS}
	${CC} filer.c 

archbase.o: archbase.c archive.h fecdef.h ${HDRS}
	${CC} archbase.c 

archlib.o: archlib.c archive.h fecdef.h ${HDRS}
	${CC} archlib.c 

clean:
	rm *.o
