#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <sys/types.h>
#include "servdef.h"
#include "rpctypes.h"
#include "archive.h"
#include "unixcmd.h"

extern SRVINFO srvinfo;
int getStartupInfo(void);
void PostSystemInit(void);
extern int g_isTerminating;

int main(int argc, char *argv[])
{
  int cc;
  switch (argc)                           /* initial debug level */
  {           /* on UNIX or DOS stations: set debug = 1 (2,or 3) */
    case 2:              /* will dynamically set the debug level */
      NGdebug = atoi(argv[1]);
      break;
    default:
      NGdebug = 0;                              /* default level */
  }
  printf("Server running (debug level %d)\n",NGdebug);

  if (getStartupInfo()) exit(2);
  
  RegisterFecNameEx(srvinfo.name,"[MEX]Data Server/Archiver","Linux","Bldg 30 Rm 103","none","P.Duval",srvinfo.port,"HERA");
  
  MaxNumContracts = 1000; // lot's of room for the Machine parameter page
  MaxNumClients = 200;
  MaxNumConnections = 400;
  ListenForMCasts = 0;
  MaxRPCTransportSize = MAX_TRANSPORTSIZE*2;
  /* init RPC server: */
  if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",erlst[cc]); exit(1); }

  /* call FEC specific initialization: */
  PostSystemInit();

  for(;;)
  {
    if (g_isTerminating) quit(NULL,NULL);
    SystemCycle(TRUE);
  }
  return 0;
}
