// =============================================================
// ==
// ==   Dataserver routine: ttfstatebase.c
// ==
// =============================================================
#include "prolog.h"
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <malloc.h>
#include <ctype.h>
#include <signal.h>
#include <dirent.h>
#include "fecerr.h"
#include "fecdef.h"
#include "rpctypes.h"
#include "database.h"
#include "almsrv.h"
#include "errors.h"
#include "archive.h"
#include "toolkit.h"

extern FEC *fec;

// important initialization:
float TTFenergy = -1, TTFcurrent = -1;

// state variables:
extern int ramping, running, beam;
extern int DclRun;

void updateStateInfo(int i, int j,int cc)
{
  static float lastEnergy, lastCurrent;
  static int Epanic = 0, Cpanic = 0,STpanic = 0; // monitor curcial parameters
  
  if (!strcmp(fec[i].fecdata[j].param,"TTFENERGY"))
  {
    TTFenergy = *(float *)(fec[i].data+fec[i].fecdata[j].offset);
    if (cc)            // there's something wrong
    {
      if (++Epanic > 3)
      {
        TTFenergy = -1;
        SetAlarm("FILER",0,energy_undefined,NULL);
      }
    }
    else               // everything's okay
    {
      Epanic = 0;
      running =  TTFenergy > 2 ? 1 : 0;
    }
    return;
  }
  if (!strcmp(fec[i].fecdata[j].param,"TTFCURRENT"))
  {
    TTFcurrent = *(float *)(fec[i].data+fec[i].fecdata[j].offset);
    if (cc)            // there's something wrong
    {
      if (++Cpanic > 3)
      {
        TTFcurrent = -1;
        SetAlarm("FILER",0,current_undefined,NULL);
      }
    }
    else               // everything's okay
    {
      Cpanic = 0;
      beam =  TTFcurrent > 0.1 ? 1 : 0;
    }
    return;
  }
  if (!strcmp(fec[i].fecdata[j].param,"TTFSTATE"))
  {
    if (cc)
    {
      if (++STpanic > 3)
      {
        DclRun = 0;
        SetAlarm("FILER",0,state_undefined,NULL);
      }
    }
    else
    {
      STpanic = 0;
      DclRun = !strcmp("Run Active",fec[i].data+fec[i].fecdata[j].offset);
    }
    return;
  }
}


