Attribute VB_Name = "Apis"
Option Explicit




Public Const MAX_PATH = 260

Public Const PROCESS_TERMINATE As Long = 1
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const SYNCHRONIZE = &H100000
Public Const PROCESS_VM_READ = &H10
Public Const PROCESS_QUERY_INFORMATION = &H400
Public Const PROCESS_ALL_ACCESS As Long = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &HFFF
Public Const TH32CS_SNAPPROCESS As Long = 2&

Public Const GW_HWNDFIRST = 0
Public Const GW_HWNDLAST = 1
Public Const GW_HWNDNEXT = 2
Public Const GW_HWNDPREV = 3
Public Const GW_OWNER = 4
Public Const GW_CHILD = 5
Public Const GW_MAX = 5
Public Const GWL_STYLE = (-16)
Public Const WS_VISIBLE = &H10000000
Public Const WS_BORDER = &H800000

Public Const SW_SHOWNORMAL = 1
Public Const SW_SHOWMINIMIZED = 2

Public Const SRCCOPY = &HCC0020

Public Const BI_RGB As Long = 0
Public Const DIB_RGB_COLORS As Long = 0


Public Type T_PROCESSENTRY32
  dwSize As Long
  cntUsage As Long
  th32ProcessID As Long
  th32DefaultHeapID As Long
  th32ModuleID As Long
  cntThreads As Long
  th32ParentProcessID As Long
  pcPriClassBase As Long
  dwFlags As Long
  szExeFile As String * MAX_PATH
End Type

Public Type T_RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Type T_POINTAPI
  x As Long
  y As Long
End Type

Public Type T_WINDOWPLACEMENT
  Length As Long
  flags As Long
  showCmd As Long
  ptMinPosition As T_POINTAPI
  ptMaxPosition As T_POINTAPI
  rcNormalPosition As T_RECT
End Type

Public Type T_BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type T_RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Public Type T_BITMAPINFO
    bmiHeader As T_BITMAPINFOHEADER
    bmiColors As T_RGBQUAD
End Type

Public Declare Function EnumProcesses Lib "PSAPI.DLL" _
                            (idProcess As Long, ByVal cBytes As Long, cbNeeded As Long) As Long
Public Declare Function EnumProcessModules Lib "PSAPI.DLL" _
                            (ByVal hProcess As Long, hModule As Long, ByVal cb As Long, _
                             cbNeeded As Long) As Long
Public Declare Function GetModuleFileNameEx Lib "PSAPI.DLL" Alias "GetModuleFileNameExA" _
                            (ByVal hProcess As Long, ByVal hModule As Long, _
                             ByVal lpFileName As String, ByVal nSize As Long) As Long
Public Declare Function OpenProcess Lib "kernel32.dll" _
                            (ByVal dwAccess As Long, ByVal bInherit As Long, _
                             ByVal dwProcessId As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function CreateToolhelp32Snapshot Lib "kernel32" _
                            (ByVal lFlags As Long, ByVal lProcessID As Long) As Long
Public Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" _
                            (ByVal hSnapShot As Long, uProcess As T_PROCESSENTRY32) As Long
Public Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" _
                            (ByVal hSnapShot As Long, uProcess As T_PROCESSENTRY32) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function GetWindow Lib "user32" _
                            (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
                            (ByVal hwnd As Long, ByVal wIndx As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" _
                            (ByVal hwnd As Long) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" _
                            (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetWindowThreadProcessId Lib "user32" _
                            (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Public Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, lpRect As T_RECT) As Long
Public Declare Function GetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As T_WINDOWPLACEMENT) As Long
Public Declare Function SetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As T_WINDOWPLACEMENT) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function BringWindowToTop Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, _
  ByVal xDest As Long, ByVal yDest As Long, ByVal nDestWidth As Long, ByVal nDestHeight As Long, _
  ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, _
  lpBits As Any, lpBitsInfo As T_BITMAPINFO, ByVal iUsage As Long, ByVal dwRop As Long) As Long


Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc _
        As Long, ByVal x As Long, ByVal y As Long, ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, _
        ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long


Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hdc As Long, pBitmapInfo As T_BITMAPINFO, _
                                                   ByVal un As Long, ByVal lplpVoid As Long, _
                                                   ByVal handle As Long, ByVal dw As Long) As Long
Public Declare Function GetDIBits Lib "gdi32.dll" (ByVal aHDC As Long, ByVal hBitmap As Long, _
                                                   ByVal nStartScan As Long, ByVal nNumScans As Long, _
                                                   lpBits As Any, lpBI As T_BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As _
        Long, ByVal srcRectWidth As Long, ByVal srcRectHeight As Long, ByVal srcX As Long, ByVal srcY As Long, ByVal firstScanLineInArray As _
        Long, ByVal numberOfscanLines As Long, BitsArray As Any, BitsInfo As T_BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal xDest As Long, ByVal yDest As Long, ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function GetLastError Lib "kernel32.dll" () As Long


