Attribute VB_Name = "NETWORKINFO"

Option Explicit
      
Private Declare Function WSAGetLastError Lib "WSOCK32.DLL" () _
        As Long
        
Private Declare Function WSAStartup Lib "WSOCK32.DLL" (ByVal _
        wVersionRequired As Long, lpWSAData As WinSocketDataType) _
        As Long
        
Private Declare Function WSACleanup Lib "WSOCK32.DLL" () _
        As Long
        
Private Declare Function gethostname Lib "WSOCK32.DLL" (ByVal _
        hostName As String, ByVal HostLen As Integer) As Long
        
Private Declare Function gethostbyname Lib "WSOCK32.DLL" _
        (ByVal hostName As String) As Long
        
Private Declare Function gethostbyaddr Lib "WSOCK32.DLL" _
        (ByVal addr As String, ByVal laenge As Integer, _
        ByVal typ As Integer) As Long
        
Private Declare Sub RtlMoveMemory Lib "kernel32" (hpvDest As _
        Any, ByVal hpvSource As Long, ByVal cbCopy As Long)
       
Private Type HostDeType
    hName As Long
    hAliases As Long
    hAddrType As Integer
    hLength As Integer
    hAddrList As Long
End Type

Const WS_VERSION_REQD As Long = &H101&
Const MIN_SOCKETS_REQD As Long = 1&
Const SOCKET_ERROR As Long = -1&
Const WSADescription_Len As Long = 256&
Const WSASYS_Status_Len As Long = 128&

Private Type WinSocketDataType
    wversion As Integer
    wHighVersion As Integer
    szDescription(0 To WSADescription_Len) As Byte
    szSystemStatus(0 To WSASYS_Status_Len) As Byte
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpszVendorInfo As Long
End Type

Public Sub GetNetInfo(ip As String, hostName As String)
    
    Call InitSocketAPI
    hostName = MyHostName()
    ip = HostByName(hostName, 0)
    Call CleanSockets
    
End Sub

Private Sub InitSocketAPI()
    Dim Result As Integer
    Dim SocketData As WinSocketDataType
  
    Result = WSAStartup(WS_VERSION_REQD, SocketData)
    If Result <> 0 Then
        Call MsgBox("'winsock.dll' antwortet nicht !")
        End
    End If
End Sub

Private Function MyHostName() As String
    Dim hostName As String * 256
  
    If gethostname(hostName, 256) = SOCKET_ERROR Then
        MsgBox "Windows Sockets error " & Str(WSAGetLastError())
        Exit Function
    Else
        MyHostName = NextChar(Trim$(hostName), Chr$(0))
    End If
End Function

Private Function HostByName(Name As String, Optional x As Integer = _
0) As String
    Dim MemIp() As Byte
    Dim y As Integer
    Dim HostDeAddress As Long, HostIp As Long
    Dim IpAddress As String
    Dim host As HostDeType
  
    HostDeAddress = gethostbyname(Name)
    If HostDeAddress = 0 Then
        HostByName = ""
        Exit Function
    End If
    
    Call RtlMoveMemory(host, HostDeAddress, LenB(host))
    
    For y = 0 To x
        Call RtlMoveMemory(HostIp, host.hAddrList + 4 * y, 4)
        If HostIp = 0 Then
            HostByName = ""
            Exit Function
        End If
    Next y
    
    ReDim MemIp(1 To host.hLength)
    Call RtlMoveMemory(MemIp(1), HostIp, host.hLength)
    
    IpAddress = ""
    
    For y = 1 To host.hLength
        IpAddress = IpAddress & MemIp(y) & "."
    Next y
    
    IpAddress = Left$(IpAddress, Len(IpAddress) - 1)
    HostByName = IpAddress
End Function

Private Sub CleanSockets()
    Dim Result As Long
    
    Result = WSACleanup()
    If Result <> 0 Then
        Call MsgBox("Socket Error " & Trim$(Str$(Result)) & _
                      " in Prozedur 'CleanSockets' aufgetreten !")
        
        End
    End If
End Sub

Private Function NextChar(Text As String, Char As String) As String
    Dim pos As Integer
    
    pos = InStr(1, Text, Char)
    If pos = 0 Then
        NextChar = Text
        Text = ""
    Else
        NextChar = Left$(Text, pos - 1)
        Text = Mid$(Text, pos + Len(Char))
    End If
End Function




