Attribute VB_Name = "tine"
'/** \file tine.bas
' *  \brief TINE Client and Server API Calls for Visual Basic
' *
' */
'        Global constants of general use
'        Version 18.04.01,swh:  fill in struct types

Global Const CF_DOUBLE = 512
Global Const CF_INTEGER = 513
Global Const CF_SHORT = 513
Global Const CF_BYTE = 514
Global Const CF_LONG = 515
Global Const CF_TEXT = 516
Global Const CF_FLOAT = 517
Global Const CF_POCALBLK = 518
Global Const CF_STRUCT = 519
Global Const CF_CHAR8 = 520
Global Const CF_STRING8 = 520
Global Const CF_NAME8 = 520
Global Const CF_CHAR16 = 521
Global Const CF_STRING16 = 521
Global Const CF_NAME16 = 521
Global Const CF_CHAR16FI = 522
Global Const CF_BIT = 523
Global Const CF_HITTS = 524
Global Const CF_CHAR32 = 525
Global Const CF_STRING32 = 525
Global Const CF_NAME32 = 525
Global Const CF_FI = 526
Global Const CF_FLTINT = 526
Global Const CF_II = 527
Global Const CF_LI = 527
Global Const CF_LL = 527
Global Const CF_INTINT = 527
Global Const CF_LNGINT = 527
Global Const CF_DI = 528
Global Const CF_DBLINT = 528
Global Const CF_SI = 529
Global Const CF_SHTINT = 529
Global Const CF_TDS = 530
Global Const CF_IFI = 530
Global Const CF_CHAR48 = 531
Global Const CF_NAME48 = 531
Global Const CF_STRING48 = 531
Global Const CF_CHAR8I = 532
Global Const CF_NAME8I = 532
Global Const CF_CHAR16I = 533
Global Const CF_NAME16I = 533
Global Const CF_CHAR32I = 534
Global Const CF_NAME32I = 534
Global Const CF_CHAR48I = 535
Global Const CF_NAME48I = 535

Global Const CF_USTRING = 536
Global Const CF_XYS = 537
Global Const CF_FFI = 537
Global Const CF_FLTFLTINT = 537
Global Const CF_FLTINTINT = 538
Global Const CF_FILTER = 539
Global Const CF_IFFF = 539
Global Const CF_INTFLTFLTFLT = 539
Global Const CF_SPECTRUM = 540

Global Const CF_ADDRESS = 541
Global Const CF_IIII = 541
Global Const CF_INTINTINTINT = 541
Global Const CF_WINDOW = 542
Global Const CF_TTII = 542
Global Const CF_POINT = 543
Global Const CF_FF = 543
Global Const CF_XY = 543
Global Const CF_FLTFLT = 543
Global Const CF_TDSI = 544
Global Const CF_INTFLTSHTSHT = 544
Global Const CF_BOOLEAN = 545
Global Const CF_IIFF = 546
Global Const CF_INTINTFLTFLT = 546
Global Const CF_FIFI = 547
Global Const CF_FLTINTFLTINT = 547
Global Const CF_NAME64 = 548
Global Const CF_CHAR64 = 548
Global Const CF_STRING64 = 548
Global Const CF_NAME64I = 549
Global Const CF_CHAR64I = 549
Global Const CF_STRING64I = 549
Global Const CF_INTDBL = 550
Global Const CF_LNGDBL = 550
Global Const CF_FLTDBL = 551
Global Const CF_DBLDBL = 552

Global Const CF_DEFAULT = 766
Global Const CF_NULL = 767

Global Const CM_CANCEL = 0
Global Const CM_SINGLE = 1
Global Const CM_REFRESH = 2
Global Const CM_POLL = 3
Global Const CM_REGISTER = 4
Global Const CM_BCAST = &H100
Global Const CM_MCAST = &H200
Global Const CM_NETWORK = &H200
Global Const CM_USE_ON_ERROR = &H400
Global Const CM_GROUPED = &H1000
Global Const CM_CONNECT = &H2000
Global Const CM_WAIT = &H4000
Global Const CM_SYNCNOTIFY = &H8000

Global Const ACCESS_LOCK_UNLOCKED = 0
Global Const ACCESS_LOCK_PREEMPTIVE = 1
Global Const ACCESS_LOCK_PERSISTENT = 2
Global Const ACCESS_LOCK_ABORT = 3

Enum AccessLockTypes
  AccessUnlocked = ACCESS_LOCK_UNLOCKED
  AccessPreemptive = ACCESS_LOCK_PREEMPTIVE
  AccessPersistent = ACCESS_LOCK_PERSISTENT
  AccessAbort = ACCESS_LOCK_ABORT
End Enum

Type FLTINT
 fval As Single
 iVal As Long
End Type

Type FLTDBL
 fval As Single
 dval As Double
End Type

Type INTINT
 i1val As Long
 i2val As Long
End Type

Type SHTINT
 sval As Integer
 iVal As Long
End Type

Type LNGINT
 lval As Long
 iVal As Long
End Type

Type INTDBL
 iVal As Long
 dval As Double
End Type

Type DBLINT
 dval As Double
 iVal As Long
End Type

Type DBLDBL
 d1val As Double
 d2val As Double
End Type

Type FLTFLTINT
  f1val As Single
  f2val As Single
  iVal As Long
End Type

Type FLTINTINT
  fval As Single
  i1val As Long
  i2val As Long
End Type

Type INTINTINTINT
  i1val As Long
  i2val As Long
  i3val As Long
  i4val As Long
End Type

Type INTFLTFLTFLT
  iVal As Long
  f1val As Single
  f2val As Single
  f3val As Single
End Type

Type INTINTFLTFLT
 i1val As Long
 i2val As Long
 f1val As Single
 f2val As Single
End Type

Type FLTINTFLTINT
 f1val As Single
 i1val As Long
 f2val As Single
 i2val As Long
End Type

Type NAME8
  nam(7) As Byte
End Type

Type NAME16
  nam(15) As Byte
End Type

Type NAME16I
  nam(15) As Byte
  iVal As Long
End Type

Type NAME32
  nam(31) As Byte
End Type

Type NAME48
  nam(47) As Byte
End Type

Type NAME64
  nam(63) As Byte
End Type

Type NAME32I
  nam(31) As Byte
  iVal As Long
End Type

Type NAME48I
  nam(47) As Byte
  iVal As Long
End Type

Type NAME64I
  nam(63) As Byte
  iVal As Long
End Type

Type NAMEFI
  nam(15) As Byte
  fval As Single
  iVal As Long
End Type

Type NAME16FI
  nam(15) As Byte
  fval As Single
  iVal As Long
End Type

Type CHAR16FI
  nam(15) As Byte
  f As Single
  i As Long
End Type

Type FSTRUCT
  date As Integer
  time As Integer
  fname(7) As Byte
End Type

Type TDS
  tval As Long
  dval As Single
  sval As Long
End Type

Type USTRING
  iVal As Long
  f1val As Single
  f2val As Single
  ts As Long
  str(79) As Byte
End Type

Type DSPECTRUM
  str(79) As Byte
  ts As Long
  start As Single
  inc As Single
  Status As Long
  spectrum(4095) As Single
End Type

Declare Function SetAcopQueueDepth Lib "acop.ocx" (ByVal QueueDepth%) As Integer

'
' | converts Byte array to UNICODE string and vice versa |

Declare Sub Bytes2String Lib "utils32.dll" (ByVal s$, byteArray As Byte, ByVal numBytes%)
Declare Sub String2Bytes Lib "utils32.dll" (byteArray As Byte, ByVal s$, ByVal numBytes%)


'
'         network routines for data acquisition

Type rpctext
  text As String * 80
End Type
Dim netuser As String * 16

'/**
' * \struct DBLK
' * \brief DBLK defines a TINE data object for Visual Basic calls
' *
' * - dArrayLength is the size of the data set in terms of the format size specified.
' * - dFormat is the TINE format of the data set
' * - dTag is an optional data tag used typically to identify user-defined structures
' * Note that this is held as a byte array (in order to avoid problems with embedded
' * unicode versus ascii.  This means that the translation routines BSTR() (returns a
' * string from a byte array) and BARR() (makes a byte array from a string) should be
' * used when working directly with this field.
' *
' * DBLK is used in certain calls where the data arrays are to be passed by reference
' * as a separate parameter in the calling routine
' *
' * \see T_EXECLINK(), T_OPENLINK(), DTYPE
' */
Type DBLK
  dArrayLength As Long
  dFormat As Integer
  Reserved As Integer
  dTag(7) As Byte
End Type

'/**
' * \struct DTYPE
' * \brief DTYPE defines a TINE data object
' *
' * - dArrayLength is the size of the data set in terms of the format size specified.
' * - dFormat is the TINE format of the data set.
' * - dTag is an optional data tag used typically to identify user-defined structures.
' * Note that this is held as a byte array (in order to avoid problems with embedded
' * unicode versus ascii.  This means that the translation routines BSTR() (returns a
' * string from a byte array) and BARR() (makes a byte array from a string) should be
' * used when working directly with this field.
' * - ddata is a reference to the data set.  This need to be a pointer, so you will need
' * to apply the CADDR() routine to your Visual Basic array.
' *
' *
' * DTYPE is used in certain calls where the pointer address of the data array
' * is passed within this structure
' *
' * \see T_ATTACHLINK(), DBLK
' */
Type DTYPE
  dArrayLength As Long
  dFormat As Integer
  Reserved As Integer
  dTag(15) As Byte
  ddata As Long
End Type

Declare Function RPCAssignBufferSpace Lib "tinecln32.dll" (ByVal rcvBufferSizeInBytes As Long) As Integer

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''    Direct inteface routines: (But use ACOP if you can)  ''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'/**
' * \brief executes a synchronous link
' *
' * Synchronous data exchange. T_EXECLINK() does not complete until the data transfer has completed or
' * a timeout has ensued.
' *
' * \param devName is the full device name (/\<Context\>/\<Server\>/\<Device\>) of the device to contact.
' * For example: "/HERA/BPM/WL167".
' * \param devProperty is the device property requested, for example "ORBIT.X"
' * \param dout is a reference to the output data block, that is, the data set to be returned from the server
' * to the client. The associated data are returned in the 'dataout' parameter.
' * \param dataout is a reference to the data array or variable to receive the returned data.  If no data are
' * requested in the call, then a '0' should be passed, and the dArraySize field in 'dout' should be set to '0'.
' * \param din is a reference to the input data block, that is, the data set to be sent to the server from the
' * client. The associated data to be sent should be contained in the 'datain' parameter.
' * \param dindata is a reference to the data array or variable to be sent.  If no data are to be sent
' * in the call, then a '0' should be passed, and the dArraySize field in 'din' should be set to '0'.
' * \param devAccess is the data access mode.  A client can set either CA_READ and/or CA_WRITE access.
' * \param devTimeout is the allowed timeout in milliseconds for the call to complete
' *
' * \see DBLK
' *
' */
Declare Function T_EXECLINK Lib "tinecln32.dll" (ByVal devName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal devAccess As Integer, ByVal devTimeout As Long) As Integer
Declare Function T_OPENLINK Lib "tinecln32.dll" (ByVal hWnd As Long, ByVal devName As String, ByVal devprop As String, dout As DBLK, din As DBLK, datain As Any, ByVal acc As Integer, ByVal timer As Long, ByVal mode As Integer) As Integer
Declare Function EXECLINKEx Lib "tinecln32.dll" (ByVal devName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal devAccess As Integer, ByVal devTimeout As Long) As Integer
Declare Function EXECLINK Lib "tinecln32.dll" (ByVal devName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal devAccess As Integer) As Integer

'/**
' * \brief established an asynchronous link
' *
' * Synchronous data exchange. T_ATTACHLINK() will establish a data link to the designated
' * server if possible and return a positive link handle if successful.  When data are
' * tranfered over the link, the designated callback routine will be called.
' *
' * \param devName is the full device name (/\<Context\>/\<Server\>/\<Device\>) of the device to contact.
' * For example: "/HERA/BPM/WL167".
' * \param devProperty is the device property requested, for example "ORBIT.X"
' * \param dout is a reference to the output DTYPE object, that is, the data set to be returned from the server
' * to the client. The associated data are returned in array referenced by the ddata field.
' * \param din is a reference to the input DTYPE object, that is, the data set to be sent to the server from the
' * client. The associated data to be sent should be referenced by the ddata field.
' * \param devAccess is the data access mode.  A client can set either CA_READ and/or CA_WRITE access.
' * \param timer is the polling rate in milliseconds to be registered with the server.
' * \param callback is the callback routine to be called when new data arrive
' * \param accessMode is the data access mode: one of CM_SINGLE (once), CM_REFRESH (on change),
' * CM_POLL (on timer) in combination with any access mode flags (e.g. CM_CONNECT, CM_NETWORK, etc.)
' *
' * \note In assigning references to a DTYPE object, you will have to use the CADDR() to retreive
' * the reference to the Visual Basic array.  In passing a callback routine, you will have to
' * use the AddressOf function on a Visual Basic Sub which can only be found within a .bas Module.
' * Also note that it is very difficult to debug a callback routine.  Do NOT put a break point
' * inside this Sub in design mode, as Visual Basic will hang!
' *
' *
' * \see DTYPE, CADDR()
' *
' */
Declare Function T_ATTACHLINK Lib "tinecln32.dll" ( _
  ByVal devName As String, ByVal devProperty As String, dout As DTYPE, din As DTYPE, _
  ByVal devAccess As Integer, ByVal timer As Long, ByVal callback As Any, ByVal accessMode As Integer _
  ) As Integer

'
' Legacy routines:
'Define Arguments in function call RPC (13.08.97)
'Eqm$ "EQPNAME" (points to REC and Server Task) [ now max of 16 characters ]
'Eqno% Equipment number (if server supports multiple devices)
'prop$ "PROPERTY"  VB string with up to 32 characters (now)
'num%  (number of data requested (ie array dimension for dat) SIGN, next line !!
'For READ, num%>0  , for WRITE, num% = -1*(array dimension) !!!!
'dat   (user defined array for data transfer - must be big enough !!)
'datasize (size of data transfer array in bytes ( for VB, use len(dat) )
'format  ( pktr datatype - CF_SHORT, CF_LONG, etc, see definitions above)
Declare Function rpc Lib "tinecln32.dll" Alias "RPC" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%) As Integer
Declare Function RPCEx Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%, ByVal timeout&) As Integer
Declare Function HOTRPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%) As Integer
Declare Function CLOSERPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal id%) As Integer
Declare Function GETRPC Lib "tinecln32.dll" (ByVal id%, dat As Any) As Integer
Declare Function GETRPCSTR Lib "tinecln32.dll" Alias "GETRPC" (ByVal id%, ByVal sdat As String) As Integer
Declare Function PUTRPC Lib "tinecln32.dll" (ByVal id%, dat As Any) As Integer
Declare Function PUTRPCSTR Lib "tinecln32.dll" Alias "PUTRPC" (ByVal id%, ByVal sdat As String) As Integer
Declare Function GETRPCDATA Lib "tinecln32.dll" (ByVal id%, dat As Any, ts&) As Integer
Declare Function GETRPCSTRDATA Lib "tinecln32.dll" Alias "GETRPCDATA" (ByVal id%, ByVal sdat As String, ts&) As Integer
Declare Function RPCERR Lib "tinecln32.dll" (ByVal errno%, ByVal errstr$) As Integer
Declare Function GetRPCLastError Lib "tinecln32.dll" (ByVal cc%, ByVal errstr$) As Integer
Declare Function GETGLOBAL Lib "tinecln32.dll" (ByVal keyword$, dat As Any, ByVal size%, ByVal fmt%) As Integer
Declare Function GETUSER Lib "tinecln32.dll" (ByVal user$) As Integer
Declare Function SUBSCRIBE Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%, ByVal mode%) As Integer
Declare Function A_RPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function SA_RPC Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%) As Integer
Declare Function S_RPC Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%) As Integer

Declare Function FILLSTRUCT Lib "tinecln32.dll" (ByVal structTag$, ByVal structSize%, ByVal maxArraySize%, ByVal fmt%) As Integer
Declare Function GETSTRUCTSIZE Lib "tinecln32.dll" (ByVal structTag$) As Long
Declare Function RPCGETLASTERR Lib "tinecln32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTERROR Lib "tinecln32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTSOURCE Lib "tinecln32.dll" (ByVal srcstr$) As Integer
Declare Function RPCGETLASTTIME Lib "tinecln32.dll" () As Long
Declare Function T_GETDATATIMESTAMP Lib "tinecln32.dll" () As Double
Declare Function T_GETCONTEXTS Lib "tinecln32.dll" (contexts As NAME16, ncontexts As Long) As Integer
Declare Function T_GETDEVICESERVERS Lib "tinecln32.dll" (context As NAME16, servers As NAME16, nservers As Long) As Integer
Declare Function T_GETCONTEXTSFromFile Lib "tinecln32.dll" (contexts As NAME16, ncontexts As Long) As Integer
Declare Function T_GETDEVICESERVERSFromFile Lib "tinecln32.dll" (context As NAME16, servers As NAME16, nservers As Long) As Integer
Declare Function T_GETDEVICENAMES Lib "tinecln32.dll" (context As NAME16, servers As NAME16, names As NAME16, property As NAME32, ndevices As Long) As Integer
Declare Function T_GETDEVICEPROPERTIES Lib "tinecln32.dll" (context As NAME16, servers As NAME16, name As NAME16, Properties As NAME32, nproperties As Long) As Integer
Declare Function T_PUTRPCERRORVALUE Lib "tinecln32.dll" (ByVal LinkIndex As Integer, errValue As Any) As Integer
Declare Function GETRPCFECDATA Lib "tinecln32.dll" (ByVal context$, ByVal server$, ByVal eqm$, ByVal fec$, AlarmSystem%, _
                 ByVal ipxnet$, ByVal ipxaddr$, ByVal IPAddr$, portoffset%) As Integer
Declare Function vBalsnExecLink Lib "tinecln32.dll" (ByVal devName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal devAccess As Integer, ByVal devTimeout As Long) As Integer
Declare Function tgetArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, ByVal datafmt As Integer, dataout As Any, ByVal buffersiz As Long) As Integer
Declare Function tgetSingleArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Single, ByVal buffersiz As Long) As Integer
Declare Function tgetDoubleArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Double, ByVal buffersiz As Long) As Integer
Declare Function tgetLongArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Long, ByVal buffersiz As Long) As Integer
Declare Function tgetShortArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Integer, ByVal buffersiz As Long) As Integer
Declare Function tgetStringArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, ByVal dataout As String, ByVal buffersiz As Long) As Integer

Type MessageLog
  ts As Long
  Status As Long
  msg(127) As Byte
End Type
Declare Function GetMessages Lib "tinecln32.dll" (ml As MessageLog, num As Long) As Integer
Declare Sub ClearMessages Lib "tinecln32.dll" ()

Declare Function GetEqpStatisticsCounters Lib "tinecln32.dll" (stbuf As Long)

Type ElemQueryStruct
  devServ(15) As Byte
  eqm(7) As Byte
  devprop(31) As Byte
  devName(15) As Byte
  formatIn As Integer
  formatOut As Integer
  devContext(15) As Byte
'  strTagIn(7) As Byte
'  strTagOut(7) As Byte
  sizeIn As Long
  sizeOut As Long
  access As Integer
  CompCode As Integer
  pollRate As Integer
  FecIndex As Integer
  links(19) As Integer
  timeoutCount As Integer
  lockCount As Integer
  id As Integer
  heartbeat As Integer
  mode As Integer
  PrimeMode As Integer
  RPCprotocol As Integer
  protocol As Integer
  time As Long
  starttime As Long
  RPCtimestamp As Long
  counter As Long
End Type
Declare Function GETELEMDATA Lib "tinecln32.dll" (elem As ElemQueryStruct, ByVal num%) As Integer
Declare Function RPCDBG Lib "tinecln32.dll" (ByVal dbg%) As Integer
Declare Sub FlushCache Lib "tinecln32.dll" Alias "FLUSHCACHE" ()

Type RPCFECINFO
  os(11) As Byte
  Description(63) As Byte
  Location(31) As Byte
  hardware(47) As Byte
  responsible(31) As Byte
End Type
Declare Function GETRPCFECINFO Lib "tinecln32.dll" (ByVal fecname$, rpcfec As RPCFECINFO) As Integer
Declare Function GetHostFromFecName Lib "tinecln32.dll" (ByVal fecname$, ByVal hostname$) As Integer

Type PropertyQuery
  prpName(31) As Byte
  prpDesc(31) As Byte
  prpSize As Integer
  prpFormat As Byte
  prpAccess As Byte
End Type

Type PropertyQueryEx
  prpName(31) As Byte
  prpDesc(63) As Byte
  prpRedir(1) As NAME16
  prpTag(7) As Byte
  prpTagIn(7) As Byte
  prpUnits(15) As Byte
  prpMinValue As Single
  prpMaxValue As Single
  prpSize As Long
  prpSizeIn As Long
  prpNumOverloads As Long
  prpHistoryDepthShort As Integer
  prpHistoryDepthLong As Integer
  prpFormat As Byte
  prpFormatIn As Byte
  prpAccess As Byte
  prpGraphType As Byte
End Type

'
'              Special export from Acop.dll

Declare Function GetCompletionDataSize Lib "acop.dll" () As Long

'
'              Net Globals

Global HPENERGY As Integer   'Hera Proton energy
Global HPCURRENT As Double   'Hera Proton Beam Current
Global HPTAU     As Double   'Hera Proton Beam Lifetime
Global HEENERGY As Integer   'Hera Electron energy
Global HECURRENT As Double   'Hera Electron Beam Current
Global HETAU     As Double   'Hera Electron Beam Lifetime

' The associated get routines are:
'     HERAGetEnergy(typ$)
'     HERAGetCurrent(typ$)
'     HERAGetLifetime(typ$)
' where typ$ is either "PROTON" or "ELECTRON"
' the above varables are then updated
' e.g. To get the current HERA Proton magnet energy:
'    rc% = HERAGetEnergy("PROTON")
'    If rc% Then
'      MsgBox "RPC Error : " + RPCERROR(rc%)
'    Else
'      MsgBox "Then energy in HERA P is: " + str$(HPENERGY)
'    End If

'
'              Server Routines

Declare Function Address Lib "tinesrv32.dll" (r As Any) As Long
Declare Function CADDR Lib "tinesrv32.dll" (r As Any) As Long
Declare Function CSTRADDR Lib "tinesrv32.dll" Alias "CADDR" (ByVal r As String) As Long
Declare Function UTIME Lib "tinesrv32.dll" () As Long
Declare Function DebugServer Lib "tinesrv32.dll" (ByVal level%) As Integer
Declare Function SetMinimumPollingRate Lib "tinesrv32.dll" (ByVal mpr%) As Integer
Declare Function RegisterFecName Lib "tinesrv32.dll" (ByVal name$, ByVal desc$, ByVal loc$, ByVal hdw$, ByVal resp$, ByVal port%) As Integer
Declare Function RegisterFecNameEx Lib "tinesrv32.dll" (ByVal name$, ByVal desc$, ByVal loc$, ByVal hdw$, ByVal resp$, ByVal port%, ByVal context$) As Integer
Declare Function FILLSRVSTRUCT Lib "tinesrv32.dll" (ByVal tag$, ByVal addr%, ByVal size%, ByVal fmt%) As Integer
Declare Sub GetCallerInfo Lib "tinesrv32.dll" (ByVal ClientName$, ByVal ClientAddress$)
Declare Function SRVSTATUS Lib "tinesrv32.dll" () As Integer
Declare Function feclog Lib "tinesrv32.dll" (ByVal txt As String) As Integer
Declare Function SetWorkAreaSize Lib "tinesrv32.dll" (ByVal siz As Long) As Long
Declare Function setFecLogDepth Lib "tinesrv32.dll" (ByVal nlines As Integer) As Integer
Declare Function SetBurstLimit Lib "tinesrv32.dll" (ByVal npackets As Long) As Long
Declare Function SetCycleDelay Lib "tinesrv32.dll" (ByVal msec As Long) As Long
Declare Function RedirectProperty Lib "tinesrv32.dll" (ByVal localname$, ByVal prpName$, ByVal redirector$) As Integer
Declare Function sendNetGlobal Lib "tinesrv32.dll" (ByVal keyword$, Data As Any, ByVal size As Long, ByVal fmt As Long, ByVal minPeriod As Long, ByVal maxPeriod As Long, ByVal tolerance As Double) As Long
Declare Function ScheduleProperty Lib "tinesrv32.dll" (ByVal localname$, ByVal property$) As Integer
Declare Function srvAssignBufferSpace Lib "tinesrv32.dll" (ByVal rcvBufferSize As Long, ByVal sndBufferSize As Long) As Integer
Declare Function SetContractListSize Lib "tinesrv32.dll" (ByVal numContracts As Long) As Long
Declare Function SetConsumerListSize Lib "tinesrv32.dll" (ByVal numConsumers As Long) As Long
Declare Function getDataTimeStamp Lib "tinesrv32.dll" () As Double
Declare Function makeDataTimeStamp Lib "tinesrv32.dll" () As Double
Declare Function setDataTimeStamp Lib "tinesrv32.dll" (ByVal ts As Double)
Declare Function setSystemPresetMemory Lib "tinesrv32.dll" (ByVal v As Long)
Declare Function setGlobalSynchronization Lib "tinesrv32.dll" (ByVal v As Long)
Declare Function GetLocalHistoryData Lib "tinesrv32.dll" (ByVal localname$, ByVal prpName$, ByVal devName$, dout As DTYPE, din As DTYPE) As Integer
Declare Sub setRetardContractRemoval Lib "tinesrv32.dll" (ByVal v As Long)

Declare Function AttachServer Lib "TBufferedSrv.dll" (ByVal exportname As String, ByVal localname As String, ByVal ndevices As Long) As Integer
Declare Function RegisterDeviceName Lib "TBufferedSrv.dll" (ByVal devName As String, ByVal devNumber As Integer) As Integer
Declare Function RegisterBufferedProperty Lib "TBufferedSrv.dll" ( _
  ByVal prpName As String, ByVal prpInSiz As Long, ByVal prpInFmt As Integer, _
  ByVal prpOutSiz As Long, ByVal prpOutFmt As Integer, ByVal prpMax As Single, _
  ByVal prpMin As Single, ByVal prpEgu As String, ByVal access As Integer, ByVal prpDescription As String _
) As Integer
  
Declare Function pushBufferedData Lib "TBufferedSrv.dll" ( _
  ByVal prpName As String, ByVal devName As String, prpData As Any, _
  ByVal prpSiz As Long, ByVal prpSchedule As Integer _
) As Integer
Declare Function pullBufferedData Lib "TBufferedSrv.dll" ( _
  ByVal prpName As String, ByVal devName As String, prpData As Any, ByVal prpSiz As Long _
) As Integer
Declare Function hasInputChanged Lib "TBufferedSrv.dll" (ByVal prpName As String) As Integer
Declare Function RegisterServerCallback Lib "TBufferedSrv.dll" (ByVal prpName As String, ByVal cb As Any) As Integer
Declare Function GetRegisteredProperties Lib "TBufferedSrv.dll" (prpNames As NAME32, nPrpNames As Integer) As Integer
Declare Function AttachDatabase Lib "TBufferedSrv.dll" () As Integer

Type HistorySpecification
  pollingRate As Long
  archiveRate As Long
  depthInSeconds As Long
  depthInMonths As Long
  heartbeat As Long
  pTolerance As Single
  aTolerance As Single
End Type

Declare Function AppendHistoryInformation Lib "tinesrv32.dll" (ByVal localname$, ByVal property$, ByVal device$, ByVal Length As Long, ByVal fmt As Long, ByVal idx As Long, hspec As HistorySpecification) As Integer
'
'   RPC Access modes

Global Const CA_READ = &H1
Global Const CA_WRITE = &H2
Global Const CA_WRITEREAD = &H3
Global Const CA_ASYNC = &H4
Global Const CA_SYNC = &H8
Global Const CA_HIST = &H20
Global Const CA_FIRST = &H40
Global Const CA_LAST = &H80

'
'   RPC Error Definitions
Global Const success% = 0
Global Const illegal_line% = 1
Global Const illegal_format% = 2
Global Const illegal_arithmetic% = 3
Global Const ambiguous% = 4
Global Const illegal_delimiter% = 5
Global Const zero_divide% = 6
Global Const WA_full% = 7
Global Const non_existent% = 8
Global Const wrong_type% = 9
Global Const link_exhausted% = 10
Global Const not_properly% = 11
Global Const un_allocated% = 12
Global Const no_such_line% = 13
Global Const illegal_shuffle% = 14
Global Const if_error% = 15
Global Const escape_typed% = 16
Global Const ask_error% = 18
Global Const argument_list_error% = 20
Global Const file_error% = 21
Global Const user_stream_transport% = 22
Global Const dimension_error% = 23
Global Const t_dimension_error% = 23
Global Const square_root_negative% = 24
Global Const buffer_too_small% = 25
Global Const string_too_long% = 26
Global Const ipx_socket_error% = 27
Global Const net_read_error% = 28
Global Const not_ready% = 29
Global Const invalid_transport_size% = 30
Global Const log_negative% = 31
Global Const device_not_connected% = 32
Global Const unauthorised_action% = 33
Global Const hardware_error% = 34
Global Const illegal_equipment_number% = 35
Global Const illegal_property% = 36
Global Const out_of_range% = 37
Global Const not_implemented% = 38
Global Const no_such_computer% = 39
Global Const string_filled% = 40
Global Const syntax_error% = 41
Global Const no_such_file% = 42
Global Const no_file_space% = 44
Global Const link_not_open% = 45
Global Const remitted_data_lost% = 46
Global Const end_of_file% = 47
Global Const def_area_full% = 52
Global Const def_syntax% = 53
Global Const illegal_string_set% = 54
Global Const serr1% = 54
Global Const string_function_failure% = 55
Global Const serr2% = 55
Global Const Sif_error% = 57
Global Const Sask_error% = 58
Global Const string_expected% = 59
Global Const out_of_local_memory% = 60
Global Const out_of_shared_memory% = 61
Global Const invalid_structure_tag% = 62
Global Const invalid_index% = 63
Global Const illegal_equipment_name% = 64
Global Const link_error% = 65
Global Const code_failure% = 66
Global Const bracket_missing% = 67
Global Const wrong_hexa% = 68
Global Const wrong_octal% = 69
Global Const illegal_character% = 70
Global Const illegal_operator% = 71
Global Const not_allowed% = 72
Global Const illegal_read_write% = 73
Global Const out_of_memory% = 74
Global Const database_not_loaded% = 75
Global Const illegal_command% = 76
Global Const resources_exhausted% = 77
Global Const file_not_open% = 78
Global Const sedac_error% = 79
Global Const no_such_loop% = 80
Global Const driver_not_installed% = 82
Global Const port_not_available% = 83
Global Const scan_error% = 84
Global Const no_high_voltage% = 85
Global Const non_existent_elem% = 86
Global Const non_existent_fec% = 87
Global Const non_existent_client% = 88
Global Const cannot_lock% = 89
Global Const not_running% = 90
Global Const not_posted% = 91
Global Const not_accepted% = 92
Global Const oeration_timeout% = 93
Global Const illegal_protocol% = 94
Global Const gpib_error% = 95
Global Const rs232_error% = 96
Global Const operation_busy% = 97
Global Const connection_timeout% = 98
Global Const illegal_mode% = 99
Global Const not_owner% = 100
Global Const not_defined% = 101
Global Const net_write_error% = 102
Global Const invalid_data% = 103
Global Const software_error% = 104
Global Const access_denied% = 105
Global Const tcp_not_supported% = 106
Global Const ipx_not_supported% = 107
Global Const host_not_resolved% = 108
Global Const tcp_connect_error% = 109
Global Const tcp_socket_error% = 110
Global Const fpss_error% = 111
Global Const fpss_timeout% = 112
Global Const fpss_overflow% = 113
Global Const pocal_error% = 114
Global Const max_alarms_exceeded% = 115
Global Const not_exported% = 116
Global Const is_switching% = 117
Global Const at_limit% = 118

Global Const CE_SENDDATA = &H4000

Declare Sub MEMCPY Lib "utils32.dll" (dst As Any, src As Any, ByVal nBytes%)

Function GetFormatSize(ByVal fmt As Integer)
If fmt < CF_DOUBLE Then fmt = fmt + CF_DOUBLE
Select Case fmt
  Case CF_DOUBLE: GetFormatSize = 8
  Case CF_SHORT: GetFormatSize = 2
  Case CF_BYTE: GetFormatSize = 1
  Case CF_LONG: GetFormatSize = 4
  Case CF_TEXT: GetFormatSize = 1
  Case CF_FLOAT: GetFormatSize = 4
  Case CF_STRUCT: GetFormatSize = 1
  Case CF_NAME8: GetFormatSize = 8
  Case CF_NAME16: GetFormatSize = 16
  Case CF_CHAR16FI: GetFormatSize = 16 + 4 + 4
  Case CF_BIT: GetFormatSize = 1
  Case CF_NAME32: GetFormatSize = 32
  Case CF_FLTINT: GetFormatSize = 8
  Case CF_LNGINT: GetFormatSize = 8
  Case CF_DBLINT: GetFormatSize = 12
  Case CF_IFI: GetFormatSize = 12
  Case CF_NAME48: GetFormatSize = 48
  Case CF_NAME8I: GetFormatSize = 12
  Case CF_NAME16I: GetFormatSize = 20
  Case CF_NAME32I: GetFormatSize = 36
  Case CF_NAME48I: GetFormatSize = 52
  Case CF_USTRING: GetFormatSize = 96
  Case CF_FLTFLTINT: GetFormatSize = 12
  Case CF_FLTINTINT: GetFormatSize = 12
  Case CF_INTFLTFLTFLT: GetFormatSize = 16
  Case CF_SPECTRUM: GetFormatSize = 4
  Case CF_INTINTINTINT: GetFormatSize = 16
  Case CF_TTII: GetFormatSize = 16
  Case CF_FLTFLT: GetFormatSize = 8
  Case CF_INTFLTSHTSHT: GetFormatSize = 12
  Case CF_BOOLEAN: GetFormatSize = 4
  Case CF_INTINTFLTFLT: GetFormatSize = 16
  Case CF_FLTINTFLTINT: GetFormatSize = 16
  Case CF_NAME64: GetFormatSize = 64
  Case CF_NAME64I: GetFormatSize = 68
  Case CF_LNGDBL: GetFormatSize = 12
  Case CF_DBLDBL: GetFormatSize = 32
  Case Else: GetFormatSize = 0
End Select
End Function
Function GetFormatAsString(ByVal fmt As Integer)
If fmt < CF_DOUBLE Then fmt = fmt + CF_DOUBLE
Select Case fmt
  Case CF_DOUBLE: GetFormatAsString = "DOUBLE"
  Case CF_SHORT: GetFormatAsString = "SHORT"
  Case CF_BYTE: GetFormatAsString = "BYTE"
  Case CF_LONG: GetFormatAsString = "LONG"
  Case CF_TEXT: GetFormatAsString = "TEXT"
  Case CF_FLOAT: GetFormatAsString = "SINGLE"
  Case CF_STRUCT: GetFormatAsString = "STRUCT"
  Case CF_NAME8: GetFormatAsString = "NAME8"
  Case CF_NAME16: GetFormatAsString = "NAME16"
  Case CF_CHAR16FI: GetFormatAsString = "NAME16FI"
  Case CF_BIT: GetFormatAsString = "BIT"
  Case CF_HITTS: GetFormatAsString = "HITTS"
  Case CF_NAME32: GetFormatAsString = "NAME32"
  Case CF_FLTINT: GetFormatAsString = "FLTINT"
  Case CF_LNGINT: GetFormatAsString = "LNGINT"
  Case CF_DBLINT: GetFormatAsString = "DBLINT"
  Case CF_IFI: GetFormatAsString = "INTFLTINT"
  Case CF_NAME48: GetFormatAsString = "NAME48"
  Case CF_NAME8I: GetFormatAsString = "NAME8I"
  Case CF_NAME16I: GetFormatAsString = "NAME16I"
  Case CF_NAME32I: GetFormatAsString = "NAME32I"
  Case CF_NAME48I: GetFormatAsString = "NAME48I"
  Case CF_USTRING: GetFormatAsString = "USTRING"
  Case CF_FLTFLTINT: GetFormatAsString = "FLTFLTINT"
  Case CF_FLTINTINT: GetFormatAsString = "FLTINTINT"
  Case CF_INTFLTFLTFLT: GetFormatAsString = "INTFLTFLTFLT"
  Case CF_SPECTRUM: GetFormatAsString = "SPECTRUM"
  Case CF_INTINTINTINT: GetFormatAsString = "INTINTINTINT"
  Case CF_TTII: GetFormatAsString = "WINDOW"
  Case CF_FLTFLT: GetFormatAsString = "FLTFLT"
  Case CF_INTFLTSHTSHT: GetFormatAsString = "INTFLTSHTSHT"
  Case CF_BOOLEAN: GetFormatAsString = "BOOLEAN"
  Case CF_INTINTFLTFLT: GetFormatAsString = "INTINTFLTFLT"
  Case CF_FLTINTFLTINT: GetFormatAsString = "FLTINTFLTINT"
  Case CF_NAME64: GetFormatAsString = "NAME64"
  Case CF_NAME64I: GetFormatAsString = "NAME64I"
  Case CF_LNGDBL: GetFormatAsString = "LNGDBL"
  Case CF_DBLDBL: GetFormatAsString = "DBLDBL"
  Case Else: GetFormatAsString = "NULL"
End Select
End Function

Function GETCURRENT() As Double
Static er As String * 80
rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
If rc% = 0 Then
  GETCURRENT = HPCURRENT
Else
  rc% = RPCERR(rc%, er$)
  GETCURRENT = -1
End If
End Function

Function GETENERGY() As Integer
Static er As String * 80
rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
If rc% = 0 Then
  GETENERGY = HPENERGY
Else
  rc% = RPCERR(rc%, er$)
  GETENERGY = -1
End If
End Function

Function HERAGetCurrent(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
       If HPCur < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HECur", HECURRENT, 1, CF_DOUBLE)
       If HECur < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetCurrent = rc%
End Function

Function HERAGetEnergy(ByVal t$) As Integer
Static hemagen As Single
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
       If HPENERGY < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEMAGEN", hemagen, 1, CF_FLOAT)
       HEENERGY = CInt(hemagen)
       If HEENERGY < 0 Then rc% = 91
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetEnergy = rc%
End Function

Function HERAGetLifetime(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPtau", HPTAU, 1, CF_DOUBLE)
       If HPTAU < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEtau", HETAU, 1, CF_DOUBLE)
       If HETAU < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetLifetime = rc%
End Function
Function GetEquipmentDevicePropertyInformation(devName As String, Properties() As String, PropertySizes() As Integer, PropertyTypes() As Integer, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQuery
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
ReDim prps(n)
dbout.dArrayLength = n * Len(prps(0)): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(devName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim Properties(n): ReDim PropertySizes(n): ReDim PropertyTypes(n)
For i% = 0 To n - 1
  Properties(i%) = Trim$(BSTR(prps(i).prpName))
  PropertySizes(i%) = prps(i).prpSize
  PropertyTypes(i%) = prps(i).prpFormat + CF_DOUBLE
Next
exitFunction:
nproperties = n
GetEquipmentDevicePropertyInformation = rc%
End Function
Function GetEquipmentDeviceProperties(devName As String, Properties() As String, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQuery
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
ReDim prps(n)
dbout.dArrayLength = n * Len(prps(0)): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(devName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim Properties(n)
For i% = 0 To n - 1
  Properties(i%) = Trim$(BSTR(prps(i).prpName))
Next
exitFunction:
nproperties = n
GetEquipmentDeviceProperties = rc%
End Function

Function GetEquipmentDeviceHistories(devName As String, Histories() As String, nHistories As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim hsts() As NAME32
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devName, "NHISTORIES", dbout, n, dbin, Null, CA_READ, 500)
If rc <> 0 Or n <= 0 Then GoTo exitFunction
ReDim hsts(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME32
rc = T_EXECLINK(devName, "HISTORIES", dbout, hsts(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim Histories(n)
For i% = 0 To n - 1
  Histories(i%) = Trim$(BSTR(hsts(i).nam))
Next
exitFunction:
nHistories = n
GetEquipmentDeviceHistories = rc%
End Function

Function SetAccessLock(ByVal devName As String, ByVal lockType As AccessLockTypes, lockDurationInSeconds As Integer)
Dim dbout As DBLK
Dim dbin As DBLK
Dim rc As Integer
Dim accLock(1) As Integer
Dim lt As Integer

lt = lockType
accLock(0) = lt
accLock(1) = lockDurationInSeconds
dbin.dArrayLength = 2: dbin.dFormat = CF_SHORT
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
rc = T_EXECLINK(devName, "ACCESSLOCK", dbout, 0, dbin, accLock(0), CA_WRITE, 1000)
SetAccessLock = rc%
End Function
Function GetAccessLockInformation(ByVal devName As String, clnName As String, clnAddr As String)
Dim dbout As DBLK
Dim dbin As DBLK
Dim accInfo(1) As NAME32
Dim rc As Integer
  
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 2: dbout.dFormat = CF_NAME32
rc = T_EXECLINK(devName, "ACCESSLOCK", dbout, accInfo(0), dbin, 0, CA_READ, 1000)
If rc = 0 Then
  clnName = BSTR(accInfo(0).nam())
  clnAddr = BSTR(accInfo(1).nam())
End If
GetAccessLockInformation = rc%
End Function
Function GetPropertyInformation(devName As String, property As String, DataLength As Long, DataFormat As Integer, Description As String) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prp As PropertyQuery
Dim rc As Integer, i%
Dim tgt As NAME32
  
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
BARR tgt.nam(), property
rc = T_EXECLINK(devName, "PROPS", dbout, prp, dbin, tgt, CA_READ, 1000)
If rc = 0 Then
  DataLength = prp.prpSize
  DataFormat = CF_DOUBLE + prp.prpFormat
  Description = BSTR(prp.prpDesc())
End If
GetPropertyInformation = rc%
End Function
Function GetPropertyInformationEx(devName As String, property As String, prp As PropertyQueryEx) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim rc As Integer, i%
Dim tgt As NAME32
  
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
BARR tgt.nam(), property
rc = T_EXECLINK(devName, "PROPS", dbout, prp, dbin, tgt, CA_READ, 1000)
GetPropertyInformationEx = rc%
End Function

Function GetEquipmentEGU(devName As String, devProperty As String, eguMin As Single, eguMax As Single, egu As String) As Integer
Dim u As USTRING
Dim dout As DBLK, din As DBLK
Dim rc As Integer
Dim devPrp As String

din.dArrayLength = 0: din.dFormat = CF_NULL
dout.dArrayLength = 1: dout.dFormat = CF_USTRING
devPrp = devProperty + ".EGU"
rc = T_EXECLINK(devName, devPrp, dout, u, din, 0, CA_READ, 500)
If rc Then
 GetEquipmentEGU = rc
 Exit Function
End If
eguMin = u.f1val
eguMax = u.f2val
egu$ = BSTR(u.str())
GetEquipmentEGU = 0
End Function
Function GetEquipmentExtEGU(devName As String, devProperty As String, eguMin As Single, eguMax As Single, egu As String, eguType As Integer) As Integer
Dim u As USTRING
Dim dout As DBLK, din As DBLK
Dim rc As Integer
Dim devPrp As String

din.dArrayLength = 0: din.dFormat = CF_NULL
dout.dArrayLength = 1: dout.dFormat = CF_USTRING
devPrp = devProperty + ".EGU"
rc = T_EXECLINK(devName, devPrp, dout, u, din, 0, CA_READ, 500)
If rc Then
 GetEquipmentExtEGU = rc
 Exit Function
End If
eguMin = u.f1val
eguMax = u.f2val
eguType = u.iVal
egu$ = BSTR(u.str())
GetEquipmentExtEGU = 0
End Function
Function GetEquipmentDeviceNames(devServer As String, devNames() As String, ndevices As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim nms() As NAME16
Dim rc As Integer, i%, j%
Dim dev As String
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devServer, "NDEVICES", dbout, n, dbin, Null, CA_READ, 800)
If rc = non_existent_elem Then
  n = 512 ' try this
  rc = 0
End If
If rc Then GoTo exitFunction
ReDim nms(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(devServer, "DEVICES", dbout, nms(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim devNames(n): j% = 0
For i% = 0 To n - 1
  dev = Trim$(BSTR(nms(i%).nam()))
  If Right$(dev, 1) = "&" And Len(dev) = 16 Then
    i% = i% + 1
    dev = Left$(dev, 15) + Trim$(BSTR(nms(i%).nam()))
  End If
  If Len(dev) > 0 Then
    devNames(j%) = dev
    j% = j% + 1
  End If
Next
exitFunction:
ndevices = j%
GetEquipmentDeviceNames = rc
End Function

Function GetEquipmentDeviceNamesFromProperty(devServer As String, devProperty As String, devNames() As String, ndevices As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim nms() As NAME16
Dim rc As Integer, i%, j%
Dim dev As String

n = ndevices
If n = 0 Then n = 2000
ReDim nms(n - 1)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(devServer, devProperty + ".NAM", dbout, nms(0), dbin, Null, CA_READ, 1000)
If rc Then GoTo exitFunction
If dbout.dArrayLength < ndevices And dbout.dArrayLength > 0 Then
  If BSTR(nms(i%).nam()) = "#0" Then
    ReDim devNames(n): j% = 0
    For i% = 0 To n - 1: devNames(i%) = "#" + Trim$(str(i)):  Next
    GetEquipmentDeviceNamesFromProperty = 0
    Exit Function
  End If
End If
n = dbout.dArrayLength
ReDim devNames(n - 1): j% = 0
For i% = 0 To n - 1
  dev = Trim$(BSTR(nms(i%).nam()))
  If Right$(dev, 1) = "&" And Len(dev) = 16 Then
    i% = i% + 1
    dev = Left$(dev, 15) + Trim$(BSTR(nms(i%).nam()))
  End If
  If Len(dev) > 0 Then
    devNames(j%) = dev
    j% = j% + 1
  End If
Next
exitFunction:
ndevices = j%
GetEquipmentDeviceNamesFromProperty = rc
End Function

Function RPCERROR(ByVal rc%) As String
Static rpcerrbuff As String * 80
cc% = RPCERR(rc%, rpcerrbuff)
If cc% Then
  RPCERROR = "Error undefined"
Else
  RPCERROR = Left$(rpcerrbuff, InStr(rpcerrbuff, Chr(0)) - 1)
End If
End Function

Function UserName() As String
cc% = GETUSER(netuser$)
UserName = UCase(Left$(netuser$, InStr(netuser$, Chr(0)) - 1))
End Function

Function BSTR(b() As Byte) As String
Dim s As String * 32767
Dim t As String
Dim tok() As String
Dim numBytes As Integer
numBytes = UBound(b) - LBound(b) + 1
If numBytes > 32767 Then numBytes = 32767
Call Bytes2String(s, b(LBound(b)), numBytes)
t = Left$(s, InStr(s, Chr(0)) - 1)
If InStr(t, Chr(10)) Then
    tok = Split(t, Chr(10))
    t = ""
    For i = 0 To UBound(tok)
      t = t + tok(i) + vbNewLine
    Next
End If
BSTR = t
End Function
Function BARR(b() As Byte, s As String) As Integer
Dim numBytes&, strlen%, i%
numBytes& = UBound(b) - LBound(b) + 1
strlen% = Len(s)
If strlen% > numBytes& Then
  BARR = 0
Else
  Call String2Bytes(b(LBound(b)), s, strlen%)
  If numBytes& > strlen% Then b(LBound(b) + strlen%) = 0
  BARR = strlen%
End If
End Function
Function GetFecInfoFromNameServer(ByVal fecname As String, finfo As RPCFECINFO, eqps() As String, neqps As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim devName As String
Dim eqpnames(24) As NAME16
Dim txtbuf(188 + 25 * 16) As Byte
Dim rc As Integer, i%, pos%
dbout.dArrayLength = 188 + 25 * 16: dbout.dFormat = CF_TEXT
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
devName = "ENS/FEC.EXT"
For i% = 0 To 1
  rc = T_EXECLINK(devName, fecname, dbout, txtbuf(0), dbin, 0, CA_READ, 600)
  If rc = 0 Then Exit For
Next
If rc Then GoTo exitFunction
MEMCPY finfo, txtbuf(0), Len(finfo)
pos% = Len(finfo)
For i% = 0 To 24
  MEMCPY eqpnames(i%).nam(0), txtbuf(pos%), 16
  pos% = pos% + 16
  If eqpnames(i%).nam(0) = 0 Then Exit For
Next
neqps = i%
ReDim eqps(neqps)
For i% = 0 To neqps - 1
  eqps(i%) = BSTR(eqpnames(i%).nam)
Next
exitFunction:
GetFecInfoFromNameServer = rc
End Function
Function GetFecsFromNameServer(ByVal context$, fecNames() As String, nfecs As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim fns(1000) As NAME16, cnt As NAME16
Dim devName As String
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
devName = "ENS"
If Len(context$) > 0 Then
  devName = devName + "/" + context$
End If
dbout.dArrayLength = 1000: dbout.dFormat = CF_NAME16
For i% = 0 To 1
  rc = T_EXECLINK(devName, "FECS", dbout, fns(0), dbin, 0, CA_READ, 800)
  If rc = 0 Then Exit For
Next
If rc Then GoTo exitFunction
n = dbout.dArrayLength
ReDim fecNames(n)
For i% = 0 To n - 1
  fecNames(i%) = Trim$(BSTR(fns(i%).nam()))
Next
exitFunction:
nfecs = n
GetFecsFromNameServer = rc%
End Function

Function GetEquipmentDeviceContexts(devContexts() As String, nDevContexts As Integer) As Integer
Dim ldc(200) As NAME16
Dim n As Long, rc As Integer, i%

n = 200
rc = T_GETCONTEXTS(ldc(0), n)
If rc Then GoTo exitGetEquipmentDeviceContexts
ReDim devContexts(n)
For i% = 0 To n - 1
  devContexts(i%) = Trim$(BSTR(ldc(i%).nam()))
Next

exitGetEquipmentDeviceContexts:
nDevContexts = n
GetEquipmentDeviceContexts = rc

End Function
Function GetEquipmentDeviceServers(devContext As String, devSubSystem As String, devServers() As String, nDevServers As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim srvs() As NAME16, subsys As NAME16
Dim devName As String
Dim rc As Integer, i%
If Len(devSubSystem) = 0 Then
  dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
Else
  dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
  BARR subsys.nam(), devSubSystem
End If
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
devName = "ENS"
If Len(devContext) > 0 Then devName = devName + "/" + devContext
rc = T_EXECLINK(devName, "NTAGS", dbout, n, dbin, subsys, CA_READ, 500)
If rc Then GoTo exitFunction
ReDim srvs(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(devName, "TAGS", dbout, srvs(0), dbin, subsys, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim devServers(n)
For i% = 0 To n - 1
  devServers(i%) = Trim$(BSTR(srvs(i%).nam()))
Next
exitFunction:
nDevServers = n
GetEquipmentDeviceServers = rc%
End Function
Function SetRPCDragDropString(devName$, devprop$, devType%, devSize&, devDesc$) As String
SetRPCDragDropString = devName$ & "!" & devprop$ & "!" & Trim$(str$(devType%)) _
                       & "!" & Trim$(str$(devSize&)) & "!" & devDesc$
End Function
Function ParseRPCDragDropString(ddstr$, devName$, devprop$, devType%, devSize&, devDesc$) As Integer
Dim tmpstr$
Dim pos As Long

tmpstr$ = ddstr$
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devName$ = Left$(tmpstr$, pos)
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devprop$ = Left$(tmpstr$, pos)
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devType% = CInt(Left$(tmpstr$, pos))
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devSize& = CLng(Left$(tmpstr$, pos))
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
devDesc$ = tmpstr$

End Function
Function TrimString(ByVal st As String) As String
Dim p As Integer
Dim s As String
s = st
s = Trim(s) ' ist iteration
p = InStr(s, Chr(0))
If p >= 1 Then s = Left$(s, p - 1)
TrimString = s
End Function

