Attribute VB_Name = "Apis"
Option Explicit

Public Const MAX_PATH = 260

Public Const NORMAL_PRIORITY_CLASS = &H20&

Public Const PROCESS_TERMINATE As Long = 1
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const SYNCHRONIZE = &H100000
Public Const PROCESS_VM_READ = &H10
Public Const PROCESS_QUERY_INFORMATION = &H400
Public Const PROCESS_ALL_ACCESS As Long = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &HFFF
Public Const TH32CS_SNAPPROCESS As Long = 2&

Public Const GW_HWNDFIRST = 0
Public Const GW_HWNDLAST = 1
Public Const GW_HWNDNEXT = 2
Public Const GW_HWNDPREV = 3
Public Const GW_OWNER = 4
Public Const GW_CHILD = 5
Public Const GW_MAX = 5
Public Const GWL_STYLE = (-16)
Public Const WS_VISIBLE = &H10000000
Public Const WS_BORDER = &H800000

Public Const SW_SHOWMAXIMIZED = 0
Public Const SW_SHOWNORMAL = 1
Public Const SW_SHOWMINIMIZED = 2

Public Const SRCCOPY = &HCC0020

Public Const SMTO_BLOCK = &H1
Public Const SMTO_ABORTIFHUNG = &H2
Public Const WM_CLOSE = &H10
Public Const WM_NULL = &H0
Public Const WM_DESTROY = &H2

' system metrics
Public Const SM_XVIRTUALSCREEN = 76    'virtual desktop left
Public Const SM_YVIRTUALSCREEN = 77    'virtual top
Public Const SM_CXVIRTUALSCREEN = 78   'virtual width
Public Const SM_CYVIRTUALSCREEN = 79   'virtual height
Public Const SM_CMONITORS = 80         'number of monitors
Public Const SM_SAMEDISPLAYFORMAT = 81
  
  
'system tray

Public Const NIM_ADD As Long = &H0&
Public Const NIM_MODIFY As Long = &H1&
Public Const NIM_DELETE As Long = &H2&
Public Const NIF_MESSAGE As Long = &H1&
Public Const NIF_ICON As Long = &H2&
Public Const NIF_TIP As Long = &H4&

Public Const WM_MOUSEMOVE As Long = &H200&
Public Const WM_LBUTTONDOWN As Long = &H201&
Public Const WM_LBUTTONUP As Long = &H202&
Public Const WM_LBUTTONDBLCLK As Long = &H203&
Public Const WM_RBUTTONDOWN As Long = &H204&
Public Const WM_RBUTTONUP As Long = &H205&
Public Const WM_RBUTTONDBLCLK As Long = &H206&
  
  
  
  
' reboot
 

Public Const SE_PRIVILEGE_ENABLED = &H2
Public Const SE_SHUTDOWN_NAME = "SeShutdownPrivilege"

Public Const TOKEN_QUERY = &H8
Public Const TOKEN_ADJUST_PRIVILEGES = &H20
Public Const EWX_LOGOFF As Long = 0
Public Const EWX_SHUTDOWN As Long = 1
Public Const EWX_REBOOT As Long = 2
Public Const EWX_FORCE As Long = 4
Public Const EWX_POWEROFF As Long = 8
Public Const EWX_FORCEIFHUNG As Long = 16  ' only Win 2000, XP ?
                                                  

Public Const ANYSIZE_ARRAY = 1



Public Type T_LUID
    LowPart As Long
    HighPart As Long
End Type

Public Type T_LUID_AND_ATTRIBUTES
    pLuid As T_LUID
    Attributes As Long
End Type

Public Type T_TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(ANYSIZE_ARRAY) As T_LUID_AND_ATTRIBUTES
End Type


Public Type T_PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type

Public Type T_STARTUP_INFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type
  

Public Type T_PROCESSENTRY32
  dwSize As Long
  cntUsage As Long
  th32ProcessID As Long
  th32DefaultHeapID As Long
  th32ModuleID As Long
  cntThreads As Long
  th32ParentProcessID As Long
  pcPriClassBase As Long
  dwFlags As Long
  szExeFile As String * MAX_PATH
End Type

Public Type T_RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Type T_POINTAPI
  x As Long
  y As Long
End Type

Public Type T_WINDOWPLACEMENT
  Length As Long
  flags As Long
  showCmd As Long
  ptMinPosition As T_POINTAPI
  ptMaxPosition As T_POINTAPI
  rcNormalPosition As T_RECT
End Type

Public Type T_BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type T_RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Public Type T_BITMAPINFO
    bmiHeader As T_BITMAPINFOHEADER
    bmiColors As T_RGBQUAD
End Type

Public Type T_DISPLAYDEVICE
   cb As Long
   DeviceName(0 To 31) As Byte
   DeviceString(0 To 127) As Byte
   StateFlags As Long
   DeviceID(0 To 127) As Byte
   DeviceKey(0 To 127) As Byte
End Type

Public Type T_NOTIFYICONDATA
    cbSize As Long
    hWnd As Long
    uId As Long
    uFlags As Long
    ucallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type


Public Const BI_RGB As Long = 0
Public Const DIB_RGB_COLORS As Long = 0

Public Declare Function EnumProcesses Lib "PSAPI.DLL" _
                            (idProcess As Long, ByVal cBytes As Long, cbNeeded As Long) As Long
Public Declare Function EnumProcessModules Lib "PSAPI.DLL" _
                            (ByVal hProcess As Long, hModule As Long, ByVal cb As Long, _
                             cbNeeded As Long) As Long
Public Declare Function GetModuleFileNameEx Lib "PSAPI.DLL" Alias "GetModuleFileNameExA" _
                            (ByVal hProcess As Long, ByVal hModule As Long, _
                             ByVal lpFileName As String, ByVal nSize As Long) As Long
Public Declare Function OpenProcess Lib "kernel32.dll" _
                            (ByVal dwAccess As Long, ByVal bInherit As Long, _
                             ByVal dwProcessId As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function CreateToolhelp32Snapshot Lib "kernel32" _
                            (ByVal lFlags As Long, ByVal lProcessID As Long) As Long
Public Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" _
                            (ByVal hSnapShot As Long, uProcess As T_PROCESSENTRY32) As Long
Public Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" _
                            (ByVal hSnapShot As Long, uProcess As T_PROCESSENTRY32) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function GetWindow Lib "user32" _
                            (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
                            (ByVal hWnd As Long, ByVal wIndx As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" _
                            (ByVal hWnd As Long) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" _
                            (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetWindowThreadProcessId Lib "user32" _
                            (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Public Declare Function GetWindowRect Lib "user32.dll" (ByVal hWnd As Long, lpRect As T_RECT) As Long
Public Declare Function GetWindowPlacement Lib "user32" (ByVal hWnd As Long, lpwndpl As T_WINDOWPLACEMENT) As Long
Public Declare Function SetWindowPlacement Lib "user32" (ByVal hWnd As Long, lpwndpl As T_WINDOWPLACEMENT) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function BringWindowToTop Lib "user32" (ByVal hWnd As Long) As Long

Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hDC _
        As Long, ByVal x As Long, ByVal y As Long, ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, _
        ByVal YSrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hDC As Long, pBitmapInfo As T_BITMAPINFO, _
                                                   ByVal un As Long, ByVal lplpVoid As Long, _
                                                   ByVal handle As Long, ByVal dw As Long) As Long
Public Declare Function GetDIBits Lib "gdi32.dll" (ByVal aHDC As Long, ByVal hBitmap As Long, _
                                                   ByVal nStartScan As Long, ByVal nNumScans As Long, _
                                                   lpBits As Any, lpBI As T_BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As _
        Long, ByVal srcRectWidth As Long, ByVal srcRectHeight As Long, ByVal srcX As Long, ByVal srcY As Long, ByVal firstScanLineInArray As _
        Long, ByVal numberOfscanLines As Long, BitsArray As Any, BitsInfo As T_BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function GetLastError Lib "kernel32.dll" () As Long

Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dst As Any, src As Any, ByVal nBytes As Long)
Public Declare Function EnumDisplayMonitors Lib "user32" (ByVal hDC As Long, ByVal lprcClip As Long, ByVal lpfnEnum As Long, dwData As Any) As Long
Public Declare Function EnumDisplayDevices Lib "user32" Alias "EnumDisplayDevicesA" (ByVal lpDevice As Any, _
                    ByVal iDevNum As Long, lpDisplayDevice As T_DISPLAYDEVICE, ByVal dwFlags As Long) As Long
   
Public Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" _
                 (ByVal lpApplicationName As String, ByVal lpCommandLine As String, _
                 lpProcessAttributes As Any, lpThreadAttributes As Any, _
                 ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, _
                 lpEnvironment As Any, ByVal lpCurrentDriectory As String, _
                 lpStartupInfo As T_STARTUP_INFO, lpProcessInformation As T_PROCESS_INFORMATION) As Long
Public Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Public Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" _
                 (ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, _
                  ByVal lParam As Long, ByVal fuFlags As Long, ByVal uTimeout As Long, _
                  pdwResult As Long) As Long
Public Declare Function GetCurrentProcess Lib "kernel32" () As Long
Public Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Public Declare Function ExitWindowsEx& Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long)
Public Declare Function AdjustTokenPrivileges Lib "advapi32.dll" _
                (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, _
                 NewState As T_TOKEN_PRIVILEGES, ByVal BufferLength As Long, _
                 PreviousState As T_TOKEN_PRIVILEGES, ReturnLength As Long) As Long
                 
Public Declare Function OpenProcessToken Lib "advapi32.dll" _
                (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
                 
Public Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" _
                (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As T_LUID) As Long

'system tray
Public Declare Function Shell_NotifyIcon Lib "shell32" Alias _
                "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As _
                T_NOTIFYICONDATA) As Boolean


