VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form FORM_configTree 
   Caption         =   "Console Daemon: current configuration tree"
   ClientHeight    =   7725
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9495
   LinkTopic       =   "Form1"
   ScaleHeight     =   7725
   ScaleWidth      =   9495
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ImageList IMAGELIST 
      Left            =   120
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   393216
   End
   Begin MSComctlLib.TreeView TREEVIEW 
      Height          =   6555
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   5295
      _ExtentX        =   9340
      _ExtentY        =   11562
      _Version        =   393217
      Style           =   7
      Appearance      =   1
   End
End
Attribute VB_Name = "FORM_configTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private HwndTV As Long


Private Sub Form_Load()
    initTreeview
    fillTreeNodes
End Sub

Private Sub initTreeview()
    Dim i As Integer, j As Integer, k As Integer
    Dim node1 As Node
    Dim node2 As Node
    Dim node3 As Node
    
    ' Initialize the Imagelist
    With IMAGELIST
        .ImageWidth = 24  '16
        .ImageHeight = 24 '16
        .ListImages.Add Picture:=LoadPicture("S:\Projects\Service\vb\consoleDaemon\server\icons\mycomp.ico")
        .ListImages.Add Picture:=LoadPicture("S:\Projects\Service\vb\consoleDaemon\server\icons\pie.ico")
        .ListImages.Add Picture:=LoadPicture("S:\Projects\Service\vb\consoleDaemon\server\icons\application.ico")
        .ListImages.Add Picture:=LoadPicture("S:\Projects\Service\vb\consoleDaemon\server\icons\window.ico")
    End With
  
    With TREEVIEW
        ' Initialize the TreeView
        .HideSelection = False
        .IMAGELIST = IMAGELIST
        .Indentation = 19 * Screen.TwipsPerPixelX
        .LabelEdit = tvwManual
        .LineStyle = tvwRootLines
         HwndTV = .hWnd
    End With   ' TreeView1

End Sub


Private Sub fillTreeNodes()
    Dim i As Integer, j As Integer, k As Integer
    Dim n0 As Node, n1 As Node, n2 As Node
    Dim key As Integer
    
    MyCompName = Environ("COMPUTERNAME")
    With TREEVIEW
        .Nodes.Clear
        
        Set n0 = .Nodes.Add(, , , MyCompName, 1, 1)
        
        For i = 0 To UBound(ConsoleModes)
            If (Trim(getName16String(ConsoleModes(i).name)) <> "") Then
                Set n1 = .Nodes.Add(n0, tvwChild, "M" + Trim(str(i)), getName16String(ConsoleModes(i).name), 2, 2)
                For j = 0 To ConsoleModes(i).nProcs - 1
                    Set n2 = .Nodes.Add(n1, tvwChild, "K" + Trim(str(i)) + "," + Trim(str(j)), Trim(ConsoleModes(i).procs(j).exeName), 3, 3)
                    Call addWindowNodes(n2, i, j)
                Next
            End If
        Next
    
        If .Nodes.Count > 0 Then .Nodes(1).selected = True
    End With
    
End Sub

Private Function addWindowNodes(n As Node, modeIdx As Integer, procIdx As Integer) As Node
    Dim i As Integer, j As Integer, key As Integer
    Dim nd As Node
    Dim inserted As New Collection
    
    With ConsoleModes(modeIdx).procs(procIdx)
        For i = 0 To .nVisibleWindows - 1
            If Not keyExists(inserted, i) Then
                If .visibleWindows(i).parentWindowHandle = 0 Then
                    ''''Set nd = TREEVIEW.Nodes.Add(n, tvwChild, "K" + Trim(str(modeIdx)) + "," + Trim(str(procIdx)) + "," + Trim(str(i)), Trim(.visibleWindows(i).reqCaption), 4, 4)
                    Set nd = TREEVIEW.Nodes.Add(n, tvwChild, "K" + Trim(str(modeIdx)) + "," + Trim(str(procIdx)) + "," + Trim(str(i)), Trim(.visibleWindows(i).caption), 4, 4)
                    inserted.Add i
                    Call addChildNode(nd, modeIdx, procIdx, i, inserted)  ' ProcessDetails(procIdx).visibleWindows(i))
                End If
            End If
        Next
    End With
End Function

Private Sub addChildNode(n As Node, modeIdx As Integer, procIdx As Integer, windowIdx As Integer, inserted As Collection)
    Dim i As Integer
    
    If Not keyExists(inserted, windowIdx) Then
        '''Set n = TREEVIEW.Nodes.Add(n, tvwChild, "K" + Trim(str(modeIdx)) + "," + Trim(str(procIdx)) + "," + Trim(str(windowIdx)), _
        '''                        Trim(ConsoleModes(modeIdx).procs(procIdx).visibleWindows(windowIdx).reqCaption), 4, 4)
        Set n = TREEVIEW.Nodes.Add(n, tvwChild, "K" + Trim(str(modeIdx)) + "," + Trim(str(procIdx)) + "," + Trim(str(windowIdx)), _
                                Trim(ConsoleModes(modeIdx).procs(procIdx).visibleWindows(windowIdx).caption), 4, 4)
        inserted.Add windowIdx
    End If
    For i = 0 To ConsoleModes(modeIdx).procs(procIdx).visibleWindows(windowIdx).nChildWindows - 1
        Call addChildNode(n, modeIdx, procIdx, i, inserted)
    Next
End Sub

Private Function findModeNode(consMode As String) As Node
    Dim nd As Node
    Dim n As Integer
         
    If Trim(Trim0(consMode)) = "" Then consMode = "Any"
    
    While (True)
        Set nd = TREEVIEW.Nodes(1).root
        
        If nd.children < 1 Then
            putlog ("findModeNode: error, no mode defined!")
            Exit Function
        End If
        
        Set nd = nd.child
        
        If Trim(nd.text) = Trim(consMode) Then
            Set findModeNode = nd
            Exit Function
        End If
        
        n = nd.FirstSibling.Index ' Set n to FirstSibling's index.
        While n <> nd.LastSibling.Index
            ' While n is not the index of the last sibling, go to the
            ' next sibling and check its text
            Set nd = TREEVIEW.Nodes(n)
            If Trim(nd.text) = Trim(consMode) Then
                'node found.
                Set findModeNode = nd
                Exit Function
            End If
            ' Set n to the next node's index.
            n = TREEVIEW.Nodes(n).Next.Index
        Wend
        Set nd = TREEVIEW.Nodes(n)
        If Trim(nd.text) = Trim(consMode) Then
            Set findModeNode = nd
            Exit Function
        End If
    
        ' we are here because we havn't found any a node, let's repeat with "Any"
        consMode = "Any"
    Wend
    
End Function

Private Function keyExists(c As Collection, k As Integer) As Boolean
    Dim i
    
    keyExists = True
    For Each i In c
        If i = k Then Exit Function
    Next
    keyExists = False
End Function

Private Sub Form_Resize()
    With TREEVIEW
        .Width = ScaleWidth - 2 * .Left
        .Height = ScaleHeight - 2 * .Top
    End With
End Sub
