Attribute VB_Name = "MenuApis"
Option Explicit
                      
Private Declare Function CallWindowProc Lib "user32" Alias _
        "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal _
        hwnd As Long, ByVal MSG As Long, ByVal wParam As _
        Long, ByVal lParam As Long) As Long
               
Private Declare Function SetWindowLong Lib "user32" Alias _
        "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
        As Long, ByVal dwNewLong As Long) As Long

Private Declare Function InsertMenu Lib "user32" Alias _
        "InsertMenuA" (ByVal hMenu As Long, ByVal nPosition _
        As Long, ByVal wFlags As Long, ByVal wIDNewItem As _
        Long, ByVal lpNewItem As Any) As Long
        
Private Declare Function RemoveMenu Lib "user32" (ByVal _
        hMenu As Long, ByVal nPosition As Long, ByVal wFlags _
        As Long) As Long

Private Declare Function GetSystemMenu Lib "user32" (ByVal _
        hwnd As Long, ByVal bRevert As Long) As Long
        
Private Declare Function GetMenu Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function GetSubMenu Lib "user32.dll" (ByVal hMenu As Long, ByVal nPos As Long) As Long
        
Private Declare Function AppendMenu Lib "user32" Alias _
        "AppendMenuA" (ByVal hMenu As Long, ByVal wFlags As _
        Long, ByVal wIDNewItem As Long, ByVal lpNewItem As _
        String) As Long


Const MF_STRING = &H0&
Const MF_SEPARATOR = &H800&
Const MF_BYPOSITION = &H400&

Const GWL_WNDPROC = (-4&)
Const WM_SYSCOMMAND = &H112

Dim PrevWndProc As Long, MenuHandle As Long

Private Function WndProc(ByVal hwnd As Long, ByVal MSG _
                         As Long, ByVal wParam As Long, _
                         ByVal lParam As Long) As Long
  Dim Result&
  
    If MSG = WM_SYSCOMMAND Then
      Select Case wParam
        Case &H200:  Form1.caption = "Befehl 1"
        Case &H201:  Form1.caption = "Befehl 2"
        Case &H202:  Form1.caption = "Befehl 3"
         '... etc
      End Select
    End If
  
    WndProc = CallWindowProc(PrevWndProc, hwnd, MSG, wParam, lParam)
End Function

Public Sub Init(h As Long)
  Dim tHandle As Long
  
  MenuHandle = GetMenu(h)
  tHandle = GetSubMenu(MenuHandle, 0&)
  tHandle = GetSubMenu(MenuHandle, 1&)
  tHandle = GetSubMenu(MenuHandle, 2&)
  'MenuHandle = GetSubMenu(tHandle, 0&)
  
  'separator line
  Call AppendMenu(MenuHandle, MF_SEPARATOR, 0, "")
  
  '2 add menu items
  Call AppendMenu(MenuHandle, MF_STRING, &H200, "command &1")
  Call AppendMenu(MenuHandle, MF_STRING, &H201, "command &2")
  
  'add menu item at given position
  Call InsertMenu(MenuHandle, 2, MF_BYPOSITION, &H202, "Befehl 3")
  
  'remove item
  Call RemoveMenu(MenuHandle, 0, MF_BYPOSITION)
  
  PrevWndProc = SetWindowLong(h, GWL_WNDPROC, AddressOf WndProc)
End Sub

Public Sub Terminate(hwnd As Long)
  Call SetWindowLong(hwnd, GWL_WNDPROC, PrevWndProc)
End Sub


