Attribute VB_Name = "ServerCode"
Option Explicit

Private Type T_REMOTEWINDOW
    handle As Long 'to compare if proc/window index was not chanegd due to refreshing the process list
    modeIdx As Integer
    procIdx As Integer
    windIdx As Integer
    wp As T_WINDOWPLACEMENT
End Type


Public Function initServer(server As SRV) As Boolean
    Dim errCode As Long
    Dim l As Integer
    Dim size As Long, retSize As Long
    Dim fecname As String
    Dim portNo As Integer
    Dim rWdw As T_REMOTEWINDOW
    Dim startProc As T_STARTPROC
    Dim stopProc As T_STOPPROC
    
    initServer = False
    
    size = 20 * CLng(CLng(MAX_PROC_INFO) * CLng(LenB(RunningProcesses(0))))
    retSize = SetWorkAreaSize(size)
    SetBurstLimit 2000
    
    If retSize < size Then
        putlog ("error: can not set Server Work Area Size to: " + str(size) + ", allocated: " + str(retSize))
    End If
    
    With server
            .EqpName = "ConsDaemon"
            .EqpNumberModules = 1
            .exportname = getServerName
            fecname = "CD_" + Left(.exportname, 13)
            portNo = 22
       
        errCode = RegisterFecNameEx(fecname, "Console Daemon", _
           getMachineName, "none", "KAROL", portNo, "HERA.DAEMON")
        If errCode <> 0 Then
            putlog ("RegisterFecName(): error=" + str(errCode) + "," + RPCERROR(errCode))
            Exit Function
        Else
            putlog ("RegisterFecNameEx(" + fecname + ") - OK")
            putlog ("EqpName = " + .EqpName + " , ExportName = " + .exportname)
        End If
    
        .Enabled = True
        
        Call RegisterProperty(server, "GETPROCS", 1, CF_SHORT, "", 1000& * LenB(RunningProcesses(0)), CF_STRUCT, "", CA_READ, "get processes information")
        Call RegisterProperty(server, "GETNPROCS", 0, CF_NULL, "", 1, CF_SHORT, "", CA_READ, "get number of processes")
        Call RegisterProperty(server, "SETWINPOS", LenB(rWdw), CF_STRUCT, "", 0, CF_NULL, "", CA_WRITE, "set remote window position")
        Call RegisterProperty(server, "GETSCRSHTSIZE", 1, CF_SHORT, "", 2, CF_LONG, "", CA_READ, "get snapshot buffer size")
        Call RegisterProperty(server, "GETSCRSHOT", 1, CF_SHORT, "", 8000000, CF_BYTE, "", CA_READ, "get snapshot")
        Call RegisterProperty(server, "GETSYSINFO", 0, CF_NULL, "", LenB(SystemInfo), CF_STRUCT, "", CA_READ, "get remote system info")
        Call RegisterProperty(server, "STARTPROC", LenB(startProc), CF_STRUCT, "", 0, CF_NULL, "", CA_WRITE, "start remote process")
        Call RegisterProperty(server, "STOPPROC", LenB(stopProc), CF_STRUCT, "", 0, CF_NULL, "", CA_WRITE, "stop remote process")
        Call RegisterProperty(server, "REBOOT", 1, CF_LONG, "", 0, CF_NULL, "", CA_WRITE, "reboot remote PC after t seconds")
        Call RegisterProperty(server, "GETMODES", 0, CF_NULL, "", LenB(ConsoleModes(0)) * (UBound(ConsoleModes) + 1), CF_STRUCT, "", CA_READ, "get console modes")
        Call RegisterProperty(server, "SETCONSMODE", 16, CF_TEXT, "", 0, CF_NULL, "", CA_WRITE, "set console mode")
        errCode = .EqpStatus
        If (errCode <> 0) Then putlog (RPCERROR(errCode))
    End With
    initServer = True
    
End Function

Private Sub RegisterProperty(server As SRV, devProperty As String, inMaxArrayLength As Long, inFormat As Integer, _
                             inStructureTag, outMaxArrayLength As Long, outFormat As Integer, _
                             outStructureTag As String, access As Integer, Description As String)
    Dim rc As Integer
    
    rc = server.EqpRegisterPropertyEx(devProperty, inMaxArrayLength, _
                                   inFormat, inStructureTag, outMaxArrayLength, _
                                   outFormat, outStructureTag, access, Description)
    If rc < 0 Then
        putlog ("EqpRegisterPropertyEx(" + devProperty + "): error = " + str(rc) + ", " + RPCERROR(rc))
        Exit Sub
    End If
End Sub


Public Sub handleRequest(server As SRV, ByVal devName As String, ByVal devProperty As String, _
                        ByVal outArrayLen As Long, ByVal inArrayLen As Long, _
                        ByVal devAccess As Integer)
    
    Select Case UCase(devProperty)
    Case "GETPROCS"
        If ((devAccess And CA_READ) <> CA_READ) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_getProcDetails(server, outArrayLen)
        
    Case "GETNPROCS"
        If ((devAccess And CA_READ) <> CA_READ) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_getNproc(server, outArrayLen)
        
    Case "SETWINPOS"
        If ((devAccess And CA_WRITE) <> CA_WRITE) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_setWindowpos(server, inArrayLen)
        
    Case "GETSCRSHTSIZE"
        If ((devAccess And CA_READ) <> CA_READ) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_getScreenShotSize(server, inArrayLen, outArrayLen)
        
    Case "GETSCRSHOT"
        If ((devAccess And CA_READ) <> CA_READ) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_getScreenShot(server, inArrayLen, outArrayLen)
    Case "GETSYSINFO"
        If ((devAccess And CA_READ) <> CA_READ) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_getSystemInfo(server, outArrayLen)
    Case "STARTPROC"
        If ((devAccess And CA_WRITE) <> CA_WRITE) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_startProcess(server, inArrayLen)
    Case "STOPPROC"
        If ((devAccess And CA_WRITE) <> CA_WRITE) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_stopProcess(server, inArrayLen)
    Case "REBOOT"
        If ((devAccess And CA_WRITE) <> CA_WRITE) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_reboot(server, inArrayLen)
    Case "GETMODES"
        If ((devAccess And CA_READ) <> CA_READ) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_getConsoleModes(server, outArrayLen)
    Case "SETCONSMODE"
        If ((devAccess And CA_WRITE) <> CA_WRITE) Then
            server.EqpSetCompletion 73, ""
            Exit Sub
        End If
        Call cmd_setConsoleMode(server, inArrayLen)
    Case Else
        putlog ("*** property: " + devProperty + " is not handled.")
        server.EqpSetCompletion 0, ""
    End Select
    
End Sub

Private Sub cmd_getProcDetSize(server As SRV, datalen As Long)
    Dim errCode As Integer
            
    If datalen < 1 Then
        putlog ("---cmd_getProcDetSize: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    errCode = server.EqpSendDataEx(NRunningProcesses)
    If errCode <> 0 Then
        putlog ("SERVER.EqpSendData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    server.EqpSetCompletion 0, ""
End Sub

Private Sub cmd_getProcDetails(server As SRV, datalen As Long)
    Dim errCode As Integer
            
    If datalen < 1 Then
        putlog ("---cmd_getProcDetails: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    errCode = server.EqpSendDataEx(RunningProcesses(0).procEntry.dwSize, datalen)
    If errCode <> 0 Then
        putlog ("SERVER.EqpSendData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    server.EqpSetCompletion 0, ""
End Sub

Private Sub cmd_getNproc(server As SRV, datalen As Long)
    Dim errCode As Integer
            
    If datalen < 1 Then
        putlog ("---cmd_getNproc: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    getProcessAndWindowInfo   ' refresh
    errCode = server.EqpSendDataEx(NRunningProcesses)
    If errCode <> 0 Then
        putlog ("SERVER.EqpSendData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    server.EqpSetCompletion 0, ""

End Sub

Private Sub cmd_setWindowpos(server As SRV, datalen As Long)
    Dim errCode As Integer
    Dim rWdw As T_REMOTEWINDOW
    
    If datalen <> LenB(rWdw) Then
        putlog ("---cmd_setWindowpos: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    errCode = server.EqpRecvData(rWdw.handle)
    If errCode <> 0 Then
        putlog ("SERVER.EqpRecvData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    With rWdw
        If .handle <> ConsoleModes(.modeIdx).procs(.procIdx).visibleWindows(.windIdx).handle Then
            'client had stale process list
            server.EqpSetCompletion invalid_data, ""
            Exit Sub
        End If
        Call SetWindowPosition(.modeIdx, .procIdx, .windIdx, rWdw.wp)
        putlog ("remote request to place window: " + ConsoleModes(.modeIdx).procs(.procIdx).visibleWindows(.windIdx).caption)
    End With
        
    server.EqpSetCompletion 0, ""

End Sub

Private Sub cmd_getScreenShotSize(server As SRV, inDataLen As Long, outDataLen As Long)
    Dim errCode As Integer
    Dim size(1) As Long
    Dim idx As Integer
    
    If inDataLen < 1 Then
        putlog ("---cmd_getScreenShotSize: wrong length of the input buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    If outDataLen < 2 Then
        putlog ("---cmd_getScreenShotSize: wrong length of the output buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    
    errCode = server.EqpRecvData(idx)
    If errCode <> 0 Then
        putlog ("SERVER.EqpRecvData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    Call getScreenShotDims(idx, size(0), size(1))
    errCode = server.EqpSendData(size)
    If errCode <> 0 Then
         putlog ("SERVER.EqpSendData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    server.EqpSetCompletion 0, ""
End Sub

Private Sub cmd_getScreenShot(server As SRV, inDataLen As Long, outDataLen As Long)
    Dim errCode As Integer
    Dim size(1) As Long
    Dim idx As Integer
    Static screenShotBuff() As Byte
    
    
    If inDataLen < 1 Then
        putlog ("---cmd_getScreenShot: wrong length of the input buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
       
    errCode = server.EqpRecvData(idx)
    If errCode <> 0 Then
        putlog ("SERVER.EqpRecvData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    Call getScreenShotDims(idx, size(0), size(1))
    If outDataLen < size(0) * (size(1) + 1) Then    ' size(0)+1 because first row is reserved for the header info
        putlog ("---cmd_getScreenShot: wrong length of the output buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    
    Call getScreenShot(idx, screenShotBuff)
    errCode = server.EqpSendDataEx(screenShotBuff(0, 0), size(0) * (size(1) + 1))
    If errCode <> 0 Then
         putlog ("SERVER.EqpSendData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    putlog ("get screen shot - ok")
    server.EqpSetCompletion 0, ""
End Sub

Private Function getServerName() As String
    
    MyCompName = getMachineName
    
    If UCase((Left(MyCompName, 5))) = "BKRXP" Then
        'assume BKRXPHERACONSOLExx
        getServerName = Right(MyCompName, Len(MyCompName) - 5)
    Else
        getServerName = Left(MyCompName, 16)
    End If
        
End Function

Private Function getMachineName() As String
    getMachineName = Environ("COMPUTERNAME")
End Function

Private Sub cmd_getSystemInfo(server As SRV, datalen As Long)
    Dim errCode As Integer
    Dim size As Long
    
    size = LenB(SystemInfo)
    If datalen < size Then
        putlog ("---cmd_getSystemInfo: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    
    fillSystemInfo
    
    errCode = server.EqpSendDataEx(SystemInfo.nMonitors, size)
    If errCode <> 0 Then
        putlog ("getSystemInfo: SERVER.EqpSendData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    server.EqpSetCompletion 0, ""

End Sub

Private Sub cmd_startProcess(server As SRV, datalen As Long)
    Dim errCode As Integer
    Dim size As Long
    Dim startProcessInfo As T_STARTPROC
    
    size = LenB(startProcessInfo)
    If datalen < size Then
        putlog ("---cmd_startProcess: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    
    errCode = server.EqpRecvData(startProcessInfo.pathName(0))
    If errCode <> 0 Then
        putlog ("cmd_startProcess: SERVER.EqpRecvData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    server.EqpSetCompletion 0, ""
    
    Call startProcess("", "", BSTR(startProcessInfo.pathName), BSTR(startProcessInfo.exeNname), BSTR(startProcessInfo.args), BSTR(startProcessInfo.workingDirectory))
End Sub

Private Sub cmd_stopProcess(server As SRV, datalen As Long)
    Dim errCode As Integer
    Dim size As Long
    Dim stopProcessInfo As T_STOPPROC
    
    size = LenB(stopProcessInfo)
    If datalen < size Then
        putlog ("---cmd_getStopProcess: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    
    errCode = server.EqpRecvData(stopProcessInfo.procIdx)
    If errCode <> 0 Then
        putlog ("cmd_stopProcess: SERVER.EqpRecvData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    If RunningProcesses(stopProcessInfo.procIdx).procEntry.szExeFile <> stopProcessInfo.exeName Then
        server.EqpSetCompletion illegal_string_set, ""
        Exit Sub
    End If
    server.EqpSetCompletion 0, ""
    
    Call stopProcess(RunningProcesses(stopProcessInfo.procIdx))
End Sub


Private Sub cmd_reboot(server As SRV, datalen As Long)
    Dim errCode As Integer
    Dim timeout As Long
    
    
    If datalen < 1 Then
        putlog ("---cmd_getStopProcess: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    
    errCode = server.EqpRecvData(timeout)
    If errCode <> 0 Then
        putlog ("cmd_reboot: SERVER.EqpRecvData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    server.EqpSetCompletion 0, ""
    reboot
    
End Sub


Private Sub reboot()
    Dim action As Long      ' 0 - logoff, 1 - shutdown, 2 - reboot
    Dim retCode As Long
    Dim hToken As Long      ' Handle Processtoken
    Dim localUID As T_LUID        ' LUID (locally unique identifier)
    Dim priv As T_TOKEN_PRIVILEGES
    Dim prevPriv As T_TOKEN_PRIVILEGES
    
    action = 2 Or EWX_FORCE Or EWX_FORCEIFHUNG   ' EWX_FORCEIFHUNG  works only with Win 2000 and XP
        
    retCode = OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, hToken)
    
    If retCode Then
        retCode = LookupPrivilegeValue(vbNullString, SE_SHUTDOWN_NAME & vbNullChar, localUID)
        If retCode Then
            ' Shutdownprivileg setzen
            With priv
                .PrivilegeCount = 1
                .Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
                .Privileges(0).pLuid = localUID
            End With
            
            retCode = AdjustTokenPrivileges(hToken, 0, priv, 4 + 12 * priv.PrivilegeCount, prevPriv, 4 + 12 * prevPriv.PrivilegeCount)
            
            If retCode > 0 Then Call ExitWindowsEx(action, 0)
        End If
    End If
End Sub

Private Sub cmd_getConsoleModes(server As SRV, datalen As Long)
    Dim errCode As Integer
    Dim i As Integer
    
    If datalen < LenB(ConsoleModes(0)) * (UBound(ConsoleModes) + 1) Then
        putlog ("---cmd_getConsoleModes: wrong length of the buffer")
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
        
    errCode = server.EqpSendDataEx(ConsoleModes(0).name.nam(0), datalen)
    If errCode <> 0 Then
        putlog ("SERVER.EqpSendData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    server.EqpSetCompletion 0, ""
End Sub


Private Sub cmd_setConsoleMode(server As SRV, datalen As Long)
    Dim errCode As Integer
    Dim i As Integer
    'Dim cnsMode As NAME16
    Dim cnsMode As String
   
    If datalen < 1 Or datalen > 16 Then
        putlog ("---cmd_setConsoleMode: wrong length of the buffer")
        putlog ("got: " + str(datalen))
        server.EqpSetCompletion illegal_format, ""
        Exit Sub
    End If
    
    'errCode = server.EqpRecvData(cnsMode.nam(0))
    cnsMode = Space(16)
    errCode = server.EqpRecvData(cnsMode)
    If errCode <> 0 Then
        putlog ("SERVER.EqpRecvData failed: " + str(errCode) + ", " + RPCERROR(errCode))
        server.EqpSetCompletion errCode, ""
        Exit Sub
    End If
    
    cnsMode = UCase(Trim(cnsMode))
    putlog ("Remote request to switch console mode to: " + cnsMode)
    For i = 0 To UBound(ConsoleModes)
        If cnsMode = UCase(Trim(getName16String(ConsoleModes(i).name))) Then
            Call FORM_consoleDaemon.setCurrentConsoleMode(cnsMode, True)
            server.EqpSetCompletion 0, ""
            Exit Sub
        End If
    Next
    putlog ("Error: requested mode not found on the mode list")
    server.EqpSetCompletion invalid_data, ""
    
End Sub
