Attribute VB_Name = "XMLparsing"
Option Explicit

'''Private Const XML_CONFIG = "E:\Projects\projects.VB\ConsoleDaemon\DeamonServer\xml parsing\test.xml"
Private Const XML_CONFIG = "L:\daemon\consoleDaemon.cfg"
Private Const TAB_STEP = 4   'identation depth in the ouptut XML file

Private Nwindows As Integer




Private Const MAX_STACK = 100
Private Type T_STACK
    ptr As Integer
    body(MAX_STACK) As String
End Type
Private Stack As T_STACK

Public Function loadXMLconfigFile() As Boolean
    Dim root As IXMLDOMNode
    Dim objDOMDoc As New MSXML2.DOMDocument40
    
    objDOMDoc.async = False
    If Not objDOMDoc.Load(XML_CONFIG) Then
         putlog ("loadXMLconfigFile error: " + objDOMDoc.parseError.reason)
         Exit Function
    End If
    
    Set root = objDOMDoc.documentElement
   
    Call processNode(root)
    
    Set objDOMDoc = Nothing
    
    loadXMLconfigFile = True
    
End Function

Private Sub processNode(n As IXMLDOMNode)
    Dim child  As IXMLDOMNode
    
    Select Case n.nodeTypeString
        Case "element"
            Call parseElement(n)
        Case "text"
            Call parseText(n)
        Case "cdatasection"
            '''msgbox "cdatasection"
        Case Else
            MsgBox "DEFAULT: node type = " + n.nodeTypeString
    End Select
      
End Sub

Private Sub parseElement(n As IXMLDOMNode)
    Dim ch As IXMLDOMNode
    Dim i As Integer
    Dim attr As IXMLDOMAttribute
    Dim nodeType As XMLELEM_TYPE
    
    Call push(n.nodeName)
            
    Select Case UCase(n.nodeName)
        Case "APPLICATION"   ' new application description found
            ConsoleModes(CurrentConsoleModeIdx).procs(ConsoleModes(CurrentConsoleModeIdx).nProcs).arguments = ""
            ConsoleModes(CurrentConsoleModeIdx).procs(ConsoleModes(CurrentConsoleModeIdx).nProcs).launcherScript = ""
            ConsoleModes(CurrentConsoleModeIdx).nProcs = ConsoleModes(CurrentConsoleModeIdx).nProcs + 1
            Nwindows = 0
        Case "WINDOW"
            Nwindows = Nwindows + 1
    End Select
    
    For i = 0 To n.Attributes.Length - 1
        Set attr = n.Attributes(i)
        Call parseAttributes(attr)
    Next

    For Each ch In n.childNodes
        Call processNode(ch)
    Next

    Call pop
    
End Sub

Private Sub parseText(n As IXMLDOMNode)
    With ConsoleModes(CurrentConsoleModeIdx)
        Select Case UCase(getTop())
            Case "NAME"
                .procs(.nProcs - 1).path = GetPathFromName(n.nodeValue)
                .procs(.nProcs - 1).exeName = GetExeFromName(n.nodeValue)
            Case "WINDOW"
                 '''.procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqCaption = n.nodeValue
                 .procs(.nProcs - 1).visibleWindows(Nwindows - 1).caption = n.nodeValue
                 .procs(.nProcs - 1).nVisibleWindows = .procs(.nProcs - 1).nVisibleWindows + 1
            Case "ARGS"
                 .procs(.nProcs - 1).arguments = n.nodeValue
            Case "AUTORESTART"
                  DaemonConfig.restartProcesses = (InStr("yY1Tt", Left(Trim(n.nodeValue), 1)) > 0)
            Case "STICKYWINDOWS"
                  DaemonConfig.keepWindowsInGivenPosition = (InStr("yY1Tt", Left(Trim(n.nodeValue), 1)) > 0)
            Case "WINDOW_PLACEMENT_DELAY"
                  DaemonConfig.placeWindowsAfterApplicationStart = CLng(n.nodeValue)
            Case "PROCESSES_CHECK_PERIOD"
                  DaemonConfig.checkProcessesPeriod = CLng(n.nodeValue)
            Case "LAUNCHER"
                  DaemonConfig.scriptLocation = Trim(n.nodeValue)
            Case "SCRIPT_LOCATION"
                  .procs(.nProcs - 1).launcherScript = Trim(n.nodeValue)
        End Select
    End With
End Sub

Private Sub parseAttributes(attr As IXMLDOMAttribute)
    Dim i As Integer
    
    With ConsoleModes(CurrentConsoleModeIdx)
        Select Case UCase(getTop())
            Case "WINDOW"
                Select Case UCase(attr.baseName)
                    Case "TOP"
                        .procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqTop = CLng(attr.text)
                    Case "LEFT"
                        .procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqLeft = CLng(attr.text)
                    Case "RIGHT"
                        .procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqRight = CLng(attr.text)
                    Case "BOTTOM"
                        .procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqBottom = CLng(attr.text)
                    Case "STATE"
                        Select Case UCase(attr.text)
                            Case "MINIMIZED"
                                .procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqStatus = SW_SHOWMINIMIZED
                            Case "MAXIMIZED"
                                .procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqStatus = SW_SHOWMAXIMIZED
                            Case Else
                                .procs(.nProcs - 1).visibleWindows(Nwindows - 1).reqStatus = SW_SHOWNORMAL
                        End Select
                End Select
            Case "MODE"
                    CurrentConsoleMode = UCase(attr.text)
                    For i = 0 To UBound(ConsoleModes)
                        If getName16String(ConsoleModes(i).name) = CurrentConsoleMode Then
                            CurrentConsoleModeIdx = i
                            Exit Sub
                        End If
                        If getName16String(ConsoleModes(i).name) = "" Then
                            CurrentConsoleModeIdx = i
                            Call setName16(ConsoleModes(i).name, CurrentConsoleMode)
                            Exit Sub
                        End If
                    Next
                    MsgBox " Attempt to define too many console modes. Currently allowed: " + UBound(ConsoleModes), vbYes + vbExclamation
        End Select
    End With
End Sub

Private Sub push(txt As String)
    With Stack
        .body(.ptr) = txt
        If .ptr = MAX_STACK Then
            MsgBox "STACK OVERFLOW", vbCritical
            Exit Sub
        End If
        .ptr = .ptr + 1
    End With
End Sub

Private Function pop() As String
    With Stack
        If .ptr = 0 Then
            MsgBox "STACK UNDERFLOW", vbCritical
            Exit Function
        End If
        .ptr = .ptr - 1
        pop = .body(.ptr)
    End With
End Function

Private Function getTop() As String
    getTop = pop()
    push (getTop)
End Function


Public Function saveXMLConfig() As Boolean
    Dim h As Integer
    Dim tmp As Integer
    Dim q As String   ' "
    Dim tabCnt As Integer
    Dim i As Integer, j As Integer, windIdx As Integer
    Dim consMode As String
    
    On Error GoTo err_handler
    
    h = -1
    tmp = FreeFile
    
    Open XML_CONFIG For Output As tmp
    h = tmp   'we are here == no error while opening the file
    
    q = Chr(34)
    Print #h, "<?xml version=" + q + "1.0" + q + " encoding=" + q + "ISO-8859-1" + q + "?>"
    
    Print #h, "<COMPUTER NAME = " + q + MyCompName + q + " >"
    tabCnt = tabCnt + TAB_STEP
    
    Print #h, Tab(tabCnt); "<DAEMON_CONFIG>"
    tabCnt = tabCnt + TAB_STEP
    With DaemonConfig
           Print #h, Tab(tabCnt); "<AUTORESTART> " + IIf(.restartProcesses, "YES", "NO") + " </AUTORESTART>"
           Print #h, Tab(tabCnt); "<STICKYWINDOWS> " + IIf(.keepWindowsInGivenPosition, "YES", "NO") + " </STICKYWINDOWS>"
           Print #h, Tab(tabCnt); "<WINDOW_PLACEMENT_DELAY> " + str(.placeWindowsAfterApplicationStart) + " </WINDOW_PLACEMENT_DELAY>"
           Print #h, Tab(tabCnt); "<PROCESSES_CHECK_PERIOD> " + str(.checkProcessesPeriod) + " </PROCESSES_CHECK_PERIOD>"
           Print #h, Tab(tabCnt); "<LAUNCHER> " + Trim(.scriptLocation) + " </LAUNCHER>"
    End With
    tabCnt = tabCnt - TAB_STEP
    Print #h, Tab(tabCnt); "</DAEMON_CONFIG>"

    For i = 0 To UBound(ConsoleModes)
        consMode = Trim(getName16String(ConsoleModes(i).name))
        If consMode = "" Then Exit For
        If UCase(consMode) <> "ANY" Then
            ' <MODE name = "E-INJECTION">
            Print #h, Tab(tabCnt); "<MODE name = " + q + consMode + q + ">"
            For j = 0 To ConsoleModes(i).nProcs - 1
                    With ConsoleModes(i)
                        If CurrentConsoleModeIdx = i Then
                        'copy current window settings only for current console mode
                            For windIdx = 0 To .procs(j).nVisibleWindows - 1
                                .procs(j).visibleWindows(windIdx).reqTop = .procs(j).visibleWindows(windIdx).g.rcNormalPosition.Top
                                .procs(j).visibleWindows(windIdx).reqLeft = .procs(j).visibleWindows(windIdx).g.rcNormalPosition.Left
                                .procs(j).visibleWindows(windIdx).reqBottom = .procs(j).visibleWindows(windIdx).g.rcNormalPosition.Bottom
                                .procs(j).visibleWindows(windIdx).reqRight = .procs(j).visibleWindows(windIdx).g.rcNormalPosition.Right
                                .procs(j).visibleWindows(windIdx).reqStatus = .procs(j).visibleWindows(windIdx).g.showCmd
                                '.procs(j).visibleWindows(windIdx).reqCaption = Trim(Trim0(.procs(j).visibleWindows(windIdx).caption))
                                .procs(j).visibleWindows(windIdx).caption = Trim(Trim0(.procs(j).visibleWindows(windIdx).caption))
                            Next
                        End If
                        Call xmlSave_addApplictaion(h, tabCnt, .procs(j))
                    End With
            Next
            Print #h, Tab(tabCnt); "</MODE>"
        End If
    Next
    tabCnt = tabCnt - TAB_STEP
    Print #h, "</COMPUTER>"
    Close #h
    saveXMLConfig = True
    Exit Function
    
err_handler:
    If h > -1 Then Close #h
    saveXMLConfig = False
End Function

Private Sub xmlSave_addApplictaion(ByVal h As Integer, tabCnt As Integer, procDetail As T_PROCESSDETAILS)
    Dim q As String   ' "
    Dim i As Integer
    Dim argsStr As String
    Dim launchScript As String
    
    If procDetail.nVisibleWindows < 1 Then Exit Sub
    
    
    q = Chr(34)
    tabCnt = tabCnt + TAB_STEP
    ' <APPLICATION>
    Print #h, Tab(tabCnt); "<APPLICATION>"
        tabCnt = tabCnt + TAB_STEP
        
        ' <NAME> test1 </NAME>
        Print #h, Tab(tabCnt); "<NAME> " + Trim(procDetail.path) + Trim(procDetail.exeName) + " </NAME>"
        ' <ARGS> -arg1 -arg2 </ARGS>
        argsStr = Trim(Trim0(procDetail.arguments))
        If argsStr <> "" Then Print #h, Tab(tabCnt); "<ARGS> " + argsStr + " </ARGS>"
        launchScript = Trim(Trim0(procDetail.launcherScript))
        If launchScript <> "" Then Print #h, Tab(tabCnt); "<SCRIPT_LOCATION> " + launchScript + " </SCRIPT_LOCATION>"
        ' <WINDOWS>
        Print #h, Tab(tabCnt); "<WINDOWS>"
            tabCnt = tabCnt + TAB_STEP
            For i = 0 To procDetail.nVisibleWindows - 1
                Print #h, Tab(tabCnt); "<WINDOW top = " + q + Trim(str(procDetail.visibleWindows(i).reqTop)) + q + _
                                       " left = " + q + Trim(str(procDetail.visibleWindows(i).reqLeft)) + q + _
                                       " right = " + q + Trim(str(procDetail.visibleWindows(i).reqRight)) + q + _
                                       " bottom = " + q + Trim(str(procDetail.visibleWindows(i).reqBottom)) + q + _
                                       " state = " + q + stateString(CLng(procDetail.visibleWindows(i).reqStatus)) + q + " > <![CDATA[" + _
                                       Trim(Trim0(procDetail.visibleWindows(i).caption)) + " ]]> </WINDOW>"
                                       '''Trim(Trim0(procDetail.visibleWindows(i).reqCaption)) + " </WINDOW>"
                                       
            Next
            tabCnt = tabCnt - TAB_STEP
        Print #h, Tab(tabCnt); "</WINDOWS>"
        tabCnt = tabCnt - TAB_STEP
    Print #h, Tab(tabCnt); "</APPLICATION>"
    tabCnt = tabCnt - TAB_STEP
    
End Sub


Private Function stateString(code As Long) As String

    Select Case code
        Case SW_SHOWNORMAL
            stateString = "NORMAL"
        Case SW_SHOWMINIMIZED
            stateString = "MINIMIZED"
        Case Else
            stateString = "MAXIMIZED"
    End Select
    
End Function
