#ifdef vxWorks
#include <vxWorks.h>
#include <timexLib.h>
#include <ioLib.h>
#include "taskLib.h"
#include "moduleLib.h"
#include "loadLib.h"
#endif	/* vxWorks */

#ifdef WIN32
#include "e2t.h"
#include "iocsh.h"
#include <registryFunction.h>
#include <subRecord.h>
#include "epicsExport.h"
#endif  /* WIN32 */

#ifdef UNIX
#define INCLsemLibh
#define INCLvxLibh
#endif	/* UNIX */

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

/* TINE includes */
#include "prolog.h"
#include "rpctypes.h"
#include "errors.h"
#include "database.h"
#include "almsrv.h"
#include "toolkit.h"

#include "dbDefs.h"
#include "errlog.h"
#include "ellLib.h"
#include "fast_lock.h"
#include "dbAccess.h"
#include "dbBase.h"
#include "dbCommon.h"
#include "dbLock.h"
#include "recSup.h"
#include "devSup.h"
#include "drvSup.h"
#include "recGbl.h"
#include "special.h"
#include "dbStaticLib.h"
#include "dbEvent.h"
#include "ellLib.h"
#include "callback.h"
#include "freeList.h"
#include "cvtFast.h"

extern struct dbBase *pdbbase;

#define MAXLINE 80
typedef struct {		/* line output structure */
    char            out_buff[MAXLINE + 1];
    char           *pNext;
    char           *pLast;
    char           *pNexTab;
    char            message[128];
} TAB_BUFFER;

#ifndef MIN
#define MIN(x,y)        ((x < y)?x:y)
#endif
#ifndef MAX
#define MAX(x,y)        ((x > y)?x:y)
#endif

/* Defines */
#define CONFIG_FILE	"e2t.cfg"
#define TINE_FREE_PROPERTIES	5

/* Prototypes */
long tineGetNumRecords();
long tineGetRecords(NAME32 *pname);
long tineGetRecords();

long tineGetRecordNamesAndTypes();

long tineTest();
long tineGetRecordTypes();
int  tineGetFieldValue(char *pname, char *pprop, void *ptr, int tineFmt, int len, int *pCount);
int tineGetAlarmLimits(char *recName, ALARM_WATCH_THRESHOLDS *pThr);

long tinePutFieldValue(char *pname,char *pvalue);
short getTINEformat(int epicsFmt);

void KeepTineSrvAlive();
int GetDataBaseSize(char *filename);
int findcol(char *str,char *tag);
char *colptr(int col,char *str);

typedef struct devChainStruct
{
  char name[16];
  struct devChainStruct *next;
} devChain;

typedef struct {
  char  name[32];
  char  desc[96];
  char separater[2];
  devChain *devs;
  short fmt;
  short elem;
  int ndev;
} Tproperty;

int numProperties = 0;
int offsetComposites = 0;

typedef struct {
  char devName[32];
  char devProperty[32];
  int  prpLength;
  int  prpFormat;
  char prpDesc[32];
  int  numCmpPrps;
  NAME32 *cmpPrps;
  NAME32 *cmpDevPrps;
  NAME32 *cmpDevs;
  NAME16 *cmpAliasDevs;
  NAME32 *cmpDesc;
} COMPOSITE;

COMPOSITE *composites = NULL;
int ncomposites = 0;

int debug = 1;

int readStructureFile( char *filename, NAME32 **cmpPrps, NAME32 **cmpDevPrps, NAME32 **cmpDevs, NAME16 **cmpAliasDevs, NAME32 **cmpDesc, int *numCmpProperties);
int readCompositeFile(char *cmpFileName);
/* short getTINEformat(int epicsFmt); */
int fillDeviceNamesAndProperties(char *fec,char *server,NAME32 **devnames,int *numDevices,Tproperty **prp,int *numProperties);
int gtweqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);
int E2T();
