#include <vxWorks.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <timexLib.h>

/* TINE includes */
#include "rpctypes.h"
#include "errors.h"
#include "database.h"
#include "almsrv.h"

/*for open and close*/
#include <ioLib.h>

#include "dbDefs.h"
#include "errlog.h"
#include "ellLib.h"
#include "fast_lock.h"
#include "dbAccess.h"
#include "dbBase.h"
#include "dbCommon.h"
#include "dbLock.h"
#include "recSup.h"
#include "devSup.h"
#include "drvSup.h"
#include "recGbl.h"
#include "special.h"
#include "dbStaticLib.h"
#include "dbEvent.h"
#include "ellLib.h"
#include "callback.h"
#include "freeList.h"
#include "cvtFast.h"

extern struct dbBase *pdbbase;

#define MAXLINE 80
typedef struct {		/* line output structure */
    char            out_buff[MAXLINE + 1];
    char           *pNext;
    char           *pLast;
    char           *pNexTab;
    char            message[128];
} TAB_BUFFER;

#ifndef MIN
#define MIN(x,y)        ((x < y)?x:y)
#endif
#ifndef MAX
#define MAX(x,y)        ((x > y)?x:y)
#endif

/* Defines */
#define CONFIG_FILE	"e2t.cfg"

/* Prototypes */
long tineGetNumRecords();
long tineGetRecords(NAME32 *pname);
long tineGetRecords();
/* long tineGetProperties(char *pname, Tproperty *pprop); */

long tineGetRecordNamesAndTypes();

long tineTest();
long tineGetRecordTypes();
int  tineGetFieldValue(char *pname, char *pprop, void *ptr, int tineFmt, int *pCount);
int tineGetAlarmLimits(char *recName, ALARM_WATCH_THRESHOLDS *pThr);

long tinePutFieldValue(char *pname,char *pvalue);
static int tineFillProp(char *pname, DBADDR *paddr);
short getTINEformat(int epicsFmt);

void KeepTineSrvAlive();
int GetDataBaseSize(char *filename);
int findcol(char *str,char *tag);
char *colptr(int col,char *str);

typedef struct {
  char  name[8];
  char  desc[32];
  short fmt;
  short elem;
} Tproperty;

int numProperties = 0;

typedef struct {
  char devName[32];
  char devProperty[32];
  int  prpLength;
  int  prpFormat;
  char prpDesc[32];
  int  numCmpPrps;
  NAME32 *cmpPrps;
  NAME32 *cmpDevPrps;
  NAME32 *cmpDevs;
  NAME16 *cmpAliasDevs;
  NAME32 *cmpDesc;
} COMPOSITE;

COMPOSITE *composites = NULL;
int ncomposites = 0;

int debug = 1;

int readStructureFile( char *filename, NAME32 **cmpPrps, NAME32 **cmpDevPrps, NAME32 **cmpDevs, NAME16 **cmpAliasDevs, NAME32 **cmpDesc, int *numCmpProperties);
int readCompositeFile(char *cmpFileName);
/* short getTINEformat(int epicsFmt); */
int fillDeviceNamesAndProperties(char *fec,char *server,NAME32 **devnames,int *numDevices,Tproperty **prp,int *numProperties);
int gtweqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);
int E2T();
