/* tineFunc.c */
#include "tineFunc.h"

int	CA_OK  	       = 0;
int	ERRORnoDevice  = 1;
int	ERRORnoChannel = 2;
int	ERRORnoValue   = 3;

long tineGetRecords()
{
DBENTRY         dbentry;
DBENTRY         *pdbentry=&dbentry;
long            status;
short           c, co;

    for(c=0; c<MAX_RECORDS; c++) strcpy(tineRecS[c].recName, "");

    dbInitEntry(pdbbase,pdbentry);

    status = dbFirstRecordType(pdbentry);
    if(status) printf("No record description\n");

    c = 0;
    while(!status) {
        status = dbFirstRecord(pdbentry);
        while(!status) {
            strcpy(tineRecS[c].recName, dbGetRecordName(pdbentry));
            status = dbNextRecord(pdbentry);
            c++;
	    if(c >= MAX_RECORDS) {
		printf("WARNING !!! Limit of records reached (%d). Contact your admin please !!!!!\n\n\n", c);
		c = 0;
	    }
        }
        status = dbNextRecordType(pdbentry);
    }

    dbFinishEntry(pdbentry);

    DZK(printf("Nr\tChannel Access Name\n");
    for(co=0; co < c; co++) printf("[%d]\t%s\t%s\n",co,tineRecS[co].recName);) 

    return (c);
}


long tineGetProperties(char *pname)
{
static TAB_BUFFER msg_Buff;
TAB_BUFFER      *pMsgBuff = &msg_Buff;
DBADDR    	addr;
long            status;
int		c;

    DZK(printf("add to the generic list of props >>> %s:\n",pname);)

    for(c=0; c<MAX_RECORDS; c++) strcpy(tineRecS[c].propName, "");

    status = dbNameToAddr(pname, &addr);
    if(status) {
	printf("error no record with this name <%s>\n",pname);
        errMessage(status," dbNameToAddr failed");
        return(0);
    }
    status = tineFillProp(pname, &addr, pMsgBuff);
    if(status <= 0) return(0);

    return (status);
}

static int tineFillProp( char *pname,DBADDR *paddr, TAB_BUFFER *pMsgBuff)
{
dbFldDes  	*pdbFldDes = paddr->pfldDes;
dbRecordType    *pdbRecordType = pdbFldDes->pdbRecordType;
short		i;
DBENTRY		dbentry;
DBENTRY		*pdbentry = &dbentry;
long		status;
int		co;

    printf(">>> tineFillProp\n");
    co = 0;
    dbInitEntry(pdbbase,pdbentry);
    status = dbFindRecord(pdbentry,pname);
    if(status) {
		errMessage(status,pname);
		return(-1);
    }
    for (i = 0; i <= pdbRecordType->no_fields - 1; i++) {
		pdbFldDes = pdbRecordType->papFldDes[pdbRecordType->sortFldInd[i]];
		if(pdbFldDes->field_type != DBF_NOACCESS) {
			if((strcmp(pdbFldDes->name, "DESC") == 0) || (strcmp(pdbFldDes->name, "VAL") == 0)) {
				strcpy(tineRecS[co].propName, pdbFldDes->name);
				tineRecS[co].propName[4] = '\0';
				tineRecS[co].propType = DBF_STRING; /* convert from pdbFldDes->field_type;*/
				tineRecS[co].propElem = 40;
				co++;
			}
		}
			
		/* pfield = ((char *)paddr->precord) + pdbFldDes->offset; */
    }

    dbFinishEntry(pdbentry);
    return (co);
}

int tineGetFieldValue(char *pname, char *pprop, void *ptr, int tineFmt)
{
long 		buffer[100];
long 		*pbuffer=&buffer[0];
DBADDR 		addr;
long		status = 0;
long		options,no_elements;
int		nr, getUnixTime = FALSE;
char		locName[40] = "";

    DZK(printf("tineGetFieldValue name = %s  prop = %s  ptr = %x  tineFmt = %d\n",pname,pprop,ptr,tineFmt);)

    sprintf(locName, "%s.%s", pname, pprop);
    DZK(printf("locName = %s\n",locName);)

    status=dbNameToAddr(&locName[0],&addr);
    if(status) {
	errMessage(status," dbNameToAddr failed");
	printf(" dbNameToAddr failed >>> no record with name %s\n", locName);
	return(ERRORnoChannel);
    }

    if( tineFmt == CF_LONG && addr.precord->dtyp == 2 ) getUnixTime = TRUE;
    if( getUnixTime ) {
	sprintf(locName, "%s.%s", pname, "SVAL");
        
    	DZK(printf("for Event Time String locName = %s\n",locName);)
	status=dbNameToAddr(&locName[0],&addr);
	if(status) {
	    errMessage(status," dbNameToAddr failed");
            printf(" dbNameToAddr failed >>> no record with name %s\n", locName);
            return(ERRORnoChannel);
   	}
    } 

    no_elements=MIN(addr.no_elements,((sizeof(buffer))/addr.field_size));
    options=0;
    if(addr.dbr_field_type==DBR_ENUM) {
	status=dbGetField(&addr,DBR_STRING,pbuffer,&options,&no_elements,NULL);
    } else {
	status=dbGetField(&addr,addr.dbr_field_type,pbuffer,&options,&no_elements,NULL);
    }
    
    if( status != 0 ) {
	printf(" dbGetField failed with status = %d\n", status);
	return(ERRORnoValue);
    }

    DZK(printf("Record %s >>> addr.dbr_field_type = %d\n", locName /*tineRecS[nr].recName*/, addr.dbr_field_type );)

    switch (addr.dbr_field_type) {
    case DBR_STRING:
    case DBR_CHAR:
    case DBR_UCHAR:
    case DBR_ENUM:
	DZK(printf("DBR_STRING %s \n", pbuffer);)
	switch (tineFmt) {
	case CF_SHORT: 	*(short *)ptr = atoi(pbuffer); status = 0; break;
	case CF_LONG: 	*(long *)ptr = atoi(pbuffer); status = 0; break;
	case CF_FLOAT: 
	case CF_DOUBLE: *(float *)ptr = atof(pbuffer); status = 0; break;
	case CF_NAME32: strncpy(ptr, buffer, 32); status = 0; break;
	case CF_NAME16: strncpy(ptr, buffer, 16); status = 0; break;
	case CF_TEXT: 	strncpy(ptr, buffer, 40); status = 0; break;
	default: 	status = illegal_format;
	}
	break;
    case DBR_SHORT:
    case DBR_USHORT:
	DZK(printf("DBR_SHORT %d\n", *pbuffer);)
	switch (tineFmt) {
	case CF_SHORT: 	*(short *)ptr = *pbuffer; status = 0; break; 
	case CF_LONG:	*(long *)ptr = *pbuffer; status = 0; break;
	case CF_FLOAT:	*(float *)ptr = *(float *)pbuffer; status = 0; break;  
	case CF_DOUBLE:	*(float *)ptr = *(double *)pbuffer; status = 0; break;
	case CF_NAME16: if( addr.field_size < 16) sprintf(ptr, "%d", pbuffer); status = 0; break;
	case CF_NAME32: if( addr.field_size < 32) sprintf(ptr, "%d", pbuffer); status = 0; break;
	case CF_TEXT:   if( addr.field_size < 40) sprintf(ptr, "%d", pbuffer); status = 0; break;
	default:	status = illegal_format;
	}
	break;
    case DBR_LONG:
    case DBR_ULONG:
	DZK(printf("DBR_LONG %d\n", *pbuffer);)
	switch (tineFmt) {
	case CF_SHORT:	*(short *)ptr = *(short *)pbuffer; status = 0; break;
	case CF_LONG:	*(long *)ptr = *pbuffer; status = 0; break;
	case CF_FLOAT:
	case CF_DOUBLE:	*(float *)ptr = *(float *)pbuffer; status = 0; break;
	case CF_NAME16:	if( addr.field_size < 16) sprintf(ptr, "%d", pbuffer); status = 0; break;
	case CF_NAME32:	if( addr.field_size < 32) sprintf(ptr, "%d", pbuffer); status = 0; break;
	case CF_TEXT:	if( addr.field_size < 40) sprintf(ptr, "%d", pbuffer); status = 0; break;
	default:	status = illegal_format;
	}
	break;
    case DBR_FLOAT:
	DZK(printf("DBR_FLOAT %f\n", *pbuffer);)
	switch (tineFmt) {
	case CF_SHORT:	*(short *)ptr = *(short *)pbuffer; status = 0; break;
	case CF_LONG:   *(long *)ptr = *(long *)pbuffer; status = 0; break;
	case CF_FLOAT:	*(float *)ptr = *(float *)pbuffer; status = 0; break;
	case CF_DOUBLE:	*(double *)ptr = *(double *)pbuffer; status = 0; break;
	case CF_NAME16:	
	case CF_NAME32:
	case CF_TEXT:	cvtFloatToString(*(float *)pbuffer, ptr, NULL); status = 0; break;
	default:	status = illegal_format;
	}
	break;
    case DBR_DOUBLE:
	DZK(printf("DBR_DOUBLE %f\n", *pbuffer);)
	switch (tineFmt) {
        case CF_SHORT:  *(short *)ptr = *(short *)pbuffer; status = 0; break;
        case CF_LONG:   *(long *)ptr = *(long *)pbuffer; status = 0; break;
        case CF_FLOAT:	*(float *)ptr = *(float *)pbuffer; status = 0; break;
        case CF_DOUBLE: *(double *)ptr = *(double *)pbuffer; status = 0; break;
	case CF_NAME16:
	case CF_NAME32:
	case CF_TEXT:	cvtDoubleToString(*(double *)pbuffer, ptr, NULL); status = 0; break;
    	default:        status = illegal_format;
        }
	break;
    case DBR_PUT_ACKT:
    case DBR_PUT_ACKS:
    case DBR_NOACCESS:
    default: 		
	DZK(printf("default\n");)
	status = ERRORnoValue;
    }

    return(status);
}

long tinePutFieldValue(char *pname,char *pvalue)
{
/* declare buffer long just to ensure correct alignment */
DBADDR addr;
long	  status;

    /* make sure value was passed*/
    if(pvalue==0) {
	errMessage(0L,"No value was specified");
	return(1);
    }
    status=dbNameToAddr(pname,&addr);
    if(status) {
         errMessage(status,"dbNameToAddr error");
         return(status);
    }
    /* For enumerated types must allow for ENUM rather than string*/
    /* If entire field is digits then use DBR_ENUM else DBR_STRING*/
    if((addr.dbr_field_type==DBR_ENUM) && (*pvalue!=0)
    &&  (strspn(pvalue,"0123456789")==strlen(pvalue))) {
	    short value;

	    sscanf(pvalue,"%hu",&value);
	    status=dbPutField(&addr,DBR_ENUM,&value,1L);
    } else {
	status=dbPutField(&addr,DBR_STRING,pvalue,1L);
    }
    if(status) {
         errMessage(status,"dbPutField error");
         return(status);
    }
    /* status=(long) tineGetFieldValue(pname, "VAL"); */
    return(status);
}

static char *dbf[DBF_NTYPES]={
	"STRING","CHAR","UCHAR","SHORT","USHORT","LONG","ULONG",
	"FLOAT","DOUBLE","ENUM","MENU","DEVICE",
	"INLINK","OUTLINK","FWDLINK","NOACCESS"};

static char *dbr[DBR_ENUM+2]={
	"STRING","CHAR","UCHAR","SHORT","USHORT","LONG","ULONG",
	"FLOAT","DOUBLE","ENUM","NOACCESS"};

static void tinePrint(long status,DBADDR *paddr, int count)
{
dbFldDes    *pdbFldDes = (dbFldDes *)paddr->pfldDes;;

    if(status!=0) errMessage(status,"dbNameToAddr error");

    strcpy(tineRecS[count].recType, pdbFldDes->pdbRecordType->name);
    printf("\t\tType: %s\n",pdbFldDes->pdbRecordType->name);
}

static void tineMsgOut(TAB_BUFFER *pMsgBuff)
{
int             len;
int             err = 0;
char           *pmsg = pMsgBuff->message;
static int      last_tabsize;
static int	tab_size = 4;

    /* init if first time */
    if (!(pMsgBuff->pNext)) dbpr_init_msg(pMsgBuff, tab_size);

    if (tab_size != last_tabsize) pMsgBuff->pNexTab = pMsgBuff->out_buff + tab_size;

    last_tabsize = tab_size;
    /* flush output if NULL string command */
    if (*pmsg == 0) {
		dbpr_msg_flush(pMsgBuff, tab_size);
		return;
    }
    /* truncate if too long */
    if ((len = strlen(pmsg)) > MAXLINE) err = 1;
    len = ((len > MAXLINE) ? MAXLINE : len);

    dbpr_insert_msg(pMsgBuff, len, tab_size);

    /* warn if msg gt 80 */
    if (err == 1) {
		len = strlen(pmsg);
		sprintf(pmsg, "tineMsgOut: ERROR - msg length=%d limit=%d ", len, MAXLINE);
		dbpr_insert_msg(pMsgBuff, len, tab_size);
		return;
    }
    return;
}

static void dbpr_init_msg(TAB_BUFFER *pMsgBuff,int tab_size)
{
    pMsgBuff->pNext = pMsgBuff->out_buff;
    pMsgBuff->pLast = pMsgBuff->out_buff + MAXLINE;
    pMsgBuff->pNexTab = pMsgBuff->out_buff + tab_size;
    return;
}

static void dbpr_insert_msg(TAB_BUFFER *pMsgBuff,int len,int tab_size)
{
    int             current_len;
    int             n;
    int             tot_line;
    char           *pmsg = pMsgBuff->message;
    current_len = strlen(pMsgBuff->out_buff);
    tot_line = current_len + len;

    /* flush buffer if overflow would occor */
    if (tot_line > MAXLINE)
	dbpr_msg_flush(pMsgBuff, tab_size);

    /* append message to buffer */
    n = 0;
    while ((*pmsg) && (n < len)) {
	*pMsgBuff->pNext++ = *pmsg++;

	/* position to next tab stop */
	if (*(pMsgBuff->pNexTab - 1) != '\0')
	    pMsgBuff->pNexTab = pMsgBuff->pNexTab + tab_size;
	n++;
    }

    /* fill spaces to next tab stop */
    while (*(pMsgBuff->pNexTab - 1) != ' '
	    && pMsgBuff->pNext < pMsgBuff->pLast) {
	*pMsgBuff->pNext++ = ' ';
    }
    return;

}

static void dbpr_msg_flush(TAB_BUFFER *pMsgBuff,int tab_size)
{

    /* skip print if buffer empty */
    if (pMsgBuff->pNext != pMsgBuff->out_buff) {
	printf("%s\n", pMsgBuff->out_buff); 
    }

    memset(pMsgBuff->out_buff,'\0', (int) MAXLINE + 1);
    pMsgBuff->pNext = pMsgBuff->out_buff;
    pMsgBuff->pNexTab = pMsgBuff->out_buff + tab_size;
    return;
}

int tineGetRecordFromFile(void)
{
int c,co;
FILE *fp = NULL;
char str[32];
static char RecordFilename[32];
	
	for(c=0; c<MAX_RECORDS; c++) {
		strcpy(tineRecS[c].recName, "");
	}

	if (strlen(RecordFilename) == 0) {
		sprintf(RecordFilename,"%s","freeRecord.list");
		printf("file to open = %s\n", RecordFilename);
	}
	if ((fp=fopen(RecordFilename,"r")) == NULL) {
		printf("no such file\n");
		return -1;
	}

	c = 0;
	while (fscanf(fp,"%s",str) != EOF) {
		if (strchr("#",str[0])) continue;
		strcpy(tineRecS[c].recName, str);
		c++;
	}

	if (feof(fp)) fclose(fp);

	DZK(printf("Nr\t\tChannel Access Name\n");
	for(co=0; co < c; co++) printf("[%d]\t%s\t%s\n",co,tineRecS[co].recName);)

	return c;
}

int getPropsNotInclude(void)
{
int c;
FILE *fp = NULL;
char str[8];
static char PropsFilename[32];
	
	if (strlen(PropsFilename) == 0) {
		sprintf(PropsFilename,"%s","propsNotIncl.list");
		printf("file to open = %s\n", PropsFilename);
	}
	if ((fp=fopen(PropsFilename,"r")) == NULL) {
		printf("no such file\n");
		return -1;
	}

	c = 0;
	while (fgets(str,7,fp) != NULL) {
		if (strchr("#",str[0])) continue;      /* comment line(s) */
		printf("%d\t%s\n",c,str);
		c++;
	}

	if (feof(fp)) fclose(fp);
	return 1;
}
