/* tineFunc.h */
#include <vxWorks.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <timexLib.h>

/* TINE includes */
#undef BYTE
#include "rpcdefs.h"
#include "errors.h"

/*for open and close*/
#include <ioLib.h>

#include "dbDefs.h"
#include "errlog.h"
#include "ellLib.h"
#include "fast_lock.h"
#include "dbAccess.h"
#include "dbBase.h"
#include "dbCommon.h"
#include "dbLock.h"
#include "recSup.h"
#include "devSup.h"
#include "drvSup.h"
#include "recGbl.h"
#include "special.h"
#include "dbStaticLib.h"
#include "dbEvent.h"
#include "ellLib.h"
#include "callback.h"
#include "freeList.h"
#include "cvtFast.h"

extern struct dbBase *pdbbase;

#define DZK(c)   if(verboseTINE) {c}
long verboseTINE = 0;

#define MAXLINE 80
typedef struct {		/* line output structure */
    char            out_buff[MAXLINE + 1];
    char           *pNext;
    char           *pLast;
    char           *pNexTab;
    char            message[128];
} TAB_BUFFER;

#define	MAX_RECORDS	3500
#define	MAX_PROPS	10

typedef struct {
	char	recName[32];
	int	recType;
	char	propName[5];
        short   propType;
        short   propElem;
} REC_STRUCT;

typedef struct {
	short		xshort;
	long		xlong;
	float 		xfloat;
	double		xdouble;
	char		xstring[40];
} VAL_STRUCT;

REC_STRUCT tineRecS[MAX_RECORDS];

#ifndef MIN
#define MIN(x,y)        ((x < y)?x:y)
#endif
#ifndef MAX
#define MAX(x,y)        ((x > y)?x:y)
#endif


/* Prototypes */
long tineGetRecords();
long tineGetRecordNamesAndTypes();

long tineTest();
long tineGetRecordTypes();
long tineGetProperties();
int  tineGetFieldValue(char *pname, char *pprop, void *ptr, int tineFmt);
long tinePutFieldValue(char *pname,char *pvalue);


long tine_dbgrep(char *pmask);	/*list records with mask*/
long tine_dbpr(char *pname,int interest_level); /*print record*/
long tine_dbtr(char *pname);		/*test record*/
long tine_dbior(char	*pdrvName,int type); /*I/O report */
int tine_dbhcr(char *filename);		/*Hardware Configuration Report*/

/* Local Routines */
static int tineFillProp(char *pname, DBADDR *paddr, TAB_BUFFER *pMsgBuff);
static int tineFields(char *pname, DBADDR *paddr, TAB_BUFFER *pMsgBuff, int tab_size);
static void tineMsgOut(TAB_BUFFER *pMsgBuff);
static void dbpr_init_msg(TAB_BUFFER *pMsgBuff,int tab_size);
static void dbpr_insert_msg(TAB_BUFFER *pMsgBuff,int len,int tab_size);
static void dbpr_msg_flush(TAB_BUFFER *pMsgBuff,int tab_size);

