Attribute VB_Name = "spectrum"
Option Explicit

'Global CSVPropInfo(200) As HistDisplayType, NOCXCSVProps%
'Global ServerPropInfo() As HistDisplayType, NOCXServerProps%
'Global OCXPropertyListFlag%, OCXFormCaption$, SpectrumOCXPath$
Global Const MaxSubSystems = 15

Global referenceId&, spectrumId&

Global HistoryOCXPath$, OCXFlag As Boolean, OCXLoadedFlag As Boolean
Global ConfigFilesLoaded As Boolean

Type SpectrumSubsystemType
    ConfigDirectory As String
    ConfigFile As String
    MachineFile As String
    Description As String
End Type
Global MachineInfo(MaxSubSystems) As SpectrumSubsystemType
Global NMachines%, SelectedMachine%

Global SpectrumSubSystemInfo(MaxSubSystems) As SpectrumSubsystemType
Global OCXSubSystemInfo As SpectrumSubsystemType
Global NSubSystems%, SelectedSubSystem%
Global Const MKKMachineIndex = 4

Global SpectrumLiveTS&, SpectrumLiveReferenceTS&
Global ConfigFileDirectory$

Global Const RelativeScale = 0
Global Const AbsoluteScale = 1
Global ScalingMode%, SwitchingScalingFlag As Boolean
Global ShowExtraDisplay%, MenuExtraProperties As Boolean
Global nItemsSelected%, nExtraItemsSelected%, ExtraComboPropIndexSAVE%, ComboPropIndexSAVE%

Global itemSelected As Integer
Global zLevel%
Global Const MaxZooms = 20
Global Const HistoryIndex = 0
Global Const ExtraIndex = 1
Global Const AcceleratorIndex = 2
Global Const SpectrumPlot = 5
Global Const RefreshAll_Flag = -1
Global Const RefreshSelected_Flag = 1

Public Type SelectedDataItem
    deviceContext As String
    deviceGroup As String
    deviceProperty As String
    arcServer As String
    arcProperty As String
    hstServer As String
    hstProperty As String
    deviceName As String
    ExtendedDevNameFlag As Boolean
    ExtendedDevName As String
    ExtraPropComboIndex As Integer
    DeviceTag As String
    LastReadArchiver As Boolean
    index As Integer
    TagIndex As Integer
    listIndex As Integer
    
    PlotArrayIndex As Integer
    PropArrayIndex As Integer
    ComboBoxListIndex As Integer
    PropListIndex As Integer
    
    color As Long
    displayId As Long
    linkId As Long
    
    Description As String
    dataThresholdFlag As Boolean
    RawData() As Single
    ScaledData() As Single
    RawTS() As Long
    LiveData As Single ' for LIVE data
    
    hasData As Boolean
    ReScale As Boolean
    npoints As Integer
    TotalPoints As Long
    TotalHistPoints As Long
    TotalArchPoints As Long
    PropLink As Integer
    PropShort As String

    ' COPIED FROM ARCHIVE READER!
    VMax As Double ' Default Values
    VMin As Double ' for scaling
    VScale As Double
    VOffset As Double
    VPlot As String
    VUnit As String
    '
    MaxValue As Double
    MinValue As Double
    'Offset As Integer
    '
    SelectedMaxValue As Double ' When reading in TextBox stuff...
    SelectedMinValue As Double ' For scaling....
    SelectedOffset As Double ' For scaling....
    SelectedVMode As String ' Plotted as Log/Lin...
    SelectedVModeIndex As Integer ' Plotted as Log/Lin...
    PlotMaxValue As Double ' Actual Values (especially for AUTOSCALE, needed for ARRAY mode)
    PlotMinValue As Double ' for scaling
    PlotOffset As Double ' for scaling
    PlotZeroOffset As Double ' for calculating BACK
    PlotDelta As Double '
    PlotScale As Double '
    PlotAutoScale As Boolean

    YScale As Single
End Type

Type DataSource
  Description As String
  deviceContext As String
  deviceGroup As String
  deviceName As String
  deviceProperty As String
  ExtDeviceNameDevice As String
  ExtDeviceNameProperty As String
  ExtDeviceNameFlag As Boolean
  ExtraPropComboIndex As Integer
  DeviceTag As String
  hstServer As String
  hstProperty As String
  hstShortTermDepth As Integer
  hstLongTermDepth As Integer
  arcServer As String
  arcProperty As String
  accessRate As Integer
  deviceData() As Single
  DeviceNames() As String
  ExtendedDeviceNames() As String
  DataSize As Long
  dataThresholdType As Integer
  dataThresholdSource As String
  dataThresholdHigh() As Single
  dataThresholdLow() As Single
  deviceOperationsExe As String
  dataMax As Single
  dataMin As Single
  dataEGU As String
  ShortName As String
  GridCaption As String
  linkId As Long
  appendToPrevious As Boolean
  reverseArray As Boolean
  infoDone As Boolean
  LastReadArchiver As Boolean
    PropLink As Integer
    PropShort As String
    YScale As Single
End Type

Global Const threshold_none = 0
Global Const threshold_single = 1
Global Const threshold_file = 2
Global Const threshold_extern = 3
Global Const threshold_app = 4

Global MaxSelectedItems
Global Const MaxDIMSelectedItems = 10

Global Const MAX_BUFFER_SIZE = 8000
Global dsrc As DataSource
Global ndsrc As Integer
Global Const MaxNDSrc% = 100
Global nMachineStates As Integer
Global msrc(MaxDIMSelectedItems) As DataSource
Global sDI(MaxDIMSelectedItems) As SelectedDataItem
Global dsrcListItem As SelectedDataItem

Global mDI(MaxDIMSelectedItems) As SelectedDataItem

Global ExtraDI(MaxDIMSelectedItems) As SelectedDataItem, ExtraItemFlag As Boolean

Global SaveScales(MaxDIMSelectedItems + 1) As SelectedDataItem

Global dsrcList(100) As DataSource
Global dsrcXref(100) As Integer
Global dsrcListIndex As Integer
Global dsrcNumberInGroup As Integer
Global dsrcDataBuffer(MAX_BUFFER_SIZE) As Single
Global dsrcDevNames(MAX_BUFFER_SIZE) As String
Global gStartTime As Long, gStopTime As Long
Global gStripChartDepth As Long
Global gSpectrumNpts As Integer
Global g_selectedItem%, selectedPlot%
Global PlotColors&(MaxDIMSelectedItems)

Global PropSelections(5) As SelectedDataItem, NPropSelections%, PropListIndex%(4), PropComboIndex%(4)

Global SelectedTS&, CursorTS&

Global zmaxbuf#(20), zminbuf#(20), ymaxbuf#(20, 3), yminbuf#(20, 3)

Global SettingUp As Boolean

' REDUCE for Kaul's slow PC....
Global Const MaxPlotPoints = 2000
Global Const MaxGetDataPointsARCH = 1000
Global Const MaxGetDataPointsHIST = 1000
Global Const MaxDataPointsAPPEND = MaxPlotPoints - MaxGetDataPointsHIST - 2
Global AppendTimeIncrement%(3), AppendTimeCounter%(3), AppendTotalCounter%(3)


Function readMACHINESourceInfo(ByVal configFileName As String) As Integer
Dim cc As Integer, i As Integer, n As Integer
Dim siz As Long
Dim ds As String
Dim ndn As Integer
Dim pqs As PropertyQueryEx
Dim done As Boolean
Dim con_col As Integer, srv_col As Integer, prp_col As Integer, siz_col As Integer
Dim hstsrv_col As Integer, hstprp_col As Integer, dsc_col As Integer, max_col As Integer, min_col As Integer
Dim egu_col As Integer, arcsrv_col As Integer, arcprp_col As Integer, shortname_col As Integer
Dim a$, tok$, tmpText$

On Error GoTo readMachineSourceInfoErr
Open configFileName For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      srv_col = colptr(a$, "SERVER")
      prp_col = colptr(a$, "PROPERTY")
      hstsrv_col = colptr(a$, "HSTSERVER")
      hstprp_col = colptr(a$, "HSTPROPERTY")
      arcsrv_col = colptr(a$, "ARCSERVER")
      arcprp_col = colptr(a$, "ARCPROPERTY")
      dsc_col = colptr(a$, "DESCRIPTION")
      max_col = colptr(a$, "MAX")
      min_col = colptr(a$, "MIN")
      egu_col = colptr(a$, "EGU")
      shortname_col = colptr(a$, "SHORTNAME")
      done = True
    Else
        With msrc(i)
            If con_col >= 0 Then .deviceContext = getcol(a$, con_col) Else .deviceContext = ""
            If srv_col >= 0 Then .deviceGroup = getcol(a$, srv_col) Else .deviceGroup = ""
            If prp_col >= 0 Then .deviceProperty = getcol(a$, prp_col) Else .deviceProperty = ""
            If siz_col >= 0 Then .DataSize = Val(getcol(a$, siz_col)) Else msrc(i).DataSize = 1
            If hstsrv_col >= 0 Then .hstServer = getcol(a$, hstsrv_col) Else .hstServer = ""
            If hstprp_col >= 0 Then .hstProperty = getcol(a$, hstprp_col) Else .hstProperty = ""
            If arcsrv_col >= 0 Then .arcServer = getcol(a$, arcsrv_col) Else .arcServer = ""
            If arcprp_col >= 0 Then .arcProperty = getcol(a$, arcprp_col) Else .arcProperty = ""
            If dsc_col >= 0 Then .Description = getcol(a$, dsc_col) Else .Description = ""
            If max_col >= 0 Then .dataMax = Val(getcol(a$, max_col))
            If min_col >= 0 Then .dataMin = Val(getcol(a$, min_col))
            If egu_col >= 0 Then .dataEGU = getcol(a$, egu_col)
            If shortname_col >= 0 Then .ShortName = getcol(a$, shortname_col) Else .ShortName = ""
        End With
      i = i + 1
    End If
  End If
Loop While (Not EOF(1)) And (i < 10)
Close 1

nMachineStates = i

For i% = 0 To nMachineStates - 1
    With msrc(i%)
        .DataSize = 1
        ds = "/" + .deviceContext + "/" + .deviceGroup
        'If Len(.hstServer) = 0 Then .hstServer = ds
        'If Len(.hstProperty) = 0 Then .hstProperty = .deviceProperty + ".HIST"
        If Len(.hstProperty) > 0 Then
            If InStr(1, .hstProperty, ".HIST") = 0 Then .hstProperty = .hstProperty + ".HIST"
        End If
        
        If .ShortName = "" Then
            tmpText$ = .deviceProperty
        Else
            tmpText$ = .ShortName
        End If
    
        If .dataEGU <> "" Then
            tmpText$ = tmpText$ + "    (" + .dataEGU + ")"
        End If
        .GridCaption = tmpText$
    End With
Next i%

readMACHINESourceInfo = 0
Exit Function
readMachineSourceInfoErr:
readMACHINESourceInfo = tine.file_error
Exit Function
End Function
Function readThresholdValues(ByVal fn As String, hvarray() As Single, lvarray() As Single) As Integer
Dim cc As Integer, i As Integer, n As Integer, p As Integer
Dim ffn As String, a$, s$, tok$, args() As String, toks() As String
Dim done As Boolean
Dim hval_col As Integer, lval_col As Integer, dev_col As Integer
Dim dout As DBLK, din As DBLK
Dim dnam As String, dprp As String

If UCase(Right$(fn, 4)) <> ".CSV" Then ' assume fn points to a full device name
  i = InStr(fn, "[")
  If i > 0 Then
    dnam = Left(fn, i - 1)
    dprp = Mid(fn, i + 1, Len(fn) - i - 1)
    dout.dArrayLength = UBound(hvarray) + 1: dout.dFormat = CF_FLOAT
    din.dArrayLength = 0: din.dFormat = CF_NULL
    cc = T_EXECLINK(dnam, dprp, dout, hvarray(0), din, 0, CA_READ, 800)
    If cc = 0 Then
'     For p = 0 To UBound(hvarray): lvarray(p) = -hvarray(p): Next
      readThresholdValues = threshold_extern
    Else
      GoTo readThresholdValuesErr
    End If
    Exit Function
  End If
End If

On Error GoTo readThresholdValuesErr
ffn = App.Path + "\" + fn
Open ffn For Input Access Read Shared As #2
n = 0
Do
  Line Input #2, a$
  tok$ = Left$(a$, 2)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      hval_col = colptr(a$, "HIGH")
      lval_col = colptr(a$, "LOW")
      dev_col = colptr(a$, "DEVICE")
      done = True
    Else
      If n > UBound(hvarray) Then
        MsgBox "Threshold array out of bounds !"
        GoTo readThresholdValuesErr
      End If
      If hval_col >= 0 Then hvarray(n) = getcol(a$, hval_col)
      If lval_col >= 0 Then lvarray(n) = getcol(a$, lval_col)
      'later use the device column to match a name to a number ...
      n = n + 1
    End If
  End If
Loop While Not EOF(2)
Close 2
readThresholdValues = threshold_file
Exit Function
readThresholdValuesErr:
readThresholdValues = -1
ReDim hvarray(0): ReDim lvarray(0)
Exit Function
End Function
Function readINITSourceInfo(ByVal configFileName As String, cmdString As String) As Integer
Dim cc As Integer, i As Integer, n As Integer, p As Integer
Dim siz As Long
Dim ds As String
Dim ndn As Integer
Dim pqs As PropertyQueryEx
Dim done As Boolean
Dim con_col As Integer, srv_col As Integer, prp_col As Integer, siz_col As Integer
Dim hstsrv_col As Integer, hstprp_col As Integer, dsc_col As Integer, max_col As Integer, min_col As Integer
Dim egu_col As Integer, arcsrv_col As Integer, arcprp_col As Integer, append_col As Integer
Dim thresh_high_col As Integer, thresh_low_col As Integer, tag_col As Integer
Dim a$, s$, tok$, args() As String, toks() As String
Dim AppStr As String
Dim v As Single

' defaults :
dsrc.deviceContext = "HERA"
'dsrc.deviceGroup = "HEVakMLayer"
'dsrc.deviceProperty = "AbsTempN"
'dsrc.deviceGroup = "HEPBPM"
'dsrc.deviceProperty = "ORBIT.X"
dsrc.accessRate = 1000

If Len(cmdString) > 0 Then
    args = Split(cmdString)
    For i = 0 To UBound(args)
      toks = Split(args(i), "=")
       If UBound(toks) <> 1 Then GoTo readDataSourceInfoErr
      Select Case LCase(Left(args(i), 3))
        Case "con":
          dsrc.deviceContext = Trim$(toks(1))
        Case "srv":
          dsrc.deviceGroup = Trim$(toks(1))
        Case "prp":
          dsrc.deviceProperty = Trim$(toks(1))
        Case "siz":
          dsrc.DataSize = Val(toks(1))
        Case "hstsrv":
          dsrc.hstServer = Trim$(toks(1))
        Case "hstprp":
          dsrc.hstProperty = Trim$(toks(1))
        Case "arcsrv":
          dsrc.arcServer = Trim$(toks(1))
        Case "arcprp":
          dsrc.arcProperty = Trim$(toks(1))
        Case "dsc":
          dsrc.Description = Trim$(toks(1))
        Case "max":
          dsrc.dataMax = Val(Trim$(toks(1)))
        Case "min":
          dsrc.dataMin = Val(Trim$(toks(1)))
        Case "high":
          dsrc.dataThresholdSource = Trim$(toks(1))
        Case "low":
          dsrc.dataThresholdSource = Trim$(toks(1))
        Case "egu":
          dsrc.dataEGU = Trim$(toks(1))
      End Select
    Next
    ndsrc = 1
    ReDim dsrc.dataThresholdHigh(0)
    ReDim dsrc.dataThresholdLow(0)
    dsrcList(0) = dsrc
    GoTo DataSourceInfoDone
End If

On Error GoTo readDataSourceInfoErr
Open configFileName For Input Access Read Shared As #1
n = 0
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      srv_col = colptr(a$, "SERVER")
      prp_col = colptr(a$, "PROPERTY")
      siz_col = colptr(a$, "SIZE")
      hstsrv_col = colptr(a$, "HSTSERVER")
      hstprp_col = colptr(a$, "HSTPROPERTY")
      arcsrv_col = colptr(a$, "ARCSERVER")
      arcprp_col = colptr(a$, "ARCPROPERTY")
      dsc_col = colptr(a$, "DESCRIPTION")
      max_col = colptr(a$, "MAX")
      min_col = colptr(a$, "MIN")
      egu_col = colptr(a$, "EGU")
      append_col = colptr(a$, "APPEND")
      thresh_high_col = colptr(a$, "HIGH")
      thresh_low_col = colptr(a$, "LOW")
      tag_col = colptr(a$, "TAG")
      done = True
    Else
      If con_col >= 0 Then dsrc.deviceContext = getcol(a$, con_col)
      If srv_col >= 0 Then
        dsrc.deviceGroup = getcol(a$, srv_col)
        p = InStr(dsrc.deviceGroup, "/")
        If p > 0 Then
          dsrc.deviceName = Right$(dsrc.deviceGroup, Len(dsrc.deviceGroup) - p)
          dsrc.deviceGroup = Left$(dsrc.deviceGroup, p - 1)
        End If
      End If
      If prp_col >= 0 Then dsrc.deviceProperty = getcol(a$, prp_col)
      If siz_col >= 0 Then dsrc.DataSize = Val(getcol(a$, siz_col))
      If hstsrv_col >= 0 Then dsrc.hstServer = getcol(a$, hstsrv_col)
      If hstprp_col >= 0 Then dsrc.hstProperty = getcol(a$, hstprp_col)
      If arcsrv_col >= 0 Then dsrc.arcServer = getcol(a$, arcsrv_col)
      If arcprp_col >= 0 Then dsrc.arcProperty = getcol(a$, arcprp_col)
      If dsc_col >= 0 Then dsrc.Description = getcol(a$, dsc_col)
      If max_col >= 0 Then dsrc.dataMax = Val(getcol(a$, max_col))
      If min_col >= 0 Then dsrc.dataMin = Val(getcol(a$, min_col))
      If egu_col >= 0 Then dsrc.dataEGU = getcol(a$, egu_col)
      If tag_col >= 0 Then dsrc.DeviceTag = getcol(a$, tag_col)
      If Len(dsrc.DeviceTag) > 0 Then dsrc.DeviceTag = dsrc.DeviceTag + "/"
      If thresh_high_col >= 0 Then dsrc.dataThresholdSource = getcol(a$, thresh_high_col)
      ReDim dsrc.dataThresholdHigh(0)
      If thresh_low_col >= 0 Then dsrc.dataThresholdSource = getcol(a$, thresh_low_col)
      ReDim dsrc.dataThresholdLow(0)
      dsrc.appendToPrevious = False: dsrc.reverseArray = False
      If (append_col >= 0) And (n > 0) Then
        AppStr = UCase(getcol(a$, append_col))
'        If appstr = "YES" Or appstr = "TRUE" Then
        If InStr(AppStr, "YES") > 0 Or InStr(AppStr, "TRUE") > 0 Then
          If (dsrc.dataMax = dsrcList(n - 1).dataMax) And _
             (dsrc.dataMin = dsrcList(n - 1).dataMin) And _
             (dsrc.dataEGU = dsrcList(n - 1).dataEGU) Then
            dsrc.appendToPrevious = True
          End If
        End If
        If InStr(AppStr, "REVERSE") > 0 Then
          dsrc.reverseArray = True
        End If
      End If
      dsrcList(n) = dsrc
      n = n + 1
    End If
  End If
Loop While Not EOF(1)
Close 1

ndsrc = n
If n > 1 Then
  SpectrumForm.SpectrumCombo.Visible = True
  For i = 0 To n - 1
    If Not dsrcList(i).appendToPrevious Then
      dsrcXref(SpectrumForm.SpectrumCombo.ListCount) = i
      SpectrumForm.SpectrumCombo.AddItem dsrcList(i).Description
    End If
  Next
  SpectrumForm.SpectrumCombo.listIndex = 0
  readINITSourceInfo = 0
  Exit Function
Else
  SpectrumForm.SpectrumCombo.Visible = False
End If

DataSourceInfoDone:

readINITSourceInfo = fillDataSourceInfo(0)
Exit Function

readDataSourceInfoErr:
readINITSourceInfo = tine.file_error
Exit Function
End Function
Function readCONFIGSourceInfo(ByVal configFileName As String) As Integer
Dim cc%, i%, n%, p%, siz&, ndn%, v!
Dim File_col%, Desc_col%, ds$, AppStr$
Dim pqs As PropertyQueryEx
Dim done As Boolean
Dim a$, s$, tok$, args() As String, toks() As String
Dim tmpName$, tmpOCXFlag As Boolean

' Read a config file with different subsystems for a GIVEN MACHINE....
' FIRST CHECK IF THIS IS IN AN OCX!!!!

' If this is called from an OCX, then there is an ADDITIONAL SUBSYSTEM!
tmpOCXFlag = False
If HistoryOCXPath$ <> "" Then
    If Dir(HistoryOCXPath$) <> "" Then tmpOCXFlag = True
End If

n = 0

If tmpOCXFlag Then
    On Error GoTo readDataSourceInfoErr
    Open HistoryOCXPath$ + "\" + "SpectrumInfo.csv" For Input Access Read Shared As #1
    done = False
    Do
        Line Input #1, a$
        tok$ = Left$(a$, 1)
        If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And tok$ <> "" Then
            If Not done Then
                File_col% = colptr(a$, "FILENAME")
                Desc_col% = colptr(a$, "DESCRIPTION")
                done = True
            Else
                With SpectrumSubSystemInfo(n)
                    .ConfigDirectory = HistoryOCXPath$
                    If File_col% >= 0 Then .ConfigFile = getcol(a$, File_col%)
                    If Desc_col% >= 0 Then .Description = getcol(a$, Desc_col%)
                    n = n + 1
                End With
            End If
        End If
    Loop While Not EOF(1)
    Close 1
End If
NSubSystems% = n

' Use command to determine the start-up subsystem.
On Error GoTo readDataSourceInfoErr



Open configFileName For Input Access Read Shared As #1
done = False
Do
    Line Input #1, a$
    tok$ = Left$(a$, 1)
    If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And tok$ <> "" Then
        If Not done Then
            File_col% = colptr(a$, "FILENAME")
            Desc_col% = colptr(a$, "DESCRIPTION")
            done = True
        Else
            With SpectrumSubSystemInfo(n)
                .ConfigDirectory = ConfigFileDirectory$
                If File_col% >= 0 Then .ConfigFile = getcol(a$, File_col%)
                If Desc_col% >= 0 Then .Description = getcol(a$, Desc_col%)
                n = n + 1
            End With
        End If
    End If
Loop While Not EOF(1)
Close 1
NSubSystems% = n



' fill caption stuff...
For i% = 0 To NSubSystems% - 1
    SpectrumForm.MenuSubsystem(i%).Caption = SpectrumSubSystemInfo(i%).Description
    SpectrumForm.MenuSubsystem(i%).Visible = True
Next i%
For i% = NSubSystems% To MaxSubSystems - 1
    SpectrumForm.MenuSubsystem(i%).Visible = False
Next i%

Exit Function

DataSourceInfoDone:

Exit Function

readDataSourceInfoErr:
Debug.Print Err.Description
readCONFIGSourceInfo = tine.file_error
Exit Function
End Function

Function readMACHINEConfigInfo(ByVal configFileName As String) As Integer
Dim cc%, i%, n%, p%, siz&, ndn%, v!
Dim File_col%, Name_col%, Machine_col%, ds$, AppStr$
Dim pqs As PropertyQueryEx
Dim done As Boolean
Dim a$, s$, tok$, args() As String, toks() As String
Dim tmpName$

' Read a config file with different MACHINE - CONFIG NAMES
On Error GoTo readDataSourceInfoErr
Open configFileName For Input Access Read Shared As #1
n = 0
done = False
Do
    Line Input #1, a$
    tok$ = Left$(a$, 1)
    If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And tok$ <> "" Then
        If Not done Then
            Name_col% = colptr(a$, "MACHINE")
            File_col% = colptr(a$, "CONFIGFILE")
            Machine_col% = colptr(a$, "MACHINEFILE")
            done = True
        Else
            With MachineInfo(n)
                If Name_col% >= 0 Then .Description = Trim(getcol(a$, Name_col%))
                If File_col% >= 0 Then .ConfigFile = Trim(getcol(a$, File_col%))
                If Machine_col% >= 0 Then .MachineFile = Trim(getcol(a$, Machine_col%))
                n = n + 1
            End With
        End If
    End If
Loop While Not EOF(1)
Close 1
NMachines% = n

'' fill caption stuff...
'For i% = 0 To NMachines% - 1
'    SpectrumForm.MenuSubsystem(i%).Caption = SpectrumSubSystemInfo(i%).Description
'    SpectrumForm.MenuSubsystem(i%).Visible = True
'Next i%
'For i% = NSubSystems% To MaxSubSystems - 1
'    SpectrumForm.MenuSubsystem(i%).Visible = False
'Next i%

readMACHINEConfigInfo = 0
Exit Function

readDataSourceInfoErr:
readMACHINEConfigInfo = tine.file_error
Exit Function
End Function



Function readSUBSYSTEMInfo(ByVal configFileName As String) As Integer
Dim cc As Integer, i As Integer, n As Integer, p As Integer
Dim siz As Long
Dim ds As String
Dim ndn As Integer
Dim pqs As PropertyQueryEx
Dim done As Boolean
Dim File_col%, Desc_col%, tmpName$
Dim con_col%, srv_col%, prp_col%, siz_col%
Dim hstsrv_col%, hstprp_col%, dsc_col%, max_col%, min_col%
Dim egu_col%, arcsrv_col%, arcprp_col%, append_col%
Dim thresh_high_col%, thresh_low_col%, tag_col%
Dim proplink_col%, propshort_col%, extdevDev_col%, extdevProp_col%, extrahistprop_col%
Dim a$, s$, tok$, args() As String, toks() As String
Dim AppStr As String
Dim v As Single

' Read a subsystem config file

On Error GoTo readDataSourceInfoErr
Open configFileName For Input Access Read Shared As #1
n = 0
done = False
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      srv_col = colptr(a$, "SERVER")
      prp_col = colptr(a$, "PROPERTY")
      siz_col = colptr(a$, "SIZE")
      hstsrv_col = colptr(a$, "HSTSERVER")
      hstprp_col = colptr(a$, "HSTPROPERTY")
      arcsrv_col = colptr(a$, "ARCSERVER")
      arcprp_col = colptr(a$, "ARCPROPERTY")
      dsc_col = colptr(a$, "DESCRIPTION")
      max_col = colptr(a$, "MAX")
      min_col = colptr(a$, "MIN")
      egu_col = colptr(a$, "EGU")
      append_col = colptr(a$, "APPEND")
      thresh_high_col = colptr(a$, "HIGH")
      thresh_low_col = colptr(a$, "LOW")
      tag_col = colptr(a$, "TAG")
      proplink_col = colptr(a$, "PROPLINK")
      propshort_col = colptr(a$, "PROPSHORT")
      
      extdevDev_col% = colptr(a$, "EXTDEVNAMEDEV")
      extdevProp_col% = colptr(a$, "EXTDEVNAMEPROP")
      extrahistprop_col% = colptr(a$, "EXTRAPROPCOMBOINDEX")
      done = True
    Else
      If con_col >= 0 Then dsrc.deviceContext = getcol(a$, con_col)
      If srv_col >= 0 Then
        dsrc.deviceGroup = getcol(a$, srv_col)
        p = InStr(dsrc.deviceGroup, "/")
        If p > 0 Then
          dsrc.deviceName = Right$(dsrc.deviceGroup, Len(dsrc.deviceGroup) - p)
          dsrc.deviceGroup = Left$(dsrc.deviceGroup, p - 1)
        End If
      End If
      If prp_col >= 0 Then dsrc.deviceProperty = getcol(a$, prp_col)
      If siz_col >= 0 Then dsrc.DataSize = Val(getcol(a$, siz_col))
      If hstsrv_col >= 0 Then dsrc.hstServer = getcol(a$, hstsrv_col)
      If hstprp_col >= 0 Then dsrc.hstProperty = getcol(a$, hstprp_col)
      If arcsrv_col >= 0 Then dsrc.arcServer = getcol(a$, arcsrv_col)
      If arcprp_col >= 0 Then dsrc.arcProperty = getcol(a$, arcprp_col)
      If dsc_col >= 0 Then dsrc.Description = getcol(a$, dsc_col)
      If max_col >= 0 Then dsrc.dataMax = Val(getcol(a$, max_col))
      If min_col >= 0 Then dsrc.dataMin = Val(getcol(a$, min_col))
      If egu_col >= 0 Then dsrc.dataEGU = getcol(a$, egu_col)
      If tag_col >= 0 Then dsrc.DeviceTag = getcol(a$, tag_col)
      If proplink_col >= 0 Then
        dsrc.PropLink = Val(getcol(a$, proplink_col))
        dsrc.PropShort = getcol(a$, propshort_col)
      Else
        dsrc.PropLink = -1
      End If
      If extdevProp_col >= 0 Then
        tmpName$ = getcol(a$, extdevProp_col)
        If tmpName$ <> "" Then
            dsrc.ExtDeviceNameProperty = tmpName$
            dsrc.ExtDeviceNameFlag = True
        Else
            dsrc.ExtDeviceNameFlag = False
        End If
      Else
        dsrc.ExtDeviceNameFlag = False
      End If
      If extdevDev_col >= 0 Then
        tmpName$ = getcol(a$, extdevDev_col)
        dsrc.ExtDeviceNameDevice = tmpName$
      End If
      If extrahistprop_col% >= 0 Then dsrc.ExtraPropComboIndex = Val(getcol(a$, extrahistprop_col%)) Else dsrc.ExtraPropComboIndex = -1
      
      If Len(dsrc.DeviceTag) > 0 Then dsrc.DeviceTag = dsrc.DeviceTag + "/"
      If thresh_high_col >= 0 Then dsrc.dataThresholdSource = getcol(a$, thresh_high_col)
      ReDim dsrc.dataThresholdHigh(0)
      If thresh_low_col >= 0 Then dsrc.dataThresholdSource = getcol(a$, thresh_low_col)
      ReDim dsrc.dataThresholdLow(0)
      
      dsrc.appendToPrevious = False: dsrc.reverseArray = False
      If (append_col >= 0) And (n > 0) Then
        AppStr = UCase(getcol(a$, append_col))
'        If appstr = "YES" Or appstr = "TRUE" Then
        If InStr(AppStr, "YES") > 0 Or InStr(AppStr, "TRUE") > 0 Then
          If (dsrc.dataMax = dsrcList(n - 1).dataMax) And _
             (dsrc.dataMin = dsrcList(n - 1).dataMin) And _
             (dsrc.dataEGU = dsrcList(n - 1).dataEGU) Then
            dsrc.appendToPrevious = True
          End If
        End If
        If InStr(AppStr, "REVERSE") > 0 Then
          dsrc.reverseArray = True
        End If
      End If
      dsrcList(n) = dsrc
      n = n + 1
    End If
  End If
Loop While Not EOF(1)
Close 1

ndsrc = n

' this is checked in loops...
dsrcList(ndsrc).appendToPrevious = False

spectrumId = -1
SpectrumForm.SpectrumCombo.Clear
If n > 1 Then
  SpectrumForm.SpectrumCombo.Visible = True
  For i = 0 To n - 1
    If Not dsrcList(i).appendToPrevious Then
      dsrcXref(SpectrumForm.SpectrumCombo.ListCount) = i
      SpectrumForm.SpectrumCombo.AddItem dsrcList(i).Description
    End If
  Next
  SpectrumForm.SpectrumCombo.listIndex = 0
  Exit Function
Else
  SpectrumForm.SpectrumCombo.Visible = False
  dsrcXref(0) = 0
  SpectrumForm.SpectrumCombo.AddItem dsrcList(0).Description
  
  SpectrumForm.SpectrumCombo.listIndex = 0
End If
readSUBSYSTEMInfo = 0

' Be sure that this is re-set?
ExtraComboPropIndexSAVE% = -1
ComboPropIndexSAVE% = -1

DataSourceInfoDone:

readSUBSYSTEMInfo = fillDataSourceInfo(0)
Exit Function

readDataSourceInfoErr:
readSUBSYSTEMInfo = tine.file_error
Exit Function
End Function



Function fillDataSourceInfo(ByVal index As Integer) As Integer
Dim cc As Integer, i As Integer, n As Integer
Dim siz As Long
Dim ds As String
Dim ndn As Integer
Dim pqs As PropertyQueryEx
Dim exe As String

fillDataSourceInfo = 0

If dsrcList(index).infoDone Then Exit Function
ds = "/" + dsrcList(index).deviceContext + "/" + dsrcList(index).deviceGroup
For i = 0 To 1
  cc = GetPropertyInformationEx(ds, dsrcList(index).deviceProperty, pqs)
  If cc = 0 Then
    If dsrcList(index).deviceName = "#1" Then pqs.prpSize = pqs.prpSize - 1 ' kluge for Uwe
    Exit For
  End If
Next
If dsrcList(index).DataSize = 0 Then dsrcList(index).DataSize = pqs.prpSize
If dsrcList(index).DataSize = 0 Then
    fillDataSourceInfo = cc
    Exit Function
End If
ReDim dsrcList(index).deviceData(dsrcList(index).DataSize - 1)
If dsrcList(index).dataMax = 0 Then dsrcList(index).dataMax = pqs.prpMaxValue
If dsrcList(index).dataMin = 0 Then dsrcList(index).dataMin = pqs.prpMinValue
If Len(dsrcList(index).dataEGU) = 0 Then dsrcList(index).dataEGU = BSTR(pqs.prpUnits)
If Len(dsrcList(index).dataThresholdSource) > 0 Then
  ' Thresholds available
  Dim v As Single
  ReDim dsrcList(index).dataThresholdHigh(dsrcList(index).DataSize - 1)
  ReDim dsrcList(index).dataThresholdLow(dsrcList(index).DataSize - 1)
  If Val(dsrcList(index).dataThresholdSource) > 0 Then ' single value given
    v = Val(dsrcList(index).dataThresholdSource)
    For i = 0 To dsrcList(index).DataSize - 1
      dsrcList(index).dataThresholdHigh(i) = v
      dsrcList(index).dataThresholdLow(i) = -v
    Next
    dsrcList(index).dataThresholdType = threshold_single
  ElseIf UCase(Right$(dsrcList(index).dataThresholdSource, 4)) = ".EXE" Then
    dsrcList(index).dataThresholdType = threshold_app
    i = InStr(dsrcList(index).dataThresholdSource, "]")
    If i > 0 Then
      exe = Right(dsrcList(index).dataThresholdSource, Len(dsrcList(index).dataThresholdSource) - i)
      dsrcList(index).deviceOperationsExe = exe
      dsrcList(index).dataThresholdSource = Left(dsrcList(index).dataThresholdSource, i - 1 + 1)
      i = readThresholdValues(dsrcList(index).dataThresholdSource, dsrcList(index).dataThresholdHigh, dsrcList(index).dataThresholdLow)
    Else
      dsrcList(index).deviceOperationsExe = dsrcList(index).dataThresholdSource
      dsrcList(index).dataThresholdSource = ""
    End If
  Else
    i = readThresholdValues(dsrcList(index).dataThresholdSource, dsrcList(index).dataThresholdHigh, dsrcList(index).dataThresholdLow)
    If i > 0 Then dsrcList(index).dataThresholdType = i
  End If
End If
dsrcList(index).hstLongTermDepth = pqs.prpHistoryDepthLong
dsrcList(index).hstShortTermDepth = pqs.prpHistoryDepthShort
If dsrcList(index).hstShortTermDepth = 0 Then dsrcList(index).hstShortTermDepth = 600 ' give the machine params 10 minutes
If Len(dsrcList(index).hstServer) > 0 And Left(dsrcList(index).hstServer, 1) <> "/" Then
  dsrcList(index).hstServer = "/" + dsrcList(index).deviceContext + "/" + dsrcList(index).hstServer
End If
'ElseIf pqs.prpHistoryDepthLong > 0 Then
If pqs.prpHistoryDepthLong > 0 Then
  dsrcList(index).hstServer = ds
  dsrcList(index).hstProperty = dsrcList(index).deviceProperty + ".HIST"
End If
If InStr(1, dsrcList(index).hstProperty, ".HIST") = 0 Then dsrcList(index).hstProperty = dsrcList(index).hstProperty + ".HIST"

If Len(dsrcList(index).arcServer) > 0 And Left(dsrcList(index).arcServer, 1) <> "/" Then
  dsrcList(index).arcServer = "/" + dsrcList(index).deviceContext + "/" + dsrcList(index).arcServer
Else
  dsrcList(index).arcServer = "" 'dsrcList(index).hstServer
  dsrcList(index).arcProperty = "" 'dsrcList(index).hstProperty
End If
If Len(dsrcList(index).Description) = 0 Then dsrcList(index).Description = BSTR(pqs.prpDesc)
ds = ds + "/#0": ndn = dsrcList(index).DataSize
For i = 0 To 1
  cc = GetEquipmentDeviceNamesFromProperty(ds, dsrcList(index).deviceProperty, dsrcList(index).DeviceNames, ndn)
  If cc = 0 Then Exit For
Next
If cc Then
    ' Something went wrong getting the names....
    If ndn = 0 Then ndn = dsrcList(index).DataSize
    
    ReDim dsrcList(index).DeviceNames(ndn - 1)
    For i = 0 To ndn - 1: dsrcList(index).DeviceNames(i) = "#" + Trim$(str(i)):  Next
End If
If Len(dsrcList(index).deviceName) = 0 Then
  If ndn > 0 Then dsrcList(index).deviceName = dsrcList(index).DeviceNames(0) Else dsrcList(index).deviceName = "#0"
End If
If dsrcList(index).ExtDeviceNameFlag Then
    For i = 0 To 1
        cc = GetExtendedDeviceNamesFromProperty(ds, dsrcList(index).ExtDeviceNameProperty, dsrcList(index).ExtendedDeviceNames, ndn)
        If cc = 0 Then Exit For
    Next
End If

If dsrcList(index).reverseArray Then Call ArrayReverse(dsrcList(index).DeviceNames)
dsrcList(index).infoDone = True
End Function

Function GetExtendedDeviceNamesFromProperty(devServer As String, devProperty As String, devNames() As String, ndevices As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim nms() As NAME16
Dim rc As Integer, i%, j%
Dim dev As String

' Use to get the MKKNames...

n = ndevices
If n = 0 Then n = 2000
ReDim nms(n - 1)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(devServer, devProperty, dbout, nms(0), dbin, Null, CA_READ, 1000)
If rc Then GoTo exitFunction
If dbout.dArrayLength < ndevices And dbout.dArrayLength > 0 Then
  If BSTR(nms(i%).nam()) = "#0" Then
    ReDim devNames(n): j% = 0
    For i% = 0 To n - 1: devNames(i%) = "#" + Trim$(str(i)):  Next
    GetExtendedDeviceNamesFromProperty = 0
    Exit Function
  End If
End If
n = dbout.dArrayLength
ReDim devNames(n - 1): j% = 0
For i% = 0 To n - 1
  dev = Trim$(BSTR(nms(i%).nam()))
  If Right$(dev, 1) = "&" And Len(dev) = 16 Then
    i% = i% + 1
    dev = Left$(dev, 15) + Trim$(BSTR(nms(i%).nam()))
  End If
  If Len(dev) > 0 Then
    devNames(j%) = dev
    j% = j% + 1
  End If
Next
exitFunction:
ndevices = j%
GetExtendedDeviceNamesFromProperty = rc
End Function


Sub ArrayReverse(a As Variant)
Dim tmp As Variant
Dim i As Integer, Top As Integer, Bottom As Integer
Top = UBound(a): Bottom = LBound(a)
For i = Bottom To Top / 2
  tmp = a(i)
  a(i) = a(Top - i)
  a(Top - i) = tmp
Next
End Sub
Sub ArrayPercent()
Dim i As Integer, index As Integer, ar As Integer, li As Integer
Dim v As Single

If UBound(dsrcList(index).dataThresholdHigh) = 0 Then Exit Sub
For i = 0 To gSpectrumNpts - 1
  ar = i: li = dsrcListIndex
  getPropIndicesFromPlot li, ar
  v = dsrcDataBuffer(i)
  If v >= 0 And dsrcList(li).dataThresholdHigh(ar) > 0 Then
    v = v / dsrcList(li).dataThresholdHigh(ar)
  ElseIf v < 0 And dsrcList(li).dataThresholdLow(ar) < 0 Then
    v = v / dsrcList(li).dataThresholdLow(ar)
  Else
    v = 0
  End If
  dsrcDataBuffer(i) = v * 100
Next
End Sub
Sub ArrayPrepare()
Dim i As Integer, n As Integer, npts As Integer
npts = 0
For i = 0 To dsrcNumberInGroup - 1
  For n = 0 To UBound(dsrcList(dsrcListIndex + i).deviceData)
    dsrcDataBuffer(n + npts) = dsrcList(dsrcListIndex + i).deviceData(n)
  Next
  npts = npts + UBound(dsrcList(dsrcListIndex + i).deviceData) + 1
Next
End Sub
Sub getPropIndicesFromPlot(listIndex As Integer, ArrayIndex As Integer)
Dim ar As Integer, i As Integer, n As Integer
Dim nig As Integer

' ONLY NEED FOR LIVE-SPECTRUM DATA????

On Error GoTo getIndicesError
For i = 0 To 98 - listIndex
  nig = nig + 1
  If Not dsrcList(listIndex + i + 1).appendToPrevious Then Exit For
Next
ar = ArrayIndex
If nig > 1 Then
  For i = 0 To nig - 1
    n = UBound(dsrcList(listIndex + i).deviceData)
    If ar > n Then
      ar = ar - n - 1
    Else
      Exit For
    End If
  Next
End If

listIndex = listIndex + i
ArrayIndex = ar
Exit Sub
getIndicesError:
Debug.Print "Error-> List Index: " + str(listIndex) + " Array Index : " + str(ArrayIndex)
Exit Sub
End Sub

Public Function ScaleForBits(index%, StatusValue&) As Single
Dim tmpMask&, tmpFaktor!, tmpValue!

' Convert statusvalue to LONG and THEN do bist-mask/scaling?
'tmpFaktor! = 1
'tmpMask& = SelectBits&(sdi(index%).DeviceSubIndex - 1)

'tmpValue! = 2 * index% + (StatusValue& And tmpMask&) / tmpMask&

ScaleForBits! = tmpValue!
End Function

Public Sub ReadTheHistoryData(DataItem As SelectedDataItem, BlockFlag%)
Dim strt As Long, stpt As Long
Dim deviceName As String
Dim npts As Integer, rc As Integer, pass As Integer, i%
Dim ds As String, dp As String
Dim ar As Integer, li As Integer
Dim tmpNHistory&, tmpNArchive&, tmpstr$
Dim tmpStart&, tmpStop&

pass = 0

'If ArrayType% = 0 Then

AppendTotalCounter%(BlockFlag%) = 0
AppendTimeCounter%(BlockFlag%) = 0

tmpStart& = gStartTime
tmpStop& = gStopTime

With DataItem
    deviceName = .deviceName

    ' Check number of points:
    Call GetNPoints(tmpNHistory&, tmpNArchive&, DataItem, deviceName, gStartTime, gStopTime)
    If tmpNArchive& > 500 Or tmpNHistory& < tmpNArchive& Then
        pass = 1
        ds = .arcServer + "/" + deviceName
        dp = .arcProperty
        .LastReadArchiver = True
        .TotalPoints = tmpNArchive&
        tmpstr$ = "Archiver"
    Else
        ds = .hstServer + "/" + deviceName
        dp = .hstProperty
        .LastReadArchiver = False
        .TotalPoints = tmpNHistory&
        tmpstr$ = "History"
    End If

    .TotalArchPoints = tmpNArchive&
    .TotalHistPoints = tmpNHistory&

    strt = gStartTime - 60
    stpt = gStopTime + 60
    
getHistoryTrace:
    rc = SpectrumForm.MYGetArchivedDataEx(ds, dp, 0, strt, stpt, .RawData, .RawTS, npts)
    ' Try again, with archiver?
    If (npts = 0) And (pass = 0) And (.arcServer <> .hstServer) And Len(.arcServer) > 0 Then
        pass = 1
        ds = .arcServer + "/" + deviceName
        dp = .arcProperty
        GoTo getHistoryTrace
    End If
    If rc <> 0 Then
        .hasData = False
        Exit Sub
    End If
    If (npts < 4) And (pass < 5) Then
        pass = pass + 1
        strt = strt - 1000
        stpt = stpt + 1000
        npts = 0
        GoTo getHistoryTrace
    End If
    
    .hasData = True
    .npoints = npts
    .ReScale = True

    If BlockFlag% = HistoryIndex And .linkId < 0 Then
        SpectrumForm.ACOPPlotSelected.deviceContext = .deviceContext
        SpectrumForm.ACOPPlotSelected.deviceGroup = .deviceGroup
        'the old netmex re-kluge:
        If .deviceGroup = "HERADATA" And Left$(deviceName, 1) = "#" Then
            deviceName = "#" + Trim(str$(Val(Right(deviceName, Len(deviceName) - 1)) + 1))
        End If
        SpectrumForm.ACOPPlotSelected.deviceName = deviceName
        SpectrumForm.ACOPPlotSelected.deviceProperty = .deviceProperty
        SpectrumForm.ACOPPlotSelected.accessMode = "POLL"
        SpectrumForm.ACOPPlotSelected.AccessProtocol = "TINE"
        SpectrumForm.ACOPPlotSelected.accessRate = 1000
        .linkId = SpectrumForm.ACOPPlotSelected.OpenLink(.LiveData)
    ElseIf BlockFlag% = ExtraIndex And .linkId < 0 Then
        SpectrumForm.ACOPPlotExtra.deviceContext = .deviceContext
        SpectrumForm.ACOPPlotExtra.deviceGroup = .deviceGroup
        'the old netmex re-kluge:
        If .deviceGroup = "HERADATA" And Left$(deviceName, 1) = "#" Then
            deviceName = "#" + Trim(str$(Val(Right(deviceName, Len(deviceName) - 1)) + 1))
        End If
        SpectrumForm.ACOPPlotExtra.deviceName = deviceName
        SpectrumForm.ACOPPlotExtra.deviceProperty = .deviceProperty
        SpectrumForm.ACOPPlotExtra.accessMode = "POLL"
        SpectrumForm.ACOPPlotExtra.AccessProtocol = "TINE"
        SpectrumForm.ACOPPlotExtra.accessRate = 1000
        .linkId = SpectrumForm.ACOPPlotExtra.OpenLink(.LiveData)
    ElseIf BlockFlag% = AcceleratorIndex And .linkId < 0 Then
        ' Links are made in InitAcceleratorHistory!
    End If
    
    ' Need to put the NAME in?
    Call SpectrumForm.FillAGrid(0, BlockFlag%, 0, False)
    
End With

End Sub

Public Sub GetNPoints(NHistory&, NArchive&, DataItem As SelectedDataItem, deviceName$, starttime&, StopTime&)
Dim i%, tmpIndex%, scratchTotalPoints As FLTINT, tmpTimeOut&, tmpStartStop&(2), iAnswer%
Dim rcc&

' Get the NUMBER OF POINTS from History and Archive.... to decide WHICH ONE to use....
NHistory& = -1
NArchive& = -1

tmpStartStop&(0) = starttime&
tmpStartStop&(1) = StopTime&
tmpStartStop&(2) = 0
With DataItem
    If .hstServer <> "" And .hstProperty <> "" Then
        ' First find out how many points
        tmpTimeOut& = 1000
        SpectrumForm.ACOPData.accessRate = tmpTimeOut&
        SpectrumForm.ACOPData.accessMode = "READ"
        SpectrumForm.ACOPData.deviceName = .hstServer + "/" + "#1" 'deviceName$ '"/#" + Format(.HistoryIndex, "##0")
        SpectrumForm.ACOPData.deviceProperty = .hstProperty ' + ".HIST"
        
TryAgain:
        rcc& = SpectrumForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", tmpStartStop, 2)
        If rcc& Then
            'TextBox(0) = "Error Reading Pressure-Histories: " + ACOPPlotSpectrum.Status
            iAnswer% = MsgBox("Error Reading History Data: " + SpectrumForm.ACOPData.Status, vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
                ' Get out of the loop
                Exit Sub
            ElseIf iAnswer = vbIgnore Then
                ' Go to the next pump
            Else
                tmpTimeOut& = tmpTimeOut& + 1000  ' Try again
                GoTo TryAgain
            End If
        Else
            NHistory& = scratchTotalPoints.iVal
        End If
    Else
        NHistory& = -1
    End If
            
    If .arcServer <> "" Then
        tmpTimeOut& = 1000
        SpectrumForm.ACOPData.deviceName = .arcServer + "/#1"
        SpectrumForm.ACOPData.deviceProperty = .arcProperty
        
TryAgainArch:
        rcc& = SpectrumForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", tmpStartStop, 2)
        If rcc& Then
            'TextBox(0) = "Error Reading Pressure-Histories: " + ACOPPlotSpectrum.Status
            iAnswer% = MsgBox("Error Reading Archive Data: " + SpectrumForm.ACOPData.Status, vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
                ' Get out of the loop
                Exit Sub
            ElseIf iAnswer = vbIgnore Then
                ' Go to the next pump
            Else
                tmpTimeOut& = tmpTimeOut& + 1000  ' Try again
                GoTo TryAgainArch
            End If
        Else
            NArchive& = scratchTotalPoints.iVal
        End If
    Else
        NArchive& = -1
    End If
End With
End Sub


Public Sub ScaleTheHistoryData(DeviceFlag%, NSelectedItems%, DataItem() As SelectedDataItem)
Dim i%, ii%, j%, n%, StartLabel%, StopLabel%, tmpFaktor!, TmpOffset!, tmpMask&
Dim ScaleMax!, ScaleMin!, ScaleOffset!, tmpPlotRange!, tmpPlotOffset!
Dim Delta!, ZeroOffset!, InvDelta!, tmpCopyBytes&
Dim TmpArray!(), tmpItems%


StartLabel% = 0
StopLabel% = NSelectedItems% - 1

' How to do the scaling? 0-100, or absolute, or ACOP-YScale?
'If ScalingMode% = 0 Then

If DeviceFlag% = RefreshAll_Flag Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        'If sdi(i%).Active = True Then
            DataItem(i%).ReScale = True
        'Else
        '    sdi(i%).ReScale = False
        'End If
    Next i%
End If

'Need to do anything? Check if RELATIVE scale....
If SpectrumForm.ChkRelScale.Value Then
    'Need to do the re-scaling
Else
    For i% = StartLabel% To StopLabel%
        If DataItem(i%).ReScale = True Then
            'FSlct(i%).ReScale = False
            'FSlct(i%).RePlot = True
        Else
            ''FSlct(i%).ReScale = False
        End If
    Next i%
End If

For i% = StartLabel% To StopLabel%
    With DataItem(i%)
        If .ReScale = True And .npoints > 0 Then 'sdi(i%).Active And
            n% = .npoints
            
    '        ' What is this for?
    '        For j% = 0 To NDisplayModes% - 1
    '            If UCase$(FSlct(i%).SelectedVMode) = DisplayModes$(j%) Then
    '                FSlct(i%).SelectedVModeIndex = DisplayModeIndexes%(j%)
    '                Exit For
    '            End If
    '        Next j%
            ' EVERYTHING SHOULD BE LIN!
            
            ' Kludeg initial values (for value useful for archive-reader)?
            .VPlot = "LIN"
            .VScale = 1
            .VOffset = 0
            ReDim TmpArray!(n%)
            ReDim .ScaledData(n%)
            
            ' A bit of data-verarbeiting...
            ' Check if the DATA is meant to be scaled...
            tmpFaktor! = .VScale
            If Not (tmpFaktor! = 0 Or tmpFaktor! = 1) Then
                TmpOffset! = .VOffset
                For ii% = 0 To n% - 1
                   TmpArray!(ii%) = .RawData(ii%) * tmpFaktor! + TmpOffset!
                Next ii%
            ElseIf (.VPlot = "BIT") Or (.VPlot = "BITS") Then
                'FSlct(i%).VMax = 16.1
                'FSlct(i%).VMin = -0.05
                .SelectedMaxValue = .VMax
                .SelectedMinValue = .VMin
               
                ' ScaleForBits
                'tmpFaktor! = 1
                'tmpMask& = SelectBits&(FSlct(i%).DeviceSubIndex - 1)
                For ii% = 0 To n% - 1
                   TmpArray!(ii%) = ScaleForBits(i%, CLng(.RawData(ii%))) '2 * i% + (CLng(ArchData(ii%, i%).fval) And TmpMask&) / TmpMask&
                Next ii%
            ElseIf UCase$(.SelectedVMode) = "LOG" Then
                ' Do this check HERE, and do it only ONCE....
                For ii% = 0 To n% - 1
                   If TmpArray!(ii%) <= 0 Then .ScaledData(ii%) = 0.0000001
                Next ii%
                tmpFaktor! = 1
            Else
                tmpCopyBytes& = CLng(n%) * 4
                Call MEMCPYL(TmpArray!(0), .RawData(0), tmpCopyBytes&)
            End If
                    
            .PlotScale = tmpFaktor!
            
            .MaxValue = -1
            .MinValue = -1
                                                          
            
            If .PlotAutoScale Then 'tmpAutoFlag Then
                ' Scale to the Max and Min values IN THE DATA....
                If .MaxValue = -1 And .MinValue = -1 Then
                    ' Must find NEW max and min values
                    ScaleMax! = TmpArray!(0)
                    ScaleMin! = ScaleMax!
                    For ii% = 1 To n% - 1
                        ' Only look at points being DISPLAYED!
                        If .RawTS(ii%) > zminbuf#(zLevel%) And .RawTS(ii%) < zmaxbuf#(zLevel%) Then
                            If TmpArray!(ii%) > ScaleMax! Then
                                ScaleMax! = TmpArray!(ii%)
                            ElseIf TmpArray!(ii%) < ScaleMin! Then
                                ScaleMin! = TmpArray!(ii%)
                            End If
                        End If
                    Next ii%
                    ' make sure an array of "all the same thing" goes down the middle:
                    If ScaleMax! = ScaleMin! Then
                      ScaleMax! = ScaleMax! + ScaleMax! * 0.1 + 1
                      ScaleMin! = ScaleMin! - ScaleMin! * 0.1 - 1
                    End If
                    .MaxValue = ScaleMax!
                    .MinValue = ScaleMin!
                End If
                ' Put them 5% away from the edge?
                ScaleMax! = .MaxValue + (.MaxValue - .MinValue) * 0.01
                ScaleMin! = .MinValue - (.MaxValue - .MinValue) * 0.01
            
                ScaleMax! = ScaleMax! * 1
                ScaleMin! = ScaleMin!
            
                ScaleOffset! = 0
            Else
                .MaxValue = -1: .MinValue = -1
                ScaleMax! = .SelectedMaxValue
                ScaleMin! = .SelectedMinValue
                ScaleOffset! = .SelectedOffset
            End If
                    
            .PlotMaxValue = ScaleMax!
            .PlotMinValue = ScaleMin!
            .PlotOffset = ScaleOffset!
        
            If .PlotAutoScale Then
                tmpPlotRange! = ymaxbuf#(zLevel%, HistoryIndex) - yminbuf#(zLevel%, HistoryIndex)
                tmpPlotOffset! = yminbuf#(zLevel%, HistoryIndex)
            Else
                tmpPlotRange! = 100
                tmpPlotOffset! = 0
            End If
            
            If n% <= 1 Then
                Delta! = ScaleMax! - ScaleMin!
                ZeroOffset! = ScaleMin! + .PlotOffset
                .PlotDelta = Delta! / 100
                .PlotZeroOffset = ZeroOffset!
            Else
                ' To scale the data properly....
                If UCase$(.SelectedVMode) = "LOG" Then
                    If ScaleMin <= 0 Then ScaleMin = 0.01
                    If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
                    Delta! = (Log(ScaleMax!) - Log(ScaleMin!))
                    If .VMin = 0 Then .VMin = 1E-20
                    ZeroOffset! = Log(ScaleMin)
                Else
                    Delta! = ScaleMax! - ScaleMin!
                    ZeroOffset! = ScaleMin! + .PlotOffset
                End If
            
                ' Use the scale-factor in the form for the GRAPHICS!
                If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = tmpPlotRange! / Delta!
            
                ' For re-scaling
                .PlotDelta = Delta! / tmpPlotRange!
                .PlotZeroOffset = ZeroOffset!
            
                Select Case ScalingMode%
                Case AbsoluteScale:
                        tmpCopyBytes& = CLng(n%) * 4
                        Call MEMCPYL(.ScaledData(0), TmpArray!(0), tmpCopyBytes&)
                
                Case RelativeScale:
                    ' Plotting "mode"
                    If UCase$(.SelectedVMode) = "LOG" Then
                        For ii% = 0 To n% - 1
                            If TmpArray!(ii%) > 0 Then
                                .ScaledData(ii%) = (Log(TmpArray!(ii%)) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                            Else
                                .ScaledData(ii%) = 0
                            End If
                        Next ii%
                    ElseIf UCase$(.SelectedVMode) = "ABS" Then
                        For ii% = 0 To n% - 1
                            .ScaledData(ii%) = (Abs(TmpArray!(ii%)) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                        Next ii%
                    ElseIf UCase$(.SelectedVMode) = "SLOG" Then
                        tmpFaktor! = 1 '/ FSlct(i%).VMax
                        For ii% = 0 To n% - 1
                            If TmpArray!(ii%) > 0 Then
                                ii% = ii%
                            End If
                            .ScaledData(ii%) = (TmpArray!(ii%) * tmpFaktor! - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                        Next ii%
                    Else
                        For ii% = 0 To n% - 1
                            .ScaledData(ii%) = (TmpArray!(ii%) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                        Next ii%
                    End If
                End Select
            End If
        
            .ReScale = False
            '.ReFilter = True
            '.RePlot = True
        Else
            ' Nothing to do?
            .ReScale = False
        End If
    End With
Next i%
End Sub


Public Sub ScaleData(DataItem As SelectedDataItem, DataUnScaled!, DataScaled!)
Dim tmpValue!, tmpFaktor!

Select Case ScalingMode%
Case AbsoluteScale:
    tmpValue! = DataUnScaled!
Case RelativeScale:
    With DataItem
        If .SelectedVMode = "LOG" Then
            If DataScaled! > 0 Then
                tmpValue! = (Log(DataUnScaled!) - .PlotZeroOffset) / .PlotDelta
            Else
                tmpValue! = 0
            End If
        ElseIf .SelectedVMode = "ABS" Then
            tmpValue! = (Abs(DataUnScaled!) - .PlotZeroOffset) / .PlotDelta
        ElseIf .SelectedVMode = "SLOG" Then
            tmpFaktor! = 1 '/ FSlct(i%).VMax
            tmpValue! = (DataUnScaled! * tmpFaktor! - .PlotZeroOffset) / .PlotDelta
        Else
            tmpValue! = (DataUnScaled! - .PlotZeroOffset) / .PlotDelta
        End If
    End With
End Select
DataScaled! = tmpValue!
End Sub

Public Sub UnScaleData(DataItem As SelectedDataItem, DataScaled!, DataUnScaled!)
Dim tmpValue!, tmpFaktor!

Select Case ScalingMode%
Case AbsoluteScale:
    tmpValue! = DataScaled!
Case RelativeScale:
    With DataItem
        If UCase$(.SelectedVMode) = "LOG" Then
            'PlotData(ii%, i%).fval = (Log(ArchData(ii%, i%).fval) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
           tmpValue! = Exp(DataScaled! * .PlotDelta + .PlotZeroOffset) + .PlotMinValue
        Else
            'PlotData(ii%, i%).fval = (ArchData(ii%, i%).fval - ZeroOffset!) * InvDelta! + tmpPlotOffset!
            tmpValue! = DataScaled! * .PlotDelta + .PlotMinValue
        End If
    End With
End Select
DataUnScaled! = tmpValue!

End Sub



