Attribute VB_Name = "getPid"
Option Explicit
#Const WINDOWS95 = False

#If Not WINDOWS95 Then
Public Function isRunning(pathExe As String) As Long
    'return pid, or -1 if not running
    
    Dim pName As String, tmpstr As String
    Dim nProc As Integer, i As Integer
    Dim pids() As Long
    
    Call fillProcessTable(pids)
    pName = UCase(pathExe)
    nProc = UBound(pids) + 1
    
    For i = 0 To nProc - 1
        tmpstr = UCase(getExeName(pids(i)))
        If tmpstr = pName Then
            isRunning = pids(i)
            Exit Function
        End If
    Next
    isRunning = -1
    
End Function

Private Sub fillProcessTable(pidTable() As Long)
    Dim nProc As Long, needed As Long
  
    Dim lret As Long
     
    nProc = 25  'set to initial, reasonable value
    Do
        ReDim pidTable(nProc - 1)
   
        lret = EnumProcesses(pidTable(0), nProc * 4, needed)
        If lret = 0 Then
            ReDim pidTable(0)
            Exit Sub
        End If
        ' Compare needed bytes with array size in bytes.
        ' If less, then we got them all.
        If needed < nProc * 4 Then
            nProc = needed / 4
            ReDim Preserve pidTable(nProc - 1)
            Exit Sub
        End If
        nProc = nProc * 2
    Loop
End Sub


Public Function getExeName(processId As Long) As String
    Dim hProcess As Long, hExe As Long
    Dim lret As Long, cbNeeded As Long
    
    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, _
                            0&, processId)


    If hProcess <> 0 Then
   
      ' Now get the handle of the first module
      ' in this process, since first module is EXE
      hExe = 0
      lret = EnumProcessModules(hProcess, hExe, 4&, cbNeeded)
      
      If hExe <> 0 Then
         ' Get full path name
         getExeName = String$(MAX_PATH, 0)
         lret = GetModuleFileNameEx(hProcess, hExe, getExeName, Len(getExeName))
         getExeName = Trim0(getExeName)
      End If   ' EXE <> 0
   End If      ' hProcess <> 0
   
   ' Close handle
   lret = CloseHandle(hProcess)


End Function

#End If
