Attribute VB_Name = "reboot"
' based on the code downloaded from  "Gtz Software" web page
' some modification made by Karol, 21.08.2001

Option Explicit
    
    Public Enum SysVer
        Win2000 = 3&
        WinNT = 2&
        Win9x = 1&
    End Enum
    

    Private Const SE_PRIVILEGE_ENABLED = &H2
    Private Const SE_SHUTDOWN_NAME = "SeShutdownPrivilege"
    
    Private Const TOKEN_QUERY = &H8
    Private Const TOKEN_ADJUST_PRIVILEGES = &H20
    Private Const EWX_LOGOFF As Long = 0
    Private Const EWX_SHUTDOWN As Long = 1
    Private Const EWX_REBOOT As Long = 2
    Private Const EWX_FORCE As Long = 4
    Private Const EWX_POWEROFF As Long = 8
    Private Const EWX_FORCEIFHUNG As Long = 16  ' nur Win2000 _
                                                                                          evtl. hngende Anwendungen werden _
                                                                                          damit zwangsweise beendet.

    Private Const ANYSIZE_ARRAY = 1
    
    Private Const PROCESS_TERMINATE As Long = 1
    Private Const STANDARD_RIGHTS_REQUIRED As Long = &HF0000
    Private Const SYNCHRONIZE As Long = &H100000
    Private Const PROCESS_ALL_ACCESS As Long = STANDARD_RIGHTS_REQUIRED Or _
                                                                                         SYNCHRONIZE Or _
                                                                                         &HFFF
    
    Private Type LUID
        LowPart As Long
        HighPart As Long
    End Type

    Private Type LUID_AND_ATTRIBUTES
        pLuid As LUID
        Attributes As Long
    End Type

    Private Type TOKEN_PRIVILEGES
        PrivilegeCount As Long
        Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
    End Type

    Private Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
    End Type

    Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" _
                (ByVal lpClassName As String, _
                 ByVal lpWindowName As String) As Long

    Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
                (lpVersionInformation As OSVERSIONINFO) As Long
    
    Private Declare Function ExitWindowsEx& Lib "user32" _
                 (ByVal uFlags As Long, ByVal dwReserved As Long)
            
    Private Declare Function AdjustTokenPrivileges _
                Lib "advapi32.dll" _
                (ByVal TokenHandle As Long, _
                 ByVal DisableAllPrivileges As Long, _
                 NewState As TOKEN_PRIVILEGES, _
                 ByVal BufferLength As Long, _
                 PreviousState As TOKEN_PRIVILEGES, _
                 ReturnLength As Long) As Long
                 
    Private Declare Function OpenProcessToken _
                Lib "advapi32.dll" _
                (ByVal ProcessHandle As Long, _
                 ByVal DesiredAccess As Long, _
                 TokenHandle As Long) As Long
                 
    Private Declare Function LookupPrivilegeValue _
                Lib "advapi32" _
                Alias "LookupPrivilegeValueA" _
                (ByVal lpSystemName As String, _
                 ByVal lpName As String, _
                 lpLuid As LUID) As Long
             
    Private Declare Function GetCurrentProcess _
                Lib "kernel32" () As Long

    Private Declare Function GetWindowThreadProcessId _
                Lib "user32" _
                (ByVal hWnd As Long, _
                lpdwProcessId As Long) As Long
                
    Private Declare Function GetDesktopWindow _
                Lib "user32" () As Long
                
    Private Declare Function OpenProcess _
                Lib "kernel32" _
                (ByVal dwDesiredAccess As Long, _
                 ByVal bInheritHandle As Long, _
                 ByVal dwProcessId As Long) As Long
                 
    Private Declare Function TerminateProcess _
                Lib "kernel32" _
                (ByVal hProcess As Long, _
                 ByVal uExitCode As Long) As Long
                 
    Private Declare Function CloseHandle _
                Lib "kernel32" _
                (ByVal hObject As Long) As Long





Private Sub optAction_Click(Index As Integer)
    Dim Ret As Boolean
    Dim OSI As SysVer
    Ret = GetWinPlatform(OSI)
End Sub


Public Function shutDownPC() As Boolean
    shutDownPC = False
    If ForceShutdown(EWX_SHUTDOWN, True, False) Then
        shutDownPC = True
        Unload MAIN
    End If
End Function

Public Function rebootPC() As Boolean
    rebootPC = False
    If ForceShutdown(EWX_REBOOT, True, False) Then
        rebootPC = True
        Unload MAIN
    End If
End Function

Public Function logOff() As Boolean
    logOff = False
    If ForceShutdown(EWX_LOGOFF, True, False) Then
        logOff = True
        Unload MAIN
    End If
End Function

Private Function ForceShutdown(ByVal Action As Long, _
                                                      ForceFlag As Boolean, _
                                                      PowerOff As Boolean) As Boolean
    ' System beenden, neu starten oder akt. Benutzer abmelden
    
    ' zulssige Werte fr Action
    '     0 = Benutzer abmelden (LogOff)
    '     1 = System beenden (Shutdown)
    '     2 = System neu starten (Reboot)
    
    ' ForceFlag = True bewirkt, dass laufende Anwendungen _
      ohne Rckfrage beendet werden und keine MsgBox zum _
      Abbrechen des Shutdowns ausgegeben wird (EWX_FORCE).
    ' Falls ForceFlag = True, wird bei Win2000 zustzlich zu _
      EWX_FORCE auch noch EWX_FORCEIFHUNG gesetzt.
    
    Dim Ret As Boolean
    Dim OSVer As Long
    Dim Msg As String
    
    ' Action kann / darf hier nur 0,1 oder 2 sein
    If (Action > -1) And (Action < 3) Then
  
        ' Wenn ForceFlag gesetzt ist, _
          wird zum Wert von Action der Wert von _
          EWX_FORCE (4) hinzuaddiert
        If ForceFlag Then
            Action = Action Or EWX_FORCE
        End If
        
        
        ' Wenn PowerOff gesetzt ist, _
          wird zum Wert von Action EWX_POWEROFF (8) hinzuaddiert
        If PowerOff Then
            Action = Action Or EWX_POWEROFF
        End If
        
        Ret = GetWinPlatform(OSVer)
        If Ret Then
            Select Case OSVer
        
                Case 2, 3    'NT / Win2000
                    ' bei NT / Win2000 muss erst das _
                      Shutdownprivileg gesetzt werden.
                    If SetPrivilege Then
                        If OSVer = 3 Then
                            ' NT2000
                            If ForceFlag Then
                                ' wenn ForceFlag gesetzt ist dann zustzlich _
                                  EXX_FORECEIFHUNG setzen.
                                  
                                ' EWX_FORCEIFHUNG bewirkt, dass hngende _
                                  Anwendungen zwangsweise beendet werden. _
                                  Nur bei Win2000 mglich
                                Action = Action Or EWX_FORCEIFHUNG
                            End If
                        End If
                        ' Ret ist hier noch True, _
                          (ExitWindowsEx ausfhren ...)
                    Else
                        ' Fehler: SetPrivilege ist fehlgeschlagen
                        Msg = "Privileg """ & SE_SHUTDOWN_NAME & Chr$(34) & vbCrLf & _
                                   "konnte nicht gesetzt werden!"
                        ' Ret auf False setzen, _
                          (ExitWindowsEx nicht ausfhren ...)
                        Ret = False
                    End If
                    
                Case 1  'Win95/98
                    If Not CBool(Action And (EWX_SHUTDOWN Or EWX_REBOOT)) Then
                        ' LogOff wurde ausgewhlt
                              
                        ' Explorer beenden
                        ' s. MSDN Artikel ID: Q216638 _
                                         HOWTO: Programmatically Force Windows 95 _
                                                          and Windows 98 to Log Off _

                        If Not TerminateExplorer Then
                            Msg = "Explorer konnte nicht beendet werden." & vbCrLf & _
                                       "Whlen Sie Shutdown oder Reboot"
                            ' Ret auf False setzen, _
                              (ExitWindowsEx nicht ausfhren ...)
                            Ret = False
                        End If
                        ' wenn TerminateExplorer fehlerfrei gelaufen ist, _
                          dann ist Ret hier noch True _
                          (ExitWindowsEx ausfhren ...)
                    End If
                    
                Case Else
                    Msg = "Falsches System!"
                    ' Ret auf False setzen, _
                      (ExitWindowsEx nicht ausfhren ...)
                    Ret = False
            End Select
            
            ' falls bisher kein Fehler aufgetreten ist, _
              hat Ret hier den Wert True
            If Ret Then
                Ret = ExitWindowsEx(Action, 0)
            Else
                Call MAIN.putlog(Msg)
            End If
        End If
    End If
    
    ' Rckgabewert bergeben
    ForceShutdown = Ret
End Function

Public Function SetPrivilege() As Boolean

    ' Setzt Shutdown-Privileg fr WinNT
    
    ' Rckgabewert:       True, wenn das Privileg erfolgreich gesetzt wurde
    '                                 False, wenn das Privileg nicht gesetzt wurde
    
    
    Dim hToken As Long      ' Handle Processtoken
    Dim aLUID As LUID        ' LUID (locally unique identifier)
    Dim NewPriv As TOKEN_PRIVILEGES         ' Neue Privileginformation
    Dim PrevPriv As TOKEN_PRIVILEGES         ' Bisherige Privileginformation
    Dim Ret As Boolean       ' fr Rckgabewert der Funktionen

    ' Handle fr akt. Process-Token ermitteln _
      (wird an hToken bergeben)
    Ret = OpenProcessToken(GetCurrentProcess(), _
                                                TOKEN_ADJUST_PRIVILEGES Or _
                                                TOKEN_QUERY, _
                                                hToken)
    
    If Ret Then
        ' LUID (locally unique identifier) fr Shutdownprivileg ermitteln _
          (wird an aLUID bergeben)
        Ret = LookupPrivilegeValue(vbNullString, _
                                                      SE_SHUTDOWN_NAME & vbNullChar, _
                                                      aLUID)
        If Ret Then
            ' Shutdownprivileg setzen
            With NewPriv
                .PrivilegeCount = 1
                .Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
                .Privileges(0).pLuid = aLUID
            End With
            
            Ret = AdjustTokenPrivileges(hToken, _
                                                           0, _
                                                           NewPriv, _
                                                           4 + 12 * NewPriv.PrivilegeCount, _
                                                           PrevPriv, 4 + 12 * PrevPriv.PrivilegeCount)
        End If
    End If
    
    ' Rckgabewert bergeben
    SetPrivilege = Ret
End Function

Public Function GetWinPlatform(OSInfo As SysVer) As Boolean
    ' Ermittelt die aktuelle Betriebssystemversion
    ' Der Funktion trgt bei Erfolg die entsprechende _
      Systeminformation in die an die Funktion bergebene _
      Variable OSInfo ein.
    
    ' Mgliche Werte die in OSInfo zurckgegeben werden:
    '       1 = Win95/98
    '       2 = NT
    '       3 = Win2000
    
    ' Rckgabewert:  True, wenn Win95/98, NT oder Win2000 erkannt wurde _
                                 False, wenn keines dieser Systeme ermittelt wurde.
                                
    Dim OSVI As OSVERSIONINFO
    Dim Ret As Boolean
    Dim strCSDVersion As String
    
    OSVI.dwOSVersionInfoSize = Len(OSVI)
    Ret = GetVersionEx(OSVI)
    
    If Ret Then
        OSInfo = OSVI.dwPlatformId
        Select Case OSInfo
            Case 1
                ' Win95/98 erkannt
            Case 2
                ' Windows NT oder Win2000 erkannt
                If OSVI.dwMajorVersion > 4 Then
                    ' Win2000 gibt fr .dwPlatformID den _
                      gleichen Wert (2) wie NT zurck. _
                      .dwMajorVersion ist jedoch > 4
                    OSInfo = OSInfo + 1
                    ' fr Win2000 wird also der _
                      Wert 2 + 1 = 3 zurckgegeben
                End If
            Case Else
                ' kein Win95/98, NT oder Win2000 erkannt, _
                  Rckgabewert auf False setzen
                Ret = False
        End Select
    End If
    
    GetWinPlatform = Ret
End Function


Private Function TerminateExplorer() As Boolean
' Korrektur zum MSDN Artikel ID: Q216638 _
      HOWTO: Programmatically Force Windows 95 _
                       and Windows 98 to Log Off _
      nach einem Korrekturvorschlag von _
      Mathias Schiffer vom 1.8.2000

' Beendet den Explorer-Prozess unter Win9x.
' (Fr Windows NT / 2000 wre zustzlich das Privileg
' SE_DEBUG_NAME = "SeDebugPrivilege" zu setzen.)

    Dim ProcessIDExplorer As Long
    Dim hProcessExplorer As Long
    Dim hExplorerWindow As Long

  ' Handle des Programm-Manager-Fensters ermitteln (gehrt zu Explorer.exe)
  hExplorerWindow = FindWindow("progman", "program manager")
  If hExplorerWindow <> 0 Then
      ' Die Prozess-ID des Explorers ermitteln
      GetWindowThreadProcessId hExplorerWindow, ProcessIDExplorer

      If ProcessIDExplorer <> 0 Then
         ' Durch OpenProcess ein Pseudo-Handle fr den Explorer-Prozess ermitteln:
         hProcessExplorer = OpenProcess(PROCESS_TERMINATE, 0&, ProcessIDExplorer)

         If hProcessExplorer <> 0 Then

            ' Den Explorer-Prozess terminieren
            TerminateProcess hProcessExplorer, PROCESS_TERMINATE

            ' Das Pseudo-Handle auf den Explorer-Prozess freigeben
            CloseHandle hProcessExplorer
            TerminateExplorer = True
         End If
      End If
   End If
End Function




