'==========================================================
'==                                                      ==
'==        Global constants of general use               ==
'==                                                      ==
'==========================================================

Global Const RED = &HFF&
Global Const DRED = &H80&
Global Const BLUE = &HFF0000
Global Const DBLUE = &H800000
Global Const GREEN = &HFF00&
Global Const DGREEN = &H8000&
Global Const WHITE = &HFFFFFF
Global Const BLACK = &H0&
Global Const YELLOW = &HFFFF&
Global Const PINK = &HF000F0
Global Const LPINK = &HFF00FF
Global Const DPURPLE = &HFF00FF
Global Const LGREY = &HC0C0C0
Global Const DGREY = &H808080

Global Const CF_TEXT2 = 1 ' this old idiocy will disappear
			  ' when there are no more pre-Release 3.0
			  ' programs
Global Const CF_DOUBLE = 512
Global Const CF_INTEGER = 513
Global Const CF_SHORT = 513
Global Const CF_BYTE = 514
Global Const CF_LONG = 515
Global Const CF_TEXT = 516
Global Const CF_FLOAT = 517
Global Const CF_POCALBLK = 518
Global Const CF_STRUCT = 519
Global Const CF_STRING8 = 520
Global Const CF_CHAR8 = 520
Global Const CF_NAME8 = 520
Global Const CF_CHAR16 = 521
Global Const CF_NAME16 = 521
Global Const CF_STRING16 = 521
Global Const CF_CHAR16FI = 522
Global Const CF_BIT = 523
Global Const CF_HITTS = 524
Global Const CF_STRING32 = 525
Global Const CF_NAME32 = 525
Global Const CF_CHAR32 = 525
Global Const CF_FI = 526
Global Const CF_FLTINT = 526
Global Const CF_II = 527
Global Const CF_INTINT = 527
Global Const CF_LI = 527
Global Const CF_LNGINT = 527
Global Const CF_DI = 528
Global Const CF_DBLINT = 528
Global Const CF_SI = 529
Global Const CF_SHTINT = 529
Global Const CF_TDS = 530
Global Const CF_STRING48 = 531
Global Const CF_NAME48 = 531
Global Const CF_CHAR48 = 531
Global Const CF_CHAR8I = 532
Global Const CF_NAME8I = 532
Global Const CF_CHAR16I = 533
Global Const CF_NAME16I = 533
Global Const CF_CHAR32I = 534
Global Const CF_NAME32I = 534
Global Const CF_CHAR48I = 535
Global Const CF_NAME48I = 535

Global Const CF_NULL = 767

Global Const CM_NULL = 0
Global Const CM_CANCEL = 0
Global Const CM_SINGLE = 1
Global Const CM_REFRESH = 2
Global Const CM_POLL = 3


Global Const CA_NULL = &H0
Global Const CA_READ = &H1
Global Const CA_WRITE = &H2
Global Const CA_ASYNC = &H4
Global Const CA_SYNC = &H8
Global Const CA_FIRST = &H40
Global Const CA_LAST = &H80

Type FSTRUCT
  date As Integer
  time As Integer
  name As String * 8
End Type

Type FLTINT
  fval As Single
  ival As Long
End Type

Type SHTINT
  sval As Integer
  ival As Long
End Type

Type DBLINT
  dval As Double
  ival As Long
End Type

Type NAME8
  nam As String * 8
End Type

Type NAME16
  nam As String * 16
End Type

Type NAME32
  nam As String * 32
End Type

Type PropertyQueryType
  prpName As String * 32
  prpDesc As String * 32
  prpSize As Integer
  prpFormat As String * 1
  prpAccess As String * 1
End Type
'==========================================================
'==                                                      ==
'==       Kernel routines for determining multiple usage ==
'==                                                      ==
'==========================================================

Declare Function GetModuleHandle% Lib "Kernel" (ByVal IpProgramName$)
Declare Function GetModuleUsage% Lib "Kernel" (ByVal hProgram%)

' -----------------------------------------
' | Example of usage                      |
' | (put into form_load of startup form): |
' -----------------------------------------

'       hw% = GetModuleHandle("blm.exe")
'       n% = GetModuleUsage(hw%)
'       If n% > 1 Then
'          MsgBox "Program already running ..."
'          End
'       End If
 
'==========================================================
'==                                                      ==
'==         Work Station Environment Routines            ==
'==                                                      ==
'==========================================================
Type NAMELIST: name As String * 48: End Type
Declare Function MONITOR Lib "monitor.dll" (ByVal NCONN%, fs As NAMELIST, un As NAMELIST, conn%, logtime As NAMELIST, cc%) As Integer
Declare Function INITMONITOR Lib "monitor.dll" () As Integer
Declare Function ATTACH Lib "monitor.dll" (ByVal fs$, ByVal un$, ByVal pw$) As Integer
Declare Function DETACH Lib "monitor.dll" (ByVal fs$) As Integer
Declare Function IPADDR Lib "monitor.dll" (IP As NAMELIST) As Integer
Declare Function IPXADDR Lib "monitor.dll" (IPX As NAMELIST) As Integer
Declare Function MAP Lib "monitor.dll" (ByVal Drive%, ByVal fs$, ByVal path$) As Integer
Declare Function FINDMAP Lib "monitor.dll" (ByVal fs$, ByVal path$) As Integer
Declare Function GETFIRSTDRIVE Lib "monitor.dll" () As Integer
Declare Function MAPFIRSTDRIVE Lib "monitor.dll" (ByVal fs$, ByVal path$) As Integer

'==========================================================
'==                                                      ==
'==         network routines for data acquisition        ==
'==                                                      ==
'==========================================================
Type DBLK
  dArrayLength As Long
  dFormat As Integer
  reserved As Integer
  dTag As String * 8
End Type

Type RPCTEXT
  text As String * 80
End Type

Type RPCSTRING
  text As String * 256
End Type

Dim netuser As String * 16
Declare Function RPC Lib "tinecl16.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function EXECLINK Lib "tinecl16.dll" (ByVal devName$, ByVal devprop$, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal acc%) As Integer
Declare Function EXECLINKEx Lib "tinecl16.dll" (ByVal devName$, ByVal devprop$, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal acc%, ByVal timeout&) As Integer
Declare Function HOTRPC Lib "tinecl16.dll" (ByVal hWnd%, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%) As Integer
Declare Function CLOSERPC Lib "tinecl16.dll" (ByVal hWnd%, ByVal ID%) As Integer
Declare Function GETRPC Lib "tinecl16.dll" (ByVal ID%, dat As Any) As Integer
Declare Function GETRPCDATA Lib "tinecl16.dll" (ByVal ID%, dat As Any, ts&) As Integer
Declare Function PUTRPC Lib "tinecl16.dll" (ByVal ID%, dat As Any) As Integer
Declare Function PUTRPCDATA Lib "tinecl16.dll" (ByVal ID%, dat As Any, ByVal siz%, ByVal fmt%) As Integer
Declare Function RPCERR Lib "tinecl16.dll" (ByVal errno%, ByVal errstr$) As Integer
Declare Function GETGLOBAL Lib "tinecl16.dll" (ByVal keyword$, dat As Any, ByVal size%, ByVal fmt%) As Integer
Declare Function GETUSER Lib "tinecl16.dll" (ByVal user$) As Integer
Declare Function SUBSCRIBE Lib "tinecl16.dll" (ByVal hWnd%, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%, ByVal mode%) As Integer
Declare Function A_RPC Lib "tinecl16.dll" (ByVal hWnd%, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function SA_RPC Lib "tinecl16.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function S_RPC Lib "tinecl16.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function OPENLINK Lib "tinecl16.dll" (ByVal hWnd%, ByVal devName$, ByVal devProperty$, dout As DBLK, din As DBLK, datain As Any, ByVal acc%, ByVal pollrate&, ByVal mode%) As Integer

' --------------------------------------------------------
' | to get the client username, you can also use the call:
' |
' |     user$ = username()
' |
' --------------------------------------------------------

' -----------------------------------------
' | Hot Link example (Asynchronous Call): |
' -----------------------------------------
'
' -----------------------------------------
' | 1). Register Link (e.g. in form_load) |
' -----------------------------------------
'      hotID% = HOTRPC(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER)
' OR:
'      hotID% = SUBSCRIBE(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER, CM_REFRESH)
'
' '    registers a Hot Link for:
' '       equipment function EQP$, equipment number EqNo%,
' '       property prop$, polling rate 5000 milliseconds,
' '       equipment size of 100 data elements,
' '       data element format CF_INTEGER
' '    SUBSCRIBE is a more general routine in that you can
' '       also specify the data acquisition mode:
' '       CM_SINGLE  - is a one-shot (i.e. COLD link)
' '                    asynchronous call
' '       CM_REFRESH - specifies a polling rate to the FEC
' '                    but receives data only when they have
' '                    changed (with a heartbeat of 60 sec)
' '                    good for status calls, etc.
' '       CM_POLL    - receives data at the given polling
' '                    rate.
' '       CM_CANCEL  - cancels the subscription
' '    HOTRPC   is identical to SUBSCRIBE with CM_POLL
' '    CLOSERPC is identical to SUBSCRIBE with CM_CANCEL
'
' -----------------------------------------
' | 2). In the paint routine of given form
' |     (here form1) include:
' -----------------------------------------
'
'      If hotID% > 0 Then
'        hotrc% = GETRPC(hotID%, dat%(0))
'        Select Case hotrc%
'          Case Is > 0: rpcerrbox.visible = True 'signal RPC error
'          Case 0: rpcerrbox.visible = False
'                  call updateData               'called when there are new data
'        End Select
'      End If
'
' '    retrieves the incoming data and puts them into array
' '    dat%(), beginning at dat%(0).  You must insure that
' '    dat%() is large enought to hold the amount of data
' '    you request
'
' --------------------------------------------------------
' | rpcerrbox is a picture box with a red RPC icon        |
' | when clicked you can give the most recent return code:|
' --------------------------------------------------------
'
'     rc% = RPCERR(hotrc%, errstr)
'     If rc% Then
'        MsgBox "RPC return code Not defined!"
'     Else
'        MsgBox "RPC error : " + RPCERROR(rc%)
'     End If
'
' ----------------------------------------
' | in form_unload() be sure to include: |
' ----------------------------------------
'
'    If CLOSERPC(form1.hWnd, hotID%) Then
'       msgbox"Error closing hot link!"
'    End If
'    End
'
'
' ----------------------------------------
' | Cold Link Example (Synchronous Call): |
' ----------------------------------------
'
'    rc% = RPC(EQP$, EqNo%, prop$, NPOINTS, dat%(0), 8 * NPOINTS, CF_DOUBLE)
'    If rc% Then
'      MsgBox EQP$ + " : " +RPCERROR(rc%)
'    Else
'      Call updataData
'    End If
'

'==========================================================
'==                                                      ==
'==         General purpose plotting routines            ==
'==                                                      ==
'==========================================================

' -------------------------------------------------
'   For quick plotting, it is strongly suggested that
'   you use the routine DRAWXY described below
'   Several other routines are also given (for historical
'   reasons)
' -------------------------------------------------

Declare Sub DRAWTRACE Lib "utils.dll" (ByVal hDC%, l%, ByVal n%, ByVal ym%)

' -------------------------------------------------
' | plots the trace array (e.g. x%()) vs its index |
' | from 0 to NPOINTS - 1                          |
' |  e.g.                                          |
' -------------------------------------------------
'
'    Call DRAWTRACE(picture1.hDC, x%(0), NPOINTS, YMAX)
'

Declare Sub DRAWTIME Lib "utils.dll" (ByVal hDC%, ByVal x%, ByVal y%)
Declare Sub HISTO Lib "utils.dll" (ByVal hDC%, a!, ByVal aMAX!, ByVal npts%, ByVal wdth%, ByVal offset%, ByVal mode%)

' ---------------------------------------------------
' | mode% = 0 plots positive values only            |
' | mode% = 1 plots negative and positive values    |
' | wdth% gives the spacing between histogram lines |
' | offset% gives the starting position             |
' | e.g.                                            |
' ---------------------------------------------------
'
'    Call HISTO(picture1.hDC, loss(2), ymax, numBLM%, 2, 0, 0)
'
'
Declare Sub PLOTXY Lib "utils.dll" (ByVal hDC%, y!, ByVal ymax!, ByVal ymin!, x!, ByVal npts%)

' ----------------------------------------
' | plots array x() vs array y(), e.g.   |
' ----------------------------------------
'
'    Call PLOTXY(picture1.hDC, y(0), ymax, ymin, x(0), npts%)
'
Declare Sub DRAWXY Lib "utils.dll" (ByVal hDC%, y!, ByVal ymax!, ByVal ymin!, x!, ByVal npts%, ByVal mode%)
Declare Sub WINDOWXY Lib "utils.dll" (ByVal hDC%, y!, ByVal ymax!, ByVal ymin!, x!, ByVal xmax!, ByVal xmin!, ByVal npts%, ByVal mode%)

' ---------------------------------------------------------------
' | plots array x() vs array y() according to given mode, e.g.   |
' | x() and y() both float arrays
' |
' |  MODE:  type of display:
' |     0     connect-the-dots
' |     1     bar-graph
' |     2     histogram
' |     3     individual points
' ---------------------------------------------------------------
'
'    Call DRAWXY(picture1.hDC, y(0), ymax, ymin, x(0), npts%, 0)
'
' ---------------------------------------------------------------
' | WINDOWXY allows you to specify the x-axis window through
' | the xmax and xmin parameters, DRAWXY calculates them for you
' ---------------------------------------------------------------
'
Declare Sub ARRMULT Lib "utils.dll" (ByVal typ%, a As Any, ByVal v As Double, ByVal num%)
'
' -----------------------------------------------------
' | multiplies given array by given value according to |
' | specified type: CF_INTEGER,CF_FLOAT,CF_LONG,       |
' | CF_DOUBLE                                          |
' -----------------------------------------------------
'
'   Call ARRMULT(CF_FLOAT, f(0), x!, npts%)
'
Declare Sub MEMCPY Lib "utils.dll" (dst As Any, src As Any, ByVal nbytes%)
Declare Sub ITOF Lib "utils.dll" (dst!, src%, ByVal num%, ByVal scl!)
Declare Sub LTOF Lib "utils.dll" (dst!, src&, ByVal num%, ByVal scl!)
Declare Function MEAN Lib "utils.dll" (arr!, avearr!, ByVal num%, ByVal depth%) As Integer
Declare Function NORM Lib "utils.dll" (newarr!, avearr!, ByVal num%) As Integer

Declare Function HISTORYINIT Lib "history.dll" (ByVal tag$, ByVal dimen%, ByVal depth%, ByVal rastor%) As Integer
Declare Function HISTORYPUT Lib "history.dll" (ByVal tag$, ByVal value!) As Integer
Declare Function HISTORYPUTARRAY Lib "history.dll" (ByVal tag$, values!, ByVal dimen%) As Integer
Declare Function HISTORYGET Lib "history.dll" (ByVal tag$, ByVal index%, values!, ByVal num%) As Integer
Declare Function HISTORYGETARRAY Lib "history.dll" (ByVal tag$, values!, ByVal dimen%) As Integer

' ---------------------------------------
' | scales integer array ix%() (ITOF) or |
' | lx&() (LTOF) by xscale!              |
' | puts the result in float array fx()  |
' ----------------------------------------
'
'    call ITOF(fx!(0), ix%(0), npts%, xscale!)
'    call LTOF(fx!(0), lx&(0), npts%, xscale!)
'
Declare Function getbit Lib "utils.dll" (ByVal wrd%, ByVal BIT%) As Integer
Declare Function get32bit Lib "utils.dll" (ByVal wrd&, ByVal BIT%) As Integer

' --------------------------------------------
' |   returns value of specified bit (0 or 1) |
' --------------------------------------------

Declare Function SETBIT Lib "utils.dll" (ByVal wrd%, ByVal BIT%) As Integer

' -----------------------------------------------------
' |   sets specified bit to 1 and returns the new word |
' -----------------------------------------------------

Declare Function CLEARBIT Lib "utils.dll" (ByVal wrd%, ByVal BIT%) As Integer

' -----------------------------------------------------
' |   sets specified bit to 0 and returns the new word |
' -----------------------------------------------------

Declare Function CONVTIME Lib "utils.dll" (ByVal dat$, ByVal LONGtime&) As Integer
Declare Sub CTIME Lib "utils.dll" (ByVal dat$, ByVal LONGtime&)

' -----------------------------------------------------
' | returns ascii time string with current time and date |
' | given the unix time constant LONGtime&               |
' | be sure to reserve space for dat$ in global.bas      |
' -----------------------------------------------------
'      global dat as string * 25
'
'      rc% = CONVTIME(dat, timen&)

Declare Function UNIXTIME Lib "utils.dll" () As Long

'==========================================================
'==                                                      ==
'==     archive retrieval routines following LPC format  =====
'==                                                      ==
'==========================================================

Declare Function LOADEQP Lib "lpc.dll" (ByVal fileName$) As Integer
Declare Function LPC Lib "lpc.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal size%, d As Any, ByVal dsize%, ByVal fmt%) As Integer
Declare Function FILER Lib "lpc.dll" (ByVal fname$, f As FSTRUCT, ByVal num%) As Integer

'==========================================================
'==                                                      ==
'==         HERA DATA Retrieval routines                 ==
'==                                                      ==
'==========================================================

Declare Function FETCH Lib "heradata.dll" (ByVal keyword$, ByVal index%, ByVal start&, ByVal Minutes%, ByVal size%, dat As Any, tstamp&) As Integer
Declare Sub FTIME Lib "heradata.dll" (dst!, src&, ByVal shft&, ByVal num%)
Declare Sub ARRLOG Lib "heradata.dll" (dst!, src!, ByVal num%)
Declare Function INTERP Lib "heradata.dll" (y!, ty&, ByVal ny%, tx&, ByVal nx%) As Integer

'==========================================================
'==                                                      ==
'==         windows unzipping routine                    ==
'==                                                      ==
'==========================================================

Declare Function UNZIP Lib "winunzip.dll" (ByVal filenm$, ByVal outpath$) As Integer

'==========================================================
'==                                                      ==
'==            Math routines                             ==
'==                                                      ==
'==========================================================

Declare Function FFT Lib "utils.dll" (ByVal num%, x_arr!, f_arr!, q_max!, ByVal percent!, ByVal cut!) As Integer

'==========================================================
'==
'==              Net Globals
'==
'==========================================================

Global HPENERGY As Integer   'Hera Proton energy
Global HPCURRENT As Double   'Hera Proton Beam Current
Global HPTAU     As Double   'Hera Proton Beam Lifetime
Global HEENERGY As Integer   'Hera Electron energy
Global HECURRENT As Double   'Hera Electron Beam Current
Global HETAU     As Double   'Hera Electron Beam Lifetime

' The associated get routines are:
'     HERAGetEnergy(typ$)
'     HERAGetCurrent(typ$)
'     HERAGetLifetime(typ$)
' where typ$ is either "PROTON" or "ELECTRON"
' the above varables are then updated
'
' e.g. To get the current HERA Proton magnet energy:
'
'    rc% = HERAGetEnergy("PROTON")
'    If rc% Then
'      rc% = RPCERR(rc%, errstr)
'      MsgBox "RPC Error : " + errstr
'    Else
'      MsgBox "Then energy in HERA P is: " + str$(HPENERGY)
'    End If
'

'==========================================================
'==
'==              Printer & GDI Routines
'==
'==========================================================


    ' Paperorientation Portrait <-> Landscape
    Type OrientStructure
      Orientation As Long
      Pad As String * 16
    End Type
    '
    Declare Function Escape% Lib "GDI" (ByVal hDC%, ByVal nEsc%, ByVal nLen%, lpData As OrientStructure, lpOut As Any)

Function GETCURRENT () As Double
Static er As String * 80
rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
If rc% = 0 Then
  GETCURRENT = HPCURRENT
Else
  rc% = RPCERR(rc%, er$)
  MsgBox "GETCURRENT: " + er$
End If
End Function

Function GETENERGY () As Integer
Static er As String * 80
rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
If rc% = 0 Then
  GETENERGY = HPENERGY
Else
  rc% = RPCERR(rc%, er$)
  MsgBox "GETENERGY: " + er$
End If
End Function

Function HERAGetCurrent (ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
       If HPCur < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HECur", HECURRENT, 1, CF_DOUBLE)
       If HECur < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetCurrent = rc%
End Function

Function HERAGetEnergy (ByVal t$) As Integer
Static hemagen As Single
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
       If HPENERGY < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEMAGEN", hemagen, 1, CF_FLOAT)
       HEENERGY = CInt(hemagen)
       If HEENERGY < 0 Then rc% = 91
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetEnergy = rc%
End Function

Function HERAGetLifetime (ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPtau", HPTAU, 1, CF_DOUBLE)
       If HPTAU < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEtau", HETAU, 1, CF_DOUBLE)
       If HETAU < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetLifetime = rc%
End Function

'
Sub Paperorient (to_land As Integer)

    Const PORTRAIT = 1
    Const LANDSCAPE = 2
    Const GETSETPAPERORIENT = 30
    Const myNULL = 0&
    
    Dim Orient As OrientStructure

    '* Specify the orientation
    If to_land Then Orient.Orientation = LANDSCAPE Else Orient.Orientation = PORTRAIT

    '* Send escape sequence to change orientation
    Dim dummy
    dummy = Escape(printer.hDC, GETSETPAPERORIENT, Len(Orient), Orient, myNULL)

    printer.EndDoc 'printer mu jetzt neue initialisiert werden

End Sub

Function RPCERROR (ByVal rc%) As String
Static RPCErrorString As String * 80
If rc% = 0 Then
  RPCERROR = "Success"
Else
  If RPCERR(rc%, RPCErrorString) Then
    RPCERROR = "Error not defined"
  Else
    RPCERROR = RPCErrorString
  End If
End If
End Function

Function SendPMTrigger (subsys As String, cmt As String) As Integer
Dim devName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim triggerlevel%, pmtime&
' Input data (to send):
dbin.dArrayLength = 1
dbin.dFormat = CF_SHORT
triggerlevel% = 1 ' later user -1 to indicate a more critical trigger
' Output data (to receive):
dbout.dArrayLength = 1
dbout.dFormat = CF_LONG
' sub system to receive the trigger
devName$ = "STORAGE/" + LCase(subsys)
rc% = EXECLINK(devName$, "TRIGGER", dbout, pmtime&, dbin, triggerlevel%, CA_WRITE)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
' now send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(Str$(pmtime&))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
rpccmt.text = cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = EXECLINK(devName$, "ANNOTATE", dbout, 0, dbin, rpccmt, CA_WRITE)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
SendPMTrigger = 0
End Function

Function username () As String
cc% = GETUSER(netuser$)
username = Left$(netuser$, InStr(netuser$, Chr(0)) - 1)
End Function

