Attribute VB_Name = "Fit"
'Option Explicit

Type FIT_DATA
    Value(0 To 6) As Double
    Value_Range(0 To 6) As Double
    Deriv(0 To 6) As Double
End Type

Global min_val As Double, max_val As Double, min_arg As Double, max_arg As Double
Global Sum As Double, WireSpeed As Double

Global FitFlags%(6)
Global FitLimit!(1), TagIndexL%, TagIndexR%, CurrentMean!

Global FitArg#(8192)
Global FitVal#(8192)

Function fit_normal_distribution(arg() As Double, fval() As Double, Fit As FIT_DATA, numb As Integer) As Integer
Dim sum_val As Double, sum_val_arg As Double, sum_val_arg2 As Double
Dim sum2 As Double, sum3 As Double, sumtmp As Double
Dim Value As Double, part As Double, unit As Double
Static fitvaltmp(0 To 6) As Double
Dim iteration As Long
Dim i%, wire_freq As Integer
Dim store As FIT_DATA, fit_tmp As FIT_DATA
    
    If numb < 4 Then
        fit_normal_distribution = False
        Exit Function
    End If
    min_val = fval(0)
    max_val = fval(0)
    min_arg = arg(0)
    max_arg = arg(0)
    sum_val = 0
    sum_val_arg = 0
    sum_val_arg2 = 0
    For i% = 0 To numb - 1
        If max_arg < arg(i%) Then max_arg = arg(i%)
        If min_arg > arg(i%) Then min_arg = arg(i%)
        If max_val < fval(i%) Then max_val = fval(i%)
        If min_val > fval(i%) Then min_val = fval(i%)
        sum_val = sum_val + fval(i%)
        sum_val_arg = sum_val_arg + fval(i%) * arg(i%)
        sum_val_arg2 = sum_val_arg2 + fval(i%) * arg(i%) ^ 2
    Next i%
    
    Fit.Value(0) = sum_val_arg / sum_val                            'Mean
    Fit.Value(1) = Sqr(sum_val_arg2 / sum_val - Fit.Value(0) ^ 2)   'Sigma
    Fit.Value(2) = min_val                                          'Offset
    Fit.Value(3) = max_val - min_val                                'Fit Amplitude
'    fit.Value(4) = 1000                                     'Wire Amplitude in microns
'    fit.Value(5) = 3 * 2.661 * WireSpeed / fit.Value(1)     'Angle's frequency omega
    Fit.Value(6) = 0                                        'Wire phase
    Fit.Value_Range(0) = max_arg - min_arg
    Fit.Value_Range(1) = Fit.Value(1)
    Fit.Value_Range(2) = max_val - min_val
    Fit.Value_Range(3) = max_val - min_val
    Fit.Value_Range(4) = 3000                       'Wire Amplitude range in microns
'    fit.value_range(5) = fit.Value(5)         'Angle's frequency (omega) range
    Fit.Value_Range(6) = 6.283186                   'Wire phase range (0 <= phase <= 2*pi)
    
    For i% = 0 To 6
        fit_tmp.Value(i%) = Fit.Value(i%)
        fit_tmp.Value_Range(i%) = Fit.Value_Range(i%)
    Next i%

'For wire_freq = 0 To 400 Step 50
wire_freq = 0
 For i% = 0 To 6
     Fit.Value(i%) = fit_tmp.Value(i%)
     Fit.Value_Range(i%) = fit_tmp.Value_Range(i%)
 Next i%
 Fit.Value(5) = wire_freq * 6.28            'Angle's frequency omega
 Fit.Value_Range(5) = Fit.Value(5)          'Angle's frequency (omega) range

part = 1
Sum = integral_normal_distribution(arg(), fval(), Fit, numb)
For iteration = 1 To 90
    DoEvents
    Value = Abs(Fit.Deriv(0) * Fit.Value_Range(0))
    unit = Abs(Fit.Value_Range(0) / Fit.Deriv(0))
    For i% = 1 To 6
        If Value < Abs(Fit.Deriv(i%) * Fit.Value_Range(i%)) Then
             Value = Abs(Fit.Deriv(i%) * Fit.Value_Range(i%))
             unit = Abs(Fit.Value_Range(i%) / Fit.Deriv(i%))
        End If
    Next i%
    For i% = 0 To 6
        store.Value(i%) = Fit.Value(i%)
        store.Deriv(i%) = Fit.Deriv(i%)
        If Abs(Fit.Deriv(i%) * unit) > Fit.Value_Range(i%) Then
             Fit.Value(i%) = Fit.Value(i%) - Sgn(Fit.Deriv(i%)) * Fit.Value_Range(i%) * part
        Else
            Fit.Value(i%) = Fit.Value(i%) - part * unit * Fit.Deriv(i%)
        End If
    Next i%
    sum2 = integral_normal_distribution(arg(), fval(), Fit, numb)
    If sum2 > Sum Then
        part = part * 0.75
        For i% = 0 To 6
            Fit.Value(i%) = store.Value(i%)
            Fit.Deriv(i%) = store.Deriv(i%)
        Next i%
    Else
        Sum = sum2
    End If
Next iteration

If wire_freq = 100 Then
    sumtmp = Sum
    For i% = 0 To 6
        fitvaltmp(i%) = Fit.Value(i%)
    Next i%
Else
    If Sum < sumtmp Then
        sumtmp = Sum
        For i% = 0 To 6
            fitvaltmp(i%) = Fit.Value(i%)
        Next i%
    End If
End If

'Next wire_freq

 Sum = sumtmp
 For i% = 0 To 6
     Fit.Value(i%) = fitvaltmp(i%)
 Next i%

fit_normal_distribution = True

End Function

Function integral_normal_distribution(arg() As Double, fval() As Double, Fit As FIT_DATA, numb As Integer) As Double
Dim Index%, best_step%
Dim part#, int_nor_dist_tmp#, mean_der_inc#, sigma_der_inc#, offset_der_inc#
Dim statistic_der_inc#, WireAmp_der_inc#, WireFreq_der_inc#, WirePhase_der_inc#
Dim sigma_div#, part_exp#, exp_divident#, WireTime#, sin_cos_arg#

    
    int_nor_dist_tmp = 0
    For Index = 0 To 6
        Fit.Deriv(Index) = 0
    Next Index
    If Fit.Value(1) = 0 Then Fit.Value(1) = 100
    sigma_div = -0.5 / (Fit.Value(1) ^ 2)
    best_step = numb / 50
    
    For Index = 0 To numb - 1 Step best_step
        WireTime = (arg(Index)) / WireSpeed
        sin_cos_arg = Fit.Value(5) * WireTime + Fit.Value(6)
        exp_divident = arg(Index) + Fit.Value(4) * Sin(sin_cos_arg) - Fit.Value(0)
        part_exp = Exp(sigma_div * exp_divident ^ 2)
        offset_der_inc = (Fit.Value(2) - fval(Index) + Fit.Value(3) * part_exp)
        int_nor_dist_tmp = int_nor_dist_tmp + offset_der_inc ^ 2
        statistic_der_inc = offset_der_inc * part_exp
        mean_der_inc = statistic_der_inc * Fit.Value(3) * exp_divident / (Fit.Value(1) ^ 2)
        sigma_der_inc = mean_der_inc * exp_divident / Fit.Value(1)
        WireAmp_der_inc = (-mean_der_inc) * Sin(sin_cos_arg)
        WirePhase_der_inc = (-mean_der_inc) * Fit.Value(4) * Cos(sin_cos_arg)
        WireFreq_der_inc = WirePhase_der_inc * WireTime
        Fit.Deriv(0) = Fit.Deriv(0) + mean_der_inc
        Fit.Deriv(1) = Fit.Deriv(1) + sigma_der_inc
        Fit.Deriv(2) = Fit.Deriv(2) + offset_der_inc
        Fit.Deriv(3) = Fit.Deriv(3) + statistic_der_inc
        Fit.Deriv(4) = Fit.Deriv(4) + WireAmp_der_inc
        Fit.Deriv(5) = Fit.Deriv(5) + WireFreq_der_inc
        Fit.Deriv(6) = Fit.Deriv(6) + WirePhase_der_inc
'        DoEvents
    Next Index
    
    integral_normal_distribution = int_nor_dist_tmp

End Function


Public Sub DoFit()
''  Dim i&, Emit#, Sigma#, WireTime#, sumtmp#
''  Static fitparam#(0 To 6)
''  Dim stat%, wire_amp%, fit_array As FIT_DATA
'''  Dim tmpstr As String
''
''
''  WSMain.ComBut(4).Caption = "Wait ..."
''
''WireSpeed = 500000#                             'Wire speed in microns/sec by default
''
''
''
''
''  For wire_amp = 1000 To 2000 Step 1000
''
''    fit_array.Value(4) = wire_amp                        'Wire Amplitude in microns
''    stat = fit_normal_distribution(FitArg(), FitVal(), fit_array, CInt(PrBeg))
''
''    If wire_amp = 1000 Then
''        sumtmp = Sum
''        For i = 0 To 6
''            fitparam(i) = fit_array.Value(i)
''        Next i
''    Else
''        If Sum < sumtmp Then
''            sumtmp = Sum
''            For i = 0 To 6
''                fitparam(i) = fit_array.Value(i)
''            Next i
''        End If
''    End If
''
''  Next wire_amp
''
''  For i = 0 To PrBeg - 1
''    WireTime = FitArg(i) / WireSpeed
''    FitVal(i) = fitparam(2) + fitparam(3) * Exp(-0.5 * (FitArg(i) + fitparam(4) * Sin(fitparam(5) * WireTime + fitparam(6)) - fitparam(0)) ^ 2 / fitparam(1) ^ 2)
''  Next i
''
''  'FittedProfileDrawing fitval(), 0    'Black color
''
''  For i = 0 To PrBeg - 1
''    FitVal(i) = fitparam(2) + fitparam(3) * Exp(-0.5 * (FitArg(i) - fitparam(0)) ^ 2 / fitparam(1) ^ 2)
''  Next i
''
''  'FittedProfileDrawing fitval(), 15   'White color
''
''  Sigma = fitparam(1) / 1000#
''
''''  WSMain.LabFit(5).Caption = Format$(FWHM!, "##0.000") & " mm"
''''  WSMain.LabFit(0).Caption = Format$(fitparam(0) / 1000#, "##0.000") & " mm"
''''  WSMain.LabFit(6).Caption = CLng(fitparam(3)) + Noise
''''  WSMain.WireFr.Caption = Format$(fitparam(5) / 6.28, "##0") & " Hz"
''''  WSMain.WireAm.Caption = Format$(fitparam(4) / 1000#, "0.00") & "mm"
''
'''   emit in pi*mm* mrad, fwhm in mm, Energy and Rest_Mass in GeV, beta in meter
'''   Emit = (fwhm / 1000# / 1.18) ^ 2 * Energy / (Rest_Mass * beta)
''
''''  If Energy < 0# Then
''''     WSMain.n_emit.Caption = ""
''''     Exit Sub
''''  End If
'''''  Emit = (fwhm / 1.18) ^ 2 * Energy / (.938 * BetaValue(Energy))
''''  Emit = (2 * Sigma) ^ 2 * Energy / (0.938 * BetaValue(Energy))
''''  WSMain.n_emit.Caption = Format$(Emit, "##0.000")
''
'''Picgr.ForeColor = BLUE
'''Picgr.CurrentX = 0
'''Picgr.CurrentY = 4095
'''Picgr.FontSize = 8
'''tmpstr = "mean=" & Format$(fitparam(0)) & " sigma=" & Format$(fitparam(1)) & NL & "offset=" & Format$(fitparam(2)) & " ampl=" & Format$(fitparam(3)) & NL
'''tmpstr = tmpstr & "WireAmp=" & Format$(fitparam(4)) & " omega=" & Format$(fitparam(5)) & NL & "phase=" & Format$(fitparam(6))
'''Picgr.Print tmpstr
''
''  WSMain.ComBut(4).Caption = " Data Fitting"
''
End Sub

Public Sub DoSimpleFit(ADCIndex%)
'Public Sub DoSimpleFit(XArr!(), YArr!(), NPts%, ResAna!,ResFit!(),FitArr!())

'Dim i%, j%, Emit#, Sigma#, WireTime#, sumtmp#
'Static fitparam#(0 To 6)
'Dim stat%, wire_amp%, fit_array As FIT_DATA
'Dim XStart!, XEnd!, IndStart%, IndEnd%, PosSlope!, FitPoints%
'Dim TmpRes1#(6), TmpRes2#(6), DistParams#(6)
''Dim tmpstr As String
'
'On Error GoTo NoFit
'
'WSMain.ACOPPlot(0).DisplayMode = PolyLine
'
''For i% = 0 To ScanNPoints% - 1
''    FitArg(i%) = 0 'CurrPos!(i%)
''    FitVal(i%) = 0 'CurrProf!(i%)
''Next i%
'
''For i% = 0 To 3
''    FitFlags%(i%) = 1
''Next i
''stat = fitSimpleNormal(FitArg(), FitVal(), AnaRes#(), fit_array, DistParams(), CInt(ScanNPoints%))
'
'For i% = 0 To 3
'    TmpRes1#(i%) = fit_array.Value(i%)
'Next i
'
'If WSMain.ChkFit(0).Value = 1 Then
'    For i% = 0 To ScanNPoints% - 1
'        'FitVal(i%) = TmpRes2#(2) + TmpRes2#(3) * Exp(-0.5 * (CurrPos!(i%) - TmpRes2#(0)) ^ 2 / TmpRes2#(1) ^ 2)
'        'FitVal(i%) = TmpRes1#(2) + TmpRes1#(3) * Exp(-0.5 * (CurrPos!(i%) - TmpRes1#(0)) ^ 2 / TmpRes1#(1) ^ 2)
'    Next i%
'    WSMain.ACOPPlot(0).ForeColor = BLUE
'    rcc& = WSMain.ACOPPlot(0).Draw(FitVal, FitArg, , , ScanNPoints%)
'
'    'RowStr$ = Format(TmpRes1#(0), "####0.00") + vbTab + Format(AnaRes#(1), "####0.00") + vbTab + Format(TmpRes1#(1), "####0.00") + vbCr
'    WSMain.GridResults(0).col = 1: WSMain.GridResults(0).Row = ADCIndex% + 1
'    WSMain.GridResults(0).ColSel = 3: WSMain.GridResults(0).RowSel = ADCIndex% + 1
'    WSMain.GridResults(0).Clip = RowStr$
'End If
'
'If 1 = 1 Then Exit Sub
'
''''WSMain.LabFit(0).Caption = Format$(TmpRes1(0), "##0.000") & " mm"  ' mean
''''WSMain.LabFit(1).Caption = Format$(TmpRes1(1), "##0.000") & " mm" ' sigma
''''WSMain.LabFit(2).Caption = Format$(TmpRes1(2), "####0") & " " ' offset
''''WSMain.LabFit(3).Caption = Format$(TmpRes1(3), "####0") & " " ' ampl.
'
'SigFit! = 2.5
'XStart! = TmpRes1#(0) - SigFit! * TmpRes1#(1)
'XEnd! = TmpRes1#(0) + SigFit! * TmpRes1#(1)
'
'IndStart% = 0
'IndEnd% = 0
''For i% = 0 To ScanNPoints% - 1
''    If CurrPos!(i%) > XStart! Then
''        IndStart% = i%
''        Exit For
''    End If
''Next i%
''For i% = ScanNPoints% - 1 To 0 Step -1
''    If CurrPos!(i%) < XEnd! Then
''        IndEnd% = i%
''        Exit For
''    End If
''Next i%
'FitPoints% = IndEnd% - IndStart% + 1
'
'' Fill parameter arrays - and use offset from previous fit....
'For i% = 0 To FitPoints% - 1
'    FitArg(i%) = CurrPos!(i% + IndStart%)
'    FitVal(i%) = CurrProf!(i% + IndStart%) ' - TmpRes1#(2)
'Next i%
'
'For i% = 0 To 3
'    FitFlags%(i%) = 1
'Next i%
'FitFlags%(2) = 0
'
'stat = fitSimpleNormal(FitArg(), FitVal(), AnaRes#(), fit_array, DistParams(), CInt(FitPoints%))
'
'For i% = 0 To 3
'    TmpRes2#(i%) = fit_array.Value(i%)
'Next i%
'
'If WSMain.ChkFit(0).Value = 1 Then
'    For i% = 0 To ScanNPoints% - 1
'        FitVal(i%) = TmpRes2#(2) + TmpRes2#(3) * Exp(-0.5 * (CurrPos!(i%) - TmpRes2#(0)) ^ 2 / TmpRes2#(1) ^ 2)
'        'FitVal(i%) = TmpRes1#(2) + TmpRes1#(3) * Exp(-0.5 * (CurrPos!(i%) - TmpRes1#(0)) ^ 2 / TmpRes1#(1) ^ 2)
'    Next i%
'    WSMain.ACOPPlot(0).ForeColor = BLUE
'    rcc& = WSMain.ACOPPlot(0).Draw(FitVal, FitArg, , , ScanNPoints%)
'End If
'
''''    WSMain.LabFit(8).Caption = Format$(TmpRes2(0), "##0.000") & " mm"  ' mean
''''    WSMain.LabFit(9).Caption = Format$(TmpRes2(1), "##0.000") & " mm" ' sigma
''''    WSMain.LabFit(10).Caption = Format$(TmpRes2(2), "####0") & " " ' offset
''''    WSMain.LabFit(11).Caption = Format$(TmpRes2(3), "####0") & " " ' ampl.
''''
'''''   emit in pi*mm* mrad, fwhm in mm, Energy and Rest_Mass in GeV, beta in meter
'''''   Emit = (fwhm / 1000# / 1.18) ^ 2 * Energy / (Rest_Mass * beta)
''''
''Emit = (fwhm / 1.18) ^ 2 * Energy / (.938 * BetaValue(Energy))
''Emit = (2 * Sigma) ^ 2 * Energy / (0.938 * BetaValue(Energy))
''WSMain.n_emit.Caption = Format$(Emit, "##0.000")
'Exit Sub
'
'NoFit:

End Sub

Public Function fitSimpleNormal(arg() As Double, fval() As Double, AnaResults() As Double, Fit As FIT_DATA, Dist() As Double, npts%) As Integer
'Dim sum_val As Double, sum_val_arg As Double, sum_val_arg2 As Double
'Dim sum2 As Double, sum3 As Double, sumtmp As Double
'Dim Value As Double, part As Double, unit As Double
'Static fitvaltmp(0 To 6) As Double
'Dim iteration As Long
'Dim wire_freq As Integer
'Dim store As FIT_DATA, fit_tmp As FIT_DATA
'Dim i%, q_mean#, q_rms#, s_val#, iStart%, iEnd%, TmpData!
'
'On Error GoTo NoFit
'
'If npts% < 4 Then
'    fitSimpleNormal = False
'    Exit Function
'End If
'min_val = fval(0)
'max_val = fval(0)
'min_arg = arg(0)
'max_arg = arg(0)
'sum_val = 0
'sum_val_arg = 0
'sum_val_arg2 = 0
'For i% = 0 To npts% - 1
'    If max_arg < arg(i%) Then max_arg = arg(i%)
'    If min_arg > arg(i%) Then min_arg = arg(i%)
'    If max_val < fval(i%) Then max_val = fval(i%)
'    If min_val > fval(i%) Then min_val = fval(i%)
'    'TmpData! = fval(i%)
'    TmpData! = Abs(fval(i%) - Offset!)
'    sum_val = sum_val + TmpData!
'    sum_val_arg = sum_val_arg + TmpData! * arg(i%)
'    sum_val_arg2 = sum_val_arg2 + TmpData! * arg(i%) ^ 2
'Next i%
'
'Fit.Value(0) = sum_val_arg / sum_val                            'Mean
'Fit.Value(1) = Sqr(sum_val_arg2 / sum_val - Fit.Value(0) ^ 2)   'Sigma
'If FitFlags%(2) = 1 Then Fit.Value(2) = min_val                 'Offset
'Fit.Value(3) = max_val - min_val                                'Fit Amplitude
'
'' Send Mean and RMS back...
'AnaResults(0) = Fit.Value(0)
'AnaResults(1) = Fit.Value(1)
'
'' Send basic parameters back....
'For i% = 0 To 3
'    Dist(i%) = Fit.Value(i%)
'Next i%
'
'Fit.Value_Range(0) = max_arg - min_arg
'Fit.Value_Range(1) = Fit.Value(1)
'Fit.Value_Range(2) = max_val - min_val
'Fit.Value_Range(3) = max_val - min_val
'
'part = 1
'Sum = GaussSums(arg(), fval(), Fit, npts%)
'For iteration = 1 To 90
'    DoEvents
'    Value = Abs(Fit.Deriv(0) * Fit.Value_Range(0))
'    unit = Abs(Fit.Value_Range(0) / Fit.Deriv(0))
'    For i% = 1 To 3
'        If (FitFlags%(i%) = 1) And (Value < Abs(Fit.Deriv(i%) * Fit.Value_Range(i%))) Then
'             Value = Abs(Fit.Deriv(i%) * Fit.Value_Range(i%))
'             unit = Abs(Fit.Value_Range(i%) / Fit.Deriv(i%))
'        End If
'    Next i%
'    For i% = 0 To 3
'        store.Value(i%) = Fit.Value(i%)
'        store.Deriv(i%) = Fit.Deriv(i%)
'        If FitFlags%(i%) = 1 Then
'            If Abs(Fit.Deriv(i%) * unit) > Fit.Value_Range(i%) Then
'                 Fit.Value(i%) = Fit.Value(i%) - Sgn(Fit.Deriv(i%)) * Fit.Value_Range(i%) * part
'            Else
'                Fit.Value(i%) = Fit.Value(i%) - part * unit * Fit.Deriv(i%)
'            End If
'        End If
'    Next i%
'    sum2 = GaussSums(arg(), fval(), Fit, npts%)
'    If sum2 > Sum Then
'        part = part * 0.75
'        For i% = 0 To 3
'            Fit.Value(i%) = store.Value(i%)
'            Fit.Deriv(i%) = store.Deriv(i%)
'        Next i%
'    Else
'        Sum = sum2
'    End If
'Next iteration
'
'For i% = 0 To npts% - 1
'    If arg(i%) > Fit.Value(0) - 3 * Fit.Value(1) Then
'        iStart% = i%
'        Exit For
'    End If
'Next i%
'
'For i% = npts% - 1 To 0 Step -1
'    If arg(i%) < Fit.Value(0) + 3 * Fit.Value(1) Then
'        iEnd% = i%
'        Exit For
'    End If
'Next i%
'
'sum_val = 0
'sum_val_arg = 0
'sum_val_arg2 = 0
'For i% = iStart% To iEnd%
'    s_val = fval(i%)
'    sum_val = sum_val + s_val
'    sum_val_arg = sum_val_arg + s_val * arg(i%)
'    sum_val_arg2 = sum_val_arg2 + s_val * arg(i%) ^ 2
'Next i%
'
'q_mean = sum_val_arg / sum_val                           'Mean
'q_rms = Sqr(sum_val_arg2 / sum_val - q_mean ^ 2)         'RMS
''WSMain.labfit(4).Caption = Format$(q_rms, "##0.000") & " mm"
'
'fitSimpleNormal = True
'Exit Function
'
'NoFit:
'fitSimpleNormal = False

End Function

Public Function GaussSums(arg() As Double, fval() As Double, Fit As FIT_DATA, npts As Integer) As Double
Dim Index%, best_step%
Dim int_nor_dist_tmp#, mean_der_inc#, sigma_der_inc#, Diff#, statistic_der_inc#
Dim sigma_div#, part_exp#, exp_divident#

    
int_nor_dist_tmp = 0
For Index = 0 To 3
    Fit.Deriv(Index) = 0
Next Index
If Fit.Value(1) = 0 Then Fit.Value(1) = 100
sigma_div = -0.5 / (Fit.Value(1) ^ 2)
best_step = npts% / 50
If best_step < 2 Then best_step = 1
    
For Index = 0 To npts% - 1 Step best_step
    exp_divident = arg(Index) - Fit.Value(0)
    part_exp = Exp(sigma_div * exp_divident ^ 2)
    Diff = (Fit.Value(2) + Fit.Value(3) * part_exp - fval(Index))
    int_nor_dist_tmp = int_nor_dist_tmp + Diff ^ 2
    statistic_der_inc = Diff * part_exp
    mean_der_inc = statistic_der_inc * Fit.Value(3) * exp_divident / (Fit.Value(1) ^ 2)
    sigma_der_inc = mean_der_inc * exp_divident / Fit.Value(1)
    Fit.Deriv(0) = Fit.Deriv(0) + mean_der_inc
    Fit.Deriv(1) = Fit.Deriv(1) + sigma_der_inc
    Fit.Deriv(2) = Fit.Deriv(2) + Diff
    Fit.Deriv(3) = Fit.Deriv(3) + statistic_der_inc
Next Index
GaussSums = int_nor_dist_tmp
End Function
Public Function FitaLine(arg() As Double, fval() As Double, Fit As FIT_DATA, Dist() As Double, npts%) As Integer
'Dim sum_val As Double, sum_val_arg As Double, sum_val_arg2 As Double
'Dim sum2 As Double, sum3 As Double, sumtmp As Double
'Dim Value As Double, part As Double, unit As Double
'Static fitvaltmp(0 To 6) As Double
'Dim iteration As Long
'Dim wire_freq As Integer
'Dim store As FIT_DATA, fit_tmp As FIT_DATA
'Dim i%, q_mean#, q_rms#, s_val#, iStart%, iEnd%, TmpData!
'
'If npts% < 4 Then
'    FitaLine = False
'    Exit Function
'End If
'min_val = fval(0)
'max_val = fval(0)
'min_arg = arg(0)
'max_arg = arg(0)
'sum_val = 0
'sum_val_arg = 0
'sum_val_arg2 = 0
'
'For i% = 0 To npts% - 1
'    If max_arg < arg(i%) Then max_arg = arg(i%)
'    If min_arg > arg(i%) Then min_arg = arg(i%)
'    If max_val < fval(i%) Then max_val = fval(i%)
'    If min_val > fval(i%) Then min_val = fval(i%)
'    TmpData! = Abs(fval(i%) - Offset!)
'    sum_val = sum_val + TmpData!
'    sum_val_arg = sum_val_arg + TmpData! * arg(i%)
'    sum_val_arg2 = sum_val_arg2 + TmpData! * arg(i%) ^ 2
'Next i%
'
'Fit.Value(0) = (fval(npts% - 1) - fval(1)) / (arg(npts% - 1) - arg(1)) 'Slope
'Fit.Value(1) = Sqr(sum_val_arg2 / sum_val - Fit.Value(0) ^ 2)          'Offset
'
'' Send basic parameters back....
'For i% = 0 To 3
'    Dist(i%) = Fit.Value(i%)
'Next i%
'
'Fit.Value_Range(0) = max_arg - min_arg
'Fit.Value_Range(1) = Fit.Value(1)
'
'part = 1
'Sum = GaussSums(arg(), fval(), Fit, npts%)
'For iteration = 1 To 90
'    DoEvents
'    Value = Abs(Fit.Deriv(0) * Fit.Value_Range(0))
'    unit = Abs(Fit.Value_Range(0) / Fit.Deriv(0))
'    For i% = 1 To 1
'        If (FitFlags%(i%) = 1) And (Value < Abs(Fit.Deriv(i%) * Fit.Value_Range(i%))) Then
'             Value = Abs(Fit.Deriv(i%) * Fit.Value_Range(i%))
'             unit = Abs(Fit.Value_Range(i%) / Fit.Deriv(i%))
'        End If
'    Next i%
'    For i% = 0 To 1
'        store.Value(i%) = Fit.Value(i%)
'        store.Deriv(i%) = Fit.Deriv(i%)
'        If Abs(Fit.Deriv(i%) * unit) > Fit.Value_Range(i%) Then
'             Fit.Value(i%) = Fit.Value(i%) - Sgn(Fit.Deriv(i%)) * Fit.Value_Range(i%) * part
'        Else
'            Fit.Value(i%) = Fit.Value(i%) - part * unit * Fit.Deriv(i%)
'        End If
'    Next i%
'    sum2 = GaussSums(arg(), fval(), Fit, npts%)
'    If sum2 > Sum Then
'        part = part * 0.75
'        For i% = 0 To 1
'            Fit.Value(i%) = store.Value(i%)
'            Fit.Deriv(i%) = store.Deriv(i%)
'        Next i%
'    Else
'        Sum = sum2
'    End If
'Next iteration
'
'' Calculate difference to EXPECTED slope?
'
'sum_val = 0
'sum_val_arg = 0
'sum_val_arg2 = 0
'For i% = iStart% To iEnd%
'    s_val = fval(i%)
'    sum_val = sum_val + s_val
'    sum_val_arg = sum_val_arg + s_val * arg(i%)
'    sum_val_arg2 = sum_val_arg2 + s_val * arg(i%) ^ 2
'Next i%
'
'FitaLine = True

End Function

Public Function LineSums(arg() As Double, fval() As Double, Fit As FIT_DATA, npts As Integer) As Double
Dim Index%, best_step%
Dim int_nor_dist_tmp#, mean_der_inc#, sigma_der_inc#, Diff#, statistic_der_inc#
Dim sigma_div#, part_exp#, exp_divident#

int_nor_dist_tmp = 0
Fit.Deriv(0) = 0
Fit.Deriv(1) = 0
best_step = npts% / 50
    
For Index = 0 To npts% - 1 Step best_step
    exp_divident = arg(Index) - Fit.Value(0)
    part_exp = Exp(sigma_div * exp_divident ^ 2)
    Diff = (Fit.Value(2) + Fit.Value(3) * part_exp - fval(Index))
    int_nor_dist_tmp = int_nor_dist_tmp + Diff ^ 2
    statistic_der_inc = Diff * part_exp
    mean_der_inc = statistic_der_inc * Fit.Value(3) * exp_divident / (Fit.Value(1) ^ 2)
    sigma_der_inc = mean_der_inc * exp_divident / Fit.Value(1)
    Fit.Deriv(0) = Fit.Deriv(0) + mean_der_inc
    Fit.Deriv(1) = Fit.Deriv(1) + sigma_der_inc
Next Index
LineSums = int_nor_dist_tmp
End Function


Public Function FitaCurve(XArr!(), YArr!(), InPts%, ResAna!(), ResFit!())

Dim i%, j%
Dim stat%, FitArray As FIT_DATA
Dim XStart!, XEnd!, IndStart%, IndEnd%, PosSlope!, FitPoints%
Dim Tmp#, TmpRMSEstimate!, tmpFlag As Boolean

Dim MinVal!, MaxVal!, Sum#, SumX#, SumXX#, MeanAll!, RMSAll!, TmpCut!, NFitPoints%
Dim TmpOffset!, TmpSlope!, tmpX!, HMaxLow!, HMaxHi!
Dim iStart%, iEnd%, TmpMean!

Dim RefinedMean!, RefinedRMS!

On Error GoTo NoFit

For i% = 0 To InPts% - 1 ' - 1000
    TmpData# = CDbl(YArr!(i%)) 'Abs(CurrProf!(i%) - Offset!)
    'If TmpData# < 0 Then TmpData# = 0
    'If Abs(TmpData) < 10 Then TmpData# = 0
    Sum# = Sum# + TmpData#
    SumX# = SumX# + TmpData# * CDbl(XArr!(i%))
Next i%
TmpMean! = SumX# / Sum#


' Calculate mean and RMS
MinVal! = YArr!(0): MaxVal! = YArr!(0)
Sum# = 0: SumX# = 0: SumXX# = 0
For i% = 0 To InPts% - 1 ' - 1000
    If MaxVal! < YArr!(i%) Then MaxVal! = YArr!(i%)
    If MinVal! > YArr!(i%) Then MinVal! = YArr!(i%)
    
    TmpData# = CDbl(YArr!(i%)) 'Abs(CurrProf!(i%) - Offset!)
    'If TmpData# < 0 Then TmpData# = 0
    If Abs(TmpData) < 10 Then TmpData# = 0
    
    Sum# = Sum# + TmpData#
    SumX# = SumX# + TmpData# * CDbl(XArr!(i%) - TmpMean!)
    SumXX# = SumXX# + Abs(TmpData#) * (CDbl(XArr!(i%) - TmpMean!) ^ 2)
Next i%

' Prepare estimates for the fit....
MeanAll! = SumX# / Sum#
Tmp# = SumXX# / Sum# - CDbl(MeanAll!) ^ 2
If Tmp# < 0 Then
    RMSAll! = 1
Else
    RMSAll! = Sqr(SumXX# / Sum# - MeanAll! ^ 2)   'Sigma
End If
MeanAll! = MeanAll! + TmpMean!

' Find the FWHM (rather crude, but...)
HMaxLow! = 0
HMaxHi! = 0
FWHM = 0
TmpOffset! = 0
TestVal! = (MaxVal! - TmpOffset!) / 2 + TmpOffset!

FirstInd% = -1
For i% = 1 To InPts% - 1
    If YArr!(i%) >= TestVal! Then
        FirstInd% = i%
        ' calculate the slope...
        ' What to do if not monotonically increasing?
        If YArr!(i%) > YArr!(i% - 1) Then
            ' Normal case...
            TmpSlope! = (YArr!(i%) - YArr!(i% - 1)) / (XArr!(i%) - XArr!(i% - 1))
            tmpX! = (TestVal! - YArr!(i% - 1)) / TmpSlope!
            HMaxLow! = XArr!(i% - 1) + tmpX!
            ' Just because of the kludging... so if it goes BANANAS, then it isn't SO bad...
            If HMaxLow! < (2 * XArr!(0) - XArr!(1)) Then HMaxLow! = (2 * XArr!(0) - XArr!(1))
        Else
            HMaxLow! = XArr!(i%) '+ TmpX!
        End If
        'Debug.Print "FWHM Low: ", XArr!(FirstInd%), HMaxLow!
        Exit For
    End If
Next i%
  
LastInd% = -1
For i% = InPts% - 2 To FirstInd% + 1 Step -1
    If YArr!(i%) >= TestVal! Then
        LastInd% = i%
        ' calculate the slope...
        ' What to do if not monotonically decreasing?
        If YArr!(i% + 1) < YArr!(i%) Then
            ' Normal case...
            TmpSlope! = (YArr!(i% + 1) - YArr!(i%)) / (XArr!(i% + 1) - XArr!(i%))
            tmpX! = (TestVal! - YArr!(i%)) / TmpSlope!
            HMaxHi! = XArr!(i%) + tmpX!
            If HMaxHi! > (2 * XArr!(InPts% - 1) - XArr!(InPts% - 2)) Then HMaxHi! = 2 * XArr!(InPts% - 1) - XArr!(InPts% - 2)
        Else
            ' Not OK - just punt... error on the BIG side?
            HMaxHi! = XArr!(i%)  '+ TmpX!
        End If
        'Debug.Print "FWHM Hi: ", XArr!(LastInd%), HMaxHi!
        Exit For
    End If
Next i%

If FirstInd% = -1 Then
    FirstInd% = 0
    HMaxLow! = XArr!(FirstInd%)
End If
If LastInd% = -1 Then
    LastInd% = InPts% - 1
    HMaxHi! = XArr!(LastInd%)
End If

FWHM = XArr!(LastInd%) - XArr!(FirstInd%)

' ResAna:
' mean, sigma, offset, Max, fwhmLo, fwhmHi
ResAna!(0) = MeanAll!
ResAna!(1) = RMSAll!
ResAna!(2) = TmpOffset!
ResAna!(3) = MaxVal! - TmpOffset!
ResAna!(4) = HMaxLow!
ResAna!(5) = HMaxHi!

CurrentMean! = ResAna!(0)

' Don't need to bother to fit the whole region: +/- a few sigma(?)
' Check first if "tagged"
If TagIndexL% = -1 Then
    TmpCut! = MeanAll! - FitLimit!(0) * RMSAll!
    For i% = 1 To InPts% - 1
        If XArr!(i%) > TmpCut! Then
            iStart% = i% - 1
            Exit For
        End If
    Next i%
Else
    iStart% = TagIndexL%
End If

If TagIndexR% = -1 Then
    TmpCut! = MeanAll! + FitLimit!(1) * RMSAll!
    For i% = InPts% - 2 To 0 Step -1
        If XArr!(i%) < TmpCut! Then
            iEnd% = i% + 1
            Exit For
        End If
    Next i%
Else
    iEnd% = TagIndexR%
End If

' Recalculate the RMS?
tmpFlag = False 'True
If tmpFlag Then
    Sum# = 0: SumX# = 0: SumXX# = 0
    For i% = iStart% To iEnd%
        TmpData# = CDbl(YArr!(i%))
        If Abs(TmpData) < 10 Then TmpData# = 0
        
        Sum# = Sum# + TmpData#
        SumX# = SumX# + TmpData# * CDbl(XArr!(i%) - TmpMean!)
        SumXX# = SumXX# + Abs(TmpData#) * (CDbl(XArr!(i%) - TmpMean!) ^ 2)
    Next i%
    
    ' Prepare estimates for the fit....
    RefinedMean! = SumX# / Sum#
    Tmp# = SumXX# / Sum# - CDbl(RefinedMean!) ^ 2
    If Tmp# < 0 Then
        RefinedRMS! = 1
    Else
        RefinedRMS! = Sqr(SumXX# / Sum# - RefinedMean! ^ 2)   'Sigma
    End If
    RefinedMean! = RefinedMean! + TmpMean!

    RMSAll! = RefinedRMS!
    MeanAll! = RefinedMean!
End If


If RMSAll! = 1 Then
    ' Get a better estimate?
    TmpRMSEstimate! = (XArr!(iEnd%) - XArr!(iStart%)) / 2
Else
    TmpRMSEstimate! = RMSAll!
End If

' Prepare estimates for the fit....
NFitPoints% = iEnd% - iStart% + 1
For i% = 0 To NFitPoints% - 1
    FitArg(i%) = XArr!(i% + iStart%)
    FitVal(i%) = YArr!(i% + iStart%)
Next i%

FitArray.Value(0) = MeanAll!                            'Mean
FitArray.Value(1) = TmpRMSEstimate! 'RMSAll!                             'Sigma
FitArray.Value(2) = MinVal!                             'Offset
FitArray.Value(3) = MaxVal! - MinVal!                   'Fit Amplitude

FitArray.Value_Range(0) = FitArg(NFitPoints% - 1) - FitArg(0)
FitArray.Value_Range(1) = FitArray.Value(1)
FitArray.Value_Range(2) = FitArray.Value(3)
FitArray.Value_Range(3) = FitArray.Value(3)

For i% = 0 To 3
    FitFlags%(i%) = 1
Next i

If WSHera.ChkFitOffset.Value = 1 Then
    FitArray.Value(2) = 0
    FitArray.Value_Range(2) = 0
    FitFlags%(2) = 0
End If

RetStatus = LSLoop(FitArg(), FitVal(), FitArray, NFitPoints%)
If RetStatus Then
    ' ResFit:
    ' mean, sigma, offset, ampl.
    For i% = 0 To 3
        ResFit!(i%) = FitArray.Value(i%)
    Next i
    FitaCurve = 1
Else
    FitaCurve = -1
    For i% = 0 To 3
        ResFit!(i%) = 0
    Next i
End If
Exit Function

NoFit:
For i% = 0 To 3
    ResFit!(i%) = 0
Next i
FitaCurve = -1
End Function

Public Function LSLoop(arg#(), fval#(), Fit As FIT_DATA, InPts%) As Integer

Dim sum_val As Double, sum_val_arg As Double, sum_val_arg2 As Double
Dim sum2 As Double, sum3 As Double, sumtmp As Double
Dim Value As Double, part As Double, unit As Double
Static fitvaltmp(0 To 6) As Double
Dim iteration As Long
Dim wire_freq As Integer
Dim store As FIT_DATA, fit_tmp As FIT_DATA
Dim i%, q_mean#, q_rms#, s_val#, iStart%, iEnd%, TmpData!

On Error GoTo NoFit

If InPts% < 4 Then
    LSLoop = False
    Exit Function
End If
    
part = 1
Sum = GaussSums(arg(), fval(), Fit, InPts%)
For iteration = 1 To 90
    DoEvents
    Value = Abs(Fit.Deriv(0) * Fit.Value_Range(0))
    unit = Abs(Fit.Value_Range(0) / Fit.Deriv(0))
    For i% = 1 To 3
        If (FitFlags%(i%) = 1) And (Value < Abs(Fit.Deriv(i%) * Fit.Value_Range(i%))) Then
             Value = Abs(Fit.Deriv(i%) * Fit.Value_Range(i%))
             unit = Abs(Fit.Value_Range(i%) / Fit.Deriv(i%))
        End If
    Next i%
    For i% = 0 To 3
        store.Value(i%) = Fit.Value(i%)
        store.Deriv(i%) = Fit.Deriv(i%)
        If FitFlags%(i%) = 1 Then
            If Abs(Fit.Deriv(i%) * unit) > Fit.Value_Range(i%) Then
                 Fit.Value(i%) = Fit.Value(i%) - Sgn(Fit.Deriv(i%)) * Fit.Value_Range(i%) * part
            Else
                Fit.Value(i%) = Fit.Value(i%) - part * unit * Fit.Deriv(i%)
            End If
        End If
    Next i%
    sum2 = GaussSums(arg(), fval(), Fit, InPts%)
    If sum2 > Sum Then
        part = part * 0.75
        For i% = 0 To 3
            Fit.Value(i%) = store.Value(i%)
            Fit.Deriv(i%) = store.Deriv(i%)
        Next i%
    Else
        Sum = sum2
    End If
Next iteration

LSLoop = True
Exit Function

NoFit:
LSLoop = False

End Function
