Attribute VB_Name = "OpticsFuncs"

Public Sub RPC_OrbitCorrectionFK(IndexArg As Integer, ByRef OrbitArg As OrbitType, ByRef PhaseRmsArg As PhaseRmsType, ByRef OrbitCorrectionArg As OrbitCorrectionType)
    Dim RpcOrbitLoc As RpcFindKickType
    Dim i%, j%
    
    ' Control Information from Client >> RPC Hdr
    RpcOrbitLoc.Hdr.Version = MAIN_VERSION
    RpcOrbitLoc.Hdr.NGDebug = NGDebug
    RpcOrbitLoc.Hdr.HPDebug = HPDebug

    RpcOrbitLoc.Hdr.Arr_mon = MonDim + 1
    RpcOrbitLoc.Hdr.Arr_cor = CorDim + 1
    RpcOrbitLoc.Hdr.Arr_il = LatDim + 1
    RpcOrbitLoc.Hdr.Arr_jl = EleDim + 1

    RpcOrbitLoc.Hdr.Hdr_Size = Len(RpcOrbitLoc.Hdr)
    RpcOrbitLoc.Hdr.Spez_Hdr_Size = Len(RpcOrbitLoc.Hdr2)
    RpcOrbitLoc.Hdr.Arr_Size = Len(RpcOrbitLoc) - Len(RpcOrbitLoc.Hdr) - Len(RpcOrbitLoc.Hdr2)
           
    ' Machine / Year >> RPC Hdr
    Call String2Bytes(RpcOrbitLoc.Hdr.Machine(0), OrbitArg.Machine, 8)
    Call String2Bytes(RpcOrbitLoc.Hdr.Year(0), OrbitArg.Year, 4)
    
    ' Orbit Structure >> RPC Hdr
    Call String2Bytes(RpcOrbitLoc.Hdr.Text1(0), OrbitArg.Text1, 60)
    Call String2Bytes(RpcOrbitLoc.Hdr.text2(0), OrbitArg.text2, 60)
    Call String2Bytes(RpcOrbitLoc.Hdr.DateTime(0), OrbitArg.DateTime, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr.Optic(0), OrbitArg.Optic, 16)
    Call String2Bytes(RpcOrbitLoc.Hdr.OpticFlag(0), OrbitArg.OpticFlag, 16)
    ' RpcOrbitLoc.Hdr.MonNum(HOR) = OrbitArg.MonNum(HOR)  ' F.Brinker
    ' RpcOrbitLoc.Hdr.MonNum(VER) = OrbitArg.MonNum(VER)  ' F.Brinker
    ' RpcOrbitLoc.Hdr.CorNum(HOR) = OrbitArg.CorNum(HOR)  ' F.Brinker
    ' RpcOrbitLoc.Hdr.CorNum(VER) = OrbitArg.CorNum(VER)  ' F.Brinker

    ' Orbit Structure >> RPC Spez Orbcor Hdr
    RpcOrbitLoc.Hdr2.OrbcorVersion = ORBCOR_VERSION
    
    RpcOrbitLoc.Hdr2.QMeas(0) = OrbitArg.QMeas(0)
    RpcOrbitLoc.Hdr2.QMeas(1) = OrbitArg.QMeas(1)
    RpcOrbitLoc.Hdr2.OrbitEnergy = OrbitArg.Energy
    RpcOrbitLoc.Hdr2.IBunch = OrbitArg.IBunchE
    Call String2Bytes(RpcOrbitLoc.Hdr2.UserName(0), OrbitArg.UserName, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr2.MonitorMode(0), OrbitArg.MonitorMode, 16)
    Call String2Bytes(RpcOrbitLoc.Hdr2.OrbitName(0), OrbitArg.name, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr2.MachineFile(0), OrbitArg.MachineFile, 32)
    
    ' Orbit Correction Structure >> RPC Spez Orbcor Hdr
    If (IndexArg = 0) Then
        RpcOrbitLoc.Hdr2.Neff(0) = NRMSvsPhase% + 1
        RpcOrbitLoc.Hdr2.Neff(1) = 0
    Else
        RpcOrbitLoc.Hdr2.Neff(1) = NRMSvsPhase% + 1
        RpcOrbitLoc.Hdr2.Neff(0) = 0
    End If
    
    'first turn
    
    ' Orbit and Kicks >> RPC Arrays
    
    For j% = HORIZONTAL To VERTICAL
        For i% = 0 To OrbitArg.MonNum(j%) - 1
            RpcOrbitLoc.Orbit(i%, j%) = OrbitArg.Orbit(i%, j%)
            RpcOrbitLoc.MonFlags(i%, j%) = OrbitArg.MonFlags(i%, j%)
        Next i%
        For i% = 0 To OrbitArg.CorNum(j%) - 1
            RpcOrbitLoc.Kicks(i%, j%) = OrbitArg.Kicks(i%, j%)
            RpcOrbitLoc.Currents(i%, j%) = OrbitArg.Currents(i%, j%) ' F.Brinker
            RpcOrbitLoc.CorFlags(i%, j%) = OrbitArg.CorFlags(i%, j%)
        Next i%
    Next j%
    
    RpcOrbitLoc.Hdr2.KicksOrCurrents = Asc("N") ' Use currents
    RpcOrbitLoc.Hdr2.ReturnDifference = Asc("N") ' Use absolute (and not difference) values of currents and kicks
    
    ' ----------
    ' RPC Aufruf
    '-----------
    
    OpticRPCEqpF$ = "ORBCOR"
    OpticRPCProp$ = "FINDKICK"
    
    OpticRWFlag% = -Len(RpcOrbitLoc)
    RPCStart1 = Now
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RpcOrbitLoc, Len(RpcOrbitLoc), CF_STRUCT)
    RPCEnd1 = Now
    
    ' RPC Header >> Globals
    Call Bytes2String(OpticServerErrText, RpcOrbitLoc.Hdr.ErrorString(0), 32)
    
    ' rc auswerten
    If OpticRC% = 0 Then
        OpticReturnMsgShort$ = "Find Kick successfully calculated from server"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "Find Kick not calculated from server" & ErrorRight$
    End If
    Call ViewRpcRC(OrbitCorrectionArg.Machine, OrbitCorrectionArg.Year, "")
        
    ' RPC Header >> Orbit Structure
    Call Bytes2String(OrbitArg.Machine, RpcOrbitLoc.Hdr.Machine(0), 8)
    Call Bytes2String(OrbitArg.Year, RpcOrbitLoc.Hdr.Year(0), 4)
    OrbitArg.MonNum(HOR) = RpcOrbitLoc.Hdr.MonNum(HOR)
    OrbitArg.MonNum(VER) = RpcOrbitLoc.Hdr.MonNum(VER)
    OrbitArg.CorNum(HOR) = RpcOrbitLoc.Hdr.CorNum(HOR)
    OrbitArg.CorNum(VER) = RpcOrbitLoc.Hdr.CorNum(VER)
    Call Bytes2String(OrbitArg.Text1, RpcOrbitLoc.Hdr.Text1(0), 60)
    Call Bytes2String(OrbitArg.text2, RpcOrbitLoc.Hdr.text2(0), 60)
    Call Bytes2String(OrbitArg.DateTime, RpcOrbitLoc.Hdr.DateTime(0), 32)
    Call Bytes2String(OrbitArg.Optic, RpcOrbitLoc.Hdr.Optic(0), 16)
    Call Bytes2String(OrbitArg.OpticFlag, RpcOrbitLoc.Hdr.OpticFlag(0), 16)

    ' RPC Spez Orbcor Header >> Orbit Structure
    OrbitArg.QMeas(0) = RpcOrbitLoc.Hdr2.QMeas(0)
    OrbitArg.QMeas(1) = RpcOrbitLoc.Hdr2.QMeas(1)
    OrbitArg.Energy = RpcOrbitLoc.Hdr2.OrbitEnergy
    OrbitArg.IBunchE = RpcOrbitLoc.Hdr2.IBunch
    Call Bytes2String(OrbitArg.UserName, RpcOrbitLoc.Hdr2.UserName(0), 32)
    Call Bytes2String(OrbitArg.MonitorMode, RpcOrbitLoc.Hdr2.MonitorMode(0), 16)
    Call Bytes2String(OrbitArg.name, RpcOrbitLoc.Hdr2.OrbitName(0), 32)
    Call Bytes2String(OrbitArg.MachineFile, RpcOrbitLoc.Hdr2.MachineFile(0), 32)
    ' RPC Spez Orbcor Header >> OrbitCorrection Structure
    For j% = 0 To 7
        OrbitArg.PolVal8(j%) = RpcOrbitLoc.Hdr2.PolVal8(j%)
        Call Bytes2String(OrbitArg.PolStr8(j%), RpcOrbitLoc.Hdr2.PolStr8(j%, 0), 8)
        Call Bytes2String(OrbitArg.ParaText(j%), RpcOrbitLoc.Hdr2.ParaText(j%, 0), 8)
        OrbitArg.Parameter(j%) = RpcOrbitLoc.Hdr2.Parameter(j%)
    Next

    ' RPC Arrays >> Orbit and Kicks
    PhaseRmsArg = RpcOrbitLoc.PhaseRms

    RPCEnd1 = Now
End Sub
Public Sub RPC_OrbitCorrection(ByRef OrbitArg As OrbitType, ByRef OrbitCorrectionArg As OrbitCorrectionType, ByRef PropertyArg As String)
    Dim RpcOrbitLoc As RpcHdrsOrbcorType
    Dim i%, j%
    ' Control Information from Client >> RPC Hdr
    RpcOrbitLoc.Hdr.Version = MAIN_VERSION
    RpcOrbitLoc.Hdr.NGDebug = NGDebug
    RpcOrbitLoc.Hdr.HPDebug = HPDebug

    RpcOrbitLoc.Hdr.Arr_mon = MonDim + 1
    RpcOrbitLoc.Hdr.Arr_cor = CorDim + 1
    RpcOrbitLoc.Hdr.Arr_il = LatDim + 1
    RpcOrbitLoc.Hdr.Arr_jl = EleDim + 1

    RpcOrbitLoc.Hdr.Hdr_Size = Len(RpcOrbitLoc.Hdr)
    RpcOrbitLoc.Hdr.Spez_Hdr_Size = Len(RpcOrbitLoc.Hdr2)
    RpcOrbitLoc.Hdr.Arr_Size = Len(RpcOrbitLoc) - Len(RpcOrbitLoc.Hdr) - Len(RpcOrbitLoc.Hdr2)
           
    ' Machine / Year >> RPC Hdr
    Select Case PropertyArg
        Case "RORBIT":
            Call String2Bytes(RpcOrbitLoc.Hdr.Machine(0), OrbitCorrectionArg.Machine, 8)
            Call String2Bytes(RpcOrbitLoc.Hdr.Year(0), OrbitCorrectionArg.Year, 4)
        Case "RORBIT8":
            Call String2Bytes(RpcOrbitLoc.Hdr.Machine(0), OrbitCorrectionArg.Machine, 8)
            Call String2Bytes(RpcOrbitLoc.Hdr.Year(0), OrbitCorrectionArg.Year, 4)
        Case Else
            Call String2Bytes(RpcOrbitLoc.Hdr.Machine(0), OrbitArg.Machine, 8)
            Call String2Bytes(RpcOrbitLoc.Hdr.Year(0), OrbitArg.Year, 4)
    End Select
    
    ' Orbit Structure >> RPC Hdr
    Call String2Bytes(RpcOrbitLoc.Hdr.Text1(0), OrbitArg.Text1, 60)
    Call String2Bytes(RpcOrbitLoc.Hdr.text2(0), OrbitArg.text2, 60)
    Call String2Bytes(RpcOrbitLoc.Hdr.DateTime(0), OrbitArg.DateTime, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr.Optic(0), OrbitArg.Optic, 16)
    Call String2Bytes(RpcOrbitLoc.Hdr.OpticFlag(0), OrbitArg.OpticFlag, 16)
    ' RpcOrbitLoc.Hdr.MonNum(HOR) = OrbitArg.MonNum(HOR)  ' F.Brinker
    ' RpcOrbitLoc.Hdr.MonNum(VER) = OrbitArg.MonNum(VER)  ' F.Brinker
    ' RpcOrbitLoc.Hdr.CorNum(HOR) = OrbitArg.CorNum(HOR)  ' F.Brinker
    ' RpcOrbitLoc.Hdr.CorNum(VER) = OrbitArg.CorNum(VER)  ' F.Brinker

    ' Orbit Structure >> RPC Spez Orbcor Hdr

    RpcOrbitLoc.Hdr2.OrbcorVersion = ORBCOR_VERSION
    
    RpcOrbitLoc.Hdr2.QMeas(0) = OrbitArg.QMeas(0)
    RpcOrbitLoc.Hdr2.QMeas(1) = OrbitArg.QMeas(1)
    RpcOrbitLoc.Hdr2.OrbitEnergy = OrbitArg.Energy
    RpcOrbitLoc.Hdr2.IBunch = OrbitArg.IBunchE
    Call String2Bytes(RpcOrbitLoc.Hdr2.UserName(0), OrbitArg.UserName, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr2.MonitorMode(0), OrbitArg.MonitorMode, 16)
    Call String2Bytes(RpcOrbitLoc.Hdr2.OrbitName(0), OrbitArg.name, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr2.MachineFile(0), OrbitArg.MachineFile, 32)
    For j% = 0 To 7
        RpcOrbitLoc.Hdr2.PolVal8(j%) = OrbitArg.PolVal8(j%)
        Call String2Bytes(RpcOrbitLoc.Hdr2.PolStr8(j%, 0), OrbitArg.PolStr8(j%), 8)
        Call String2Bytes(RpcOrbitLoc.Hdr2.ParaText(j%, 0), OrbitArg.ParaText(j%), 8)
        RpcOrbitLoc.Hdr2.Parameter(j%) = OrbitArg.Parameter(j%)
    Next
        
    ' Orbit Correction Structure >> RPC Spez Orbcor Hdr
    For j% = HORIZONTAL To VERTICAL
        RpcOrbitLoc.Hdr2.Neff(j%) = OrbitCorrectionArg.Neff(j%)
        RpcOrbitLoc.Hdr2.CorNow(j%) = OrbitCorrectionArg.CorNow(j%)
        RpcOrbitLoc.Hdr2.CorNext(j%) = OrbitCorrectionArg.CorNext(j%)
        RpcOrbitLoc.Hdr2.MaxOrbits(j%) = OrbitCorrectionArg.MaxOrbits(j%)
        RpcOrbitLoc.Hdr2.MaxAblage(j%) = OrbitCorrectionArg.MaxAblage(j%)
    Next
   
    Call String2Bytes(RpcOrbitLoc.Hdr2.KMaxScaled, OrbitCorrectionArg.KMaxScaled, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.KMaxIgnore, OrbitCorrectionArg.KMaxIgnore, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.KicksOrCurrents, OrbitCorrectionArg.KicksOrCurrents, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.Overwrite, OrbitCorrectionArg.Overwrite, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.ReferenceOrbit(0), OrbitCorrectionArg.ReferenceOrbit, 32)
    RpcOrbitLoc.Hdr2.FitQuality = OrbitCorrectionArg.FitQuality
    
    For j% = 0 To 2
        Call String2Bytes(RpcOrbitLoc.Hdr2.Totsch(j%, 0), OrbitCorrectionArg.Totsch(j%), 8)
    Next
    
    RpcOrbitLoc.Hdr2.Pattern = OrbitCorrectionArg.Pattern
    
    ' Orbit and Kicks >> RPC Arrays
    
    RpcOrbitLoc.Hdr2.KicksOrCurrents = Asc("N") ' use currents
    RpcOrbitLoc.Hdr2.ReturnDifference = Asc("N") ' Use absolute (and not difference) values of currents and kicks
    
    For j% = HORIZONTAL To VERTICAL
        For i% = 0 To OrbitArg.MonNum(j%) - 1
            RpcOrbitLoc.Orbit(i%, j%) = OrbitArg.Orbit(i%, j%)
            RpcOrbitLoc.MonFlags(i%, j%) = OrbitArg.MonFlags(i%, j%)
        Next i%
        For i% = 0 To OrbitArg.CorNum(j%) - 1
            RpcOrbitLoc.Kicks(i%, j%) = OrbitArg.Kicks(i%, j%)
            RpcOrbitLoc.Currents(i%, j%) = OrbitArg.Currents(i%, j%) ' F.Brinker
            RpcOrbitLoc.CorFlags(i%, j%) = OrbitArg.CorFlags(i%, j%)
        Next i%
    Next j%
    
    ' ----------
    ' RPC Aufruf
    '-----------
    
    OpticRPCEqpF$ = "ORBCOR"
    OpticRPCProp$ = PropertyArg
    
    OpticRWFlag% = -Len(RpcOrbitLoc)
    RPCStart1 = Now
    OpticRC% = RPCEx(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RpcOrbitLoc, Len(RpcOrbitLoc), CF_STRUCT, 60000)
    RPCEnd1 = Now
    
    ' RPC Header >> Globals
    Call Bytes2String(OpticServerErrText, RpcOrbitLoc.Hdr.ErrorString(0), 32)
    
    ' rc auswerten
    If OpticRC% = 0 Then
        Select Case OpticRPCProp$
            Case "RORBIT":
                OpticReturnMsgShort$ = "orbit successfully loaded from server"
                OrbitArg.Loaded = True
            Case "RORBIT8":
                OpticReturnMsgShort$ = "orbit 3.00 successfully loaded from server"
                OrbitArg.Loaded = True
            Case "WORBIT":
                OpticReturnMsgShort$ = "orbit successfully saved on server"
            Case Else
                OpticReturnMsgShort$ = "orbit correction calculated by server"
        End Select
    Else
        Select Case OpticRPCProp$
            Case "RORBIT":
                OpticReturnMsgShort$ = ErrorLeft$ & "orbit NOT loaded from server" & ErrorRight$
            Case "RORBIT8":
                OpticReturnMsgShort$ = ErrorLeft$ & "orbit 300 NOT loaded from server" & ErrorRight$
            Case "WORBIT":
                OpticReturnMsgShort$ = ErrorLeft$ & "orbit NOT saved on server" & ErrorRight$
            Case Else
                OpticReturnMsgShort$ = ErrorLeft$ & "orbit correction NOT calculated by server" & ErrorRight$
        End Select
    End If
    Call ViewRpcRC(OrbitCorrectionArg.Machine, OrbitCorrectionArg.Year, "")
    
    ' RPC Header >> Orbit Structure

    Call Bytes2String(OrbitArg.Machine, RpcOrbitLoc.Hdr.Machine(0), 8)
    Call Bytes2String(OrbitArg.Year, RpcOrbitLoc.Hdr.Year(0), 4)
    OrbitArg.MonNum(HOR) = RpcOrbitLoc.Hdr.MonNum(HOR)
    OrbitArg.MonNum(VER) = RpcOrbitLoc.Hdr.MonNum(VER)
    OrbitArg.CorNum(HOR) = RpcOrbitLoc.Hdr.CorNum(HOR)
    OrbitArg.CorNum(VER) = RpcOrbitLoc.Hdr.CorNum(VER)
    Call Bytes2String(OrbitArg.Text1, RpcOrbitLoc.Hdr.Text1(0), 60)
    Call Bytes2String(OrbitArg.text2, RpcOrbitLoc.Hdr.text2(0), 60)
    Call Bytes2String(OrbitArg.DateTime, RpcOrbitLoc.Hdr.DateTime(0), 32)
    Call Bytes2String(OrbitArg.Optic, RpcOrbitLoc.Hdr.Optic(0), 16)
    Call Bytes2String(OrbitArg.OpticFlag, RpcOrbitLoc.Hdr.OpticFlag(0), 16)

    ' RPC Spez Orbcor Header >> Orbit Structure
    OrbitArg.QMeas(0) = RpcOrbitLoc.Hdr2.QMeas(0)
    OrbitArg.QMeas(1) = RpcOrbitLoc.Hdr2.QMeas(1)
    OrbitArg.Energy = RpcOrbitLoc.Hdr2.OrbitEnergy
    OrbitArg.IBunchE = RpcOrbitLoc.Hdr2.IBunch
    Call Bytes2String(OrbitArg.UserName, RpcOrbitLoc.Hdr2.UserName(0), 32)
    Call Bytes2String(OrbitArg.MonitorMode, RpcOrbitLoc.Hdr2.MonitorMode(0), 16)
    Call Bytes2String(OrbitArg.name, RpcOrbitLoc.Hdr2.OrbitName(0), 32)
    Call Bytes2String(OrbitArg.MachineFile, RpcOrbitLoc.Hdr2.MachineFile(0), 32)
    For j% = 0 To 7
        OrbitArg.PolVal8(j%) = RpcOrbitLoc.Hdr2.PolVal8(j%)
        Call Bytes2String(OrbitArg.PolStr8(j%), RpcOrbitLoc.Hdr2.PolStr8(j%, 0), 8)
        Call Bytes2String(OrbitArg.ParaText(j%), RpcOrbitLoc.Hdr2.ParaText(j%, 0), 8)
        OrbitArg.Parameter(j%) = RpcOrbitLoc.Hdr2.Parameter(j%)
    Next
        
    ' RPC Spez Orbcor Header >> OrbitCorrection Structure
    For j% = HORIZONTAL To VERTICAL
        OrbitCorrectionArg.Neff(j%) = RpcOrbitLoc.Hdr2.Neff(j%)
        OrbitCorrectionArg.CorNow(j%) = RpcOrbitLoc.Hdr2.CorNow(j%)
        OrbitCorrectionArg.CorNext(j%) = RpcOrbitLoc.Hdr2.CorNext(j%)
        OrbitCorrectionArg.MaxOrbits(j%) = RpcOrbitLoc.Hdr2.MaxOrbits(j%)
        OrbitCorrectionArg.MaxAblage(j%) = RpcOrbitLoc.Hdr2.MaxAblage(j%)
    Next
   
    Call Bytes2String(OrbitCorrectionArg.KMaxScaled, RpcOrbitLoc.Hdr2.KMaxScaled, 1)
    Call Bytes2String(OrbitCorrectionArg.KMaxIgnore, RpcOrbitLoc.Hdr2.KMaxIgnore, 1)
    Call Bytes2String(OrbitCorrectionArg.KicksOrCurrents, RpcOrbitLoc.Hdr2.KicksOrCurrents, 1)
    Call Bytes2String(OrbitCorrectionArg.Overwrite, RpcOrbitLoc.Hdr2.Overwrite, 1)
    Call Bytes2String(OrbitCorrectionArg.ReferenceOrbit, RpcOrbitLoc.Hdr2.ReferenceOrbit(0), 32)
    OrbitCorrectionArg.FitQuality = RpcOrbitLoc.Hdr2.FitQuality
    
    For j% = 0 To 2
        Call Bytes2String(OrbitCorrectionArg.Totsch(j%), RpcOrbitLoc.Hdr2.Totsch(j%, 0), 8)
    Next
    
    OrbitCorrectionArg.Pattern = RpcOrbitLoc.Hdr2.Pattern
    
    ' RPC Arrays >> Orbit and Kicks
    For j% = HORIZONTAL To VERTICAL
        For i% = 0 To RpcOrbitLoc.Hdr.MonNum(j%) - 1
            OrbitArg.Orbit(i%, j%) = RpcOrbitLoc.Orbit(i%, j%)
            OrbitArg.MonFlags(i%, j%) = RpcOrbitLoc.MonFlags(i%, j%)
        Next i%
        For i% = 0 To RpcOrbitLoc.Hdr.CorNum(j%) - 1
            OrbitArg.Kicks(i%, j%) = RpcOrbitLoc.Kicks(i%, j%)
            OrbitArg.Currents(i%, j%) = RpcOrbitLoc.Currents(i%, j%)  ' F.Brinker
            OrbitArg.CorFlags(i%, j%) = RpcOrbitLoc.CorFlags(i%, j%)
        Next i%
    Next j%
    
    Call RMS(OrbitArg)
    RPCEnd1 = Now
End Sub
Public Sub RPC_OrbitCorrection2(ByRef OrbitInArg As OrbitType, ByRef OrbitOutArg As OrbitType, ByRef OrbitCorrectionArg As OrbitCorrectionType, ByRef PropertyArg As String)
    Dim RpcOrbitLoc As RpcHdrsOrbcorType
    Dim i%, j%
    
    ' Unterschied zu RPC_OrbitCorrection ist ein zweiter Orbit als Argument
    ' in:  OrbitInArg
    ' out: OrbitOutArg
    
    ' Control Information from Client >> RPC Hdr
    RpcOrbitLoc.Hdr.Version = MAIN_VERSION
    RpcOrbitLoc.Hdr.NGDebug = NGDebug
    RpcOrbitLoc.Hdr.HPDebug = HPDebug

    RpcOrbitLoc.Hdr.Arr_mon = MonDim + 1
    RpcOrbitLoc.Hdr.Arr_cor = CorDim + 1
    RpcOrbitLoc.Hdr.Arr_il = LatDim + 1
    RpcOrbitLoc.Hdr.Arr_jl = EleDim + 1

    RpcOrbitLoc.Hdr.Hdr_Size = Len(RpcOrbitLoc.Hdr)
    RpcOrbitLoc.Hdr.Spez_Hdr_Size = Len(RpcOrbitLoc.Hdr2)
    RpcOrbitLoc.Hdr.Arr_Size = Len(RpcOrbitLoc) - Len(RpcOrbitLoc.Hdr) - Len(RpcOrbitLoc.Hdr2)
           
    ' Machine / Year >> RPC Hdr
    Call String2Bytes(RpcOrbitLoc.Hdr.Machine(0), OrbitCorrectionArg.Machine, 8)
    Call String2Bytes(RpcOrbitLoc.Hdr.Year(0), OrbitCorrectionArg.Year, 4)
    
    ' Orbit Structure >> RPC Hdr
    Call String2Bytes(RpcOrbitLoc.Hdr.Text1(0), OrbitInArg.Text1, 60)
    Call String2Bytes(RpcOrbitLoc.Hdr.text2(0), OrbitInArg.text2, 60)
    Call String2Bytes(RpcOrbitLoc.Hdr.DateTime(0), OrbitInArg.DateTime, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr.Optic(0), OrbitInArg.Optic, 16)
    Call String2Bytes(RpcOrbitLoc.Hdr.OpticFlag(0), OrbitInArg.OpticFlag, 16)
    'RpcOrbitLoc.Hdr.MonNum(HOR) = OrbitInArg.MonNum(HOR)  ' F.Brinker
    'RpcOrbitLoc.Hdr.MonNum(VER) = OrbitInArg.MonNum(VER)  ' F.Brinker
    'RpcOrbitLoc.Hdr.CorNum(HOR) = OrbitInArg.CorNum(HOR)  ' F.Brinker
    'RpcOrbitLoc.Hdr.CorNum(VER) = OrbitInArg.CorNum(VER)  ' F.Brinker

    ' Orbit Structure >> RPC Spez Orbcor Hdr
    RpcOrbitLoc.Hdr2.OrbcorVersion = ORBCOR_VERSION
    
    RpcOrbitLoc.Hdr2.QMeas(0) = OrbitInArg.QMeas(0)
    RpcOrbitLoc.Hdr2.QMeas(1) = OrbitInArg.QMeas(1)
    RpcOrbitLoc.Hdr2.OrbitEnergy = OrbitInArg.Energy
    RpcOrbitLoc.Hdr2.IBunch = OrbitInArg.IBunchE
    Call String2Bytes(RpcOrbitLoc.Hdr2.UserName(0), OrbitInArg.UserName, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr2.MonitorMode(0), OrbitInArg.MonitorMode, 16)
    Call String2Bytes(RpcOrbitLoc.Hdr2.OrbitName(0), OrbitInArg.name, 32)
    Call String2Bytes(RpcOrbitLoc.Hdr2.MachineFile(0), OrbitInArg.MachineFile, 32)
    For j% = 0 To 7
        RpcOrbitLoc.Hdr2.PolVal8(j%) = OrbitInArg.PolVal8(j%)
        Call String2Bytes(RpcOrbitLoc.Hdr2.PolStr8(j%, 0), OrbitInArg.PolStr8(j%), 8)
        Call String2Bytes(RpcOrbitLoc.Hdr2.ParaText(j%, 0), OrbitInArg.ParaText(j%), 8)
        RpcOrbitLoc.Hdr2.Parameter(j%) = OrbitInArg.Parameter(j%)
    Next
    
    ' Orbit Correction Structure >> RPC Spez Orbcor Hdr
    For j% = HORIZONTAL To VERTICAL
        RpcOrbitLoc.Hdr2.Neff(j%) = OrbitCorrectionArg.Neff(j%)
        RpcOrbitLoc.Hdr2.CorNow(j%) = OrbitCorrectionArg.CorNow(j%)
        RpcOrbitLoc.Hdr2.CorNext(j%) = OrbitCorrectionArg.CorNext(j%)
        RpcOrbitLoc.Hdr2.MaxOrbits(j%) = OrbitCorrectionArg.MaxOrbits(j%)
        RpcOrbitLoc.Hdr2.MaxAblage(j%) = OrbitCorrectionArg.MaxAblage(j%)
    Next
   
    Call String2Bytes(RpcOrbitLoc.Hdr2.KMaxScaled, OrbitCorrectionArg.KMaxScaled, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.KMaxIgnore, OrbitCorrectionArg.KMaxIgnore, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.KicksOrCurrents, OrbitCorrectionArg.KicksOrCurrents, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.Overwrite, OrbitCorrectionArg.Overwrite, 1)
    Call String2Bytes(RpcOrbitLoc.Hdr2.ReferenceOrbit(0), OrbitCorrectionArg.ReferenceOrbit, 32)
    RpcOrbitLoc.Hdr2.FitQuality = OrbitCorrectionArg.FitQuality
    
    For j% = 0 To 2
        Call String2Bytes(RpcOrbitLoc.Hdr2.Totsch(j%, 0), OrbitCorrectionArg.Totsch(j%), 8)
    Next
    
    RpcOrbitLoc.Hdr2.Pattern = OrbitCorrectionArg.Pattern
    
    
    RpcOrbitLoc.Hdr2.KicksOrCurrents = Asc("Y") ' Use currents
    RpcOrbitLoc.Hdr2.ReturnDifference = Asc("N") ' Use absolute (and not difference) values of currents and kicks

    ' Orbit and Kicks >> RPC Arrays
    For j% = HORIZONTAL To VERTICAL
        For i% = 0 To OrbitInArg.MonNum(j%) - 1
            RpcOrbitLoc.Orbit(i%, j%) = OrbitInArg.Orbit(i%, j%)
            RpcOrbitLoc.MonFlags(i%, j%) = OrbitInArg.MonFlags(i%, j%)
        Next i%
        
        For i% = 0 To OrbitInArg.CorNum(j%) - 1
            RpcOrbitLoc.Kicks(i%, j%) = OrbitInArg.Kicks(i%, j%)
            RpcOrbitLoc.Currents(i%, j%) = OrbitInArg.Currents(i%, j%)   ' F.Brinker
            RpcOrbitLoc.CorFlags(i%, j%) = OrbitInArg.CorFlags(i%, j%)
        Next i%
    Next j%
    
    ' ----------
    ' RPC Aufruf
    '-----------
    
    OpticRPCEqpF$ = "ORBCOR"
    OpticRPCProp$ = PropertyArg
    
    OpticRWFlag% = -Len(RpcOrbitLoc)
    RPCStart1 = Now
    OpticRC% = RPCEx(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RpcOrbitLoc, Len(RpcOrbitLoc), CF_STRUCT, 30000)
    RPCEnd1 = Now
    
    ' RPC Header >> Globals
    Call Bytes2String(OpticServerErrText, RpcOrbitLoc.Hdr.ErrorString(0), 32)
    
    ' rc auswerten
    If OpticRC% = 0 Then
        OpticReturnMsgShort$ = "orbit correction calculated by server"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "orbit correction NOT calculated by server" & ErrorRight$
    End If
    Call ViewRpcRC(OrbitCorrectionArg.Machine, OrbitCorrectionArg.Year, OrbitInArg.Optic)
    
    ' RPC Header >> OrbitOutArg Structure
    Call Bytes2String(OrbitOutArg.Machine, RpcOrbitLoc.Hdr.Machine(0), 8)
    Call Bytes2String(OrbitOutArg.Year, RpcOrbitLoc.Hdr.Year(0), 4)
    OrbitOutArg.MonNum(HOR) = RpcOrbitLoc.Hdr.MonNum(HOR)
    OrbitOutArg.MonNum(VER) = RpcOrbitLoc.Hdr.MonNum(VER)
    OrbitOutArg.CorNum(HOR) = RpcOrbitLoc.Hdr.CorNum(HOR)
    OrbitOutArg.CorNum(VER) = RpcOrbitLoc.Hdr.CorNum(VER)
    Call Bytes2String(OrbitOutArg.Text1, RpcOrbitLoc.Hdr.Text1(0), 60)
    Call Bytes2String(OrbitOutArg.text2, RpcOrbitLoc.Hdr.text2(0), 60)
    Call Bytes2String(OrbitOutArg.DateTime, RpcOrbitLoc.Hdr.DateTime(0), 32)
    Call Bytes2String(OrbitOutArg.Optic, RpcOrbitLoc.Hdr.Optic(0), 16)
    Call Bytes2String(OrbitOutArg.OpticFlag, RpcOrbitLoc.Hdr.OpticFlag(0), 16)

    ' RPC Spez Orbcor Header >> Orbit Structure
    OrbitOutArg.QMeas(0) = RpcOrbitLoc.Hdr2.QMeas(0)
    OrbitOutArg.QMeas(1) = RpcOrbitLoc.Hdr2.QMeas(1)
    OrbitOutArg.Energy = RpcOrbitLoc.Hdr2.OrbitEnergy
    OrbitOutArg.IBunchE = RpcOrbitLoc.Hdr2.IBunch
    Call Bytes2String(OrbitOutArg.UserName, RpcOrbitLoc.Hdr2.UserName(0), 32)
    Call Bytes2String(OrbitOutArg.MonitorMode, RpcOrbitLoc.Hdr2.MonitorMode(0), 16)
    Call Bytes2String(OrbitOutArg.name, RpcOrbitLoc.Hdr2.OrbitName(0), 32)
    Call Bytes2String(OrbitOutArg.MachineFile, RpcOrbitLoc.Hdr2.MachineFile(0), 32)
    For j% = 0 To 7
        OrbitOutArg.PolVal8(j%) = RpcOrbitLoc.Hdr2.PolVal8(j%)
        Call Bytes2String(OrbitOutArg.PolStr8(j%), RpcOrbitLoc.Hdr2.PolStr8(j%, 0), 8)
        Call Bytes2String(OrbitOutArg.ParaText(j%), RpcOrbitLoc.Hdr2.ParaText(j%, 0), 8)
        OrbitOutArg.Parameter(j%) = RpcOrbitLoc.Hdr2.Parameter(j%)
    Next
        
    ' RPC Spez Orbcor Header >> OrbitCorrection Structure
    For j% = HORIZONTAL To VERTICAL
        OrbitCorrectionArg.Neff(j%) = RpcOrbitLoc.Hdr2.Neff(j%)
        OrbitCorrectionArg.CorNow(j%) = RpcOrbitLoc.Hdr2.CorNow(j%)
        OrbitCorrectionArg.CorNext(j%) = RpcOrbitLoc.Hdr2.CorNext(j%)
        OrbitCorrectionArg.MaxOrbits(j%) = RpcOrbitLoc.Hdr2.MaxOrbits(j%)
        OrbitCorrectionArg.MaxAblage(j%) = RpcOrbitLoc.Hdr2.MaxAblage(j%)
    Next
   
    Call Bytes2String(OrbitCorrectionArg.KMaxScaled, RpcOrbitLoc.Hdr2.KMaxScaled, 1)
    Call Bytes2String(OrbitCorrectionArg.KMaxIgnore, RpcOrbitLoc.Hdr2.KMaxIgnore, 1)
    Call Bytes2String(OrbitCorrectionArg.KicksOrCurrents, RpcOrbitLoc.Hdr2.KicksOrCurrents, 1)
    Call Bytes2String(OrbitCorrectionArg.Overwrite, RpcOrbitLoc.Hdr2.Overwrite, 1)
    Call Bytes2String(OrbitCorrectionArg.ReferenceOrbit, RpcOrbitLoc.Hdr2.ReferenceOrbit(0), 32)
    OrbitCorrectionArg.FitQuality = RpcOrbitLoc.Hdr2.FitQuality
    
    For j% = 0 To 2
        Call Bytes2String(OrbitCorrectionArg.Totsch(j%), RpcOrbitLoc.Hdr2.Totsch(j%, 0), 8)
    Next
    
    OrbitCorrectionArg.Pattern = RpcOrbitLoc.Hdr2.Pattern
    
    ' RPC Arrays >> Orbit and Kicks
    For j% = HORIZONTAL To VERTICAL
        For i% = 0 To RpcOrbitLoc.Hdr.MonNum(j%) - 1
            OrbitOutArg.Orbit(i%, j%) = RpcOrbitLoc.Orbit(i%, j%)
            OrbitOutArg.MonFlags(i%, j%) = RpcOrbitLoc.MonFlags(i%, j%)
        Next i%
        For i% = 0 To RpcOrbitLoc.Hdr.CorNum(j%) - 1
            OrbitOutArg.Kicks(i%, j%) = RpcOrbitLoc.Kicks(i%, j%)
            OrbitOutArg.Currents(i%, j%) = RpcOrbitLoc.Currents(i%, j%)  ' F.Brinker
            OrbitOutArg.CorFlags(i%, j%) = RpcOrbitLoc.CorFlags(i%, j%)
        Next i%
    Next j%
        
    OrbitOutArg.Loaded = True
    Call RMS(OrbitOutArg)

    RPCEnd1 = Now
End Sub
Public Sub RPC_OrbitList(ByRef YearArg As String, ByRef MachineArg As String, ByRef OrbitListArg As OrbitListType)
    Dim RpcOrbitListLoc As RpcHdrOrbListType
    Dim irpc, i2 As Integer
    
    ' Control Information from Client >> RPC Hdr
    RpcOrbitListLoc.Hdr.Version = MAIN_VERSION
    RpcOrbitListLoc.Hdr.NGDebug = NGDebug
    RpcOrbitListLoc.Hdr.HPDebug = HPDebug

    RpcOrbitListLoc.Hdr.Arr_mon = MonDim + 1
    RpcOrbitListLoc.Hdr.Arr_cor = CorDim + 1
    RpcOrbitListLoc.Hdr.Arr_il = LatDim + 1
    RpcOrbitListLoc.Hdr.Arr_jl = EleDim + 1

    RpcOrbitListLoc.Hdr.Hdr_Size = Len(RpcOrbitListLoc.Hdr)
    RpcOrbitListLoc.Hdr.Spez_Hdr_Size = 0
    RpcOrbitListLoc.Hdr.Arr_Size = Len(RpcOrbitListLoc) - Len(RpcOrbitListLoc.Hdr)
    
    Call String2Bytes(RpcOrbitListLoc.Hdr.Machine(0), MachineArg, 8)
    Call String2Bytes(RpcOrbitListLoc.Hdr.Year(0), YearArg, 4)

    ' -----------------------------
    ' Filter fr Orbit Liste setzen
    '------------------------------
    If Not OrbitListArg.Filter Then
        ' MsgBox "Filter disabled"
        OrbitListArg.OrbitMask = " "
        OrbitListArg.DateMask = " "
        OrbitListArg.OpticMask = " "
    End If
    
    ' ----------------------------------------
    ' RPC Aufrufe, bis lokale Orbit Liste voll
    '-----------------------------------------
    
    OpticRPCEqpF$ = "ORBCOR"
    OpticRPCProp$ = OrbitListProperty
    
    RPCStart2 = Now
    irpc = 0
    OrbitListArg.OrbNum = 0
    RpcOrbitListLoc.Hdr.Counter = 0 ' # of transfered orbits
    RpcOrbitListLoc.Hdr.SpezNum = 0 ' # orbits found in masks
    Do
        irpc = irpc + 1
        ' Suchmaske im ersten Orbit versteckt:
        Call String2Bytes(RpcOrbitListLoc.List(0).OrbName(0), OrbitListArg.OrbitMask, 32)
        Call String2Bytes(RpcOrbitListLoc.List(0).OrbDatum(0), OrbitListArg.DateMask, 32)
        Call String2Bytes(RpcOrbitListLoc.List(0).OrbOptic(0), OrbitListArg.OpticMask, 16)
        ' MsgBox "Orbit Mask: '" & OrbitListArg.OrbitMask & "'"
        OpticRWFlag% = -Len(RpcOrbitListLoc)
        RPCStart1 = Now
        OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RpcOrbitListLoc, Len(RpcOrbitListLoc), CF_STRUCT)
        RPCEnd1 = Now
        Call Bytes2String(OpticServerErrText, RpcOrbitListLoc.Hdr.ErrorString(0), 32)
        If OpticRC% = 0 Then
            OrbitListArg.OrbNum = OrbitListArg.OrbNum + RpcOrbitListLoc.Hdr.Counter
            If RpcOrbitListLoc.Hdr.SpezNum <> OrbitListArg.OrbNum Then
                OpticReturnMsgShort$ = "loading orbit list (" & Format(OrbitListArg.OrbNum) & "/" & Format(RpcOrbitListLoc.Hdr.SpezNum) & ")"
            End If
            ' Keine Orbits mehr laden, wenn lokale Orbitlist berzulaufen droht:
            If OrbitListArg.OrbNum <= MaxOrbits + 1 Then
                For i2% = 0 To RpcOrbitListLoc.Hdr.Counter - 1
                    Call Bytes2String(OrbitListArg.OrbName((irpc - 1) * (MaxOrbitsRPC + 1) + i2%), RpcOrbitListLoc.List(i2%).OrbName(0), 32)
                    Call Bytes2String(OrbitListArg.OrbDatum((irpc - 1) * (MaxOrbitsRPC + 1) + i2%), RpcOrbitListLoc.List(i2%).OrbDatum(0), 32)
                    Call Bytes2String(OrbitListArg.OrbOptic((irpc - 1) * (MaxOrbitsRPC + 1) + i2%), RpcOrbitListLoc.List(i2%).OrbOptic(0), 16)
                Next i2%
            End If
        Else
            OpticReturnMsgShort$ = ErrorLeft$ & "orbit list NOT loaded" & ErrorRight$
        End If
        Call ViewRpcRC(MachineArg, YearArg, "")
        ' Offset setzen
        RpcOrbitListLoc.Hdr.Index = OrbitListArg.OrbNum
    Loop Until RpcOrbitListLoc.Hdr.Counter < MaxOrbitsRPC + 1 Or OrbitListArg.OrbNum >= MaxOrbits + 1
    
    If OrbitListArg.OrbNum = 0 Then
        OpticReturnMsgShort$ = ErrorLeft$ & "NO orbit found in orbit list" & ErrorRight$
    Else
        If OrbitListArg.OrbNum = 1 Then
            OpticReturnMsgShort$ = "1 orbit found in orbit list"
        Else
            If RpcOrbitListLoc.Hdr.SpezNum > MaxOrbits + 1 Then
                OpticReturnMsgShort$ = ErrorLeft$ & Format(RpcOrbitListLoc.Hdr.SpezNum) & " orbits found in orbit list" & " orbit list truncated to " & Format(OrbitListArg.OrbNum) & " orbits" & ErrorRight$
            Else
                OpticReturnMsgShort$ = Format(OrbitListArg.OrbNum) & " orbits found in orbit list"
            End If
        End If
    End If
    Call ViewRpcRC(MachineArg, YearArg, "")
    RPCEnd2 = Now
End Sub

Public Sub RMS(OrbitArg As OrbitType)
    
    Dim iMonOK(1) As Integer
    Dim iCorOK(1) As Integer
    Dim i%, j%
    
    For j% = HORIZONTAL To VERTICAL
        iMonOK(j%) = 0
        iCorOK(j%) = 0
        OrbitArg.OrbRMS(j%) = 0
        OrbitArg.CorRMS(j%) = 0
        OrbitArg.OrbMean(j%) = 0
        OrbitArg.CorMean(j%) = 0
        OrbitArg.OrbMinMax(j%) = 0
        OrbitArg.CorMinMax(j%) = 0
        
        For i% = 0 To OrbitArg.MonNum(j%) - 1
            If OrbitArg.MonFlags(i%, j%) = 0 Then
                iMonOK(j%) = iMonOK(j%) + 1
                OrbitArg.OrbRMS(j%) = OrbitArg.OrbRMS(j%) + OrbitArg.Orbit(i%, j%) * OrbitArg.Orbit(i%, j%)
                OrbitArg.OrbMean(j%) = OrbitArg.OrbMean(j%) + OrbitArg.Orbit(i%, j%)
                If Abs(OrbitArg.Orbit(i%, j%)) > Abs(OrbitArg.OrbMinMax(j%)) Then _
                    OrbitArg.OrbMinMax(j%) = OrbitArg.Orbit(i%, j%)
            End If
        Next i%
        
        If iMonOK(j%) = 0 Then
            OrbitArg.OrbRMS(j%) = 0
            OrbitArg.OrbMean(j%) = 0
        Else
            OrbitArg.OrbRMS(j%) = Sqr(OrbitArg.OrbRMS(j%) / iMonOK(j%))
            OrbitArg.OrbMean(j%) = OrbitArg.OrbMean(j%) / iMonOK(j%)
        End If
        
        For i% = 0 To OrbitArg.CorNum(j%) - 1
            If OrbitArg.CorFlags(i%, j%) = 0 Then
                iCorOK(j%) = iCorOK(j%) + 1
                OrbitArg.CorRMS(j%) = OrbitArg.CorRMS(j%) + OrbitArg.Kicks(i%, j%) * OrbitArg.Kicks(i%, j%)
                OrbitArg.CorMean(j%) = OrbitArg.CorMean(j%) + OrbitArg.Kicks(i%, j%)
                If Abs(OrbitArg.Kicks(i%, j%)) > Abs(OrbitArg.CorMinMax(j%)) Then _
                    OrbitArg.CorMinMax(j%) = OrbitArg.Kicks(i%, j%)
            End If
        Next i%
        
        If iCorOK(j%) = 0 Then
            OrbitArg.CorRMS(j%) = 0
            OrbitArg.CorMean(j%) = 0
        Else
            OrbitArg.CorRMS(j%) = Sqr(OrbitArg.CorRMS(j%) / iCorOK(j%))
            OrbitArg.CorMean(j%) = OrbitArg.CorMean(j%) / iCorOK(j%)
        End If
    Next j%
End Sub
Public Sub LoadOpticForOrbit(OrbitArg As OrbitType)

    Dim OpticListLoc As OpticListType
    Dim OpticHeaderLoc As OpticHeaderType
    Dim MonLoc(MonDim%, 1) As MonitorType
    Dim CorLoc(CorDim%, 1) As CorrectorType
    Dim i%, j%, iOptic%
    
    If Not OrbitArg.Loaded Then Exit Sub
    
    ' Opticliste laden
    OpticListLoc.Machine = OrbitArg.Machine
    OpticListLoc.Year = OrbitArg.Year
    Call RPC_OpticList(OpticListLoc)
    If OpticRC% <> 0 Then Exit Sub
    
    ' Optik suchen
    OrbitArg.OpticFound = False
    OrbitArg.OpticLoaded = False
    iOptic = 0
    For i% = 0 To OpticListLoc.NumOptics
        If RTrim(OrbitArg.Optic) = RTrim(OpticListLoc.Optic(i%)) Then
            iOptic = i%
            OrbitArg.OpticFound = True
            Exit For
        End If
    Next i%
    
    OpticHeaderLoc.Machine = OrbitArg.Machine
    OpticHeaderLoc.Year = OrbitArg.Year
    OpticHeaderLoc.name = OpticListLoc.Optic(iOptic)
    
    ' Optik fr Orbit laden, zur Not 1. Optik aus der Liste
    Call RPC_OpticHeader(OpticHeaderLoc)
    If OpticRC% <> 0 Then Exit Sub
    Call RPC_OpticCMStruct(OpticHeaderLoc, MonLoc, CorLoc)
    If OpticRC% <> 0 Then Exit Sub
    
    ' Optik Info mit Orbit Info vergleichen
    For j% = HORIZONTAL To VERTICAL
        If OrbitArg.MonNum(j%) <> OpticHeaderLoc.MonNum(j%) Or _
           OrbitArg.CorNum(j%) <> OpticHeaderLoc.CorNum(j%) Then
           OpticRC% = 777
           Exit Sub
        End If
    Next j%
    
    ' Optik Info >> Orbit abspeichern
    
    For j% = HORIZONTAL To VERTICAL
        OrbitArg.MonNum(j%) = OpticHeaderLoc.MonNum(j%)
        OrbitArg.CorNum(j%) = OpticHeaderLoc.CorNum(j%)
        OrbitArg.QTheo(j%) = OpticHeaderLoc.QTheory(j%)
        ' OrbitArg.QMeas(j) natrlich nicht
        OrbitArg.Circumference = OpticHeaderLoc.Circumference
        For i% = 0 To OrbitArg.MonNum(j%)
            OrbitArg.MonPhi(i%, j%) = MonLoc(i%, j%).Phi
            OrbitArg.monname(i%, j%) = MonLoc(i%, j%).name
        Next i%
        For i% = 0 To OrbitArg.CorNum(j%)
            OrbitArg.CorPhi(i%, j%) = CorLoc(i%, j%).Phi
            OrbitArg.CorName(i%, j%) = CorLoc(i%, j%).name
        Next i%
    Next j%
    
    OrbitArg.OpticLoaded = True
End Sub
Public Sub FillOpticHeader(RpcHeaderArg As RpcHdrType, OpticHeaderArg As OpticHeaderType)
    
    Call Bytes2String(OpticServerErrText, RpcHeaderArg.ErrorString(0), 32)
    
    Call Bytes2String(OpticHeaderArg.Machine, RpcHeaderArg.Machine(0), 8)
    Call Bytes2String(OpticHeaderArg.Year, RpcHeaderArg.Year(0), 4)
    Call Bytes2String(OpticHeaderArg.name, RpcHeaderArg.Optic(0), 16)
    Call Bytes2String(OpticHeaderArg.Flag, RpcHeaderArg.OpticFlag(0), 16)
    Call Bytes2String(OpticHeaderArg.MopsText1, RpcHeaderArg.Text1(0), 60)
    Call Bytes2String(OpticHeaderArg.MopsText2, RpcHeaderArg.text2(0), 60)
    Call Bytes2String(OpticHeaderArg.DateTime, RpcHeaderArg.DateTime(0), 32)
    Call Bytes2String(OpticHeaderArg.filename, RpcHeaderArg.filename(0), 80)
    
    OpticHeaderArg.MonNum(0) = RpcHeaderArg.MonNum(0)
    OpticHeaderArg.MonNum(1) = RpcHeaderArg.MonNum(1)
    OpticHeaderArg.CorNum(0) = RpcHeaderArg.CorNum(0)
    OpticHeaderArg.CorNum(1) = RpcHeaderArg.CorNum(1)
    OpticHeaderArg.LatNum = RpcHeaderArg.LatNum
    OpticHeaderArg.EleNum = RpcHeaderArg.EleNum
    
    OpticHeaderArg.QTheory(0) = RpcHeaderArg.QTheory(0)
    OpticHeaderArg.QTheory(1) = RpcHeaderArg.QTheory(1)
    OpticHeaderArg.MomComp = RpcHeaderArg.MomComp
    OpticHeaderArg.Circumference = RpcHeaderArg.Circumference

End Sub
Public Sub FillRpcHeader(OpticHeaderArg As OpticHeaderType, RpcHeaderArg As RpcHdrType, ArrSizeArg As Integer, SpezHeaderSizeArg As Integer)
    
    ' Array Dimensionen
    
    RpcHeaderArg.Arr_mon = MonDim + 1
    RpcHeaderArg.Arr_cor = CorDim + 1
    RpcHeaderArg.Arr_il = LatDim + 1
    RpcHeaderArg.Arr_jl = EleDim + 1
    
    RpcHeaderArg.Hdr_Size = Len(RpcHeaderArg)
    RpcHeaderArg.Spez_Hdr_Size = SpezHeaderSizeArg
    RpcHeaderArg.Arr_Size = ArrSizeArg
    
    ' Information aus globalen Variablen
    Call String2Bytes(RpcHeaderArg.ErrorString(0), OpticServerErrText, 32)
    RpcHeaderArg.NGDebug = NGDebug
    RpcHeaderArg.HPDebug = HPDebug
    RpcHeaderArg.Version = MAIN_VERSION
    
    ' Information aus OpticHeader
    Call String2Bytes(RpcHeaderArg.Machine(0), OpticHeaderArg.Machine, 8)
    Call String2Bytes(RpcHeaderArg.Year(0), OpticHeaderArg.Year, 4)
    Call String2Bytes(RpcHeaderArg.Text1(0), OpticHeaderArg.MopsText1, 60)
    Call String2Bytes(RpcHeaderArg.text2(0), OpticHeaderArg.MopsText2, 60)
    Call String2Bytes(RpcHeaderArg.DateTime(0), OpticHeaderArg.DateTime, 32)
    Call String2Bytes(RpcHeaderArg.filename(0), OpticHeaderArg.filename, 80)
    Call String2Bytes(RpcHeaderArg.Optic(0), OpticHeaderArg.name, 16)
    Call String2Bytes(RpcHeaderArg.OpticFlag(0), OpticHeaderArg.Flag, 16)
    
    RpcHeaderArg.LatNum = OpticHeaderArg.LatNum
    RpcHeaderArg.EleNum = OpticHeaderArg.EleNum
    RpcHeaderArg.MonNum(0) = OpticHeaderArg.MonNum(0)
    RpcHeaderArg.MonNum(1) = OpticHeaderArg.MonNum(1)
    RpcHeaderArg.CorNum(0) = OpticHeaderArg.CorNum(0)
    RpcHeaderArg.CorNum(1) = OpticHeaderArg.CorNum(1)
    
    RpcHeaderArg.QTheory(0) = OpticHeaderArg.QTheory(0)
    RpcHeaderArg.QTheory(1) = OpticHeaderArg.QTheory(1)
    RpcHeaderArg.MomComp = OpticHeaderArg.MomComp
    RpcHeaderArg.Circumference = OpticHeaderArg.Circumference
    
    ' RpcHeaderArg.index = OpticHeaderArg.index
    ' RpcHeaderArg.SpezNum = OpticHeaderArg.SpezNum
    ' RpcHeaderArg.Counter = OpticHeaderArg.Counter

End Sub
Public Sub RPC_OpticHeader(OpticHeaderArg As OpticHeaderType)
    Dim RpcHeaderLoc As RpcHdrType
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = "HEADER"
    Call FillRpcHeader(OpticHeaderArg, RpcHeaderLoc, Len(OpticHeaderArg), 0)
    OpticRWFlag% = -Len(RpcHeaderLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RpcHeaderLoc, Len(RpcHeaderLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RpcHeaderLoc, OpticHeaderArg)
        OpticReturnMsgShort$ = "optic header loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "optic header NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticElementList(OpticHeaderArg As OpticHeaderType, EleArg() As ElementType)
    Dim RPCVarLoc As RpcHdrElementListType
    Dim i%
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = "ELEMENTLIST"
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, Len(RPCVarLoc) - Len(RPCVarLoc.Hdr), 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        For i% = 0 To OpticHeaderArg.EleNum% - 1
            Call Bytes2String(EleArg(i%).TypeName, RPCVarLoc.List(i%).TypeName(0), 8)
            EleArg(i%).Strength = RPCVarLoc.List(i%).Strength
            EleArg(i%).Length = RPCVarLoc.List(i%).Length
            EleArg(i%).PetType = RPCVarLoc.List(i%).PetType
            EleArg(i%).Angle = RPCVarLoc.List(i%).Angle
            EleArg(i%).HX = RPCVarLoc.List(i%).HX
            EleArg(i%).HZ = RPCVarLoc.List(i%).HZ
        Next i
        OpticReturnMsgShort$ = "element list loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "element list NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticCMStruct(OpticHeaderArg As OpticHeaderType, MonArg() As MonitorType, CorArg() As CorrectorType)
    Dim RPCVarLoc As RpcHdrCMStructType
    Dim i%, j%
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = "CMSTRUCT"
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, Len(RPCVarLoc) - Len(RPCVarLoc.Hdr), 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        For j% = HORIZONTAL To VERTICAL
            For i% = 0 To OpticHeaderArg.MonNum(j%) - 1
                Call Bytes2String(MonArg(i%, j%).name, RPCVarLoc.Mon(i%, j%).CMName(0), 8)
                MonArg(i%, j%).Beta = RPCVarLoc.Mon(i%, j%).Beta
                MonArg(i%, j%).Disp = RPCVarLoc.Mon(i%, j%).Disp
                MonArg(i%, j%).Phi = RPCVarLoc.Mon(i%, j%).Phi
            Next i%
            For i% = 0 To OpticHeaderArg.CorNum(j%) - 1
                Call Bytes2String(CorArg(i%, j%).name, RPCVarLoc.Cor(i%, j%).CMName(0), 8)
                CorArg(i%, j%).Beta = RPCVarLoc.Cor(i%, j%).Beta
                CorArg(i%, j%).Disp = RPCVarLoc.Cor(i%, j%).Disp
                CorArg(i%, j%).Phi = RPCVarLoc.Cor(i%, j%).Phi
                CorArg(i%, j%).KMax = RPCVarLoc.Cor(i%, j%).KMax
            Next i%
        Next j%
        OpticReturnMsgShort$ = "monitor and corrector optic arrays loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "monitor and corrector optic arrays NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticRCMops( _
    OpticHeaderArg As OpticHeaderType, _
    MonBetaArg() As Single, _
    MonDispArg() As Single, _
    MonPhiArg() As Single, _
    MonNameArg() As String, _
    CorBetaArg() As Single, _
    CorDispArg() As Single, _
    CorPhiArg() As Single, _
    CorNameArg() As String, _
    CorKmaxArg() As Single)
    
    Dim RPCVarLoc As RpcHdrRcmops
    Dim i%, j%
    
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = "RCMOPS"
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, Len(RPCVarLoc) - Len(RPCVarLoc.Hdr), 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        For j% = HORIZONTAL To VERTICAL
            For i% = 0 To OpticHeaderArg.MonNum(j%) - 1
                Call Bytes2String(MonNameArg(i%, j%), RPCVarLoc.monname(0, i%, j%), 8)
                MonBetaArg(i%, j%) = RPCVarLoc.MonBeta(i%, j%)
                MonDispArg(i%, j%) = RPCVarLoc.MonDisp(i%, j%)
                MonPhiArg(i%, j%) = RPCVarLoc.MonPhi(i%, j%)
            Next i%
            For i% = 0 To OpticHeaderArg.CorNum(j%) - 1
                Call Bytes2String(CorNameArg(i%, j%), RPCVarLoc.CorName(0, i%, j%), 8)
                CorBetaArg(i%, j%) = RPCVarLoc.CorBeta(i%, j%)
                CorDispArg(i%, j%) = RPCVarLoc.CorDisp(i%, j%)
                CorPhiArg(i%, j%) = RPCVarLoc.CorPhi(i%, j%)
                CorKmaxArg(i%, j%) = RPCVarLoc.CorKmax(i%, j%)
            Next i%
        Next j%
        OpticReturnMsgShort$ = "monitor and corrector optic arrays loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "monitor and corrector optic arrays NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticLatticeElement(OpticHeaderArg As OpticHeaderType, LatNArg As LatticeElementType)
    Dim RPCVarLoc As RpcHdrLatticeElementType
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = "LATTICE"
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, Len(RPCVarLoc) - Len(RPCVarLoc.Hdr), 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        Call Bytes2String(LatNArg.Position, RPCVarLoc.Position(0), 8)
        LatNArg.Beta(0) = RPCVarLoc.Beta(0)
        LatNArg.Beta(1) = RPCVarLoc.Beta(1)
        LatNArg.Alpha(0) = RPCVarLoc.Alpha(0)
        LatNArg.Alpha(1) = RPCVarLoc.Alpha(1)
        LatNArg.Phi(0) = RPCVarLoc.Phi(0)
        LatNArg.Phi(1) = RPCVarLoc.Phi(1)
        LatNArg.Disp(0) = RPCVarLoc.Disp(0)
        LatNArg.Disp(1) = RPCVarLoc.Disp(1)
        LatNArg.DispP(0) = RPCVarLoc.DispP(0)
        LatNArg.DispP(1) = RPCVarLoc.DispP(1)
        LatNArg.Pointer = RPCVarLoc.Pointer
        OpticReturnMsgShort$ = "optic for single element loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "optic for single element NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticLatticeSingle(ByVal PropertyArg As String, ByVal PlaneArg As Integer, OpticHeaderArg As OpticHeaderType, ByRef DataArg() As Single)
    Dim RPCVarLoc As RpcHdrLatticeSingle
    Dim AnySingle As Single
    Dim i%
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = PropertyArg
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, (LatDim% + 1) * Len(AnySingle), 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag$, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        For i% = 0 To OpticHeaderArg.LatNum% - 1
            DataArg(i%, PlaneArg%) = RPCVarLoc.sval(i%)
        Next
        OpticReturnMsgShort$ = "optic data array (single) loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "optic data array (single) NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticLatticeDouble(ByVal PropertyArg As String, OpticHeaderArg As OpticHeaderType, ByRef DataArg() As Double)
    Dim RPCVarLoc As RpcHdrLatticeDouble
    Dim AnyDouble As Double
    Dim i%
    
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = PropertyArg
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, (LatDim% + 1) * Len(AnyDouble), 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        For i% = 0 To OpticHeaderArg.LatNum% - 1
            DataArg(i%) = RPCVarLoc.dval(i%)
        Next
        OpticReturnMsgShort$ = "optic data array (double) loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "optic data array (double) NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticLatticeInteger(ByVal PropertyArg As String, OpticHeaderArg As OpticHeaderType, ByRef DataArg() As Integer)
    Dim RPCVarLoc As RpcHdrLatticeInteger
    Dim AnyInteger As Integer
    Dim i%
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = PropertyArg
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, (LatDim% + 1) * Len(AnyInteger), 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        For i% = 0 To OpticHeaderArg.LatNum% - 1
            DataArg(i%) = RPCVarLoc.ival(i%)
        Next
        OpticReturnMsgShort$ = "optic data array (integer) loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "optic data array (integer) NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Sub RPC_OpticLattice8Bytes(ByVal PropertyArg As String, OpticHeaderArg As OpticHeaderType, ByRef DataArg() As String * 8)
    Dim RPCVarLoc As RpcHdrLattice8Bytes
    Dim i%
    RPCStart1 = Now
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = PropertyArg
    Call FillRpcHeader(OpticHeaderArg, RPCVarLoc.Hdr, (LatDim% + 1) * 8, 0)
    OpticRWFlag% = -Len(RPCVarLoc)
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag, 1, OpticRPCProp$, OpticRWFlag%, RPCVarLoc, Len(RPCVarLoc), CF_STRUCT)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        Call FillOpticHeader(RPCVarLoc.Hdr, OpticHeaderArg)
        For i% = 0 To OpticHeaderArg.LatNum% - 1
            Call Bytes2String(DataArg(i%), RPCVarLoc.B8(0, i%), 8)
        Next
        OpticReturnMsgShort$ = "optic data array (char*8) loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "optic data array (char*8) NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticHeaderArg.Machine, OpticHeaderArg.Year, OpticHeaderArg.name)
End Sub
Public Function f77single(ByVal SArg As Single, SpaltenBreiteArg As Byte, VBformatArg As String) As String
    Dim OK As Boolean
    Dim str$, laenge%, i%
    OK = True
    f77single = ""
    str$ = Format(SArg, VBformatArg)
    laenge% = Len(str)
    If laenge% > SpaltenBreiteArg Then OK = False
    If laenge% < 1 Then OK = False
    If OK Then
        f77single = Space(SpaltenBreiteArg - laenge%) + str$
    Else
        For i% = 1 To SpaltenBreiteArg
            f77single = f77single + "#"
        Next
    End If
End Function
Public Function f77double(ByVal DArg As Double, SpaltenBreiteArg As Byte, VBformatArg As String) As String
    Dim OK As Boolean
    Dim str$, laenge%, i%
    OK = True
    f77double = ""
    str$ = Format(DArg, VBformatArg)
    laenge = Len(str)
    If laenge% > SpaltenBreiteArg Then OK = False
    If laenge% < 1 Then OK = False
    If OK Then
        f77double = Space(SpaltenBreiteArg - laenge%) + str$
    Else
        For i% = 1 To SpaltenBreiteArg
            f77double = f77double + "#"
        Next
    End If
End Function
Public Sub RPC_OpticList(OpticListArg As OpticListType)
    Dim RpcOpticListLoc As RpcHdrOpticListType
    Dim i%
    Call String2Bytes(RpcOpticListLoc.Hdr.Machine(0), OpticListArg.Machine, 8)
    Call String2Bytes(RpcOpticListLoc.Hdr.Year(0), OpticListArg.Year, 4)
    RpcOpticListLoc.Hdr.Hdr_Size = Len(RpcOpticListLoc.Hdr)
    RpcOpticListLoc.Hdr.Arr_Size = Len(RpcOpticListLoc) - Len(RpcOpticListLoc.Hdr)
    RpcOpticListLoc.Hdr.Spez_Hdr_Size = 0
    RpcOpticListLoc.Hdr.NGDebug = NGDebug
    RpcOpticListLoc.Hdr.HPDebug = HPDebug
    RpcOpticListLoc.Hdr.Version = MAIN_VERSION
    OpticRPCEqpF$ = "OPTICS"
    OpticRPCProp$ = "OPTICLIST"
    OpticRWFlag% = -Len(RpcOpticListLoc)
    RPCStart1 = Now
    OpticRC% = RPC(OpticRPCEqpF$ + OpticServerTag$, 1, OpticRPCProp, OpticRWFlag%, RpcOpticListLoc, Len(RpcOpticListLoc), CF_STRUCT)
    Call Bytes2String(OpticServerErrText, RpcOpticListLoc.Hdr.ErrorString(0), 32)
    RPCEnd1 = Now
    If OpticRC% = 0 Then
        OpticListArg.NumOptics = RpcOpticListLoc.Hdr.OpticNum
        For i% = 0 To OpticListArg.NumOptics - 1
            Call Bytes2String(OpticListArg.Optic(i%), RpcOpticListLoc.Optics(i%).OpticName(0), 16)
            Call Bytes2String(OpticListArg.Description1(i%), RpcOpticListLoc.Optics(i%).Text1(0), 60)
            Call Bytes2String(OpticListArg.Description2(i%), RpcOpticListLoc.Optics(i%).text2(0), 60)
        Next
        OpticReturnMsgShort$ = "optic list loaded"
    Else
        OpticReturnMsgShort$ = ErrorLeft$ & "optic list NOT loaded" & ErrorRight$
    End If
    Call ViewRpcRC(OpticListArg.Machine, OpticListArg.Year, " ")
End Sub
Public Sub RPC_CompleteOptic( _
    OpticHeaderArg As OpticHeaderType, _
    PosNameArg() As String * 8, _
    TypeNameArg() As String * 8, _
    DriftArg() As Double, _
    MiddleArg() As Double, _
    PhiArg() As Single, _
    BetaArg() As Single, _
    AlphaArg() As Single, _
    DispArg() As Single, _
    DispPArg() As Single, _
    ElePointerArg() As Integer, _
    EleArg() As ElementType, _
    MonArg() As MonitorType, _
    CorArg() As CorrectorType)
 
    Call RPC_OpticHeader(OpticHeaderArg)
    If OpticRC% <> 0 Then Exit Sub
 
    Call RPC_OpticLattice8Bytes("POSITION", OpticHeaderArg, PosNameArg)
    If OpticRC% <> 0 Then Exit Sub
    
    Call RPC_OpticLattice8Bytes("TYPENAME", OpticHeaderArg, TypeNameArg)
    If OpticRC% <> 0 Then Exit Sub
    
    Call RPC_OpticLatticeDouble("DRIFT", OpticHeaderArg, DriftArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeDouble("MIDDLE", OpticHeaderArg, MiddleArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeInteger("TYPEPOINTER", OpticHeaderArg, ElePointerArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("PHI-X", HORIZONTAL, OpticHeaderArg, PhiArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("PHI-Z", VERTICAL, OpticHeaderArg, PhiArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("BETA-X", HORIZONTAL, OpticHeaderArg, BetaArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("BETA-Z", VERTICAL, OpticHeaderArg, BetaArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("ALPHA-X", HORIZONTAL, OpticHeaderArg, AlphaArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("ALPHA-Z", VERTICAL, OpticHeaderArg, AlphaArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("DISP-X", HORIZONTAL, OpticHeaderArg, DispArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("DISP-Z", VERTICAL, OpticHeaderArg, DispArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("DISPP-X", HORIZONTAL, OpticHeaderArg, DispPArg)
    If OpticRC% <> 0 Then Exit Sub
   
    Call RPC_OpticLatticeSingle("DISPP-Z", VERTICAL, OpticHeaderArg, DispPArg)
    If OpticRC% <> 0 Then Exit Sub
    
    Call RPC_OpticElementList(OpticHeaderArg, EleArg)
    If OpticRC% <> 0 Then Exit Sub
    
    Call RPC_OpticCMStruct(OpticHeaderArg, MonArg, CorArg) 'swh, MonArg was Mon
    If OpticRC% <> 0 Then Exit Sub
End Sub
Public Sub ViewRpcRC(ByVal MachineArg As String, ByVal YearArg As String, ByVal OpticArg As String)

If OpticRC% > 0 And OpticRC% < 600 Then
    OpticReturnMsgLong = "Equipment Function = " & OpticRPCEqpF$ & " Property = " + OpticRPCProp$ + " Error = " + Format(OpticRC%) & " : " & RPCERROR(OpticRC%) & OpticReturnMsgShort
ElseIf OpticRC% > 600 Then
    OpticReturnMsgLong = "Equipment Function = " + OpticRPCEqpF$ & " Property = " + OpticRPCProp$ & " Error = " & Format(OpticRC%) + " : " & OpticServerErrText & OpticReturnMsgShort
End If

'
' THIS SUBROUTINE needs to be defined SOMEWHERE in a .bas file!!!!
'
' Public Sub ViewOpticMessage(ByVal MachineArg As String, ByVal YearArg As String, ByVal OpticArg As String)
'
Call ViewOpticMessage(MachineArg, YearArg, OpticArg)

End Sub
Public Sub ListLattice( _
    OpticHeaderArg As OpticHeaderType, _
    PosNameArg() As String * 8, _
    TypeNameArg() As String * 8, _
    DriftArg() As Double, _
    MiddleArg() As Double, _
    PhiArg() As Single, _
    BetaArg() As Single, _
    AlphaArg() As Single, _
    DispArg() As Single, _
    DispPArg() As Single, _
    ElePointerArg() As Integer)
    
    Dim lattice_file$, Editor$
    Dim str_num As String * 4
    Dim str_pointer As String * 4
    Dim i%, lattice_id%
    
    lattice_file = Environ("TEMP") + "\" + RTrim(OpticHeaderArg.Machine) + _
                    "-lattice-" + RTrim(OpticHeaderArg.name) + ".txt"
    lattice_id = FreeFile
    
    Open lattice_file$ For Output Access Write As lattice_id
        
    Print #lattice_id, RTrim(OpticHeaderArg.Machine) + " Lattice " + _
                       RTrim(OpticHeaderArg.name) + " (" + _
                       OpticHeaderArg.Year + ")"
    Print #lattice_id, " "
    Print #lattice_id, "Qx = " + f77single(OpticHeaderArg.QTheory(0), 5, ".00")
    Print #lattice_id, "Qz = " + f77single(OpticHeaderArg.QTheory(1), 5, ".00")
    Print #lattice_id, "Momentum Compaction Factor = " + Format(OpticHeaderArg.MomComp)
    ' Print #lattice_id, " "
    Print #lattice_id, "                                          | -----   hor   ----- | -----   ver   ----- | ---   hor  --- | ---   ver  ---"
    Print #lattice_id, " Num Position Typename RefNo    Pos Drift |   Beta  Alpha   Phi |   Beta  Alpha   Phi |    Disp  DispP |    Disp  DispP"
    Print #lattice_id, "                                 mm    mm |      m              |      m              |      mm   mrad |      mm   mrad"
    Print #lattice_id, "------------------------------------------|---------------------|---------------------|----------------|---------------"
    For i% = 0 To OpticHeaderArg.LatNum - 1
        RSet str_num = Format(i%)
        RSet str_pointer = Format(ElePointerArg(i%))
        Print #lattice_id, str_num + " " + PosNameArg(i%) + " " + TypeNameArg(i%) _
        + " " + str_pointer _
        + f77double(MiddleArg(i%) * 1000, 8, "0") _
        + f77double(DriftArg(i%) * 1000, 6, "0") _
        + " |" _
        + f77single(BetaArg(i%, 0), 7, ".00") _
        + f77single(AlphaArg(i%, 0), 7, ".00") _
        + f77single(PhiArg(i%, 0), 6, ".00") _
        + " |" _
        + f77single(BetaArg(i%, 1), 7, ".00") _
        + f77single(AlphaArg(i%, 1), 7, ".00") _
        + f77single(PhiArg(i%, 1), 6, ".00") _
        + " | " _
        + f77single(DispArg(i%, 0) * 1000, 7, ".0") _
        + f77single(DispPArg(i%, 0) * 1000, 7, ".0") _
        + " | " _
        + f77single(DispArg(i%, 1) * 1000, 7, ".0") _
        + f77single(DispPArg(i%, 1) * 1000, 7, ".0")
    Next i%
    
    Close lattice_id
    
    Editor$ = Environ("systemroot") + "\system32\notepad.exe"
    OpticRC% = Shell(Editor$ + " " + lattice_file$, vbNormalFocus)

End Sub
Public Sub ListElementList(OpticHeaderArg As OpticHeaderType, EleArg() As ElementType)

    Dim i%, ele_id%
    Dim ele_file$, Editor$
    Dim str_num As String * 3
    Dim str_pettype As String * 5
    Dim str_count As String * 6
    Dim Pi As Double
    
    Pi = 4 * Atn(1)
    
    ele_file = Environ("TEMP") + "\" + RTrim(OpticHeaderArg.Machine) + "-elementlist-" + RTrim(OpticHeaderArg.name) + ".txt"
    ele_id = FreeFile
    
    Open ele_file$ For Output Access Write As ele_id
        
    Print #ele_id, RTrim(OpticHeaderArg.Machine) + " Element List " + RTrim(OpticHeaderArg.name) + " (" + OpticHeaderArg.Year + ")"
    Print #ele_id, " "
    
    str_count = "   666"
    
    Print #ele_id, "Num TypeName   Length Type Count  Angle    Strength     1/RHO-X     1/RHO-Z"
    Print #ele_id, "---------------------------------------------------------------------------"
    
    For i% = 0 To OpticHeaderArg.EleNum% - 1
        RSet str_num = Format(i%)
        RSet str_pettype = Format(EleArg(i%).PetType)
        Print #ele_id, str_num + " " + EleArg(i%).TypeName _
        + f77double(EleArg(i%).Length * 1000, 9, "0.00;;0") _
        + str_pettype _
        + str_count _
        + f77double(EleArg(i%).Angle * 180 / Pi, 7, "0.00;;0") _
        + f77double(EleArg(i%).Strength, 12, "0.0000e+00;;0") _
        + f77double(EleArg(i%).HX, 12, "0.0000e+00;;0") _
        + f77double(EleArg(i%).HZ, 12, "0.0000e+00;;0")
    Next i
    
    Close ele_id
    
    Editor$ = Environ("systemroot") + "\system32\notepad.exe"
    OpticRC% = Shell(Editor$ + " " + ele_file$, vbNormalFocus)

End Sub
Public Sub ListCMStruct(OpticHeaderArg As OpticHeaderType, MonArg() As MonitorType, CorArg() As CorrectorType)

    Const LR = "           "

    Dim i%, j%, cmstruct_id%
    Dim cmstruct_file$, Editor$
    Dim str_num As String * 3
    
    cmstruct_file = Environ("TEMP") + "\" + RTrim(OpticHeaderArg.Machine) + "-cormon-" + RTrim(OpticHeaderArg.name) + ".txt"
    cmstruct_id = FreeFile
    
    Open cmstruct_file$ For Output Access Write As cmstruct_id
        
    Print #cmstruct_id, RTrim(OpticHeaderArg.Machine) + " Optic " + RTrim(OpticHeaderArg.name) + " (" + OpticHeaderArg.Year + ")"
    
    For j% = HORIZONTAL To VERTICAL
        Print #cmstruct_id, " "
        If j% = HORIZONTAL Then Print #cmstruct_id, LR$ + "Horizontal Monitors"
        If j% = VERTICAL Then Print #cmstruct_id, LR$ + "Vertical Monitors"
        Print #cmstruct_id, " "
        Print #cmstruct_id, "Num     Name       Beta     Disp      Phi"
        Print #cmstruct_id, "-----------------------------------------"
        For i% = 0 To OpticHeaderArg.MonNum%(j%) - 1
            RSet str_num = Format(i%)
            Print #cmstruct_id, str_num _
            + "   " + MonArg(i%, j%).name _
            + f77double(MonArg(i%, j%).Beta, 9, "0.00;;0") _
            + f77double(MonArg(i%, j%).Disp, 9, "0.00;;0") _
            + f77double(MonArg(i%, j%).Phi, 9, "0.00;;0")
        Next i%
        Print #cmstruct_id, "========================================="
    Next j%
    For j% = HORIZONTAL To VERTICAL
        Print #cmstruct_id, " "
        If j% = HORIZONTAL Then Print #cmstruct_id, LR$ + "Horizontal Correctors"
        If j% = VERTICAL Then Print #cmstruct_id, LR$ + "Vertical Correctors"
        Print #cmstruct_id, " "
        Print #cmstruct_id, "Num     Name       Beta     Disp      Phi Max-Kick"
        Print #cmstruct_id, "--------------------------------------------------"
        For i% = 0 To OpticHeaderArg.CorNum%(j%) - 1
            RSet str_num = Format(i%)
            Print #cmstruct_id, str_num _
            + "   " + CorArg(i%, j%).name _
            + f77double(CorArg(i%, j%).Beta, 9, "0.00;;0") _
            + f77double(CorArg(i%, j%).Disp, 9, "0.00;;0") _
            + f77double(CorArg(i%, j%).Phi, 9, "0.00;;0") _
            + f77double(CorArg(i%, j%).KMax, 9, "0.00;;0")
        Next i
        Print #cmstruct_id, "=================================================="
   Next j
    
    Close cmstruct_id
    
    Editor$ = Environ("systemroot") + "\system32\notepad.exe"
    OpticRC% = Shell(Editor$ + " " + cmstruct_file$, vbNormalFocus)

End Sub
Public Sub ListOrbit(OrbitArg As OrbitType)

    Const LR = "           "

    Dim i%, j%, orbit_id%
    Dim orbit_file$, Editor$
    Dim str_num As String * 3
    
    orbit_file = Environ("TEMP") + "\" + "TMP-ORBIT" + ".txt"
'    orbit_file = Environ("TEMP") + "\" + "ORBIT-" + RTrim(OrbitArg.name) + ".txt"
    orbit_id = FreeFile
    
    Open orbit_file$ For Output Access Write As orbit_id
        
    Print #orbit_id, "Orbit " + RTrim(OrbitArg.name)
    
    For j% = HORIZONTAL To VERTICAL
        Print #orbit_id, " "
        If j% = HORIZONTAL Then Print #orbit_id, LR$ + "Horizontal Monitors"
        If j% = VERTICAL Then Print #orbit_id, LR$ + "Vertical Monitors"
        Print #orbit_id, " "
        Print #orbit_id, "Num     Name      Orbit Flag"
        Print #orbit_id, "----------------------------"
        For i% = 0 To OrbitArg.MonNum%(j%) - 1
            RSet str_num = Format(i%)
            Print #orbit_id, str_num _
            + "   " + OrbitArg.monname(i%, j%) _
            + f77double(OrbitArg.Orbit(i%, j%), 9, "0.00;;0") _
            + "    " + Format(OrbitArg.MonFlags(i%, j%))
        Next i%
        Print #orbit_id, "============================="
    Next j%
    For j% = HORIZONTAL To VERTICAL
        Print #orbit_id, " "
        If j% = HORIZONTAL Then Print #orbit_id, LR$ + "Horizontal Correctors"
        If j% = VERTICAL Then Print #orbit_id, LR$ + "Vertical Correctors"
        Print #orbit_id, " "
        Print #orbit_id, "Num     Name       Kick Max-Kick Flag"
        Print #orbit_id, "-------------------------------------"
        For i% = 0 To OrbitArg.CorNum(j%) - 1
            RSet str_num = Format(i%)
            Print #orbit_id, str_num _
            + "   " + OrbitArg.CorName(i%, j%) _
            + f77double(OrbitArg.Kicks(i%, j%), 9, "0.00;;0") _
            + f77double(OrbitArg.KMax(i%, j%), 9, "0.00;;0") _
            + "    " + Format(OrbitArg.CorFlags(i%, j%))
        Next i%
        Print #orbit_id, "====================================="
    Next j%
    
    Close orbit_id
    
    Editor$ = Environ("systemroot") + "\system32\notepad.exe"
    OpticRC% = Shell(Editor$ + " " + orbit_file$, vbNormalFocus)

End Sub
Public Sub ListRCMops(MopsData As RpcHdrRcmops)

    Const LR = "           "
    
    Dim i%, j%, rcmops_id%
    Dim rcmops_file$, Editor$
    Dim str_num As String * 3
    
    rcmops_file = Environ("TEMP") + "\" + RTrim(Hdr.Machine) + "-rcmops-" + RTrim(Hdr.Optic) + ".txt"
    rcmops_id = FreeFile
    
    Open rcmops_file$ For Output Access Write As rcmops_id
        
    Print #rcmops_id, RTrim(MopsData.Hdr.Machine) + " Optic " + RTrim(MopsData.Hdr.Optic) + " (" + RTrim(MopsData.Hdr.Year) + ")"
    
    For j% = HORIZONTAL To VERTICAL
        Print #rcmops_id, " "
        If j% = HORIZONTAL Then Print #rcmops_id, LR$ + "Horizontal Monitors"
        If j% = VERTICAL Then Print #rcmops_id, LR$ + "Vertical Monitors"
        Print #rcmops_id, " "
        Print #rcmops_id, "Num     Name       Beta     Disp      Phi"
        Print #rcmops_id, "-----------------------------------------"
        For i% = 0 To MopsData.Hdr.MonNum%(j%) - 1 'Q - first dimension for monname ??
            RSet str_num = Format(i%)
            Print #rcmops_id, str_num _
            + "   " + MopsData.monname(0, i%, j%) _
            + f77double(MopsData.MonBeta(i%, j%), 9, "0.00;;0") _
            + f77double(MopsData.MonDisp(i%, j%), 9, "0.00;;0") _
            + f77double(MopsData.MonPhi(i%, j%), 9, "0.00;;0")
        Next i%
        Print #rcmops_id, "========================================="
    Next j%
    For j% = HORIZONTAL To VERTICAL
        Print #rcmops_id, " "
        If j% = HORIZONTAL Then Print #rcmops_id, LR$ + "Horizontal Correctors"
        If j% = VERTICAL Then Print #rcmops_id, LR$ + "Vertical Correctors"
        Print #rcmops_id, " "
        Print #rcmops_id, "Num     Name       Beta     Disp      Phi Max-Kick"
        Print #rcmops_id, "--------------------------------------------------"
        For i% = 0 To MopsData.Hdr.CorNum%(j%) - 1 'Q first dimension for Corname ??
            RSet str_num = Format(i%)
            Print #rcmops_id, str_num _
            + "   " + MopsData.CorName(0, i%, j%) _
            + f77double(MopsData.CorBeta(i%, j%), 9, "0.00;;0") _
            + f77double(MopsData.CorDisp(i%, j%), 9, "0.00;;0") _
            + f77double(MopsData.CorPhi(i%, j%), 9, "0.00;;0") _
            + f77double(MopsData.CorKmax(i%, j%), 9, "0.00;;0")
        Next i%
        Print #rcmops_id, "=================================================="
   Next j%
    
    Close rcmops_id
    
    Editor$ = Environ("systemroot") + "\system32\notepad.exe"
    OpticRC% = Shell(Editor$ + " " + rcmops_file$, vbNormalFocus)

End Sub
Public Sub RpcHeaderDebug(HdrArg As RpcHdrType)
    Dim outid%
    Dim outputfile$, Editor$
    
    outputfile = Environ("TEMP") + "\hdr.txt"
    outid = FreeFile
    Open outputfile$ For Output Access Write As outid
    
    Print #outid, "Machine ......... " + Chr(34) + RTrim(HdrArg.Machine) + Chr(34)
    Print #outid, "Year ............ " + Chr(34) + RTrim(HdrArg.Year) + Chr(34)
    Print #outid, "Text1 ........... " + Chr(34) + RTrim(HdrArg.Text1) + Chr(34)
    Print #outid, "Text2 ........... " + Chr(34) + RTrim(HdrArg.text2) + Chr(34)
    Print #outid, "DateTime ........ " + Chr(34) + RTrim(HdrArg.DateTime) + Chr(34)
    Print #outid, "fileName ........ " + Chr(34) + RTrim(HdrArg.filename) + Chr(34)
    Print #outid, "Optic ........... " + Chr(34) + RTrim(HdrArg.Optic) + Chr(34)
    Print #outid, "OpticFlag ....... " + Chr(34) + RTrim(HdrArg.OpticFlag) + Chr(34)
    Print #outid, "ErrorString ..... " + Chr(34) + RTrim(HdrArg.ErrorString) + Chr(34)
    
    Print #outid, "Energy .......... " + Format(HdrArg.OpticEnergy)
    
    Print #outid, "Arr_mon ......... " + Format(HdrArg.Arr_mon)
    Print #outid, "Arr_cor ......... " + Format(HdrArg.Arr_cor)
    Print #outid, "Arr_il .......... " + Format(HdrArg.Arr_il)
    Print #outid, "Arr_jl .......... " + Format(HdrArg.Arr_jl)
    
    Print #outid, "Hdr_Size ........ " + Format(HdrArg.Hdr_Size)
    Print #outid, "Spez_Hdr_Size ... " + Format(HdrArg.Spez_Hdr_Size)
    Print #outid, "Arr_Size ........ " + Format(HdrArg.Arr_Size)

    Print #outid, "MonNum(0) ....... " + Format(HdrArg.MonNum(0))
    Print #outid, "MonNum(1) ....... " + Format(HdrArg.MonNum(1))
    Print #outid, "CorNum(0) ....... " + Format(HdrArg.CorNum(0))
    Print #outid, "CorNum(1) ....... " + Format(HdrArg.CorNum(1))
    Print #outid, "LatNum .......... " + Format(HdrArg.LatNum)
    Print #outid, "EleNum .......... " + Format(HdrArg.EleNum)
    Print #outid, "OpticNum ........ " + Format(HdrArg.OpticNum)
    
    Print #outid, "SpezNum ......... " + Format(HdrArg.SpezNum)
    Print #outid, "Counter ......... " + Format(HdrArg.Counter)

    Print #outid, "Qtheory(0) ...... " + Format(HdrArg.QTheory(0))
    Print #outid, "Qtheory(1) ...... " + Format(HdrArg.QTheory(1))
    Print #outid, "MomComp ......... " + Format(HdrArg.MomComp)
    Print #outid, "Circumference ... " + Format(HdrArg.Circumference)
    
    Print #outid, "NGDebug ......... " + Format(NGDebug)
    Print #outid, "HPDebug ......... " + Format(HPDebug)
    Print #outid, "index ........... " + Format(HdrArg.Index)
    Print #outid, "Version ......... " + Format(HdrArg.Version)

    Close outid
    
    Editor$ = Environ("systemroot") + "\system32\notepad.exe"
    OpticRC% = Shell(Editor$ + " " + outputfile$, vbNormalFocus)
End Sub

Public Sub MachineName(ByVal InString As String, OutString As String)
    Select Case InString
        Case "doris   "
            OutString = "DORIS"
        Case "petrae  "
            OutString = "PETRA-e"
        Case "petrap  "
            OutString = "PETRA-p"
        Case "herae   "
            OutString = "HERA-e"
        Case "herap   "
            OutString = "HERA-p"
        Case Else
            OutString = InString
    End Select
End Sub

Public Sub GrabAnOpticForOrbit(OrbitArg As OrbitType)
' Kludge to get basic optic data in, so orbits (from "FECs") can be loaded into "optic" structure...

    Dim OpticListLoc As OpticListType
    Dim OpticHeaderLoc As OpticHeaderType
    Dim MonLoc(MonDim%, 1) As MonitorType
    Dim CorLoc(CorDim%, 1) As CorrectorType
    Dim i%, j%, iOptic%
'   Don't need to check if an orbit has been loaded...
'    If Not OrbitArg.Loaded Then Exit Sub
    
    ' Opticliste laden
    OpticListLoc.Machine = OrbitArg.Machine
    OpticListLoc.Year = OrbitArg.Year
    Call RPC_OpticList(OpticListLoc)
    If OpticRC% <> 0 Then Exit Sub
    
    ' Optik suchen
    OrbitArg.OpticFound = False
    OrbitArg.OpticLoaded = False
    iOptic = 0
    For i% = 0 To OpticListLoc.NumOptics
        If RTrim(OrbitArg.Optic) = RTrim(OpticListLoc.Optic(i%)) Then
            iOptic = i%
            OrbitArg.OpticFound = True
            Exit For
        End If
    Next i%
    
    OpticHeaderLoc.Machine = OrbitArg.Machine
    OpticHeaderLoc.Year = OrbitArg.Year
    OpticHeaderLoc.name = OpticListLoc.Optic(iOptic)
    
    ' Optik fr Orbit laden, zur Not 1. Optik aus der Liste
    
    Call RPC_OpticHeader(OpticHeaderLoc)
    If OpticRC% <> 0 Then Exit Sub
    Call RPC_OpticCMStruct(OpticHeaderLoc, MonLoc, CorLoc)
    If OpticRC% <> 0 Then Exit Sub
    
    ' Optik Info mit Orbit Info vergleichen
     ' DON'T do this comparison...
'    For j = HORIZONTAL To VERTICAL
'        If OrbitArg.MonNum(j) <> OpticHeaderLoc.MonNum(j) Or _
'           OrbitArg.CorNum(j) <> OpticHeaderLoc.CorNum(j) Then
'           OpticRC% = 777
'           Exit Sub
'        End If
'    Next j
    
    ' Optik Info >> Orbit abspeichern
    
    For j% = HORIZONTAL To VERTICAL
        OrbitArg.MonNum(j%) = OpticHeaderLoc.MonNum(j%)
        OrbitArg.CorNum(j%) = OpticHeaderLoc.CorNum(j%)
        OrbitArg.QTheo(j%) = OpticHeaderLoc.QTheory(j%)
        ' OrbitArg.QMeas(j) natrlich nicht
        OrbitArg.Circumference = OpticHeaderLoc.Circumference
        For i = 0 To OrbitArg.MonNum(j%)
            OrbitArg.MonPhi(i%, j%) = MonLoc(i%, j%).Phi
            OrbitArg.monname(i%, j%) = MonLoc(i%, j%).name
        Next i
        For i = 0 To OrbitArg.CorNum(j%)
            OrbitArg.CorPhi(i%, j%) = CorLoc(i%, j%).Phi
            OrbitArg.CorName(i%, j%) = CorLoc(i%, j%).name
        Next i%
    Next j%
    
    OrbitArg.OpticLoaded = True
End Sub
