Attribute VB_Name = "PMArchive"
'==========================================================
'==                                                      ==
'==     archive retrieval routines following LPC format  ==
'==                                                      ==
'==========================================================
Global pmArchiveServer$
Global EventArchiveServer$
Global EventStorageServer$
Global MaxNumHistoryPoints As Integer

Type APCBLK
  SessionID As Long
  Event As Long
  Ext(3) As Byte
  EqpName(15) As Byte
  devName(15) As Byte
  devProperty(31) As Byte
  dsize As Integer
  dFormat As Integer
End Type

Type ARS
  starttime As Long
  idx As Integer
  mins As Integer
  keyword(15) As Byte
End Type

Type ADRB
  eventNumber As Long
  starttime As Long
  StopTime As Long
  deviceServerName(15) As Byte
  deviceProperty(15) As Byte
  deviceName(15) As Byte
  dataFormat As Integer
  dataDimension As Integer
End Type

Type ADRBX
  eventNumber As Long
  starttime As Long
  StopTime As Long
  deviceContext(15) As Byte
  deviceServerName(15) As Byte
  deviceProperty(31) As Byte
  deviceName(31) As Byte
  dataFormat As Integer
  Reserved As Integer
  dataIndex As Long
  dataDimension As Long
End Type

'Type AMS            ' Alarm Message Structure
'tag(15) As Byte
'device(15) As Byte
'almTag(15) As Byte
'alarmCode As Long
'timestamp As Long
'alarmMask As Long
'alarmData(5) As Byte
'alarmDataFormat As Byte
'alarmDataArraySize As Byte
'severity As Byte
'descriptor As Byte
'AlarmSystem As Integer
'End Type

Type DHS
    channelID(31) As Byte
    eventCode As Long
    arraySize As Integer
    datatype As Integer
    samplingRate As Single
    preTrigger As Long
    timeOffset As Long
    lowCount As Long
    highCount As Long
    egu(15) As Byte
    eguLow As Single
    eguHigh As Single
    DataLength  As Long  ' was Reserved(3) As Byte
    desc(255) As Byte
End Type

'Type CASQS
'devContext(15) As Byte
'devServer(15) As Byte
'subSystem(15) As Byte
'arcExt(15) As Byte
'SeverityLevel As Long
'ArchiveLevel As Long
'Retention As Long
'AlarmLevel As Long
'AlarmSystem As Long
'End Type

Type RPCSTRING
  text(255) As Byte
End Type

Declare Function LOADEQP Lib "apc32.dll" (ByVal filename$, ByVal yr%) As Integer
Declare Function CLOSEEQP Lib "apc32.dll" () As Integer
Declare Function LPC Lib "apc32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal size%, d As Any, ByVal dsize%, ByVal fmt%) As Integer
Declare Function apc Lib "apc32.dll" Alias "APC" (ByVal eqm$, ByVal dev$, ByVal prop$, ByVal size%, d As Any, ByVal fmt%) As Integer
Declare Function A_LPC Lib "apc32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function FILER Lib "apc32.dll" (ByVal fname$, f As FSTRUCT, ByVal num%, ByVal yr%) As Integer
Declare Function READCMT Lib "apc32.dll" (ByVal cmt$, ByVal filename$, ByVal yr%) As Integer
Declare Function WRITECMT Lib "apc32.dll" (ByVal cmt$, ByVal filename$, ByVal yr%) As Integer
Declare Function REMOVE Lib "apc32.dll" (ByVal filename$, ByVal yr%) As Integer
Declare Function GetEventList Lib "apc32.dll" (ByVal archiveGroup$, ByVal starttime&, ByVal StopTime&, numEvents%, evnList&, evnTime As NAME32) As Integer
Declare Function GetEvents Lib "apc32.dll" (ByVal archiveGroup$, ByVal starttime&, ByVal StopTime&, numEvents%, evnList&) As Integer
Declare Function GetEventData Lib "apc32.dll" (ByVal archiveGroup$, ByVal evnNr&, ByVal devName$, ByVal devProperty$, npoints&, ByVal Format%, DataBuffer As Any) As Integer

'==========================================================
'==                                                      ==
'==         HERA DATA Retrieval routines                 ==
'==                                                      ==
'==========================================================

Declare Function FETCH Lib "apc32.dll" (ByVal keyword$, ByVal index%, ByVal start&, ByVal Minutes%, ByVal size%, dat As Any, tstamp&) As Integer
Declare Sub FTIME Lib "apc32.dll" (dst!, src&, ByVal shft&, ByVal num%)
Declare Sub ARRLOG Lib "apc32.dll" (dst!, src!, ByVal num%)
Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
Function GetArchivedKeywords(arcServerName As String, Keywords() As String, numKeywords As Integer) As Integer
Dim rc%, i%, n%, nprps&, kwd$
Dim lclprps(1000) As NAME32
Dim prps() As String
Dim cntxt As NAME16, srv As NAME16, dev As NAME16
nprps& = 1000
BARR cntxt.nam(), "": BARR srv.nam(), arcServerName: BARR dev.nam(), "#0"
rc% = T_GETDEVICEPROPERTIES(cntxt, srv, dev, lclprps(0), nprps&)
If rc% Then nprps& = 0
numKeywords = nprps&
'rc% = GetEquipmentDeviceProperties(arcServerName, prps(), numKeywords)
If rc% Then GoTo GetArchivedKeywordsErr
ReDim Keywords(numKeywords)
n% = 0
For i% = 0 To numKeywords - 1
  kwd$ = BSTR(lclprps(i%).nam())
  If (kwd$ <> "FETCH") And (kwd$ <> "dummy") Then
    Keywords(n%) = kwd$
    n% = n% + 1
  End If
Next
numKeywords% = n%
GetArchivedKeywordsErr:
  GetArchivedKeywords = rc%
End Function
Function GetArchivedParameters(arcServerName As String, arcSubSystem As String, Keywords() As String, numKeywords As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim rc%, i%, n%, nprps&, kwd$
Dim lclprps(1000) As NAME32, subs As NAME16
Dim prps() As String
Dim searchstr(80) As Byte
dout.dFormat = CF_SHORT: dout.dArrayLength = 1
din.dFormat = CF_NULL: din.dArrayLength = 0
rc% = T_EXECLINK(arcServerName, "NTAGS", dout, numKeywords, din, 0, CA_READ, 1000)
If numKeywords > 1000 Then numKeywords = 1000
If rc% Then GoTo GetArchivedParametersErr
dout.dFormat = CF_NAME32: dout.dArrayLength = numKeywords
If Left(arcSubSystem, 7) = "SEARCH:" Then
  BARR searchstr, Right(arcSubSystem, Len(arcSubSystem) - 7)
  din.dFormat = CF_TEXT: din.dArrayLength = Len(arcSubSystem) - 7
ElseIf Len(arcSubSystem) = 0 Or arcSubSystem = "All Systems" Then
  subs.nam(0) = 0
  din.dFormat = CF_NULL: din.dArrayLength = 0
Else
  BARR searchstr, arcSubSystem
  din.dFormat = CF_NAME16: din.dArrayLength = 1
End If
rc% = T_EXECLINK(arcServerName, "TAGS", dout, lclprps(0), din, searchstr(0), CA_READ, 1000)
If rc% Then
  numKeywords = 0
  GoTo GetArchivedParametersErr
End If
ReDim Keywords(numKeywords)
n% = 0
For i% = 0 To numKeywords - 1
  kwd$ = BSTR(lclprps(i%).nam())
  If Len(kwd$) > 0 And _
     (kwd$ <> "dummy") And _
     (Right(kwd$, 4) <> ".NAM") Then
    Keywords(n%) = kwd$
    n% = n% + 1
  End If
Next
numKeywords = n%
GetArchivedParametersErr:
GetArchivedParameters = rc%
End Function
Function GetArchivedSubSystems(arcServerName As String, SubSystems() As String, numSubSystems As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim rc%, i%, n%
Dim lclsubs(100) As NAME16
Dim subs$
dout.dFormat = CF_SHORT: dout.dArrayLength = 1
din.dFormat = CF_NULL: din.dArrayLength = 0
rc% = T_EXECLINK(arcServerName, "NSUBSYSTEMS", dout, numSubSystems, din, 0, CA_READ, 1000)
If rc% Then
  numSubSystems = 0
  GoTo GetArchivedSubSystemsErr
End If
If numSubSystems > 100 Then numSubSystems = 100
dout.dFormat = CF_NAME16: dout.dArrayLength = numSubSystems
rc% = T_EXECLINK(arcServerName, "SUBSYSTEMS", dout, lclsubs(0), din, 0, CA_READ, 1000)
If rc% Then
  numSubSystems = 0
  GoTo GetArchivedSubSystemsErr
End If
ReDim SubSystems(numSubSystems + 1)
For i% = 0 To numSubSystems - 1
  subs$ = BSTR(lclsubs(i%).nam())
  If Len(subs$) > 0 And (subs$ <> "Dummy") Then
    SubSystems(n%) = subs$
    n% = n% + 1
  End If
Next
SubSystems(n%) = "All Systems"
numSubSystems = n% + 1
GetArchivedSubSystemsErr:
GetArchivedSubSystems = rc%
End Function


' this is the NEW API
Function GetPMGroups(devSrvNames() As String, numDevSrvs As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim dsn() As NAME16
Dim rc%, i%
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(EventArchiveServer$, "NDSERVERS", dout, numDevSrvs, din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMGroupsErr

' Check if number is NEGATIVE!
If numDevSrvs < 0 Then
    Exit Function
ElseIf numDevSrvs = 0 Then
    MsgBox " Number of Device-Servers for " + EventArchiveServer$ + " is zero!!??@#$@!"
    numDevSrvs = 5
End If
ReDim dsn(numDevSrvs)

dout.dArrayLength = numDevSrvs: dout.dFormat = CF_NAME16
rc% = T_EXECLINK(EventArchiveServer$, "DSERVERS", dout, dsn(0), din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMGroupsErr
ReDim devSrvNames(numDevSrvs)
For i% = 0 To numDevSrvs - 1
  If dsn(i).nam(0) = 0 Then Exit For
  devSrvNames(i%) = BSTR(dsn(i%).nam())
Next
numDevSrvs = i%

GetPMGroupsErr:
  GetPMGroups = rc%
End Function

' this is the NEW API
Function GetPMDevices(ByVal pmDeviceServer$, DeviceNames() As String, numDevices As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim dn() As NAME16
Dim rc%, i%

dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "NADEVICES", dout, numDevices, din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMDevicesErr
If numDevices < 0 Then GoTo NegDevices
If numDevices = 0 Then GoTo NullDevices

ReDim dn(numDevices)
dout.dArrayLength = numDevices: dout.dFormat = CF_NAME16
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "ADEVICES", dout, dn(0), din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMDevicesErr
ReDim DeviceNames(numDevices)
For i% = 0 To numDevices - 1
  DeviceNames(i%) = BSTR(dn(i%).nam())
Next
GetPMDevicesErr:
GetPMDevices = rc%
Exit Function

NegDevices:
GetPMDevices = -100
Exit Function

NullDevices:
GetPMDevices = 0 '
Exit Function
End Function

' this is the NEW API
Function GetPMProperties(ByVal pmDeviceServer$, Properties() As String, numProperties As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim prp() As NAME16 'NAME32
Dim rc%, i%, p%
Dim dev As NAME16
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
p% = InStr(pmDeviceServer$, "/")
If p% > 0 Then
  din.dArrayLength = 1: din.dFormat = CF_NAME16
  BARR dev.nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  pmDeviceServer$ = Left$(pmDeviceServer$, p% - 1)
Else
  din.dArrayLength = 0: din.dFormat = CF_NULL
End If
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "NAPROPS", dout, numProperties, din, dev, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr

ReDim prp(numProperties)
dout.dArrayLength = numProperties: dout.dFormat = CF_NAME16 'CF_NAME32
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "APROPS", dout, prp(0), din, dev, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr

ReDim Properties(numProperties)
For i% = 0 To numProperties - 1
  Properties(i%) = BSTR(prp(i%).nam())
Next

GetPMPropertiesErr:
GetPMProperties = rc%
End Function

'this has been deprectated
Function GetPMArchivedData(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal devName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant)
Static SessionID As Integer
Static eventTag As String
Static pmArcGrp As String
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double
Static done As Boolean

If pmArchiveServer$ = "" Then
 pmArchiveServer$ = "APC"
End If

If Not done Then
  FILLSTRUCT "APCBLK", Len(apc), 1, CF_NULL
  done = True
End If

rc& = 0

If eventTag <> evnTag Or pmArchiveGroup$ <> pmArcGrp Then ' new session
  eventTag = evnTag
  pmArcGrp = pmArchiveGroup$
  If SessionID > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "CLOSE", dout, 0, din, SessionID, 1, 1000)
    If rc& Then GoTo GetPMArchivedDataError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedDataError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "OPEN", dout, SessionID, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedDataError
End If
If eventTag = "" Then GoTo GetPMArchivedDataError

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

apc.SessionID = SessionID
BARR apc.EqpName(), dServerName$
BARR apc.devName(), dName$
BARR apc.devProperty(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLK"

If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
  rc& = 2
  GoTo GetPMArchivedDataError
End If

dout.dArrayLength = npoints
Select Case VarType(DataBuffer) - vbArray
  Case vbInteger:
       ReDim ID(npoints)
       dout.dFormat = CF_SHORT
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, ID(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ID(i%): Next
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, ld(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ld(i%): Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, fd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = fd(i%): Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, dd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = dd(i%): Next
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDataError

GetPMArchivedDataError:
GetPMArchivedData = rc&
End Function

'this is the NEW API
Function GetPMArchivedHeader(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal devName$, ByVal devProperty$, hdr As DHS) As Integer
Dim devHdr As DHS
Dim devadrb As ADRB, abx As ADRBX
Dim pass%, rc%, p%, dServerName$, dName$, dContext$
Dim dout As DBLK, din As DBLK
Dim s$
Dim dlength As Long
Static done As Boolean

If Not done Then
  FILLSTRUCT "DHS", Len(devHdr), 1, CF_NULL
  FILLSTRUCT "ADRB", Len(devadrb), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

If Left$(devName$, 1) = "/" Then
  p% = InStr(Right$(devName$, Len(devName$) - 1), "/")
  dContext$ = Mid$(devName$, 2, p%)
  devName$ = Right$(devName$, Len(devName$) - p% - 1)
End If

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

RetryGetPMArchivedHeader:
dout.dArrayLength = 1: dout.dFormat = CF_STRUCT: BARR dout.dTag(), "DHS"
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.StopTime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
    rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "ARCHHEADER", dout, devHdr, din, abx, CA_READ, 1000)
Else
    devadrb.eventNumber = evnNumber&
    BARR devadrb.deviceName(), dName$
    BARR devadrb.deviceServerName, dServerName$
    BARR devadrb.deviceProperty, devProperty$
    devadrb.starttime = evnNumber&
    devadrb.StopTime = evnNumber&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
    rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "ARCHHEADER", dout, devHdr, din, devadrb, CA_READ, 1000)
End If
pass% = pass% + 1
If (rc% = 2 Or rc% = 23 Or rc% = 38) And (pass% < 2) Then GoTo RetryGetPMArchivedHeader


'devadrb.eventNumber = evnNumber&
'BARR devadrb.deviceName(), dName$
'BARR devadrb.deviceServerName, dServerName$
'BARR devadrb.deviceProperty, devProperty$
'devadrb.StartTime = evnNumber&
'devadrb.stoptime = evnNumber&
'
'din.dArrayLength = 1: din.dFormat = CF_STRUCT: BARR din.dTag(), "ADRB"

GetPMArchivedHeader = rc% 'RPCERROR(rc%)
dlength = devHdr.arraySize
If dlength < 0 Then dlength = devHdr.DataLength Else devHdr.DataLength = dlength

hdr = devHdr
Exit Function

' OLD Version: return a STRING
If rc% Then
  'GetPMArchivedHeader = RPCERROR(rc%)
  Exit Function
End If

s$ = ""
s$ = s$ + "ChannelID : " + BSTR(devHdr.channelID()) + vbNewLine
s$ = s$ + "ArraySize : " + str$(dlength) + vbNewLine
s$ = s$ + "DataType : " + str$(devHdr.datatype) + vbNewLine
s$ = s$ + "EGU : " + BSTR(devHdr.egu()) + vbNewLine
s$ = s$ + "eguHigh : " + str$(devHdr.eguHigh) + vbNewLine
s$ = s$ + "eguLow : " + str$(devHdr.eguLow) + vbNewLine
s$ = s$ + "eventCode : " + str$(devHdr.eventCode) + vbNewLine
s$ = s$ + "highCount : " + str$(devHdr.highCount) + vbNewLine
s$ = s$ + "lowCount : " + str$(devHdr.lowCount) + vbNewLine
s$ = s$ + "preTrigger : " + str$(devHdr.preTrigger) + vbNewLine
s$ = s$ + "timeOffset : " + str$(devHdr.timeOffset) + vbNewLine
s$ = s$ + "samplingRate : " + str$(devHdr.samplingRate) + vbNewLine
s$ = s$ + "desc : " + BSTR(devHdr.desc()) + vbNewLine
'GetPMArchivedHeader = s$
End Function

' this is the NEW API
Function GetPMArchivedDeviceData(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal devName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant)
Static pmDevSrv As String
Dim dout As DBLK, din As DBLK
Dim ab As ADRB, abx As ADRBX
Dim rc&, p%, dContext$, dServerName$, dName$, dIndex&, evn As NAME8, pmServerContext$
Dim i As Long
Dim pass%, vtype As Integer, isArray As Boolean
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double, bd() As Byte, tmpStatus&, tmpRCStatus&
Dim ds() As Byte
Static done As Boolean

If Not done Then
  FILLSTRUCT "ADRB", Len(ab), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

rc& = 0
If Left$(devName$, 1) = "/" Then
  p% = InStr(Right$(devName$, Len(devName$) - 1), "/")
  dContext$ = Mid$(devName$, 2, p%)
  devName$ = Right$(devName$, Len(devName$) - p% - 1)
End If
p% = InStr(devName$, "/") '  z.B. L2TRCrf/#0
If p% = 0 Then
    dServerName$ = devName$
    dName$ = "#0"
Else
    dServerName$ = Left$(devName$, p% - 1)
    dName$ = Right$(devName$, Len(devName$) - p%)
End If
p% = InStr(dName$, "[") ' z.B. ALL_DATA[3]
If p% = 0 Then
  dIndex& = 0
Else
  dIndex& = Val(Right$(dName$, Len(dName$) - p%))
  dName$ = Left$(dName$, p% - 1)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If
'pmServerContext$ = EventArchiveServer$

retryGetPMArchivedData:
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.StopTime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
Else
    BARR ab.deviceServerName(), dServerName$
    BARR ab.deviceName(), dName$
    BARR ab.deviceProperty(), devProperty$
    ab.eventNumber = evnNumber&
    ab.starttime = evnNumber&
    ab.StopTime = evnNumber&
    
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
End If
pass% = pass% + 1
If VarType(DataBuffer) > vbArray Then
  If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
  vtype = VarType(DataBuffer) - vbArray
  isArray = True
ElseIf VarType(DataBuffer) = vbString Then
  vtype = vbString
Else
  vtype = VarType(DataBuffer)
  If npoints <> 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
End If

dout.dArrayLength = npoints
Select Case vtype
  Case vbInteger:
       ReDim ID(npoints)
       dout.dFormat = CF_SHORT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ID(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ID(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       ' Signed, or unsigned?
       For i = 0 To npoints - 1
           'If id(i) < 0 Then
           If isArray Then
               DataBuffer(i) = ID(i)
           Else
             DataBuffer = ID(i)
           End If
           'Else
           '    DataBuffer(i) = id(i) + &HFFFF
           'End If
      Next i
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = ld(i): Next
       Else
         DataBuffer = ld(0)
       End If
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) Then
        If (pass% < 2) Then GoTo retryGetPMArchivedData
       Else
        Dim ustrStatus(31) As Byte, strStatus As String
        dout.dArrayLength = 32
        dout.dFormat = CF_TEXT
        If pass% < 2 Then
         BARR abx.deviceProperty(), devProperty$ + ".STS"
         tmpRCStatus& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ustrStatus(0), din, abx, 1, 2000)
        Else
         BARR ab.deviceProperty(), devProperty$ + ".STS"
         tmpRCStatus& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ustrStatus(0), din, ab, 1, 2000)
        End If
        strStatus = BSTR(ustrStatus)
       End If
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = fd(i): Next
       Else
         DataBuffer = fd(0)
       End If
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = dd(i): Next
       Else
         DataBuffer = dd(0)
       End If
  Case vbByte:
       ReDim bd(npoints)
       dout.dFormat = CF_BYTE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = bd(i): Next
       Else
         DataBuffer = bd(0)
       End If
  Case vbString:
       ReDim ds(npoints)
       Select Case npoints
         Case 48:
           dout.dFormat = CF_NAME48
           dout.dArrayLength = 1
         Case 32:
           dout.dFormat = CF_NAME32
           dout.dArrayLength = 1
         Case 16:
           dout.dFormat = CF_NAME16
           dout.dArrayLength = 1
         Case Else:
           dout.dFormat = CF_TEXT
       End Select
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23) And (pass% < 2) Then GoTo retryGetPMArchivedData
       DataBuffer = BSTR(ds)
         
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDeviceDataError

GetPMArchivedDeviceDataError:
GetPMArchivedDeviceData = rc&
End Function

' this has been deprecated
Function GetPMEventList(ByVal pmArchiveGroup$, ByVal starttime&, ByVal StopTime&, evnList() As String, evnTime() As String) As Integer
Dim dout As DBLK, din As DBLK
Dim nevents As Integer
Dim lStartStopArray(1) As Long
Dim eventNames() As NAME8
Dim i%, rc&, tmpTime As String * 32
Dim timeout&

If pmArchiveServer$ = "" Then
 pmArchiveServer$ = "APC"
End If

timeout& = 1000
devName$ = pmArchiveServer$ & "/" + pmArchiveGroup$
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 2: din.dFormat = CF_LONG
lStartStopArray(0) = starttime&
lStartStopArray(1) = StopTime&
rc& = T_EXECLINK(devName, "QUERY.NFILES", dout, nevents, din, lStartStopArray(0), 1, timeout&)
If rc& Then GoTo GetPMEventListError

If nevents = 0 Then GoTo GetPMEventListError
ReDim eventNames(nevents - 1)

If nevents > 5000 Then timeout& = 3000
dout.dArrayLength = nevents: dout.dFormat = CF_NAME8
rc& = T_EXECLINK(devName, "QUERY.FILES", dout, eventNames(0), din, lStartStopArray(0), 1, timeout&)
If rc& Then GoTo GetPMEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = BSTR(eventNames(i%).nam())
  CTIME tmpTime, CLng(Val("&H" & evnList(i%)))
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMEventListError:
GetPMEventList = IIf(rc&, -rc&, nevents)
End Function

' this is the NEW API
Function GetPMDeviceEventList(ByVal pmDeviceServer$, ByVal starttime&, ByVal StopTime&, evnList() As Long, evnTime() As String) As Long
Dim dout As DBLK, din As DBLK
Dim nevents As Long
Dim lStartStopArray(1) As Long
Dim events() As Long
Dim i%, p%, rc&, tmpTime As String * 32
Dim dev As NAME16
Dim namStartStopArray(1) As NAME16I

p% = InStr(pmDeviceServer$, "/")
If p% > 0 Then
  din.dArrayLength = 2: din.dFormat = CF_NAME16I
  BARR dev.nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  namStartStopArray(0).iVal = starttime&
  namStartStopArray(1).iVal = StopTime&
  BARR namStartStopArray(0).nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  pmDeviceServer$ = Left$(pmDeviceServer$, p% - 1)
Else
  lStartStopArray(0) = starttime&
  lStartStopArray(1) = StopTime&
  din.dArrayLength = 2: din.dFormat = CF_LONG
End If

devName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_LONG

If p% > 0 Then
  rc& = T_EXECLINK(devName, "NDEVEVENTS", dout, nevents, din, namStartStopArray(0), 1, 1000)
Else
  rc& = T_EXECLINK(devName, "NDEVEVENTS", dout, nevents, din, lStartStopArray(0), 1, 1000)
End If
If rc& Then GoTo GetPMDeviceEventListError

If nevents > 5000 Then
    MsgBox " Number of Events = " + str$(nevents) + "!!!! Only reading 5000."
    nevents = 5000
ElseIf nevents < 0 Then
    MsgBox " Number of Events = " + str$(nevents) + "!!!! Setting to ZERO!"
    nevents = 0
End If
If nevents = 0 Then GoTo GetPMDeviceEventListError
ReDim events(nevents - 1)

dout.dArrayLength = nevents: dout.dFormat = CF_LONG
If p% > 0 Then
  rc& = T_EXECLINK(devName, "DEVEVENTS", dout, events(0), din, namStartStopArray(0), 1, 1000)
Else
  rc& = T_EXECLINK(devName, "DEVEVENTS", dout, events(0), din, lStartStopArray(0), 1, 1000)
End If

If rc& Then GoTo GetPMDeviceEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = events(i%)
  CTIME tmpTime, events(i%)
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMDeviceEventListError:
GetPMDeviceEventList = IIf(rc&, -rc&, nevents)
End Function

' this is the NEW API with TimeOut as parameter
Function GetPMDeviceEventListWithTimeOut(ByVal pmDeviceServer$, ByVal starttime&, ByVal StopTime&, evnList() As Long, evnTime() As String, timeout&) As Long
Dim dout As DBLK, din As DBLK
Dim nevents As Long
Dim lStartStopArray(1) As Long
Dim events() As Long
Dim i%, p%, rc&, tmpTime As String * 32
Dim dev As NAME16
Dim namStartStopArray(1) As NAME16I

p% = InStr(pmDeviceServer$, "/")
If p% > 0 Then
  din.dArrayLength = 2: din.dFormat = CF_NAME16I
  BARR dev.nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  namStartStopArray(0).iVal = starttime&
  namStartStopArray(1).iVal = StopTime&
  BARR namStartStopArray(0).nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  pmDeviceServer$ = Left$(pmDeviceServer$, p% - 1)
Else
  lStartStopArray(0) = starttime&
  lStartStopArray(1) = StopTime&
  din.dArrayLength = 2: din.dFormat = CF_LONG
End If

devName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_LONG

If p% > 0 Then
  rc& = T_EXECLINK(devName, "NDEVEVENTS", dout, nevents, din, namStartStopArray(0), 1, timeout&)
Else
  rc& = T_EXECLINK(devName, "NDEVEVENTS", dout, nevents, din, lStartStopArray(0), 1, timeout&)
End If
If rc& Then GoTo GetPMDeviceEventListError

If nevents > 5000 Then
    MsgBox " Number of Events = " + str$(nevents) + "!!!! Only reading 5000."
    nevents = 5000
ElseIf nevents < 0 Then
    MsgBox " Number of Events = " + str$(nevents) + "!!!! Setting to ZERO!"
    nevents = 0
End If
If nevents = 0 Then GoTo GetPMDeviceEventListError
ReDim events(nevents - 1)

dout.dArrayLength = nevents: dout.dFormat = CF_LONG
If p% > 0 Then
  rc& = T_EXECLINK(devName, "DEVEVENTS", dout, events(0), din, namStartStopArray(0), 1, timeout&)
Else
  rc& = T_EXECLINK(devName, "DEVEVENTS", dout, events(0), din, lStartStopArray(0), 1, timeout&)
End If

If rc& Then GoTo GetPMDeviceEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = events(i%)
  CTIME tmpTime, events(i%)
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMDeviceEventListError:
GetPMDeviceEventListWithTimeOut = IIf(rc&, -rc&, nevents)
End Function


Function GetHistoryData(ByVal devName, ByVal devProperty As String, ByVal ArrayIndex, ByVal starttime As Long, ByVal StopTime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer)
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer, nread As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim legacySystem As Boolean
Dim arrayOffset As Integer

lStartStopArray(0) = starttime
lStartStopArray(1) = StopTime
lStartStopArray(2) = ArrayIndex

If npoints = 0 Then
  npts = StopTime - starttime ' won't be any worse than this
  If npts > 1000 Then npts = 1000
Else
  npts = npoints
End If
LaunchHistoryLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(devName, devProperty & ".HIST", dout, fiDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo HistoryError
'If (fiDataArray(0).iVal <= npts) Or (npts > 150) Then done = True
'npts = fiDataArray(0).iVal
nread = dout.dArrayLength
If (nread <= npts) Or (npts > 150) Then done = True
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts > 16000 Then npts = 16000
If Not done Then GoTo LaunchHistoryLink
If npts > 0 Then
  ReDim fDataArray(npts - 1)
  ReDim lTimeArray(npts - 1)
End If
For i = 0 To npts - 1
  fDataArray(i) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i) = fiDataArray(i + arrayOffset).iVal
Next
'npoints = npts - 1
npoints = npts
HistoryError:
GetHistoryData = rc&

End Function
Function GetHistoryDataTrace(ByVal devName, ByVal devProperty As String, ByVal ArrayIndex, ByVal targetTime As Long, fDataArray() As Single, npoints As Integer)
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer
Dim dout As DBLK, din As DBLK
Dim done As Boolean

lStartStopArray(0) = targetTime
lStartStopArray(1) = targetTime
lStartStopArray(2) = ArrayIndex

npts = npoints
LaunchHistoryTraceLink:
'ReDim fiDataArray(npts)
dout.dArrayLength = npts: dout.dFormat = CF_FLOAT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(devName, devProperty & ".HIST", dout, fDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo HistoryTraceError
npoints = dout.dArrayLength
HistoryTraceError:
GetHistoryDataTrace = rc&

End Function

Function GetArchivedDataEx(ByVal context As String, ByVal keyword As String, ByVal KeywordIndex As Integer, ByVal starttime As Long, ByVal StopTime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer, nread As Integer, nretry As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim ArchiveServer$
Dim legacySystem As Boolean
Dim arrayOffset As Integer

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
End Select

If MaxNumHistoryPoints = 0 Then MaxNumHistoryPoints = 5000

lStartStopArray(0) = starttime
lStartStopArray(1) = StopTime
lStartStopArray(2) = KeywordIndex

'npts = stoptime - StartTime ' won't be any worse than this
If npoints > 1 And npoints < MaxNumHistoryPoints Then
  npts = npoints
Else
  npts = MaxNumHistoryPoints - 1 ' start off at a reasonable number
End If

timout = 500

LaunchArchiveLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
If KeywordIndex > 0 Then din.dArrayLength = 3 Else din.dArrayLength = 2
din.dFormat = CF_LONG
'timout = iif(stoptime -starttime > 100000 ?
rc& = T_EXECLINK(ArchiveServer$, keyword, dout, fiDataArray(0), din, lStartStopArray(0), 1, timout)
If rc& = tine.link_not_open And nretry < 2 Then
  nretry = nretry + 1
  timout = timout + 2000
  GoTo LaunchArchiveLink
End If
If rc& Then GoTo ArchiveErrorEx

nread = dout.dArrayLength
If (nread <= npts) Then done = True
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts = 0 Then
    ReDim fDataArray(1)
    ReDim lTimeArray(1)
    GoTo ArchiveErrorEx
End If
If Not done Then GoTo LaunchArchiveLink
If (npoints > 1) And (npts < npoints) Then
    ReDim fDataArray(npoints - 1)
    ReDim lTimeArray(npoints - 1)
    Offset = npoints - npts - 1
Else
    ReDim fDataArray(npts - 1)
    ReDim lTimeArray(npts - 1)
    Offset = 0
    npoints = npts
End If
For i = 0 To npts - 1
  fDataArray(i + Offset) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i + Offset) = fiDataArray(i + arrayOffset).iVal
Next
ArchiveErrorEx:
GetArchivedDataEx = rc&
End Function

Function GetArchivedTraceData(ByVal context, ByVal keyword As String, ByVal targetTime As Long, fDataArray() As Single) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim dout As DBLK, din As DBLK
Dim ArchiveServer$

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
End Select

lStartStopArray(0) = targetTime
lStartStopArray(1) = targetTime
lStartStopArray(2) = 0

npts = UBound(fDataArray) - LBound(fDataArray)
If npts = 0 Then
  GetArchivedTraceData = 0
  Exit Function
End If
LaunchArchiveLink:
dout.dArrayLength = npts: dout.dFormat = CF_FLOAT
If KeywordIndex > 0 Then din.dArrayLength = 3 Else din.dArrayLength = 2
din.dFormat = CF_LONG
GetArchivedTraceData = T_EXECLINK(ArchiveServer$, keyword, dout, fDataArray(0), din, lStartStopArray(0), 1, 1000)
End Function


Function GetArchivedData(ByVal keyword As String, ByVal KeywordIndex As Integer, ByVal starttime As Long, ByVal StopTime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long, nread As Long
Dim rc&, i As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim legacySystem As Boolean
Dim arrayOffset As Integer

If gArchiveServer$ = "" Then gArchiveServer$ = "HISTORY"

lStartStopArray(0) = starttime
lStartStopArray(1) = StopTime
lStartStopArray(2) = KeywordIndex

npts = StopTime - starttime ' won't be any worse than this
npts = 150 ' start off at a reasonable number
LaunchArchiveLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = EXECLINKEx(gArchiveServer$, keyword, dout, fiDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo ArchiveError
nread = dout.dArrayLength
'If (fiDataArray(0).iVal <= npts) Or (npts > 150) Then done = True
If (nread <= npts) Or (npts > 150) Then done = True
'npts = fiDataArray(0).iVal
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset
If npts <= 0 Then GoTo ArchiveError
If npts > 16000 Then npts = 16000
If Not done Then GoTo LaunchArchiveLink
'ReDim fDataArray(npts - 1)
'ReDim lTimeArray(npts - 1)
ReDim fDataArray(npts)
ReDim lTimeArray(npts)
For i = 0 To npts - 1
  fDataArray(i) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i) = fiDataArray(i + arrayOffset).iVal
Next
npoints = npts
ArchiveError:
GetArchivedData = rc&
End Function
Function GetArchiveDataTrace(ByVal context As String, ByVal keyword As String, ByVal KeywordIndex As Integer, ByVal targetTime As Long, fDataArray() As Single, npoints As Integer)
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer
Dim dout As DBLK, din As DBLK
Dim done As Boolean
Dim ArchiveServer$

'Select Case context
'  Case "TTF": ArchiveServer$ = "TTFHISTORY"
'  Case "PETRA": ArchiveServer$ = "PEHISTORY"
'  Case "DESY", "DESY3", "DESY2": ArchiveServer$ = "D3HISTORY"
'  Case Else: ArchiveServer$ = "HISTORY"
'End Select

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
End Select


lStartStopArray(0) = targetTime
lStartStopArray(1) = targetTime
lStartStopArray(2) = KeywordIndex

npts = npoints
LaunchArchiveTraceLink:
'ReDim fiDataArray(npts)
dout.dArrayLength = npts: dout.dFormat = CF_FLOAT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(ArchiveServer$, keyword, dout, fDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetArchiveDataTraceError
npoints = npts
GetArchiveDataTraceError:
GetArchiveDataTrace = rc&

End Function

' this has been deprecated
Function RemovePMData(ByVal pmArchiveGroup$, ByVal evnTag$) As Integer
Dim devName$
Dim fn As NAME8
Dim dbout As DBLK, dbin As DBLK

If pmArchiveServer$ = "" Then
    pmArchiveServer$ = "APC"
End If

devName$ = pmArchiveServer$ & "/" + pmArchiveGroup$

dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
dbin.dArrayLength = 1
dbin.dFormat = CF_NAME8
BARR fn.nam(), evnTag$
RemovePMData = T_EXECLINK(devName$, "REMOVE", dbout, 0, dbin, fn.nam(0), CA_WRITE, 500)

End Function

' this is the NEW API
Function RemoveArchivedPMData(ByVal pmDeviceServer$, ByVal evnNumber&) As Integer
  RemoveArchivedPMData = RemovePMArchivedData(pmDeviceServer$, evnNumber&)
End Function

' this is the NEW API
Function RemovePMArchivedData(ByVal pmDeviceServer$, ByVal evnNumber&) As Integer
Dim devName$
Dim dout As DBLK, din As DBLK
Dim tmp&

devName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_LONG
din.dArrayLength = 1: din.dFormat = CF_LONG
  
RemovePMArchivedData = T_EXECLINK(devName, "REMOVE", dout, tmp, din, evnNumber&, CA_WRITE, 1000)

End Function
' this is the NEW API
Function RemovePMArchivedDataBlock(ByVal pmDeviceServer$, ByVal evnNumberStart&, ByVal evnNumberStop&) As Integer
Dim devName$
Dim dout As DBLK, din As DBLK
Dim tmpIN&(1), tmpOUT&(1)

devName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 2: dout.dFormat = CF_LONG
din.dArrayLength = 2: din.dFormat = CF_LONG
tmpIN&(0) = evnNumberStart&
tmpIN&(1) = evnNumberStop&

RemovePMArchivedDataBlock = T_EXECLINK(devName, "REMOVE", dout, tmpOUT&(0), din, tmpIN&(0), CA_WRITE, 1000)

End Function
' this is the NEW API
Function SetPMArchivedComment(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal Comment$) As Integer
Dim devName$
Dim dout As DBLK, din As DBLK
Dim cmtstr$, cmtbarr() As Byte

devName$ = EventArchiveServer$ + "/" + pmDeviceServer$
cmtstr$ = "[" + Trim$(str$(evnNumber&)) + "]" + Comment$ + Chr(0)
ReDim cmtbarr(Len(cmtstr$))
BARR cmtbarr, cmtstr$
dout.dArrayLength = 0: dout.dFormat = CF_NULL
din.dArrayLength = Len(cmtstr$): din.dFormat = CF_TEXT
  
SetPMArchivedComment = T_EXECLINK(devName, "ANNOTATE", dout, 0, din, cmtbarr(0), CA_WRITE, 1000)

End Function


Function SendPMTrigger(subsys As String, cmt As String) As Integer
Dim devName$, tmpStorageServer$, tmpSubSystem$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim triggerlevel%, pmtime&
' Input data (to send):
dbin.dArrayLength = 1
dbin.dFormat = CF_SHORT
triggerlevel% = 1 ' later user -1 to indicate a more critical trigger
' Output data (to receive):
dbout.dArrayLength = 1
dbout.dFormat = CF_LONG

' sub system to receive the trigger
p% = InStr(subsys$, "/")
If p% = 0 Then
    ' Assume that it's a HERA Subsystem....
    devName$ = "STORAGE/" + subsys 'LCase(subsys)
Else
    tmpStorageServer$ = Left$(subsys, p% - 1)
    tmpSubSystem$ = Right$(subsys, Len(subsys) - p%)
    devName$ = tmpStorageServer$ + "/" + tmpSubSystem$ 'LCase(tmpSubSystem$)
End If

rc% = T_EXECLINK(devName$, "TRIGGER", dbout, pmtime&, dbin, triggerlevel%, CA_WRITE, 500)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
' now send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(str$(pmtime&))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
BARR rpccmt.text(), cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = T_EXECLINK(devName$, "ANNOTATE", dbout, 0, dbin, rpccmt.text(0), CA_WRITE, 500)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
SendPMTrigger = 0
End Function

Function SendPMComment(subsys As String, pmtime As Long, cmt As String) As Integer
Dim devName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string

' sub system to receive the trigger
p% = InStr(subsys$, "/")
If p% = 0 Then
    ' Assume that it's a HERA Subsystem....
    devName$ = "STORAGE/" + LCase(subsys)
Else
    tmpStorageServer$ = Left$(subsys, p% - 1)
    tmpSubSystem$ = Right$(subsys, Len(subsys) - p%)
    devName$ = tmpStorageServer$ + "/" + tmpSubSystem$
End If
'devName$ = "STORAGE/" + LCase(subsys)

' send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(str$(pmtime))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
BARR rpccmt.text(), cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = T_EXECLINK(devName$, "ANNOTATE", dbout, 0, dbin, rpccmt.text(0), CA_WRITE, 500)
If rc% Then
  SendPMComment = rc%
  Exit Function
End If
SendPMComment = 0
End Function

Function GetPMComment(subsys As String, pmtime As Long, cmt As String) As Integer
Dim devName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string

' sub system to receive the trigger
p% = InStr(subsys$, "/")
If p% = 0 Then
    ' Assume that it's a HERA Subsystem....
    devName$ = "STORAGE/" + LCase(subsys)
Else
    tmpStorageServer$ = Left$(subsys, p% - 1)
    tmpSubSystem$ = Right$(subsys, Len(subsys) - p%)
    devName$ = tmpStorageServer$ + "/" + tmpSubSystem$ 'LCase(tmpSubSystem$)
End If

'devName$ = "STORAGE/" + LCase(subsys)
dbin.dArrayLength = 1
dbin.dFormat = CF_LONG
' Output data (to receive): NONE
dbout.dArrayLength = 256
dbout.dFormat = CF_TEXT
rc% = T_EXECLINK(devName$, "COMMENT", dbout, rpccmt.text(0), dbin, pmtime, CA_READ, 1000)
If rc% Then
  GetPMComment = rc%
  Exit Function
End If
cmt = BSTR(rpccmt.text())
GetPMComment = 0
End Function

' a call to set context sets the default search context at the archive server
' if a device server is not found in the selected context, the entire context list is
' scanned until a match is found
' note that the default context can be changed by somebody else at any time !!!!
Function SetPMContext(subsys As String) As Integer
Dim devName$
Dim dbin As DBLK, dbout As DBLK
Dim dummy As Long

'devName$ = "STORAGE/" + LCase(subsys)
devName$ = EventStorageServer$ + "/" + subsys 'LCase(subsys)

dbin.dArrayLength = 1
dbin.dFormat = CF_LONG
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = T_EXECLINK(devName$, "SELECT", dbout, 0, dbin, dummy, CA_READ, 500)
If rc% Then
  SetPMContext = rc%
  Exit Function
End If
SetPMContext = 0
End Function

' this is the NEW API
Function GetPMArchivedTimeSliceData(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal devName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant, TimeBuffer() As Long)
Static pmDevSrv As String
Dim dout As DBLK, din As DBLK
Dim ab As ADRB, abx As ADRBX
Dim rc&, p%, i%, dContext$, dServerName$, dName$, dIndex&, evn As NAME8, pmServerContext$
Dim pass%, vtype As Integer, isArray As Boolean
Dim ld() As LNGINT, fd() As FLTINT, dd() As DBLINT
Dim ds() As Byte
Static done As Boolean

If Not done Then
  FILLSTRUCT "ADRB", Len(ab), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

rc& = 0
If Left$(devName$, 1) = "/" Then
  p% = InStr(Right$(devName$, Len(devName$) - 1), "/")
  dContext$ = Mid$(devName$, 2, p%)
  devName$ = Right$(devName$, Len(devName$) - p% - 1)
End If
p% = InStr(devName$, "/") '  z.B. L2TRCrf/#0
If p% = 0 Then
    dServerName$ = devName$
    dName$ = "#0"
Else
    dServerName$ = Left$(devName$, p% - 1)
    dName$ = Right$(devName$, Len(devName$) - p%)
End If
p% = InStr(dName$, "[") ' z.B. ALL_DATA[3]
If p% = 0 Then
  dIndex& = 0
Else
  dIndex& = Val(Right$(dName$, Len(dName$) - p%))
  dName$ = Left$(dName$, p% - 1)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If
'pmServerContext$ = EventArchiveServer$

retryGetPMTimeSliceData:
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.StopTime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
Else
    BARR ab.deviceServerName(), dServerName$
    BARR ab.deviceName(), dName$
    BARR ab.deviceProperty(), devProperty$
    ab.eventNumber = evnNumber&
    ab.starttime = evnNumber&
    ab.StopTime = evnNumber&
    
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
End If
pass% = pass% + 1
If VarType(DataBuffer) > vbArray Then
  If UBound(TimeBuffer) - LBound(TimeBuffer) < npoints - 1 Then
    rc& = tine.dimension_error
    GoTo GetPMArchivedTimeSliceDataError
  End If
  If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
    rc& = tine.dimension_error
    GoTo GetPMArchivedTimeSliceDataError
  End If
  vtype = VarType(DataBuffer) - vbArray
  isArray = True
Else
  rc& = tine.illegal_format
  GoTo GetPMArchivedTimeSliceDataError
End If

dout.dArrayLength = npoints
Select Case vtype
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LNGINT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMTimeSliceData
       For i% = 0 To npoints - 1
         DataBuffer(i%) = ld(i%).lval
         TimeBuffer(i%) = ld(i%).iVal
       Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLTINT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMTimeSliceData
       For i% = 0 To npoints - 1
         DataBuffer(i%) = fd(i%).fval
         TimeBuffer(i%) = fd(i%).iVal
         If TimeBuffer(i%) > 1 Then Debug.Print "fval : ", fd(i%).fval, "ival : ", fd(i%).iVal, ASCTIME(fd(i%).iVal)
       Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DBLINT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMTimeSliceData
       For i% = 0 To npoints - 1
         DataBuffer(i%) = dd(i%).dval
         TimeBuffer(i%) = dd(i%).iVal
       Next
  Case Else:
       rc& = tine.illegal_format
End Select
If rc& Then GoTo GetPMArchivedTimeSliceDataError

GetPMArchivedTimeSliceDataError:
GetPMArchivedTimeSliceData = rc&
End Function

