Attribute VB_Name = "modPrintText"
'**********************************************************************
'*.H   PR.BAS|3|12/14/95|PR.BAS|MKI Visual Basic Docs
'*
'*.S   NAME
'*      PR.BAS - Ausdrucken von Forms und Controls in Visual Basic
'*.S   VERSION
'*      VB3, Windoze 3.1
'*.S   ZWECK
'*      PR.BAS stellt Routinen zum Ausdrucken von formatiertem Text
'*           und von Fenstern bereit.
'*
'*.S   VERSION
'*      003
'*
'*.S   AUTOR
'*      J.Wilgen, MKI-3  (jwlg@mail.desy.de)
'*
'*
'*.S   EXPORTIERTE FUNKTIONEN:
'*
'*
'*.s      A. Routinen zum Textausdruck
'*
'*.t        \r{prInit}         --   Modul pr.bas initialisieren
'*          \r{prPrintLine}    --   Zeile ausdrucken, neue Zeile, ggf. neue Seite
'*          \r{prPrinttab}     --   Text an vorgegebener Spaltenposition ausdrucken
'*          \r{prPrintTxt}     --   Text an aktueller X-Y-Position ausdrucken
'*          \r{prSetXY}        --   X-Y-Position festlegen
'*          \r{prSetMargins}   --   Seitenrnder festlegen
'*          \r{prClose}        --   Dokument abschicken
'*          \r{prNewLine}      --   Neue Zeile, ggf. neue Seite
'*          \r{prSetPageHdr}   --   Seitennumerierung ein/aus
'*          \r{prSetHdrTxt}    --   Kopftext
'*          \r{prSetPageNr}    --   Seitennr einstellen
'*          \r{prPrintHdr}     --   Kopfzeile ausdrucken
'*          \r{prPrintBuffer}  --   Stringbuffer in Zeilen zerlegen und ausdrucken
'*          \r{prGetWidth}     --   Seitenbreite ausgeben
'*          \r{prGetHeight}    --   Seitenhhe ausgeben
'*          \r{prSetLineHeight}  -- Zeilenhhe einstellen
'*          \r{prSetFont}      --   Font einstellen
'*
'*.s      B. Routinen zum Ausdruck von Objekten und Fenstern
'*
'*.t          \r{prPrintControl} --   VisualBasic-Objekt ausdrucken
'*          \r{prPrintForm}    --   VisualBasic-Form ausdrucken
'*          \r{prPrintScreen}  --   Bildschirm ausdrucken
'*          \r{prSetAlignment}  --  Ausrichtung einstellen
'*          \r{prSetPageLayout} --  Seitenrnder einstellen
'*          \r{prPrintWindow}  --   Windows-Fenster ausdrucken
'*
'*
'*.S    BESCHREIBUNG:
'*
'*.s    A. Routinen zum Textausdruck.
'*
'*      Die Funktion prInit mu vor dem Aufruf irgendeiner der anderen
'*      Textfunktionen mindestens einmal aufgerufen werden. Sie setzt Schrifthhe,
'*      Schriftbreite und Seitenrnder auf vordefinierte Werte. Mehrfaches
'*      Aufrufen dieser Funktion schadet nicht (entspricht einem Reset).
'*
'*.P    Am Ende eines Dokumentes mu die
'*      Funktion prClose aufgerufen werden, die den Job beendet und an
'*      den Drucker abschickt.
'*
'*.P    Alle (X,Y)-Koordinatenangaben haben die Einheit (Zeilen, Spalten).
'*      Die Breite eines Zeichens wird bei Proportionalschrift als Breite
'*      des Buchstabens "W" angenommen. Die Hhe einer
'*      Zeile ist standardmig auf 1.5 * Zeichenhhe eingestellt, kann
'*      aber variiert werden. Der Ursprung liegt in der linken oberen Ecke
'*      und hat die Koordinaten (0,0).
'*
'*.s    B. Routinen zur Ausgabe von Forms und Controls
'*.i
'*      --  Die Funktionen fr Text- und Graphikausgabe sollten nicht
'*                      miteinander vermischt werden!
'*
'*              --  Bei den Graphikroutinen ist keine Initialisierung o.. ntig.
'*
'*      --  Die Funktion \r{prPrintForm} druckt eine Form in maximaler Gre (abhngig
'*          von der Druckereinstellung) aus.
'*
'*      --  Die Funktion \r{prPrintControl} enthlt zustzlich die Mglichkeit,
'*          den Ausdruck zu verkleinern.
'*
'*      --  Die Funktion \r{prPrintScreen} druckt den gesamten Bildschirm in
'*          maximaler Gre aus.
'*
'*      --  Mit prSetPageLayout und \r{prSetAlignment} lassen sich Seitenrnder und
'*              Ausrichtung festlegen.
'*
'*
'*.s    C. Extras: Ausdrucken von Seitennummern und Kopfzeilen bei Textfunktionen
'*
'*      In der Standardeinstellung werden keine Seitennummern
'*      oder Kopfzeilen ausgedruckt. Seitennummern erscheinen nur dann,
'*      wenn die Option "Kopfzeile drucken" mit
'*
'*.c            prSetPageHdr True
'*
'*.P    gesetzt wird. Die Seitennummer erscheint dann in der rechten oberen Ecke.
'*      Der Kopfzeilentext wird gesetzt mit
'*.c
'*          prSetHdrTxt "Dies ist mein Text"
'*
'*.P    Die Seitennummer wird gesetzt mit
'*.c
'*          prSetPageNr 123
'*
'*.P    und bei jeder neuen Seite automatisch erhht.
'*
'*.P    Beim Aufruf der Funktion prInit werden alle Einstellungen
'*      wieder auf die Standardeinstellung zurckgesetzt:
'*
'*.i            -- Keine Kopfzeilen
'*              -- Seitennummer := 1
'*              -- Kopftext := ""
'*
'*.P    Auf der ersten Seite nach einem prInit-Aufruf erscheint
'*      grundstzlich keine Kopfzeile. Wer dies trotzdem will, ruft
'*      nach dem Einstellen des Kopftextes und vor dem ersten Druckbefehl
'*      die Funktion
'*.c
'*          prPrintHeader
'*
'*.P    auf. Beispiel:
'*.c
'*          '// Drucken mit Kopfzeile, auch auf der Titelseite,
'*          '// beginnend mit Seite 1 (Standardeinstellung)
'*
'*          prInit
'*          prSetHeaderTxt = "Das groe Buch"
'*          prSetPageHdr True
'*
'*          prPrintHeader           '// auch auf erster Seite ein Kopf
'*
'*          ... weitere Druckbefehle ...
'*
'*          prClose
'*
'*
'*.s    D. Systeme mit mehreren Druckern
'*
'*      Alle Funktionen aus pr.bas benutzen immer den Default-Printer.
'*      VisualBasic oder Windows bieten leider keine zufriedenstellenden
'*      Mglichkeiten zur nicht-interaktiven Einstellung des
'*      Default-Printers an. Die empfohlene Vorgehensweise ist
'*      daher, vor dem Ausdrucken eine Printer-Setup-Dialogbox
'*      anzuzeigen, wie man es ja auch von kommerziellen Windows-Programmen
'*      kennt. Beispiel:
'*.c
'*      '### mnuprn:    Menu-Item, z.B mit der Aufschrift "Print..."
'*      '### cmdialog1: Common-Dialog-VBX
'*
'*      sub mnuprn_click()
'*
'*      dim rc as integer
'*
'*      On Error GoTo mnuprn_click_x
'*      cmdialog1.CancelError = True        '// Bei "Cancel" geht's zum Errorlabel
'*      cmdialog1.Flags = &H40&             '// Nur das Setup-Fenster anzeigen
'*      cmdialog1.PrinterDefault = True     '// Alle Benutzer-Einstellungen
'*      '// auf den Default-Printer
'*                                                      '// bertragen, sonst unwirksam.
'*
'*      cmdialog1.Action = 5                '// Printer-Dialogbox starten
'*
'*      '// ---- Hier Print-Routinen einfgen ----
'*      '//   ...
'*      '// z.B. prPrintForm(form1)
'*      '//   ...
'*      '//   ...
'*      '// --------------------------------------
'*
'*      mnuprn_click_x:                        '// Errorlabel, "Cancel"
'*
'*      Exit Sub                            '// ersetzt das resume-statement
'*
'*      end sub
'*
'*
'*.P    Besser wre es natrlich, den Aufruf der Dialogbox in  eine Funktion
'*      z.B. in der Art
'*.c
'*           function ShowPrnDlg(dbx as dialogbox ) as integer
'*
'*.P    mit Rckgabewerten true=OK/false=Cancel zu verpacken.
'*      Eine solche Funktion ist in diesem Modul  n i c h t  implementiert und auch
'*      nicht geplant, weil pr.bas dann ohne geladenes Dialogbox-VBX nicht mehr
'*      funktionieren wrde. Bei Bedarf wrde der Autor ein Ergnzungsmodul
'*      "prndlg.bas" bauen.
'*
'*.P    ACHTUNG: Dialogboxen sind applikationsmodal. Auf Probleme mit
'*      IPX/SPX sollte man dabei gefat sein.
'*
'*
'*
'*.S    ANWENDUNGSBEISPIELE:
'*
'*.s    A. Text zeilenweise ausdrucken
'*.c
'*      prInit
'*
'*      prPrintLine "Zeile 1"
'*      prPrintLine "Zeile 2"
'*              ...
'*      prClose
'*
'*.s    B. Tabellen ausdrucken
'*.c
'*      prInit
'*
'*      prPrintTab 0, "Zeile"
'*
'*      for k = 1 to SPALTEN
'*           prPrintTab (10 + 15 * (k-1)), "Spalte " & format$(k)
'*      next k
'*
'*      for i = 1 to ZEILEN
'*           prPrintTab format$(i)
'*           for k = 1 to SPALTEN
'*               prPrintTab (10 + 15 * (k-1)), wert(i,k)
'*           next k
'*           rc = prNewLine()
'*      next i
'*
'*.s    C. Forms ausdrucken
'*.c
'*      rc = prPrintForm (form1)
'*
'*.s    D. Controls ausdrucken
'*.c
'*      rc = prPrintControl(picture1, 0.5)
'*
'*.s    E. Text aus Textbuffer ausdrucken, z.B. Inhalt einer Textbox
'*.c
'*      prInit
'*      rc = prPrintBuffer(text1.text)
'*      prClose
'*
'*.s    F. Text kreuz und quer ber eine Seite verstreuen (sehr praxisnah...)
'*.c
'*      prInit
'*
'*      breite = len("Text XX")
'*      spalten = prGetWidth() - breite
'*      zeilen = prGetHeight() - 1
'*
'*      for i = 1 to 100
'*          x = cint(cdbl(breite) * rnd)
'*          y = cint(cdbl(zeilen) * rnd)
'*          prSetXY x,y
'*          prPrintTxt "Text " & format(i)
'*      next i
'*
'*      prClose
'*
'*.S  BUGS:
'*
'*.s    1. Das Ausdrucken von VB-Objekten funktioniert meistens, aber nicht immer.
'*
'*      Falls eine der Funktionen prPrintForm oder prPrintControl nicht funktionieren
'*      sollte, wird folgendes Vorgehen empfohlen:
'*
'*.e    1. Windows beenden und neu starten
'*      2. Falls es noch immer nicht geht,
'*         Program Manager -> Control Panel -> Printers -> Setup anwhlen,
'*         "Orientation" verndern, abspeichern.
'*         Dann dasselbe noch einmal wiederholen, um die
'*         alte Orientierung wieder einzustellen.
'*          3. Falls es noch immer nicht geht, goto 1...
'*
'*.P    Die Ursache dieser gelegentlichen Windows-Instabilitt ist unbekannt.
'*      Es knnte ein Fehler im Druckertreiber oder in den
'*      Windows-API-Funktionen sein.
'*
'*.s    2. VB-Fehler werden nicht richtig abgefangen.
'*
'*.P    Das Verhalten der Print-Funktionen (und aller anderen) von VisualBasic
'*      im Fehlerfall, wie z.B. bei zu langen Zeilen oder ungltigen Koordinaten, ist nicht
'*      dokumentiert. VB-Laufzeitfehler werden darum einfach ignoriert, egal was passiert.
'*
'*.S    QUELLEN:
'*.i
'*      -- Microsoft Knowledge Base
'*      -- VB-Handbcher
'*      -- Stefan Wilke's "primod1.bas"
'*
'***********************************************************************
Option Explicit

'//
'//     Fehlerkonstanten
'//

Global Const PR_DONE = 0           '// Alles OK
Global Const PR_ERR = -1           '// Irgendein Fehler
Global Const PR_NP = 5             '// Neue Seite
Global Const PR_PRNERR = -2        '// Drucker nicht bereit
Global Const PR_NOOBJ = -3         '// Kein Objekt angewhlt


'//  Konstanten fr die Seitenausrichtung
Global Const PR_ALIGNCENTER = 0
Global Const PR_ALIGNLEFT = 1
Global Const PR_ALIGNRIGHT = 2
Global Const PR_ALIGNTOP = 3
Global Const PR_ALIGNBOTTOM = 4


Const default_margin = 100          '// Rand in Pixels


'//
'// Modul-interne Daten
'//

Dim pr_left As Single               '// linker Seitenrand
Dim pr_right As Single              '// rechter Seitenrand
Dim pr_top As Single                '// oberer Seitenrand
Dim pr_bottom As Single             '// unterer Seitenrand
Dim pr_dx As Single                 '// Zeichenbreite
Dim pr_dy As Single                 '// Zeilenhhe
Dim pr_curx As Single               '// momentane x-Position
Dim pr_cury As Single               '// momentane y-Position
Dim pr_printhdr As Integer          '// Kopfzeile ausdrucken?
Dim pr_pagenr As Integer            '// Seitennummer
Dim pr_hdrtxt As String             '// Kopftext


'// Benutzerdefiniertes Seitenlayout bei Form-oder Control-Ausgabe
Dim pr_usrlayout As Integer         '// User-Layout benutzen?
Dim pr_usrt As Double               '// Oberer Rand
Dim pr_usrb As Double               '// Unterer Rand
Dim pr_usrl As Double               '// Linker Rand
Dim pr_usrr As Double               '// Rechter Rand


'// Automatische Ausrichtung
Dim pr_halign As Integer              '// horizontal
Dim pr_valign As Integer              '// vertikal


'//
'//     Datentypen fr Windows-API-Funktionen
'//

Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type


Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As String * 1024 ' Array length is arbitrary; may be changed
End Type


Type RECT
    Left As Integer
    Top As Integer
    Right As Integer
    Bottom As Integer
End Type


Type pointapi
    x As Integer
    Y As Integer
End Type


'//
'//     Externals
'//


' DC related API
Declare Function prCreateCompatibleDC Lib "GDI" Alias "CreateCompatibleDC" (ByVal hdc As Integer) As Integer
Declare Function prGetWindowDC Lib "user" Alias "GetWindowDC" (ByVal hWnd As Integer) As Integer
Declare Function prGetDC Lib "user" Alias "GetDc" (ByVal hWnd As Integer) As Integer
Declare Function prReleaseDC Lib "user" Alias "ReleaseDC" (ByVal hWnd As Integer, ByVal hdc As Integer) As Integer
Declare Function prDeleteDC Lib "GDI" Alias "DeleteDC" (ByVal hdc As Integer) As Integer


' Graphics related API
Declare Function prGetDIBits Lib "GDI" Alias "GetDIBits" (ByVal aHDC As Integer, ByVal hBitmap As Integer, ByVal nStartScan As Integer, ByVal nNumScans As Integer, ByVal lpbits As Long, lpBI As BITMAPINFO, ByVal wUsage As Integer) As Integer
Declare Function prBitBlt Lib "GDI" Alias "BitBlt" (ByVal hDestDC As Integer, ByVal x As Integer, ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long) As Integer
Declare Function prStretchDIBits Lib "GDI" Alias "StretchDIBits" (ByVal hdc As Integer, ByVal x As Integer, ByVal Y As Integer, ByVal dx As Integer, ByVal dy As Integer, ByVal SrcX As Integer, ByVal SrcY As Integer, ByVal wSrcWidth As Integer, ByVal wSrcHeight As Integer, ByVal lpbits As Long, lpBitsInfo As BITMAPINFO, ByVal wUsage As Integer, ByVal dwRop As Long) As Integer


' General attribute related API
Declare Function prGetDeviceCaps Lib "GDI" Alias "GetDeviceCaps" (ByVal hdc As Integer, ByVal nIndex As Integer) As Integer
Declare Sub prGetWindowRect Lib "user" Alias "GetWindowRect" (ByVal hWnd As Integer, lpRect As RECT)
Declare Sub prGetClientRect Lib "user" Alias "GetClientRect" (ByVal hWnd As Integer, lpRect As RECT)
Declare Function prGetDesktopWindow Lib "user" Alias "GetDesktopWindow" () As Integer

' Memory allocation related API
Declare Function prGlobalAlloc Lib "Kernel" Alias "GlobalAlloc" (ByVal wFlags As Integer, ByVal dwBytes As Long) As Integer
Declare Function prGlobalLock Lib "Kernel" Alias "GlobalLock" (ByVal hmem As Integer) As Long
Declare Function prGlobalUnlock Lib "Kernel" Alias "GlobalUnlock" (ByVal hmem As Integer) As Integer
Declare Function prGlobalFree Lib "Kernel" Alias "GlobalFree" (ByVal hmem As Integer) As Integer


' Graphics object related API
Declare Function prCreateCompatibleBitmap Lib "GDI" Alias "CreateCompatibleBitmap" (ByVal hdc As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer) As Integer
Declare Function prDeleteObject Lib "GDI" Alias "DeleteObject" (ByVal hObject As Integer) As Integer
Declare Function prSelectObject Lib "GDI" Alias "SelectObject" (ByVal hdc As Integer, ByVal hObject As Integer) As Integer
Declare Sub prClientToScreen Lib "user" Alias "ClientToScreen" (ByVal hWnd As Integer, lpPoint As pointapi)

Const HORZRES = 8
Const VERTRES = 10

Const SRCCOPY = &HCC0020
Const NEWFRAME = 1
Const BITSPIXEL = 12
Const PLANES = 14

Const BI_RGB = 0
Const BI_RLE8 = 1
Const BI_RLE4 = 2

Const DIB_PAL_COLORS = 1
Const DIB_RGB_COLORS = 0


Const GMEM_MOVEABLE = 2
'***************************************
'*.C Liste der Funktionen
'***************************************

'*****************************************************************************
'*
'*.S    prClip
'*
'*      Begrenzen eines Wertes auf Minimal-und Maximalwert
'*
'*.s    Eingabeparameter:
'*
'*.p        v as double   --    Wert
'*          vmin as double  --  Untere Grenze
'*          vmax as double  --  Obere Grenze
'*
'*.s    Ausgabeparameter:
'*
'*.p        v as double  --       geclippter Wert
'*
'*.s    Rckgabe:
'*
'*.t        TRUE   --     Wert wurde gendert
'*          FALSE  --     Wert passte ins Intervall
'*
'*.s    Syntax
'*.f    Private Function prClip (v As Double, vmin As Double, vmax As Double)
'*****************************************************************************
Private Function prClip(v As Double, vmin As Double, vmax As Double)

    Dim rv As Integer       '// return value

    If v > vmax Then
        v = vmax
        rv = True
    ElseIf v < vmin Then
        v = vmin
        rv = True
    Else
        rv = False
    End If

    prClip = rv

End Function

'**********************************************************************
'*
'*.S    prClose
'*
'*      Druckauftrag beenden
'*
'***********************************************************************
Sub prClose()
    On Error Resume Next
    Printer.EndDoc
End Sub

'**********************************************************************
'*
'*.S    prErrorTxt
'*
'*      Ausgabe eines Fehlertextes zu einer Fehlerkonstanten
'*
'*.s    Eingabeparameter:
'*
'*.p        rc as integer       errorcode
'*
'*.s    Rueckgabetyp:
'*          string
'*
'*.s    Rueckgabe:
'*.s        Fehlertext
'*
'***********************************************************************
Function prErrorTxt(rc As Integer) As String

    Dim rt As String

    On Error Resume Next

    Select Case rc
    Case PR_DONE:
            rt = "Bitte Ausdruck abholen"
    Case PR_ERR:
            rt = "Fehler beim Ausdrucken!"
    Case PR_PRNERR:
            rt = "Drucker nicht bereit!"
    Case PR_NOOBJ:
            rt = "Kein Objekt angewhlt!"
    Case Else
        rt = Error(rc)
    End Select

    prErrorTxt = rt

End Function

'**********************************************************************
'*
'*.S    prGetHeight
'*
'*      Ausgabe der Seitenhhe in Zeilen
'*
'*.s    Rckgabetyp:
'*          integer
'*
'*.s    Rckgabe:
'*          Seitenhhe in Zeilen. Rnder werden bercksichtigt.
'*
'***********************************************************************
Function prGetHeight() As Integer
    On Error Resume Next
    prGetHeight = CInt((pr_bottom - pr_top) / pr_dy) + 1
End Function

'*****************************************************************************
'*
'*.S    prGetLayout
'*
'*      Drucker-Seitenlayout aus Benutzervorgaben berechnen
'*
'*.s    Ausgabeparameter:
'*.p
'*          destx as integer       -- linker Rand in Pixels
'*          desty as integer       -- oberer Rand in Pixels
'*          destwidth as integer   -- Breite in Pixels
'*          destheight as integer  -- Hhe in Pixels
'*
'*.s    Beschreibung:
'*      Nur zum Modul-internen Gebrauch.
'*
'*****************************************************************************
Sub prGetLayout(destx As Integer, desty As Integer, destwidth As Integer, destheight As Integer)

    Dim PrnWidth As Single
    Dim PrnHeight As Single

    Printer.ScaleMode = 3

    PrnWidth = CSng(Printer.ScaleWidth)
    PrnHeight = CSng(Printer.ScaleHeight)

    If pr_usrlayout Then
        destx = CInt(PrnWidth * pr_usrl)
        desty = CInt(PrnHeight * pr_usrt)
        destwidth = CInt(PrnWidth * (1# - pr_usrr - pr_usrl))
        destheight = CInt(PrnHeight * (1# - pr_usrt - pr_usrb))
    Else
        destx = default_margin
        desty = default_margin
        destwidth = PrnWidth - 2 * destx
        destheight = PrnHeight - 2 * desty
    End If

End Sub

'**********************************************************************
'*
'*.S    prGetWidth
'*
'*      Ausgabe der Seitenbreite in Zeichen
'*
'*.s    Rueckgabetyp
'*          integer
'*
'*.s    Rueckgabe
'*          Seitenbreite in Zeichen. Der Rand wird bercksichtigt.
'*
'***********************************************************************
Function prGetWidth() As Integer
    On Error Resume Next
    prGetWidth = CInt((pr_right - pr_left) / pr_dx)
End Function

'**********************************************************************
'*
'*.S    prInit
'*
'*      Initialisierung von pr.bas
'*      Seitenrnder auf Standardwerte setzen
'*
'*.s    Rckgabetyp
'*          integer
'*
'*.s   Rckgabe:
'*          VB-err()-Wert
'*
'***********************************************************************
Sub prInit()

    On Error Resume Next

    '// ScaleMode   m u s s   auf twips stehen!
    Printer.ScaleMode = 2
    prSetFont "Courier New", 10, False, False
    prSetPageNr 1
    prSetPageHdr False
    prSetHdrTxt ""
    prSetMargins 0.15, 0.1, 0.05, 0.08
    pr_curx = pr_left
    pr_cury = pr_top

End Sub

'**********************************************************************
'*
'*.S    prNewLine
'*      Zeilenvorschub
'*
'*.s    Beschreibung:
'*      Seitenvorschub automatisch, wenn die neue Zeile nicht
'*      mehr auf die Seite passt.
'*
'*.s    Rckgabetyp
'*         integer
'*
'*.s    Rckgabe:
'*.t        PR_DONE  --    Alles klar
'*          PR_NP    --    Neue Seite angefangen
'*
'***********************************************************************
Function prNewLine() As Integer

    Dim rc As Integer

    On Error Resume Next

    If ((pr_cury + pr_dy) >= pr_bottom) Then
        prNewPage
        rc = PR_NP
    Else
        pr_curx = pr_left
        pr_cury = pr_cury + pr_dy
        rc = PR_DONE
    End If

    prNewLine = rc

End Function

'**********************************************************************
'*
'*.S    prNewPage
'*      Seitenvorschub
'*
'***********************************************************************
Sub prNewPage()

    On Error Resume Next

    pr_pagenr = pr_pagenr + 1
    Printer.NewPage
    If pr_printhdr Then prPrintHeader
    pr_curx = pr_left
    pr_cury = pr_top

End Sub

'**********************************************************************
'*
'*.S    prPrintBuffer
'*
'*          Text-Buffer in Zeilen zerlegen und zeilenweise ausgeben
'*
'*.s    Eingabeparameter:
'*.p
'*      txt as string  --   auszugebender Text
'*
'*.s    Beschreibung:
'*
'*          Als Zeilenumbruch werden Linefeed und CR-LF-Paare (DOS) akzeptiert.
'*          Die Zeilenlnge wird nicht beschnitten.
'*
'***********************************************************************
Sub prPrintBuffer(ByVal txt As String)

    Dim startpos As Integer
    Dim pos As Integer
    Dim cr As String
    Dim lf As String
    Dim txtLine As String
    Dim length As Long

    On Error Resume Next

    cr = Chr$(13)
    lf = Chr$(10)

    startpos = 1
    pos = startpos
    length = Len(txt)
    If length = 0 Then Exit Sub

    While pos <> 0

        pos = InStr(startpos, txt, lf)

        If pos <> 0 Then        '// Linefeed gefunden

            '// CR-LF-Paar (DOS-Text) oder nur LF (Non-DOS)?
            If Mid$(txt, pos - 1, 1) = cr Then
                txtLine = Mid$(txt, startpos, pos - startpos - 1)
            Else
                txtLine = Mid$(txt, startpos, pos - startpos)
            End If
            startpos = pos + 1

        Else        '// Letzte Zeile

           txtLine = Mid$(txt, startpos, length - startpos + 1)

        End If

        prPrintLine (txtLine)

    Wend

End Sub

'**********************************************************************
'*
'*.S    prPrintControl
'*
'*      Ausdrucken eines VB-Controls.
'*
'*.s          FUNKTIONIERT NICHT MIT ALLEN CONTROLS !
'**********************************************************************
'*
'*.S    prPrintHeader
'*
'*      Kopfzeile ausdrucken
'*
'*.s    Beschreibung:
'*      Kann auch verwendet werden, um auf der Titelseite
'*      eine Kopfzeile auszudrucken, was normalerweise nicht geschieht.
'*
'***********************************************************************
Sub prPrintHeader()

    Dim pagetxt As String
    Dim Y As Single

    On Error Resume Next

    pagetxt = Format$(pr_pagenr)

    Printer.CurrentX = pr_left
    Printer.CurrentY = Printer.ScaleTop
    Printer.Print pr_hdrtxt
    Printer.CurrentX = pr_right - Printer.TextWidth(pagetxt)
    Printer.CurrentY = Printer.ScaleTop
    Printer.Print pagetxt

    Y = Printer.ScaleTop + Printer.TextHeight("W")

    Printer.Line (pr_left, Y)-(pr_right, Y)

End Sub

'**********************************************************************
'*
'*.S    prPrintLine
'*
'*      Zeile ausdrucken, Zeilenvorschub, ggf. Seitenvorschub
'*
'*.s    Eingabeparameter:
'*.p
'*      txt as string       auzugebende Zeile
'*
'*.s    Beschreibung:
'*
'*      Zeilenlnge wird nicht beschnitten. VB-Fehlergenerierung in
'*      solchem Fall ist nicht dokumentiert. Falls dennoch Errors generiert werden,
'*      werden sie ignoriert.
'*
'*.s    Syntax:
'*.f    Sub prPrintLine (ByVal txt As String)
'***********************************************************************
Function prPrintLine(ByVal txt As String) As Integer

    Dim rc As Integer

    On Error Resume Next

    pr_curx = pr_left
    Printer.CurrentX = pr_left
    Printer.CurrentY = pr_cury

    prPrintTxt (txt)
    rc = prNewLine()
    prPrintLine = rc
    
End Function

'**********************************************************************
'*
'*.S    prPrintTab
'*
'*      Text in bestimmter Spalte ausgeben
'*
'*.s Eingabeparameter:
'*.p
'*      x as integer   --   Spalte, in der der Ausdruck beginnt.
'*                          Linker Rand: x=0
'*      txt as string  --   auszugebender Text
'*
'*.t  ***ACHTUNG*** -- Spaltenbreite hngt vom Font ab!!!
'*
'***********************************************************************
Sub prPrintTab(x As Integer, ByVal txt As String)

    On Error Resume Next
    pr_curx = pr_left + pr_dx * x
    prPrintTxt (txt)

End Sub

'**********************************************************************
'*
'*.S    prPrintTxt
'*
'*              Text an aktueller X-Y-Position ausdrucken
'*
'*.s   Eingabeparameter:
'*.p
'*      txt as string  --   auszugebender Text
'*
'***********************************************************************
Sub prPrintTxt(ByVal txt As String)

    On Error Resume Next

    Printer.CurrentX = pr_curx
    Printer.CurrentY = pr_cury
    Printer.Print txt

End Sub

'*********************************************************************
'*.S prPrintWindow()
'*
'*.s Description
'*
'*      Copies the entire window (form or control) to another
'*      window (form or control) or device such as a printer. This
'*      routine is capable of printing complete form images on any
'*      printer that has Windows drivers loaded including Postscript.
'*
'*.P      The API functions GetDIBits and StretchDIBits are used to copy
'*      the client area image to the destination window or device.
'*
'*.s Parameters:
'*.p      hDC_Dest  --    Handle to the DC of the destination device or
'*                       window.
'*      DestX    --     X position of where the image will be
'*                       displayed on the destination device.
'*****************************************************************************
'*
'*.S    prSetAlignment
'*
'*              Einstellen der Ausgabe-Ausrichtung
'*         Nur wirksam bei der Ausgabe von Forms und Controls.
'*
'*.s      Eingabeparameter:
'*.p
'*      horz as integer --  PR_ALIGNTOP, PR_ALIGNCENTER, PR_ALIGNBOTTOM
'*      vert as integer --  PR_ALIGNLEFT, PR_ALIGNCENTER, PR_ALIGNRIGHT
'*
'*****************************************************************************
Sub prSetAlignment(horz As Integer, vert As Integer)
    pr_halign = horz
    pr_valign = vert
End Sub

'**********************************************************************
'*
'*.S    prSetFont
'*
'*              Druckerfont einstellen
'*
'*.s Eingabeparameter:
'*.p
'*      fname as string   --  Fontname
'*      fsize as integer  --  Fontgre
'*      bld as integer    --  Fettschrift (True/False)
'*      it as integer     --  Kursivschrift (True/False)
'*
'*.s Beschreibung:
'*      prSetFont stellt den Schriftsatz ein. Standardeinstellung nach prInit ist
'*      ("Courier New", 10 ,False, False). ACHTUNG: Zeichenbreite und
'*      Zeilenhhe werden auf ihre Standardwerte zurckgesetzt. Der
'*      Aufruf sollte daher nur einmal am Anfang eines Dokumentes erfolgen,
'*      am besten unmittelbar nach "prInit".
'*
'***********************************************************************
Sub prSetFont(fname As String, fsize As Integer, bld As Integer, it As Integer)

    On Error Resume Next
    Printer.FontName = fname
    Printer.FontSize = fsize
    Printer.FontBold = bld
    Printer.FontItalic = it

    pr_dx = Printer.TextWidth("W")
    pr_dy = Printer.TextHeight("W")

End Sub

'**********************************************************************
'*
'*.S prSetHdrTxt
'*
'*  Kopftext festlegen
'*
'*.s Eingabeparameter:
'*.c
'*      txt as string       Kopftext
'*
'*.s Beschreibung
'*      Kopftext erscheint nur dann, wenn "prSetPageHdr True"
'*      nach "prInit" aufgerufen wurde.
'*
'***********************************************************************
Sub prSetHdrTxt(ByVal txt As String)
    pr_hdrtxt = txt
End Sub

'**********************************************************************
'*
'*.S    prSetLineHeight
'*
'*              Zeilenhhe einstellen
'*
'*.s Eingabeparameter:
'*.p
'*      value as single  -- Zeilehhe. Einheit: Zeichenhhe
'*
'*.s Beschreibung:
'*
'*      Zeilenhhe wird begrenzt auf:
'*.i    --    Minimalwert: Zeichenhhe
'*      --    Maximalwert: Seitenhhe / 3
'*
'*.P    Standardeinstellung nach prInit ist 1.0.
'*
'***********************************************************************
Sub prSetLineHeight(Value As Single)

    On Error Resume Next

    If Value < 1# Then
        Value = 1#
    ElseIf Value > CSng(prGetHeight()) / 3# Then
        Value = CSng(prGetHeight()) / 3#
    End If
    pr_dy = Value * Printer.TextHeight("W")

End Sub

'**********************************************************************
'*
'*.S    prSetMargins
'*
'*              Seitenrnder festlegen
'*
'*.s Eingabeparameter:
'*.p
'*          ml as double   --   Breite des linken Randes
'*          mr as double   --   Breite des rechten Randes
'*          mt as double   --   Breite des oberen Randes
'*          mb as double   --   Breite des unteren Randes
'*
'*.s Beschreibung:
'*
'*      Die Einheit der Randbreite wird in Anteilen der Seitenbreite
'*      bzw. Seitenhhe angegeben.
'*      Beispiel:
'*.c
'*      prSetMargin 0.1, 0.2, 0.3, 0.4
'*.P    setzt den linken Rand auf eine Breite von 0.1 * Seitenbreite,
'*      den unteren Rand auf eine Breite von 0.4 * Seitenhhe usw.
'*
'*.P    Die Cursorposition wird nicht verndert!!!!
'*
'***********************************************************************
Sub prSetMargins(ml As Double, mr As Double, mt As Double, mb As Double)

    On Error Resume Next

    pr_left = CInt(ml * CDbl(Printer.ScaleWidth))
    pr_right = CInt((1# - mr) * CDbl(Printer.ScaleWidth))
    pr_top = CInt(mt * CDbl(Printer.ScaleHeight) + pr_dy)
    pr_bottom = CInt((1# - mb) * CDbl(Printer.ScaleHeight))

End Sub

'**********************************************************************
'*
'*.S            prSetPageHdr
'*
'*                      legt fest, ob eine Kopfzeile ausgegeben wird
'*
'*.s Eingabeparameter:
'*.p
'*      value as integer   --   TRUE: Kopfzeile ausgeben
'*                              FALSE: Keine Kopfzeile (Voreinstellung)
'*.s Beschreibung:
'*      Wird von prInit auf FALSE gesetzt.
'*
'***********************************************************************
Sub prSetPageHdr(Value As Integer)

    pr_printhdr = Value

End Sub

'*****************************************************************************
'*
'*.S            prSetPageLayout
'*
'*              Einstellen von Seitenrndern.
'*      Nur wirksam bei der Ausgabe von Forms und Controls.
'*
'*.s    Eingabeparameter:
'*.p
'*      l as double  --  0.0 <= l <= 1.0: linker Rand. Einheit: Seitenbreite
'*      r as double  --  0.0 <= r <= 1.0: rechter Rand.
'*
'*      t as double  --  0.0 <= t <= 1.0: oberer Rand. Einheit: Seitenhhe
'*      b as double  --  0.0 <= b <= 1.0: unterer Rand. Einheit: Seitenbreite
'*
'*.P  Definitionsbereich aller Eingabeparameter: 0.0 <= x <= 1.0
'*
'*.p    zoom as double  --  Verkleinerungsfaktor. Einheit: max. Gre
'*
'*.s   Beschreibung:
'*
'*      Bei sinnlosen Angaben werden gegenberliegende Seitenrnder vertauscht
'*      oder Standardwerte eingestellt.
'*
'*****************************************************************************
Sub prSetPageLayout(ByVal l As Double, ByVal r As Double, ByVal t As Double, B As Double)

    Dim rc As Integer           '// return code

    rc = prClip(l, 0#, 1#)
    rc = prClip(r, 0#, 1#)
    rc = prClip(t, 0#, 1#)
    rc = prClip(B, 0#, 1#)

    If (l + r) > 1# Then
        l = 1# - l
        r = 1# - r
    End If

    If (t + B) > 1# Then
        t = 1# - t
        B = 1# - B
    End If

    pr_usrlayout = True
    pr_usrt = t
    pr_usrl = l
    pr_usrr = r
    pr_usrb = B

End Sub

'**********************************************************************
'*
'*.S    prSetPageNr
'*
'*              Nummer der aktuellen Seite einstellen
'*
'*.s Beschreibung:
'*
'*.i  --    Bei jeder neuen Seite wird die Nummer automatisch erhht.
'*
'*    --    Die Nummer erscheint am rechten Rand der Kopfzeile, wenn
'*          nach prInit die Funktion "prSetPageHdr True" aufgerufen wurde.
'*
'*    --    prInit setzt die Seitennummer automatisch auf 1.
'*
'***********************************************************************
Sub prSetPageNr(Value As Integer)

    pr_pagenr = Value

End Sub

'**********************************************************************
'*
'*.S            prSetXY
'*
'*              X-Y-Position an bestimmte Stelle setzen
'*
'*.s Eingabeparameter:
'*.p
'*      x as integer -- x-Position. Einheit: Zeichen
'*      y as integer -- y-Position. Einheit: Zeilen
'*
'*.t  ***ACHTUNG*** -- Spaltenhhe und -breite hngen vom Font ab!!!
'*
'***********************************************************************
Sub prSetXY(ByVal x As Integer, ByVal Y As Integer)

    On Error Resume Next

    pr_curx = pr_left + x * pr_dx
    pr_cury = pr_top + CSng(Y + 1) * pr_dy
    Printer.CurrentX = pr_curx
    Printer.CurrentY = pr_cury

End Sub

