Attribute VB_Name = "Sedac"
    Option Explicit
    
' Vor der ersten Benutzung einer Funktion aus diesem Modul:
'    Load SedFun

' Falls ein Protokoll gewnscht wird, mu auf dem Device-Server-PC mca\sbin\sedac\sedprot.exe laufen,
' auf der lokalen Platte des Device-Server-PCs die Directory c:\prot\sedac vorhanden sein
    
' MyLanAl$ enthlt den RemotePC-Namen fr Broadcasts in diesem Lan
' wird benutzt, um SEDPC-Fehler zentral zu protokollieren
    Global MyLanAll$
    Global Context$
    
    Global Const MAX_NUMBER_OF_LINES = 10 ' pro PC
    
    Global StatusLastReset$

' Verschiedene Moduleigne Konstanten
        
    Global Const MAX_REMOTE_PACK_SIZE = 233   ' ins IPack passen 700 Integers, pro Telegram braucht man 3 Integer
    Const MINDEST_FIFO_LENGTH = 4095
    Const MAX_PACKET_SIZE = &H7FFF     ' jetzt wird die Lnge nur durch Typ Integer begrenzt, indem die PackRoutinen
                                       '    mehrfach hintereinander ausgefhrt werden
    
    Const SEDAC_READ = &H80
    Const SEDAC_WRITE = &H40


' Fehlernummern, die an den Sedac-Protokoll-Server geschickt werden

    Const ERR_SEDPC = 255
    Const ERR_SEDTST = 254
    Const ERR_SEDCLR = 253
    Const ERR_SEDDLY = 252
    Const ERR_SEDLCS = 251
    Const ERR_SEDCNT = 250
    Const ERR_SEDERRCNT = 249
    Const ERR_SEDTYP = 248
    
    Const HIGH_ = 1
    Const LOW_ = 2
    
' Fehlermeldungen, die ber die Check$-Variable bergeben werden

    Global Const SERVER_IS_BUSY = "Server is busy"       ' der Sedac-Treiber auf dem Device-Server-Rechner bearbeitet gerade Sedput/Sedget
    Global Const SUBR_IS_BUSY = "Subroutine is busy"     ' die Routinen in diesem Modul duerfen nicht rekursiv aufgerufen werden
    Global Const SERVER_TIMEOUT = "Timeout vom Server"   ' der Sedac-Treiber auf dem Device-Server-Rechner antwortet nicht
    Global Const sedac_error = "Sedac Error # "          ' die FehlerNr aus der dll wird angehaengt
    Global Const dimension_error = "Dimension Error"     ' die Arrays fuer SedPack... muessen alle gleich lang sein
    Global Const PACKET_TOO_LONG = "Packet too long"     ' Arrays duerfen nicht laenger sein als MAX_PACK_SIZE_READ bzw. MAX_PACK_SIZE_WRITE
    Global Const RANGE_ERROR = "Value out of range"      ' Datenformat in SedacWrite oder SedacPackMix
    Global Const ADRESS_ERROR = "Address out of range"   ' Crate < 0, crate > 63, Subadresse < 0 oder Subadresse > 255
    Global Const ENVIRONMENT = "No SEDPC Environment Variable!"
    Global Const NO_GIVEIO = "GiveIO not running!"
    Global Const LINE_RESERVED = "Sedac Line reserved by "
    Global Const no_such_line = "Keine Sedac-Line"
    
    Global Const I_SEDAC_ERROR_BASE = 20000
    Global Const I_SERVER_IS_BUSY = 20001         ' der Sedac-Treiber auf dem Device-Server-Rechner bearbeitet gerade Sedput/Sedget
    Global Const I_SUBR_IS_BUSY = 20002           ' die Routinen in diesem Modul duerfen nicht rekursiv aufgerufen werden
    Global Const I_SERVER_TIMEOUT = 20003         ' der Sedac-Treiber auf dem Device-Server-Rechner antwortet nicht
    Global Const I_SEDAC_ERROR = 20004            ' die FehlerNr aus der dll wird angehaengt
    Global Const I_DIMENSION_ERROR = 20005        ' die Arrays fuer SedPack... muessen alle gleich lang sein
    Global Const I_PACKET_TOO_LONG = 20006        ' Arrays duerfen nicht laenger sein als MAX_PACK_SIZE_READ bzw. MAX_PACK_SIZE_WRITE
    Global Const I_RANGE_ERROR = 20007            ' Datenformat in SedacWrite oder SedacPackMix
    Global Const I_ADRESS_ERROR = 20008           ' Crate < 0, crate > 63, Subadresse < 0 oder Subadresse > 255
    Global Const I_ENVIRONMENT = 20009
    Global Const I_NO_GIVEIO = 20010
    Global Const I_LINE_RESERVED = 20011
    Global Const I_UNKNOWN_ERROR = 20099
    Global Const I_NO_SUCH_LINE = 20012

' Masken fr Fehlerbits

    Const MASK_RESERV_ERR = &H300
    
    Type SedacReadArg
        Crate As Integer
        SubAdress As Integer
    End Type
    
    Type SedacWriteArg
        Crate As Integer
        SubAdress As Integer
        Value As Long
    End Type
                
    Type SedacErcArg
        Crate As Integer
        Class As Integer
    End Type
                
    Type SedacPackReadArg
        Crate(MAX_REMOTE_PACK_SIZE) As Integer
        SubAdress(MAX_REMOTE_PACK_SIZE) As Integer
        PackLen As Integer
    End Type
    
    Type SedacPackReadRet
        Reply(MAX_REMOTE_PACK_SIZE) As Integer
        PackReadData(MAX_REMOTE_PACK_SIZE) As Single
    End Type

    Type SedacPackWriteArg
        Crate(MAX_REMOTE_PACK_SIZE) As Integer
        SubAdress(MAX_REMOTE_PACK_SIZE) As Integer
        PackWriteData(MAX_REMOTE_PACK_SIZE) As Single
        PackLen As Integer
    End Type
    
    Type SedacPackWriteRet
        Reply(MAX_REMOTE_PACK_SIZE) As Integer
    End Type

    Type SedacPackMixArg
        Crate(MAX_REMOTE_PACK_SIZE) As Integer
        SubAdress(MAX_REMOTE_PACK_SIZE) As Integer
        PackWriteData(MAX_REMOTE_PACK_SIZE) As Single
        mode(MAX_REMOTE_PACK_SIZE) As Integer
        PackLen As Integer
    End Type
    
    Type SedacPackMixRet
        Reply(MAX_REMOTE_PACK_SIZE) As Integer
        PackReadData(MAX_REMOTE_PACK_SIZE) As Single
    End Type

Sub LngTo2Int(lval&, ival_low%, ival_high%)
Dim l&
' Ein Long-Word wird in 2 Integer aufgeteilt


    l& = lval And &HFFFF&
    If l& >= &H7FFF& Then l& = l& - &H10000
    ival_low% = CInt(l&)
    If lval >= 0 Then
        ival_high% = CInt(lval \ &H10000)
    Else
        l& = ((lval And &H7FFFFFFF) \ &H10000) Or &H8000&
        l& = l& - &H10000
        ival_high% = CInt(l&)
    End If
End Sub

Sub Sed32MultiReadPairs(Serv$, LinCnt%, lin%(), Cra%(), reg%(), pReadData&(), Reply%(), check$)
'   wie Sed32MultiRead, nur der Parameter pReadData hat eine Dimension mehr: Die 32-Bit Daten-Worte
'   sind aufgeteilt in zwei Integer

    Dim Length%, i%, j%
    Length = UBound(reg%)
    ReDim ReadData&(Length, LinCnt%)
    Dim i_low%, i_high%

    Sed32MultiRead Serv$, LinCnt%, lin%(), Cra%(), reg%(), ReadData&(), Reply%(), check$

    If check$ = "ok" Then
        For j% = 1 To LinCnt%
            For i% = 1 To Length%
                LngTo2Int ReadData&(i%, j%), i_low%, i_high%
                pReadData&(i%, j%, HIGH_) = CLng(i_high%)
                pReadData&(i%, j%, LOW_) = CLng(i_low%)
            Next i%
        Next j%
    End If
    
End Sub

Sub Sed32MultiWritePairs(Serv$, LinCnt%, lin%(), Cra%(), reg%(), pWriteData&(), Reply%(), check$)
'   wie Sed32MultiWrite, nur der Parameter pWriteData hat eine Dimension mehr: Die 32-Bit Daten-Worte
'   sind aufgeteilt in zwei Integer

    Dim i%, j%
    Dim leng%
    leng% = UBound(reg%)
    ReDim WriteData&(leng%)
    
    For i% = 1 To leng
        For j% = 1 To LinCnt%
            WriteData&(i%) = LngFrom2Int(pWriteData&(i%, j%, LOW_), pWriteData&(i%, j%, HIGH_))
        Next j%
    Next i%
    
    Sed32MultiWrite Serv$, LinCnt%, lin%(), Cra%(), reg%(), WriteData&(), Reply%(), check$

End Sub

Sub Sed32PackMixPairs(Serv$, lin%, Cra%(), reg%(), pReadWriteData&(), ReadWriteMode%(), Reply%(), check$)
    Dim Length%, i%
    
'   wie Sed32PackMix, nur der Parameter pReadWriteData hat eine Dimension mehr: Die 32-Bit Daten-Worte
'   sind aufgeteilt in zwei Integer
    
    Length% = UBound(reg%)
    ReDim ReadWriteData&(Length%)
    Dim i_low%, i_high%
    
    For i% = 1 To Length%
        ReadWriteData&(i%) = LngFrom2Int(pReadWriteData&(i%, LOW_), pReadWriteData&(i%, HIGH_))
    Next i%
    Sed32PackMix Serv$, lin%, Cra%(), reg%(), ReadWriteData&(), ReadWriteMode%(), Reply%(), check$

    If check$ = "ok" Then
        For i% = 1 To Length%
            LngTo2Int ReadWriteData&(i%), i_low%, i_high%
            pReadWriteData&(i%, HIGH_) = CLng(i_high%)
            pReadWriteData&(i%, LOW_) = CLng(i_low%)
        Next i%
    End If

End Sub

Sub Sed32PackReadPairs(Serv$, lin%, Cra%(), reg%(), pReadData&(), Reply%(), check$)
'   wie Sed32Read, nur der Parameter pReadData hat eine Dimension mehr: Die 32-Bit Daten-Worte
'   sind aufgeteilt in zwei Integer

    Dim Length%, i%
    Length = UBound(reg%)
    ReDim ReadData&(Length)
    Dim i_low%, i_high%
    
    Sed32PackRead Serv$, lin%, Cra%(), reg%(), ReadData&(), Reply%(), check$
    
    If check$ = "ok" Then
        For i% = 1 To Length%
            LngTo2Int ReadData&(i%), i_low%, i_high%
            pReadData&(i%, HIGH_) = CLng(i_high%)
            pReadData&(i%, LOW_) = CLng(i_low%)
        Next i%
    End If
    
End Sub

Sub Sed32PackWritePairs(Serv$, lin%, Cra%(), reg%(), pWriteData&(), Reply%(), check$)
'   wie Sed32PackWrite, nur der Parameter pWriteData hat eine Dimension mehr: Die 32-Bit Daten-Worte
'   sind aufgeteilt in zwei Integer

    Dim i%
    Dim leng%
    leng% = UBound(reg%)
    ReDim WriteData&(leng%)
    
    For i% = 1 To leng
        WriteData&(i%) = LngFrom2Int(pWriteData&(i%, LOW_), pWriteData&(i%, HIGH_))
    Next i%
    
    Sed32PackWrite Serv$, lin%, Cra%(), reg%(), WriteData&(), Reply%(), check$

End Sub

 Sub Sed32ReadPair(Serv$, lin%, Cra%, reg%, SedValHigh&, SedValLow&, check$)
    Dim SedVal&
    Dim i_low%, i_high%
    
    Sed32Read Serv$, lin%, Cra%, reg%, SedVal&, check$
    LngTo2Int SedVal&, i_low%, i_high%
    SedValHigh& = CLng(i_high%)
    SedValLow& = CLng(i_low%)
    
 End Sub
 

Sub Sed32WritePair(Serv$, lin%, Cra%, reg%, SedValHigh&, SedValLow&, check$)
    Dim SedVal&
    
    SedVal& = LngFrom2Int(SedValLow&, SedValHigh&)
    Sed32Write Serv$, lin%, Cra%, reg%, SedVal&, check$

End Sub

Sub SedacGetDatStr(Serv$, lin%, DatStr$, check$)
    
    Dim i%, j%
    Dim ReplyFlag%
    Dim SedacGetDatReturn(30) As Byte
    Dim StrArr$(), FilNo%, Filna$
    
    If Serv$ = LocalPC$ Then
      
    ' Local: Get Date of last clear counters
        
        On Error Resume Next
        Err = 0
        FilNo% = FreeFile
        Filna$ = "c:\prot\Sedac\LClrDat.txt"
        Open Filna$ For Input As FilNo%
            If Err = 76 Then
                Err = 0
                ChDir "c:\prot"
                If Err = 76 Then
                    Err = 0
                    MkDir "c:\prot"
                End If
                MkDir "c:\prot\Sedac"
                If Err <> 0 Then check$ = Error(Err) Else check$ = "ok"
            Else
                If Err <> 0 Then check$ = Error(Err) Else check$ = "ok"
            End If
            Err = 0
            Input #FilNo%, DatStr$
            If Err = 52 Then check$ = Error(Err) & " ;File: " & Filna$
        Close FilNo%
        
        On Error GoTo 0
        
    Else
        
    ' Remote: Get Date of last clear counters
        frmSedFun!ACOP1.DeviceProperty = "GetClDat"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetDatReturn, 30, "BYTE")
        
        If ReplyFlag% = 0 Then
            If SedacGetDatReturn(0) > 0 Then
                StrArr$() = Split(BSTR(SedacGetDatReturn), Chr$(10))
                check$ = StrArr$(0)
                DatStr$ = StrArr$(1)
            Else
                check$ = "No Line"
            End If
        Else
            check$ = frmSedFun!ACOP1.status
        End If
   End If


End Sub

Function ConvIntErrToCheck$(ier%)
    Dim check$
    
    Select Case ier%
        Case 0
            check$ = "ok"
        Case I_SERVER_IS_BUSY
            check$ = SERVER_IS_BUSY
        Case I_SUBR_IS_BUSY
            check$ = SUBR_IS_BUSY
        Case I_SERVER_TIMEOUT
            check$ = SERVER_TIMEOUT
        Case I_DIMENSION_ERROR
            check$ = dimension_error
        Case I_PACKET_TOO_LONG
            check$ = PACKET_TOO_LONG
        Case I_RANGE_ERROR
            check$ = RANGE_ERROR
        Case I_ADRESS_ERROR
            check$ = ADRESS_ERROR
        Case I_NO_GIVEIO
            check$ = NO_GIVEIO
        Case I_NO_SUCH_LINE
            check$ = no_such_line
        Case Is < I_SEDAC_ERROR_BASE
            check$ = sedac_error & str$(ier%)
    End Select
        
    ConvIntErrToCheck$ = check$
        
End Function
Function ConvSmallChecktoCheck$(SCheck$)
Dim check$
    Select Case Left$(SCheck$, 1)
        Case "o"
            check$ = "ok"
        Case "G"
            check$ = sedac_error & Replace(SCheck$, "G", "") & " in SedGet"
        Case "P"
            check$ = sedac_error & Replace(SCheck$, "P", "") & " in SedPut"
        Case Else
            check$ = ConvIntErrToCheck$(CInt(SCheck$))
    End Select
   ConvSmallChecktoCheck = check$

End Function
Function ConvChecktoSmallCheck$(check$)
Dim SCheck$
    Select Case check$
         Case "ok"
            SCheck$ = "ok"
         Case SERVER_IS_BUSY
            SCheck$ = str$(I_SERVER_IS_BUSY)
         Case SUBR_IS_BUSY
            SCheck$ = str$(I_SUBR_IS_BUSY)
         Case SERVER_TIMEOUT
            SCheck$ = str$(I_SERVER_TIMEOUT)
         Case sedac_error
            SCheck$ = Replace(check$, sedac_error, "")
            If InStr(SCheck$, " in SedPut") > 0 Then
                SCheck$ = "P" & Replace(SCheck$, " in SedPut", "")
            End If
            If InStr(SCheck$, " in SedGet") > 0 Then
                SCheck$ = Replace(SCheck$, " in SedGet", "")
            End If
         Case dimension_error
            SCheck$ = str$(I_DIMENSION_ERROR)
         Case PACKET_TOO_LONG
            SCheck$ = str$(I_PACKET_TOO_LONG)
         Case RANGE_ERROR
            SCheck$ = str$(I_RANGE_ERROR)
         Case ADRESS_ERROR
            SCheck$ = str$(I_ADRESS_ERROR)
         Case NO_GIVEIO
            SCheck$ = str$(I_NO_GIVEIO)
    End Select
    ConvChecktoSmallCheck = SCheck$

End Function
Function ConvCheckToIntErr%(check$)
    Dim ier%
    Select Case check$
         Case "ok"
            ier% = 0
         Case SERVER_IS_BUSY
            ier% = I_SERVER_IS_BUSY
         Case SUBR_IS_BUSY
            ier% = I_SUBR_IS_BUSY
         Case SERVER_TIMEOUT
            ier% = I_SERVER_TIMEOUT
         Case dimension_error
            ier% = I_DIMENSION_ERROR
         Case PACKET_TOO_LONG
            ier% = I_PACKET_TOO_LONG
         Case RANGE_ERROR
            ier% = I_RANGE_ERROR
         Case ADRESS_ERROR
            ier% = I_ADRESS_ERROR
         Case NO_GIVEIO
            ier% = I_NO_GIVEIO
         Case no_such_line
            ier% = I_NO_SUCH_LINE
         Case Else
            If InStr(check$, sedac_error) > 0 Then
                ier% = Val(Replace(check$, sedac_error, ""))
            Else
                ier% = I_UNKNOWN_ERROR
            End If
    End Select
    ConvCheckToIntErr = ier%
End Function

Sub Sed32GetErrorStatistics(Serv$, lin%, Class%, ErrArr&(), check$)
    
        
    Dim SedacGetErcArgument As SedacErcArg
    Dim SedacGetErcReturn(256) As Integer
    Dim ReplyFlag%, lSedErr&
    Dim i%
    
    If UBound(ErrArr&) < 256 Then check = dimension_error: Exit Sub
    
    If Serv$ = LocalPC$ Then
    
        ' Local: Get Sedac error statistics
        
        Call SedErc(CLng(lin%), CLng(Class%), ErrArr&(0), lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedErc", Serv$, lin%, lin%, lin%, check$)
   
        If frmSedFun.Check1 Then
            Call SedErrProt("GetCounters", lin, ERR_SEDERRCNT, ERR_SEDERRCNT, CInt(lSedErr&))
        End If
    
    
    Else
    
        ' Remote: Get Sedac error statistics
        frmSedFun!ACOP1.DeviceProperty = "GtErrCnt"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetErcReturn, 256, "INTEGER", SedacGetErcArgument.Crate, Len(SedacGetErcArgument), "STRUCT")
        
        If ReplyFlag% = 0 Then
            For i% = 1 To 32
                ErrArr&(i%) = CLng(SedacGetErcReturn(i%))
            Next i%
            check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
    End If
    

End Sub
Sub Sed32GetStatistics(Serv$, lin%, lArray&(), check$)
    
        
    Dim SedacGetCntReturn(16) As Integer
    Dim ReplyFlag%, lSedErr&
    Dim i%
    
    If UBound(lArray&) < 16 Then check = dimension_error: Exit Sub
    
    If Serv$ = LocalPC$ Then
    
        ' Local
        Call SedCnt(CLng(lin%), lArray&(1), lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedDly", Serv$, lin%, lin%, lin%, check$)
    
        If frmSedFun.Check1 Then
            Call SedErrProt("GetCounters", lin, ERR_SEDCNT, ERR_SEDCNT, CInt(lSedErr&))
        End If
    
    
    Else
    
        ' Remote


        frmSedFun!ACOP1.DeviceProperty = "GetCount"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetCntReturn, 16, "Integer")
        
        If ReplyFlag% = 0 Then
            For i% = 1 To 16
                lArray&(i%) = CLng(SedacGetCntReturn(i%))
            Next i%
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
        
    End If
    
End Sub

    

Sub clr_and_prot(Serv$, Fun$, lin%, Cra%, Sua%, iSedErr%)
    Dim SndStr$
    Dim lclearerr&

    Call SedClr(lin%, lclearerr&)
    
    SndStr$ = Format$(Now, "dd.mm.yyyy hh:mm:ss") & " " & Serv$ & " " & Fun$
    SndStr$ = SndStr$ & ",  Line " & str$(lin%)
    If Fun$ = "SedRd" Or Fun$ = "SedWr" Then SndStr$ = SndStr$ & ", Crate " & str$(Cra%) & ", Subadr " & str$(Sua%)
    SndStr$ = SndStr$ & ",SedacError " & Hex$(iSedErr%)
    If lclearerr& <> 0 Then SndStr$ = SndStr$ & " (hex),Error in Clear " & Hex$(lclearerr&)
    SndStr$ = SndStr$ & " (hex), App.Title: " & App.Title
 
    
'    frmSedFun!Send1.String1 = SndStr$
'    frmSedFun!Send1.Property = Serv$
'    frmSedFun!Send1.RemoteID = "Sed_PcEr"
'    frmSedFun!Send1.RemotePC = MyLanAll$
'    frmSedFun!Send1.StringMsg = 1
'
    iSedErr% = CInt(lclearerr&)
End Sub

Sub ErrPackProt(Serv$, lin%, Length%, Cra%(), reg%(), SedErr%())
    Dim leng%, i%, Li%

    If Length% > 233 Then
       Li% = 233
    Else
       Li% = Length%
    End If
    leng% = 3 * Li%

    ReDim IPArr%(leng%)
    For i% = 1 To Li%
      IPArr%((i% - 1) * 3 + 1) = Cra%(i%)
      IPArr%((i% - 1) * 3 + 2) = reg%(i%)
      IPArr%((i% - 1) * 3 + 3) = SedErr%(i%)
    Next i%

'    frmSedFun!Send1.Ipacklen = leng%
'    frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'    frmSedFun!Send1.Ipackindex = lin%
'    frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'    frmSedFun!Send1.RemoteID = "SedProt"
'    frmSedFun!Send1.Property = "SedPErr"
'    frmSedFun!Send1.IpackMsg = 1

    If Length% > 233 Then
      Li% = Length% - Li%
      leng% = 3 * Li%
  
      ReDim IPArr%(leng%)
      For i% = 1 To Li%
        IPArr%((i% - 1) * 3 + 1) = Cra%(i%)
        IPArr%((i% - 1) * 3 + 2) = reg%(i%)
        IPArr%((i% - 1) * 3 + 3) = SedErr%(i%)
      Next i%
  
'      frmSedFun!Send1.Ipacklen = leng%
'      frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'      frmSedFun!Send1.Ipackindex = lin%
'      frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'      frmSedFun!Send1.RemoteID = "SedProt"
'      frmSedFun!Send1.Property = "SedPErr"
'      frmSedFun!Send1.IpackMsg = 1
    End If

End Sub

Sub ErrMultiPackProt(Serv$, lin%, Length%, Cra%(), reg%(), SedErr%())
    Dim leng%, i%, Li%

    If Length% > 233 Then
       Li% = 233
    Else
       Li% = Length%
    End If
    leng% = 3 * Li%

    ReDim IPArr%(leng%)
    For i% = 1 To Li%
      IPArr%((i% - 1) * 3 + 1) = Cra%(i%, lin%)
      IPArr%((i% - 1) * 3 + 2) = reg%(i%, lin%)
      IPArr%((i% - 1) * 3 + 3) = SedErr%(i%, lin%)
    Next i%

'    frmSedFun!Send1.Ipacklen = leng%
'    frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'    frmSedFun!Send1.Ipackindex = lin%
'    frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'    frmSedFun!Send1.RemoteID = "SedProt"
'    frmSedFun!Send1.Property = "SedPErr"
'    frmSedFun!Send1.IpackMsg = 1

    If Length% > 233 Then
      Li% = Length% - Li%
      leng% = 3 * Li%
  
      ReDim IPArr%(leng%)
      For i% = 1 To Li%
        IPArr%((i% - 1) * 3 + 1) = Cra%(i%, lin%)
        IPArr%((i% - 1) * 3 + 2) = reg%(i%, lin%)
        IPArr%((i% - 1) * 3 + 3) = SedErr%(i%, lin%)
      Next i%
  
'      frmSedFun!Send1.Ipacklen = leng%
'      frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'      frmSedFun!Send1.Ipackindex = lin%
'      frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'      frmSedFun!Send1.RemoteID = "SedProt"
'      frmSedFun!Send1.Property = "SedPErr"
'      frmSedFun!Send1.IpackMsg = 1
    End If

End Sub



Sub Sed32Clear(Serv$, lin%, check$)
    
    Dim lSedErr&
    Dim ReplyFlag%
    Dim SedacClrReturn As Integer
    
        If Serv$ = LocalPC$ Then
      
    ' Local Sedac Clear

        Call SedClr(CLng(lin%), lSedErr&)
        If lSedErr& <> 0 Then
            check$ = " Error # " & str$(lSedErr&)
        Else
            check$ = "ok"
        End If

        If frmSedFun.Check1 Then
            Call SedErrProt("Clear", lin%, ERR_SEDCLR, ERR_SEDCLR, CInt(lSedErr&))
        End If
    
    Else
        
    ' Remote Sedac Clear
  
        frmSedFun!ACOP1.DeviceProperty = "SedacClear"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacClrReturn, 1, "INTEGER")
        
        If ReplyFlag% = 0 Then
            check$ = "ok"
        Else
            check$ = frmSedFun!ACOP1.status
        End If
    End If
End Sub
Sub ErrorHandling(iSedErr%, Funct$, Serv$, lin%, Cra%, Sua%, check$)
    Dim ModUse&, ResHandle&, ResCnt&, ResTim&
    Dim ResString As String * 32
    
    If iSedErr% = 0 Then check$ = "ok": Exit Sub
    If iSedErr% > 7 Then
        check$ = sedac_error & " " & str(iSedErr%) & " in " & Funct$
        If iSedErr% And MASK_RESERV_ERR Then
            Call SedGsh(ModUse&, ResHandle&, ResString$, ResCnt&, ResTim&)
            check$ = LINE_RESERVED & ResString$ & "; ModuleUse " & ModUse&
            check$ = check$ & "; by Handle " & ResHandle&
            check$ = check$ & "; ResCount " & ResCnt& & "; ResTime " & ResTim& & " msec"
        ElseIf iSedErr% > 5 Then
            Call clr_and_prot(Serv$, Funct$, lin%, Cra%, Sua%, iSedErr%)
            If iSedErr% <> 0 Then check$ = check$ & " & Error in SedClr!!!"
        End If
    ElseIf Funct$ = "SedGet" Then
        check$ = "ok"
    ElseIf iSedErr% > 0 Then
        check$ = sedac_error & " " & str(iSedErr%) & " in " & Funct$
    Else
        check$ = "ok"
    End If

End Sub

Sub ConvfromPutArr(SedCnt%, PutArr%(), Cra%(), Sua%(), Data%(), mode%(), Reply%())
    Dim i%
            
    ReDim Cra%(SedCnt%), Sua%(SedCnt%), mode%(SedCnt%), Data%(SedCnt%), Reply%(SedCnt%)
    For i% = 1 To SedCnt%
           Cra%(i%) = PutArr((i% - 1) * 3 + 1) And &H3F
           Sua%(i%) = PutArr((i% - 1) * 3 + 2)
           Data%(i%) = PutArr((i% - 1) * 3 + 3)
           mode%(i%) = PutArr((i% - 1) * 3 + 1) And &HC0
    Next i%

End Sub
Sub ConvToGetArr(SedCnt%, GetArr%(), Data%(), Reply%())
    Dim i%
    
    ReDim GetArr%(2 * SedCnt%)
    For i% = 1 To SedCnt%
        GetArr%(2 * (i% - 1) + 1) = Reply%(i%)
        GetArr%(2 * (i% - 1) + 2) = Data%(i%)
    Next i%
    
End Sub
Sub Sed32SinglePackMix(Serv$, lin%, Cra%(), reg%(), ReadWriteData&(), ReadWriteMode%(), Reply%(), check$)
'
'  Fuehrt SedPut/SedGet mit beliebig sortierten Read- und Write- Telegrammen aus
'
'
'  Parameter:
'     Serv              I/O     Name des PCs, an dem die Sedac-Line haengt
'     lin               I/O     Sedac-Line-Nummer
'     cra               I/O     Array, der die Crate-Nummern enthaelt
'     reg               I/O     Array, der die SubAdressen enthaelt
'     ReadWriteMode     I/O     enthaelt die Konstanten SEDAC_READ, bzw. SEDAC_WRITE, je nachdem, ob  an dieser Stelle ein
'                                  Read- oder ein Write Telegramm behandelt werden soll
'     ReadWriteData     I/      enthaelt der Array ReadWriteMode an dieser Stelle SEDAC_READ, steht hier ein Dummy-Wert,
'                                  enthaelt er SEDAC_WRITE, steht hier der zu schreibende SedacValue
'                        /O     enthaelt der Array ReadWriteMode an dieser Stelle SEDAC_Write, steht hier ein Dummy-Wert,
'                                  enthaelt er SEDAC_READ, steht hier der gelesene SedacValue
'     Reply              /O     enthaelt den StatusArray aus SedGet
'     Check              /O     Fehlerstring, ist "ok", wenn alles stimmt
'

    Dim lSedErr&
    Dim ReplyFlag%
    Dim Length&
    Dim PackLength%, i%, j%
    Dim SedacPackMxArgument As SedacPackMixArg
    Dim SedacPackMxReturn As SedacPackMixRet
    
    Length& = CLng(UBound(Cra%))
    
    If Length& = UBound(reg%) Then Else check$ = dimension_error:               Exit Sub
    If Length& = UBound(ReadWriteData&) Then Else check$ = dimension_error:     Exit Sub
    If Length& = UBound(Reply%) Then Else check$ = dimension_error:             Exit Sub
  
    If Serv$ = LocalPC$ Then
    ' Local Sedac Read
        
        PackLength% = 3 * Length&
        ReDim PutArr&(1 To PackLength)
  
        j% = 0
        For i% = 1 To Length&
            If Cra%(i) < 0 Or Cra%(i) > 63 Then check$ = ADRESS_ERROR: Exit Sub
            If reg%(i) < 0 Or reg%(i) > 255 Then check$ = ADRESS_ERROR: Exit Sub
            Select Case ReadWriteMode%(i)
            Case SEDAC_READ
                PutArr&(2 * i) = CLng(2 ^ 15 + 2 ^ 8 * Cra(i%) + reg(i%))  '
                PutArr&(2 * i - 1) = 0
                j = j + 2
             Case SEDAC_WRITE
                PutArr&(2 * i) = CLng(2 ^ 14 + 2 ^ 8 * Cra(i%) + reg(i%))  '
                PutArr&(2 * i - 1) = ReadWriteData&(i)
                j = j + 2
            Case Else
                check$ = RANGE_ERROR: Exit Sub
            End Select
        Next i%
  
    
         
         ReDim ReplyArr&(1 To PackLength)
         
         Call SedPut(CLng(lin%), Length&, PutArr&(1), lSedErr&)
         Call ErrorHandling(CInt(lSedErr&), "SedPut", Serv$, lin%, lin%, lin%, check$)
         If check$ = "ok" Then
            Call SedGet(CLng(lin%), Length&, ReplyArr&(1), lSedErr&)
            Call ErrorHandling(CInt(lSedErr&), "SedGet", Serv$, lin%, lin%, lin%, check$)
            For i% = 1 To Length&
                ReadWriteData&(i%) = ReplyArr&(2 * i%)
                Reply%(i) = CInt(ReplyArr&(2 * i% - 1) And &HFFDF)
            Next i%
        End If
      
        If frmSedFun.Check1 Then
            Call SedErrProt("PackMix", lin%, ERR_SEDPC, ERR_SEDPC, CInt(lSedErr&))
            If lSedErr& <> 0 Then
                Call ErrPackProt(Serv$, lin%, CInt(Length&), Cra%(), reg%(), Reply%())
            End If
        End If
      
  
  
    Else
    ' Remote Sedac PackMix
        For i% = 1 To Length&
            SedacPackMxArgument.Crate(i%) = Cra%(i%)
            SedacPackMxArgument.SubAdress(i%) = reg%(i%)
            SedacPackMxArgument.mode(i%) = ReadWriteMode%(i%)
            SedacPackMxArgument.PackWriteData(i%) = ReadWriteData&(i%)
        Next i%
        SedacPackMxArgument.PackLen = CInt(Length&)
        
        frmSedFun!ACOP1.DeviceProperty = "SedPacMX"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacPackMxReturn.Reply(0), Len(SedacPackMxReturn), "STRUCT", SedacPackMxArgument.Crate(0), Len(SedacPackMxArgument), "STRUCT")
      
        For i% = 1 To Length&
            ReadWriteData&(i%) = SedacPackMxReturn.PackReadData(i%)
            Reply%(i%) = SedacPackMxReturn.Reply(i%)
        Next i%
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
End Sub
Sub SedacGetCrates(Serv$, lin%, CrArr%(), CrCnt%, check$)
      
          
    Dim lSedErr&
    Dim ReplyFlag%
    Dim SedacGetCraReturn(32) As Integer
    Dim Length%, i%
    Dim lCrCnt&
    Dim lCrArr&(32)
    
    Length% = 32
    If Length% > UBound(CrArr%) Then check$ = dimension_error:     Exit Sub
    
         
    If Serv$ = LocalPC$ Then
        
         ' Local
             
        Call SedLcs(CLng(lin%), 128, lCrCnt&, lCrArr&(1), lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedLcs", Serv$, lin%, lin%, lin%, check$)
        CrCnt% = CInt(lCrCnt&)
        For i% = 1 To Length: CrArr%(i%) = CInt(lCrArr&(i%)): Next i%
        
        If frmSedFun.Check1 Then
            Call SedErrProt("GetCrates", lin%, ERR_SEDLCS, ERR_SEDLCS, CInt(lSedErr&))
        End If
    
      
      Else
        
         ' Remote
         
        frmSedFun!ACOP1.DeviceProperty = "LookCra"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetCraReturn, 32, "Integer")
        
        CrCnt% = 0
        If ReplyFlag% = 0 Then
            For i% = 1 To 32
                CrArr%(i%) = SedacGetCraReturn(i%)
                If CrArr%(i%) > 0 Then CrCnt% = CrCnt% + 1
            Next i%
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If

    End If
End Sub

Sub Sed32GetSubadresses(Serv$, lin%, cr%, SuArr%(), SuCnt%, check$)
      
        
    Dim lSedErr&, lSuCnt&
    Dim ReplyFlag%
    Dim SedacGetSuaReturn(256) As Integer
    Dim lSuArr&()
    ReDim lSuArr&(256)
    Dim Length%, i%
    
    Length% = 256
    If Length% > UBound(SuArr%) Then check$ = dimension_error:     Exit Sub
        
    If Serv$ = LocalPC$ Then
      
           ' Local
               
            Call SedLcs(CLng(lin%), CLng(cr%), lSuCnt&, lSuArr&(1), lSedErr&)
            SuCnt% = CInt(lSuCnt&)
            For i% = 1 To SuCnt%
                SuArr%(i%) = lSuArr&(i%)
            Next i%
            Call ErrorHandling(CInt(lSedErr&), "SedLcs", Serv$, lin%, lin%, lin%, check$)
        
        
            If frmSedFun.Check1 Then
              Call SedErrProt("GetCrates", lin%, ERR_SEDLCS, ERR_SEDLCS, CInt(lSedErr&))
            End If
    
    
    Else
      
           ' Remote
           
        frmSedFun!ACOP1.DeviceProperty = "LookSua"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetSuaReturn, 256, "INTEGER", cr%, 1, "INTEGER")
        
        SuCnt% = 0
        If ReplyFlag% = 0 Then
            For i% = 1 To 256
                SuArr(i%) = SedacGetSuaReturn(i%)
                If SuArr(i%) > 0 Then SuCnt% = SuCnt% + 1
            Next i%
            check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If

    End If
End Sub
Sub Sed32PackMix(Serv$, lin%, Cra%(), reg%(), ReadWriteData&(), ReadWriteMode%(), Reply%(), check$)

    Dim Length%, MaxPackLen%, i%, Count%, TypArr%(6)
    Dim CraS%(), RegS%(), ReadWriteDataS&(), ReadWriteModeS%(), RePlyS%()

    Length% = UBound(Cra)
      
    If Length% > &H7FFF Then check$ = PACKET_TOO_LONG:      Exit Sub
    If Length% = UBound(reg%) Then Else check$ = dimension_error:               Exit Sub
    If Length% = UBound(ReadWriteData&) Then Else check$ = dimension_error:     Exit Sub
    If Length% = UBound(ReadWriteMode%) Then Else check$ = dimension_error:     Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:             Exit Sub

        If Serv$ = LocalPC$ Then

        If Length% > MINDEST_FIFO_LENGTH / 5 Then
            Call Sed32GetTyps(Serv$, lin%, TypArr%(), check$)
            MaxPackLen% = Int(TypArr%(3) / 5)
        Else
            MaxPackLen% = Int(MINDEST_FIFO_LENGTH / 5)
        End If
        
     Else
         MaxPackLen% = MAX_REMOTE_PACK_SIZE
     End If
     
     If Length% < MaxPackLen% Then
        Call Sed32SinglePackMix(Serv$, lin%, Cra%(), reg%(), ReadWriteData&(), ReadWriteMode%(), Reply%(), check$)
     Else
        Do While Length% > MaxPackLen%
            ReDim CraS%(MaxPackLen%), RegS%(MaxPackLen%), ReadWriteDataS&(MaxPackLen%), ReadWriteModeS%(MaxPackLen%), RePlyS%(MaxPackLen%)
            For i% = 1 To MaxPackLen%
                CraS%(i%) = Cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                ReadWriteDataS&(i%) = ReadWriteData&(i% + Count% * MaxPackLen%)
                ReadWriteModeS%(i%) = ReadWriteMode%(i% + Count% * MaxPackLen%)
            Next i%
            Call Sed32SinglePackMix(Serv$, lin%, CraS%(), RegS%(), ReadWriteDataS&(), ReadWriteModeS%(), RePlyS%(), check$)
            check$ = check$ & check$
            For i% = 1 To MaxPackLen%
                ReadWriteData&(i% + Count% * MaxPackLen%) = ReadWriteDataS&(i%)
                RePlyS%(i% + Count% * MaxPackLen%) = Reply%(i%)
            Next i%
            Length% = Length% - MaxPackLen%
            Count% = Count% + 1
        Loop
        If Length% > 0 Then
            ReDim CraS%(Length%), RegS%(Length%), ReadWriteDataS&(Length%), ReadWriteModeS%(Length%), RePlyS%(Length%)
            For i% = 1 To Length%
                CraS%(i%) = Cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                ReadWriteDataS&(i%) = ReadWriteData&(i% + Count% * MaxPackLen%)
                ReadWriteModeS%(i%) = ReadWriteMode%(i% + Count% * MaxPackLen%)
            Next i%
            Call Sed32SinglePackMix(Serv$, lin%, CraS%(), RegS%(), ReadWriteDataS&(), ReadWriteModeS%(), RePlyS%(), check$)
            check$ = check$ & check$
            For i% = 1 To Length%
                ReadWriteDataS&(i% + Count% * MaxPackLen%) = ReadWriteData&(i%)
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
            Count% = Count% + 1
        End If
        For i% = 1 To Count%
            check$ = Replace(check$, "ok", "")
            If check$ = "" Then check$ = "ok"
        Next i%
     End If
End Sub
Sub Sed32PackRead(Serv$, lin%, Cra%(), reg%(), ReadData&(), Reply%(), check$)

    Dim CraS%(), RegS%(), ReadDataS&(), RePlyS%()
    Dim Length%, MaxPackLen%, i%, Count%, TypArr%(6)
    
    Length% = UBound(Cra)
      
    If Length% > &H7FFF Then check$ = PACKET_TOO_LONG:      Exit Sub
    If Length% = UBound(reg%) Then Else check$ = dimension_error:       Exit Sub
    If Length% = UBound(ReadData&) Then Else check$ = dimension_error:  Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:     Exit Sub

    If Serv$ = LocalPC$ Then

        If Length% > MINDEST_FIFO_LENGTH / 5 Then
            Call Sed32GetTyps(Serv$, lin%, TypArr%(), check$)
            MaxPackLen% = Int(TypArr%(3) / 5)
        Else
            MaxPackLen% = Int(MINDEST_FIFO_LENGTH / 5)
        End If
        
     Else
         MaxPackLen% = MAX_REMOTE_PACK_SIZE
     End If
     
     If Length% < MaxPackLen% Then
        Call Sed32SinglePackRead(Serv$, lin%, Cra%(), reg%(), ReadData&(), Reply%(), check$)
     Else
        Do While Length% > MaxPackLen%
            ReDim CraS%(MaxPackLen%), RegS%(MaxPackLen%), ReadDataS&(MaxPackLen%), RePlyS%(MaxPackLen%)
            For i% = 1 To MaxPackLen%
                CraS%(i%) = Cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
            Next i%
            Call Sed32SinglePackRead(Serv$, lin%, CraS%(), RegS%(), ReadDataS&(), RePlyS%(), check$)
            For i% = 1 To MaxPackLen%
                ReadData&(i% + Count% * MaxPackLen%) = ReadDataS&(i%)
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
            Length% = Length% - MaxPackLen%
            Count% = Count% + 1
        Loop
        If Length% > 0 Then
            ReDim CraS%(Length%), RegS%(Length%), ReadDataS&(Length%), RePlyS%(Length%)
            For i% = 1 To Length%
                CraS%(i%) = Cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
            Next i%
            Call Sed32SinglePackRead(Serv$, lin%, CraS%(), RegS%(), ReadDataS&(), RePlyS%(), check$)
            For i% = 1 To Length%
                ReadData&(i% + Count% * MaxPackLen%) = ReadDataS&(i%)
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
        End If
     
     End If
End Sub
Sub Sed32PackWrite(Serv$, lin%, Cra%(), reg%(), WriteData&(), Reply%(), check$)
    
    Dim CraS%(), RegS%(), WriteDataS&(), RePlyS%()
    Dim Length%, MaxPackLen%, i%, Count%, TypArr%(6)
    
    Length% = UBound(Cra)
      
    If Length% > &H7FFF Then check$ = PACKET_TOO_LONG:      Exit Sub
    If Length% = UBound(reg%) Then Else check$ = dimension_error:       Exit Sub
    If Length% = UBound(WriteData&) Then Else check$ = dimension_error:  Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:     Exit Sub

        If Serv$ = LocalPC$ Then

        If Length% > MINDEST_FIFO_LENGTH / 5 Then
            Call Sed32GetTyps(Serv$, lin%, TypArr%(), check$)
            MaxPackLen% = Int(TypArr%(3) / 5)
        Else
            MaxPackLen% = Int(MINDEST_FIFO_LENGTH / 5)
        End If
        
     Else
         MaxPackLen% = MAX_REMOTE_PACK_SIZE
     End If
     
     If Length% < MaxPackLen% Then
        Call Sed32SinglePackWrite(Serv$, lin%, Cra%(), reg%(), WriteData&(), Reply%(), check$)
     Else
        Do While Length% > MaxPackLen%
            ReDim CraS%(MaxPackLen%), RegS%(MaxPackLen%), WriteDataS&(MaxPackLen%), RePlyS%(MaxPackLen%)
            For i% = 1 To MaxPackLen%
                CraS%(i%) = Cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                WriteDataS&(i%) = WriteData&(i% + Count% * MaxPackLen%)
            Next i%
            Call Sed32SinglePackWrite(Serv$, lin%, CraS%(), RegS%(), WriteDataS&(), RePlyS%(), check$)
            For i% = 1 To MaxPackLen%
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
            Length% = Length% - MaxPackLen%
            Count% = Count% + 1
        Loop
        If Length% > 0 Then
            ReDim CraS%(Length%), RegS%(Length%), WriteDataS&(Length%), RePlyS%(Length%)
            For i% = 1 To Length%
                CraS%(i%) = Cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                WriteDataS&(i%) = WriteData&(i% + Count% * MaxPackLen%)
            Next i%
            Call Sed32SinglePackWrite(Serv$, lin%, CraS%(), RegS%(), WriteDataS&(), RePlyS%(), check$)
            For i% = 1 To Length%
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
        End If
     
     End If
End Sub
Sub Sed32SinglePackRead(Serv$, lin%, Cra%(), reg%(), ReadData&(), Reply%(), check$)
        
    Dim ReplyFlag%, lSedErr&
    Dim Length&
    Dim PackLength%, i%, FifoLen%, TypArr%(6), RepeatCount%, Flen%
    Dim SedacPackRdArgument As SedacPackReadArg
    Dim SedacPackRdReturn As SedacPackReadRet
    
    Length = UBound(Cra%)
      
    If Length& = UBound(reg%) Then Else check$ = dimension_error:       Exit Sub
    If Length& = UBound(ReadData&) Then Else check$ = dimension_error:  Exit Sub
    If Length& = UBound(Reply%) Then Else check$ = dimension_error:     Exit Sub
    
    
    If Serv$ = LocalPC$ Then
    ' Local
         
        PackLength% = 2 * Length&
        ReDim PutArr&(1 To PackLength%)
    
        For i% = 1 To Length&                                       'Fill Ipackarray PutArr with UserData
          If Cra%(i%) < 0 Or Cra(i%) > 63 Then check = ADRESS_ERROR: Exit Sub
          If reg%(i%) < 0 Or reg(i%) > 255 Then check = ADRESS_ERROR: Exit Sub
          PutArr&(2 * i) = CLng(2 ^ 15 + 2 ^ 8 * Cra(i%) + reg(i%))  '
          PutArr&(2 * i - 1) = 0
        Next i%
                     
        ReDim ReplyArr&(1 To PackLength%)
           
        Call SedPut(lin%, Length&, PutArr&(1), lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedPut", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
            Call SedGet(lin%, Length&, ReplyArr&(1), lSedErr&)
            Call ErrorHandling(CInt(lSedErr&), "SedGet", Serv$, lin%, lin%, lin%, check$)
             For i% = 1 To Length&
               ' If ReplyArr&(2 * i - 1) > &H7FFF& Then ReplyArr&(2 * i - 1) = ReplyArr&(2 * i - 1) - &H10000
               ReadData&(i%) = ReplyArr&(2 * i - 1)
               Reply%(i%) = CInt(ReplyArr&(2 * i) And &H7)
             Next i%
        End If
    
        If frmSedFun.Check1 Then
          Call SedErrProt("PackRead", lin%, ERR_SEDPC, ERR_SEDPC, CInt(lSedErr&))
          If lSedErr& <> 0 Then
              Call ErrPackProt(Serv$, lin%, CInt(Length&), Cra%(), reg%(), Reply%())
          End If
        End If
    
    Else
          
    ' Remote
        
        For i% = 1 To Length&
            SedacPackRdArgument.Crate(i%) = Cra%(i%)
            SedacPackRdArgument.SubAdress(i%) = reg%(i%)
        Next i%
        SedacPackRdArgument.PackLen = Length&
        
        frmSedFun!ACOP1.DeviceProperty = "SedPacRD"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacPackRdReturn.Reply(0), Len(SedacPackRdReturn), "STRUCT", SedacPackRdArgument.Crate(0), Len(SedacPackRdArgument), "STRUCT")
      
        For i% = 1 To Length&
            ReadData&(i%) = SedacPackRdReturn.PackReadData(i%)
            Reply%(i%) = SedacPackRdReturn.Reply(i%)
        Next i%
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
    
End Sub

Sub Sed32MultiRead(Serv$, LinCnt%, lin%(), Cra%(), reg%(), ReadData&(), Reply%(), check$)
    
    ' linCnt%           Zahl der Lines

    ' Dim lin%(linCnt%,2)
    ' lin%(i%,1)        Line Nummer
    ' lin%(i%,2)        Zahl der Telegramme auf der Line lin(i%,1)

    ' Length%=Maximum von  lin%(i%,2) ber alle i%

    ' Dim cra%(Length%,linCnt%)
    ' cra%(i%,j%)       CrateAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim reg%(Length%,linCnt%)
    ' reg%(i%,j%)       SubAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim ReadData%(Length%,linCnt%)
    ' ReadData%(i%,j%)  DatenWort des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim Reply%(Length%,linCnt%)
    ' Reply%(i%,j%)     Antwort des i-ten Telegrams auf der Line lin%(j%,1)
    '

    Dim iSedErr%()
    Dim Check1$, check2$
    Dim i%, j%
    
    For i% = 1 To LinCnt%
        For j% = 1 To lin(i%, 2)                                      'Fill Ipackarray PutArr with UserData
            If Cra%(j%, i%) < 0 Or Cra(j%, i%) > 63 Then check = ADRESS_ERROR: Exit Sub
            If reg%(j%, i%) < 0 Or reg(j%, i%) > 255 Then check = ADRESS_ERROR: Exit Sub
        Next j%
    Next i%
    
        If Serv$ = LocalPC$ Then
          
        ' Local Sedac Read
           
           
        ReDim lSedErr&(LinCnt%)
    
        For i% = 1 To LinCnt%
            ReDim PutArr&(2 * lin(i%, 2))
            For j% = 1 To lin%(i%, 2)
                PutArr&(j% * 2) = CLng(2 ^ 15 + 2 ^ 8 * Cra(j%, i%) + reg(j%, i%))  '+ &H80 is SedPC DLL SedacReadFunction Code
                PutArr&(j% * 2 - 1) = 0                     'Sedac Subadress
            Next j%
            Call SedPut(CLng(lin%(i%, 1)), CLng(lin%(i%, 2)), PutArr&(1), lSedErr&(i%))
        Next i%
        For i% = 1 To LinCnt%
            Call ErrorHandling(CInt(lSedErr&(i%)), "SedPut", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), Check1$)
            If Check1$ = "ok" Then
                ReDim ReplyArr&(3 * lin(i%, 2))
                Call SedGet(CLng(lin%(i%, 1)), CLng(lin%(i%, 2)), ReplyArr&(1), lSedErr&(i%))
                Call ErrorHandling(CInt(lSedErr&(i%)), "SedGet", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), check2$)
                For j% = 1 To lin%(i%, 2)
                  ReadData&(j%, i%) = ReplyArr&(2 * j% - 1)
                  Reply%(j%, i%) = CInt(ReplyArr&(2 * j%) And &H7)
                Next j%
                If frmSedFun.Check1 Then
                    Call SedErrProt("PackRead", lin%(i%, 1), ERR_SEDPC, ERR_SEDPC, CInt(lSedErr&(i%)))
                    If lSedErr(i%) <> 0 Then
                        Call ErrMultiPackProt(Serv$, lin%(i%, 1), lin(i%, 2), Cra%(), reg%(), Reply%())
                    End If
                End If
                If check2$ <> "ok" Then check$ = check$ & ";Get: Line=" & lin%(i%, 1) & "," & check2$
            Else
                Check1$ = Replace(Check1$, " & Error in SedClr!!!", "")
                check$ = check$ & ";Put: Line=" & lin%(i%, 1) & "," & Check1$
            End If
        
        Next i%
        
        If check$ = "" Then
            check$ = "ok"
        Else
            check$ = Replace(check$, ";", "", 1, 1)
        End If
    
    Else
        check$ = "No remote Sedac-Access by multi-line functions"
    End If

End Sub
Sub Sed32MultiMixPairs(Serv$, LinCnt%, lin%(), Cra%(), reg%(), pReadWriteData&(), ReadWriteMode%(), Reply%(), check$)
'   wie Sed32MultiMix, nur der Parameter pReadWriteData hat eine Dimension mehr: Die 32-Bit Daten-Worte
'   sind aufgeteilt in zwei Integer

    Dim Length%, i%, j%
    Length = UBound(reg%)
    ReDim ReadWriteData&(Length, LinCnt%)
    Dim i_low%, i_high%
    
    For i% = 1 To Length%
        For j% = 1 To LinCnt%
            ReadWriteData&(i%) = LngFrom2Int(pReadWriteData&(i%, j%, LOW_), pReadWriteData&(i%, j%, HIGH_))
        Next j%
    Next i%
    
    Sed32MultiMix Serv$, LinCnt%, lin%(), Cra%(), reg%(), ReadWriteData&(), ReadWriteMode%(), Reply%(), check$

    If check$ = "ok" Then
        For j% = 1 To LinCnt%
            For i% = 1 To Length%
                LngTo2Int ReadWriteData&(i%, j%), i_low%, i_high%

                pReadWriteData&(i%, j%, HIGH_) = CLng(i_high%)
                pReadWriteData&(i%, j%, LOW_) = CLng(i_low%)
            Next i%
        Next j%
    End If
    
End Sub

Sub Sed32MultiMix(Serv$, LinCnt%, lin%(), Cra%(), reg%(), ReadWriteData&(), ReadWriteMode%(), Reply%(), check$)
    
    ' linCnt%           Zahl der Lines

    ' Dim lin%(linCnt%,2)
    ' lin%(i%,1)            Line Nummer
    ' lin%(i%,2)            Zahl der Telegramme auf der Line lin(i%,1)

    ' Length%=Maximum von lin%(i%,2) ber alle i%

    ' Dim cra%(Length%,linCnt%)
    ' cra%(i%,j%)           CrateAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim reg%(Length%,linCnt%)
    ' reg%(i%,j%)           SubAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim ReadWriteData%(Length%,linCnt%)
    ' ReadWriteData%(i%,j%) DatenWort des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim ReadWriteMode%(Length%,linCnt%)
    ' ReadWriteMode%(i%,j%) SEDAC_READ oder SEDAC_WRITE, je nachdem ob das i-te Telegram
    '                       auf der Line lin%(j%,1) gelesen oder geschrieben werden soll

    ' Dim Reply%(Length%,linCnt%)
    ' Reply%(i%,j%)     Antwort des i-ten Telegrams auf der Line lin%(j%,1)
    '

    Dim iSedErr%()
    Dim Check1$, check2$
    Dim i%, j%
    
    For i% = 1 To LinCnt%
        For j% = 1 To lin(i%, 2)                                      'Fill Ipackarray PutArr with UserData
            If Cra%(j%, i%) < 0 Or Cra(j%, i%) > 63 Then check = ADRESS_ERROR: Exit Sub
            If reg%(j%, i%) < 0 Or reg(j%, i%) > 255 Then check = ADRESS_ERROR: Exit Sub
        Next j%
    Next i%
    
    If Serv$ = LocalPC$ Then
          
        ' Local Sedac Read
           
           
        ReDim lSedErr&(LinCnt%)
    
        For i% = 1 To LinCnt%
            ReDim PutArr&(2 * lin(i%, 2))
            For j% = 1 To lin%(i%, 2)
                Select Case ReadWriteMode%(j%, i%)
                Case SEDAC_READ
                    PutArr&(j% * 2 + 1) = CLng(2 ^ 15 + 2 ^ 8 * Cra(j%, i%) + reg(j%, i%))
                    PutArr&(j% * 2 - 1) = 0
                Case SEDAC_WRITE
                    PutArr&(j% * 2 + 1) = CLng(2 ^ 14 + 2 ^ 8 * Cra(j%, i%) + reg(j%, i%))
                    PutArr&(j% * 2 - 1) = ReadWriteData&(j%, i%)
                End Select
            Next j%
            Call SedPut(CLng(lin%(i%, 1)), CLng(lin%(i%, 2)), PutArr&(1), lSedErr&(i%))
        Next i%
        For i% = 1 To LinCnt%
            Call ErrorHandling(CLng(lSedErr&(i%)), "SedPut", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), Check1$)
            If Check1$ = "ok" Then
                ReDim ReplyArr&(3 * lin(i%, 2))
                Call SedGet(CLng(lin%(i%, 1)), CLng(lin%(i%, 2)), ReplyArr&(1), lSedErr&(i%))
                Call ErrorHandling(CLng(lSedErr&(i%)), "SedGet", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), check2$)
                For j% = 1 To lin%(i%, 2)
                  ReadWriteData&(j%, i%) = ReplyArr&(2 * j% - 1)
                  Reply%(j%, i%) = CInt(ReplyArr&(2 * j%) And &H7)
                Next j%
                If frmSedFun.Check1 Then
                    Call SedErrProt("PackRead", lin%(i%, 1), ERR_SEDPC, ERR_SEDPC, CLng(lSedErr&(i%)))
                    If lSedErr&(i%) <> 0 Then
                        Call ErrMultiPackProt(Serv$, lin%(i%, 1), lin(i%, 2), Cra%(), reg%(), Reply%())
                    End If
                End If
                If check2$ <> "ok" Then check$ = check$ & ";Get: Line=" & lin%(i%, 1) & "," & check2$
            Else
                check$ = check$ & ";Put: Line=" & lin%(i%, 1) & "," & Check1$
            End If
        
        Next i%
        
        If check$ = "" Then
            check$ = "ok"
        Else
            check$ = Replace(check$, ";", "", 1, 1)
        End If
    
    Else
        check$ = "No remote Sedac-Access by multi-line functions"
    End If

End Sub


Sub Sed32MultiWrite(Serv$, LinCnt%, lin%(), Cra%(), reg%(), WriteData&(), Reply%(), check$)
    
    ' linCnt%           Zahl der Lines

    ' Dim lin%(linCnt%,2)
    ' lin%(i%,1)        Line Nummer
    ' lin%(i%,2)        Zahl der Telegramme auf der Line lin(i%,1)

    ' Length%=Maximum von  lin%(i%,2) ber alle i%

    ' Dim cra%(Length%,linCnt%)
    ' cra%(i%,j%)       CrateAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim reg%(Length%,linCnt%)
    ' reg%(i%,j%)       SubAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim WriteData%(Length%,linCnt%)
    ' ReadData%(i%,j%)  DatenWort des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim Reply%(Length%,linCnt%)
    ' Reply%(i%,j%)     Antwort des i-ten Telegrams auf der Line lin%(j%,1)
    '

    Dim iSedErr%()
    Dim Check1$, check2$
    Dim i%, j%
  
    For i% = 1 To LinCnt%
        For j% = 1 To lin(i%, 2)                                      'Fill Ipackarray PutArr with UserData
            If Cra%(j%, i%) < 0 Or Cra(j%, i%) > 63 Then check$ = ADRESS_ERROR: Exit Sub
            If reg%(j%, i%) < 0 Or reg(j%, i%) > 255 Then check$ = ADRESS_ERROR: Exit Sub
        Next j%
    Next i%
    
        If Serv$ = LocalPC$ Then
          
        ' Local Sedac Read
           
           
        ReDim lSedErr&(LinCnt%)
    
        For i% = 1 To LinCnt%
            ReDim PutArr&(2 * lin(i%, 2))
            For j% = 1 To lin%(i%, 2)
                PutArr&(j% * 2) = CLng(2 ^ 14 + 2 ^ 8 * Cra(j%, i%) + reg(j%, i%))
                PutArr&(j% * 2 - 1) = WriteData&(j%, i%)
            Next j%
            Call SedPut(CLng(lin%(i%, 1)), CLng(lin%(i%, 2)), PutArr&(1), lSedErr&(i%))
        Next i%
        check$ = ""
        For i% = 1 To LinCnt%
            Call ErrorHandling(iSedErr%(i%), "SedPut", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), Check1$)
            If Check1$ = "ok" Then
                ReDim ReplyArr&(3 * lin(i%, 2))
                Call SedGet(CLng(lin%(i%, 1)), CLng(lin%(i%, 2)), ReplyArr&(1), lSedErr&(i%))
                Call ErrorHandling(iSedErr%(i%), "SedGet", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), check2$)
                For j% = 1 To lin%(i%, 2)
                  Reply%(j%, i%) = CInt(ReplyArr&(2 * j%) And &H7)
                Next j%
                If frmSedFun.Check1 Then
                    Call SedErrProt("PackWrite", lin%(i%, 1), ERR_SEDPC, ERR_SEDPC, CInt(lSedErr&(i%)))
                    If lSedErr&(i%) <> 0 Then
                        Call ErrMultiPackProt(Serv$, lin%(i%, 1), lin(i%, 2), Cra%(), reg%(), Reply%())
                    End If
                End If
                If check2$ <> "ok" Then check$ = check$ & ";Get: Line=" & lin%(i%, 1) & "," & check2$
            Else
                Check1$ = Replace(Check1$, " & Error in SedClr!!!", "")
                check$ = check$ & ";Put: Line=" & lin%(i%, 1) & "," & Check1$
            End If
        
        Next i%
        
        If check$ = "" Then
            check$ = "ok"
        Else
            check$ = Replace(check$, ";", "", 1, 1)
        End If
    
    Else
        check$ = "No remote Sedac-Access by multi-line functions"
    End If

End Sub


Sub Sed32SinglePackWrite(Serv$, lin%, Cra%(), reg%(), WriteData&(), Reply%(), check$)
    
    Dim ReplyFlag%, lSedErr&
    Dim Length&
    Dim PackLength%, i%
    Dim SedacPackWrArgument As SedacPackWriteArg
    Dim SedacPackWrReturn As SedacPackWriteRet
    
    Length& = UBound(Cra%)
    If Length& = UBound(reg%) Then Else check$ = dimension_error:           Exit Sub
    If Length& = UBound(WriteData&) Then Else check$ = dimension_error:     Exit Sub
    If Length& = UBound(Reply%) Then Else check$ = dimension_error:         Exit Sub
      
    If Serv$ = LocalPC$ Then
        ' Local
    
        PackLength% = 2 * Length&
        ReDim PutArr&(1 To PackLength%)
          
        For i% = 1 To Length&                                   'Fill Ipackarray PutArr with UserData
            If Cra%(i%) < 0 Or Cra(i) > 63 Then check = ADRESS_ERROR: Exit Sub
            If reg%(i%) < 0 Or reg(i) > 255 Then check = ADRESS_ERROR: Exit Sub
            PutArr&(2 * i) = CLng(2 ^ 14 + 2 ^ 8 * Cra(i%) + reg(i%))   '
            PutArr&(2 * i - 1) = WriteData&(i%)
        Next i%
       
        
        ReDim ReplyArr&(1 To PackLength%)
        
        Call SedPut(CLng(lin%), Length&, PutArr&(1), lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedPut", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
           Call SedGet(CLng(lin%), Length&, ReplyArr&(1), lSedErr&)
           Call ErrorHandling(CInt(lSedErr&), "SedGet", Serv$, lin%, lin%, lin%, check$)
            For i% = 1 To Length&
               Reply%(i%) = CInt(ReplyArr&(2 * i) And &H7)
            Next i%
       End If
    
       If frmSedFun.Check1 Then
         Call SedErrProt("Packwrit", lin%, ERR_SEDPC, ERR_SEDPC, CInt(lSedErr&))
         If lSedErr& <> 0 Then
             Call ErrPackProt(Serv$, lin%, CInt(Length&), Cra%(), reg%(), Reply%())
         End If
       End If
    
    Else
        
    ' Remote
    
        For i% = 1 To Length&
            SedacPackWrArgument.Crate(i%) = Cra%(i%)
            SedacPackWrArgument.SubAdress(i%) = reg%(i%)
            SedacPackWrArgument.PackWriteData(i%) = WriteData&(i%)
        Next i%
        SedacPackWrArgument.PackLen = Length&
        
        frmSedFun!ACOP1.DeviceProperty = "SedPacWR"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacPackWrReturn.Reply(0), Len(SedacPackWrReturn), "STRUCT", SedacPackWrArgument.Crate(0), Len(SedacPackWrArgument), "STRUCT")
      
        For i% = 1 To Length&
            Reply%(i%) = SedacPackWrReturn.Reply(i%)
        Next i%
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
        
End Sub

 Sub Sed32Read(Serv$, lin%, Cra%, reg%, SedVal&, check$)
                
    Dim lSedErr&
    Dim lSedVal&
    Dim Li&, cr&, rg&
    Dim ReplyFlag%
    Dim SedacRdArgument As SedacReadArg
    Dim SedacRdReturn As Long

    If Cra% < 0 Or Cra% > 63 Then check$ = ADRESS_ERROR: Exit Sub
    If reg% < 0 Or reg% > 255 Then check$ = ADRESS_ERROR: Exit Sub
    
    If Serv$ = LocalPC$ Then
      
    ' Local
        
        Li& = CLng(lin%): cr& = CLng(Cra%): rg& = CLng(reg%)
        Call SedRd(Li&, cr&, rg&, lSedVal&, lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedRd", Serv$, lin%, Cra%, reg%, check$)
        If check$ = "ok" Then
            SedVal& = lSedVal&
        End If

    
        If frmSedFun.Check1 Then
            Call SedErrProt("SingRead", lin%, Cra%, reg%, CInt(lSedErr&))
        End If
    Else
        
    ' Remote
        
        check$ = ""
    
        SedacRdArgument.Crate = Cra%
        SedacRdArgument.SubAdress = reg%
        
        frmSedFun!ACOP1.DeviceProperty = "SedacRead"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacRdReturn, 1, "LONG", SedacRdArgument.Crate, Len(SedacRdArgument), "STRUCT")
        
        If ReplyFlag% = 0 Then
            SedVal& = SedacRdReturn
            check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
    
    End If
    

End Sub


Sub Sed32TestTelOff(Serv$, lin%, check$)
    
    Dim ReplyFlag%, lSedErr&

    If Serv$ = LocalPC$ Then
      
    ' Local
        
        Call SedTst(CLng(lin%), 0, 0, 0, 0, lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedTst", Serv$, lin%, lin%, lin%, check$)
    
        If frmSedFun.Check1 Then
        Call SedErrProt("TestTelOff", lin%, ERR_SEDTST, ERR_SEDTST, CInt(lSedErr&))
        End If

    Else
        
    ' Remote
        
        frmSedFun!ACOP1.DeviceProperty = "TstTelOff"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
     
End Sub
Sub Sed32GetTyps(Serv$, lin%, TypArr%(), check$)
    
        
    Dim ReplyFlag%, lSedErr&
    Dim i%, HardWareTyp&, ReleaseNr&, FiFoLength&
    Dim SedacGetTypsReturn%(4)
    If Serv$ = LocalPC$ Then
      
    ' Local
    
    
        Call SedTyp(CLng(lin%), HardWareTyp&, ReleaseNr&, FiFoLength&, lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedTyp", Serv$, lin%, lin%, lin%, check$)
        TypArr%(1) = HardWareTyp&
        TypArr%(2) = ReleaseNr&
        TypArr%(3) = FiFoLength&
        TypArr%(4) = lSedErr&
    
        If frmSedFun.Check1 Then
        Call SedErrProt("SedTyp", lin%, ERR_SEDTYP, ERR_SEDTYP, CInt(lSedErr&))
        End If
   
   Else
        
    ' Remote
        
        frmSedFun!ACOP1.DeviceProperty = "GetTyp"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetTypsReturn, 6, "Integer")
        
        If ReplyFlag% = 0 Then
            For i% = 1 To 4
                TypArr%(i%) = SedacGetTypsReturn(i%)
            Next i%
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
        
    End If
    
End Sub

Private Sub GetAllStatus(Serv$, lin%, a$, B$, c$, CrStr$(), check$)
    
    Dim lSedErr&, HardWareTyp&, ReleaseNr&, FiFoLength&, cr&, su&, lva&
    Dim i%, Class%, Dlay%, Stat&, Clr&
    Dim CntArr&(16), ErrArr%(256)
    Dim Version As String * 128, DllVersio As String * 64, Vers$, DVers$
    Dim SCheck$
    
    Call SedVer(CLng(lin%), Version$, lSedErr&)
    Call ErrorHandling(CInt(lSedErr&), "SedVer", Serv$, lin%, lin%, lin%, check$)
    
    Call SedDll(DllVersio)
    
    Call SedTyp(CLng(lin%), HardWareTyp&, ReleaseNr&, FiFoLength&, lSedErr&)
    Call ErrorHandling(CInt(lSedErr&), "SedTyp", Serv$, lin%, lin%, lin%, SCheck$)
    If SCheck$ <> "ok" Then check$ = check$ & SCheck$
    
    Call SedTst(CLng(lin%), 8, cr&, su&, lva&, lSedErr&)
    Call ErrorHandling(CInt(lSedErr&), "SedTsT", Serv$, lin%, lin%, lin%, SCheck$)
    If SCheck$ <> "ok" Then check$ = check$ & SCheck$
    
    Clr& = 1
    Call SedSta(CLng(lin%), Stat&, Clr&, lSedErr&)
    Call ErrorHandling(CInt(lSedErr&), "SedSta", Serv$, lin%, lin%, lin%, SCheck$)
    If SCheck$ <> "ok" Then check$ = check$ & SCheck$
    
    If HardWareTyp& > 0 Then
        Call SedCnt(CLng(lin%), CntArr&(1), lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedCnt", Serv$, lin%, lin%, lin%, SCheck$)
        If SCheck$ <> "ok" Then check$ = check$ & SCheck$
        If check$ = "" Then check$ = "ok"
    End If
    
    c$ = "Updated: " & date$ & " " & time$ & Chr$(13) & Chr$(10)
    Vers$ = Trim$(Replace(Version$, Chr$(0), " "))
    Vers$ = Replace(Vers$, Chr$(13) & Chr$(10), "   ", 1, 1)
    DVers$ = Trim$(Replace(DllVersio$, Chr$(0), " "))
    B$ = "Status of Sedac-Line " & lin% & " at " & LocalPC$
    a$ = "Updated: " & date$ & " " & time$ & Chr$(13) & Chr$(10)
    a$ = a$ & Vers$ & Chr$(13) & Chr$(10)
'    a$ = a$ & "Version der Dll:" & Chr$(13) & Chr$(10)
    a$ = a$ & DVers$ & Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10)
'    a$ = a$ & "Hardware Typ:" & Chr$(9) & Chr$(9) & HardWareTyp% & Chr$(13) & Chr$(10)
'    a$ = a$ & "ReleaseNr:" & Chr$(9) & Chr$(9) & ReleaseNr% & Chr$(13) & Chr$(10)
'    a$ = a$ & "Firmware Version:" & Chr$(9) & Chr$(9) & FirmWareVersion% & Chr$(13) & Chr$(10)
'    a$ = a$ & "Firmware Release:" & Chr$(9) & Chr$(9) & FirmWareRelease% & Chr$(13) & Chr$(10)
    a$ = a$ & "FiFo Length: " & Chr$(9) & Chr$(9) & FiFoLength& & Chr$(13) & Chr$(10)
    If cr& = 0 Then
        a$ = a$ & "Test Telegrams disabled" & Chr$(13) & Chr$(10)
    Else
        a$ = a$ & "Test Telegrams enabled, Param.: " & cr& & "," & su& & "," & lva& & Chr$(13) & Chr$(10)
    End If
    c$ = c$ & "Status(Hex):" & Chr$(9) & Hex$(Stat&) & Chr$(13) & Chr$(10)
    c$ = c$ & "d.h."
    If (Stat& And 1) = 1 Then c$ = c$ & Space$(3) & "Delay <> 0" & Chr$(13) & Chr$(10) Else c$ = c$ & Space$(3) & "Delay = 0" & Chr$(13) & Chr$(10)
    If (Stat& And 2) = 2 Then c$ = c$ & Space$(9) & "TestTel enabled " & Chr$(13) & Chr$(10) Else c$ = c$ & Space$(9) & "TestTel disabled " & Chr$(13) & Chr$(10)
    If HardWareTyp& > 0 Then
        If (Stat& And 8) = 8 Then c$ = c$ & Space$(9) & "There were Sedac-Errors" & Chr$(13) & Chr$(10) Else c$ = c$ & Space$(9) & "No Errors" & Chr$(13) & Chr$(10)
        If (Stat& And &HC0) <> 0 Then
            StatusLastReset$ = "Last Reset of SedPC at " & time$ & " " & date$
        End If
        c$ = c$ & Space$(9) & StatusLastReset$ & Chr$(13) & Chr$(10)
    End If
    a$ = a$ & Chr$(13) & Chr$(10)
    If HardWareTyp& > 0 Then
      a$ = a$ & "User Read Telegrams:" & Chr$(9) & CntArr&(2) & Chr$(13) & Chr$(10)
      a$ = a$ & "User Write Telegrams:" & Chr$(9) & CntArr&(3) & Chr$(13) & Chr$(10)
      a$ = a$ & "Test Telegrams:" & Chr$(9) & Chr$(9) & CntArr&(4) & Chr$(13) & Chr$(10)
     ' a$ = a$ & "Special Function Telegrams:" & Chr$(9) & CntArr&(5) & Chr$(13) & Chr$(10)
      a$ = a$ & "Cp's send, Progr. or Hardw.:" & Chr$(9) & CntArr&(5) & Chr$(13) & Chr$(10)
      a$ = a$ & "Progr. changes of Delay:" & Chr$(9) & CntArr&(6) & Chr$(13) & Chr$(10)
      a$ = a$ & "Progr. changes of TestTel.:" & Chr$(9) & CntArr&(7) & Chr$(13) & Chr$(10)
      a$ = a$ & Chr$(13) & Chr$(10)
      a$ = a$ & "Response Errors:" & Chr$(9) & Chr$(9) & CntArr&(9) & Chr$(13) & Chr$(10)
      a$ = a$ & "Parity Errors: " & Chr$(9) & Chr$(9) & CntArr&(10) & Chr$(13) & Chr$(10)
      a$ = a$ & "Framing Errors: " & Chr$(9) & Chr$(9) & CntArr&(11) & Chr$(13) & Chr$(10)
      'a$ = a$ & "Internal Errors: " & Chr$(9) & Chr$(9) & CntArr&(12) & Chr$(13) & Chr$(10)
      
      For i% = 0 To 30
          If (CntArr&(13) And 2 ^ i%) = 2 ^ i% Then CrStr$(1) = CrStr$(1) & "," & i%
          If (CntArr&(14) And 2 ^ i%) = 2 ^ i% Then CrStr$(2) = CrStr$(2) & "," & i%
          If (CntArr&(15) And 2 ^ i%) = 2 ^ i% Then CrStr$(3) = CrStr$(3) & "," & i%
      Next i%
      If CntArr&(13) < 0 Then CrStr$(1) = CrStr$(1) & "," & i%
      If CntArr&(14) < 0 Then CrStr$(2) = CrStr$(2) & "," & i%
      If CntArr&(15) < 0 Then CrStr$(3) = CrStr$(3) & "," & i%
      If CrStr$(1) <> "" Then CrStr$(1) = Right$(CrStr$(1), Len(CrStr$(1)) - 1)
      If CrStr$(2) <> "" Then CrStr$(2) = Right$(CrStr$(2), Len(CrStr$(2)) - 1)
      If CrStr$(3) <> "" Then CrStr$(3) = Right$(CrStr$(3), Len(CrStr$(3)) - 1)
    
      a$ = a$ & "Resp. Error in Crates:" & Chr$(9) & CrStr$(1) & Chr$(13) & Chr$(10)
      a$ = a$ & "Fram. Error in Crates:" & Chr$(9) & CrStr$(2) & Chr$(13) & Chr$(10)
      a$ = a$ & "Fifo Error in Crates:" & Chr$(9) & Chr$(9) & CrStr$(3) & Chr$(13) & Chr$(10)
    Else
        a$ = a$ & Chr$(13) & Chr$(10)
        a$ = a$ & " Old SEDPC doesn't give more Information!"
    End If
End Sub

Function LocalPC$()
    Dim ServPC$
    ServPC$ = Environ$("computername")
    If (Left$(ServPC$, 3) = "MST") Then ServPC$ = Replace$(ServPC$, "MST", "", 1, 1)
    If (Left$(ServPC$, 3) = "ACC") Then ServPC$ = Replace$(ServPC$, "ACC", "", 1, 1)
    If (Left$(ServPC$, 2) = "NT") Then ServPC$ = Replace$(ServPC$, "NT", "", 1, 1)
    If (Left$(ServPC$, 2) = "XP") Then ServPC$ = Replace$(ServPC$, "XP", "", 1, 1)
    LocalPC$ = ServPC$
End Function
Sub Sed32GetLine(Serv$, lin%, check$)
    
    Dim hWnd&, i%, LliCnt&
    Dim lLins&(MAX_NUMBER_OF_LINES)
    Dim lSedErr&
    Dim Found As Boolean
    Dim ReplyFlag%
    Dim SedacLinStrReturn(500) As Byte
    
    If Serv$ = LocalPC$ Then
      
    '   Local
        
        hWnd& = frmSedFun.hWnd   ' Window handle number
        
        Call SedIni(hWnd&, App.EXEName, LliCnt&, lLins&(1), lSedErr&)
        
        check$ = "ok"
        If lSedErr& = 2048 Then check$ = "GiveIO not running!" Else If lSedErr& <> 0 Then check$ = "Error #" & lSedErr& & " in SedIni"
        If LliCnt& = 0 Then check$ = no_such_line: Exit Sub
        If (LliCnt& > 0) Then
            For i% = 1 To UBound(lLins&)
                If lLins&(i% - 1) = lin% Then Found = True
            Next i%
        End If
        If Found = False Then check$ = "No Line " & lin%
    Else
        
    ' Remote
        frmSedFun!ACOP1.DeviceContext = Context$
        frmSedFun!ACOP1.DeviceProperty = "GetLines"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacLinStrReturn, 500, "BYTE")
        
        If ReplyFlag% = 0 Then
            check$ = BSTR(SedacLinStrReturn)
        Else
            check$ = frmSedFun!ACOP1.status
        End If
    End If


End Sub
Sub Sed32GetLines(Serv$, LinStr$, LinCnt%, LinAr$(), Lins%(), check$)
    
    Dim Ad%(MAX_NUMBER_OF_LINES)
    Dim hWnd&, i%, j%, k%, ModNo%, lin%, LliCnt&
    Dim lLins&(MAX_NUMBER_OF_LINES)
    Dim lSedErr&
    Dim ReplyFlag%
    Dim LinArr$(), Stri$
    Dim SedacLinStrReturn(500) As Byte
    
    If Serv$ = LocalPC$ Then
      
    '   Local
        
        hWnd& = frmSedFun.hWnd   ' Window handle number
        LinStr$ = ""
        
        Call SedIni(hWnd&, App.EXEName, LliCnt&, lLins&(1), lSedErr&)
        check$ = "ok"
        If lSedErr& = 2048 Then check$ = "GiveIO not running!" Else If lSedErr& <> 0 Then check$ = "Error #" & lSedErr& & " in SedIni"
        If LliCnt& = 0 Then check$ = no_such_line: Exit Sub
        If (LliCnt& > 0) Then
            For i% = 1 To UBound(lLins&)
                If lLins&(i% - 1) > 0 Then
                    j% = j + 1
                    ReDim Preserve Lins%(j%)
                    ReDim Preserve LinAr$(j%)
                    Lins%(j%) = CInt(lLins&(i%))
                    LinAr$(j%) = "Line " & Lins%(j%)
                    If i% = 1 Then
                        LinStr$ = LinAr$(i%)
                    Else
                        LinStr$ = LinStr$ & Chr$(10) & LinAr$(j%)
                    End If
                End If
            Next i%
        End If
        LinCnt% = CInt(LliCnt&)
                
    Else
        
    ' Remote
        check$ = "ok"
        For j% = 1 To MAX_NUMBER_OF_LINES
            frmSedFun!ACOP1.DeviceContext = Context$
            frmSedFun!ACOP1.DeviceProperty = "GetLines"
            frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(j%, "0") & "_Sd32"
            frmSedFun!ACOP1.AccessMode = "READ"
            ReplyFlag% = frmSedFun!ACOP1.Execute(SedacLinStrReturn, 500, "BYTE")
            
            If ReplyFlag% = 0 Then
                i% = 0
                Do While SedacLinStrReturn(i%) <> 0 And i% < 500
                    LinStr$ = LinStr$ & Chr$(SedacLinStrReturn(i%))
                    i% = i% + 1
                Loop
                If LinStr$ = "ok" Then
                    LinCnt% = LinCnt% + 1
                    ReDim Preserve Lins%(LinCnt%), LinAr$(LinCnt%)
                    LinArr$(LinCnt%) = LinStr$
                    Lins%(LinCnt%) = j%
                Else
                    check$ = LinStr$
                End If
            Else
                check$ = frmSedFun!ACOP1.status
            End If
        Next j%
        If LinCnt% = 0 And check$ = "ok" Then
            check$ = no_such_line
        End If
    End If


End Sub

Sub SedacClearAllCounters(Serv$, lin%, check$)
    
    Dim lSedErr&
    Dim ReplyFlag%
    Dim FilNo%, Filna$
    
    If Serv$ = LocalPC$ Then
      
        ' Local
        
       
        Call SedCac(CLng(lin%), lSedErr&)
        
        Call ErrorHandling(CInt(lSedErr&), "SedCac", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
            On Error Resume Next
            FilNo% = FreeFile
            Filna$ = "c:\prot\Sedac\LClrDat.txt"
            Open Filna$ For Output As FilNo%
                If Err <> 0 Then check$ = Error(Err)
                Print #FilNo%, Now
            Close FilNo%
            On Error GoTo 0

        End If

    
        If frmSedFun.Check1 Then
            Call SedErrProt("ClearCnt", lin, ERR_SEDDLY, ERR_SEDDLY, CInt(lSedErr&))
        End If
    
    
    Else
        'remote
        
        frmSedFun!ACOP1.DeviceProperty = "ClrCount"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute
        check$ = frmSedFun!ACOP1.status
    End If
'
End Sub
Sub SedacGetAllStatus(Serv$, lin%, a$, B$, c$, CrStr$(), check$)
            
    Dim LinID$, iSedErr%
    Dim ReplyFlag%
    Dim fcr%, su%, dat%
    Dim StrArr$()
    Dim SedacLiStatReturn As String * 1200

        If Serv$ = LocalPC$ Then
      
    ' Local
        
        Call GetAllStatus(Serv$, lin%, a$, B$, c$, CrStr$(), check$)

        If frmSedFun.Check1 Then
            Call SedErrProt("GetAllStatus", lin%, ERR_SEDTST, ERR_SEDTST, iSedErr%)
        End If

    Else
        
    ' Remote
        
        
        frmSedFun!ACOP1.DeviceProperty = "AllStat"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacLiStatReturn, 1200, "TEXT")
        
        If ReplyFlag% = 0 Then
'            Dim i%, d$
'            i% = 0
'            Do While SedacLiStatReturn(i%) <> 0 And i% < 1200
'                d$ = d$ & Chr$(SedacLiStatReturn(i%))
'                i% = i% + 1
'            Loop
            
            StrArr$() = Split(SedacLiStatReturn$, "@")
            check$ = StrArr$(0)
            B$ = StrArr$(1)
            a$ = StrArr$(2)
            c$ = StrArr$(3)
        Else
            check$ = frmSedFun!ACOP1.status
        End If
    End If
End Sub


Sub Sed32GetTestTel(Serv$, lin%, sval$, check$)
    
    Dim fcr&, su&, dat&
    Dim ReplyFlag%
    Dim lSedErr&
    Dim StrArr$()
    Dim SedacGetTestTelReturn(50) As Byte
    
    If Serv$ = LocalPC$ Then
      
    ' Local
        
        Call SedTst(CLng(lin%), 8, fcr&, su&, dat&, lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedTst", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
            If fcr& = 0 Then
                sval$ = "Keine Testtelegramme"
            Else
                sval$ = "Testtelegramme mit fcr=" & fcr& & ",su=" & su& & ",dat=" & dat&
            End If
        End If
    
    
        If frmSedFun.Check1 Then
            Call SedErrProt("TestTelOff", lin, ERR_SEDTST, ERR_SEDTST, CInt(lSedErr&))
        End If
    
    
    Else
        
    ' Remote
        
        frmSedFun!ACOP1.DeviceProperty = "GetTstTl"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetTestTelReturn, 50, "BYTE")
        
        If ReplyFlag% = 0 Then
            
            StrArr$() = Split(BSTR(SedacGetTestTelReturn), Chr$(10))
            check$ = StrArr$(0)
            sval$ = StrArr$(1)
        Else
            check$ = frmSedFun!ACOP1.status
        End If
   End If
     
End Sub


Sub Sed32TestTelOn(Serv$, lin%, check$)
        
    Dim ReplyFlag%, lSedErr&
    
    If Serv$ = LocalPC$ Then
      
    ' Local
        
        Call SedTst(lin%, 3, &HC0, 0, 0, lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedTst", Serv$, lin%, lin%, lin%, check$)
    
        If frmSedFun.Check1 Then
            Call SedErrProt("TestTelOn", lin%, ERR_SEDTST, ERR_SEDTST, CInt(lSedErr&))
        End If

    Else
        
    ' Remote
        
        frmSedFun!ACOP1.DeviceProperty = "TstTelOn"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
     
End Sub

Sub Sed32Write(Serv$, lin%, Cra%, reg%, SedVal&, check$)
                
    Dim lSedErr&
    Dim lSedVal&
    Dim Li&, cr&, rg&
    Dim ReplyFlag%
    Dim SedacWrArgument As SedacWriteArg
    
    If Cra% < 0 Or Cra% > 63 Then check$ = ADRESS_ERROR:    Exit Sub
    If reg% < 0 Or reg% > 255 Then check$ = ADRESS_ERROR:   Exit Sub
    
    If Serv$ = LocalPC$ Then
    
        ' Local

        lSedErr& = 0
        lSedVal& = SedVal&
        Li& = lin%: cr& = Cra%: rg& = reg%
        Call SedWr(Li&, cr&, rg&, lSedVal&, lSedErr&)
        Call ErrorHandling(CInt(lSedErr&), "SedWr", Serv$, lin%, Cra%, reg%, check$)

        If frmSedFun.Check1 Then
            Call SedErrProt("SingWrit", lin, Cra, reg, CInt(lSedErr&))
        End If
    
    Else

        ' Remote
      
        check$ = ""
    
        SedacWrArgument.Crate = Cra%
        SedacWrArgument.SubAdress = reg%
        SedacWrArgument.Value = SedVal&
        
        frmSedFun!ACOP1.DeviceProperty = "SedacWrite"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_Sd32"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(, , , SedacWrArgument.Crate, Len(SedacWrArgument), "STRUCT")
            
        If ReplyFlag% = 0 Then
                check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
    End If
         
End Sub

Sub SedErrProt(Serv$, lin%, Cra%, reg%, SedErr%)
        
'    frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'    frmSedFun!Send1.RemoteID = "SedProt"
'    frmSedFun!Send1.Property = "SedSErr"
'    frmSedFun!Send1.LineAdr(1) = lin%
'    frmSedFun!Send1.CrateAdr(1) = cra%
'    frmSedFun!Send1.SubAdr(1) = reg%
'    frmSedFun!Send1.SValue(1) = 0
'    frmSedFun!Send1.SFlag(1) = sederr%
'    frmSedFun!Send1.SedacMsg = 1

End Sub


Function LngFrom2Int(iLow&, iHigh&) As Long
' 2 Integer, bzw 2 16-Bit unsigned, werden in ein Long-Word gepackt
    
    Dim fl As Boolean
    Dim l&, iValLow&, iValHigh&
    
    iValLow& = iLow&
    iValHigh& = iHigh&
    
    If iValHigh& < 0 Then iValHigh& = iValHigh& + &H10000
    If iValLow& < 0 Then iValLow& = iValLow& + &H10000
    
    If iValHigh& > &HFFFF& Then Exit Function
    If iValLow& > &HFFFF& Then Exit Function
    
    If iValHigh& > &H7FFF& Then
        iValHigh& = iValHigh& And &H7FFF&
        fl = True
    End If
    
    l& = iValLow& + iValHigh& * &H10000
    If fl Then LngFrom2Int = (l& Or &H80000000) Else LngFrom2Int = l&
    
End Function



