Attribute VB_Name = "Alarm"
Option Explicit

Global Const almNEWALARM = &H1
Global Const almHEARTBEAT = &H2
Global Const almOSCILLATION = &H4
Global Const almDATACHANGE = &H8
Global Const almINSTANT = &H10
Global Const almTERMINATE = &H40
Global Const almTEST = &H80

Type AMS            ' Alarm Message Structure
tag(15) As Byte
device(15) As Byte
almTag(15) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmData(5) As Byte
alarmDataFormat As Byte
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
alarmSystem As Integer
End Type

Type AMRB         ' Alarm Message Request Block
starttime As Long
stoptime As Long
severity As Long
reservered As Long
End Type

Type ASB        ' Alarm Status Block
nalarms As Long
mostRecentAlarmTime As Long
highestSeverity As Long
nalarmsAtMostRecentAlarmTime As Long
nalarmsAtHighestSeverity As Long
End Type

Type ADS
tag(15) As Byte
code As Long
mask As Long
severity As Integer
dataFormat As Byte
dataDim As Byte
timeRes As Long
hitsChannel As Integer
hitsModule As Integer
AlarmText(39) As Byte
deviceText(37) As Byte
alarmSystem As Integer
dataText(39) As Byte
url(39) As Byte
Reserved As Long
End Type

Type CASQS
devcontext(15) As Byte
devServer(15) As Byte
subsystem(15) As Byte
arcExt(15) As Byte
SeverityLevel As Long
ArchiveLevel As Long
Retention As Long
AlarmLevel As Long
alarmSystem As Long
End Type

Declare Function appendAlarmInfoTable Lib "winsrv32.dll" (ByVal localname As String, localADS As ADS) As Integer
Declare Function SetMaximumAlarms Lib "winsrv32.dll" (ByVal maxnum As Integer) As Integer

Function GetPMArchivedStruct(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal devName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As AMS)
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8

Static SessionID As Integer
Static eventTag As String
Static pmArcGrp As String
Static done As Boolean

If pmArchiveServer$ = "" Then
 pmArchiveServer$ = "APC"
End If

If Not done Then
  FILLSTRUCT "APCBLK", Len(apc), 1, CF_NULL
  done = True
End If

rc& = 0
evnTag$ = LCase(evnTag$)
If eventTag <> evnTag Or pmArchiveGroup$ <> pmArcGrp Then ' new session
  eventTag = evnTag
  pmArcGrp = pmArchiveGroup$
  If SessionID% > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "CLOSE", dout, 0, din, SessionID%, 1, 1000)
    If rc& Then GoTo GetPMArchivedStructError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedStructError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "OPEN", dout, SessionID%, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedStructError
End If
If eventTag = "" Then GoTo GetPMArchivedStructError

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

apc.SessionID = SessionID%
BARR apc.EqpName(), dServerName$
BARR apc.devName(), dName$
BARR apc.devProperty(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLK"

dout.dArrayLength = npoints
dout.dFormat = CF_STRUCT
rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, DataBuffer, din, apc, 1, 1000)
If rc& Then GoTo GetPMArchivedStructError

GetPMArchivedStructError:
GetPMArchivedStruct = rc&
End Function


Function GetAlarmDefinitions(devServer As String, adefs() As ADS, nadefs As Integer) As Integer
Dim devName$, rc%, i%, n%
Dim dout As DBLK, din As DBLK
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(devServer, "NALMDEFS", dout, n%, din, 0, CA_READ, 200)
If n% > 163 Then n% = 163
If rc% Or n% = 0 Then GoTo GetAlarmDefinitionsError
ReDim adefs(n%)
dout.dArrayLength = n * Len(adefs(0)): dout.dFormat = CF_STRUCT
rc% = T_EXECLINK(devServer, "ALMDEFS", dout, adefs(0), din, 0, CA_READ, 200)
If rc% Then GoTo GetAlarmDefinitionsError
GetAlarmDefinitionsError:
nadefs = n%
GetAlarmDefinitions = rc%
End Function
