Attribute VB_Name = "archive"
Option Explicit
'==========================================================
'==                                                      ==
'==     archive retrieval routines following LPC format  ==
'==                                                      ==
'==========================================================
Global pmArchiveServer$
Global SessionID%
Global eventTag As String
Global pmArcGrp As String
Global gArchiveServer As String

Type APCBLK
  SessionID As Long
  Event As Long
  Ext(3) As Byte
  EqpName(15) As Byte
  devName(15) As Byte
  devProperty(31) As Byte
  dsize As Integer
  dFormat As Integer
End Type

Type ARS
  starttime As Long
  idx As Integer
  mins As Integer
  keyword(15) As Byte
End Type

Type ADRB
  eventNumber As Long
  starttime As Long
  stoptime As Long
  deviceServerName(15) As Byte
  deviceProperty(15) As Byte
  deviceName(15) As Byte
  DataFormat As Integer
  dataDimension As Integer
End Type

Type DHS
channelID(31) As Byte
eventCode As Long
arraySize As Integer
datatype As Integer
samplingRate As Single
preTrigger As Long
timeOffset As Long
lowCount As Long
highCount As Long
egu(15) As Byte
eguLow As Single
eguHigh As Single
Reserved(3) As Byte
desc(255) As Byte
End Type

Type RPCSTRING
  text(255) As Byte
End Type

Declare Function LOADEQP Lib "apc32.dll" (ByVal filename$, ByVal yr%) As Integer
Declare Function CLOSEEQP Lib "apc32.dll" () As Integer
Declare Function LPC Lib "apc32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal size%, d As Any, ByVal dsize%, ByVal fmt%) As Integer
Declare Function apc Lib "apc32.dll" Alias "APC" (ByVal eqm$, ByVal dev$, ByVal prop$, ByVal size%, d As Any, ByVal fmt%) As Integer
Declare Function A_LPC Lib "apc32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function FILER Lib "apc32.dll" (ByVal fname$, f As FSTRUCT, ByVal num%, ByVal yr%) As Integer
Declare Function READCMT Lib "apc32.dll" (ByVal cmt$, ByVal filename$, ByVal yr%) As Integer
Declare Function WRITECMT Lib "apc32.dll" (ByVal cmt$, ByVal filename$, ByVal yr%) As Integer
Declare Function REMOVE Lib "apc32.dll" (ByVal filename$, ByVal yr%) As Integer
Declare Function GetEventList Lib "apc32.dll" (ByVal archiveGroup$, ByVal starttime&, ByVal stoptime&, numEvents%, evnList&, evnTime As NAME32) As Integer
Declare Function GetEvents Lib "apc32.dll" (ByVal archiveGroup$, ByVal starttime&, ByVal stoptime&, numEvents%, evnList&) As Integer
Declare Function GetEventData Lib "apc32.dll" (ByVal archiveGroup$, ByVal evnNr&, ByVal devName$, ByVal devProperty$, npoints&, ByVal Format%, DataBuffer As Any) As Integer

'==========================================================
'==                                                      ==
'==         HERA DATA Retrieval routines                 ==
'==                                                      ==
'==========================================================

Declare Function FETCH Lib "apc32.dll" (ByVal keyword$, ByVal index%, ByVal start&, ByVal Minutes%, ByVal size%, dat As Any, tstamp&) As Integer
Declare Sub FTIME Lib "apc32.dll" (dst!, src&, ByVal shft&, ByVal num%)
Declare Sub ARRLOG Lib "apc32.dll" (dst!, src!, ByVal num%)
' Desired time axis given by tx& array,
' input: Y! array and its time axis array ty&
'        nY% maximum number of points in the Y! array
'        nX% number of points in the tx& axis array
' output: y! array (converted onto the tx& time axis)
Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
Function GetArchivedSubSystems(arcServerName As String, SubSystems() As String, numSubSystems As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim rc%, i%, n%
Dim lclsubs(100) As NAME16
Dim subs$
dout.dFormat = CF_SHORT: dout.dArrayLength = 1
din.dFormat = CF_NULL: din.dArrayLength = 0
rc% = T_EXECLINK(arcServerName, "NSUBSYSTEMS", dout, numSubSystems, din, 0, CA_READ, 1000)
If rc% Then
  numSubSystems = 0
  GoTo GetArchivedSubSystemsErr
End If
If numSubSystems > 100 Then numSubSystems = 100
dout.dFormat = CF_NAME16: dout.dArrayLength = numSubSystems
rc% = T_EXECLINK(arcServerName, "SUBSYSTEMS", dout, lclsubs(0), din, 0, CA_READ, 1000)
If rc% Then
  numSubSystems = 0
  GoTo GetArchivedSubSystemsErr
End If
ReDim SubSystems(numSubSystems + 1)
For i% = 0 To numSubSystems - 1
  subs$ = BSTR(lclsubs(i%).nam())
  If Len(subs$) > 0 And (subs$ <> "Dummy") Then
    SubSystems(n%) = subs$
    n% = n% + 1
  End If
Next
SubSystems(n%) = "All Systems"
numSubSystems = n% + 1
GetArchivedSubSystemsErr:
GetArchivedSubSystems = rc%
End Function

Function GetArchivedParameters(arcServerName As String, arcSubSystem As String, Keywords() As String, numKeywords As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim rc%, i%, n%, nprps&, kwd$
Dim lclprps(1000) As NAME32, subs As NAME16
Dim prps() As String
Dim searchstr(80) As Byte
dout.dFormat = CF_SHORT: dout.dArrayLength = 1
din.dFormat = CF_NULL: din.dArrayLength = 0
rc% = T_EXECLINK(arcServerName, "NTAGS", dout, numKeywords, din, 0, CA_READ, 1000)
If numKeywords > 1000 Then numKeywords = 1000
If rc% Then GoTo GetArchivedParametersErr
dout.dFormat = CF_NAME32: dout.dArrayLength = numKeywords
If Left(arcSubSystem, 7) = "SEARCH:" Then
  BARR searchstr, Right(arcSubSystem, Len(arcSubSystem) - 7)
  din.dFormat = CF_TEXT: din.dArrayLength = Len(arcSubSystem) - 7
ElseIf Len(arcSubSystem) = 0 Or arcSubSystem = "All Systems" Then
  subs.nam(0) = 0
  din.dFormat = CF_NULL: din.dArrayLength = 0
Else
  BARR searchstr, arcSubSystem
  din.dFormat = CF_NAME16: din.dArrayLength = 1
End If
rc% = T_EXECLINK(arcServerName, "TAGS", dout, lclprps(0), din, searchstr(0), CA_READ, 1000)
If rc% Then
  numKeywords = 0
  GoTo GetArchivedParametersErr
End If
ReDim Keywords(numKeywords)
n% = 0
For i% = 0 To numKeywords - 1
  kwd$ = BSTR(lclprps(i%).nam())
  If Len(kwd$) > 0 And _
     (kwd$ <> "dummy") And _
     (Right(kwd$, 4) <> ".NAM") Then
    Keywords(n%) = kwd$
    n% = n% + 1
  End If
Next
numKeywords = n%
GetArchivedParametersErr:
GetArchivedParameters = rc%
End Function
Function GetArchivedKeywords(arcServerName As String, Keywords() As String, numKeywords As Integer) As Integer
Dim rc%, i%, n%, nprps&, kwd$
Dim lclprps(1000) As NAME32
Dim prps() As String
Dim cntxt As NAME16, srv As NAME16, dev As NAME16
nprps& = 1000
BARR cntxt.nam(), "": BARR srv.nam(), arcServerName: BARR dev.nam(), "#0"
rc% = T_GETDEVICEPROPERTIES(cntxt, srv, dev, lclprps(0), nprps&)
If rc% Then nprps& = 0
numKeywords = nprps&
'rc% = GetEquipmentDeviceProperties(arcServerName, prps(), numKeywords)
If rc% Then GoTo GetArchivedKeywordsErr
ReDim Keywords(numKeywords)
n% = 0
For i% = 0 To numKeywords - 1
  kwd$ = BSTR(lclprps(i%).nam())
  If (kwd$ <> "FETCH") And _
     (kwd$ <> "dummy") And _
     (Right(kwd$, 4) <> ".NAM") Then
    Keywords(n%) = kwd$
    n% = n% + 1
  End If
Next
numKeywords% = n%
GetArchivedKeywordsErr:
  GetArchivedKeywords = rc%
End Function
Function GetPMGroups(devSrvNames() As String, numDevSrvs As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim dsn() As NAME16
Dim rc%, i%
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK("MARCHSRV", "NDSERVERS", dout, numDevSrvs, din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMGroupsErr
ReDim dsn(numDevSrvs)
dout.dArrayLength = numDevSrvs: dout.dFormat = CF_NAME16
rc% = T_EXECLINK("MARCHSRV", "DSERVERS", dout, dsn(0), din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMGroupsErr
ReDim devSrvNames(numDevSrvs)
For i% = 0 To numDevSrvs - 1
  If dsn(i).nam(0) = 0 Then Exit For
  devSrvNames(i%) = BSTR(dsn(i%).nam())
Next
numDevSrvs = i%
GetPMGroupsErr:
  GetPMGroups = rc%
End Function
Function GetPMDevices(ByVal pmDeviceServer$, DeviceNames() As String, numDevices As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim dn() As NAME16
Dim rc%, i%

dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK("MARCHSRV/" & pmDeviceServer$, "NADEVICES", dout, numDevices, din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMDevicesErr
ReDim dn(numDevices)
dout.dArrayLength = numDevices: dout.dFormat = CF_NAME16
rc% = T_EXECLINK("MARCHSRV/" & pmDeviceServer$, "ADEVICES", dout, dn(0), din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMDevicesErr
ReDim DeviceNames(numDevices)
For i% = 0 To numDevices - 1
  DeviceNames(i%) = BSTR(dn(i%).nam())
Next
GetPMDevicesErr:
GetPMDevices = rc%
End Function
Function GetPMProperties(ByVal pmDeviceServer$, Properties() As String, numProperties As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim prp() As NAME16
Dim rc%, i%
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK("MARCHSRV/" & pmDeviceServer$, "NAPROPS", dout, numProperties, din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr
ReDim prp(numProperties)
dout.dArrayLength = numProperties: dout.dFormat = CF_NAME16
rc% = T_EXECLINK("MARCHSRV/" & pmDeviceServer$, "APROPS", dout, prp(0), din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr
ReDim Properties(numProperties)
For i% = 0 To numProperties - 1
  Properties(i%) = BSTR(prp(i%).nam())
Next
GetPMPropertiesErr:
GetPMProperties = rc%
End Function
Function ClosePMArchivedDataSession()
Dim rcc As Long
Dim dout As DBLK, din As DBLK
  If SessionID% > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rcc = T_EXECLINK(pmArchiveServer$ & "/" & pmArcGrp, "CLOSE", dout, 0, din, SessionID%, 1, 1000)
    If rcc Then GoTo ClosePMArchivedDataError
  End If
ClosePMArchivedDataError:
  ClosePMArchivedDataSession = rcc
  SessionID% = 0
End Function

Function GetPMArchivedData(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal devName$, ByVal devProperty$, npoints As Integer, DataBuffer As Variant)
'Static SessionID As Integer
'Static eventTag As String
'Static pmArcGrp As String
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double
Static done As Boolean

If pmArchiveServer$ = "" Then
 pmArchiveServer$ = "APC"
End If

If Not done Then
  FILLSTRUCT "APCBLK", Len(apc), 1, CF_NULL
  done = True
End If

rc& = 0
evnTag$ = LCase(evnTag$)
If eventTag <> evnTag Or pmArchiveGroup$ <> pmArcGrp Then ' new session
  eventTag = evnTag
  pmArcGrp = pmArchiveGroup$
  If SessionID% > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "CLOSE", dout, 0, din, SessionID%, 1, 1000)
    If rc& Then GoTo GetPMArchivedDataError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedDataError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "OPEN", dout, SessionID%, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedDataError
End If
If eventTag = "" Then GoTo GetPMArchivedDataError

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

apc.SessionID = SessionID%
BARR apc.EqpName(), dServerName$
BARR apc.devName(), dName$
BARR apc.devProperty(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLK"

If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
  rc& = 2
  GoTo GetPMArchivedDataError
End If

dout.dArrayLength = npoints
Select Case VarType(DataBuffer) - vbArray
  Case vbInteger:
       ReDim ID(npoints)
       dout.dFormat = CF_SHORT
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, ID(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ID(i%): Next
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, ld(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ld(i%): Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, fd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = fd(i%): Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, dd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = dd(i%): Next
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDataError

GetPMArchivedDataError:
GetPMArchivedData = rc&
End Function
Function GetPMArchivedHeader(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal devName$, ByVal devProperty$, hdr As DHS) As String
Dim devHdr As DHS
Dim devadrb As ADRB
Dim rc%, p%, dServerName$, dName$
Dim dout As DBLK, din As DBLK
Dim s$
Static done As Boolean

If Not done Then
  FILLSTRUCT "DHS", Len(devHdr), 1, CF_NULL
  FILLSTRUCT "ADRB", Len(devadrb), 1, CF_NULL
  done = True
End If

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

devadrb.eventNumber = evnNumber&
BARR devadrb.deviceName(), dName$
BARR devadrb.deviceServerName, dServerName$
BARR devadrb.deviceProperty, devProperty$
devadrb.starttime = evnNumber&
devadrb.stoptime = evnNumber&

dout.dArrayLength = 1: dout.dFormat = CF_STRUCT: BARR dout.dTag(), "DHS"
din.dArrayLength = 1: din.dFormat = CF_STRUCT: BARR din.dTag(), "ADRB"
rc% = T_EXECLINK("MARCHSRV/" & pmDeviceServer$, "ARCHHEADER", dout, devHdr, din, devadrb, CA_READ, 1000)
If rc% Then
  GetPMArchivedHeader = RPCERROR(rc%)
  Exit Function
End If
hdr = devHdr
s$ = ""
s$ = s$ + "ChannelID : " + BSTR(devHdr.channelID()) + vbNewLine
s$ = s$ + "ArraySize : " + str$(devHdr.arraySize) + vbNewLine
s$ = s$ + "DataType : " + str$(devHdr.datatype) + vbNewLine
s$ = s$ + "EGU : " + BSTR(devHdr.egu()) + vbNewLine
s$ = s$ + "eguHigh : " + str$(devHdr.eguHigh) + vbNewLine
s$ = s$ + "eguLow : " + str$(devHdr.eguLow) + vbNewLine
s$ = s$ + "eventCode : " + str$(devHdr.eventCode) + vbNewLine
s$ = s$ + "highCount : " + str$(devHdr.highCount) + vbNewLine
s$ = s$ + "lowCount : " + str$(devHdr.lowCount) + vbNewLine
s$ = s$ + "preTrigger : " + str$(devHdr.preTrigger) + vbNewLine
s$ = s$ + "timeOffset : " + str$(devHdr.timeOffset) + vbNewLine
s$ = s$ + "samplingRate : " + str$(devHdr.samplingRate) + vbNewLine
s$ = s$ + "desc : " + BSTR(devHdr.desc()) + vbNewLine
GetPMArchivedHeader = s$

End Function
Function GetPMArchivedDeviceData(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal devName$, ByVal devProperty$, npoints As Integer, DataBuffer As Variant)
Static pmDevSrv As String
Dim dout As DBLK, din As DBLK
Dim ab As ADRB
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double
Static done As Boolean

If Not done Then
  FILLSTRUCT "ADRB", Len(ab), 1, CF_NULL
  done = True
End If

rc& = 0
p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

BARR ab.deviceServerName(), dServerName$
BARR ab.deviceName(), dName$
BARR ab.deviceProperty(), devProperty$
ab.eventNumber = evnNumber&
ab.starttime = evnNumber&
ab.stoptime = evnNumber&

din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "ADRB"

If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
  rc& = 2
  GoTo GetPMArchivedDeviceDataError
End If

dout.dArrayLength = npoints
Select Case VarType(DataBuffer) - vbArray
  Case vbInteger:
       ReDim ID(npoints)
       dout.dFormat = CF_SHORT
       rc& = T_EXECLINK("MARCHSRV", "ARCHDATA", dout, ID(0), din, ab, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ID(i%): Next
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       rc& = T_EXECLINK("MARCHSRV", "ARCHDATA", dout, ld(0), din, ab, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ld(i%): Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       rc& = T_EXECLINK("MARCHSRV", "ARCHDATA", dout, fd(0), din, ab, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = fd(i%): Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       rc& = T_EXECLINK("MARCHSRV", "ARCHDATA", dout, dd(0), din, ab, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = dd(i%): Next
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDeviceDataError

GetPMArchivedDeviceDataError:
GetPMArchivedDeviceData = rc&
End Function
Function GetPMEventList(ByVal pmArchiveGroup$, ByVal starttime&, ByVal stoptime&, evnList() As String, evnTime() As String) As Integer
Dim dout As DBLK, din As DBLK
Dim nevents As Integer
Dim lStartStopArray(1) As Long
Dim eventNames() As NAME8
Dim i%, rc&, tmpTime As String * 32
Dim t As Long
Dim devName As String

If pmArchiveServer$ = "" Then
 pmArchiveServer$ = "APC"
End If

devName$ = pmArchiveServer$ & "/" + pmArchiveGroup$

dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 2: din.dFormat = CF_LONG
lStartStopArray(0) = starttime&
lStartStopArray(1) = stoptime&

rc& = T_EXECLINK(devName, "QUERY.NFILES", dout, nevents, din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetPMEventListError

If nevents = 0 Then GoTo GetPMEventListError
ReDim eventNames(nevents - 1)

dout.dArrayLength = nevents: dout.dFormat = CF_NAME8
rc& = T_EXECLINK(devName, "QUERY.FILES", dout, eventNames(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetPMEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = BSTR(eventNames(i%).nam())
  t = CLng(Val("&H" & evnList(i%)))
  If t > 0 Then
    CTIME tmpTime, t
  Else
    tmpTime = str$(t)
  End If
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMEventListError:
GetPMEventList = IIf(rc&, -rc&, nevents)
End Function
Function GetPMDeviceEventList(ByVal pmDeviceServer$, ByVal starttime&, ByVal stoptime&, evnList() As Long, evnTime() As String) As Integer
Dim dout As DBLK, din As DBLK
Dim nevents As Integer
Dim lStartStopArray(1) As Long
Dim events() As Long
Dim i%, rc&, tmpTime As String * 32
Dim devName As String

devName = "MARCHSRV/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 2: din.dFormat = CF_LONG
lStartStopArray(0) = starttime&
lStartStopArray(1) = stoptime&
rc& = T_EXECLINK(devName, "NDEVEVENTS", dout, nevents, din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetPMDeviceEventListError

If nevents = 0 Then GoTo GetPMDeviceEventListError
ReDim events(nevents - 1)

dout.dArrayLength = nevents: dout.dFormat = CF_LONG
rc& = T_EXECLINK(devName, "DEVEVENTS", dout, events(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetPMDeviceEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = events(i%)
  If events(i%) > 0 Then
    CTIME tmpTime, events(i%)
  Else
    tmpTime = str$(events(i%))
  End If
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMDeviceEventListError:
GetPMDeviceEventList = IIf(rc&, -rc&, nevents)
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' 'to use GetHistoryData() do something like the following:
'
' Dim f() as Single
' Dim t() as Long
' Dim n as Integer
' Dim startt as Long, stopt as Long
'
' ' (skipped lines of code)
'
' stopt = UNIXTIME  ' now
' startt = stopt - 600 ' 10 minutes ago
'
' rc = GetHistoryData("/HERA/BPM/WL197X","POSITIONS.X",0,startt,stopt,f,t,n)
'
' ' if rc = 0 then n contains the number of history points returned, and f() and t()
' ' will have been correctly dimensioned
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetHistoryData(ByVal devName, ByVal devProperty As String, ByVal ArrayIndex, ByVal starttime As Long, ByVal stoptime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Long
Dim lStartStopArray(2) As Long
Dim npts As Long, n As Long
Dim rc&, i As Integer, nread As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim legacySystem As Boolean
Dim arrayOffset As Integer

lStartStopArray(0) = starttime
lStartStopArray(1) = stoptime
lStartStopArray(2) = ArrayIndex

npts = stoptime - starttime ' won't be any worse than this
'npts = 150 ' start off at a reasonable number
If npts > 4000 Then npts = 4000
LaunchHistoryLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(devName, devProperty & ".HIST", dout, fiDataArray(0), din, lStartStopArray(0), 1, 2000)
If rc& Then GoTo HistoryError

'If (fiDataArray(0).iVal <= npts) Or (npts > 4000) Then done = True
'npts = fiDataArray(0).iVal

nread = dout.dArrayLength
If (nread <= npts) Or (npts > 4000) Then done = True
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts > 16000 Then npts = 16000
'For i = npts To 0 Step -1
'  If fiDataArray(i).ival > 0 Then Exit For
'Next
'npts = i
If Not done Then GoTo LaunchHistoryLink
If npts > 0 Then
  ReDim fDataArray(npts)
  ReDim lTimeArray(npts)
End If
n = 0
For i = 0 To npts - 1
  If fiDataArray(i).iVal > 0 Then
    fDataArray(n) = fiDataArray(i + arrayOffset).fval
    lTimeArray(n) = fiDataArray(i + arrayOffset).iVal
    n = n + 1
  End If
Next
npoints = n
HistoryError:
GetHistoryData = rc&
End Function

Function GetArchivedDataEx(ByVal context, ByVal keyword As String, ByVal KeywordIndex As Integer, ByVal starttime As Long, ByVal stoptime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer, Offset As Integer, nread As Long
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim ArchiveServer$
Dim nretry As Integer
Dim timout As Long
Dim legacySystem As Boolean
Dim arrayOffset As Integer

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
  
End Select

lStartStopArray(0) = starttime
lStartStopArray(1) = stoptime
lStartStopArray(2) = KeywordIndex

'npts = stoptime - StartTime ' won't be any worse than this
If npoints > 1 Then
  npts = npoints
Else
  npts = 5000 ' start off at a reasonable number
End If

'timout = ((stoptime - starttime) / (3600& * 12)) * 1000
'If timout < 1000 Then timout = 1000
timout = 500

LaunchArchiveLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
If KeywordIndex > 0 Then din.dArrayLength = 3 Else din.dArrayLength = 2
din.dFormat = CF_LONG
'timout = iif(stoptime -starttime > 100000 ?
rc& = T_EXECLINK(ArchiveServer$, keyword, dout, fiDataArray(0), din, lStartStopArray(0), 1, timout)
If rc& = tine.link_not_open And nretry < 2 Then
  nretry = nretry + 1
  timout = timout + 2000
  GoTo LaunchArchiveLink
End If
If rc& Then GoTo ArchiveErrorEx
'If (fiDataArray(0).iVal <= npts) Or (npts > 150) Then done = True
'npts = fiDataArray(0).iVal
nread = dout.dArrayLength
If (nread <= npts) Or (npts > 150) Then done = True
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts = 0 Then GoTo ArchiveErrorEx
If npts > 16000 Then npts = 16000
If Not done Then GoTo LaunchArchiveLink
If (npoints > 1) And (npts < npoints) Then
    ReDim fDataArray(npoints - 1)
    ReDim lTimeArray(npoints - 1)
    Offset = npoints - npts - 1
Else
    ReDim fDataArray(npts - 1)
    ReDim lTimeArray(npts - 1)
    Offset = 0
    npoints = npts
End If
For i = 0 To npts - 1
  fDataArray(i + Offset) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i + Offset) = fiDataArray(i + arrayOffset).iVal
Next
ArchiveErrorEx:
GetArchivedDataEx = rc&
End Function
Function GetArchivedStringDataEx(ByVal context, ByVal keyword As String, ByVal KeywordIndex As Integer, ByVal starttime As Long, ByVal stoptime As Long, strArray() As String, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer, nread As Long
Dim dout As DBLK, din As DBLK
Dim niDataArray() As NAME32I
Dim done As Boolean
Dim ArchiveServer$
Dim legacySystem As Boolean
Dim arrayOffset As Integer

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "DESY3", "DESY2": ArchiveServer$ = "D3HISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case Else: ArchiveServer$ = "HISTORY"
  
End Select

lStartStopArray(0) = starttime
lStartStopArray(1) = stoptime
lStartStopArray(2) = KeywordIndex

npts = stoptime - starttime ' won't be any worse than this
npts = 1600 ' start off at a reasonable number
ReDim niDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_NAME32I
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(ArchiveServer$, keyword, dout, niDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo ArchiveStringErrorEx

'If (niDataArray(0).iVal <= npts) Or (npts > 150) Then done = True
'npts = niDataArray(0).iVal
nread = dout.dArrayLength
If (nread <= npts) Or (npts > 150) Then done = True
If niDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts = 0 Then GoTo ArchiveStringErrorEx
If npts > 16000 Then npts = 16000
'If Not done Then GoTo LaunchArchiveLink
ReDim strArray(npts)
ReDim lTimeArray(npts)
For i = 0 To npts - 1
  strArray(i) = TrimString(BSTR(niDataArray(i + 1).nam()))
  lTimeArray(i) = niDataArray(i + arrayOffset).iVal
Next
npoints = npts
ArchiveStringErrorEx:
GetArchivedStringDataEx = rc&
End Function

Function GetArchivedData(ByVal keyword As String, ByVal KeywordIndex As Integer, ByVal starttime As Long, ByVal stoptime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer, nread As Long
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim legacySystem As Boolean
Dim arrayOffset As Integer

If gArchiveServer$ = "" Then gArchiveServer$ = "HISTORY"

lStartStopArray(0) = starttime
lStartStopArray(1) = stoptime
lStartStopArray(2) = KeywordIndex

'npts = stoptime - starttime ' won't be any worse than this
npts = 8000 ' start off at a reasonable number
LaunchArchiveLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(gArchiveServer$, keyword, dout, fiDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo ArchiveError
'If (fiDataArray(0).ival <= npts) Or (npts > 150) Then done = True
'If (fiDataArray(0).ival <= npts) Then done = True

nread = dout.dArrayLength
'npts = fiDataArray(0).iVal
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts = 0 Then GoTo ArchiveError
If npts > 8000 Then npts = 8000
'If Not done Then GoTo LaunchArchiveLink
'ReDim fDataArray(npts - 1)
'ReDim lTimeArray(npts - 1)
ReDim fDataArray(npts)
ReDim lTimeArray(npts)
For i = 0 To npts - 1
  fDataArray(i) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i) = fiDataArray(i + arrayOffset).iVal
Next
npoints = npts
ArchiveError:
GetArchivedData = rc&
End Function
Function RemovePMData(ByVal pmArchiveGroup$, ByVal evnTag$) As Integer
Dim devName$
Dim fn As NAME8
Dim dbout As DBLK, dbin As DBLK

If pmArchiveServer$ = "" Then
 pmArchiveServer$ = "APC"
End If

devName$ = pmArchiveServer$ & "/" + pmArchiveGroup$
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
dbin.dArrayLength = 1
dbin.dFormat = CF_NAME8
BARR fn.nam(), evnTag$
RemovePMData = T_EXECLINK(devName$, "REMOVE", dbout, 0, dbin, fn.nam(0), CA_WRITE, 500)

End Function
Function SendPMTrigger(subsys As String, cmt As String) As Integer
Dim devName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim triggerlevel%, pmtime&
Dim i As Integer, rc As Integer
For i = 0 To 2
  ' Input data (to send):
  dbin.dArrayLength = 1
  dbin.dFormat = CF_SHORT
  triggerlevel% = 1 ' later user -1 to indicate a more critical trigger
  ' Output data (to receive):
  dbout.dArrayLength = 1
  dbout.dFormat = CF_LONG
  ' sub system to receive the trigger
  devName$ = "STORAGE/" + LCase(subsys)
  rc% = T_EXECLINK(devName$, "TRIGGER", dbout, pmtime&, dbin, triggerlevel%, CA_WRITE, 300)
  If rc% <> link_not_open Then Exit For
Next
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
For i = 0 To 2
  ' now send comment :
  ' append the assigned Post Mortem time to comment ...
  cmt = cmt & " @" & Trim$(str$(pmtime&))
  ' Input data (to send):
  dbin.dArrayLength = Len(cmt)
  dbin.dFormat = CF_TEXT
  BARR rpccmt.text(), cmt
  ' Output data (to receive): NONE
  dbout.dArrayLength = 0
  dbout.dFormat = CF_NULL
  rc% = T_EXECLINK(devName$, "ANNOTATE", dbout, 0, dbin, rpccmt.text(0), CA_WRITE, 300)
  If rc% <> link_not_open Then Exit For
Next
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
SendPMTrigger = 0
End Function
Function SendPMComment(subsys As String, pmtime As Long, cmt As String) As Integer
Dim devName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim rc As Integer
devName$ = "STORAGE/" + LCase(subsys)
' send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(str$(pmtime))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
BARR rpccmt.text(), cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc = T_EXECLINK(devName$, "ANNOTATE", dbout, 0, dbin, rpccmt.text(0), CA_WRITE, 500)
If rc Then
  SendPMComment = rc
  Exit Function
End If
SendPMComment = 0
End Function
Function GetPMComment(subsys As String, pmtime As Long, cmt As String) As Integer
Dim devName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim rc As Integer
devName$ = "STORAGE/" + LCase(subsys)
dbin.dArrayLength = 1
dbin.dFormat = CF_LONG
' Output data (to receive): NONE
dbout.dArrayLength = 256
dbout.dFormat = CF_TEXT
rc = T_EXECLINK(devName$, "COMMENT", dbout, rpccmt.text(0), dbin, pmtime, CA_READ, 500)
If rc Then
  GetPMComment = rc
  Exit Function
End If
cmt = BSTR(rpccmt.text())
GetPMComment = 0
End Function
Function GetArchivedTraceData(ByVal context, ByVal keyword As String, ByVal targetTime As Long, fDataArray() As Single) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim dout As DBLK, din As DBLK
Dim ArchiveServer$

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
  
End Select

lStartStopArray(0) = targetTime
lStartStopArray(1) = targetTime
lStartStopArray(2) = 0

npts = UBound(fDataArray) - LBound(fDataArray)
If npts = 0 Then
  GetArchivedTraceData = 0
  Exit Function
End If
LaunchArchiveLink:
dout.dArrayLength = npts: dout.dFormat = CF_FLOAT
'If KeywordIndex > 0 Then din.dArrayLength = 3 Else din.dArrayLength = 2
din.dFormat = CF_LONG
GetArchivedTraceData = T_EXECLINK(ArchiveServer$, keyword, dout, fDataArray(0), din, lStartStopArray(0), 1, 1000)
End Function

