#ifndef SWAPLIB_H_
#define SWAPLIB_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#include "rpcdefs.h"
#include "rpctypes.h"
#undef NONE
#define NONE   -1
#define RTOL    0  /* Swap: Remote to Local */
#define LTOR    1  /* Swap: Local to Remote  */

#define OFFSETIN(struc,field)   ((unsigned int)&(((struc *)0L)->field))

#if defined(NONALIGNED) || defined(INTEL)
#  define SwapBytes(dat,size,fmt,dir) ;
#  define ISWAP(w) (w)
#  define _ISWAP(w) (w)
#  define LSWAP(w) (w)
#  define _LSWAP(w) (w)
#else
#  ifdef VAX_VMS   /* ints unswapped, special swapping for floats, doubles */
#    define ISWAP(w) (w)
#    define _ISWAP(w) (w)
#    define LSWAP(w) (w)
#    define _LSWAP(w) (w)
#  else
#    define ISWAP(w) ((((w)&0xff00)>>8)|(((w)&0xff)<<8))
#    define _ISWAP(w) { tmp = ((BYTE *)&w)[0];\
                        ((BYTE *)&w)[0] = ((BYTE *)&w)[1];\
                        ((BYTE *)&w)[1] = tmp; }
#    define LSWAP(w) ((w>>24)|(w<<24)|((w&0xff00)<<8)|((w&0x00ff0000L)>>8))
#    define _LSWAP(w) { tmp = ISWAP(((short *)&w)[0]);\
	             ((short *)&w)[0] = ISWAP(((short *)&w)[1]);\
                     ((short *)&w)[1] = tmp; }
#  endif
#  define _DSWAP(w) { tmp = ISWAP(((short *)&w)[0]);\
		    ((short *)&w)[0] = ISWAP(((short *)&w)[3]);\
		    ((short *)&w)[3] = tmp;\
		    tmp = ISWAP(((short *)&w)[1]);\
		    ((short *)&w)[1] = ISWAP(((short *)&w)[2]);\
		    ((short *)&w)[2] = tmp; }
int SwapBytes(char *dat,int size,int fmt,int dir);
#endif
struct structFormat
{
  int   siz;
  int   fmt;
  int   off;
  int  addr;
  struct structFormat *nxt;
};
struct structStruct
{
  char name[12];           /* structure tag */
  int  rawlen;             /* network data size */
  int  size;               /* local structure size */
  int  num;                /* maximum number of structure sets buffered */
  BYTE *sdata;             /* structure data holder */
  struct structFormat *s;  /* structure definition */
  struct structStruct *next;
};
extern struct structStruct *structList;

struct structStruct *getStructFromTag(char *tag);
struct structStruct *findstruct(char *tag);
int addtostruct(void *target,int addr,int size, int fmt);
int fillstruct(char *tag,int addr,int size,int fmt);
int _StructSwap(struct structFormat *s,unsigned char *dat,unsigned char *struc,int dir);
int StructSwap(char *tag,unsigned char *dat,unsigned char *struc,int dir);
int StructSwapEx(char *tag,unsigned char *dat,unsigned char *struc,int dir,int num,int structsize);
int _StructSwapEx(struct structFormat *s,unsigned char *dat,unsigned char *struc,int dir,int num,int structsize);
int initControlStructs(void);
void RegisterLongDataStructs(void);
int queryStructFormat(char *tag,INTINT *sfq,int *sfqsiz);
void freeStruct(struct structFormat *sf);

extern struct structFormat *HeaderStructStruct;
extern struct structFormat *EqpInfoStructStruct;
extern struct structFormat *CONTRACT4Struct;
extern struct structFormat *CONTRACTStruct;
extern struct structFormat *ProducerHeaderStruct4Struct;
extern struct structFormat *ProducerHeaderStructStruct;
extern struct structFormat *SUBSCRIPTION4Struct;
extern struct structFormat *SUBSCRIPTIONStruct;
extern struct structFormat *RPCDataStructStruct;
extern struct structFormat *RPCFecStructStruct;
extern struct structFormat *ADSStructStruct;
extern struct structFormat *AMSStructStruct;
extern struct structFormat *PropertyQueryStructStruct;
extern struct structFormat *PropertyQueryStructExStruct;
extern struct structFormat *XPropertyQueryStructStruct;
extern struct structFormat *ActivityQueryStructStruct;
extern struct structFormat *ServerStateStructStruct;
extern struct structFormat *BrdcstDataStruct;
extern struct structFormat *ClientQueryStructStruct;
extern struct structFormat *SpectrumHeaderStruct;

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* SWAPLIB_H_ */
