
# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI,OSF CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# VxWorks:CC = gcc        CCL = ld68k

#CC = cc68k
#CC = cc68k -c -I/usr/vw/h -DCPU=MC68020 -fno-builtin -O

CFLAGS          = 
CPU             = MC68LC040
TOOL            = gnu
CC              =  cc68k -c -I $(WIND_BASE)/target/h -nostdinc -DCPU=MC68040 -m68040 -fno-builtin -O


#include $(WIND_BASE)/target/h/make/defs.bsp
#include $(WIND_BASE)/target/h/make/make.$(CPU)$(TOOL)
#include $(WIND_BASE)/target/h/make/defs.$(WIND_HOST_TYPE)


CCL = ld68k
LM = 


rpcsrv.o: sinsrv.o toolkit.o rpcserv.o server.o almsrv.o srvip.o srvdbase.o srvquery.o history.o iplib.o dblib.o swaplib.o syslib.o err_list.o covercln.o
	${CCL} -o rpcsrv.o -r sinsrv.o toolkit.o rpcserv.o server.o almsrv.o srvip.o srvdbase.o srvquery.o history.o iplib.o dblib.o swaplib.o syslib.o err_list.o covercln.o ${LM}

sinsrv.o: sinsrv.c prolog.h servdef.h 
	${CC} $(CFLAGS) sinsrv.c

rpcserv.o:  rpcserv.c servdef.h prolog.h project.def
	${CC} $(CFLAGS) rpcserv.c

server.o:  server.c servdef.h prolog.h errors.h brdcast.h swaplib.h project.def
	${CC} $(CFLAGS) server.c

almsrv.o:  almsrv.c servdef.h prolog.h errors.h almsrv.h project.def
	${CC} $(CFLAGS) almsrv.c

srvip.o: srvip.c servdef.h prolog.h srvip.h errors.h prolog.h project.def
	${CC} $(CFLAGS) srvip.c

srvdbase.o: srvdbase.c database.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} $(CFLAGS) srvdbase.c

srvquery.o: srvquery.c database.h servdef.h prolog.h history.h srvip.h errors.h project.def
	${CC} $(CFLAGS) srvquery.c

history.o: history.c history.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} $(CFLAGS) history.c

toolkit.o: toolkit.c toolkit.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} $(CFLAGS) toolkit.c

iplib.o: iplib.c servdef.h prolog.h srvip.h errors.h prolog.h project.def
	${CC} $(CFLAGS) iplib.c

swaplib.o: swaplib.c swaplib.h prolog.h servdef.h project.def
	${CC} $(CFLAGS) swaplib.c 

dblib.o:  dblib.c database.h errors.h prolog.h project.def
	${CC} $(CFLAGS) dblib.c

err_list.o: err_list.c errors.h
	${CC} $(CFLAGS) err_list.c

syslib.o: syslib.c errors.h
	${CC} $(CFLAGS) syslib.c

unixcmd.o: unixcmd.c prolog.h servdef.h unixcmd.h
	${CC} $(CFLAGS) unixcmd.c

covercln.o:  covercln.c servdef.h prolog.h project.def
	${CC} $(CFLAGS) covercln.c

clean:
	rm rpcsrv.o rpcserv.o server.o almsrv.o srvip.o dblib.o swaplib.o covercln.o

