#include "project.def"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <nwipxspx.h>
#include <nwcaldef.h>
#include <nwcalls.h>
#include "errors.h"
#include "database.h"
#ifdef WINSOCK
#include <winsock.h>
#else
#define WINDOWS
#include <sys/socket.h>
#endif

#include "rpcsrv.h"

#define LOINT(l)       ((int)(l))
#define HIINT(l)       ((int)(((long)(l) >> 16) & 0xFFFF))

//short tRPC(int fecindex, char far *name,short EqNo,char far *prop,
//           short size,void far *data,short format,short timout);
short tRPC(int fecindex,void far *data,char far *name,short EqNo,char far *prop,
           short size,short format,short timout);
extern void soperror(char far *txt);
extern int debug;
extern int TCPGetResource(void);
extern int TCPFreeResource(void);
int GetAddressFromNameServer(char far *context,char far *name,char far *fecname,int far *rpcindex);
int GetAddressFromNameFile(char far *context,char far *name,char far *fecname,int far *rpcindex);

int ReadString(FILE far *fp,char far *str,int far *lower);
int NextLine(FILE far *fp,char far *str,int far *lower);
unsigned int HexToDec(char far *str);

LDS ldsXRef[] = {
  {"cfS{ECT",CF_SPECTRUM,4192},
};
int nLdsXRef = sizeof(ldsXRef)/sizeof(LDS);

void RegisterLongDataStructs(void)
{
  FILLSTRUCT ("cfSPECT",sizeof(DSPECTRUM),1,CF_NULL);
}

static char strn[100];

int ReadString(FILE far *fp,char far *str,int far *lower)
{
  char c,ch,far *string;
  int i,cc;

  string=str;*lower=0;
  for (i=0; i>=0;i++)
  {
   if ((cc=fread(&c,1,1,fp)) == 0) break;
   ch=toupper(c);
   if (c!=ch) *lower=1;
   if (ch!=',' && ch!=10 && cc==1)
   {
     if (i<99) {*string=ch;string++;}
   }
   else break;
  }
  *string=0;
  if (cc==1) cc=ch;else cc=-1;
  return cc;
}

int NextLine(FILE far *fp,char far *str,int far *lower)
{
  int cc;

  do
  {
   do
   {
     cc=ReadString(fp,str,lower);
   }
   while (cc==',');
   if (cc>=0) cc=ReadString(fp,str,lower);
  }
  while (cc>0 && str[0]=='%');
  return cc;
}
int ReadDataBase(DataBaseElemsStruct far *elems)
{
  FILE far *DataBaseFP;
  static char tmp[100];
  char far *addr;
  int cc,e,col,i,j,recsread;
  int error;

  int nrlines,far *colflags,size;
  int msb,lsb,lower;
  char far *file;
  int in;
  double r;

  recsread=0;
  for (nrlines=0; _fstrlen(elems[nrlines+1].ColName); nrlines++);
  size=LOINT(elems[0].Type);
  file=elems[0].ColName;
  colflags=malloc(nrlines*sizeof(int));

  for (i=0;i<nrlines;i++) colflags[i]=(-1);
  DataBaseFP=fopen(file,"r");
  if (!DataBaseFP) { error = -no_such_file; goto err;};
  col=0;
  do
  {
   cc=ReadString(DataBaseFP,(char far *)strn,&lower);
   if (!col && strn[0]=='%') cc=NextLine(DataBaseFP,strn,&lower);
   i=0;
   while ((_fstrcmp((char far *)strn,(char far *)elems[i+1].ColName) || colflags[i]!=-1)
        && i<nrlines) i++;
   if (i<nrlines)
   {
     colflags[i]=col;
   }
   col++;
  }
  while (cc==',');

  for (i=0;i<nrlines;i++)
   if (colflags[i]<0) { error = -non_existent; goto err;};
  while (1)
  {
   col=0;
   do
   {
     cc=ReadString(DataBaseFP,strn,&lower);
     if (!col && strn[0]=='"')
     {
      tmp[0] = '\0'; strcat(tmp,&strn[1]);
      do
      {
        cc=ReadString(DataBaseFP,strn,&lower);
        strcat(tmp,strn);
      } while (strn[_fstrlen(strn)-1] != '"');
      tmp[_fstrlen(tmp)-1] = '\0';
      _fstrcpy(strn,tmp);
     }
     if (!col && strn[0]=='%') cc=NextLine(DataBaseFP,strn,&lower);
     if (cc<0 && (!_fstrlen(strn) || strn[0]=='%')) break;
     for (i=0;i<nrlines;i++) if (colflags[i]==col)
     {
      addr = (char far *)GlobalLock(elems[i+1].handle) + elems[i+1].offset + recsread*size;
      GlobalUnlock(elems[i+1].handle);

      switch (LOINT(elems[i+1].Type))
      {
      case STR: _fstrcpy((char far *)addr,(char far *)strn);break;
      case INT:
        if (strn[_fstrlen(strn)-1]=='H')
        {
         strn[_fstrlen(strn)-1]=0;
         in=HexToDec(strn);
        }
        else in=atoi(strn);
        *(int far *)addr=in;break;
      case FLT:
        if (strn[_fstrlen(strn)-1]=='H')
        {
         strn[_fstrlen(strn)-1]=0;
         r=(double)HexToDec(strn);
        }
        else r=atof(strn);
        *(double far *)addr=r;break;
      case HEX:
        e=_fstrlen(strn)/2;
        for (j=0;j<e;j++)
        {
         msb=toupper(strn[j*2]);lsb=toupper(strn[j*2+1]);
         if (msb>64) msb=msb-55;else msb=msb-48;
         if (lsb>64) lsb=lsb-55;else lsb=lsb-48;
         *(unsigned char far *)((char far *)(addr)+j)=(unsigned char)msb*16+lsb;
        }
        break;
      }
     }
     col++;
   }
   while (cc==',');
   if (cc<0) break;
   recsread++;
  }
  fclose(DataBaseFP);
  elems[0].Type=size+65536L*(unsigned long)recsread;
  free(colflags);
  return recsread;
err:
  fclose(DataBaseFP);
  free(colflags);
  return error;
}
/*
int SearchDataBase(DataBaseElemsStruct far *elems,char far *searchstr,char far *colname)
{
  int i,line,recs,size;
  char far *p2,far *p3;

  recs=HIINT(elems[0].Type);
  size=LOINT(elems[0].Type);
  for (line=1; _fstrcmp((char far *)colname,elems[line].ColName) && _fstrlen(elems[line].ColName); line++);
  if (!_fstrlen(elems[line].ColName)) return -non_existent;
  i=-1;
  p2 = (char far *)GlobalLock(elems[line].handle) + elems[line].offset;
  GlobalUnlock(elems[line].handle);
  p3=searchstr;
  for (i=0; i<recs; i++)
  {
   if (!_fstrncmp(p2,p3,8)) break;
   p2 += size;
  }
  if (i == recs) return -non_existent;
  return i;
}
int GetDataBaseProperties(char far *properties,int size,char far *file)
{
  FILE far *DataBaseFP;
  int off,cc,col;
  int lower;

  DataBaseFP=fopen(file,"r");
  if (!DataBaseFP) return -no_such_file;
  col=0;off=0;
  do
  {
   cc=ReadString(DataBaseFP,strn,&lower);
   if (!col && strn[0]=='%') cc=NextLine(DataBaseFP,strn,&lower);
   if (!lower && _fstrlen(strn))
   {
     _fstrcpy(properties+off,strn);
     off=off+size;
   }
   col++;
  }
  while (cc==',');

  fclose(DataBaseFP);
  return (int)(off/size);
}
*/
unsigned int HexToDec(char far *str)
{
  int i,d;
  unsigned int off,value;

  off=1;value=0;
  for (i=_fstrlen(str)-1;i>=0;i--)
  {
   if (str[i]>='A') d=str[i]-'A'+10;else d=str[i]-'0';
   value=value+off*d;
   off=off*16;
  }
  return value;
}
/*
int SearchDataBaseFromFile(char far *filename,char far *searchstr,char far *colname,
   char far *datacol,int datacollen,char far *data,int datalen)
{
  FILE far *DataBaseFP;
  int cc,col,colnrsearch,colnrdata[100],lower,found,maxdatacol,x;

  DataBaseFP=fopen(filename,"r");
  if (!DataBaseFP) return -no_such_file;

  maxdatacol=0;while (_fstrlen(&datacol[maxdatacol*datacollen])) maxdatacol++;
  col=0;colnrsearch=-1;for (x=0;x<100;x++) colnrdata[x]=-1;
  do
  {
   cc=ReadString(DataBaseFP,strn,&lower);
   if (!col && strn[0]=='%') cc=NextLine(DataBaseFP,strn,&lower);
   if (!_fstrcmp(strn,colname)) colnrsearch=col;
   for (x=0;x<maxdatacol;x++)
     if (!_fstrcmp(strn,&datacol[x*datacollen])) colnrdata[x]=col;
   col++;
  }
  while (cc==',');
  if (colnrsearch==-1) { fclose(DataBaseFP); return -non_existent;};
  for (x=0;x<maxdatacol;x++)
   if (colnrdata[x]==-1) { fclose(DataBaseFP);return -non_existent;};

  for (found=0,cc=0; !found && cc >= 0;)
  {
   for (col=0,cc=','; cc == ','; col++)
   {
     cc=ReadString(DataBaseFP,strn,&lower);
     if (!col && strn[0]=='%') cc=NextLine(DataBaseFP,strn,&lower);
     if (cc<0 && (!_fstrlen(strn) || strn[0]=='%')) break;
     if (col==colnrsearch && !_fstrcmp(strn,searchstr)) found=1;
     for (x=0;x<maxdatacol;x++)
      if (col==colnrdata[x]) _fstrcpy(&data[x*datalen],strn);
   }
  }
  fclose(DataBaseFP);
  return found ? 0 : -non_existent;
}
*/
int GetDataBaseSize(char far *filename)
{
  FILE far *DataBaseFP;
  int cc,col,line,lower;

  DataBaseFP=fopen(filename,"r");
  if (!DataBaseFP) return -no_such_file;
  for (line=-1,cc=0; cc>=0;line++)
  {
   for (col=0,cc=','; cc == ','; col++)
   {
     cc=ReadString(DataBaseFP,strn,&lower);
     if (!col && strn[0]=='%') cc=NextLine(DataBaseFP,strn,&lower);
   }
  }
  fclose(DataBaseFP);
  return line;
}
void trim(char far *str)
{
  while (strstr(str," ") == str) str++;
  str[strcspn(str," ")] = '\0';
  return;
}

void BytesToHex(BYTE far *b,char far *s,int n)
{
  int v;

  while (n--)
  {
   *s++ = (v = (*b&0xf0)>>4) < 10 ? '0' + v : 'A' + v - 10;
   *s++ = (v = *b++&0xf) < 10 ? '0' + v : 'A' + v - 10;
  }
  *s = 0;
  strrev(s);
  return;
}
void HextoBytes(char far *s,BYTE far *b,int nibs)
{
  char buf[20];
  int l,i;

  if ((l=_fstrlen(s)) < nibs)
  {
   _fstrrev(s); _fstrncat(s,"000000000000",nibs-l);
   _fstrrev(s);
  }
  for (i=0; i<nibs/2; i++)
  {
   _fstrncpy(buf,&s[i*2],2); buf[2] = 0;
   b[i] = (unsigned char)strtol(buf,NULL,16);
  }
}

char ControlDBpath[80];
char NameServerPath[80];
char RPCDatabaseFullName[80];
char FECDatabaseFullName[80];
BYTE zero[6] = {0,0,0,0,0,0};
RPCDataStruct far *RPCData, NameServerData;
RPCFecStruct  far *RPCFec, NameServer;
int numNameServers = 0,curNameServer = 0;
HANDLE hRPCData = 0, hRPCFec = 0;
int RPCallocNum = 0,FECallocNum=0;
int NameServerLoaded = 0;

void flushFecRpcCache(void)
{
  RPCNumFecsRead = NameServerLoaded ? 1 : 0;
  RPCNumRecsRead = NameServerLoaded ? 1 : 0;
  RPCFec=(RPCFecStruct far *)DeReference(hRPCFec);
    RPCData=(RPCDataStruct far *)DeReference(hRPCData);
  _fmemset(&RPCFec[RPCNumFecsRead],0,(FECallocNum-RPCNumFecsRead)*sizeof(RPCFecStruct));
  _fmemset(&RPCData[RPCNumRecsRead],0,(RPCallocNum-RPCNumRecsRead)*sizeof(RPCDataStruct));
}
int fixFecProtocol(int i)
{
  static int TransportTime;

  if (hRPCFec == 0) return database_not_loaded;
  if (i < 0 || i >= RPCNumFecsRead) return non_existent;
  RPCFec=(RPCFecStruct far *)DeReference(hRPCFec);

  if (TCPloaded && _fmemcmp(&RPCFec[i].iaddr,zero,4))
  {
   RPCFec[i].Prot = UDP;
   return 0;
  }
  if (IPXloaded &&  *(DWORD far *)RPCFec[i].Network != 0)
  {
   if (IPXGetLocalTarget(IPXTaskID,RPCFec[i].Network,
      &RPCFec[i].ImmediateAddress,&TransportTime)) return ipx_socket_error;
   RPCFec[i].Prot = IPX;
   return 0;
  }
  return illegal_protocol;
}
int fixNameServerProtocol(void)
{
  static int TransportTime;

  if (TCPloaded && _fmemcmp(&NameServer.iaddr,zero,4))
  {
   NameServer.Prot = UDP;
   return 0;
  }
  if (IPXloaded && *(DWORD far *)NameServer.Network != 0)
  {
   if (IPXGetLocalTarget(IPXTaskID,NameServer.Network,
      &NameServer.ImmediateAddress,&TransportTime)) return ipx_socket_error;
   NameServer.Prot = IPX;
   return 0;
  }
  return illegal_protocol;
}
int locateTagName(char far *context,char far *name)
{
  static char fecname[16];
  static int rpcidx;
  int i,cc;

  if ((i=GetAddressFromNameServer(context,name,fecname,&rpcidx)) < 0 &&
      (i=GetAddressFromNameFile(context,name,fecname,&rpcidx)) < 0) return -i;
  if ((cc=fixFecProtocol(i)) != 0) return -cc;
  return rpcidx;
}
int locateFecName(char far *fecname)
{
  static int nullindex;
  int i,cc;

  if ((i=GetAddressFromNameServer(NULL,NULL,fecname,&nullindex)) < 0 &&
     (i=GetAddressFromNameFile(NULL,NULL,fecname,&nullindex)) < 0) return -i;
  if ((cc=fixFecProtocol(i)) != 0) return -cc;
  return i;
}
int getRPCDataIndex(char far *context,char far *name)
{
  int i;
  static char lclname[17];

  if (name == NULL || _fstrlen(name) == 0) return -non_existent_elem;
  _fstrncpy(lclname,name,16); lclname[16] = 0;
  if (NameServerLoaded && !_fstrcmp(lclname,CSHOSTS)) return 0;
  RPCData=(RPCDataStruct far *)DeReference(hRPCData);
  for (i=0; i<RPCNumRecsRead; i++)
  {
    if (context != NULL && _fstrlen(context) && _fstrcmp(context,"DEFAULT") &&
        _fstrncmp(RPCData[i].Context,context,16)) continue;
    if (!_fstrncmp(RPCData[i].FullName,lclname,16)) return i;
  }
  return locateTagName(context,lclname);
}
int getRPCFecIndex(char far *fecname)
{
  int i;

  if (fecname == NULL || _fstrlen(fecname) == 0) return -non_existent_fec;
  RPCFec=(RPCFecStruct far *)DeReference(hRPCFec);
  for (i=0; i<RPCNumFecsRead; i++)
   if (!_fstrncmp(RPCFec[i].Name,fecname,16)) return i;
  return locateFecName(fecname);
}
int findcol(char far *str,char far *tag)
{
  char far *c;
  int i,len;

  for (i=0,c=str; strlen(c); i++,c++)
  {
   while (*c == '\"') { c = strchr(++c,'\"'); if (c++ == NULL) return -1; }
   strupr(c);
    len = _fstrcspn(c,",\n"); while (c[len-1] == ' ') len--;
    if (!_fstrncmp(c,tag,MAX(len,_fstrlen(tag)))) return i;
   if ((c=strpbrk(c,",\n")) == NULL) return -1;
  }
  return -1;
}
char far *colptr(int col,char far *str)
{
  static char buf[48];
  char far *c;
  int i;

  for (i=0,c=str; i < col && strlen(c); i++,c++)
  {
   while (*c == '\"') { c = strchr(++c,'\"'); if (c++ == NULL) return NULL; }
   if ((c=strpbrk(c,",")) == NULL) return NULL;
  }
  _fstrncpy(buf,c,i=MIN(sizeof(buf)-1,strcspn(c,",\n"))); buf[i] = 0;
  return buf;
}
int namcmp(char far *name,char far *str,int col,int limit)
{
  char far *c = colptr(col,str);
  int n = MAX(limit,strcspn(c,",\n"));
  return _fstrncmp(name,c,n);
}
int GetAddressFromNameServer(char far *context,char far *expname,char far *fecname,int far *rpcindex)
{
  static BYTE buf[sizeof(RPCDataStruct)+sizeof(RPCFecStruct)];
  static int retry = 0;
  int i,j,cc;
  RPCDataStruct far *rpcdata = (RPCDataStruct far *)buf;
  static char cntxt[17] = "";

  *rpcindex = -1;
  if (!NameServerLoaded || retry--) return -not_ready;
  RPCData =(RPCDataStruct far *)DeReference(hRPCData);
  RPCFec =(RPCFecStruct far *)DeReference(hRPCFec);
  if (expname == NULL)                  /* resolve fecname only */
  {
    if (fecname == NULL || _fstrlen(fecname) == 0) return -non_existent_fec;
    for (i=0; i<RPCNumFecsRead && _fstrcmp(RPCFec[i].Name,fecname); i++);
    if (i<RPCNumFecsRead && RPCFec[i].Prot) return i;
    retry = 10;                        /* in case the Name Server hangs */
    cc = tRPC(0,(char far *)buf,CSHOSTS,1,fecname,RPCFECSTRUCT_SIZE,CF_STRUCT,1);
    if (cc) ccerr(cc);
    for (i=0; i<RPCNumFecsRead && _fstrcmp(fecname,RPCFec[i].Name); i++);
    if (i == RPCNumFecsRead)
    {
      if (RPCNumFecsRead < FECallocNum) RPCNumFecsRead++;
      else return -buffer_too_small;
    }
    _fmemcpy(&RPCFec[i],buf,RPCFECSTRUCT_SIZE);
  }
  else                               /* resolve both tagname and fecname */
  {
    if (_fstrlen(expname) == 0) return -non_existent_elem;
    for (j=0; j<RPCNumRecsRead; j++)
    {
      if (context != NULL && _fstrcmp(context,"DEFAULT") &&
          _fstrncmp(context,RPCData[j].Context,16)) continue;
      if (!_fstrncmp(expname,RPCData[j].FullName,16)) break;
    }
    *rpcindex = j;
    if (j < RPCNumRecsRead)
    {
      for (i=0; i<RPCNumFecsRead && strcmp(RPCData[j].FecName,RPCFec[i].Name); i++);
      if (i < RPCNumFecsRead && RPCFec[i].Prot) goto err;
    }
    retry = 2;                         /* in case the Name Server hangs */
    if (context != NULL) _fstrncpy(cntxt,context,16);
    if (_fstrlen(cntxt) == 0) sprintf(cntxt,"#2");
    cc = tExecLink(0,CSHOSTS,cntxt,expname,RPCFECSTRUCT_SIZE+RPCDATASTRUCT_SIZE,(char far *)buf,CF_STRUCT,500);
    if (cc) ccerr(cc);
    for (i=0; i<RPCNumRecsRead; i++)
      if (!_fstrncmp(RPCData[i].FecName,rpcdata->FecName,16) &&
          !_fstrncmp(RPCData[i].EqName,rpcdata->EqName,6)) break;
    if (i == RPCNumRecsRead)
    {
      if (RPCNumRecsRead < RPCallocNum) RPCNumRecsRead++;
      else ccerr(buffer_too_small);
    }
    _fmemcpy(&RPCData[i],buf,RPCDATASTRUCT_SIZE);
    if (j == RPCNumRecsRead)    // must be an alias ...
    {
      _fmemcpy(&RPCData[j],buf,RPCDATASTRUCT_SIZE);
      if (RPCNumRecsRead < RPCallocNum) RPCNumRecsRead++;
      else ccerr(buffer_too_small);
    }
    _fstrncpy(fecname,RPCData[i].FecName,16);
    for (i=0; i<RPCNumFecsRead && _fstrncmp(fecname,RPCFec[i].Name,16); i++);
    if (i == RPCNumFecsRead)
    {
      if (RPCNumFecsRead < FECallocNum) RPCNumFecsRead++;
      else ccerr(buffer_too_small);
    }
    if (i > 0) _fmemcpy(&RPCFec[i],&buf[RPCDATASTRUCT_SIZE],RPCFECSTRUCT_SIZE);
  }
err:
  if (cc != link_not_open) retry = 0; /* Name Server was there */
  return cc ? -cc : i;
}

int GetAddressFromNameFile(char far *context,char far *srvname,char far *fecname,int far *rpcindex)
{
  FILE far *fp = NULL;
  DWORD haddr;
  int i,cc=0,done=0,col;
  char far *c;
  static char str[256],hdr[256],scratch[16],name[17];

  if (fecname == NULL) ccerr(non_existent_fec);
  if (srvname == NULL) goto acquireFecName;     /* only interested in FEC address*/
   _fstrncpy(scratch,srvname,16);
   c = scratch;
   for (c=scratch; *c == ' '; c++);  // remove leading blanks
   for (i=_fstrlen(c); i > 0 && c[i] == ' '; i--); if (i >= 0) c[i] = 0;
   _fstrncpy(name,c,16);
   *rpcindex = -1;
  if (_fstrlen(name) == 0) ccerr(non_existent_elem);
  cc = non_existent_elem;
  if ((fp=fopen(RPCDatabaseFullName,"r")) == NULL) ccerr(no_such_file);
  RPCData=(RPCDataStruct far *)DeReference(hRPCData);
  for (done=0; fgets(str,255,fp) != NULL;)   /* scan file       */
  {
   if (strchr("%;#",str[0])) continue;      /* comment line(s) */
   if (!done)
   {
     _fstrcpy(hdr,str);
     if ((col=findcol(hdr,"NAME")) < 0) ccerr(no_such_line);
     done = 1;
     continue;
   }
   if (!namcmp(name,str,col,16))               /* found entry in file */
   {
     for (i=0; i<RPCNumRecsRead && _fstrcmp(name,RPCData[i].FullName); i++);
     if (i == RPCNumRecsRead)
     {
      if (RPCNumRecsRead < RPCallocNum) RPCNumRecsRead++;
      else ccerr(buffer_too_small);
     }
     _fstrncpy(RPCData[i].FullName,colptr(col,str),ELEM_NAME_SIZE);
     if ((col=findcol(hdr,"FECNAME")) < 0) ccerr(no_such_line);
     _fstrncpy(RPCData[i].FecName,colptr(col,str),FEC_NAME_SIZE);
     _fstrcpy(fecname,RPCData[i].FecName);
     if ((col=findcol(hdr,"EQPMODULE")) < 0) ccerr(no_such_line);
     _fstrncpy(RPCData[i].EqName,colptr(col,str),EQNAME_SIZE);
     if (context != NULL && _fstrlen(context) && _fstrcmp(context,"DEFAULT") &&
         (col=findcol(hdr,"CONTEXT")) >= 0)
     {
       c = colptr(col,str);
       if (_fstrncmp(context,c,16)) continue;
       _fstrncpy(RPCData[i].Context,c,16);
     }
     else RPCData[i].Context[0] = 0;
     cc = 0;
     *rpcindex = i;
     break;
   }
  }
  fclose(fp);
  if (cc) ccerr(cc);
acquireFecName:
  cc = non_existent_fec;
  if (_fstrlen(fecname) == 0) ccerr(non_existent_fec);
  RPCFec=(RPCFecStruct far *)DeReference(hRPCFec);
  for (i=0; i<RPCNumFecsRead; i++)
   if (!_fstrcmp(RPCFec[i].Name,fecname))
      if (RPCFec[i].Prot) return i; else break;
  if ((fp=fopen(FECDatabaseFullName,"r")) == NULL) ccerr(no_such_file);
  for (done=0; fgets(str,255,fp) != NULL;)   /* scan file       */
  {
   if (strchr("%;#",str[0])) continue;      /* comment line(s) */
   if (!done)
   {
     _fstrcpy(hdr,str);
     if ((col=findcol(hdr,"FECNAME")) < 0) ccerr(no_such_line);
     done = 1;
     continue;
   }
   if (!namcmp(fecname,str,col,16))           /* found entry in file */
   {
     for (i=0; i<RPCNumFecsRead && _fstrcmp(fecname,RPCFec[i].Name); i++);
     if (i == RPCNumFecsRead)
     {
      if (RPCNumFecsRead < FECallocNum) RPCNumFecsRead++;
      else ccerr(buffer_too_small);
     }
     _fstrncpy(RPCFec[i].Name,colptr(col,str),FEC_NAME_SIZE);
     if ((col=findcol(hdr,"FECNETWORK")) < 0) ccerr(no_such_line);
     _fstrncpy(scratch,colptr(col,str),16);
     HextoBytes(scratch,RPCFec[i].Network,8);
     if ((col=findcol(hdr,"FECNODE")) < 0) ccerr(no_such_line);
     _fstrncpy(scratch,colptr(col,str),16);
     HextoBytes(scratch,RPCFec[i].Node,12);
     if ((col=findcol(hdr,"IPADDR")) < 0) ccerr(no_such_line);
     _fstrncpy(RPCFec[i].IP,colptr(col,str),16);
     haddr = inet_addr(RPCFec[i].IP);
     _fmemcpy(&RPCFec[i].iaddr,&haddr,4);
      if ((col=findcol(hdr,"PORTOFFSET")) >= 0)
      {
        _fstrncpy(scratch,colptr(col,str),16);
        RPCFec[i].PortOffset = atoi(scratch);
     }
      else RPCFec[i].PortOffset = 0;
     break;
   }
  }
err:
  if (fp) fclose(fp);
  return cc ? -cc : i;
}
int GetAllocSizesFromNameServer(int far *RPCsize,int far *FECsize)
{
  FILE far *fp;
  static DWORD haddr;
  int cc=0,done=0,col;
  static char str[256],hdr[256],scratch[16];

  if (!NameServerLoaded)
  {
    if ((fp=fopen(NameServerPath,"r")) == NULL)
    {
      NameServerPath[0] = 0;  // get rid of this in '99
      _fstrcat(NameServerPath,ControlDBpath); _fstrcat(NameServerPath,"herans.csv");
      if ((fp=fopen(NameServerPath,"r")) == NULL)
      ccerr(no_such_file);
    }
    for (done=0; fgets(str,255,fp) != NULL;)   /* scan file       */
    {
      if (_fstrchr("%;#\n",str[0])) continue;      /* comment line(s) */
      if (!done)
      {
        _fstrcpy(hdr,str);
        if ((col=findcol(hdr,"FECNAME")) < 0) ccerr(no_such_line);
        done = 1;
        continue;
      }
      _fstrncpy(NameServer.Name,colptr(col,str),FEC_NAME_SIZE);
      if ((col=findcol(hdr,"FECNETWORK")) < 0) ccerr(no_such_line);
      _fstrncpy(scratch,colptr(col,str),16);
      HextoBytes(scratch,NameServer.Network,8);
      if ((col=findcol(hdr,"FECNODE")) < 0) ccerr(no_such_line);
      _fstrncpy(scratch,colptr(col,str),16);
      HextoBytes(scratch,NameServer.Node,12);
      if ((col=findcol(hdr,"IPADDR")) < 0) ccerr(no_such_line);
      _fstrncpy(NameServer.IP,colptr(col,str),16);
      haddr = inet_addr(NameServer.IP);
      _fmemcpy(&NameServer.iaddr,&haddr,4);
      break; // take the first one as primary
    }
    fclose(fp);
    if ((cc=fixNameServerProtocol()) != 0) ccerr(cc);
//   NameServer.Prot = UDP;
    _fstrcpy(NameServerData.FecName,NameServer.Name);
    _fstrcpy(NameServerData.FullName,CSHOSTS);
    _fstrcpy(NameServerData.EqName,CSHOSTS);
    RPCFec = &NameServer; RPCData = &NameServerData;
    RPCNumRecsRead = RPCNumFecsRead = 1;  /* Hardwire first call */
    NameServerLoaded = 1;
  }
  *RPCsize =  *FECsize = MAX_ENTRIES;
err: if (fp) fclose(fp);
  return cc;
}

int GetAllocSizesFromNameFile(int far *RPCsize,int far *FECsize)
{
  int size;

  if ((size=GetDataBaseSize(RPCDatabaseFullName))<0) return -size;
  if (size == 0) return un_allocated;
  *RPCsize = size;

  if ((size=GetDataBaseSize(FECDatabaseFullName))<0) return -size;
  if (size == 0) return un_allocated;
  *FECsize = size;

  return 0;
}
int initDataBase(void)
{
  static char far *ptr;
  static int dbaseloaded = 0;

  if (dbaseloaded) return 0;

  ControlDBpath[0] = NameServerPath[0] = 0;
  RPCDatabaseFullName[0] = FECDatabaseFullName[0] = 0;

	if ((ptr=getenv("TINE.HOME")) != NULL ||
			(ptr=getenv("CONTROLDB")) != NULL)
	{
		_fstrcpy(ControlDBpath,ptr);
	}
  _fstrcat(NameServerPath,ControlDBpath);
  _fstrcat(NameServerPath,CSHOSTS_FILE);

  _fstrcat(RPCDatabaseFullName,ControlDBpath);
  _fstrcat(RPCDatabaseFullName,EQPDB_FILE);

  _fstrcat(FECDatabaseFullName,ControlDBpath);
  _fstrcat(FECDatabaseFullName,FECDB_FILE);

  if (GetAllocSizesFromNameServer(&RPCallocNum,&FECallocNum) &&
     GetAllocSizesFromNameFile(&RPCallocNum,&FECallocNum))
   return database_not_loaded;

  if (!RPCallocNum || !FECallocNum) return un_allocated;

  if (!(hRPCData=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,sizeof(RPCDataStruct)*RPCallocNum)))
   return out_of_client_memory;

  if (!(hRPCFec=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,sizeof(RPCFecStruct)*FECallocNum)))
   return out_of_client_memory;

  if (NameServerLoaded)
  {
    RPCData = (RPCDataStruct far *)DeReference(hRPCData);
    RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
		_fmemcpy(RPCData,&NameServerData,sizeof(RPCDataStruct));
    _fmemcpy(RPCFec,&NameServer,sizeof(RPCFecStruct));
  }
  dbaseloaded = 1;
  return 0;
}
char BroadcastDBaseFullName[80];
int loadBroadcastDBase(void)
{
  int cc=0,i,n,fmt,done=0;
  int keycol,fmtcol,sizcol,percol;
  FILE  far *fp = NULL;
  char far *ptr,str[256],hdr[256],scratch[17];

  if (_fstrlen(ControlDBpath) == 0)
  {
    ControlDBpath[0] = 0;
		if ((ptr=getenv("TINE.HOME")) != NULL ||
				(ptr=getenv("CONTROLDB")) != NULL)
			strncpy(ControlDBpath,ptr,60);
  }
  _fstrcpy(BroadcastDBaseFullName,ControlDBpath);
  _fstrcat(BroadcastDBaseFullName,"NGLOBALS.CSV");
  if ((n=GetDataBaseSize(BroadcastDBaseFullName)) > 0)
  {
    if ((fp=fopen(BroadcastDBaseFullName,"r")) == NULL) ccerr(no_such_file);
    if (!(BrdcstList=calloc(n,sizeof(BrdcstListStruct)))) ccerr(out_of_client_memory);
    for (done=0,i=0; fgets(str,255,fp) != NULL && i<n;)   /* scan file       */
    {
      if (_fstrchr("%;#\n",str[0])) continue;      /* comment line(s) */
      if (!done)
      {
        _fstrcpy(hdr,str);
        if ((keycol=findcol(hdr,"KEYWORD")) < 0) ccerr(no_such_line);
        if ((fmtcol=findcol(hdr,"FORMAT")) < 0) ccerr(no_such_line);
        if ((sizcol=findcol(hdr,"SIZE")) < 0) ccerr(no_such_line);
        if ((percol=findcol(hdr,"PERIOD_MAX")) < 0) ccerr(no_such_line);
        done = 1;
        continue;
      }
      _fstrncpy(BrdcstList[i].keyword,colptr(keycol,str),16);
      _fstrncpy(scratch,colptr(fmtcol,str),16); _fstrupr(scratch);
      if ((fmt=ftoi(scratch)) == CF_NULL) fmt = atoi(scratch); // historical
      BrdcstList[i].format = fmt;
      _fstrncpy(scratch,colptr(sizcol,str),16);
      BrdcstList[i].size = atoi(scratch);
      _fstrncpy(scratch,colptr(percol,str),16);
      BrdcstList[i].heartbeat = atoi(scratch);
      i++;
    }
  }
err: 
  if (fp != NULL) fclose(fp);
  return cc ? -cc : n;
}
short reformatData(void far *dst,short dstfmt,unsigned short dstsiz,void far *src,short srcfmt,unsigned short srcsiz)
{
  int i;
  short dsize;

  if (dstsiz < 1) return dimension_error;
  if (dstfmt == srcfmt) 
  {
    dsize = MIN(dstsiz,srcsiz) * fmtsizeof(dstfmt);
    _fmemcpy(dst,src,dsize);
    return 0;
  }

  switch (dstfmt)
  {
    case CF_SHORT: 
      switch (srcfmt)
      {
        case CF_LONG:  for (i=0; i<dstsiz && i<srcsiz; i++) ((short far *)dst)[i] = (short)((long far *)src)[i]; return 0;
        case CF_FLOAT: for (i=0; i<dstsiz && i<srcsiz; i++) ((short far *)dst)[i] = (short)((float far *)src)[i]; return 0;
        case CF_DOUBLE:for (i=0; i<dstsiz && i<srcsiz; i++) ((short far *)dst)[i] = (short)((double far *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_LONG:
      switch (srcfmt)
      {
        case CF_SHORT: for (i=0; i<dstsiz && i<srcsiz; i++) ((long far *)dst)[i] = (long)((short far *)src)[i]; return 0;
        case CF_FLOAT: for (i=0; i<dstsiz && i<srcsiz; i++) ((long far *)dst)[i] = (long)((float far *)src)[i]; return 0;
        case CF_DOUBLE:for (i=0; i<dstsiz && i<srcsiz; i++) ((long far *)dst)[i] = (long)((double far *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_FLOAT:
      switch (srcfmt)
      {
        case CF_SHORT: for (i=0; i<dstsiz && i<srcsiz; i++) ((float far *)dst)[i] = (float)((short far *)src)[i]; return 0;
        case CF_LONG:  for (i=0; i<dstsiz && i<srcsiz; i++) ((float far *)dst)[i] = (float)((long far *)src)[i]; return 0;
        case CF_DOUBLE:for (i=0; i<dstsiz && i<srcsiz; i++) ((float far *)dst)[i] = (float)((double far *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_DOUBLE:
      switch (srcfmt)
      {
        case CF_SHORT: for (i=0; i<dstsiz && i<srcsiz; i++) ((double far *)dst)[i] = (double)((short far *)src)[i]; return 0;
        case CF_LONG:  for (i=0; i<dstsiz && i<srcsiz; i++) ((double far *)dst)[i] = (double)((long far *)src)[i]; return 0;
        case CF_FLOAT: for (i=0; i<dstsiz && i<srcsiz; i++) ((double far *)dst)[i] = (double)((float far *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_NAME8:
      switch (srcfmt)
      {
        case CF_NAME16: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char far *)dst)[i*8],&((char far *)src)[i*16],8); return 0;
        case CF_NAME32: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char far *)dst)[i*8],&((char far *)src)[i*32],8); return 0;
        case CF_TEXT:   if (srcsiz < 8) return illegal_format;
          _fstrncpy((char far *)dst,(char far *)src,8); 
          return 0;
        default: return illegal_format;
      }
    case CF_NAME16: 
      switch (srcfmt)
      {
        case CF_NAME8: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char far *)dst)[i*16],&((char far *)src)[i*8],8); return 0;
        case CF_NAME32: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char far *)dst)[i*16],&((char far *)src)[i*32],16); return 0;
        case CF_TEXT:   if (srcsiz < 16) return illegal_format;
          _fstrncpy((char far *)dst,(char far *)src,16); 
          return 0;
        default: return illegal_format;
      }
    case CF_NAME32: 
      switch (srcfmt)
      {
        case CF_NAME8: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char far *)dst)[i*32],&((char far *)src)[i*8],8); return 0;
        case CF_NAME16:for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char far *)dst)[i*32],&((char far *)src)[i*16],16); return 0;
        case CF_TEXT:   if (srcsiz < 32) return illegal_format;
          _fstrncpy((char far *)dst,(char far *)src,32); 
          return 0;
        default: return illegal_format;
      }
    case CF_TEXT: 
      switch (srcfmt)
      {
        case CF_NAME8: for (i=0; i<dstsiz/8 && i<srcsiz; i++) strncpy(&((char far *)dst)[i*8],&((char far *)src)[i*8],8); return 0;
        case CF_NAME16:for (i=0; i<dstsiz/16 && i<srcsiz; i++) strncpy(&((char far *)dst)[i*16],&((char far *)src)[i*16],16); return 0;
        case CF_NAME32:for (i=0; i<dstsiz/32 && i<srcsiz; i++) strncpy(&((char far *)dst)[i*32],&((char far *)src)[i*16],32); return 0;
        default: return illegal_format;
      }
    default: return illegal_format;
  }
  return 0;
}
short ftoi(char far *fmt)
{
  short ifmt;
  _fstrupr(fmt);
  if ((ifmt=getSimpleFormatType(fmt)) != CF_NULL) return ifmt;
  return getCompoundFormatType(fmt);
}
