#ifndef _RPCDEFS_H_
#define _RPCDEFS_H_

#include "project.def"

#ifndef CNTXT_PREFIX
#define CNTXT_PREFIX "\\\\"
#endif

#ifndef DELIMITER
#define DELIMITER "/\\"
#endif
#ifndef RTOL
#define RTOL    0  /* Direction: Remote to Local */
#define LTOR    1  /* Direction: Local to Remote  */
#endif
#ifndef MAX
#define MAX(a,b)  ((a) > (b) ? a : b)
#endif
#ifndef MIN
#define MIN(a,b)  ((a) < (b) ? a : b)
#endif
#ifndef BYTE
#define BYTE unsigned char
#endif
#ifndef WORD
#define WORD unsigned short
#endif
#ifndef DWORD
#define DWORD unsigned long
#endif
#ifndef UINT8
#define UINT8 unsigned char
#endif
#ifndef UINT16
#define UINT16 unsigned short
#endif
#ifndef UINT32
#define UINT32 unsigned long
#endif

#ifndef TRUE
#define TRUE -1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#undef CF_TEXT
#define CF_DOUBLE       512
#define CF_UINT16       513
#define CF_SHORT        513
#define CF_INTEGER      513
#define CF_UINT8        514
#define CF_BYTE         514
#define CF_UINT32       515
#define CF_INT4         515
#define CF_LONG         515
#define CF_TEXT         516
#define CF_FLOAT        517
#define CF_POCALBLK     518
#define CF_STRUCT       519
#define CF_CHAR8        520
#define CF_NAME8        520
#define CF_STRING8      520
#define CF_CHAR16       521
#define CF_NAME16       521
#define CF_STRING16     521
#define CF_CHAR16FI     522
#define CF_NAME16FI     522
#define CF_BIT          523
#define CF_HITTS        524
#define CF_CHAR32       525
#define CF_NAME32       525
#define CF_STRING32     525
#define CF_FI           526
#define CF_FLTINT       526
#define CF_II           527
#define CF_LI           527
#define CF_LL           527
#define CF_INTINT       527
#define CF_LNGINT       527
#define CF_DI           528
#define CF_DBLINT       528
#define CF_SI           529
#define CF_SHTINT       529
#define CF_TDS          530
#define CF_IFI          530
#define CF_INTFLTINT    530
#define CF_CHAR48       531
#define CF_NAME48       531
#define CF_STRING48     531
#define CF_CHAR8I       532
#define CF_NAME8I       532
#define CF_CHAR16I      533
#define CF_NAME16I      533
#define CF_CHAR32I      534
#define CF_NAME32I      534
#define CF_CHAR48I      535
#define CF_NAME48I      535

#define CF_USTRING      536
#define CF_XYS          537
#define CF_FFI          537
#define CF_FLTFLTINT    537
#define CF_FII          538
#define CF_FLTINTINT    538
#define CF_FIS          538
#define CF_FILTER       539
#define CF_IFFF         539
#define CF_INTFLTFLTFLT 539
#define CF_SPECTRUM     540
#define CF_ADDRESS      541
#define CF_IIII         541
#define CF_INTINTINTINT 541
#define CF_WINDOW       542
#define CF_TTII         542
#define CF_POINT        543
#define CF_FF           543
#define CF_XY           543
#define CF_FLTFLT       543
#define CF_TDSI         544
#define CF_INTFLTSHTSHT 544
#define CF_BOOLEAN      545
#define CF_IIFF         546
#define CF_INTINTFLTFLT 546
#define CF_FWINDOW      546
#define CF_FIFI         547
#define CF_FLTINTFLTINT 547
#define CF_CHAR64       548
#define CF_NAME64       548
#define CF_STRING64     548
#define CF_CHAR64I      549
#define CF_NAME64I      549
#define CF_INTDBL       550
#define CF_LNGDBL       550
#define CF_FLTDBL       551
#define CF_DBLDBL       552
#define CF_NAMEDBLDBL   553
#define CF_NAME16DBLDBL 553

#define CF_DEFAULT      766
#undef CF_NULL
#define CF_NULL     767

#define getFormatSize(fmt)\
 ( fmt == CF_DOUBLE  ? 8 :\
   fmt == CF_SHORT   ? 2 :\
   fmt == CF_BYTE    ? 1 :\
   fmt == CF_LONG    ? 4 :\
   fmt == CF_FLOAT   ? 4 :\
   fmt == CF_STRUCT  ? 1 :\
   fmt == CF_POCALBLK? 1 :\
   fmt == CF_CHAR8   ? 8 :\
   fmt == CF_CHAR16  ? 16:\
   fmt == CF_CHAR32  ? 32:\
   fmt == CF_CHAR48  ? 48:\
   fmt == CF_CHAR64  ? 64:\
   fmt == CF_CHAR16FI? 24:\
   fmt == CF_SI      ? 6 :\
   fmt == CF_FI      ? 8 :\
   fmt == CF_II      ? 8 :\
   fmt == CF_DI      ? 12:\
   fmt == CF_TDS     ? 12:\
   fmt == CF_HITTS   ? 6 :\
   fmt == CF_CHAR8I  ? 12:\
   fmt == CF_CHAR16I ? 20:\
   fmt == CF_CHAR32I ? 36:\
   fmt == CF_CHAR48I ? 52:\
   fmt == CF_CHAR64I ? 68:\
   fmt == CF_USTRING ? 96:\
   fmt == CF_FFI     ? 12:\
   fmt == CF_FII     ? 12:\
   fmt == CF_IFFF    ? 16:\
   fmt == CF_IIII    ? 16:\
   fmt == CF_TTII    ? 16:\
   fmt == CF_IIFF    ? 16:\
   fmt == CF_FIFI    ? 16:\
   fmt == CF_XY      ?  8:\
   fmt == CF_TDSI    ? 12:\
   fmt == CF_SPECTRUM?  4:\
   fmt == CF_TEXT    ?  1:\
   fmt == CF_BIT     ?  4:\
   fmt == CF_BOOLEAN ?  4:\
   fmt == CF_LNGDBL  ?  12:\
   fmt == CF_FLTDBL  ?  12:\
   fmt == CF_DBLDBL  ?  16:\
   fmt == CF_NAMEDBLDBL ?  32:\
   fmt == CF_DEFAULT ?  1: 0 )

short ftoi(char far *fmt);

#define fmtsizeof(fmt)\
 ( (short)(fmt) < CF_DOUBLE ? getFormatSize((short)(fmt+CF_DOUBLE)) : getFormatSize((short)(fmt)) )

#define LFMT(fmt) ((fmt)+CF_DOUBLE)
#define BFMT(fmt) ((fmt)-CF_DOUBLE)

#define getSimpleFormatType(txt) (\
	!_fstrcmp(txt,"BYTE")     ? CF_BYTE :\
	!_fstrcmp(txt,"SHORT")    ? CF_SHORT :\
	!_fstrcmp(txt,"INT")      ? CF_SHORT :\
	!_fstrcmp(txt,"INTEGER")  ? CF_SHORT :\
	!_fstrcmp(txt,"LONG")     ? CF_LONG :\
	!_fstrcmp(txt,"FLOAT")    ? CF_FLOAT :\
	!_fstrcmp(txt,"SINGLE")   ? CF_FLOAT :\
	!_fstrcmp(txt,"DOUBLE")   ? CF_DOUBLE :\
	!_fstrcmp(txt,"STRUCT")   ? CF_STRUCT :\
	!_fstrcmp(txt,"TEXT")     ? CF_TEXT :\
	!_fstrcmp(txt,"CHAR")     ? CF_TEXT :\
	!_fstrcmp(txt,"STRING")   ? CF_TEXT :\
	!_fstrcmp(txt,"NAME8")    ? CF_CHAR8 :\
	!_fstrcmp(txt,"CHAR8")    ? CF_CHAR8 :\
	!_fstrcmp(txt,"NAME16")   ? CF_CHAR16 :\
	!_fstrcmp(txt,"CHAR16")   ? CF_CHAR16 :\
	!_fstrcmp(txt,"CHAR32")   ? CF_CHAR32 :\
	!_fstrcmp(txt,"NAME32")   ? CF_CHAR32 :\
	!_fstrcmp(txt,"CHAR48")   ? CF_CHAR48 :\
	!_fstrcmp(txt,"NAME48")   ? CF_CHAR48 :\
	!_fstrcmp(txt,"CHAR64")   ? CF_CHAR64 :\
	!_fstrcmp(txt,"NAME64")   ? CF_CHAR64 :\
	!_fstrcmp(txt,"BIT")      ? CF_BIT :\
	CF_NULL )

#define getCompoundFormatType(txt) (\
	!_fstrcmp(txt,"NAME16FI") ? CF_CHAR16FI :\
	!_fstrcmp(txt,"CHAR16FI") ? CF_CHAR16FI :\
	!_fstrcmp(txt,"NAME8I")   ? CF_CHAR8I :\
	!_fstrcmp(txt,"CHAR8I")   ? CF_CHAR8I :\
	!_fstrcmp(txt,"NAME16I")  ? CF_CHAR16I :\
	!_fstrcmp(txt,"CHAR16I")  ? CF_CHAR16I :\
	!_fstrcmp(txt,"NAME32I")  ? CF_CHAR32I :\
	!_fstrcmp(txt,"CHAR32I")  ? CF_CHAR32I :\
	!_fstrcmp(txt,"NAME48I")  ? CF_CHAR48I :\
	!_fstrcmp(txt,"CHAR48I")  ? CF_CHAR48I :\
	!_fstrcmp(txt,"NAME64I")  ? CF_CHAR64I :\
	!_fstrcmp(txt,"CHAR64I")  ? CF_CHAR64I :\
	!_fstrcmp(txt,"HITTS")    ? CF_HITTS :\
	!_fstrcmp(txt,"FI")       ? CF_FI :\
	!_fstrcmp(txt,"FLTINT")   ? CF_FI :\
	!_fstrcmp(txt,"FLTDBL")   ? CF_FLTDBL :\
	!_fstrcmp(txt,"II")       ? CF_II :\
	!_fstrcmp(txt,"INTINT")   ? CF_II :\
	!_fstrcmp(txt,"LI")       ? CF_II :\
	!_fstrcmp(txt,"LNGINT")   ? CF_II :\
	!_fstrcmp(txt,"LNGDBL")   ? CF_LNGDBL :\
	!_fstrcmp(txt,"INTDBL")   ? CF_LNGDBL :\
	!_fstrcmp(txt,"DI")       ? CF_DI :\
	!_fstrcmp(txt,"DBLINT")   ? CF_DI :\
	!_fstrcmp(txt,"DBLDBL")   ? CF_DBLDBL :\
	!_fstrcmp(txt,"NAMEDBLDBL") ? CF_NAMEDBLDBL :\
	!_fstrcmp(txt,"NAME16DBLDBL") ? CF_NAMEDBLDBL :\
	!_fstrcmp(txt,"SI")       ? CF_SI :\
	!_fstrcmp(txt,"SHTINT")   ? CF_SI :\
	!_fstrcmp(txt,"TDS")      ? CF_TDS :\
	!_fstrcmp(txt,"IFI")      ? CF_TDS :\
	!_fstrcmp(txt,"INTFLTINT")? CF_TDS :\
	!_fstrcmp(txt,"USTRING")  ? CF_USTRING :\
	!_fstrcmp(txt,"XYS")      ? CF_XYS :\
	!_fstrcmp(txt,"FFI")      ? CF_XYS :\
	!_fstrcmp(txt,"FLTFLTINT")? CF_XYS :\
	!_fstrcmp(txt,"FLTINTINT")? CF_FII :\
	!_fstrcmp(txt,"FIS")      ? CF_FII :\
	!_fstrcmp(txt,"FILTER")   ? CF_FILTER :\
	!_fstrcmp(txt,"IFFF")     ? CF_IFFF :\
	!_fstrcmp(txt,"INTFLTFLTFLT")? CF_IFFF :\
	!_fstrcmp(txt,"SPECTRUM") ? CF_SPECTRUM :\
	!_fstrcmp(txt,"ADDRESS")  ? CF_ADDRESS  :\
	!_fstrcmp(txt,"INTINTINTINT")? CF_ADDRESS  :\
	!_fstrcmp(txt,"IIII")     ? CF_ADDRESS  :\
	!_fstrcmp(txt,"WINDOW")   ? CF_WINDOW  :\
	!_fstrcmp(txt,"TTII")     ? CF_WINDOW  :\
	!_fstrcmp(txt,"POINT")    ? CF_POINT  :\
	!_fstrcmp(txt,"XY")       ? CF_POINT  :\
	!_fstrcmp(txt,"FLTFLT")   ? CF_POINT  :\
	!_fstrcmp(txt,"TDSI")     ? CF_TDSI  :\
	!_fstrcmp(txt,"INTFLTSHTSHT")? CF_TDSI  :\
	!_fstrcmp(txt,"BOOLEAN")? CF_BOOLEAN  :\
	!_fstrcmp(txt,"DEFAULT")  ? CF_DEFAULT :\
	!_fstrcmp(txt,"IIFF")     ? CF_IIFF :\
	!_fstrcmp(txt,"INTINTFLTFLT")? CF_IIFF :\
	!_fstrcmp(txt,"FIFI")     ? CF_FIFI :\
	!_fstrcmp(txt,"FLTINTFLTINT")? CF_FIFI :\
	!_fstrcmp(txt,"FWINDOW")   ? CF_FWINDOW  :\
	CF_NULL )

#define CM_NULL         0x00
#define CM_CANCEL       0x00
#define CM_SINGLE       0x01
#define CM_REFRESH      0x02
#define CM_POLL         0x03
#define CM_REGISTER     0x04
#define CM_BCAST        0x100
#define CM_NETWORK      0x200
#define CM_MCAST        0x200
#define CM_USE_ON_ERROR 0x400
#define CM_RETRY        0x800
#define CM_GROUPED      0x1000
#define CM_CONNECT      0x2000

#define BASEMODE(m)  ((m) & 0xff)
#define TARGETMODE(m)  ((m) & 0x0fff)

#define getAccessMode(txt) (\
 	_fstrstr(txt,"READ")    ? CM_SINGLE :\
	_fstrstr(txt,"WRITE")   ? CM_SINGLE :\
	_fstrstr(txt,"SINGLE")  ? CM_SINGLE :\
	_fstrstr(txt,"REFRESH") ? CM_REFRESH :\
	_fstrstr(txt,"POLL")    ? CM_POLL :\
	_fstrstr(txt,"REGISTER")? CM_REGISTER :\
	CM_CANCEL )

#define CA_NULL         0x00
#define CA_READ         0x01
#define CA_WRITE        0x02
#define CA_ASYNC        0x04
#define CA_SYNC         0x08
#define CA_ALARM        0x10
#define CA_HIST         0x20
#define CA_FIRST        0x40
#define CA_LAST         0x80
#define CA_CONNECT      0x2000
#define CA_SYNCNOTIFY   0x8000

#define getAccessType(txt) ( _fstrstr(txt,"WRITE") ? CA_WRITE : CA_READ )

#define CSHOSTS      "ENSEQM"
#define CSHOSTS_FILE "cshosts.csv"
#define EXPORT_FILE "exports.csv"
#define EQPDB_FILE   "eqpdbase.csv"
#define FECDB_FILE   "fecaddr.csv"
#define USERS_FILE   "users.csv"
#define IPNETS_FILE  "ipnets.csv"
#define IPBCASTNETS_FILE  "ipbcast.csv"
#define IPXNETS_FILE "ipxnets.csv"
#define IPXBCASTNETS_FILE "ipxbcast.csv"
#define DENYUSER_FILE     "denyuser.csv"
#define ALIAS_FILE        "alias.csv"

#define MAJOR_VERSION 3
#define MINOR_VERSION 30
#endif /* _RPCDEFS_H_ */
