#include "project.def"
#include <stdio.h>
#include <mem.h>
#include <dos.h>
#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <time.h>
#include <sys\timeb.h>
#include "nwipxspx.h"
#include "nwcaldef.h"
#include "nwcalls.h"
#include <winsock.h>
#include "errors.h"
#include "database.h"
#include "rpcsrv.h"

extern linkType link [MAXHOTLINKS];
extern int numLinks,nUDPsets;
extern char txtbuf[128];
extern char username[17];
extern FARPROC lpfnIncomingUDP;

extern int TCPGetResource(void);
extern int TCPFreeResource(void);
int debug = 0;
int TCPloaded = 0;
int IPXloaded = 0;
struct fd_set rwset;
struct timeval fec_to = { 0, 500000L };
extern struct fd_set conset;
int AsyncSocket;
extern WORD ASYsocket,CNSsocket;
extern WORD PnPsocket;
extern int SyncSocket;
extern int initialized;
char RPCLastErrorString[PREFIX+RPCERR_SIZE];
extern FILE far *fpDebugFile;
char strbuf[256];
extern time_t RPCtimestamp;

ElemDataStruct far *ElemList = NULL;
HANDLE hElemList = NULL;
LCLCONTRACT lclContract;
short IncomingNetworkProtocol;
struct sockaddr_in IncomingIPfec;
IPXAddress far *IncomingIPXfec;

int TimerPeriod = SYSTEM_DELAY;

extern RPCDataStruct far *RPCData;
extern RPCFecStruct  far *RPCFec;
extern HANDLE hRPCData, hRPCFec;

int RPCNumRecsRead=0,
  RPCNumFecsRead=0,
  RPCNumEqpsRead=0;

int RPCConnect(int size, HANDLE hElemPointer,WORD far *connectionID);
void RPCSend(int size, HANDLE hElemStart, WORD connectionID);
void RPCReceive(int size,HANDLE hElemStart,WORD connectionID);
void DoRPC(void);
void RemoveRPC(int ID);
void CancelElem(HANDLE hElem);
int locateFecName(char far *fecname);
int getRPCFecIndex(char far *fecname);
int getRPCDataIndex(char far *context,char far *name);
void output(char far *txt);

HCURSOR WaitCurs;
BYTE far *msgbuf;

int SynchronousCallPending = 0;

WORD IntSwap(WORD w) { return ((w>>8)|(w<<8)); }

int GetErrno(void);
int soioctl(int s,long cmd,char far *mode);
int soclose(int s);
void soperror(char far *txt)
{
  static char buf[40];
  int cc = WSAGetLastError();
  wsprintf(buf,"%s: error %d (%x)",(char far *)txt,cc,cc);
  output(buf);
  return;
}
extern char szDebugFile[82];
void OutputToDebugFile(char far *routine, char far *txt)
{
  static char outputbuffer[512];
  static time_t t;
  int len;

  if (szDebugFile[0] == 0) return;
  if ((fpDebugFile=fopen(szDebugFile,"a")) == NULL) return;
  wsprintf(outputbuffer,"%s : %s",routine,txt);
  if (outputbuffer[len=(_fstrlen(outputbuffer)-1)] == '\n') outputbuffer[len] = ' ';
  t = time(NULL);
  _fstrcat(outputbuffer,ctime(&t));
  fprintf(fpDebugFile,outputbuffer);
  fclose(fpDebugFile); fpDebugFile = NULL;
}

// =================================================
//         network stream data exchange routines
// =================================================
void SPXCleanup(void)
{
  int i;
  for (i=0;i<NUM_RCV_ECB;i++)
  {
   if (rcvECB[i]->ecb.inUseFlag) continue;
   rcvECB[i]->ecb.fragmentCount = 2;
   SPXListenForSequencedPacket(SPXTaskID,(ECB far *)rcvECB[i]);
  }
  return;
}
int SendRequest(int size,HANDLE hElemStart)
{
  int cc=0,fecindex,socket;
  WORD ID;
  ElemDataStruct far *e;

  e = (ElemDataStruct far *)DeReference(hElemStart);
  fecindex = e->FecIndex;
  WorkArea = (BYTE far *)GlobalLock(hWorkArea);

  PrepRequest(size,hElemStart);

  RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
retry:switch (RPCFec[fecindex].Prot)
  {
   case   0: if (locateFecName(RPCFec[fecindex].Name) < 0) ccerr(link_not_open);
        goto retry;
   case IPX: if ((ID=connectSPX(hElemStart)) == 0) ccerr(link_not_open);
        SPXSendData(ID);
        cc = getSPXStream(ID);
        break;
   case UDP: TCPGetResource();
        if ((socket=connectTCP(hElemStart)) < 0)
        {
         TCPFreeResource();
         ccerr(-socket);
        }
        TCPSendData(socket);
        cc = getTCPStream(socket);
        TCPFreeResource();
        break;
  }
err: decodeData(cc,size,hElemStart);
  GlobalUnlock(hWorkArea);
  return cc;
}
void PrepRequest(int size,HANDLE hElemStart)
{
  int dsize,i;
  int cnt=sizeof(HeaderStruct),rwflag=size,eqsize=abs(size);
  ElemDataStruct far *e;
  BYTE far *data;
  HANDLE hElem;
  HeaderStruct far *RPCHeader = (HeaderStruct far *)WorkArea;
  EqpInfoStruct far *eqp;

  _fstrncpy((LPSTR)RPCHeader->UserName,(LPSTR)username,16);

  e = (ElemDataStruct far *)DeReference(hElemStart);
  RPCFec=(RPCFecStruct far *)DeReference(hRPCFec);
  RPCHeader->EqpSize = size;
  RPCHeader->Protocol = 1;
  RPCHeader->TotalSize = sizeof(HeaderStruct) + sizeof(EqpInfoStruct)*eqsize;

  if (rwflag<0) for (i=0; i<eqsize; i++)
  {
   dsize = (UINT16)(fmtsizeof(e->formatOut)*MAX(e->sizeOut,e->sizeIn));
   RPCHeader->TotalSize += dsize;
   if (!(hElem = e->hNext)) break;
   e = (ElemDataStruct far *)DeReference(hElem);
  }
  e = (ElemDataStruct far *)DeReference(hElemStart);

  for (i=0; i<eqsize; i++,cnt+=sizeof(EqpInfoStruct))
  {
   eqp = (EqpInfoStruct far *)&WorkArea[cnt];
   _fmemcpy(eqp->ElemName,e->ElemName,sizeof(eqp->ElemName));
   _fmemcpy(eqp->EqpModName,e->EqName,sizeof(eqp->EqpModName));
   eqp->EqpModNo = e->EqNo;
   _fmemcpy(eqp->Property,e->Property,sizeof(eqp->Property));
   eqp->Format   = e->formatOut;
   eqp->DataSize = (short)e->sizeOut;
   if (debug)
   {
     wsprintf(strbuf,"Request: %s %s %d (%d %d) [%s] (%d ms) <SINGLE>\n",
       e->ElemName,e->Property,e->EqNo,e->sizeOut,e->formatOut,
       RPCFec[e->FecIndex].Name,e->PollRate);
     output(strbuf);
   }
   do
   {
     if (!(hElem=e->hNext)) break;
     e = (ElemDataStruct far *)DeReference(hElem);
   } while (!e->Acquire);
  }
  if (rwflag<0)
  {
   e = (ElemDataStruct far *)DeReference(hElemStart);
   for (i=0; i<eqsize; i++,cnt+=dsize)
   {
     dsize = MAX(e->sizeOut,e->sizeIn)*fmtsizeof(e->formatOut);
     data=(BYTE far *)DeReference(e->hDataIn);
     _fmemcpy(&WorkArea[cnt],data,dsize);
     if (dsize%2) dsize++;                             // 16-bit boundaries
     do
     {
      if (!(hElem=e->hNext)) break;
      e = (ElemDataStruct far *)DeReference(hElem);
     } while (!e->Acquire);
   }
  }
  return;
}

WORD connectSPX(HANDLE hElem)
{
  ElemDataStruct far *e;
  int fecindex;
  time_t interim = time(NULL);
  static WORD ID;

  RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
  e = (ElemDataStruct far *)DeReference(hElem);
  fecindex = e->FecIndex;

  conECB->ecb.socketNumber=SPXsocket;
  conECB->ecb.fragmentCount=1;
  *(WORD far *)conECB->hdr.destination.socket = *(WORD far *)&rpc_socket[0];
  _fmemcpy(&conECB->hdr.destination,RPCFec[fecindex].Network,10);

  SPXEstablishConnection(SPXTaskID,RPC_RETRY_COUNT,0,&ID,(ECB far *)conECB);

  while (conECB->ecb.inUseFlag && time(NULL) <= interim + 1) IPXRelinquishControl();
  if (conECB->ecb.inUseFlag)
  {
   IPXCancelEvent(SPXTaskID,(ECB far *)conECB);
   return RPCFec[fecindex].Prot = 0;
  }

  if (conECB->ecb.completionCode) return RPCFec[fecindex].Prot = 0;
  return ID;
}
int connectTCP(HANDLE hElem)
{
  static int sck;
  static optval = 1;
#ifdef WINSOCK
  static u_long mode = 1;
#else
  static int mode = 1;
#endif
  static struct sockaddr_in sck_name;
  ElemDataStruct far *e;
  time_t interim = time(NULL);
  int cc=0,fecindex;

  e = (ElemDataStruct far *)DeReference(hElem);
  fecindex = e->FecIndex;

  if (!TCPloaded) return tcp_not_supported;

  RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
  if (!RPCFec[fecindex].iaddr) return non_existent_fec;
  _fmemset(&sck_name,0,sizeof(sck_name));
  _fmemcpy(&sck_name.sin_addr,&RPCFec[fecindex].iaddr,4);
  sck_name.sin_family=AF_INET;
  sck_name.sin_port = htons(TCP_LEGACYPORT+RPCFec[fecindex].PortOffset);

  if ((sck=socket(AF_INET,SOCK_STREAM,0)) < 0) ccerr(tcp_socket_error);
  if (setsockopt(sck,SOL_SOCKET,SO_REUSEADDR,(char far *)&optval,sizeof(optval)))
   ccerr(tcp_socket_error);
  if (soioctl(sck,FIONBIO,(char far *)&mode)) ccerr(tcp_socket_error);
  while  (connect(sck,(struct sockaddr far *)&sck_name,sizeof(sck_name)) < 0)
  {
   if (time(NULL) > interim + RPC_TIMEOUT*2) ccerr(link_not_open);
   if (GetErrno() == EISCONN) break;
  }
err: if (cc)
  {
   soclose(sck);
   if (debug) soperror("socket");
  }
  return cc ? -cc : sck;
}
void SPXSendData(WORD ID)
{
  int cnt,msgsize,dsize;
  time_t interim = time(NULL);

  msgsize = *(int far *)WorkArea;
  sndECB->ecb.fragmentCount=2;
  sndECB->hdr.dataStreamType=0;

  for (cnt=0, dsize=0; cnt<msgsize; cnt+=dsize)
  {
   dsize = msgsize-cnt>IPX_DATA_SIZE ? IPX_DATA_SIZE : msgsize-cnt;
   _fmemcpy(sndECB->buf,&WorkArea[cnt],dsize);
   SPXSendSequencedPacket(SPXTaskID,ID,(ECB far *)sndECB);
   while (sndECB->ecb.inUseFlag && time(NULL) <= interim + 1) IPXRelinquishControl();
   if (sndECB->ecb.inUseFlag)
   {
     IPXCancelEvent(SPXTaskID,(ECB far *)sndECB);
     break;
   }
   if (sndECB->ecb.completionCode) break;
  }
  return;
}
void TCPSendData(int socket)
{
  int cnt = 0,msgsize,dsize;
  time_t interim = time(NULL);

  msgsize = *(int far *)WorkArea;
  while (cnt<msgsize && time(NULL) < interim + RPC_TIMEOUT*2)
  {
   if ((dsize=send(socket,(LPSTR)&WorkArea[cnt],msgsize-cnt,0)) > 0)
     cnt += dsize;
  }
  return;
}
int getSPXStream(WORD ID)
{
  int i,b,bytesread=0,actseq=0,cc=0,msgsize=-1;
  WORD seqnr = 0xffff;
  HANDLE hNew;
  time_t interim = time(NULL);

  while (time(NULL) < interim+RPC_TIMEOUT) for (i=0; i<NUM_RCV_ECB; i++)
  {
   IPXRelinquishControl();
   if (ID != rcvECB[i]->hdr.destConnectionID) continue;
   if (rcvECB[i]->ecb.inUseFlag) continue;
   if ((seqnr = IntSwap(rcvECB[i]->hdr.sequenceNumber)) != actseq) continue;
   if (rcvECB[i]->hdr.dataStreamType==0xfe) ccerr(0);
   if (!seqnr)
   {
     msgsize = *(int far *)rcvECB[i]->buf;
     if (msgsize > WorkAreaSize)
     {
      GlobalUnlock(hWorkArea);
      if ((hNew=GlobalReAlloc(hWorkArea,msgsize,GMEM_MOVEABLE)) == hNULL)
        ccerr(out_of_client_memory);
      WorkAreaSize = msgsize; hWorkArea = hNew;
      WorkArea = (BYTE far *)GlobalLock(hWorkArea);
     }
     msgbuf = (BYTE far *)&WorkArea[sizeof(int)];
   }
   b = msgsize-bytesread > IPX_DATA_SIZE ? IPX_DATA_SIZE :
                                 msgsize-bytesread;
   _fmemcpy(&WorkArea[bytesread],&rcvECB[i]->buf,b);
   SPXListenForSequencedPacket(SPXTaskID,(ECB far *)rcvECB[i]);
   actseq = seqnr+1;
   if ((bytesread += b) == msgsize) ccerr(0);
  }

err:
  IPXRelinquishControl();
  sndECB->ecb.fragmentCount = 1;
  SPXTerminateConnection(SPXTaskID,ID,(ECB far *)sndECB);
  SPXCleanup();
  if (bytesread != msgsize) cc = remitted_data_lost;
  return cc;
}
int getTCPStream(int socket) // windows TCP sockets are non-blocking
{
  int d,bytesread,cc=0;
  static msgsize=0;
  HANDLE hNew;
  time_t interim = time(NULL);

  if (!TCPloaded) return -tcp_not_supported;

  for (msgsize=0,bytesread=0;bytesread<2;)
  {
   if ((d=recv(socket,&((LPSTR)&msgsize)[bytesread],2-bytesread,0)) > 0)
     bytesread += d;
   if (time(NULL) > interim+RPC_TIMEOUT*2) ccerr(remitted_data_lost);
  }
  if (msgsize > WorkAreaSize)
  {
   GlobalUnlock(hWorkArea);
   if ((hNew=GlobalReAlloc(hWorkArea,msgsize,GMEM_MOVEABLE)) == hNULL)
     ccerr(out_of_client_memory);
   WorkAreaSize = msgsize; hWorkArea = hNew;
   WorkArea = (BYTE far *)GlobalLock(hWorkArea);
  }
  msgbuf = (BYTE far *)&WorkArea[sizeof(int)];
  *(int far *)WorkArea = msgsize;
  while (bytesread<msgsize)
  {
   if (time(NULL) > interim+RPC_TIMEOUT+msgsize/3000) ccerr(remitted_data_lost);
   if ((d=recv(socket,(LPSTR)&WorkArea[bytesread],msgsize-bytesread,0)) > 0)
     bytesread += d;
  }
err: soclose(socket);
  return cc;
}
int decodeData(int cc,int size,HANDLE hElemStart)
{
  int b,el,datasize;
  int eqsize=abs(size),msgsize = *(int far *)WorkArea-sizeof(int);
  ElemDataStruct far *e;
  HANDLE hElem;
  char far *Values;

  e = (ElemDataStruct far *)DeReference(hElemStart);
  RPCFec=(RPCFecStruct far *)DeReference(hRPCFec);

  Values = (char far *)DeReference(e->hDataOut);
  for (b=0,el=0; el<eqsize; el++)
  {
   if (cc) e->CompCode = cc;
   else
   {
     e->CompCode = *(int far *)&msgbuf[b]; b += 2;
     if (!e->CompCode && b+4<=msgsize)
     {
      if (e->formatOut != *(int far *)&msgbuf[b]) ccerr(illegal_format);
      b += 2;
      datasize = *(int far *)&msgbuf[b];  b += 2;
      if (datasize > e->sizeOut*fmtsizeof(e->formatOut)) ccerr(out_of_range);
      _fmemcpy(Values,&msgbuf[b],datasize); b += datasize;
      if (debug)
      {
        wsprintf(strbuf,"%s %s (%d) [%d bytes (%d)]<%d>\n",
                        e->ElemName,e->Property,e->EqNo,datasize,e->formatOut,cc);
        output(strbuf);
      }
     }
   }
   do
   {
     if (!(hElem=e->hNext)) goto out;
     e = (ElemDataStruct far *)DeReference(hElem);
     Values = (char far *)DeReference(e->hDataOut);
   } while (!e->Acquire);
  }

out: e = (ElemDataStruct far *)DeReference(hElemStart);
  for (el=0; el<eqsize; el++)
  {
   NotifyClients(e);
   do
   {
     if (!(hElem=e->hNext)) return 0;
     e = (ElemDataStruct far *)DeReference(hElem);
   } while (!e->Acquire);
  }
err: return cc;
}
void NotifyClients(ElemDataStruct far *e)
{
  static RECT Rect;
  time_t timestamp = time(NULL);
  int i,id,cc,notified = FALSE;
  static char lclbuf[256];

  for (i=0; i<MAXCOMMONLINKS && (id=e->links[i]) > 0; i++)
  {
    if (link[id].active <= 0) continue;  // just a place holder
    notified = TRUE;
    if (debug) wsprintf(lclbuf,"link %s %s (%d) notification : ",e->ElemName,e->Property,id);
    if ((cc=e->CompCode) != 0) link[id].dataFlg = cc;
    else link[id].dataFlg = -1;
    if (link[id].hVBWnd == hDLLWnd)               //internal
    {
      if (debug) wsprintf(&lclbuf[strlen(lclbuf)],"Synchronous\n");
      SynchronousCallPending = 0;
      link[id].hVBXWnd = 0;
    }
    else if (link[id].hVBWnd && IsWindow(link[id].hVBWnd))
    {
      if (debug) wsprintf(&lclbuf[strlen(lclbuf)],"Paint\n");
      GetClientRect (link[id].hVBWnd, (LPRECT) &Rect);
      InvalidateRect (link[id].hVBWnd, (LPRECT) &Rect, TRUE); // send PAINT msg
    }
    else if (link[id].hVBXWnd && IsWindow (link[id].hVBXWnd))
    {
      if (debug) wsprintf(&lclbuf[strlen(lclbuf)],"OLE control\n");
      PostMessage(link[id].hVBXWnd, RPCMSG_RECEIVE, id, cc);
    }
    else
    {
      if (debug) wsprintf(&lclbuf[strlen(lclbuf)],"NO PARENT !!\n");
      MessageBeep(0);   // this should never happen !!
      e->mode = CM_CANCEL;
      e->heartbeat = 0;
    }
    if (debug) output(lclbuf);
  }
  if (!notified) // active link with no desktop client !
  {
    MessageBeep(0);   // this should never happen !!
    e->mode = CM_CANCEL;
    e->heartbeat = 0;
  }
  e->time = timestamp;
  return;
}

// =================================================
//      Hot link cycle from connection streams
// =================================================

void DoRPC(void)
{
  BOOL Acquire = FALSE;
  ElemDataStruct far *e,far *eStart,far *eStop;
  HANDLE hElem,hElemStart,hElemStop;
  int size, rwflag;
  time_t timestamp = time(NULL);
  HCURSOR OldCurs;

  for (hElem=hElemList; hElem!=hNULL; hElem=e->hNext)
  {
    e = (ElemDataStruct far *)DeReference(hElem);
    if (e == NULL) return;
    e->Acquire = FALSE;
    if (e->mode == CM_REGISTER || e->mode == CM_CANCEL) continue;
    if (e->RPCprotocol < 1 || e->RPCprotocol > 2) continue;
    if (e->PollRate < 1000) e->PollRate = 1000;
    if (timestamp >= (e->PollRate/1000) + e->time)
    {
      e->Acquire = TRUE;
      Acquire = TRUE;
    }
  }
  if (!Acquire) return;               // nothing to do

  hElemStop = hElemList;
  eStop = (ElemDataStruct far *)DeReference(hElemStop);

  while (hElemStop != NULL)
  {
    size=0;  rwflag = 0;             // how many go out to same FEC at same time ?
    while(!eStop->Acquire)
    {
      if (!(hElemStop = eStop->hNext)) return;
      eStop = (ElemDataStruct far *)DeReference(hElemStop);
    }
    hElemStart = hElemStop;
    eStart = (ElemDataStruct far *)DeReference(hElemStart);
    while (eStart->FecIndex == eStop->FecIndex)
    {
      if (eStop->Acquire)
      {
         if (!rwflag) rwflag = eStop->access & CA_WRITE ? -1 : 1;
         if (eStop->access & CA_WRITE && rwflag == 1) break;
            if (!(eStop->access & CA_WRITE) && rwflag == -1) break;
         if (eStop->mode == CM_SINGLE) eStop->mode = CM_CANCEL;
         size++;
     }
     if (!(hElemStop = eStop->hNext)) break;
     eStop = (ElemDataStruct far *)DeReference(hElemStop);
    }
    OldCurs=SetCursor(WaitCurs);
    SendRequest(size*rwflag,hElemStart);
    SetCursor(OldCurs);
  }
}
void RemoveRPC(int ID)
{
  ElemDataStruct far *elem;
  HANDLE h,hElem;
  int i, idx = 0;

  if (debug)
  {
    wsprintf(strbuf,"Remove RPC link id %d\n",ID);
    output(strbuf);
  }
  if (ID==-1)
  {
    for (hElem=hElemList; hElem!=hNULL; )
    {
      elem = (ElemDataStruct far *)DeReference(hElem);
      h = hElem; hElem=elem->hNext;
      CancelElem(h);
    }
    while(hElemList!=NULL)
    {
      CheckSubscriptions();
      Cleanup();
    }
    return;
  }
  if (!(hElem=link[ID].hElem)) { link[ID].active = 0; return; }
  elem=(ElemDataStruct far *)DeReference(hElem);
  if (elem == NULL) return;

  link[ID].active = elem->ID == ID ? -1 : 0;
  link[ID].hElem = 0;

  for (i=0; i<MAXCOMMONLINKS && elem->links[i] > 0; i++) if (elem->links[i] == ID) idx = i;

  if (i==1) CancelElem(hElem);
  else
  {
    for (i=idx; i<MAXCOMMONLINKS-1 && elem->links[i] >= 0; i++)              // reorder
      elem->links[i] = elem->links[i+1];

    elem->links[i] = -1;
  }
  return;
}

#define IsSynchronous(id) if (id == 0) {\
  link[0].hVBWnd    = hDLLWnd;\
  link[0].active    = 1; }

#define MAXMODE(m1,m2) (\
  m1 == REGISTER ? m2 :\
  m2 == REGISTER ? m1 :\
  m1 > m2 ? m1 : m2\
)
int maxmode(int m1, int m2)
{
  int hibyte,m;
  if (m1 == REGISTER) return m2;
  if (m2 == REGISTER) return m1;
  m = MAX(BASEMODE(m1),BASEMODE(m2));
  hibyte = MAX((m1 & 0xf00),(m2 & 0xf00));
  return m | hibyte;
}

int CreateElem(int ID)
{
  ElemDataStruct far *e,far *tag,far *nxt;
  HANDLE hElem,hTag,hNxt;
  short i,cc=0,fecindex,dataindex;
  LCLCONTRACT far *con = &lclContract;
  BYTE far *DataIn;
  UINT16 dinsize,pktlen;
  UINT32 allocsizeOut;

  RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
  RPCData = (RPCDataStruct far *)DeReference(hRPCData);
  if ((dataindex=getRPCDataIndex(con->EqpContext,con->EqpTagName)) < 0) ccerr(-dataindex);
  if ((fecindex=getRPCFecIndex(RPCData[dataindex].FecName)) < 0) ccerr(-fecindex);
  if (!RPCFec[fecindex].Prot && (i=locateFecName(RPCFec[fecindex].Name)) < 0) ccerr(-i);
  _fstrncpy(con->EqpName,RPCData[dataindex].EqName,EQNAME_SIZE);
  _fstrncpy(con->FecName,RPCFec[fecindex].Name,16);

  if (ID != 0 && (hElem=GetElemPointer(con)) != NULL)
  {
    e = (ElemDataStruct far *)DeReference(hElem);
    for(i=0;i<MAXCOMMONLINKS && e->links[i] >= 0; i++);
    if (i==MAXCOMMONLINKS) return buffer_too_small;
    // mode could have been set to CM_CANCEL
    e->PrimeMode = maxmode(e->PrimeMode,e->mode);
    e->links[i]=ID;
    link[ID].hElem = hElem;
    IsSynchronous(ID); // 0 is reserverd for cold links
    if (debug)
    {
      wsprintf(strbuf,"Link %d (%s %s) found (instance %d)\n",ID,e->ElemName,e->Property,i);
      output(strbuf);
    }
    ccerr(0);
  }
  if (ID == 0) link[ID].hElem = hNULL;
  if (!(hElem=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,sizeof(ElemDataStruct))))
    return out_of_client_memory;

  e = (ElemDataStruct far *)DeReference(hElem);
  e->hNext = 0;
  _fstrncpy(e->ElemName,con->EqpTagName,16);
  e->sizeIn = con->EqpSizeIn;
  e->sizeOut = con->EqpSizeOut;
  e->PollRate = con->PollRate > 0 ? con->PollRate : _POLLRATE;
  e->formatIn = LFMT(con->EqpFormatIn);
  e->formatOut = LFMT(con->EqpFormatOut);
  if (e->sizeIn && !(e->hDataIn=GlobalAlloc(GMEM_MOVEABLE,fmtsizeof(con->EqpFormatIn)*con->EqpSizeIn)))
  {
    GlobalFree(hElem);
    return out_of_client_memory;
  }
  allocsizeOut = fmtsizeof(con->EqpFormatOut)*con->EqpSizeOut;
  if (allocsizeOut%2) allocsizeOut++;
  if (e->sizeOut && !(e->hDataOut= GlobalAlloc(GMEM_MOVEABLE,allocsizeOut)))
  {
    if (e->hDataIn) GlobalFree(e->hDataIn);
    GlobalFree(hElem);
    return out_of_client_memory;
  }
  _fstrncpy(e->strTagOut,con->strTagOut,8);
  _fstrncpy(e->strTagIn,con->strTagIn,8);
  e->access = con->EqpAccess;
  e->blknumIn = 1;
  e->numblksIn = 1;
  e->nextDataPtr = 0;
  e->blkidIn = 0;
  pktlen = RPCFec[fecindex].Prot == IPX ? IPX_BUFFER_SIZE : UDP_BUFFER_SIZE;
  e->datamtu = pktlen - SUBSCRIPTION_SIZE - HEADERSTRUCT_SIZE;
  if (e->sizeIn > 0)
  {
    dinsize = (UINT16)e->sizeIn*fmtsizeof(e->formatIn);
    DataIn = (BYTE far *)DeReference(e->hDataIn);
    _fmemcpy(DataIn,con->DataIn,dinsize);
    e->BytesTotal = dinsize;
    e->BytesRemaining = dinsize;
    e->numblksIn = dinsize/e->datamtu + (dinsize%e->datamtu ? 1 : 0);
    e->nextDataSize = MIN(e->datamtu,e->BytesTotal);
  }
  if (RPCFec[fecindex].MaxRPCProt == 0) RPCFec[fecindex].MaxRPCProt = 5;
  e->RPCprotocol = RPCFec[fecindex].MaxRPCProt;
  if (e->RPCprotocol == 4)
  {
    if (e->sizeIn*fmtsizeof(e->formatIn) > UDP_BUFFER_SIZE - SUBSCRIPTION4_SIZE) e->RPCprotocol = 1;
    else if (e->sizeOut*fmtsizeof(e->formatOut) > UDP_BUFFER_SIZE - PRODUCER4_SIZE) e->RPCprotocol = 1;
  }
  e->heartbeat = 0;
  e->timeoutCount = 10;
  e->PrimeMode = REGISTER;
  e->mode = REGISTER;
  e->FecIndex = fecindex;
  e->protocol = RPCFec[fecindex].Prot;
  _fstrncpy(e->EqName,RPCData[dataindex].EqName,EQNAME_SIZE);
  _fstrncpy(e->Property,con->EqpProperty,PROPERTY_SIZE);
  _fstrncpy(e->DeviceName,con->EqpDeviceName,16);
  _fstrncpy(e->Context,con->EqpContext,16);
  _fstrncpy(e->FecName,RPCFec[fecindex].Name,16);
  e->EqNo = atoi(&e->DeviceName[1]);
  e->CompCode=0;
  e->ID = ID;        // subscription ID tag
  e->links[0]=ID;
  e->starttime = time(NULL);
  for(i=1;i<MAXCOMMONLINKS; i++) e->links[i] = -1;
  link[ID].hElem = hElem;
  IsSynchronous(ID); // 0 is reserverd for cold links
  if (debug)
  {
    wsprintf(strbuf,"Link %d (%s %s %s) created\n",ID,e->ElemName,e->DeviceName,e->Property);
    output(strbuf);
  }

  // 1st one is now out or order, find out where it belongs:
  if ((hTag=hElemList) == hNULL) hElemList = hElem; // list is empty
  else
  {
    tag = (ElemDataStruct far *)DeReference(hTag);
    if (tag->FecIndex > e->FecIndex)     // look no further
    {
      e->hNext = hTag;
      hElemList = hElem;
    }
    else									  // find location
    {

      while ((hNxt=tag->hNext) != hNULL)
      {
        nxt = (ElemDataStruct far *)DeReference(hNxt);
        if (nxt->FecIndex > e->FecIndex) break;
        tag = nxt;
      }
      e->hNext = hNxt;
      tag->hNext = hElem;
    }
  }
err:
  return cc;
}
HANDLE GetElemPointer(LCLCONTRACT far *c)
{
  ElemDataStruct far *e = NULL;
  char lclElemName[17];
  HANDLE hElem;
  UINT16 dinsize;
  BYTE *DataIn;

  _fstrncpy(lclElemName,c->EqpTagName,16); lclElemName[16] = 0;
  for (hElem=hElemList; hElem != hNULL; hElem=e->hNext)
  {
    e = (ElemDataStruct far *)DeReference(hElem);
    if (!_fstrncmp(c->FecName,e->FecName,16) &&
        !_fstrncmp(lclElemName,e->EqName,6) &&
	!_fstrncmp(c->EqpProperty,e->Property,32) &&
	!_fstrncmp(c->EqpDeviceName,e->DeviceName,16))
    {
      if (e->sizeOut > 0)
      {
        if (e->sizeOut != c->EqpSizeOut || e->formatOut != LFMT(c->EqpFormatOut)) continue;
	if (_fstrncmp(e->strTagOut,c->strTagOut,8)) continue;
      }
      if (e->sizeIn > 0)
      {
        if (c->DataIn == NULL || e->sizeIn != c->EqpSizeIn || e->formatIn != LFMT(c->EqpFormatIn))
	  continue;
        if (_fstrncmp(e->strTagIn,c->strTagIn,8)) continue;
        dinsize = (UINT16)e->sizeIn*fmtsizeof(e->formatIn);
        DataIn = (BYTE far *)DeReference(e->hDataIn);
        if (_fmemcmp(c->DataIn,DataIn,dinsize)) continue;
      }
      else if (c->EqpSizeIn) continue;
      if (e->CompLoc == -1) continue;  // going out of scope soon
      return hElem;         /* found it */
    }
  }
  return hNULL;
}
void CancelElem(HANDLE hElem)
{
  ElemDataStruct far *e;

  e = (ElemDataStruct far *)DeReference(hElem);
  if (debug > 1)
  {
    wsprintf(strbuf,"Cancel %d (next at %d)\n",hElem,e->hNext);
    output(strbuf);
  }
  if (e->RPCprotocol >= 4 && BASEMODE(e->mode) > CM_SINGLE && BASEMODE(e->mode) < CM_REGISTER)
  {
     e->heartbeat = SUB_PENDING;
     e->mode = CM_CANCEL;
     e->links[0] = -1;
     e->CompLoc = -1;   // special flag
  }
  else RemoveElem(hElem);
}
void RemoveElem(HANDLE hElem)
{
   int i,id;
   ElemDataStruct far *t, far *e;
   HANDLE hTemp;

   e = (ElemDataStruct far *)DeReference(hElem);
   if (debug)
   {
     wsprintf(strbuf,"remove %s %s\n",e->ElemName,e->Property);
     output(strbuf);
   }
   for (i=0; i<MAXCOMMONLINKS && (id=e->links[i]) > 0; i++)
   {
     link[id].hElem = 0; link[id].active = 0;
     if (debug)
     {
       wsprintf(strbuf,"Link %d deactivated\n",id);
       output(strbuf);
     }
   }
   link[e->ID].active = 0;
   if (hElemList == hElem)
   {
     hElemList = e->hNext;
     if (e->hDataIn) GlobalFree(e->hDataIn);
     if (e->hDataOut) GlobalFree(e->hDataOut);
     GlobalFree(hElem);
     return;
   }

   hTemp = hElemList;
   t = (ElemDataStruct far *)DeReference(hTemp);
   while (t->hNext != hNULL)
   {
     if (t->hNext == hElem) break;
     hTemp = t->hNext;
     t = (ElemDataStruct far *)DeReference(hTemp);
   }
   if (t->hNext == NULL) return;

   t->hNext = e->hNext;
   if (e->hDataIn) GlobalFree(e->hDataIn);
   if (e->hDataOut) GlobalFree(e->hDataOut);
   GlobalFree(hElem);
   return;
}
// =============================================
//       Network broadcast global routines
// =============================================
void doGlobalUpdate(BYTE far *buf)
{
  int cc,i,j,num,size=sizeof(HeaderStruct),fmtsize,datasize;
  char far *buffer;
  BrdcstData far *brdcstdata;
  HeaderStruct far *brdcstHdr = (HeaderStruct far *)buf;

  num = brdcstHdr->EqpSize;
  if (brdcstHdr->Protocol != 3) ccerr(illegal_protocol);

  for (i=0; i<num; i++)
  {
   brdcstdata = (BrdcstData far *)&buf[size];
   size += sizeof(BrdcstData);
   fmtsize = getFormatSize(brdcstdata->format);
   if (fmtsize == 0) ccerr(illegal_format); // unknown format type
   if (debug)
   {
     if (IncomingNetworkProtocol == UDP)
       wsprintf(strbuf,"recv UDP GLB : %s\n",(char far *)brdcstdata->name);
     else
       wsprintf(strbuf,"recv IPX GLB : %s\n",(char far *)brdcstdata->name);
     output(strbuf);
   }
   for (j=0; j<nglobals; j++)
   {
     if (!_fstricmp(brdcstdata->name,BrdcstList[j].keyword))
     {
       BrdcstList[j].brdcstTime = time(NULL);
       BrdcstList[j].time = brdcstdata->time;
       datasize = BrdcstList[j].size > brdcstdata->size ?
                  brdcstdata->size : BrdcstList[j].size;
       buffer = (char far *)DeReference(BrdcstList[j].hData);

//       if (BrdcstList[j].format != brdcstdata->format) ccerr(illegal_format);
//       _fmemcpy(buffer,&buf[size],fmtsize*datasize);
       if ((cc=reformatData(buffer,BrdcstList[j].format,BrdcstList[j].size,
                            &buf[size],brdcstdata->format,brdcstdata->size)) != 0) ccerr(cc);
       break;
     }   // keywords matched
   }
   size += brdcstdata->size*fmtsize;
  }

err:
  return;
}
void GetGlobalIPX(void)
{
  int i;

  for (i=0; i<NUM_GLB_ECB; i++) if (!glbECB[i]->ecb.inUseFlag)
  {
   IncomingNetworkProtocol = IPX;
   if (!glbECB[i]->ecb.completionCode) doGlobalUpdate(glbECB[i]->buf);
   IPXListenForPacket(IPXTaskID,(ECB far *)glbECB[i]);
  }

  return;
}
void GetIPXData(int num,IPXECB far *e[])
{
  int i;

  IncomingNetworkProtocol = IPX;
  WorkArea = (BYTE far *)GlobalLock(hWorkArea);
  for (i=0; i<num; i++) if (!e[i]->ecb.inUseFlag)
  {
    IncomingIPXfec = &e[i]->hdr.source;
    if (!e[i]->ecb.completionCode) consumeData(e[i]->buf);
    IPXListenForPacket(IPXTaskID,(ECB far *)e[i]);
  }
  GlobalUnlock(hWorkArea);
  return;
}
void GetGlobalUDP(void)
{
  int n;
  static int len = sizeof(IncomingIPfec);

  IncomingNetworkProtocol = UDP;
  WorkArea = (BYTE far *)GlobalLock(hWorkArea);
  if ((n=recvfrom(GlobalSocket,(char far *)WorkArea,UDP_BUFFER_SIZE,0,
                 (struct sockaddr far *)&IncomingIPfec,&len)) > 0)
  {
     if (n < *(int far *)WorkArea)
     {
       if (debug) soperror("recvfrom");
     }
     else doGlobalUpdate(WorkArea);
  }
  GlobalUnlock(hWorkArea);
  return;
}
void GetUDPData(int sck)
{
  int n, retry = 2;
  static int len = sizeof(IncomingIPfec);

  IncomingNetworkProtocol = UDP;
  WorkArea = (BYTE far *)GlobalLock(hWorkArea);
  if (FD_ISSET(sck,&conset) &&
     (n=recvfrom(sck,(char far *)WorkArea,UDP_BUFFER_SIZE,0,
                 (struct sockaddr far *)&IncomingIPfec,&len)) > 0)
  {
     if (n != *(int far *)WorkArea)
     {
       if (debug) soperror("recvfrom");
     }
     else consumeData(WorkArea);
  }
  FD_SET(sck,&conset);
  GlobalUnlock(hWorkArea);
  while (WSAAsyncSelect(sck,hDLLWnd,WM_RCVPKT_UDP,FD_READ) && retry--)
  {
    if (debug) soperror("select");
  }
  return;
}
int getIncomingFecIndex(void)
{
  int idx;
  HANDLE hElem;
  ElemDataStruct far *e = NULL;

  RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
  for (hElem=hElemList; hElem != hNULL; hElem=e->hNext)
  {
    e = (ElemDataStruct far *)DeReference(hElem);
    if (e->protocol != IncomingNetworkProtocol) continue;
    idx = e->FecIndex;
    switch (IncomingNetworkProtocol)
    {
      case UDP:
        if (IncomingIPfec.sin_port == htons(UDP_PORT+RPCFec[idx].PortOffset) &&
            IncomingIPfec.sin_addr.s_addr == *(UINT32 far *)&RPCFec[idx].iaddr)
          return idx;
        continue;
      case IPX:
        if (!_fmemcmp(RPCFec[idx].Node,IncomingIPXfec->node,6)) return idx;
        continue;
      default:
        return -1;
    }
  }
  return -1;
}

#define bowout(txt) { _fstrcat(strbuf,txt); _fstrcat(strbuf,"\n"); tc = -1; goto bow; }
#define AssignFromPheader(p) {\
	msgsize = (p)->msgsize;\
	counter = (p)->counter;\
        if (e->starttime != (p)->starttime) bowout("wrong starttime");\
	if ((p)->timestamp < e->RPCtimestamp) bowout("stale");\
	e->RPCtimestamp = (p)->timestamp;\
	e->time = timestamp;\
	cc = (p)->CompletionCode;\
}

short consumeData(BYTE far *buf)
{
  short idx,prot,cc,rc,tc=0,fmtsize,counter;
  UINT16 csize,pstepsize,msgsize,
         totalsize = *(short far *)buf,bytesread=sizeof(totalsize);
  UINT32 datasize,dcmpsize;
  UINT32 dataPtr,dretsize,doutsize;
  long gapsize, gapptr;
  ProducerHeaderStruct far *Pheader=(ProducerHeaderStruct far *)&buf[bytesread];
  ProducerHeaderStruct4 far *Pheader4=(ProducerHeaderStruct4 far *)&buf[bytesread];
  ElemDataStruct far *e = NULL;
  time_t timestamp = time(NULL);
  BYTE far *DataOut;
  HANDLE hElem;
  static char namstr[64],devstr[64],str[32],scratch[48];
  int dataindex,fecindex;

  switch (cc=*(short far *)&buf[6])
  {
    case server_redirection:
      for (hElem=hElemList; hElem != hNULL; hElem=e->hNext)
      {
        e = (ElemDataStruct far *)DeReference(hElem);
        if (e->ID == *(short far *)&buf[4]) break;     // primary ID
      }
      if (hElem == hNULL) ccerr(non_existent);
      _fmemcpy(namstr,&buf[bytesread+PRODUCER_SIZE],RPCERR_SIZE);
      _fstrncpy(str,namstr,16); str[16] = 0;
      if ((dataindex=getRPCDataIndex(e->Context,str)) < 0) ccerr(-dataindex);
      if ((fecindex=getRPCFecIndex(RPCData[dataindex].FecName)) < 0) ccerr(-fecindex);
      if (!RPCFec[fecindex].Prot && (cc=locateFecName(RPCFec[fecindex].Name)) < 0) ccerr(-cc);
      _fstrncpy(e->EqName,RPCData[dataindex].EqName,EQNAME_SIZE);
      _fstrncpy(e->FecName,RPCFec[fecindex].Name,16);
      e->FecIndex = fecindex;

      if (_fstrlen(e->Context) > 0) wsprintf(devstr,"/%s/%s/%s",e->Context,str,e->DeviceName);
      else wsprintf(devstr,"%s/%s",str,e->DeviceName);
      _fstrncpy(str,&namstr[16],16);
      if (_fstrlen(str) > 0) _fstrncpy(e->Property,str,32);
      if (debug)
      {
        wsprintf(strbuf,"redirect %s/%s %s to %s %s",e->ElemName,e->DeviceName,e->Property,devstr,str);
        output(strbuf);
      }
      e->heartbeat = SUB_PENDING;
      return tc;
    case illegal_protocol:
      if ((idx=getIncomingFecIndex()) < 0) ccerr(invalid_index);
      for (hElem=hElemList; hElem != hNULL; hElem=e->hNext)
      {
        e = (ElemDataStruct far *)DeReference(hElem);
        if (e->FecIndex == idx && e->RPCprotocol == 5)
        {
          datasize = (UINT16)e->sizeOut*fmtsizeof(e->formatOut);
          csize = e->access & CA_WRITE ? SUBSCRIPTION4_SIZE + HEADERSTRUCT_SIZE : PRODUCER4_SIZE;
          if (e->protocol == IPX) e->RPCprotocol = datasize > IPX_BUFFER_SIZE - csize ? 1 : 4;
          else e->RPCprotocol = (datasize > UDP_BUFFER_SIZE - csize) ? 1 : 4;
          if (e->RPCprotocol < 4)
          {
            if (e->PollRate < 1000) e->PollRate = _POLLRATE;
            e->time = 0L;
          }
          e->heartbeat = SUB_PENDING;
          if (debug)
          {
            wsprintf(strbuf,"%s %s %s : switch to protocol 4\n",e->ElemName,e->DeviceName,e->Property);
            output(strbuf);
          }
          RPCFec[idx].MaxRPCProt = 4;
        }
      }
      return tc;
    case get_subscription_id:
      if ((idx=getIncomingFecIndex()) < 0) ccerr(invalid_index);
      for (hElem=hElemList; hElem != hNULL; hElem=e->hNext)
      {
        e = (ElemDataStruct far *)DeReference(hElem);
        if (e->ID == *(short far *)&buf[4]) break;     // primary ID
      }
      if (!hElem) ccerr(non_existent);
      e->srvID = *(short far *)&buf[bytesread+PRODUCER_SIZE];
      if (debug)
      {
        wsprintf(strbuf,"BCAST sub id %d from %s",e->srvID,RPCFec[idx].Name);
        output(strbuf);
      }
      return tc;
    default:
      break;
  }

  while (bytesread < totalsize)
  {
    if (Pheader->starttime == BCAST_ID)
    {
      if ((idx=getIncomingFecIndex()) < 0) return 0;         /* which FEC ? */
      for (hElem=hElemList; hElem != hNULL; hElem=e->hNext)
      {
        e = (ElemDataStruct far *)DeReference(hElem);
        if (e->srvID == Pheader->SubscriptionID &&
            e->FecIndex == idx &&
            e->RPCprotocol == 5)
        {
          Pheader->SubscriptionID = e->ID;
          Pheader->starttime = e->starttime;
          break;
        }
      }
      if (!hElem) return 0; // not interested
    }
    strbuf[0] = 0;
    if (debug > 1)
      wsprintf(strbuf,"ID %d : %d bytes ",Pheader->SubscriptionID,Pheader->msgsize);
    for (hElem=hElemList; hElem!=hNULL; hElem=e->hNext)
    {
      e = (ElemDataStruct far *)DeReference(hElem);
      if (e->ID == Pheader->SubscriptionID &&   // primary ID
          e->CompLoc != -1) break;             // just in case
    }
    if (hElem == hNULL) bowout("illegal id");

    if ((prot=e->RPCprotocol) < 4 || prot > 5) bowout("protocol");
    pstepsize = prot == 4 ? PRODUCER4_SIZE : PRODUCER_SIZE;

    if (prot == 5) { AssignFromPheader(Pheader); }
    else { AssignFromPheader(Pheader4); }

    fmtsize = fmtsizeof(e->formatOut);
    datasize = fmtsize*e->sizeOut; // expected size of call in bytes
    if (e->formatOut == CF_SPECTRUM) datasize += 96;
    if (datasize % 2) datasize++;  // even boundaries !!!
    doutsize = Pheader->msgsize - pstepsize; // data bytes in this datagram
    dcmpsize = datasize;
    e->lastDataSize = 0; gapsize = 0;  // always reset
    if (debug > 1 || (debug && BASEMODE(e->mode) <= CM_SINGLE))
      wsprintf(&strbuf[strlen(strbuf)],"%s %s %s [%d bytes (%d) p%d]<%d> (+%d)\n",
               e->ElemName,e->DeviceName,e->Property,datasize,e->formatOut,prot,cc,counter);

    switch (cc)
    {
      case use_stream_transport:
        e->RPCprotocol = 1;
        e->time = 0L;
        e->CompCode = cc;
        bowout("use stream");
      case non_existent_elem:
        counter = 0;
      default:
        rc = cc & 0x0fff;
        _fstrcpy(RPCLastErrorString,rc > 0 && rc < numErr ? erlst[rc] : "error undefined");
        if (prot == 4) 
        {
          _fmemcpy(&(e->RPCLastErrorString[PREFIX]),RPCLastErrorString,RPCERR_SIZE-1);
          break;
        }
        if (doutsize < RPCERR_SIZE && e->blksin == 0)
        {
          e->Bytesin = 0;
          bowout("partial error block");
        }
        if (!(Pheader->CompletionCode & CE_SENDDATA)) datasize = 0;
        if ((gapsize=e->Bytesin+doutsize-datasize) > RPCERR_SIZE) bowout("phantom block");
        if (gapsize > 0)
        {
          gapptr = 0;
          if (doutsize < RPCERR_SIZE)
          {
            gapsize = doutsize;
            gapptr = RPCERR_SIZE - gapsize;
          }
          else
          {
            _fmemset(e->RPCLastErrorString,0,PREFIX+RPCERR_SIZE);
            _fstrcpy(e->RPCLastErrorString,"[RMT] ");
          }
          _fmemcpy(&e->RPCLastErrorString[PREFIX+gapptr],&buf[bytesread+Pheader->msgsize-gapsize],gapsize);
//          Pheader->msgsize -= (UINT16)gapsize;
          doutsize -= (UINT16)gapsize;
          e->Bytesin += (UINT16)gapsize;
        }
        else gapsize = 0;
        if (!(Pheader->CompletionCode & CE_SENDDATA)) break;
      case 0:
        if (datasize == 0) break;
        DataOut = (BYTE far *)DeReference(e->hDataOut);
        if (prot == 5)
        {
          if (!e->blksin) e->counter = Pheader->counter;   /* new set */
          if (Pheader->numblks > 1 && e->counter != Pheader->counter)   /* we're being passed */
          {
            if (Pheader->counter < e->counter || Pheader->counter > e->counter + 30)
            {
              e->blksin = 0;
              e->counter = Pheader->counter;       /* more recent set */
            }
            else goto bow;                       /* old stuff coming in */
          }
          dataPtr = (Pheader->blknum-1)*Pheader->mtu;
          if (dcmpsize < doutsize) bowout("data alignment");
          if (doutsize > 0) _fmemcpy(&(DataOut)[dataPtr],&buf[bytesread+pstepsize],doutsize);
          if (debug > 1 || (debug && BASEMODE(e->mode) <= CM_SINGLE))
            wsprintf(&strbuf[strlen(strbuf)],"Long datagram block %d of %d\n",Pheader->blknum,Pheader->numblks);
          e->Bytesin += doutsize;
          if (++(e->blksin) < Pheader->numblks) goto bow;
        }
        else
        {
          if (doutsize > datasize) bowout("size mismatch");
          if (doutsize > 0) _fmemcpy(DataOut,&buf[bytesread+pstepsize],doutsize);        
        }
        dretsize = e->Bytesin - (cc == 0 ? 0 : RPCERR_SIZE);
        if (dretsize < datasize) _fmemset(&(DataOut)[dretsize],0,dcmpsize-dretsize);
        if (fmtsize > 0)
        {
          e->lastDataSize = dretsize/fmtsize;
          if (e->formatOut == CF_SPECTRUM) e->lastDataSize -= 24;
        }
        break;
    }
    switch (BASEMODE(e->mode))
    {
      case CM_CANCEL :
        bowout("cancelled");
      default:
      case CM_SINGLE : 
        if (e->ID != 0) e->mode = CM_CANCEL;  // got reply
		    e->heartbeat = 0;
		    break;
      case CM_REFRESH : 
        e->heartbeat = 5 + HEARTBEAT;
        break;
      case CM_POLL : 
        e->heartbeat = 2 + e->PollRate/1000;
        break;
    }
    e->CompCode = cc;
    e->blksin   = 0;
    NotifyClients(e);

    if (BASEMODE(e->mode)>CM_SINGLE && counter > 0)
    {
      if (counter < REMINDER) e->heartbeat = SUB_PENDING;
      else if (counter <= ACK_REQUEST) e->heartbeat = ACK_PENDING;
    }

bow:bytesread += msgsize;
    if (debug && _fstrlen(strbuf)) output(strbuf);
    if (msgsize == 0) return tc;  // avoid potential infinite loop
    Pheader = (ProducerHeaderStruct far *)&buf[bytesread];
    Pheader4 = (ProducerHeaderStruct4 far *)&buf[bytesread];
  }
  cc = 0;
err:
  if (cc && debug)
  {
    wsprintf(strbuf,"ConsumeData : %s",erlst[cc]);
    output(strbuf);
  }
  return tc;
}
void CheckConnections(void)
{
  HANDLE hElem;
  ElemDataStruct far *e;
  time_t timestamp = time(NULL);

  for (hElem = hElemList; hElem; hElem = e->hNext)
  {
    e = (ElemDataStruct far *)DeReference(hElem);
    if (e->RPCprotocol < 4 || e->mode == REGISTER) continue;
    if (e->mode && timestamp > e->time + e->heartbeat)
    {
      if (debug > 2)
      {
        wsprintf(strbuf,"Alarm check: %s %s (id %d) timed out",
	        e->ElemName,e->Property,e->ID);
        OutputToDebugFile("CheckConnections",strbuf);
      }
      if (BASEMODE(e->mode))
      {
        e->CompCode = link_not_open;
        e->CompLoc = 0;

        if (e->timeoutCount-- < 0)
        {
          e->timeoutCount = BASEMODE(e->mode) == CM_SINGLE ? 10 : 30;
          RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
          RPCFec[e->FecIndex].Prot = 0;  // force address resolution
        }
        SetErrorString(e->RPCLastErrorString,e->CompCode,e->CompLoc)
        NotifyClients(e);
        if (BASEMODE(e->mode) > CM_SINGLE) e->heartbeat = SUB_PENDING;
        else
        {
          e->heartbeat = 0;
          e->mode = CM_CANCEL;
        }
      }
      else if (e->heartbeat > 0) e->lockCount = 0;
    }
  }
  return;
}
void Cleanup(void)
{
  int i;
  HANDLE h,hElem;
  ElemDataStruct far *e;

  for (hElem=hElemList; hElem; )
  {
   e = (ElemDataStruct far *)DeReference(hElem);
   h = hElem; hElem=e->hNext;
   if (e->RPCprotocol > 4 && BASEMODE(e->mode) == CM_CANCEL && e->heartbeat != SUB_PENDING)
   {
     if (e->PrimeMode > CM_SINGLE && e->PrimeMode < REGISTER) e->lockCount = 0;
     if (e->lockCount <= 0) RemoveElem(h);
   }
  }
  for (i=1; i<numLinks; i++)
    if (link[i].active && !IsWindow(link[i].hVBWnd)
      && !IsWindow(link[i].hVBXWnd))
  {
    if (debug)
    {
      wsprintf(strbuf,"removing stranded link %d\n",i);
      output(strbuf);
    }
    RemoveRPC(i);
  }

  SPXCleanup();
  GetGlobalIPX();
  GetIPXData(NUM_CNS_ECB,cnsECB);
  GetUDPData(ConsumerSocket);
  GetGlobalUDP();
  GetUDPData(MCastConsumerSocket);
  return;
}
int RetardClientCycle = 1;
int checkSubscriptionEngine(void)
{
  int i, retry = 2;
  static int busy=0;
  if (busy) return busy;
  busy = 1;
  WorkArea = (BYTE far *)GlobalLock(hWorkArea);
  if ((i=PrepSubBuffer(WorkArea)) >= 0)
    while (retry-- && SendSubBuffer(i,WorkArea));
  GlobalUnlock(hWorkArea);
  busy = 0;
  return busy;
}
void CheckSubscriptions(void)
{
  while (checkSubscriptionEngine()); // put in a delay for RetardClientCycle
  return;
}
void dumpData(BYTE far *data,short size,short format)
{
  int i;
  wsprintf(strbuf,"Sending %d elements <%d>: ",size,format);
  switch (format)
  {
    case CF_BYTE:
	for (i=0; i<size && i < 10; i++)
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((BYTE far *)data)[i]);
	break;
    case CF_SHORT:
	for (i=0; i<size && i < 10; i++)
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((short far *)data)[i]);
	break;
    case CF_SI:
	for (i=0; i<size && i < 10; i++)
	{
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((short far *)data)[i*6]);
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((long far *)data)[i*6+2]);
	}
	break;
    case CF_LONG:
	for (i=0; i<size && i < 10; i++)
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((long far *)data)[i]);
	break;
    case CF_II:
	for (i=0; i<size && i < 10; i++)
	{
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((long far *)data)[i*8]);
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((long far *)data)[i*8+4]);
	}
	break;
    case CF_FLOAT:
	for (i=0; i<size && i < 10; i++)
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%g ",((float far *)data)[i]);
	break;
    case CF_FI:
	for (i=0; i<size && i < 10; i++)
	{
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%g ",((float far *)data)[i*8]);
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((long far *)data)[i*8+4]);
	}
	break;
    case CF_DOUBLE:
	for (i=0; i<size && i < 10; i++)
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%g ",((double far *)data)[i]);
	break;
    case CF_DI:
	for (i=0; i<size && i < 10; i++)
	{
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%g ",((double far *)data)[i*12]);
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((long far *)data)[i*12+4]);
	}
	break;
    case CF_CHAR8:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*8],8);
	  _fstrcat(strbuf," ");
	}
	break;
    case CF_CHAR8I:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*12],8);
	  wsprintf(&strbuf[_fstrlen(strbuf)]," %d ",((long far *)data)[i*12+8]);
	}
	break;
    case CF_CHAR16:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*16],16);
	  _fstrcat(strbuf," ");
	}
	break;
    case CF_CHAR16I:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*20],16);
	  wsprintf(&strbuf[_fstrlen(strbuf)]," %d ",((long far *)data)[i*20+16]);
	}
	break;
    case CF_CHAR32:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*32],32);
	  _fstrcat(strbuf," ");
	}
	break;
    case CF_CHAR32I:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*36],32);
	  wsprintf(&strbuf[_fstrlen(strbuf)]," %d ",((long far *)data)[i*36+32]);
	}
	break;
    case CF_CHAR48:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*48],48);
	  _fstrcat(strbuf," ");
	}
	break;
    case CF_CHAR48I:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*52],48);
	  wsprintf(&strbuf[_fstrlen(strbuf)]," %d ",((long far *)data)[i*52+48]);
	}
	break;
    case CF_TEXT:
	_fstrncpy(&strbuf[_fstrlen(strbuf)],(char far *)data,MIN(_fstrlen(data),sizeof(strbuf)-_fstrlen(strbuf)));
	break;
    default:
    case CF_STRUCT:
	for (i=0; i<size && i < 80; i++)
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%x ",((BYTE far *)data)[i]);
	break;
    case CF_CHAR16FI:
	for (i=0; i<size && i < 10; i++)
	{
	  _fstrncpy(&strbuf[_fstrlen(strbuf)],&((char far *)data)[i*24],16);
	  wsprintf(&strbuf[_fstrlen(strbuf)]," %g ",((float far *)data)[i*24+16]);
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((float far *)data)[i*24+20]);
	}
	break;
    case CF_TDS:
	for (i=0; i<size && i < 10; i++)
	{
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((UINT32 far *)data)[i*12]);
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%g ",((float far *)data)[i*12+4]);
	  wsprintf(&strbuf[_fstrlen(strbuf)],"%d ",((long far *)data)[i*12+8]);
	}
	break;
  }
  output(strbuf);
}
char *modetoa[] = { "CANCEL","SINGLE","REFRESH","POLL","REGISTER" };

int PrepSubBuffer(BYTE far *data)
{
  HeaderStruct far *h = (HeaderStruct far *)data;
  int FECindex=-1,j,pktlen,dsize,totalsize=sizeof(HeaderStruct);
  struct subscription far *s = (struct subscription far *)&data[totalsize];
  struct subscription4 far *s4 = (struct subscription4 far *)&data[totalsize];
  ElemDataStruct far *e;
  HANDLE hElem;
  time_t timestamp = time(NULL);
  short stepsize,prot = 0;
  BYTE far *DataIn;

  if (data == NULL) return -1;
  RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
  for (hElem = hElemList,j=0; hElem; hElem = e->hNext)
  {
    e = (ElemDataStruct far *)DeReference(hElem);
    if (e->RPCprotocol < 4 || e->heartbeat < SUB_PENDING) continue;
    if (e->mode == REGISTER) continue;
    if (!j)
    {
      FECindex=e->FecIndex;
      pktlen = RPCFec[FECindex].Prot == IPX ? IPX_BUFFER_SIZE : UDP_BUFFER_SIZE;
      _fmemset(data,0,pktlen);
      if (RPCFec[FECindex].MaxRPCProt == 0) e->RPCprotocol = RPCFec[FECindex].MaxRPCProt = 5;
      if ((prot=e->RPCprotocol) == 4)
      {
        stepsize = SUBSCRIPTION4_SIZE;
    	e->datamtu = pktlen-stepsize-HEADERSTRUCT_SIZE;
	e->numblksIn = 1;
      }
      else stepsize = SUBSCRIPTION_SIZE;
    }
    else if (FECindex != e->FecIndex) continue;

    if (prot == 4)
    {
      s4->PollingRate = e->PollRate;
      s4->id = (unsigned short)e->ID;
      s4->mode = BASEMODE(e->mode);
      s4->starttime = e->starttime;
      _fstrncpy(s4->contract.EqpName,e->EqName,EQNAME_SIZE);
      _fstrncpy(s4->contract.Property,e->Property,12);

      s4->contract.EqpNumber = e->EqNo;
      s4->contract.EqpSize = (UINT16)MAX(e->sizeOut,e->sizeIn);
      s4->contract.EqpFormat = e->formatOut == CF_TEXT ? 1 : e->formatOut;

      if (e->sizeIn > 0)
      {
        dsize = s4->contract.EqpSize*fmtsizeof(s4->contract.EqpFormat);
        if ((totalsize + stepsize + dsize) > pktlen)
	{
	  if (totalsize == sizeof(HeaderStruct)) e->RPCprotocol = 1;
	  break;
	}
        DataIn = (BYTE far *)DeReference(e->hDataIn);
        _fmemcpy(&data[totalsize+stepsize],DataIn,dsize);
        s4->contract.EqpSize *= -1;
      }
      else dsize = 0;
      s4->msgsize = stepsize + dsize;
      totalsize += stepsize + dsize;
      s4 = (struct subscription4 far *)&data[totalsize];
    }
    else
    {
      s->mtu = e->datamtu;
      s->numblks = e->numblksIn;
      s->blknum = e->blknumIn;
      s->blkid = e->blkidIn;
      s->PollingRate = e->PollRate;
      s->id = (unsigned short)e->ID;
      s->mode = e->mode;
      s->starttime = e->starttime;
      _fstrncpy(s->contract.EqpName,e->EqName,6);
      _fstrncpy(s->contract.EqpProperty,e->Property,32);
      _fstrncpy(s->contract.EqpDeviceName,e->DeviceName,16);
      s->contract.EqpSizeOut = e->sizeOut;
      s->contract.EqpFormatOut = BFMT(e->formatOut);
      _fstrncpy(s->contract.strTagOut,e->strTagOut,8);
      s->contract.EqpSizeIn = e->sizeIn;
      s->contract.EqpFormatIn = BFMT(e->formatIn);
      _fstrncpy(s->contract.strTagIn,e->strTagIn,8);
      s->contract.EqpAccess = e->access;
      if (e->sizeIn > 0)
      {
        dsize =  e->nextDataSize;
        if ((totalsize + stepsize + dsize) > pktlen) break;
        DataIn = (BYTE far *)DeReference(e->hDataIn);
        _fmemcpy(&data[totalsize+stepsize],&(DataIn)[e->nextDataPtr],dsize);
      }
      else dsize = 0;
      s->msgsize = stepsize + dsize;
      totalsize += stepsize + dsize;
      s = (struct subscription far *)&data[totalsize];
    }
    if (BASEMODE(e->mode) == CM_CANCEL) e->lockCount = 0;

    j++;

    if (debug)
    {
      wsprintf(strbuf,"Subscribe: %s %s %s (i:%ld %d o:%ld %d) p%d (%d of %d -%d-)[%s] (%d ms) <%s>\n",
              e->ElemName,e->DeviceName,e->Property,
	      e->sizeIn,e->formatIn,e->sizeOut,e->formatOut,prot,
	      e->blknumIn,e->numblksIn,e->blkidIn,
	      RPCFec[FECindex].Name,e->PollRate,modetoa[BASEMODE(e->mode)]);
      output(strbuf);
    }
    if (e->blknumIn == e->numblksIn)
    {
      e->blknumIn = 1;
      e->nextDataPtr = 0;
      e->blkidIn = (++(e->blkidIn))%1000;
      e->BytesRemaining = e->BytesTotal;
      e->heartbeat = BASEMODE(e->mode) == CM_REFRESH ? REPLY_PENDING : 2+e->PollRate/1000;
      e->time = timestamp;
      RetardClientCycle = 1;
    }
    else if (e->sizeIn > 0)
    {
      if (prot != 5)
      {
        if (debug)
	{
          wsprintf(strbuf,"Long Datagrams can only be used with protocol 1 or 5\n");
          output(strbuf);
	}
	e->RPCprotocol = 1;
	return -1;
      }
      e->blknumIn++;
      e->nextDataPtr += e->nextDataSize;
      e->BytesRemaining = e->BytesTotal - e->nextDataPtr;
      RetardClientCycle = 5;
    }
    e->nextDataSize = MIN(e->datamtu,e->BytesRemaining);

    if (debug > 1 && e->sizeIn > 0 && e->blknumIn == e->numblksIn)
    {
      DataIn = (BYTE far *)DeReference(e->hDataIn);
      dumpData(DataIn,e->sizeIn,e->formatIn);
    }
    if ((totalsize + stepsize) > pktlen) break;  // no more packing possible
  }

  h->TotalSize = totalsize;
  _fmemcpy(h->UserName,username,16);
  h->Protocol = prot;
  h->EqpSize = j;

  return FECindex;
}
int SendSubBuffer(int FECindex,BYTE far *data) // FECindex
{
  int cc=0,retrycnt=1;
  static CLIENT cln;
  static BYTE reg_sock[2];

  RPCFec  = (RPCFecStruct far *)DeReference(hRPCFec);
  _fmemset(&cln,0,sizeof(CLIENT));
  _fstrncpy(cln.userName,RPCFec[FECindex].Name,16);
retry:switch (RPCFec[FECindex].Prot)
  {
   case   0:
       if (locateFecName(RPCFec[FECindex].Name) < 0) ccerr(link_not_open);
     	 if (retrycnt-- > 0) goto retry; else ccerr(non_existent_fec);
   case IPX:
       reg_sock[0] = REG_SOCKET + RPCFec[FECindex].PortOffset;
       reg_sock[1] = REG_SOCKET + RPCFec[FECindex].PortOffset;
       _fmemcpy(&cln.IPXaddress,RPCFec[FECindex].Network,10);
       _fmemcpy(cln.IPXaddress.socket,reg_sock,2);
       _fmemcpy(cln.node,RPCFec[FECindex].ImmediateAddress,6);
       break;
   case UDP:
       if (!RPCFec[FECindex].iaddr) ccerr(non_existent_fec);
       _fmemset(&prod_name,0,sizeof(prod_name));
       _fmemcpy(&prod_name.sin_addr,&RPCFec[FECindex].iaddr,sizeof(struct in_addr));
       prod_name.sin_family=AF_INET;
       prod_name.sin_port = htons(UDP_PORT+RPCFec[FECindex].PortOffset);
       _fmemcpy(&cln.IPaddress,&prod_name,sizeof(prod_name));
       break;
   default:
       ccerr(not_implemented);
  }
err:
  return cc ? cc : SendToPC(&cln,data,ConsumerSocket);
}
int SendIPXData(CLIENT far *cln,BYTE far *data)
{
  time_t interim = time(NULL);
  int msgsize = *(int far *)data;

  if (*(int far *)cln->IPXaddress.socket == 0) return illegal_protocol;
  if (msgsize > IPX_BUFFER_SIZE) return use_stream_transport;
  _fmemcpy(&PCECB->hdr.destination.network,&cln->IPXaddress,12);
  _fmemcpy(&PCECB->ecb.immediateAddress,cln->node,6);
  _fmemcpy(PCECB->buf,data,msgsize);
  PCECB->ecb.fragmentDescriptor[1].size = msgsize;
  IPXSendPacket(IPXTaskID,(ECB far *)PCECB);
  while (PCECB->ecb.inUseFlag && time(NULL) <= interim + 1) IPXRelinquishControl();
  if (PCECB->ecb.inUseFlag)
  {
   IPXCancelEvent(IPXTaskID,(ECB far *)PCECB);
   return ipx_socket_error;
  }
  if (PCECB->ecb.completionCode) return ipx_socket_error;
  return 0;
}
int SendUDPData(CLIENT far *cln,BYTE far *data,int UDPsocket)
{
  int msgsize = *(int far *)data;

  if (!TCPloaded) return tcp_not_supported;
  if (msgsize > UDP_BUFFER_SIZE) return use_stream_transport;
  if (sendto(UDPsocket,(char far *)data,msgsize,0,
      (struct sockaddr far *)&cln->IPaddress,sizeof(cln->IPaddress)) < 0)
  {

   if (debug) soperror("sendto");
   return tcp_socket_error;
  }
  return 0;
}

int getNextLinkID()
{
  int i;
  static int lastAssignedLinkID0 = 0,lastAssignedLinkID1;
  if (!initialized) return -not_accepted;
  for (i=1; i<MAXHOTLINKS && (link[i].active || i == lastAssignedLinkID0  || i == lastAssignedLinkID1); i++);
  if (i == MAXHOTLINKS) return -link_exhausted;  // error: link table full
  link[i].active = -1;
  if (debug)
  {
    wsprintf(strbuf,"Assigned link id %d\n",i);
    output(strbuf);
  }
  lastAssignedLinkID1 = lastAssignedLinkID0;
  lastAssignedLinkID0 = i;
  return i;
}
short Subscribe(HWND hWnd,HWND hVBX,char far *name,short EqNo,char far *prop,
                long timer,short size,short format,short mode)
{
  LCLCONTRACT far *con = &lclContract;
  HANDLE hTmp = hNULL;
  short cc = 0;
  int i,fmtsize,dsize;
  ElemDataStruct far *e;
  UINT16 dinsize;
  static char fulname[72];
  char far *cn = NULL,far *en = NULL,far *dn = NULL;

  if (format == 0) format = CF_DOUBLE;
  if (format == 1) format = CF_TEXT;

  if ((fmtsize=getFormatSize(format)) == 0) return -illegal_format;
  mode = mode > REGISTER   ? REGISTER   :
	 mode < CM_CANCEL ? CM_CANCEL : mode;
  if (name == NULL || _fstrlen(name) == 0) return -non_existent_elem;
  if (prop == NULL || _fstrlen(prop) == 0) return -illegal_property;
  if (_fstrlen(name) > 33 ||  _fstrlen(prop) > 32) return -string_too_long;
  if (size == 0) return -argument_list_error;

  if (debug > 2 )
  {
    wsprintf(strbuf,"Get Link ID for %s %s\n",name,prop);
    OutputToDebugFile("Subscribe",strbuf);
  }
  if ((i=SendMessage(hDLLWnd,WM_GETLINKID,0,0)) < 0) ccerr(-i);

  _fstrncpy(fulname,name,71); fulname[71] = 0;
  if ((cn=_fstrtok(fulname,DELIMITER)) == NULL) ccerr(argument_list_error);
  if ((en=_fstrtok(NULL,DELIMITER)) == NULL) /* only one given */
  {
    en = cn; cn = NULL; dn = NULL;
  }
  else if ((dn=_fstrtok(NULL,DELIMITER)) == NULL) /* only two given */
  {
    if (cn == fulname) /* no leading delimiter */
    {
      dn = en; en = cn; cn = NULL;
    }
    else dn = NULL;
  }

  _fmemset(con,0,sizeof(LCLCONTRACT));
  if (cn != NULL) _fstrncpy(con->EqpContext,cn,16);
  _fstrncpy(con->EqpTagName,en,16);
  _fstrncpy(con->EqpProperty,prop,32);
  if (dn != NULL) _fstrncpy(con->EqpDeviceName,dn,16);
  else wsprintf(con->EqpDeviceName,"#%d",EqNo);

  // can't fill in the dataIn with this prototype for subscribe()
  con->EqpSizeOut      = abs(size);
  con->EqpFormatOut    = BFMT(format);
  if (size < 0)
  {
    con->EqpSizeIn = abs(size);
    con->EqpFormatIn = BFMT(format);
    con->EqpAccess = CA_READ|CA_WRITE;
    dinsize = (UINT16)con->EqpSizeIn*fmtsizeof(con->EqpFormatIn);
    if (!(hTmp=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,dinsize)))
      ccerr(out_of_client_memory);
    con->DataIn = (BYTE far *)DeReference(hTmp);
    _fmemset(con->DataIn,0,dinsize); // give it something ...
  }
  else
  {
    con->EqpSizeIn = 0;
    con->EqpFormatIn = BFMT(CF_NULL);
    con->EqpAccess = CA_READ;
  }
  dsize = abs(size)*fmtsize;

  con->PollRate = timer;
  if (mode == CM_SINGLE && timer < (2*dsize)/5)  con->PollRate += (2*dsize)/5;

  if (debug > 2 )
  {
    wsprintf(strbuf,"Create link for %s %s\n",name,prop);
    OutputToDebugFile("Subscribe",strbuf);
  }
  if ((cc=(short)SendMessage(hDLLWnd,WM_CREATELINK,i,0)) != 0) ccerr(cc);

  link[i].hVBWnd    = hWnd;
  link[i].hVBXWnd   = hVBX;
  link[i].dataFlg   = -not_posted;
  link[i].active    = 1;
  link[i].mode      = mode;
  link[i].cnt       = (con->PollRate+RPC_TIMEOUT*1000)/SYSTEM_DELAY; // default cleanup counter

  e=(ElemDataStruct far *)DeReference(link[i].hElem);
  if (e == NULL) return -un_allocated;

  if (e->RPCprotocol == 0) e->RPCprotocol = 5;
  if (e->RPCprotocol == 1)
  {
    if (mode == CM_SINGLE) ccerr(use_stream_transport);
    if (timer < 1000) e->PollRate = _POLLRATE;
  }
  e->lockCount++;
  e->PrimeMode = maxmode(e->PrimeMode,mode);
  e->mode = e->PrimeMode;
  e->heartbeat = SUB_PENDING;
  e->time      = e->RPCprotocol == 1 ? 0 : time(NULL);

  link[i].cnt  = ((e->PollRate+RPC_TIMEOUT*1000))/SYSTEM_DELAY; // refresh cleanup counter
err:
  if (hTmp) GlobalFree(hTmp);
  if (cc && i > 0 && i < MAXHOTLINKS) {SendMessage(hDLLWnd,WM_REMOVELINK,i,0); link[i].active = 0;}
  return cc ? -cc : i;
}
#pragma argsused
short syncAsyncRPC(char far *name,short EqNo,char far *prop,
                   short size,void far *data,short datasize,short format,unsigned short timout)
{
  short id,rc,cc = 0;
  int dsize,retry = 1,dotcp = 0;
  ElemDataStruct far *e = NULL;
  BYTE far *DataIn = NULL, far *DataOut = NULL;
//  static MSG Msg, far *lpMsg = &Msg;
  static localSyncSemaphore = 0;  // protect against local re-entrancy (the infamous
                                  // Cold link in a VB timer !!)
  if (localSyncSemaphore) return not_ready; else localSyncSemaphore = 1;
  TCPGetResource();
  CheckSubscriptions();                    // flush all SUB_PENDINGs
  if (timout == RPC_TIMEOUT)
  {
    dotcp = 1;  // trap at unusually low timout value
    timout = RPC_TIMEOUT*1000;
  }
  dsize = abs(size)*fmtsizeof(format);
  if (timout < (2*dsize)/10)  timout += (2*dsize)/10;
UDPretry:
  if ((id=Subscribe(hDLLWnd,0,name,EqNo,prop,timout,size,format,REGISTER)) < 0) ccerr(-id);

  e = (ElemDataStruct far *)DeReference(link[id].hElem);
  if (!e) ccerr(un_allocated);
  if (size < 0)
  {
    if (debug)
    {
      wsprintf(strbuf,"write %d elements\n",abs(size));
      OutputToDebugFile("syncAsyncRPC",strbuf);
    }
    if (data == NULL || IsBadReadPtr(data,dsize)) ccerr(buffer_too_small);
    DataIn = (BYTE far *)DeReference(e->hDataIn);
    if (DataIn == NULL) ccerr(buffer_too_small);
    _fmemcpy(DataIn,data,dsize);
    retry = 0;        // don't retry for write commands
  }
  if (debug > 2 )
  {
    wsprintf(strbuf,"lock link %d\n",id);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  if (SendMessage(hDLLWnd,WM_LOCKLINK,id,0)) ccerr(serr2);
  if (dotcp)
  {
    e->RPCprotocol = 1;
    e->time = 0L;
  }
  link[id].mode = CM_SINGLE;
  e->PrimeMode = maxmode(e->PrimeMode,CM_SINGLE);
  e->mode = e->PrimeMode;

  SynchronousCallPending = -1;
  while (SynchronousCallPending)
  {
    SendMessage(hDLLWnd,WM_TIMER,0,0);  // make sure the timer goes
//    if (GetMessage(lpMsg,hDLLWnd,0,0)) DispatchMessage(lpMsg);
  }

  if (((cc=e->CompCode) == 0 || (cc && CE_SENDDATA)) && e->sizeOut > 0)
  {
    if (data == NULL ||
      IsBadWritePtr(data,dsize=e->sizeOut*getFormatSize(e->formatOut)) ) ccerr(buffer_too_small);
    DataOut = (BYTE far *)DeReference(e->hDataOut);
    if (DataOut == NULL) ccerr(buffer_too_small);
    _fmemcpy(data,DataOut,dsize);
  }
  RPCtimestamp = e->RPCtimestamp;
err:
  if ((rc = (cc & 0x0fff)))
  {
    if (e == NULL || !e->CompCode) wsprintf(RPCLastErrorString,"[LCL] %s",rc > 0 && rc < numErr ? erlst[rc] : "error undefined");
    else _fstrncpy(RPCLastErrorString,e->RPCLastErrorString,PREFIX+RPCERR_SIZE);
  }
  if (debug > 2 )
  {
    wsprintf(strbuf,"removing link %d\n",id);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  if (id > 0) SendMessage(hDLLWnd,WM_REMOVELINK,id,0);
  if (retry-- > 0 && cc == link_not_open && !dotcp) goto UDPretry;
  TCPFreeResource();
  localSyncSemaphore = 0;
  if (debug > 2 )
  {
    wsprintf(strbuf,"%s %s completed with error code %d\n",name,prop,cc);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  return cc;
}

short OpenLink(HWND hWnd,char far *devName,char far *devprop,
               DBLK far *dout,DBLK far *din,void far *datain,
	       short access,long timer,short mode)
{
  LCLCONTRACT far *con = &lclContract;
  short cc = 0,fmtin,fmtout,baseMode;
  int i;
  ElemDataStruct far *e;
  UINT32 dinsize,doutsize,sizin,sizout;
  char far *c;
  static char fulname[72];
  static char eqpname[48],devname[32];
  struct structStruct far *s;
  char far *cn = NULL,far *en = NULL,far *dn = NULL,far *ap = NULL;

  if (mode & CM_BCAST && !ListenForMCasts) return illegal_mode;
  baseMode = BASEMODE(mode);
  if (baseMode > REGISTER  || baseMode < CM_CANCEL) return illegal_mode;
  if (dout && dout->dArrayLength > 0)
  {
    if ((doutsize=dout->dArrayLength*fmtsizeof(dout->dFormat)) == 0) return -illegal_format;
    fmtout = dout->dFormat; sizout = dout->dArrayLength;
    if (fmtout == CF_STRUCT && (s=getStructFromTag(dout->dTag)) != NULL)
    {
      sizout *= s->size;
    }
  }
  else
  {
    doutsize = 0; fmtout = CF_NULL; sizout = 0;
  }
  if (din && din->dArrayLength > 0)
  {
    if ((dinsize = din->dArrayLength*fmtsizeof(din->dFormat)) == 0) return -illegal_format;
    if (datain == NULL) return -argument_list_error;
    fmtin = din->dFormat; sizin = din->dArrayLength;
    if (fmtin == CF_STRUCT && (s=getStructFromTag(din->dTag)) != NULL)
    {
      sizin *= s->size;
      dinsize = sizin;
    }
  }
  else
  {
    dinsize = 0; fmtin = CF_NULL; sizin = 0;
  }

  if (devName == NULL || _fstrlen(devName) == 0) return -non_existent_elem;
  if (devprop == NULL || _fstrlen(devprop) == 0) return -illegal_property;

  _fstrncpy(fulname,devName,71); fulname[71] = 0;
  if ((cn=_fstrtok(fulname,DELIMITER)) == NULL) ccerr(argument_list_error);
  if ((en=_fstrtok(NULL,DELIMITER)) == NULL) /* only one given */
  {
    en = cn; cn = NULL; dn = &fulname[71];
  }
  else if ((dn=_fstrtok(NULL,DELIMITER)) == NULL) /* only two given */
  {
    if (cn == fulname) /* no leading delimiter */
    {
      dn = en; en = cn; cn = NULL;
    }
    else dn = &fulname[71];
  }
  else if ((ap=_fstrtok(NULL,"\0")) != NULL) /* a '/' in the device name */
  {
    dn[strlen(dn)] = '/';  /* put it back */
  }

  if (debug > 2 )
  {
    wsprintf(strbuf,"Get Link ID for %s %s\n",devName,devprop);
    OutputToDebugFile("Subscribe",strbuf);
  }

  if ((i=SendMessage(hDLLWnd,WM_GETLINKID,0,0)) < 0) ccerr(-i);

  _fmemset(con,0,sizeof(LCLCONTRACT));
  if (cn!= NULL) _fstrncpy(con->EqpContext,cn,16); else con->EqpContext[0] = 0;
  _fstrncpy(con->EqpTagName,en,16);
  if (dn != NULL) _fstrncpy(con->EqpDeviceName,dn,16); else con->EqpDeviceName[0] = 0;
  _fstrncpy(con->EqpProperty,devprop,32);
  con->EqpSizeOut      = sizout;
  con->EqpFormatOut    = BFMT(fmtout);
  if (dout) _fstrncpy(con->strTagOut,dout->dTag,8);
  con->EqpSizeIn       = sizin;
  con->EqpFormatIn     = BFMT(fmtin);
  con->EqpAccess       = (BYTE) access;
  if (din) _fstrncpy(con->strTagIn,din->dTag,8);

  if (dinsize) con->DataIn = datain;

  con->PollRate = timer;
  if (baseMode == CM_SINGLE && timer < (dinsize + doutsize)/5)
    con->PollRate += (dinsize + doutsize)/5;

  if (debug > 2 )
  {
    wsprintf(strbuf,"Create link for %s %s\n",eqpname,devprop);
    OutputToDebugFile("Subscribe",strbuf);
  }
  if ((cc=(short)SendMessage(hDLLWnd,WM_CREATELINK,i,0)) != 0) ccerr(cc);

  link[i].hVBWnd    = NULL;
  link[i].hVBXWnd   = hWnd;
  link[i].dataFlg   = -not_posted;
  link[i].active    = 1;
  link[i].mode      = mode;
  link[i].cnt       = (con->PollRate+RPC_TIMEOUT*1000)/SYSTEM_DELAY; // default cleanup counter

  e=(ElemDataStruct far *)DeReference(link[i].hElem);
  if (e == NULL) ccerr(un_allocated);

  if (e->RPCprotocol == 0) e->RPCprotocol = 5;
  if (e->RPCprotocol == 1)
  {
    if (baseMode == CM_SINGLE) ccerr(use_stream_transport);
    if (timer < 1000) e->PollRate = 1000;
  }
  e->lockCount++;
//  if (e->PrimeMode == REGISTER) e->PrimeMode = mode;
  e->PrimeMode = maxmode(e->PrimeMode,mode);
  e->mode = e->PrimeMode;
  e->heartbeat = SUB_PENDING;
  e->time      = e->RPCprotocol == 1 ? 0 : time(NULL);

  link[i].cnt  = ((e->PollRate+RPC_TIMEOUT*1000))/SYSTEM_DELAY; // refresh cleanup counter
err:
  if (cc && i > 0 && i < MAXHOTLINKS) {SendMessage(hDLLWnd,WM_REMOVELINK,i,0); link[i].active = 0;}
  return cc ? -cc : i;
}
short ExecLinkEx(char far *devname,char far *devprop,DBLK far *dout,void far *dataout,DBLK far *din,void far *datain,short access,long timeout)
{
  short id,rc,cc = 0;
  int dsize,dinsize=0,doutsize=0,retry = 1;
  ElemDataStruct far *e = NULL;
  BYTE far *DataOut = NULL;
  short tgtTimeout;
//  static MSG Msg, far *lpMsg = &Msg;
  static struct timeval tv0,tv;
  static struct timeb t0,t1;
  static localSyncSemaphore = 0;  // protect against local re-entrancy (the infamous
                                  // Cold link in a VB timer !!)
  if (localSyncSemaphore) return not_ready; else localSyncSemaphore = 1;
  if (din && din->dArrayLength > 0) dinsize = din->dArrayLength*fmtsizeof(din->dFormat);
  if (dout && dout->dArrayLength > 0) doutsize = dout->dArrayLength*fmtsizeof(dout->dFormat);
  if (timeout < (dinsize+doutsize)/10)  timeout += (dinsize+doutsize)/10;
UDPretry:
  if ((id=OpenLink(0,devname,devprop,dout,din,datain,access,timeout,REGISTER)) < 0) ccerr(-id);

  link[id].hVBWnd = hDLLWnd;

  e=(ElemDataStruct far *)DeReference(link[id].hElem);
  if (e == NULL) ccerr(un_allocated);

  if (SendMessage(hDLLWnd,WM_LOCKLINK,id,0)) ccerr(serr2);
  link[id].mode = CM_SINGLE;
  e->PrimeMode = maxmode(e->PrimeMode,CM_SINGLE);
  e->mode = e->PrimeMode;

  SynchronousCallPending = -1;
//  while (SynchronousCallPending) SendMessage(hDLLWnd,WM_TIMER,0,0);
  ftime(&t0); t1 = t0;
  tgtTimeout = timeout < 1000 ? timeout: 2*timeout+2000;
  while (SynchronousCallPending)
  {
    if (t1.time*1000 + t1.millitm > t0.time*1000 + t0.millitm + timeout)
    {
      e->CompCode = link_not_open;
      break;
    }
    SendMessage(hDLLWnd,WM_TIMER,0,0);
    ftime(&t1);
  }
//    if (GetMessage(lpMsg,hDLLWnd,0,0)) DispatchMessage(lpMsg);

  if (((cc=e->CompCode) == 0 || (cc && CE_SENDDATA)) && e->sizeOut > 0)
  {
    if (dataout == NULL ||
        IsBadWritePtr(dataout,dsize=e->sizeOut*fmtsizeof(e->formatOut)) ) ccerr(buffer_too_small);
    DataOut = (BYTE far *)DeReference(e->hDataOut);
    if (DataOut == NULL) ccerr(buffer_too_small);
    _fmemcpy(dataout,DataOut,dsize);
  }
  if (dout) dout->dArrayLength = e->lastDataSize;
  RPCtimestamp = e->RPCtimestamp;
err:
  if ((rc = (cc & 0x0fff)))
  {
    if (e == NULL || !e->CompCode) wsprintf(RPCLastErrorString,"[LCL] %s",rc > 0 && rc < numErr ? erlst[rc] : "error undefined");
    else _fstrncpy(RPCLastErrorString,e->RPCLastErrorString,PREFIX+RPCERR_SIZE);
  }
  if (debug > 2 )
  {
    wsprintf(strbuf,"removing link %d\n",id);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  if (id > 0) SendMessage(hDLLWnd,WM_REMOVELINK,id,0);
  if (retry-- > 0 && cc == link_not_open) goto UDPretry;
  localSyncSemaphore = 0;
  if (debug > 2 )
  {
    wsprintf(strbuf,"%s %s completed with error code %d\n",devname,devprop,cc);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  return cc;
}
short ExecLink(char far *devname,char far *devprop,DBLK far *dout,void far *dataout,DBLK far *din,void far *datain,short access)
{
  return ExecLinkEx(devname,devprop,dout,dataout,din,datain,access,RPC_TIMEOUT*1000);
}
/* trivial RPC call: */
int tUDPCall(int fecindex,BYTE far *buf,int timout);
int tIPXCall(int fecindex,BYTE far *buf,int timout);
#define tCall(idx,buf,to) ( TCPloaded ? tUDPCall(idx,buf,to) : tIPXCall(idx,buf,to) )
extern BYTE lclWorkArea[IPX_BUFFER_SIZE];

/* trivial RPC call: */
int tRPC(int fecindex,char far *data,char far *name,short EqNo,char far *prop,
	   short size,short format,short timout)
{
  static char dev[16];
  sprintf(dev,"#%d",EqNo);
  return tExecLink(fecindex,name,dev,prop,size,data,format,timout);
}
#pragma argsused
int tExecLink(int fecindex,char far *name,char far *dev,char far *prop,
	   short size,char far *data,short format,short timout)
{
  int fmtsize,retry = 2;
  short cc=0,EqNo,dsize,sstepsize,pstepsize;
  static short NameServerProtocol = 5,RPCprotocol;
  HeaderStruct far *h = (HeaderStruct far *)lclWorkArea;
  struct subscription4 far *s = (struct subscription4 far *)&lclWorkArea[HEADERSTRUCT_SIZE];
  struct subscription far *sEx = (struct subscription far *)&lclWorkArea[HEADERSTRUCT_SIZE];
  ProducerHeaderStruct4 far *Pheader;
  static ProducerHeaderStruct PheaderTmp;
  ProducerHeaderStruct far *PheaderEx = &PheaderTmp;
  short sizeIn,sizeOut,formatIn,formatOut,access;
  static char devname[16];

  if (debug)
  {
    wsprintf(txtbuf,"trivial RPC: %s %s %s\n",name,prop,dev);
    output(txtbuf);
  }
  format = format ? format : CF_DOUBLE;
  fmtsize = fmtsizeof(format);
  if (!fmtsize || strlen(name) > 15 || strlen(prop) > 32) return string_too_long;
  if ((dsize = abs(size)*fmtsize) < 1) return out_of_range;
  if ((HEADERSTRUCT_SIZE+SUBSCRIPTION4_SIZE+dsize) > IPX_BUFFER_SIZE) return use_stream_transport;
  if (timout < 1) timout = 1;
  EqNo = dev[0] == '#' ? atoi(&dev[1]) : 0;
  sprintf(devname,"%s",dev);

  if (size < 0)
  {
    sizeIn = -size; formatIn = format;
    sizeOut = -size; formatOut = format;
    access = CA_WRITE|CA_READ;
  }
  else
  {
    sizeIn = 0; formatIn = CF_NULL;
    sizeOut = size; formatOut = format;
    access = CA_READ;
  }

  if (NameServerProtocol == 5)
  {
    sstepsize = SUBSCRIPTION_SIZE;
    pstepsize = PRODUCER_SIZE;
  }
  else
  {
    sstepsize = SUBSCRIPTION4_SIZE;
    pstepsize = PRODUCER4_SIZE;
  }
  _fmemset(h,0,sizeof(HeaderStruct));

tRETRY:
  RPCprotocol = NameServerProtocol;
  AssignOutgoingSubscription(NameServerProtocol,&lclWorkArea[HEADERSTRUCT_SIZE]);
  if (size < 0)
  {
    _fmemcpy(&lclWorkArea[HEADERSTRUCT_SIZE+sstepsize],data,dsize);
    s->msgsize = sstepsize + dsize;
  }
  else s->msgsize = sstepsize;

  h->TotalSize = HEADERSTRUCT_SIZE + s->msgsize;
  _fmemcpy(h->UserName,username,16);
  h->Protocol = RPCprotocol;
  h->EqpSize = 1;

  switch (cc = tCall(fecindex,lclWorkArea,timout))
  {
    case 0: break;
    case link_not_open:
      if (--retry) goto tRETRY;
      return cc;
    case illegal_protocol:
      if (NameServerProtocol == 5)
      {
        NameServerProtocol = 4;
        sstepsize = SUBSCRIPTION4_SIZE;
        pstepsize = PRODUCER4_SIZE;
        goto tRETRY;
      }
      return cc;
    default:
      return cc;
  }

  PrepIncomingSubscription(NameServerProtocol,&lclWorkArea[2]);
  if (PheaderEx->SubscriptionID != 0) return connection_timeout;
  if ((cc=PheaderEx->CompletionCode) == 0)
  {
    if (dsize != PheaderEx->msgsize-pstepsize) return illegal_format;
    else _fmemcpy(data,&lclWorkArea[2+pstepsize],dsize);
  }
  return cc;
}
extern RPCFecStruct NameServer;
#pragma argsused
int tUDPCall(int fecindex,BYTE far *buf,int timout)
{
  static struct fd_set tset;
  static struct timeval t_to;
  static struct sockaddr_in IPfec;
  static CLIENT cln;
  static struct sockaddr_in prod_name;
  int msgsize = *(unsigned short far *)buf;
  static int n,len;
  RPCFecStruct far *rpcfec = &NameServer;

  if (!TCPloaded) return tcp_not_supported;

  // clear the read queue
  FD_ZERO(&tset); FD_SET(SyncSocket,&tset);
  t_to.tv_sec=0; t_to.tv_usec=0; len = sizeof(IPfec);
  while (select(32,&tset,NULL,NULL,&t_to) > 0)
  {
    recvfrom(SyncSocket,(char far *)buf,IPX_BUFFER_SIZE,0,
             (struct sockaddr far *)&IPfec,&len);
  }

  _fmemset(&cln,0,sizeof(CLIENT));
  _fstrncpy(cln.userName,rpcfec->Name,16);
  if (!rpcfec->iaddr) return non_existent_fec;
  _fmemset(&prod_name,0,sizeof(prod_name));
  _fmemcpy(&prod_name.sin_addr,&rpcfec->iaddr,sizeof(struct in_addr));
  prod_name.sin_family=AF_INET;
  prod_name.sin_port = htons(UDP_PORT);
  _fmemcpy(&cln.IPaddress,&prod_name,sizeof(prod_name));

  // flush any input bytes there are somehow there ...
  FD_ZERO(&tset); FD_SET(SyncSocket,&tset);
  t_to.tv_sec=0; t_to.tv_usec=0;
  while (select(32,&tset,NULL,NULL,&t_to) > 0)
  {
    len = sizeof(IPfec);
    recvfrom(SyncSocket,(char far *)buf,IPX_BUFFER_SIZE,0,
            (struct sockaddr far *)&IPfec,&len);
  }
  if (sendto(SyncSocket,(char far *)buf,msgsize,0,
	    (struct sockaddr far *)&cln.IPaddress,sizeof(cln.IPaddress)) < 0)
    return tcp_socket_error;
  if (debug)
  {
    wsprintf(txtbuf,"tUDP: %d bytes sent\n",msgsize);
    output(txtbuf);
  }

  FD_ZERO(&tset); FD_SET(SyncSocket,&tset);
  t_to.tv_sec=timout; t_to.tv_usec=0; len = sizeof(IPfec);
  switch (select(32,&tset,NULL,NULL,&t_to))
  {
    case -1: return tcp_socket_error;
    case 0:  return link_not_open;
    default: n = recvfrom(SyncSocket,(char far *)buf,IPX_BUFFER_SIZE,0,
				      (struct sockaddr far *)&IPfec,&len);
  }
  if (n != *(short *)buf) return remitted_data_lost;
  return 0;
}
#pragma argsused
int tIPXCall(int fecindex,BYTE far *buf,int timout)
{
  static CLIENT cln;
  static BYTE reg_sock[2];
  int msgsize = *(unsigned short far *)buf;
  time_t t0 = time(NULL);
  RPCFecStruct far *rpcfec = &NameServer;

  reg_sock[0] = REG_SOCKET + rpcfec->PortOffset;
  reg_sock[1] = REG_SOCKET + rpcfec->PortOffset;
  _fmemset(&cln,0,sizeof(CLIENT));
  _fstrncpy(cln.userName,rpcfec->Name,16);
  _fmemcpy(&cln.IPXaddress,rpcfec->Network,10);
  _fmemcpy(cln.IPXaddress.socket,&reg_sock,2);
  _fmemcpy(cln.node,rpcfec->ImmediateAddress,6);

  if (*(int far *)cln.IPXaddress.socket == 0) return ipx_socket_error;
  _fmemcpy(&PCECB->hdr.destination.network,&cln.IPXaddress,12);
  _fmemcpy(&PCECB->ecb.immediateAddress,cln.node,6);
  PCECB->ecb.fragmentDescriptor[1].size = msgsize;
  _fmemcpy(PCECB->buf,buf,msgsize);
  PCECB->ecb.socketNumber = PnPsocket;
  IPXListenForPacket(IPXTaskID,&pnpECB->ecb);
  IPXSendPacket(IPXTaskID,(ECB far *)PCECB);
  while (PCECB->ecb.inUseFlag) IPXRelinquishControl();
  PCECB->ecb.socketNumber = CNSsocket;
  if (PCECB->ecb.completionCode) return ipx_socket_error;
  if (debug)
  {
    wsprintf(txtbuf,"tIPX: %d bytes sent\n",msgsize);
    output(txtbuf);
  }
  while (time(NULL) <= t0 + timout)
  {
    if (!pnpECB->ecb.inUseFlag)
    {
      _fmemcpy(buf,pnpECB->buf,IPX_BUFFER_SIZE);
      return 0;
    }
    IPXRelinquishControl();
  }
  return link_not_open;
}
