/* (s0p16.67h8.5v0s0b3T          */
/* File:      EQP.C            */

#include <windows.h>
#include <string.h>
#include <math.h>
#include "vbapi.h"
#include "eqp.h"

#define UINT32 unsigned long
typedef struct
{
  UINT32 dArrayLength;
  short  dFormat;
  short  reserved;
  char   dTag[8];
} DBLK;

/*--------------------------------------------------------------------------*/
/* Global Variables                                                         */
/*--------------------------------------------------------------------------*/
HANDLE hmodDLL;
WORD   cVbxUsers = 0;
HINSTANCE hinst;

/*--------------------------------------------------------------------------*/
/* Global Prototypes                                                        */
/*--------------------------------------------------------------------------*/
int FAR PASCAL _export OPENLINK (HWND hWnd, char far *devName,char far *devProperty,
				 DBLK far *dout,DBLK far *din,void far *datain,
				 short access,long timer,short mode);

int FAR PASCAL LinkData(HWND hVBWnd, char far *name, int EqNo,
	  char far *prop, long timer, int size, int format,int mode);

int FAR PASCAL CloseLink(HWND hVBWnd, int i);

/*--------------------------------------------------------------------------*/
/* Local Prototypes                                                         */
/*--------------------------------------------------------------------------*/
VOID NEAR FireReceive(HCTL hctl);
VOID NEAR FireSend(HCTL hctl);

VOID NEAR itoa(int i, char far *a)
{
  char str[100];
  int len, sgn = i < 0 ? 1 : 0;

  for (i=abs(i),len=0; i; len++, i /= 10)
  {
    *a++ = '0' + i%10;
    str[0] = '0' + i%10; str[1] = 0;
    MessageBox(NULL, str, "", MB_OK);
  }
  if (sgn) *a++ = '-', len++;
  a -= len;
  str[len] = 0;
  while (len--)  str[len] = *a++;
  return;
}
int RPCformats[] = { 512,513,514,515,513,517,519,520,1 };

LONG FAR PASCAL _export RPCCtlProc(HCTL hctl,HWND hwnd,USHORT msg,
	 USHORT wp,LONG lp)
{
  int cc;

  switch (msg)
  {
    case WM_QUERYENDSESSION:
    {
      if (MessageBox(GetParent(hwnd), "ENDSESSION", "", MB_OK)==IDOK) return 1L;
      else return 0;
    }
    case WM_NCCREATE:
    {
      LPRPC lpRPC = LpRPCDEREF(hctl);
      lpRPC->EqpPollMode = 3;
      lpRPC->EqpPollRate = 5000;
      lpRPC->EqpEnabled = 0;
      break;
    }
   case WM_NCDESTROY:
   {
     LPRPC lpRPC = LpRPCDEREF(hctl);
      if (lpRPC->EqpEnabled) CloseLink(hwnd,lpRPC->EqpIndex);
     if (lpRPC->EqpName)VBDestroyHsz(lpRPC->EqpName);
     if (lpRPC->EqpProperty) VBDestroyHsz(lpRPC->EqpProperty);
     break;                  /* an application should return zero */
   }
   case RPCMSG_RECEIVE:
   {
     LPRPC lpRPC = LpRPCDEREF(hctl);
     VBSetControlProperty(hctl,IPROP_RPC_EQPINDEX,(LONG)wp);
     VBSetControlProperty(hctl,IPROP_RPC_EQPSTATUS,(LONG)lp);
     FireReceive(hctl);
     if (lpRPC->EqpPollMode < 2) lpRPC->EqpEnabled = 0;
     return 0;
   }
   case RPCMSG_SEND:
   {
     LPRPC lpRPC = LpRPCDEREF(hctl);
     FireSend(hctl);
     return 0;
   }
   case VBM_CREATED:
   {
     if (VBGetMode() != MODE_DESIGN) return 0;
     break;
   }
   case VBM_SETPROPERTY:
   {
     switch (wp)
     {
      case IPROP_RPC_EQPENABLED:
      {
	LPRPC lpRPC = LpRPCDEREF(hctl);
	if (VBGetMode()==MODE_RUN)
	{
	 if ((SHORT)lp && !lpRPC->EqpEnabled)
	 {
	   cc = LinkData(hwnd,VBDerefHsz(lpRPC->EqpName),
		     lpRPC->EqpNumber,
		     VBDerefHsz(lpRPC->EqpProperty),
		     lpRPC->EqpPollRate,lpRPC->EqpSize,
		     RPCformats[lpRPC->EqpFormat],
		     lpRPC->EqpPollMode);
	   if (cc < 0)
	   {
	    lpRPC->EqpStatus = -cc;
	    FireReceive(hctl);
	    lp = 0;
	   }
	   else
	   {
	     lpRPC->EqpIndex = cc;
	     FireSend(hctl);
	   }
	 }
	 else if (!(SHORT)lp && lpRPC->EqpEnabled)
	   CloseLink(hwnd,lpRPC->EqpIndex);
	}
	lpRPC->EqpEnabled = lp;
	return 0;
      }
     }
     break;
   }
  }
  return VBDefControlProc(hctl, hwnd, msg, wp, lp);
}

/*--------------------------------------------------------------------------*/
/* Fire the Receive event.                                                  */
/*--------------------------------------------------------------------------*/
VOID NEAR FireReceive(HCTL hctl)
{
  VBFireEvent(hctl, IEVENT_RPC_RECEIVE, NULL);
}
VOID NEAR FireSend(HCTL hctl)
{
  VBFireEvent(hctl, IEVENT_RPC_SEND, NULL);
}

/*--------------------------------------------------------------------------*/
/* Initialize library. This routine is called when the first client loads   */
/* the DLL.                                                                 */
/*--------------------------------------------------------------------------*/
int FAR PASCAL LibMain
(
  HANDLE hModule,
  WORD   wDataSeg,
  WORD   cbHeapSize,
  LPSTR  lpszCmdLine
)
{
  /* Avoid warnings on unused (but required) formal parameters */
  wDataSeg    = wDataSeg;
  cbHeapSize  = cbHeapSize;
  lpszCmdLine = lpszCmdLine;
  hmodDLL = hModule;
  return 1;
}

/*--------------------------------------------------------------------------*/
/* Register custom control.  This routine is called by VB when the custom   */
/* control DLL is loaded for use.                                           */
/*--------------------------------------------------------------------------*/
BOOL FAR PASCAL _export VBINITCC
(
  USHORT usVersion,
  BOOL   fRuntime
)
{
  ++cVbxUsers;     /* count the number of hosts using this VBX */
  fRuntime = fRuntime; /* avoid warnings on unused (but required) formal parameters */
  usVersion = usVersion;
  return VBRegisterModel(hmodDLL, &modelRPC); /* register control(s) */
}

/*--------------------------------------------------------------------------*/
/* Register custom control.  This routine is called by VB when the custom   */
/* control DLL is unloaded.                                                 */
/*--------------------------------------------------------------------------*/
VOID FAR PASCAL _export VBTERMCC
(
  VOID
)
{
  --cVbxUsers;
  return;
}

/*--------------------------------------------------------------------------*/
/* WEP                                                                      */
/*--------------------------------------------------------------------------*/
/*
int FAR PASCAL WEP(int fSystemExit)
{
  fSystemExit = fSystemExit;
  return 1;
}
*/
