/* (s0p16.67h8.5v0s0b3T         */
/* File:      EQP.H           */

//extern int FAR PASCAL RPC(char far *name, int EqNo, char far *prop, int size, void far *data, int datasize, int format);
//---------------------------------------------------------------------------
// Resource Information
//---------------------------------------------------------------------------
// Toolbox bitmap resource IDs numbers.
//---------------------------------------------------------------------------
#define IDBMP_RPC            8000
#define IDBMP_RPCDOWN        8001
#define IDBMP_RPCMONO        8003
#define IDBMP_RPCEGA         8006

#define RPCMSG_RECEIVE       (WM_USER+1)
#define RPCMSG_SEND          (WM_USER+2)

//              Copyright (C) 1991-93, Microsoft Corporation
//
// You have a royalty-free right to use, modify, reproduce and distribute
// the Sample Custom Control Files (and/or any modified version) in any way
// you find useful, provided that you agree that Microsoft has no warranty,
// obligation or liability for any Custom Control File.
//---------------------------------------------------------------------------
// eqp.h
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Change these for each new VBX file
//---------------------------------------------------------------------------
#define VBX_COMPANYNAME            "DESY\0"
#define VBX_FILEDESCRIPTION        "Visual Basic RPC Client\0"
#define VBX_INTERNALNAME           "Eqp\0"
#define VBX_LEGALCOPYRIGHT         "Copyright \251 Microsoft Corp. 1991-93\0"
#define VBX_LEGALTRADEMARKS        "Microsoft\256 is a registered trademark of Microsoft Corporation. Visual Basic\231 is a trademark of Microsoft Corporation. Windows\231 is a trademark of Microsoft Corporation.\0"
#define VBX_ORIGINALFILENAME       "EQP.VBX\0"
#define VBX_PRODUCTNAME            "Microsoft\256 Visual Basic\231 for Windows\231\0"

//---------------------------------------------------------------------------
// Update these fields for each build.
//---------------------------------------------------------------------------
#define VBX_VERSION                 3,00,0,00
#define VBX_VERSION_STR            "3.00.000\0"

#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Macro for referencing member of structure
//---------------------------------------------------------------------------
#define OFFSETIN(struc,field)     ((USHORT)&(((struc *)0)->field))

//#define ERR_BADINDEX           381
#define ERR_PF                 32000

//---------------------------------------------------------------------------
 // Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export RPCCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


//---------------------------------------------------------------------------
// RPC control data and structs
//---------------------------------------------------------------------------
typedef struct tagRPC
    {
    HSZ         EqpName;
    HSZ         EqpProperty;
    WORD        EqpNumber;
    SHORT       EqpSize;
    SHORT       EqpFormat;
    SHORT       EqpPollRate;
    SHORT       EqpPollMode;
    SHORT       EqpEnabled;
    SHORT       EqpIndex;
		SHORT       EqpStatus;
		} RPC;

typedef RPC FAR * LPRPC;

#define LpRPCDEREF(hctl)       ((LPRPC)VBDerefControl(hctl))

CHAR szRPCTypes[] = "0 - WriteRead\0"\
				"1 - Read\0"\
				"";

CHAR szRPCFormats[] = "0 - DOUBLE\0"\
											"1 - INTEGER\0"\
											"2 - BYTE\0"\
											"3 - LONG\0"\
											"4 - SHORT\0"\
											"5 - FLOAT\0"\
											"6 - STRUCT\0"\
											"7 - STRING8\0"\
											"8 - TEXT\0"\
											"";

CHAR szRPCModes[] = "0 - CANCEL\0"\
		    "1 - SINGLE\0"\
		    "2 - REFRESH\0"\
		    "3 - POLL\0"\
		    "";

CHAR szRPCenabled[] = "0 - False\0"\
		      "1 - True\0"\
		      "";

//---------------------------------------------------------------------------
// Property info
//---------------------------------------------------------------------------
PROPINFO Property_EqpName =
		{
		"EqpName",
		DT_HSZ | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
		OFFSETIN(RPC, EqpName), 0,
		0,
		NULL, 0
		};

PROPINFO Property_EqpProperty =
		{
		"EqpProperty",
		DT_HSZ | PF_fSetData | PF_fGetData | PF_fSaveData,
		OFFSETIN(RPC, EqpProperty), 0,
		0,
		NULL, 0
		};

PROPINFO Property_EqpNumber =
		{
		"EqpNumber",
		DT_SHORT | PF_fGetData | PF_fSetData | PF_fSaveData,
		OFFSETIN(RPC, EqpNumber), 0,
		0,
		NULL, 0
		};

PROPINFO Property_EqpSize =
		{
		"EqpSize",
		DT_SHORT | PF_fGetData | PF_fSetData | PF_fSaveData,
		OFFSETIN(RPC, EqpSize), 0,
		0,
		NULL, 0
		};

PROPINFO Property_EqpFormat =
		{
		"EqpFormat",
		DT_ENUM | PF_fSetData | PF_fGetData | PF_fSaveData,
		OFFSETIN(RPC, EqpFormat), 0,
		0,
		szRPCFormats, 8
		};

PROPINFO Property_EqpPollRate =
		{
		"EqpPollRate",
		DT_SHORT | PF_fSetData | PF_fGetData | PF_fSaveData,
		OFFSETIN(RPC, EqpPollRate), 0,
		0,
		NULL, 0
		};

PROPINFO Property_EqpPollMode =
		{
		"EqpPollMode",
		DT_ENUM | PF_fSetData | PF_fGetData | PF_fSaveData,
		OFFSETIN(RPC, EqpPollMode), 0,
		0,
		szRPCModes, 3
		};

PROPINFO Property_EqpEnabled =
		{
		"Enabled",
		DT_BOOL | PF_fGetData | PF_fSetMsg,
		OFFSETIN(RPC, EqpEnabled), 0,
		0,
		NULL, 0
		};

PROPINFO Property_EqpIndex =
		{
		"EqpIndex",
		DT_SHORT | PF_fSetData | PF_fGetData | PF_fNoShow,
		OFFSETIN(RPC, EqpIndex), 0,
		0,
		NULL, 0
		};

PROPINFO Property_EqpStatus =
		{
		"EqpStatus",
		DT_SHORT | PF_fSetData | PF_fGetData | PF_fNoShow,
		OFFSETIN(RPC, EqpStatus), 0,
		0,
		NULL, 0
		};
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------

#define IPROP_RPC_CTLNAME              0
#define IPROP_RPC_LEFT                 1
#define IPROP_RPC_TOP                  2
#define IPROP_RPC_PARENT               3
#define IPROP_RPC_HWND                 4
#define IPROP_RPC_INDEX                5

#define IPROP_RPC_EQPNAME             6
#define IPROP_RPC_PROPERTY            7
#define IPROP_RPC_EQPNUMBER           8
#define IPROP_RPC_EQPSIZE             9
#define IPROP_RPC_EQPFORMAT          10
#define IPROP_RPC_EQPPOLL            11
#define IPROP_RPC_EQPMODE            12
#define IPROP_RPC_EQPENABLED         13
#define IPROP_RPC_EQPINDEX           14
#define IPROP_RPC_EQPSTATUS          15

PPROPINFO RPC_Properties[] =
    {
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_LEFTNORUN,
    PPROPINFO_STD_TOPNORUN,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_HWND,
    PPROPINFO_STD_INDEX,
    &Property_EqpName,
    &Property_EqpProperty,
    &Property_EqpNumber,
    &Property_EqpSize,
    &Property_EqpFormat,
    &Property_EqpPollRate,
    &Property_EqpPollMode,
    &Property_EqpEnabled,
    &Property_EqpIndex,
		&Property_EqpStatus,
		NULL
		};
//---------------------------------------------------------------------------
// Event info
//---------------------------------------------------------------------------
EVENTINFO Event_Receive =
		{
		"Receive",
		0,
		0,
		NULL,
		NULL
		};

EVENTINFO Event_Send =
		{
		"Send",
		0,
		0,
		NULL,
		NULL
		};

//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define IEVENT_RPC_RECEIVE             0
#define IEVENT_RPC_SEND                1

PEVENTINFO RPC_Events[] =
		{
		&Event_Receive,
		&Event_Send,
		NULL
		};

//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
MODEL modelRPC =
		{
		VB_VERSION,                         // VB version being used
		MODEL_fInvisAtRun,                     // MODEL flags
		(PCTLPROC)RPCCtlProc,               // Control procedure
		CS_VREDRAW | CS_HREDRAW,            // Class style
		WS_BORDER,                          // Default Windows style
		sizeof(RPC),                        // Size of RPC structure
		IDBMP_RPC,                          // Palette bitmap ID
		"Eqp",                            // Default control name
		"Eqp",                            // Visual Basic class name
		NULL,                               // Parent class name
		RPC_Properties,                  // Property information table
		RPC_Events,                      // Event information table
		IPROP_RPC_CTLNAME,                 // Default property
		IEVENT_RPC_RECEIVE,                // Default event
		IPROP_RPC_CTLNAME                // Property representing value of ctl
		};

//---------------------------------------------------------------------------

#endif /* RC_INVOKED */
