#ifndef _RPCDEFS_H_
#define _RPCDEFS_H_

#ifndef DELIMITER
#define DELIMITER "/\\"
#endif
#ifndef RTOL
#define RTOL    0  /* Direction: Remote to Local */
#define LTOR    1  /* Direction: Local to Remote  */
#endif
#ifndef MAX
#define MAX(a,b)  ((a) > (b) ? a : b)
#endif
#ifndef MIN
#define MIN(a,b)  ((a) < (b) ? a : b)
#endif
#ifndef BYTE
#define BYTE unsigned char
#endif
#ifndef WORD
#define WORD unsigned short
#endif
#ifndef DWORD
#define DWORD unsigned long
#endif
#ifndef UINT8
#define UINT8 unsigned char
#endif
#ifndef UINT16
#define UINT16 unsigned short
#endif
#ifndef UINT32
#define UINT32 unsigned long
#endif

#ifndef TRUE
#define TRUE -1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#undef CF_TEXT
#define CF_DOUBLE   512
#define CF_UINT16   513
#define CF_SHORT    513
#define CF_INTEGER  513
#define CF_UINT8    514
#define CF_BYTE     514
#define CF_UINT32   515
#define CF_INT4     515
#define CF_LONG     515
#define CF_TEXT     516
#define CF_FLOAT    517
#define CF_POCALBLK 518
#define CF_STRUCT   519
#define CF_CHAR8    520
#define CF_STRING8  520
#define CF_CHAR16   521
#define CF_STRING16 521
#define CF_CHAR16FI 522
#define CF_BIT      523
#define CF_HITTS    524

#define CF_NULL     767

#define getFormatSize(fmt)\
 ( fmt == CF_DOUBLE  ? 8 :\
   fmt == CF_SHORT   ? 2 :\
   fmt == CF_BYTE    ? 1 :\
   fmt == CF_LONG    ? 4 :\
   fmt == CF_FLOAT   ? 4 :\
   fmt == CF_STRUCT  ? 1 :\
   fmt == CF_POCALBLK? 1 :\
   fmt == CF_CHAR8   ? 8 :\
   fmt == CF_CHAR16  ? 16:\
   fmt == CF_CHAR16FI? 24:\
   fmt == CF_HITTS   ? 6 :\
   fmt == CF_TEXT    ? 1 : 0 )

#define fmtsizeof(fmt)\
 ( (short)(fmt) < CF_DOUBLE ? getFormatSize((short)(fmt+CF_DOUBLE)) : getFormatSize((short)(fmt)) )

#define LFMT(fmt) ((fmt)+CF_DOUBLE)
#define BFMT(fmt) ((fmt)-CF_DOUBLE)

#define enumFormat(fmt) (\
   fmt == CF_DOUBLE  ? 0  :\
   fmt == CF_SHORT   ? 1  :\
   fmt == CF_BYTE    ? 2  :\
   fmt == CF_LONG    ? 3  :\
   fmt == CF_FLOAT   ? 4  :\
   fmt == CF_STRUCT  ? 5  :\
   fmt == CF_POCALBLK? 6  :\
   fmt == CF_STRING8 ? 7  :\
   fmt == CF_CHAR16  ? 8  :\
   fmt == CF_CHAR16FI? 9  :\
   fmt == CF_TEXT    ? 10 :\
   fmt == CF_BIT     ? 11 :\
   fmt == CF_HITTS   ? 12 :\
   13 )

#define getFormatType(txt) (\
	!strcmp(txt,"BYTE")     ? CF_BYTE :\
	!strcmp(txt,"SHORT")    ? CF_SHORT :\
	!strcmp(txt,"INTEGER")  ? CF_SHORT :\
	!strcmp(txt,"LONG")     ? CF_LONG :\
	!strcmp(txt,"FLOAT")    ? CF_FLOAT :\
	!strcmp(txt,"SINGLE")   ? CF_FLOAT :\
	!strcmp(txt,"DOUBLE")   ? CF_DOUBLE :\
	!strcmp(txt,"STRUCT")   ? CF_STRUCT :\
	!strcmp(txt,"TEXT")     ? CF_TEXT :\
	!strcmp(txt,"CHAR")     ? CF_TEXT :\
	!strcmp(txt,"STRING")   ? CF_TEXT :\
	!strcmp(txt,"NAME8")    ? CF_CHAR8 :\
	!strcmp(txt,"CHAR8")    ? CF_CHAR8 :\
	!strcmp(txt,"NAME16")   ? CF_CHAR16 :\
	!strcmp(txt,"CHAR16")   ? CF_CHAR16 :\
	!strcmp(txt,"CHAR16FI") ? CF_CHAR16FI :\
	!strcmp(txt,"BIT")      ? CF_BIT :\
	!strcmp(txt,"HITTS")    ? CF_HITTS :\
	!strcmp(txt,"POCALBLK") ? CF_POCALBLK :\
	CF_NULL )

#define CM_NULL         0x00
#define CM_CANCEL       0x00
#define CM_SINGLE       0x01
#define CM_REFRESH      0x02
#define CM_POLL         0x03
#define CM_REGISTER     0x04
#define CM_GROUPED      0x1000

#define getAccessMode(txt) (\
 	!strcmp(txt,"READ")    ? CM_SINGLE :\
	!strcmp(txt,"WRITE")   ? CM_SINGLE :\
	!strcmp(txt,"SINGLE")  ? CM_SINGLE :\
	!strcmp(txt,"REFRESH") ? CM_REFRESH :\
	!strcmp(txt,"POLL")    ? CM_POLL :\
	!strcmp(txt,"REGISTER")? CM_REGISTER :\
	CM_CANCEL )

#define CA_NULL         0x00
#define CA_READ         0x01
#define CA_WRITE        0x02
#define CA_ASYNC        0x04
#define CA_SYNC         0x08
#define CA_FIRST		0x40
#define CA_LAST			0x80

#define getAccessType(txt) ( !strcmp(txt,"WRITE") ? CA_WRITE : CA_READ )

#define CSHOSTS      "HERANS"
#define CSHOSTS_FILE "herans.csv"
#define EQPDB_FILE   "eqpdbase.csv"
#define FECDB_FILE   "fecaddr.csv"

#endif /* _RPCDEFS_H_ */
