/* (s0p16.67h8.5v0s0b3T          */
/* File:      SRV.C               */
/* Date:      07-06-93            */
/* Author:    U. Laustrer        */

/* Changes:                       */
/* Date:      14-02-94            */
/* Reason:    RAddress, WAddress  */
/* -------------------------------------------------------------------------*/
/* SRV.c                                                                    */
/* -------------------------------------------------------------------------*/
/* Contains control procedure for SRV control                              */
/* -------------------------------------------------------------------------*/
#include <windows.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "vbapi.h"
#include "errors.h"
#include "rpcdefs.h"
#include "winsrv.h"

/*--------------------------------------------------------------------------*/
/* Global Variables                                                         */
/*--------------------------------------------------------------------------*/
HANDLE hmodDLL;
WORD   cVbxUsers = 0;
HINSTANCE hinst;

/*--------------------------------------------------------------------------*/
/* Global Prototypes                                                        */
/*--------------------------------------------------------------------------*/
typedef union
{
	void   far *vptr;
	char   far *cptr;
	UINT8  far *bptr;
	UINT16 far *sptr;
	UINT32 far *lptr;
	float  far *fptr;
	double far *dptr;
} DUNION;

typedef struct
{
	UINT32 dArrayLength;
	short  dFormat;
	short  reserved;
	char   dTag[16];
	DUNION data;
} DTYPE;

int  FAR PASCAL Register(char far *name, HWND hVBWnd);
int  FAR PASCAL RegisterEQP(char far *tag, char far *name, int num, HWND hVBWnd);
void FAR PASCAL AcceptSPXStream(void);
void FAR PASCAL AcceptTCPStream(void);
void FAR PASCAL GetIPXData(void);
void FAR PASCAL GetUDPData(void);
void FAR PASCAL GetContract(int far *eqno, char far *prop, int far *size, int EqpIndex, unsigned long far *EqpTime);
short FAR PASCAL GetContractEx(char far *devName, char far *devProperty,
		DTYPE far *dout,DTYPE far *din,short far *access,short eqpidx);
void FAR PASCAL ContractDone(void far *data, int size, int status, int EqpIndex, unsigned long EqpTime, int EqpFormat);
void FAR PASCAL RemoveEqpfcn(char far *name, HWND hVBWnd);
void FAR PASCAL GetCallerInfo(char far *ClientName,char far *ClientAddress);
int FAR PASCAL GetData(void far *data, int size, int eqpidx, int EqpFormat);
int FAR PASCAL GetCallerFormat(int eqpidx);
void FAR PASCAL SETRPCERROR(int errcode,char far *errstr);
short FAR PASCAL PutData(void far *data,time_t eqptime,short eqpidx);
short __export __loadds FAR PASCAL AdjustContract(char far *devName, char far *devProperty,
		long dataLengthOut, long dataLengthIn,short eqpidx);

/*--------------------------------------------------------------------------*/
/* Local Prototypes                                                         */
/*--------------------------------------------------------------------------*/
VOID NEAR FireReceive(HCTL hctl);
VOID NEAR FireEqpFcn(HCTL hctl,LPSTR nm,LPSTR prp,long outsiz,long insiz,int acc);

int atoi(char far *a)
{
  int v = 0;
  char far *c;

  for (c=a; *c >= '0' && *c <= '9'; c++)
  {
    v = v*10 + *c - '0';
  }
  return v;
}
/*  see page 300
VOID PASCAL PaintControl(HWND hwnd)
{
  HDC hdcMem;
  PAINTSTRUCT ps;

  BeginPaint(hwnd, &ps);
  hdcMem = CreateCompatible(ps.hdc);
  if (!hdcMem) return;
  SelectObject(hdcMem,HBitmap);
  BitBlt(ps.hdc,0,0,bmWidth,bmHeight,hdcMem,0,0,SRCCOPY);
  DeleteDC(hdcMem);
  EndPaint(hwnd,&ps);
}
*/
/*--------------------------------------------------------------------------*/
/* SRV Control Procedure                                                    */
/*--------------------------------------------------------------------------*/

int RPCformats[] = { 512,513,514,515,513,517,519,520,1 };

#define getEnumeratedFormat(f)\
 ( f == 512 ? 0 :\
   f == 513 ? 1 :\
   f == 514 ? 2 :\
   f == 515 ? 3 :\
   f == 517 ? 5 :\
   f == 519 ? 6 :\
   f == 520 ? 7 :\
   f ==   1 ? 8 : 0 )


LONG FAR PASCAL _export SrvCtlProc
(
  HCTL   hctl,
  HWND   hwnd,
  USHORT msg,
  USHORT wp,
  LONG   lp
)
{
  switch (msg)
  {
    case WM_NCCREATE:
    {
      LPSRV lpSRV = LpSRVDEREF(hctl);
      lpSRV->RWSize=0;
      lpSRV->EqpEnabled = 0;
      break;
    }
    case WM_NCDESTROY:
    {
      LPSRV lpSRV = LpSRVDEREF(hctl);
      char far *eqname = VBDerefHsz(lpSRV->EqpName);
      RemoveEqpfcn(eqname,hwnd);
      lpSRV->EqpEnabled = 0;
      if (lpSRV->EqpName) VBDestroyHsz(lpSRV->EqpName);
      if (lpSRV->Property) VBDestroyHsz(lpSRV->Property);
      break;                  /* an application should return zero */
    }
    case WM_QUERYENDSESSION:
    {
      if (MessageBox(GetParent(hwnd), "ENDSESSION", "", MB_OK)==IDOK) return 1L;
      else return 0;
    }
    case RECEIVE_MSG:
    {
      LPSRV lpSRV = LpSRVDEREF(hctl);
      short cc,rwflag,fmt,EqNo = 0;
      char far *es;
      static char property[33], clientName[17], fecaddr[30];
      static char devname[17];
      static WORD SizeInBytes;
      static DTYPE din,dout;
      static short access;
      static char errstr[32];

      lpSRV->EqpIndex = (short) lp;

      GetCallerInfo(clientName,fecaddr);
      VBSetControlProperty(hctl, IPROP_SRV_CLIENTNAME, (LONG)(LPSTR)clientName);
      VBSetControlProperty(hctl, IPROP_SRV_CLIENTADDRESS, (LONG)(LPSTR)fecaddr);

      if ((cc=GetContractEx((char far *)devname,(char far *)property,
	      (DTYPE far *)&dout,(DTYPE far *)&din,
	      (short far *)&access,(short)lpSRV->EqpIndex)) != 0)
      {
	return 0;
      }

      if (devname[0] == '#') EqNo = atoi((char far *)&devname[1]);
      SizeInBytes = dout.dArrayLength*fmtsizeof(dout.dFormat);
      fmt = dout.dFormat;
//      lpSRV->EqpFormat = getEnumeratedFormat(fmt);
      rwflag = din.dArrayLength > 0 ? -1*din.dArrayLength : dout.dArrayLength;

//      lpSRV->Status = not_posted;
      VBSetControlProperty(hctl, IPROP_SRV_STATUS, (LONG)not_posted);
      VBSetControlProperty(hctl, IPROP_SRV_ERRORSTRING, (LONG)(LPSTR)"Internal");
      VBSetControlProperty(hctl, IPROP_SRV_PROPERTY, (LONG)(LPSTR)property);
      VBSetControlProperty(hctl, IPROP_SRV_EQPDEVICENAME, (LONG)(LPSTR)devname);
      VBSetControlProperty(hctl, IPROP_SRV_RWSIZE, *(LPLONG)&rwflag);
      VBSetControlProperty(hctl, IPROP_SRV_EQPNUMBER,*(LPLONG)&EqNo);
      VBSetControlProperty(hctl, IPROP_SRV_EQPFORMAT,*(LPLONG)&fmt);

      VBSetControlProperty(hctl, IPROP_SRV_PACKETSIZE, (LONG)SizeInBytes);
      VBSetControlProperty(hctl, IPROP_SRV_PACKETFORMAT,*(LPLONG)&fmt);
      VBSetControlProperty(hctl, IPROP_SRV_EQNUMBER,*(LPLONG)&EqNo);

      FireEqpFcn(hctl,devname,property,dout.dArrayLength,din.dArrayLength,access);
      if (lpSRV->Status == not_posted) FireReceive(hctl);
//      if ((es=VBDerefHsz(lpSRV->ErrorString)) != NULL) _fstrncpy(errstr,es,32);
      errstr[0] = 0;
      SETRPCERROR(lpSRV->Status,(char far *)errstr);
      return 0;
    }
    case CONNECT_MSG:
    {
      int NETprotocol = wp;
      int socket = (int)lp;

      switch (wp)
      {
	      case IPX: GetIPXData();
			    break;
	      case SPX: AcceptSPXStream();
			    break;
	      case UDP: GetUDPData();
			    break;
	      case TCP: AcceptTCPStream();
			    break;
      }
      return 0;
    }
    case VBM_CREATED:
    {
      if (VBGetMode() != MODE_DESIGN) return 0;
      break;
    }
    case VBM_SETPROPERTY:
    {
      switch (wp)
      {
	case IPROP_SRV_RADDRESS:
	{
	  LPSRV lpSRV = LpSRVDEREF(hctl);

	  if (lpSRV->RAddress != 0)
	    PutData((void far *)lpSRV->RAddress,lpSRV->EqpTime,lpSRV->EqpIndex);

	  return 0;
	}
	case IPROP_SRV_EQPSEND:
	{
	  LPSRV lpSRV = LpSRVDEREF(hctl);

	  if (lpSRV->EqpSend != 0)
	    PutData((void far *)lpSRV->EqpSend,lpSRV->EqpTime,lpSRV->EqpIndex);

	  return 0;
	}
	case IPROP_SRV_WADDRESS:
	{
	  LPSRV lpSRV = LpSRVDEREF(hctl);

	  if (!lpSRV->WAddress)
	  {
	    lpSRV->Status = illegal_size;
	    return 0;
	  }
	  lpSRV->Status = GetData((void far *)lpSRV->WAddress,(int)32767,(int)lpSRV->EqpIndex,RPCformats[lpSRV->EqpFormat]);
	  return 0;
	}
	case IPROP_SRV_EQPRECV:
	{
	  LPSRV lpSRV = LpSRVDEREF(hctl);
	  if (lpSRV->EqpRecv != 0)
	    lpSRV->Status = GetData((void far *)lpSRV->EqpRecv,(int)32767,(int)lpSRV->EqpIndex,0);
	  return 0;
	}
	case IPROP_SRV_EQPENABLED:
	{
	  static char eqpname[7];
	  LPSRV lpSRV = LpSRVDEREF(hctl);
	  char far *tag = VBDerefHsz(lpSRV->ExportName);
	  char far *eqname = VBDerefHsz(lpSRV->EqpName);
	  int num = lpSRV->EqpNumModules;
	  _fstrncpy(eqpname,eqname,6); eqpname[6] = 0;
	  _fstrupr(eqpname);
	  if (VBGetMode()==MODE_RUN)
	  {
	    if ((SHORT)lp && !lpSRV->EqpEnabled)
	    {
	      lpSRV->Status = (SHORT)RegisterEQP(tag,eqpname,num,hwnd);
	    }
	    else if (!(SHORT)lp && lpSRV->EqpEnabled)
	    {
	      RemoveEqpfcn(eqpname,hwnd);
	    }
	  }
	  lpSRV->EqpEnabled = (short)lp;
	  return 0;
	}
      }

      break;
    }
  }
  return VBDefControlProc(hctl, hwnd, msg, wp, lp);
}

/*--------------------------------------------------------------------------*/
/* Fire the Receive event.                                                  */
/*--------------------------------------------------------------------------*/
VOID NEAR FireReceive(HCTL hctl)
{
  VBFireEvent(hctl, IEVENT_SRV_RECEIVE, NULL);
}
VOID NEAR FireEqpFcn(HCTL hctl,LPSTR nm,LPSTR prp,long outsiz,long insiz,int acc)
{
  EQPFCNPARAMS EqpFcnParams;
  LPSRV lpSRV = LpSRVDEREF(hctl);
  static char devname[16], devprop[32];
  static long inArrayLen,outArrayLen;
  static int access;

  if (nm == NULL || prp == NULL) return;
  _fstrncpy(devname,nm,16); _fstrncpy(devprop,prp,32);
  inArrayLen = insiz; outArrayLen = outsiz; access = acc;
  EqpFcnParams.devName = VBCreateHlstr((LPSTR)devname,_fstrlen(devname));
  EqpFcnParams.devProperty = VBCreateHlstr((LPSTR)devprop,_fstrlen(devprop));
  EqpFcnParams.outArrayLen = &outArrayLen;
  EqpFcnParams.inArrayLen  = &inArrayLen;
  EqpFcnParams.access      = &access;

  VBFireEvent(hctl,IEVENT_SRV_EQPFCN,&EqpFcnParams);

  if (outArrayLen != outsiz)
  {
    AdjustContract(NULL,NULL,outArrayLen,insiz,lpSRV->EqpIndex);
  }

  VBDestroyHlstr(EqpFcnParams.devName);
  VBDestroyHlstr(EqpFcnParams.devProperty);

}

/*--------------------------------------------------------------------------*/
/* Initialize library. This routine is called when the first client loads   */
/* the DLL.                                                                 */
/*--------------------------------------------------------------------------*/
int FAR PASCAL LibMain
(
  HANDLE hModule,
  WORD   wDataSeg,
  WORD   cbHeapSize,
  LPSTR  lpszCmdLine
)
{
  /* Avoid warnings on unused (but required) formal parameters */
  wDataSeg    = wDataSeg;
  cbHeapSize  = cbHeapSize;
  lpszCmdLine = lpszCmdLine;
  hmodDLL = hModule;
  return 1;
}

/*--------------------------------------------------------------------------*/
/* Register custom control.  This routine is called by VB when the custom   */
/* control DLL is loaded for use.                                           */
/*--------------------------------------------------------------------------*/
BOOL FAR PASCAL _export VBINITCC
(
  USHORT usVersion,
  BOOL   fRuntime
)
{
  ++cVbxUsers;     /* count the number of hosts using this VBX */
  fRuntime = fRuntime; /* avoid warnings on unused (but required) formal parameters */
  usVersion = usVersion;
  return VBRegisterModel(hmodDLL, &modelSRV); /* register control(s) */
}

/*--------------------------------------------------------------------------*/
/* Register custom control.  This routine is called by VB when the custom   */
/* control DLL is unloaded.                                                 */
/*--------------------------------------------------------------------------*/
VOID FAR PASCAL _export VBTERMCC
(
  VOID
)
{
  --cVbxUsers;
  return;
}

/*--------------------------------------------------------------------------*/
/* WEP                                                                      */
/*--------------------------------------------------------------------------*/
/*
int FAR PASCAL WEP(int fSystemExit)
{
  fSystemExit = fSystemExit;
  return 1;
}
*/
