#define IDBMP_LSN            8000
#define IDBMP_LSNDOWN        8001
#define IDBMP_LSNMONO        8003
#define IDBMP_LSNEGA         8006

#define CONNECT_MSG          (WM_USER+1)
#define RECEIVE_MSG          (WM_USER+2)
#define ACTIVATE_MSG         (WM_USER+3)

#define ERR_CONTACT          20000
#define ERR_REMOVE           20001

//              Copyright (C) 1991-93, Microsoft Corporation
//
// You have a royalty-free right to use, modify, reproduce and distribute
// the Sample Custom Control Files (and/or any modified version) in any way
// you find useful, provided that you agree that Microsoft has no warranty,
// obligation or liability for any Custom Control File.
//---------------------------------------------------------------------------
// winsrv.h
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Change these for each new VBX file
//---------------------------------------------------------------------------
#define VBX_COMPANYNAME            "DESY\0"
#define VBX_FILEDESCRIPTION        "Visual Basic RPC Server\0"
#define VBX_INTERNALNAME           "Srv\0"
#define VBX_LEGALCOPYRIGHT         "Copyright \251 Microsoft Corp. 1991-93\0"
#define VBX_LEGALTRADEMARKS        "Microsoft\256 is a registered trademark of Microsoft Corporation. Visual Basic\231 is a trademark of Microsoft Corporation. Windows\231 is a trademark of Microsoft Corporation.\0"
#define VBX_ORIGINALFILENAME       "WINSRV.VBX\0"
#define VBX_PRODUCTNAME            "Microsoft\256 Visual Basic\231 for Windows\231\0"

//---------------------------------------------------------------------------
// Update these fields for each build.
//---------------------------------------------------------------------------
#define VBX_VERSION                 3,00,0,00
#define VBX_VERSION_STR            "3.00.000\0"

#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Macro for referencing member of structure
//---------------------------------------------------------------------------
#define OFFSETIN(struc,field)     ((USHORT)&(((struc *)0)->field))

#define IMAX              2048
#define ARRMAX            4096

#undef CF_TEXT
#define CF_DOUBLE   512
#define CF_UINT16   513
#define CF_SHORT    513
#define CF_INTEGER  513
#define CF_UINT8    514
#define CF_BYTE     514
#define CF_UINT32   515
#define CF_INT4     515
#define CF_LONG     515
#define CF_TEXT     516
#define CF_FLOAT    517
#define CF_POCALBLK 518
#define CF_STRUCT   519
#define CF_CHAR8    520
#define CF_STRING8  520
#define CF_CHAR16   521
#define CF_STRING16 521
#define CF_CHAR16FI 522
#define CF_BIT      523
#define CF_HITTS    524

#define CF_NULL     767

#define IPX             0x01
#define SPX             0x02
#define TCP             0x04
#define UDP             0x08

#define illegal_size           200
//#define ERR_BADINDEX           381
#define ERR_PF                 32000

//---------------------------------------------------------------------------
 // Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export SrvCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


//---------------------------------------------------------------------------
// Srv control data and structs
//---------------------------------------------------------------------------
typedef struct tagSRV
{
    HSZ         ClientAddress;
    HSZ         ClientName;
    HSZ         ExportName;
    HSZ         EqpName;
    HSZ         Property;
    WORD        EqpNumber;
    SHORT       Status;
    LONG        RAddress;
    LONG        WAddress;
    SHORT       RWSize;
    WORD        RSize;
    WORD        WSize;
    SHORT       EqpIndex;
    SHORT       EqpFormat;
    LONG        EqpTime;
    SHORT       EqpNumModules;
    BOOL        EqpEnabled;     // was short !!
    HSZ         Caption;
    LONG        PacketSize;
    HSZ         ContactName;
    SHORT       Register;
    SHORT       PacketFormat;
    SHORT       EqNumber;
    HSZ         ErrorString;
    LONG        EqpSend;
    LONG        EqpRecv;
    HSZ         EqpDeviceName;
} SRV;

typedef SRV FAR * LPSRV;

#define LpSRVDEREF(hctl)       ((LPSRV)VBDerefControl(hctl))

CHAR szRPCTypes[] = "0 - WriteRead\0"\
		    "1 - Read\0"\
		    "";

CHAR szRPCenabled[] = "0 - False\0"\
		      "1 - True\0"\
		      "";
CHAR szRPCFormats[] = "0 - DOUBLE\0"\
		      "1 - INTEGER\0"\
		      "2 - BYTE\0"\
		      "3 - LONG\0"\
		      "4 - SHORT\0"\
		      "5 - FLOAT\0"\
		      "6 - STRUCT\0"\
		      "7 - STRING8\0"\
		      "8 - TEXT\0"\
		      "";


//---------------------------------------------------------------------------
// Property info
//---------------------------------------------------------------------------
PROPINFO Property_ClientAddress =
{
    "ClientAddress",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, ClientAddress), 0,
    0,
    NULL, 0
};

PROPINFO Property_ClientName =
{
    "ClientName",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, ClientName), 0,
    0,
    NULL, 0
};

PROPINFO Property_ExportName =
{
    "ExportName",
    DT_HSZ | PF_fGetData | PF_fSaveData | PF_fSetMsg | PF_fSetData,
    OFFSETIN(SRV, ExportName), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqpName =
{
    "EqpName",
    DT_HSZ | PF_fGetData | PF_fSaveData | PF_fSetMsg | PF_fSetData,
    OFFSETIN(SRV, EqpName), 0,
    0,
    NULL, 0
};

PROPINFO Property_Property =
{
    "Property",
    DT_HSZ | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, Property), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqpNumber =
{
    "EqpNumber",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, EqpNumber), 0,
    0,
    NULL, 0
};

PROPINFO Property_RWSize =
{
    "RWSize",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, RWSize), 0,
    0,
    NULL, 0
};

PROPINFO Property_RSize =
{
    "RSize",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, RSize), 0,
    0,
    NULL, 0
};

PROPINFO Property_WSize =
{
    "WSize",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, WSize), 0,
    0,
    NULL, 0
};

PROPINFO Property_Status =
{
    "Status",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fNoShow,
    OFFSETIN(SRV, Status), 0,
    0,
    NULL, 0
};

PROPINFO Property_RAddress =
{
    "RAddress",
    DT_LONG | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, RAddress), 0,
    0,
    NULL, 0
};

PROPINFO Property_WAddress =
{
    "WAddress",
    DT_LONG | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, WAddress), 0,
    0,
    NULL, 0
};
PROPINFO Property_EqpIndex =
{
    "EqpIndex",
    DT_SHORT | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, EqpIndex), 0,
    0,
    NULL, 0
};
PROPINFO Property_EqpFormat =
{
    "EqpFormat",
    DT_SHORT | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, EqpFormat), 0,
    0,
    NULL, 0
};
PROPINFO Property_EqpTime =
{
    "EqpTime",
    DT_LONG | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, EqpTime), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqpNumModules =
{
    "EqpNumModules",
    DT_SHORT | PF_fGetData | PF_fSaveData | PF_fSetData,
    OFFSETIN(SRV, EqpNumModules), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqpEnabled     =
{
    "Enabled",
    DT_BOOL | PF_fGetData | PF_fSetMsg,
    OFFSETIN(SRV, EqpEnabled), 0,
    0,
    NULL, 0
};

PROPINFO Property_Caption =
{
    "Caption",
    DT_HSZ | PF_fGetData | PF_fSaveData | PF_fNoShow | PF_fSetData,
    OFFSETIN(SRV, Caption), 0,
    0,
    NULL, 0
};

PROPINFO Property_PacketSize =
{
    "PacketSize",
    DT_LONG | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, PacketSize), 0,
    0,
    NULL, 0
};

PROPINFO Property_ContactName =
{
    "ContactName",
    DT_HSZ | PF_fGetData | PF_fSaveData | PF_fNoShow | PF_fSetData,
    OFFSETIN(SRV, ContactName), 0,
    0,
    NULL, 0
};

PROPINFO Property_Register =
{
    "Register",
    DT_SHORT | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, Register), 0,
    0,
    NULL, 0
};

PROPINFO Property_PacketFormat =
{
    "PacketFormat",
    DT_SHORT | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, PacketFormat), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqNumber =
{
    "EqNumber",
    DT_SHORT | PF_fSetData | PF_fGetData | PF_fNoShow,
    OFFSETIN(SRV, EqNumber), 0,
    0,
    NULL, 0
};

PROPINFO Property_ErrorString =
{
    "ErrorString",
    DT_HSZ | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, ErrorString), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqpSend =
{
    "EqpSend",
    DT_LONG | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, EqpSend), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqpRecv =
{
    "EqpRecv",
    DT_LONG | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, EqpRecv), 0,
    0,
    NULL, 0
};

PROPINFO Property_EqpDeviceName =
{
    "EqpDeviceName",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fNoShow,
    OFFSETIN(SRV, EqpDeviceName), 0,
    0,
    NULL, 0
};
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_SRV_CTLNAME              0
#define IPROP_SRV_BACKCOLOR            1
#define IPROP_SRV_LEFT                 2
#define IPROP_SRV_TOP                  3
#define IPROP_SRV_WIDTH                4
#define IPROP_SRV_HEIGHT               5
#define IPROP_SRV_VISIBLE              6
#define IPROP_SRV_PARENT               7
#define IPROP_SRV_DRAGMODE             8
#define IPROP_SRV_DRAGICON             9
#define IPROP_SRV_TAG                 10
#define IPROP_SRV_HWND                11
#define IPROP_SRV_INDEX               12

#define IPROP_SRV_CLIENTADDRESS       13
#define IPROP_SRV_CLIENTNAME          14
#define IPROP_SRV_EXPORTNAME          15
#define IPROP_SRV_EQPNAME             16
#define IPROP_SRV_PROPERTY            17
#define IPROP_SRV_EQPNUMBER           18
#define IPROP_SRV_STATUS              19
#define IPROP_SRV_RADDRESS            20
#define IPROP_SRV_WADDRESS            21
#define IPROP_SRV_RWSIZE              22
#define IPROP_SRV_RSIZE               23
#define IPROP_SRV_WSIZE               24
#define IPROP_SRV_EQPINDEX            25
#define IPROP_SRV_EQPFORMAT           26
#define IPROP_SRV_EQPTIME             27
#define IPROP_SRV_EQPNUMMODULES       28
#define IPROP_SRV_EQPENABLED          29

#define IPROP_SRV_CAPTION             30
#define IPROP_SRV_PACKETSIZE          31
#define IPROP_SRV_CONTACTNAME         32
#define IPROP_SRV_REGISTER            33
#define IPROP_SRV_PACKETFORMAT        34
#define IPROP_SRV_EQNUMBER            35
#define IPROP_SRV_ERRORSTRING         36
#define IPROP_SRV_EQPSEND             37
#define IPROP_SRV_EQPRECV             38
#define IPROP_SRV_EQPDEVICENAME       39

PPROPINFO SRV_Properties[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFTNORUN,
    PPROPINFO_STD_TOPNORUN,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TAG,
    PPROPINFO_STD_HWND,
    PPROPINFO_STD_INDEX,
    &Property_ClientAddress,
    &Property_ClientName,
    &Property_ExportName,
    &Property_EqpName,
    &Property_Property,
    &Property_EqpNumber,
    &Property_Status,
    &Property_RAddress,
    &Property_WAddress,
    &Property_RWSize,
    &Property_RSize,
    &Property_WSize,
    &Property_EqpIndex,
    &Property_EqpFormat,
    &Property_EqpTime,
    &Property_EqpNumModules,
    &Property_EqpEnabled,
    &Property_Caption,
    &Property_PacketSize,
    &Property_ContactName,
    &Property_Register,
    &Property_PacketFormat,
    &Property_EqNumber,
    &Property_ErrorString,
    &Property_EqpSend,
    &Property_EqpRecv,
    &Property_EqpDeviceName,
    NULL
};
//---------------------------------------------------------------------------
// Event info
//---------------------------------------------------------------------------
WORD ParamTypes_EqpFcn[] = {ET_HLSTR,ET_HLSTR,ET_I4,ET_I4,ET_I2};

typedef struct tagEqpFcnParams  // note reverse order !! (PASCAL)
{
  int  far *access;
  long far *inArrayLen;
  long far *outArrayLen;
  HLSTR devProperty;
  HLSTR devName;
  LPVOID Index;
} EQPFCNPARAMS;

EVENTINFO Event_Receive =
{
    "Receive",
    0,
    0,
    NULL,
    NULL
};

EVENTINFO Event_Send =
{
    "Send",
    0,
    0,
    NULL,
    NULL
};

EVENTINFO Event_EqpFcn =
{
    "EqpFcn",
    5,
    10,
    ParamTypes_EqpFcn,
    "devName As String, devProperty As String, outArrayLen As Long, inArrayLen As Long, devAccess As Integer"
};

//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define IEVENT_SRV_EQPFCN              0
#define IEVENT_SRV_RECEIVE             1

PEVENTINFO SRV_Events[] =
{
  &Event_EqpFcn,
  &Event_Receive,
  NULL
};

//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
MODEL modelSRV =
{
  VB_VERSION,                         // VB version being used
  MODEL_fInvisAtRun,                     // MODEL flags
  (PCTLPROC)SrvCtlProc,               // Control procedure
  CS_VREDRAW | CS_HREDRAW,            // Class style
  WS_BORDER,                          // Default Windows style
  sizeof(SRV),                        // Size of SRV structure
  IDBMP_LSN,                          // Palette bitmap ID
  "Eqp",                            // Default control name
  "Srv",                            // Visual Basic class name
  NULL,                               // Parent class name
  SRV_Properties,                  // Property information table
  SRV_Events,                      // Event information table
  IPROP_SRV_CTLNAME,                 // Default property
  IEVENT_SRV_EQPFCN,                // Default event
  IPROP_SRV_CTLNAME                // Property representing value of ctl
};

#endif  // RC_INVOKED

//---------------------------------------------------------------------------
