#include "project.def"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <winsock.h>
#include <wsipx.h>
#include <wsnwlink.h>
#include "errors.h"
#include "database.h"
#include "rpcsrv.h"
#ifdef USE_SHARED_MEMORY
# include "mmfshare.h"
#else
# include "rpcalloc.h"
#endif

#define LOINT(l)       ((int)(l))
#define HIINT(l)       ((int)(((long)(l) >> 16) & 0xFFFF))
#define MAX(a,b)       ((a) > (b) ? a : b)

extern int IPXloaded;
extern char *erlst[],txtbuf[128];
extern void soperror(char  *txt);
extern int TCPGetResource(void);
extern int TCPFreeResource(void);
extern short PASCAL FILLSTRUCT (char *tag, short addr, short size, short fmt);
int useLoopback = FALSE;

int GetAddressFromNameServer(char *context,char *name,char *fecname,int *rpcindex);
int GetAddressFromNameFile(char *context, char *name,char *fecname,int *rpcindex);

unsigned int HexToDec(char  *str)
{
	int i,d;
	unsigned int off,value;

	off=1;value=0;
	for (i=strlen(str)-1;i>=0;i--)
	{
		if (str[i]>='A') d=str[i]-'A'+10;else d=str[i]-'0';
		value=value+off*d;
		off=off*16;
	}
	return value;
}
char *strtrm(char *s)
{
  char str[516],*c=str;
  unsigned int len;
  int done0=0,done1=0;
  if (s == NULL || (len=strlen(s)) == 0 || len > 512) return s;
  if (s[len-1] == '\n') s[len-1] = 0;
  strncpy(c,s,512); c[512] = 0;
  for (len=strlen(c); len > 0 && len < 512; len=strlen(c))
  {
    if (c[len-1] == ' ' || c[len-1] == '\t' || c[len-1] == '\n') c[len-1] = 0; else done1 = TRUE;
    if (c[0] == ' ' || c[0] == '\t') c++; else done0 = TRUE;
    if (done0 && done1) break;
  }
  if (strlen(s) != len) 
  {
    if (len > 0) 
    {
      strncpy(s,c,len);
      s[len] = 0;
    }
    else s[0] = 0;
  }
  return s;
}
int GetDataBaseSize(char *filename)
{
	FILE *fp;
	static char str[256];
	int lines = -1;                         // assume one line of header

	if ((fp=fopen(filename,"r")) == NULL) return -no_such_file;
	while (fgets(str,255,fp) != NULL)          // scan file      
	{
    strtrm(str);
    if (strlen(str) == 0) continue;          /* carriage return */
	  if (strchr("%;#",str[0])) continue;      // comment line(s) 
	  lines++;
	}

	fclose(fp);
	return lines;
}
void trim(char *str)
{
	while (strstr(str," ") == str) str++;
	str[strcspn(str," ")] = '\0';
	return;
}

void BytesToHex(BYTE *b,char *s,int n)
{
	int v;

	while (n--)
	{
		*s++ = (v = (*b&0xf0)>>4) < 10 ? '0' + v : 'A' + v - 10;
		*s++ = (v = *b++&0xf) < 10 ? '0' + v : 'A' + v - 10;
	}
	*s = 0;
	strrev(s);
	return;
}
void HextoBytes(char *s,BYTE *b,int nibs)
{
	char buf[20];
	int l,i;

	if ((l=strlen(s)) < nibs)
	{
		strrev(s); strncat(s,"000000000000",nibs-l);
		strrev(s);
	}
	for (i=0; i<nibs/2; i++)
	{
		strncpy(buf,&s[i*2],2); buf[2] = 0;
		b[i] = (unsigned char)strtol(buf,NULL,16);
	}
}

char ControlDBpath[80];
BYTE zero[6] = {0,0,0,0,0,0};
RPCDataStruct *RPCData, NameServerData;
RPCFecStruct *RPCFec = NULL, *NameServer = NULL;
int numNameServers = 0,curNameServer = 0;
char RPCDatabaseFullName[80];
char FECDatabaseFullName[80];
char NameServerPath[80];

int RPCallocNum = 0,FECallocNum=0;
int NameServerLoaded = 0;
int RPCNumFecsKeep = 0, RPCNumRecsKeep = 0;

void flushFecRpcCache(void)
{
	RPCNumFecsRead = RPCNumFecsKeep;
	RPCNumRecsRead = RPCNumRecsKeep;
	memset(&RPCFec[RPCNumFecsRead],0,(FECallocNum-RPCNumFecsRead)*sizeof(RPCFecStruct));
	memset(&RPCData[RPCNumRecsRead],0,(RPCallocNum-RPCNumRecsRead)*sizeof(RPCDataStruct));
}
int fixFecProtocol(int i)
{
  int hWnd;
	if (RPCFec == NULL) return database_not_loaded;
	if (i < 0 || i >= RPCNumFecsRead) return non_existent;

  if (!useLoopback && (getmyipaddr() == RPCFec[i].iaddr || !strncmp(RPCFec[i].IP,LOOPBACKADDR,16)))
  {
		RPCFec[i].Prot = LCL;
    if ((hWnd=(int)FindWindow(RPCFec[i].Name,RPCFec[i].Name)) != (int)NULL)
    {
      memcpy(RPCFec[i].Network,&hWnd,4); // won't need the IPX address anyway
		  return 0;
    }
  }
  if (memcmp(&RPCFec[i].iaddr,zero,4))
	{
		RPCFec[i].Prot = UDP;
		return 0;
	}
	if (*(DWORD *)RPCFec[i].Network != 0)
	{
		if (!IPXloaded) return ipx_not_supported;
		RPCFec[i].Prot = IPX;
		return 0;
	}
	return illegal_protocol;
}
int locateTagName(char *context,char *name,int isInitialRequest)
{
	static char fecname[16];
	int i,cc,rpcidx;
  ElemDataStruct *e = NULL;
	if ((i=GetAddressFromNameServer(context,name,fecname,&rpcidx)) < 0 &&
		(i=GetAddressFromNameFile(context,name,fecname,&rpcidx)) < 0) return i;
	if ((cc=fixFecProtocol(i)) != 0) return -cc;
  if (!isInitialRequest)
  {
    for (e=ElemList; e != NULL; e=e->Next)
    {
      if (!strncmp(e->ElemName,name,16) && e->FecIndex != i) // it's moved !
      {
        strncpy(e->FecName,fecname,16);
        e->FecIndex = i;
      }
    }
  }
	return rpcidx;
}
int locateFecName(char *fecname)
{
	int i,cc,nullidx;
	if ((i=GetAddressFromNameServer(NULL,NULL,fecname,&nullidx)) < 0 &&
		(i=GetAddressFromNameFile(NULL,NULL,fecname,&nullidx)) < 0) return i;
	if ((cc=fixFecProtocol(i)) != 0) return -cc;
	return i;
}
char lclname[32];
int getRPCDataIndex(char *context,char *name)
{
	int i;

	if (name == NULL || strlen(name) == 0) return -non_existent_elem;
	strncpy(lclname,name,16); lclname[16] = 0;
	if (NameServerLoaded && !strcmp(lclname,CSHOSTS)) return 0;
	for (i=0; i<RPCNumRecsRead; i++)
	{
		if (context != NULL && strlen(context) && strcmp(context,"DEFAULT") &&
			strncmp(RPCData[i].Context,context,16)) continue;
		if (!strncmp(RPCData[i].FullName,lclname,16)) return i;
	}
	return locateTagName(context,lclname,TRUE);
}
int getRPCFecIndex(char *fecname)
{
	int i;

	if (fecname == NULL || strlen(fecname) == 0) return -non_existent_fec;
	for (i=0; i<RPCNumFecsRead; i++)
	  if (!strncmp(RPCFec[i].Name,fecname,16)) return i;
	return locateFecName(fecname);
}
int findcol(char  *str,char  *tag)
{
  char *c;
  int i,len;

  for (i=0,c=str; strlen(c); i++,c++)
  {
    while (*c == '\"') { c = strchr(++c,'\"'); if (c++ == NULL) return -1; }
    while (*c == ' ') c++;
    strupr(c);
    len = strcspn(c,",\n"); while (c[len-1] == ' ') len--;
    if (!strncmp(c,tag,MAX(len,(int)strlen(tag)))) return i;
    if ((c=strpbrk(c,",\n")) == NULL) return -1;
  }
  return -1;
}
char *colptr(int col,char *str)
{
	static char buf[48];
	char *c;
    int i,sslen;

	for (i=0,c=str; i < col && strlen(c); i++,c++)
	{
		while (*c == '\"') { c = strchr(++c,'\"'); if (c++ == NULL) return NULL; }
		if ((c=strpbrk(c,",")) == NULL) return NULL;
	}
    while (*c == ' ') c++;
    if (*c == '\"') sslen = strcspn(++c,"\"");
    else sslen = strcspn(c,",\n");
    while (sslen > 0 && c[sslen-1] == ' ') sslen--;
    strncpy(buf,c,i=MIN(sizeof(buf)-1,sslen));
    buf[i] = 0;
	return buf;
}
int namcmp(char *name,char  *str,int col,UINT32 limit)
{
	char *c = colptr(col,str);
	int n =	MAX(limit,strcspn(c,",\n"));
	return strncmp(name,c,n);
}
__declspec(dllexport) short PASCAL GETRPCFECINFO(char *fecname,RPCFecStruct *rpcfec)
{
  DBLK dout;
  char devname[64];

  dout.dArrayLength = sizeof(RPCFecExStruct);
  dout.dFormat = CF_TEXT;
  memset(dout.dTag,0,8);
  sprintf(devname,"%s/%s",CSHOSTS,"FEC.EXT");
  return dllExecLinkEx(devname,fecname,&dout,rpcfec,NULL,NULL,CA_READ,500);
}
__declspec(dllexport) short PASCAL GETRPCFECDATA
  (
    char *context,char *expname,char *eqm, char *fecname,short *almsys,
    char *ipxaddr, char *macaddr, char *ipaddr, short *portoffset
  )
{
  static BYTE buf[sizeof(RPCDataStruct)+sizeof(RPCFecStruct)];
  RPCDataStruct *rpcdata = (RPCDataStruct *)buf;
  RPCFecStruct rpcfec;
  int cc = 0;
  DBLK dout;
  char devname[64];
  char cntxt[17];
   
  if (context != NULL) strncpy(cntxt,context,16);
  if (strlen(cntxt) == 0) sprintf(cntxt,"#2");
  dout.dFormat = CF_STRUCT;
  dout.dArrayLength = RPCFECSTRUCT_SIZE+RPCDATASTRUCT_SIZE;
  memset(dout.dTag,0,8);
  sprintf(devname,"%s/%s",CSHOSTS,cntxt);
  cc = dllExecLinkEx(devname,expname,&dout,buf,NULL,NULL,CA_READ,500);
//  cc = tExecLink(0,CSHOSTS,cntxt,expname,RPCFECSTRUCT_SIZE+RPCDATASTRUCT_SIZE,(char *)buf,CF_STRUCT,500);
  if (cc) ccerr(cc);
  memcpy(&rpcfec,&buf[RPCDATASTRUCT_SIZE],RPCFECSTRUCT_SIZE);
  if (context != NULL && strlen(context) == 0) strncpy(context,rpcdata->Context,16);
  if (eqm != NULL) strncpy(eqm,rpcdata->EqName,6);
  if (fecname != NULL) strncpy(fecname,rpcdata->FecName,16);
  if (almsys != NULL) *almsys = rpcdata->alarmSystem;
//  if (ipxaddr != NULL) sprintf(ipxaddr,"%x",*((int *)rpcfec.Network));
  if (ipxaddr != NULL) strncpy(ipxaddr,ipxnet_ntoa(rpcfec.Network,4),16);
  if (macaddr != NULL) strncpy(macaddr,ipxnet_ntoa(rpcfec.Node,6),16);
  if (ipaddr != NULL) strncpy(ipaddr,rpcfec.IP,16);
  if (portoffset != NULL) *portoffset = GetPortOffset(&rpcfec); 
err:
  return cc;
}
__declspec(dllexport) short PASCAL GetHostFromFecName(char *fecname,char *hostname)
{
  int i, len = 4,cc=0;
  struct hostent *hst;

  if ((i=getRPCFecIndex(fecname)) < 0) ccerr(-i);
  if ((hst=gethostbyaddr((char *)&RPCFec[i].iaddr,len,AF_INET)) == NULL) ccerr(host_not_resolved);
  strcpy(hostname,hst->h_name);
err:
  return cc;
}
int GetAddressFromNameServer(char *context,char *expname,char *fecname,int *rpcindex)
{
  static BYTE buf[sizeof(RPCDataStruct)+sizeof(RPCFecStruct)];
  RPCDataStruct *rpcdata = (RPCDataStruct *)buf;
  static int retry = 0;
  int n,i,j,cc = 0;
  DBLK dout;
  char cntxt[17] = "";

  *rpcindex = -1;
  if (!NameServerLoaded || retry-- > 0) return -not_ready;
  for (n=0; n<numNameServers; n++)
  {
    if (expname == NULL)                  /* resolve fecname only */
    {
      if (fecname == NULL || strlen(fecname) == 0) ccerr(non_existent_fec);
      for (i=0; i<RPCNumFecsRead && strcmp(RPCFec[i].Name,fecname); i++);
      if (i < RPCNumFecsRead && RPCFec[i].Prot) return i;
      retry = 2;                         /* in case the Name Server hangs */
      cc = tRPC(0,CSHOSTS,1,fecname,RPCFECSTRUCT_SIZE,(char *)buf,CF_STRUCT,500);
      if (cc != link_not_open) retry = 0; /* Name Server was there */
      if (cc) ccerr(cc);
      for (i=0; i<RPCNumFecsRead && strncmp(fecname,RPCFec[i].Name,16); i++);
      if (i == RPCNumFecsRead)
      {
        if (RPCNumFecsRead < FECallocNum) RPCNumFecsRead++;
        else ccerr(buffer_too_small);
        if (debug)
        {
          sprintf(txtbuf,"ENS: added FEC %s to local database\n",fecname);
          output(txtbuf);
        }
      }
      memcpy(&RPCFec[i],buf,RPCFECSTRUCT_SIZE);
      break;
    }
    else                               /* resolve both expname and fecname */
    {
      if (strlen(expname) == 0) return -non_existent_elem;
      for (j=0; j<RPCNumRecsRead; j++)
      {
        if (context != NULL && strlen(context) > 0 && 
            strcmp(context,"DEFAULT") && strncmp(context,RPCData[j].Context,16)) continue;
        if (!strncmp(expname,RPCData[j].FullName,16)) break;
      }
      *rpcindex = j;
      if (j < RPCNumRecsRead)
      {
        for (i=0; i<RPCNumFecsRead && strcmp(RPCData[j].FecName,RPCFec[i].Name); i++);
        if (i < RPCNumFecsRead && RPCFec[i].Prot) goto err;
      }
      retry = 2;                         /* in case the Name Server hangs */
      if (context != NULL) strncpy(cntxt,context,16);
      if (strlen(cntxt) == 0) sprintf(cntxt,"#2");
      dout.dFormat = CF_STRUCT;
      dout.dArrayLength = RPCFECSTRUCT_SIZE+RPCDATASTRUCT_SIZE;
      memset(dout.dTag,0,8);
      cc = tExecLink(0,CSHOSTS,cntxt,expname,RPCFECSTRUCT_SIZE+RPCDATASTRUCT_SIZE,(char *)buf,CF_STRUCT,500);
      if (cc) ccerr(cc);
      for (i=0; i<RPCNumRecsRead; i++)
        if (!strncmp(RPCData[i].FecName,rpcdata->FecName,16) && 
            !strncmp(RPCData[i].EqName,rpcdata->EqName,6)) break;
      if (i == RPCNumRecsRead)
      {
        if (RPCNumRecsRead < RPCallocNum) RPCNumRecsRead++;
        else ccerr(buffer_too_small);
      }

      memcpy(&RPCData[i],buf,RPCDATASTRUCT_SIZE);

      if (j == RPCNumRecsRead)    // must be an alias ...
      {
        memcpy(&RPCData[j],buf,RPCDATASTRUCT_SIZE);
        if (RPCNumRecsRead < RPCallocNum) RPCNumRecsRead++;
        else ccerr(buffer_too_small);
      }

      strncpy(fecname,RPCData[i].FecName,16);
      for (i=0; i<RPCNumFecsRead && strncmp(fecname,RPCFec[i].Name,16); i++);
      if (i == RPCNumFecsRead)
      {
        if (RPCNumFecsRead < FECallocNum) RPCNumFecsRead++;
        else ccerr(buffer_too_small);
        if (debug)
        {
          sprintf(txtbuf,"ENS: added EQM %s FEC %s to local database\n",expname,fecname);
          output(txtbuf);
        }
      }
      if (i > 0) 
      {
        memcpy(&RPCFec[i],&buf[RPCDATASTRUCT_SIZE],RPCFECSTRUCT_SIZE);
        RPCFec[i].MaxRPCProt = 0; RPCFec[i].Prot = 0;
      }
err: 
      if (cc != link_not_open) retry = 0; /* Name Server was there */
      if (!cc) break;
      if (cc == buffer_too_small) return -cc;
      curNameServer = (++curNameServer) % numNameServers;
      memcpy(RPCFec,&NameServer[curNameServer],sizeof(RPCFecStruct));
      strncpy(RPCData[0].FecName,NameServer[curNameServer].Name,16);
    }
  }
  return cc ? -cc : i;
}
__declspec(dllexport) short PASCAL GETENS(char *name,char *addr)
{
  if (NameServerLoaded)
  {
    strncpy(name,NameServer[curNameServer].Name,16);
    strncpy(addr,NameServer[curNameServer].IP,16);
  }
  else
  {
    strncpy(name,"LOCAL FILE",16);
    strncpy(addr,ControlDBpath,48);
  }
  return numNameServers;
}
int GetAddressFromNameFile(char *context,char *srvname,char *fecname,int *rpcindex)
{
  FILE  *fp=NULL;
  DWORD haddr;
  int i,cc=0,done=0,col;
  UINT16 poff;
  char *c,str[256],hdr[256],scratch[17],name[17],cntxt[17];

  if (fecname == NULL) ccerr(non_existent_fec);
  if (srvname == NULL) goto acquireFecName;     /* only interested in FEC address*/
  strncpy(scratch,srvname,16);
  c = scratch;
  for (c=scratch; *c == ' '; c++);  // remove leading blanks
  for (i=strlen(c); i > 0 && c[i] == ' '; i--); if (i >= 0) c[i] = 0;
  strncpy(name,c,16);
  *rpcindex = -1;
  if (strlen(name) == 0) ccerr(non_existent_elem);
  if ((fp=fopen(RPCDatabaseFullName,"r")) == NULL) ccerr(no_such_file);
  cc = non_existent_elem;
  for (done=0; fgets(str,255,fp) != NULL;)   /* scan file       */
  {
    strtrm(str);
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strncpy(hdr,str,255);
      if ((col=findcol(hdr,"NAME")) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }
    if (!namcmp(name,str,col,16))               /* found entry in file */
    {
      cntxt[0] = 0;
      if ((col=findcol(hdr,"CONTEXT")) >= 0) 
      {
        c = colptr(col,str);
        strncpy(cntxt,c,16);
      }
      if (context != NULL && strlen(context) && strcmp(context,"DEFAULT"))
      {
        if (strncmp(context,cntxt,16)) continue;
      }
      for (i=0; i<RPCNumRecsRead && strncmp(name,RPCData[i].FullName,16); i++);
      if (i == RPCNumRecsRead)
      {
        if (RPCNumRecsRead < RPCallocNum) RPCNumRecsRead++;
        else ccerr(buffer_too_small);
        if (debug)
        {
          sprintf(txtbuf,"EFL: added FEC %s to local database\n",fecname);
          output(txtbuf);
        }
      }
      strncpy(RPCData[i].FullName,colptr(col,str),ELEM_NAME_SIZE);
      if ((col=findcol(hdr,"FECNAME")) < 0) ccerr(no_such_line);
      strncpy(RPCData[i].FecName,colptr(col,str),FEC_NAME_SIZE);
      strncpy(fecname,RPCData[i].FecName,FEC_NAME_SIZE);
      if ((col=findcol(hdr,"EQPMODULE")) < 0) ccerr(no_such_line);
      strncpy(RPCData[i].EqName,colptr(col,str),EQNAME_SIZE);
      strncpy(RPCData[i].Context,cntxt,CONTEXT_SIZE);
      cc = 0;
      *rpcindex = i;
      break;
    }
 	}
  fclose(fp);
  if (cc) ccerr(cc);
acquireFecName:
  cc = non_existent_fec;
  if (strlen(fecname) == 0) ccerr(cc);
  for (i=0; i<RPCNumFecsRead && strcmp(RPCFec[i].Name,fecname); i++);
  if (i < RPCNumFecsRead && RPCFec[i].Prot) return i;
  if ((fp=fopen(FECDatabaseFullName,"r")) == NULL) ccerr(no_such_file);
  for (done=0; fgets(str,255,fp) != NULL;)   /* scan file       */
  {
    strtrm(str);
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strncpy(hdr,str,255);
      if ((col=findcol(hdr,"FECNAME")) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }
    if (!namcmp(fecname,str,col,16))           /* found entry in file */
    {
      for (i=0; i<RPCNumFecsRead && strncmp(fecname,RPCFec[i].Name,16); i++);
      if (i == RPCNumFecsRead)
      {
        if (RPCNumFecsRead < FECallocNum) RPCNumFecsRead++;
        else ccerr(buffer_too_small);
        if (debug)
        {
          sprintf(txtbuf,"EFL: added EQM %s FEC %s to local database\n",name,fecname);
          output(txtbuf);
        }
      }
      strncpy(RPCFec[i].Name,colptr(col,str),FEC_NAME_SIZE);
      if ((col=findcol(hdr,"FECNETWORK")) < 0) ccerr(no_such_line);
      strncpy(scratch,colptr(col,str),16);
      HextoBytes(scratch,RPCFec[i].Network,8);
      if ((col=findcol(hdr,"FECNODE")) < 0) ccerr(no_such_line);
      strncpy(scratch,colptr(col,str),16);
      HextoBytes(scratch,RPCFec[i].Node,12);
      if ((col=findcol(hdr,"IPADDR")) < 0) ccerr(no_such_line);
      strncpy(RPCFec[i].IP,colptr(col,str),16);
      if ((haddr = inet_addr(RPCFec[i].IP)) == INADDR_NONE) haddr = 0L;
      memcpy(&RPCFec[i].iaddr,&haddr,4);
      if ((col=findcol(hdr,"PORTOFFSET")) >= 0)
      {
        strncpy(scratch,colptr(col,str),16);
        poff = atoi(scratch);
        RPCFec[i].Port[0] = poff&0xff;
        RPCFec[i].Port[1] = (poff>>8)&0xff;
        RPCFec[i].PortOffset = (BYTE)poff;
      }
      else RPCFec[i].PortOffset = 0;
      cc = 0;
      break;
    }
 	}

err: 
  if (fp) fclose(fp);
  return cc ? -cc : i;
}
__declspec(dllexport) short GetContextsFromFile(NAME16 *contexts,int *bufsiz)
{
  FILE  *fp=NULL;
  int i=0,j,n,cc=0,done=0,con_col;
  char str[256],hdr[256],scratch[17];

  if (strlen(RPCDatabaseFullName) == 0) initDataBase();
  if (strlen(RPCDatabaseFullName) == 0) ccerr(database_not_loaded);
  if ((fp=fopen(RPCDatabaseFullName,"r")) == NULL) ccerr(no_such_file);
  n = *bufsiz;
  for (done=0; fgets(str,255,fp) != NULL;)   /* scan file       */
  {
    strtrm(str);
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strncpy(hdr,str,255);
      if ((con_col=findcol(hdr,"CONTEXT")) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }
    strncpy(scratch,colptr(con_col,str),16);
    for (j=0; j<i && strncmp(scratch,contexts[j].name,16); j++);
    if (j < i) continue;
    strncpy(contexts[i].name,scratch,16);
    if (++i > n) break;
  }
  *bufsiz = i;
  fclose(fp);
  if (cc) ccerr(cc);
err:
  return cc;
}
__declspec(dllexport) short GetDeviceServersFromFile(NAME16 *context,NAME16 *servers,int *bufsiz)
{
  FILE  *fp=NULL;
  int i=0,n,cc=0,done=0,nam_col;
  char str[256],hdr[256];
  
  if (strlen(RPCDatabaseFullName) == 0) initDataBase();
  if (strlen(RPCDatabaseFullName) == 0) ccerr(database_not_loaded);
  if ((fp=fopen(RPCDatabaseFullName,"r")) == NULL) ccerr(no_such_file);
  n = *bufsiz;
  for (done=0; fgets(str,255,fp) != NULL;)   /* scan file       */
  {
    strtrm(str);
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strncpy(hdr,str,255);
      if ((nam_col=findcol(hdr,"NAME")) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }
    strncpy(servers[i].name,colptr(nam_col,str),16);
    if (++i > n) break;
  }
  *bufsiz = i;
  fclose(fp);
  if (cc) ccerr(cc);
err:
  return cc;
}
int GetAllocSizesFromNameServer(int *RPCsize,int *FECsize)
{
  FILE  *fp=NULL;
  DWORD haddr;
  int cc=0,done=0,i,siz;
  int nam_col,net_col,node_col,ip_col,poff_col;
  UINT16 poff;
  char str[256],hdr[256],scratch[16];

  if (!NameServerLoaded)
  {
    siz = GetDataBaseSize(NameServerPath);
    if ((fp=fopen(NameServerPath,"r")) == NULL) 
    {
      NameServerPath[0] = 0;  // get rid of this in '99
      strcat(NameServerPath,ControlDBpath); strcat(NameServerPath,"herans.csv");
      if ((fp=fopen(NameServerPath,"r")) == NULL) ccerr(no_such_file);
      siz = GetDataBaseSize(NameServerPath);
    }
    if (siz <= 0) ccerr(file_error);
    if ((NameServer=(RPCFecStruct *)calloc(siz,sizeof(RPCFecStruct))) == NULL)
      ccerr(out_of_local_memory);
    for (i=0; fgets(str,255,fp) != NULL && i<siz;)/* scan file       */
    {
      strtrm(str);
      if (strlen(str) == 0) continue;          /* carriage return */
      if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
      if (!done)
      {
        strncpy(hdr,str,255);
        if ((nam_col=findcol(hdr,"FECNAME")) < 0) ccerr(no_such_line);
        if ((net_col=findcol(hdr,"FECNETWORK")) < 0) ccerr(no_such_line);
        if ((node_col=findcol(hdr,"FECNODE")) < 0) ccerr(no_such_line);
        if ((ip_col=findcol(hdr,"IPADDR")) < 0) ccerr(no_such_line);
        poff_col = findcol(hdr,"PORTOFFSET");
        done = 1;
        continue;
      }
      strncpy(NameServer[i].Name,colptr(nam_col,str),FEC_NAME_SIZE);
      strncpy(scratch,colptr(net_col,str),16);
      HextoBytes(scratch,NameServer[i].Network,8);
      strncpy(scratch,colptr(node_col,str),16);
      HextoBytes(scratch,NameServer[i].Node,12);
      strncpy(NameServer[i].IP,colptr(ip_col,str),16);
      haddr = inet_addr(NameServer[i].IP);
      memcpy(&NameServer[i].iaddr,&haddr,4);
      if (poff_col >= 0)
      {
        strncpy(scratch,colptr(poff_col,str),16);
        poff = atoi(scratch);
        NameServer[i].Port[0] = poff&0xff;
        NameServer[i].Port[1] = (poff>>8)&0xff;
        NameServer[i].PortOffset = (BYTE)poff;
      }
      else NameServer[i].PortOffset = 0;
      NameServer[i].Prot = UDP;
      i++;
    }
    numNameServers = siz;
    fclose(fp);
    RPCFec = &NameServer[0];
    RPCNumRecsRead = RPCNumFecsRead = 1;  /* Hardwire first call */
    if ((cc=fixFecProtocol(0)) != 0) ccerr(cc);
    strncpy(NameServerData.FecName,NameServer[0].Name,FEC_NAME_SIZE);
    strncpy(NameServerData.FullName,CSHOSTS,ELEM_NAME_SIZE);
    strncpy(NameServerData.EqName,CSHOSTS,EQNAME_SIZE);
    RPCData = &NameServerData;
    NameServerLoaded = 1;
  }
  *RPCsize =  *FECsize = MAX_ENTRIES;
err: if (fp) fclose(fp);
  return cc;
}

int GetAllocSizesFromNameFile(int  *RPCsize,int  *FECsize)
{
	int size;

	if ((size=GetDataBaseSize(RPCDatabaseFullName))<0) return -size;
	if (size == 0) return un_allocated;
	*RPCsize = size;

	if ((size=GetDataBaseSize(FECDatabaseFullName))<0) return -size;
	if (size == 0) return un_allocated;
	*FECsize = size;

	return 0;
}
__declspec(dllexport) short PASCAL SetUseLoopback(short loopbackValue)
{
  useLoopback = loopbackValue ? TRUE : FALSE;
  return (short)useLoopback;
}
int initDataBase(void)
{
	char  *ptr;
	int i;
	static int dbaseloaded = 0;
	if (dbaseloaded) return 0;

	if ((ptr=getenv("USE_LOOPBACK")) != NULL) if (!stricmp(ptr,"TRUE")) useLoopback = TRUE;
	ControlDBpath[0] = NameServerPath[0] = RPCDatabaseFullName[0] = FECDatabaseFullName[0] = 0;
	if ((ptr=getenv("TINE.HOME")) != NULL || (ptr=getenv("CONTROLDB")) != NULL) 
	{
	  strncpy(ControlDBpath,ptr,80);
	  if (((i=strlen(ControlDBpath)) > 0) && (ControlDBpath[i-1] != '\\'))
	  { 
        ControlDBpath[i] = '\\'; ControlDBpath[i+1] = 0;
	  }
	}
	strcat(NameServerPath,ControlDBpath); strcat(NameServerPath,CSHOSTS_FILE);
	strcat(RPCDatabaseFullName,ControlDBpath); strcat(RPCDatabaseFullName,EQPDB_FILE);
	strcat(FECDatabaseFullName,ControlDBpath); strcat(FECDatabaseFullName,FECDB_FILE);

	if (GetAllocSizesFromNameServer(&RPCallocNum,&FECallocNum) &&
			GetAllocSizesFromNameFile(&RPCallocNum,&FECallocNum))
		return database_not_loaded;

	if (!RPCallocNum || !FECallocNum) return un_allocated;

	if (!(RPCData=calloc(RPCallocNum,sizeof(RPCDataStruct))))
		return out_of_client_memory;

	if (!(RPCFec=calloc(FECallocNum,sizeof(RPCFecStruct))))
		return out_of_client_memory;

  if (NameServerLoaded)
	{
	  memcpy(RPCData,&NameServerData,sizeof(RPCDataStruct));
	  memcpy(RPCFec,&NameServer[0],sizeof(RPCFecStruct));
	}

	dbaseloaded = 1;
	return 0;
}

char BroadcastDBaseFullName[80];
int loadGlobalsDBase(void)
{
  int cc=0,i,n,fmt,done=0;
  int keycol,fmtcol,sizcol,percol;
  FILE  *fp = NULL;
  char *ptr,str[256],hdr[256],scratch[17];

  if (strlen(ControlDBpath) == 0)
  {
    ControlDBpath[0] = 0;
    if ((ptr=getenv("TINE.HOME")) != NULL || (ptr=getenv("CONTROLDB")) != NULL) 
      strncpy(ControlDBpath,ptr,60);
    if (((i=strlen(ControlDBpath)) > 0) && (ControlDBpath[i-1] != '\\'))
    {  
      ControlDBpath[i] = '\\'; ControlDBpath[i+1] = 0;
    }
  }
  strncpy(BroadcastDBaseFullName,ControlDBpath,68);
  strcat(BroadcastDBaseFullName,"NGLOBALS.CSV");
  if ((n=GetDataBaseSize(BroadcastDBaseFullName)) > 0)
  {
    if ((fp=fopen(BroadcastDBaseFullName,"r")) == NULL) ccerr(no_such_file);
    if (!(GlobalList=calloc(n,sizeof(GlobalListStruct)))) ccerr(out_of_client_memory);
    for (done=0,i=0; fgets(str,255,fp) != NULL && i<n;)   /* scan file       */
    {
      strtrm(str);
      if (strlen(str) == 0) continue;          /* carriage return */
      if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
      if (!done)
      {
        strncpy(hdr,str,255);
        if ((keycol=findcol(hdr,"KEYWORD")) < 0) ccerr(no_such_line);
        if ((fmtcol=findcol(hdr,"FORMAT")) < 0) ccerr(no_such_line);
        if ((sizcol=findcol(hdr,"SIZE")) < 0) ccerr(no_such_line);
        if ((percol=findcol(hdr,"PERIOD_MAX")) < 0) ccerr(no_such_line);
        done = 1;
        continue;
      }
      strncpy(GlobalList[i].keyword,colptr(keycol,str),16);
      strncpy(scratch,colptr(fmtcol,str),16); strupr(scratch);
      if ((fmt=ftoi(scratch)) == CF_NULL) fmt = atoi(scratch); // historical
      GlobalList[i].format = fmt;
      strncpy(scratch,colptr(sizcol,str),16);
      GlobalList[i].size = atoi(scratch);
      strncpy(scratch,colptr(percol,str),16);
      GlobalList[i].heartbeat = atoi(scratch);
      i++;
    }
  }
  else if (n < 0) cc = -n;
err: 
  if (fp != NULL) fclose(fp);
  if (cc)
  {
    sprintf(txtbuf,"%s : %s",BroadcastDBaseFullName,erlst[cc]);
    OutputToDebugFile("loadGlobalsDBase",txtbuf);
  }
  return cc ? -cc : n;
}
int subnetcmp(char *addr1,char *addr2)
{
  char *c1,*c2,a1[17],a2[17];

  strncpy(a1,addr1,16); strncpy(a2,addr2,16);
  if ((c1 = strtok(a1,".")) == NULL) return -1;
  if ((c1 = strtok(NULL,".")) == NULL) return -1;
  if ((c1 = strtok(NULL,".")) == NULL) return -1;
  if ((c2 = strtok(a2,".")) == NULL) return -1;
  if ((c2 = strtok(NULL,".")) == NULL) return -1;
  if ((c2 = strtok(NULL,".")) == NULL) return -1;
  return strcmp(c1,c2);
}
int checkNet(char *myipaddr)
{
  int cc=0,i,n,done=0,col;
  FILE  *fp = NULL;
  char *ptr,str[256],hdr[256],scratch[17],IPnetsFullName[80];

  if (strlen(ControlDBpath) == 0)
  {
    ControlDBpath[0] = 0;
    if ((ptr=getenv("TINE.HOME")) != NULL || (ptr=getenv("CONTROLDB")) != NULL) 
      strncpy(ControlDBpath,ptr,60);
    if (((i=strlen(ControlDBpath)) > 0) && (ControlDBpath[i-1] != '\\'))
    {  
      ControlDBpath[i] = '\\'; ControlDBpath[i+1] = 0;
    }
 	}
  strncpy(IPnetsFullName,ControlDBpath,60);
  strcat(IPnetsFullName,IPMCASTNETS_FILE);
  if ((n=GetDataBaseSize(IPnetsFullName)) >= 0)
  {
    if (n == 0) ccerr(0);
    // nets which can't receive multicasts
    if ((fp=fopen(IPnetsFullName,"r")) == NULL) goto check_bcast;
    for (done=0,i=0; fgets(str,255,fp) != NULL && i<n; )
    {
      strtrm(str);
      if (strlen(str) == 0) continue;          /* carriage return */
      if (strchr("%;#\n",str[0])) continue;
      if (!done)
      {
        strncpy(hdr,str,255);
        if ((col=findcol(hdr,"SUBNET")) < 0) ccerr(no_such_line);
        done = 1;
        continue;
      }
      strncpy(scratch,colptr(col,str),16);
      if (!subnetcmp(scratch,myipaddr)) goto check_bcast; // on a net which can't get the multi-casts
      i++;
    }
    ccerr(0);  // control net match
  }
check_bcast:
  if (fp) fclose(fp);
  strncpy(IPnetsFullName,ControlDBpath,60);
  strcat(IPnetsFullName,IPBCASTNETS_FILE);
  if ((n=GetDataBaseSize(IPnetsFullName)) < 0)
  {
    strncpy(IPnetsFullName,ControlDBpath,60);
    strcat(IPnetsFullName,IPNETS_FILE);
    if ((n=GetDataBaseSize(IPnetsFullName)) < 0) ccerr(-n);
  }
  if (n > 0)
  {
    if ((fp=fopen(IPnetsFullName,"r")) == NULL) ccerr(no_such_file);
    for (done=0,i=0; fgets(str,255,fp) != NULL && i<n; )
    {
      strtrm(str);
      if (strlen(str) == 0) continue;          /* carriage return */
      if (strchr("%;#\n",str[0])) continue;
      if (!done)
      {
        strncpy(hdr,str,255);
        if ((col=findcol(hdr,"SUBNET")) < 0) ccerr(no_such_line);
        done = 1;
        continue;
      }
      strncpy(scratch,colptr(col,str),16);
      if (!subnetcmp(scratch,myipaddr)) ccerr(0);  // control net match
      i++;
    }
 	}
  cc = 512;
   
err:
  if (fp) fclose(fp);
  return cc ? 0 : 1;
}
short reformatData(void *dst,short dstfmt,unsigned short dstsiz,void *src,short srcfmt,unsigned short srcsiz)
{
  int i;
  short dsize;

  if (dstsiz < 1) return dimension_error;
  if (dstfmt == srcfmt) 
  {
    dsize = MIN(dstsiz,srcsiz) * fmtsizeof(dstfmt);
    memcpy(dst,src,dsize);
    return 0;
  }

  switch (dstfmt)
  {
    case CF_SHORT: 
      switch (srcfmt)
      {
        case CF_LONG:  for (i=0; i<dstsiz && i<srcsiz; i++) ((short *)dst)[i] = (short)((long *)src)[i]; return 0;
        case CF_FLOAT: for (i=0; i<dstsiz && i<srcsiz; i++) ((short *)dst)[i] = (short)((float *)src)[i]; return 0;
        case CF_DOUBLE:for (i=0; i<dstsiz && i<srcsiz; i++) ((short *)dst)[i] = (short)((double *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_LONG:
      switch (srcfmt)
      {
        case CF_SHORT: for (i=0; i<dstsiz && i<srcsiz; i++) ((long *)dst)[i] = (long)((short *)src)[i]; return 0;
        case CF_FLOAT: for (i=0; i<dstsiz && i<srcsiz; i++) ((long *)dst)[i] = (long)((float *)src)[i]; return 0;
        case CF_DOUBLE:for (i=0; i<dstsiz && i<srcsiz; i++) ((long *)dst)[i] = (long)((double *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_FLOAT:
      switch (srcfmt)
      {
        case CF_SHORT: for (i=0; i<dstsiz && i<srcsiz; i++) ((float *)dst)[i] = (float)((short *)src)[i]; return 0;
        case CF_LONG:  for (i=0; i<dstsiz && i<srcsiz; i++) ((float *)dst)[i] = (float)((long *)src)[i]; return 0;
        case CF_DOUBLE:for (i=0; i<dstsiz && i<srcsiz; i++) ((float *)dst)[i] = (float)((double *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_DOUBLE:
      switch (srcfmt)
      {
        case CF_SHORT: for (i=0; i<dstsiz && i<srcsiz; i++) ((double *)dst)[i] = (double)((short *)src)[i]; return 0;
        case CF_LONG:  for (i=0; i<dstsiz && i<srcsiz; i++) ((double *)dst)[i] = (double)((long *)src)[i]; return 0;
        case CF_FLOAT: for (i=0; i<dstsiz && i<srcsiz; i++) ((double *)dst)[i] = (double)((float *)src)[i]; return 0;
        default: return illegal_format;
      }
    case CF_NAME8: 
      switch (srcfmt)
      {
        case CF_NAME16: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char *)dst)[i*8],&((char *)src)[i*16],8); return 0;
        case CF_NAME32: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char *)dst)[i*8],&((char *)src)[i*32],8); return 0;
        case CF_TEXT:   if (srcsiz < 8) return illegal_format;
          strncpy((char *)dst,(char *)src,8); 
          return 0;
        default: return illegal_format;
      }
    case CF_NAME16: 
      switch (srcfmt)
      {
        case CF_NAME8: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char *)dst)[i*16],&((char *)src)[i*8],8); return 0;
        case CF_NAME32: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char *)dst)[i*16],&((char *)src)[i*32],16); return 0;
        case CF_TEXT:   if (srcsiz < 16) return illegal_format;
          strncpy((char *)dst,(char *)src,16); 
          return 0;
        default: return illegal_format;
      }
    case CF_NAME32: 
      switch (srcfmt)
      {
        case CF_NAME8: for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char *)dst)[i*32],&((char *)src)[i*8],8); return 0;
        case CF_NAME16:for (i=0; i<dstsiz && i<srcsiz; i++) strncpy(&((char *)dst)[i*32],&((char *)src)[i*16],16); return 0;
        case CF_TEXT:   if (srcsiz < 32) return illegal_format;
          strncpy((char *)dst,(char *)src,32); 
          return 0;
        default: return illegal_format;
      }
    case CF_TEXT: 
      switch (srcfmt)
      {
        case CF_NAME8: for (i=0; i<dstsiz/8 && i<srcsiz; i++) strncpy(&((char *)dst)[i*8],&((char *)src)[i*8],8); return 0;
        case CF_NAME16:for (i=0; i<dstsiz/16 && i<srcsiz; i++) strncpy(&((char *)dst)[i*16],&((char *)src)[i*16],16); return 0;
        case CF_NAME32:for (i=0; i<dstsiz/32 && i<srcsiz; i++) strncpy(&((char *)dst)[i*32],&((char *)src)[i*16],32); return 0;
        default: return illegal_format;
      }
    default: return illegal_format;
 	}
  return 0;
}
short ftoi(char *fmt)
{
  short ifmt;
  strupr(fmt);
  if ((ifmt=getSimpleFormatType(fmt)) != CF_NULL) return ifmt;
  return getCompoundFormatType(fmt);
}
UINT16 GetPortOffset(RPCFecStruct *f)
{
  UINT16 poff;
  poff = (f->Port[1] << 8) | f->Port[0];
  if (poff == 0) poff = f->PortOffset;
  return poff;
}
int _datcmp(char *d1,char *d2,int dsz,short fmt,DataToleranceFactor *dtf)
{
  int i,n;
  float delta = 0.0, epsilon = 0.0;

  if (dtf == NULL) return memcmp(d1,d2,dsz);
  if (fmt < CF_DOUBLE || fmt > CF_FLOAT || fmt == CF_TEXT) return memcmp(d1,d2,dsz);
  n = dsz/fmtsizeof(fmt);
  switch (fmt)
  {
    case CF_DOUBLE:
      for (i=0; i<n; i++) 
      {
        delta = (float)fabs(((double *)d1)[i] - ((double *)d2)[i]);
        epsilon = (float)fabs(dtf->percent * ((double *)d2)[i]) + dtf->absolute;
        if (delta > epsilon) return TRUE;
      }
      break;
    case CF_FLOAT:
      for (i=0; i<n; i++) 
      {
        delta = (float)fabs(((float *)d1)[i] - ((float *)d2)[i]);
        epsilon = (float)fabs(dtf->percent * ((float *)d2)[i]) + dtf->absolute;
        if (delta > epsilon) return TRUE;
      }
      break;
    case CF_SHORT:
      for (i=0; i<n; i++) 
      {
        delta = (float)abs(((short *)d1)[i] - ((short *)d2)[i]);
        epsilon = (float)abs((int)(dtf->percent * (float)((short *)d2)[i])) + dtf->absolute;
        if (delta > epsilon) return TRUE;
      }
      break;
    case CF_LONG:
      for (i=0; i<n; i++) 
      {
        delta = (float)abs(((int *)d1)[i] - ((int *)d2)[i]);
        epsilon = (float)abs((int)(dtf->percent * (float)((int *)d2)[i])) + dtf->absolute;
        if (delta > epsilon) return TRUE;
      }
      break;
    case CF_BYTE:
    default:
      return memcmp(d1,d2,dsz);
  }
  return FALSE;
}
