#include <winsock.h>
#include <wsipx.h>
#include <wsnwlink.h>
#include "mmfshare.h"

HANDLE hSharedKeys = NULL;
BYTE *SharedKeys;
extern int thisUsage;
SECURITY_ATTRIBUTES mmfSA;

HANDLE mmfalloc(char *tag,int SizeInBytes,BYTE **lpView,int *mmfFlag)
{
  HANDLE hFileMap;
  int MMFattached = 0;
  char msg[80];
  static int done = 0;

  if (!done)
  {
    done = TRUE;
    mmfSA.nLength = sizeof(mmfSA);
    mmfSA.lpSecurityDescriptor = NULL;
    mmfSA.bInheritHandle = TRUE;
  }

  if (tag == NULL || strlen(tag) == 0) return NULL;
  if ((hFileMap=CreateFileMapping(hSHARE,&mmfSA,PAGE_READWRITE,0,SizeInBytes,tag)) != NULL)
  {
    MMFattached = (GetLastError() == ERROR_ALREADY_EXISTS);
    if ((*lpView=(BYTE *)MapViewOfFile(hFileMap,FILE_MAP_READ|FILE_MAP_WRITE,0,0,0)) == NULL)
    {
      sprintf(msg,"mmfalloc error: %s (%x)",tag,GetLastError());
      MessageBox(NULL,msg,"",IDOK);
      CloseHandle(hFileMap);
      return NULL;
    }
  }
  if (mmfFlag) *mmfFlag = MMFattached;
  return hFileMap;
}

int mmfInit(void)
{
  int MMFattached=0;
  char msg[80];
  if ((hSharedKeys=mmfalloc(SharedKeysTag,SHARED_KEYS_SIZE,&SharedKeys,&MMFattached)) == NULL)
  {
    sprintf(msg,"shm error: %s",SharedKeysTag);
    MessageBox(NULL,msg,"",IDOK);
    return out_of_shared_memory;
  }
  usageCount++;
  return 0;
}
ElemDataStruct *shmContractAlloc(char *tag,int sizeIn,int sizeOut,HANDLE *hContract)
{
  ElemDataStruct *e = NULL;
  int contractSize,MMFattached=0;
  char msg[80];

  contractSize = sizeof(ElemDataStruct) + sizeIn + sizeOut;

  if ((*hContract=mmfalloc(tag,contractSize,(BYTE **)&e,&MMFattached)) == NULL)
  {
    sprintf(msg,"shm error: %s",tag);
    MessageBox(NULL,msg,"",IDOK);
    *hContract = 0;
    return NULL;
  }
  return e;
}
void shmContractFree(ElemDataStruct *e,HANDLE hContract)
{
  if (hContract == 0) return;
  UnmapViewOfFile(e);
  CloseHandle(hContract);
}
int shmSndDataGram(HANDLE hWnd,char *tag,BYTE *data,int size,HANDLE *h)
{
  shmDataGram *dg = NULL;
  int cc,rsize,MMFattached=0;
  char *c,msg[80];
  HANDLE hThisWnd;

  if ((c=strchr(tag,':')) == NULL) return -1; c++;
  hThisWnd = (void *)atoi(c);
  rsize = sizeof(shmDataGram) + size;

  if ((*h=mmfalloc(tag,rsize,(BYTE **)&dg,&MMFattached)) == NULL)
  {
    sprintf(msg,"shmSndDataGram error: %s (%x)",tag,GetLastError());
    MessageBox(NULL,msg,"",IDOK);
    *h = 0;
    return -1;
  }
  dg->payload = (BYTE *)dg + 28;
  memcpy(dg->payload,data,size);
  dg->size = size;
  dg->dirty = TRUE;
  memcpy(dg->dataTag,username,16);
  cc = SendMessage(hWnd,WM_READ_LCL,size,(long)hThisWnd);
  if (MMFattached) shmFreeDataGram(dg,*h);
  return cc;
}
shmDataGram *shmGetDataGram(char *tag,int size,HANDLE *h)
{
  shmDataGram *dg = NULL;
  int rsize,MMFattached=0;
  char msg[80];

  rsize = sizeof(shmDataGram) + size;

  if ((*h=mmfalloc(tag,rsize,(BYTE **)&dg,&MMFattached)) == NULL)
  {
    sprintf(msg,"shmGetDataGram error: %s (%x)",tag,GetLastError());
    MessageBox(NULL,msg,"",IDOK);
    *h = 0;
    return NULL;
  }
  dg->payload = (BYTE *)dg + 28;
  return dg;
}
void shmFreeDataGram(shmDataGram *dg,HANDLE h)
{
  if (h == 0) return;
  UnmapViewOfFile(dg);
  CloseHandle(h);
}
BYTE *shmDataBlockAlloc(char *tag,int size,HANDLE *hBlock)
{
  BYTE *d = NULL;
  int MMFattached=0;
  char msg[80];

  if ((*hBlock=mmfalloc(tag,size,&d,&MMFattached)) == NULL)
  {
    sprintf(msg,"shm error: %s",tag);
    MessageBox(NULL,msg,"",IDOK);
    *hBlock = 0;
    return NULL;
  }
  return d;
}
void shmDataBlockFree(BYTE *d,HANDLE hBlock)
{
  if (hBlock == 0) return;
  UnmapViewOfFile(d);
  CloseHandle(hBlock);
}
LCLCONTRACT *lclShmContractAlloc(char *tag,HANDLE *hContract)
{
  LCLCONTRACT *lc = NULL;
  int MMFattached=0;
  char msg[80];

  if ((*hContract=mmfalloc(tag,sizeof(LCLCONTRACT),(BYTE **)&lc,&MMFattached)) == NULL)
  {
    sprintf(msg,"shm error: %s",tag);
    MessageBox(NULL,msg,"",IDOK);
    *hContract = 0;
    return NULL;
  }
  return lc;
}
void lclShmContractFree(LCLCONTRACT *lc,HANDLE hContract)
{
  if (hContract == 0) return;
  UnmapViewOfFile(lc);
  CloseHandle(hContract);
}
