#ifndef _MMFSHARE_H_
#define _MMFSHARE_H_
#include "project.def"
#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <time.h>
#include "errors.h"
#include "database.h"
#include "rpcsrv.h"

#ifndef RPCALLOC_H_
#define hSHARE ((HANDLE)0xffffffff)
#define SharedKeysTag "EQPSharedKeys"
#define SHARED_KEYS_SIZE (4*sizeof(int) +\
			  sizeof(HANDLE) +\
			  sizeof(LCLCONTRACT) +\
			  sizeof(linkType)*MAXHOTLINKS)
extern HANDLE hSharedKeys;
extern BYTE *SharedKeys;
#define usageCount  (*(int *)SharedKeys)
#define nglobals    (*(int *)(SharedKeys + sizeof(int)))
#define SyncID      (*(int *)(SharedKeys + 2*sizeof(int)))
#define debug       (*(int *)(SharedKeys + 3*sizeof(int)))
#define hDLLWnd     (*(HANDLE *)(SharedKeys + 4*sizeof(int)))
#define lclContract ((LCLCONTRACT *)(SharedKeys + 4*sizeof(int) + sizeof(HANDLE)))
#define link        ((linkType *)(SharedKeys + 4*sizeof(int) + sizeof(HANDLE) + sizeof(LCLCONTRACT)))
#endif

extern char username[17];
#define WM_READ_LCL        (WM_USER+100)

typedef struct 
{
  char dataTag[16];
  int  dirty;
  int  size;
  BYTE *payload;
} shmDataGram;

HANDLE mmfalloc(char *tag,int SizeInBytes,BYTE **lpView,int *mmfFlag);
int mmfInit(void);
ElemDataStruct *shmContractAlloc(char *tag,int sizeIn,int sizeOut,HANDLE *hContract);
BYTE *shmDataBlockAlloc(char *tag,int size,HANDLE *hBlock);
LCLCONTRACT *lclShmContractAlloc(char *tag,HANDLE *hContract);
void shmContractFree(ElemDataStruct *e,HANDLE hContract);
void shmDataBlockFree(BYTE *d,HANDLE hBlock);
void lclShmContractFree(LCLCONTRACT *lc,HANDLE hBlock);
shmDataGram *shmGetDataGram(char *tag,int size,HANDLE *h);
int shmSndDataGram(HANDLE hWnd,char *tag,BYTE *data,int size,HANDLE *h);
void shmFreeDataGram(shmDataGram *dg,HANDLE h);

#ifndef RPCALLOC_H_
#define ContractAlloc(tag,sizeIn,sizeOut,hContract) shmContractAlloc(tag,sizeIn,sizeOut,hContract)
#define DataBlockAlloc(tag,size,hBlock) shmDataBlockAlloc(tag,size,hBlock)
#define lclContractAlloc(tag,hContract) lclShmContractAlloc(tag,hContract)
#define ContractFree(e,hContract) shmContractFree(e,hContract)
#define DataBlockFree(d,hBlock) shmDataBlockFree(d,hBlock)
#define lclContractFree(lc,hContract) lclShmContractFree(lc,hContract)
#endif 

#endif // _MMFSHARE_H_

