#include "project.def"
#include <stdio.h>
#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <sys/timeb.h>
#include <time.h>
#include <wsipx.h>
#include <wsnwlink.h>
#include "MeteredSection.h"
#include "errors.h"
#include "database.h"
#include "rpcsrv.h"
#ifndef USE_SHARED_MEMORY
# include "rpcalloc.h"
#endif
#include "mmfshare.h"

#define soerr(s)	{strcat(txtbuf,s); goto err;}

extern HANDLE hWatchdogWnd;
extern time_t RPCtimestamp;
extern int nUDPsets;
extern int ControlNet;
extern char *erlst[],txtbuf[128];
extern char username[17];
extern int IPXloaded;
extern int EngineShuttingDown;
extern int TCPGetResource(void);
extern int TCPFreeResource(void);
extern int thisUsage,thisUsageMsec;
extern int initialized;
char RPCLastErrorString[PREFIX+RPCERR_SIZE];
char RPCLastErrorSource[PREFIX+RPCERR_SIZE];
extern FILE *fpDebugFile;
int TCPloaded = 0;
struct fd_set rwset;
struct timeval fec_to = { 0, 500000 };
struct fd_set *conset,udpset,ipxset,brdset;
extern int SyncSocket;
extern WORD ASYsocket,CNSsocket;
BYTE reg_socket[2] = {REG_SOCKET,REG_SOCKET};
extern SOCKET IPXConsumerSocket;
extern SOCKET IPXMCastConsumerSocket;

int SystemSupressHeartbeatNotification = FALSE;
int gtUDPPort = UDP_PORT;
int gtTCPPort = TCP_PORT;
int gtGCastPort = GCAST_PORT;
int gtMCastPort = MCAST_PORT;
int gtUCPClnPort = UDP_CLN_PORT;
char *gtMCastAddr = MCAST_ADDR;
char *gtGCastAddr = GCAST_ADDR;
int gtMCastTTL = MCAST_TTL;

__declspec(dllexport) void PASCAL T_setSupressHeartbeatNofification(int value)
{
  SystemSupressHeartbeatNotification = value;
}
__declspec(dllexport) short PASCAL T_setSrvUDPPort(int port)
{
  if (port < 1024) return not_allowed;
  gtUDPPort = port;
  return 0;
}
__declspec(dllexport) short PASCAL T_setSrvTCPPort(int port)
{
  if (port < 1024) return not_allowed;
  gtTCPPort = port;
  return 0;
}
__declspec(dllexport) short PASCAL T_setSrvGCastPort(int port)
{
  if (port < 1024) return not_allowed;
  gtGCastPort = port;
  return 0;
}
__declspec(dllexport) short PASCAL T_setSrvMCastPort(int port)
{
  if (port < 1024) return not_allowed;
  gtMCastPort = port;
  return 0;
}
__declspec(dllexport) short PASCAL T_setSrvMCastAddr(char *addr)
{
  if (addr == NULL || strncmp(addr,"238.",4)) return not_allowed;
  if ((gtMCastAddr=(char *)malloc(strlen(addr)+1)) == NULL) return out_of_local_memory;
  strcpy(gtMCastAddr,addr);
  return 0;
}
__declspec(dllexport) short PASCAL T_setSrvGCastAddr(char *addr)
{
  if (addr == NULL || strncmp(addr,"238.",4)) return not_allowed;
  if ((gtGCastAddr=(char *)malloc(strlen(addr)+1)) == NULL) return out_of_local_memory;
  strcpy(gtGCastAddr,addr);
  return 0;
}
__declspec(dllexport) short PASCAL setSrvMCastTTL(int ttl)
{
  if (ttl < 1 || ttl > 64) return not_allowed;
  gtMCastTTL = ttl;
  return 0;
}

ElemDataStruct *ElemList = NULL;

int TimerPeriod = SYSTEM_DELAY;
int breakingFactor = 10;
int gRPCSyncNotify = FALSE;

extern RPCDataStruct  *RPCData;
extern RPCFecStruct    *RPCFec;
extern HANDLE hRPCData, hRPCFec;
extern char lpszSubSemaphore[128];

#define DATABLOCKNAME "EqpDataInBlock"
#define CONTRACTNAME  "EqpLocalContract"
char shmDataTag[80], shmConTag[80];

UINT32 so_snderrcnt = 0;
UINT32 cln_retrycnt = 0;
UINT32 cln_illegal_idcnt = 0;
UINT32 cln_illegal_protocolcnt = 0;
UINT32 cln_stalecnt = 0;
UINT32 cln_wrong_starttimecnt = 0;
UINT32 cln_partial_blockcnt = 0;
UINT32 cln_phantom_blockcnt = 0;
UINT32 cln_bad_alignmentcnt = 0;
UINT32 cln_size_mismatchcnt = 0;
UINT32 cln_numsynccalls = 0;
UINT32 cln_legacynumsynccalls = 0;

int RPCNumRecsRead=0,
	RPCNumFecsRead=0,
	RPCNumEqpsRead=0;

char clientaddr[17];

void output(char *txt);
int RPCConnect(int size, HANDLE hElemPointer,WORD *connectionID);
void RPCSend(int size, HANDLE hElemStart, WORD connectionID);
void RPCReceive(int size,HANDLE hElemStart,WORD connectionID);
void DoRPC(void);
void RemoveRPC(int ID);
ElemDataStruct *CancelElem(ElemDataStruct *Elem);
int locateFecName(char *fecname);
int locateTagName(char *context,char *name,int isInitialRequest);
int getRPCFecIndex(char *fecname);
int getRPCDataIndex(char *context,char *name);
int ReleaseRPCSemaphore(HANDLE hSem);
void CloseRPCSemaphore(HANDLE hSem);
int getNextLinkID(short id);

HCURSOR WaitCurs;
BYTE *msgbuf;
char strbuf[256];

REDIRECTED_LINK *RedirectedLinkList = NULL;

#define MAX_IDLE_CONNECTIONS 256
typedef struct
{
  int idx;
  int sck;
  int ttl;
} IDLE_CONNECTION;
IDLE_CONNECTION IdleConnections[MAX_IDLE_CONNECTIONS];
int nIdleConnections = 0;

void RemoveIdleConnection(int n)
{
  int i;
  if (n < 0 || n > nIdleConnections-1) return;
  nIdleConnections--;
  for (i=n; i<nIdleConnections; i++)
    IdleConnections[i] = IdleConnections[i+1];
}
void AddIdleConnection(int sck,int idx)
{
  int i;
  for (i=0; i<nIdleConnections; i++) 
    if (IdleConnections[i].sck == sck && IdleConnections[i].idx == idx) break;
  if (i < nIdleConnections) return; // already in table
  if (i == MAX_IDLE_CONNECTIONS) return; // can't mark as idle
  IdleConnections[i].sck = sck;
  IdleConnections[i].idx = idx;
  IdleConnections[i].ttl = 300000; // 5 minutes in milliseconds
  nIdleConnections++;
  return;
}

REDIRECTED_LINK *appendRedirectedLinkList(char *con,char *srv,char *prp,char *dev,char *dstsrv,char *dstprp)
{
  REDIRECTED_LINK *r;
  if ((r=(REDIRECTED_LINK *)calloc(1,sizeof(REDIRECTED_LINK))) == NULL) return NULL;
  strncpy(r->srcContext,con,16);
  strncpy(r->srcServerName,srv,16);
  strncpy(r->srcProperty,prp,32);
  strncpy(r->srcDeviceName,dev,32);
  strncpy(r->dstServerName,dstsrv,16);
  if (strlen(dstprp) > 0) strncpy(r->dstProperty,dstprp,32);
  else strncpy(r->dstProperty,prp,32);
  r->nxt = RedirectedLinkList;
  if (RedirectedLinkList != NULL) RedirectedLinkList->prv = r;
  RedirectedLinkList = r;
  sprintf(strbuf,"append /%s/%s/%s/%s -> /%s/%s/%s/%s to redirection table",
    con,srv,prp,dev,con,dstsrv,r->dstProperty,dev);
  messageLog(strbuf,0);
  if (debug) { strcat(strbuf,"\n"); output(strbuf); }
  return r;
}
int removeRedirectedLink(REDIRECTED_LINK *r,int cc)
{
  sprintf(strbuf,"removing /%s/%s/%s/%s from redirection table",
    r->srcContext,r->dstServerName,r->dstProperty,r->srcDeviceName);
  messageLog(strbuf,cc);
  if (r->prv != NULL) r->prv->nxt = r->nxt;
  else if (r == RedirectedLinkList) RedirectedLinkList = r->nxt;
  free(r);
  return 0;
}
int redirectLink(char *con,char *srv,char *prp,char *dev)
{
  REDIRECTED_LINK *r=NULL;

  for (r=RedirectedLinkList; r != NULL; r = r->nxt)
  {
    if (strncmp(r->srcContext,con,16)) continue;
    if (strncmp(r->srcServerName,srv,16)) continue;
    if (strncmp(r->srcProperty,prp,32)) continue;
    if (strncmp(r->srcDeviceName,dev,32)) continue;
    strncpy(srv,r->dstServerName,16);
    strncpy(prp,r->dstProperty,32);
    if (debug)
    {
      sprintf(strbuf,"redirecting /%s/%s/%s/%s -> /%s/%s/%s/%s from redirection table",
       r->srcContext,r->srcServerName,r->srcProperty,dev,
       r->srcContext,r->dstServerName,r->dstProperty,dev);
      OutputToDebugFile("redirectLink",strbuf);
    }
    return -1;
  }
  return 0;
}

WORD IntSwap(WORD w) { return ((w>>8)|(w<<8)); }

int GetErrno(void);
int soioctl(int s,long cmd,char *mode);
int soclose(int s);
struct timeval *gettimeofday(struct timeval *t,struct timezone *tz)
{
  struct timeb tb;
  ftime(&tb);
  t->tv_sec  = tb.time;
  t->tv_usec = ((unsigned long)tb.millitm)*1000L;
  return t;
}
void soperror(char *txt)
{
	static char buf[128];
	int cc = WSAGetLastError();
	sprintf(buf,"%s: error %d (%x)\n",(char *)txt,cc,cc);
	output(buf);
	return;
}
extern int debugTargetError;
extern int gMaxDebugTime;
extern char szDebugFile[82];
extern char szDebugFileBak[82];
int gMaxDebugLines = 5000;
void OutputToDebugFile(char *routine, char *txt)
{
  char outputbuffer[512], timestr[48];
  struct timeval tv;
  int len;
  static int filecreated = 0;
  static int lineswritten = 0;

  if (szDebugFile[0] == 0) return;
  gettimeofday(&tv,(struct timezone *)NULL);
  if (!filecreated)
  {
    if ((fpDebugFile=fopen(szDebugFile,"w")) == NULL) return;
    filecreated = -1;
  }
  else
  {
    if ((fpDebugFile=fopen(szDebugFile,"a")) == NULL) return;
  }
  sprintf(outputbuffer,"%s : %s",routine,txt);
  if (outputbuffer[len=(strlen(outputbuffer)-1)] == '\n') outputbuffer[len] = ' ';
  else strcat(outputbuffer," ");
  strncpy(timestr,ctime(&tv.tv_sec),19); 
  sprintf(&timestr[19],".%03d\n",tv.tv_usec/1000);
  strcat(outputbuffer,&timestr[4]);
  fprintf(fpDebugFile,outputbuffer);
  fclose(fpDebugFile); fpDebugFile = NULL;
  lineswritten++;

  if (lineswritten > gMaxDebugLines)
  {
    lineswritten = 0; filecreated = 0;
    remove(szDebugFileBak);
    rename(szDebugFile,szDebugFileBak);
  }
}
#define MESSAGE_LOG_DEPTH 500
typedef struct 
{
  time_t ts;
  int status;
  char msg[128];
} MessageLogType;
MessageLogType rpcmsg[MESSAGE_LOG_DEPTH];
MessageLogPtr = 0;
int messageLog(char *txt,int status)
{
  int cc = 0;
  rpcmsg[MessageLogPtr].ts = time(NULL);
  rpcmsg[MessageLogPtr].status = status;
  strncpy(rpcmsg[MessageLogPtr].msg,txt,128);
  MessageLogPtr = (MessageLogPtr+1) % MESSAGE_LOG_DEPTH;
  if (debug > 2) OutputToDebugFile("messageLog",txt);
  return cc;
}
__declspec(dllexport) void PASCAL ClearMessages(void)
{
	memset( rpcmsg, 0, sizeof(rpcmsg));
	MessageLogPtr = 0;
}
__declspec(dllexport) short PASCAL GetMessages(MessageLogType *mlt,int *nmsg)
{
  short i, j, cc = 0;
  
  if (nmsg == NULL || *nmsg <= 0) ccerr(argument_list_error);
  if (*nmsg > MESSAGE_LOG_DEPTH) *nmsg = MESSAGE_LOG_DEPTH;
  for (i=0; i<*nmsg; i++) 
  {
    j = (MessageLogPtr - 1 - i + MESSAGE_LOG_DEPTH) % MESSAGE_LOG_DEPTH;
    if (rpcmsg[j].ts == mlt[i].ts) return 0; // no change
    strncpy(mlt[i].msg,rpcmsg[j].msg,128);
    mlt[i].ts = rpcmsg[j].ts;
    mlt[i].status = rpcmsg[j].status;
    if (rpcmsg[j].ts == 0) break;
  }
  *nmsg = i;
err:
  return cc;
}

// =================================================
//         network stream data exchange routines
// =================================================
int SendRequest(int size,ElemDataStruct *ElemStart)
{
	int cc=0,fecindex,socket,retrycnt = 1;
	ElemDataStruct *e = ElemStart;

	if (WorkAreaSemaphore) return WorkAreaSemaphore;
	WorkAreaSemaphore = 1;

	fecindex = e->FecIndex;
	PrepRequest(size,ElemStart);

retry:
  switch (RPCFec[fecindex].Prot)
	{
		case   0:
      if (locateFecName(RPCFec[fecindex].Name) < 0) ccerr(link_not_open);
      if (retrycnt-- > 0) goto retry; else ccerr(non_existent_fec);
		case IPX:  
      ccerr(use_stream_transport);
      break;
		case UDP: 
      TCPGetResource();
      if ((socket=connectTCP(TCP_LEGACYPORT,ElemStart)) < 0)
      {
        TCPFreeResource();
        ccerr(-socket);
      }
      TCPSendData(socket);
      cc = getTCPStream(socket);
      TCPFreeResource();
      break;
  }
err: 
  decodeData(cc,size,ElemStart);
  WorkAreaSemaphore = 0;
  return cc;
}
void PrepRequest(int size,ElemDataStruct *ElemStart)
{
	int dsize,i;
	int cnt=sizeof(HeaderStruct),rwflag=size,eqsize=abs(size);
	ElemDataStruct *e = ElemStart;
	HeaderStruct *RPCHeader = (HeaderStruct *)WorkArea;
	EqpInfoStruct *eqp;

	strncpy((LPSTR)RPCHeader->UserName,(LPSTR)username,16);

	RPCHeader->EqpSize = size;
	RPCHeader->Protocol = 1;
	RPCHeader->TotalSize = sizeof(HeaderStruct) + sizeof(EqpInfoStruct)*eqsize;

	if (rwflag<0) for (i=0; i<eqsize; i++)
	{
		dsize = (UINT16)(fmtsizeof(e->formatOut)*MAX(e->sizeOut,e->sizeIn));
		RPCHeader->TotalSize += dsize;
		if (!(e = e->Next)) break;
	}
	e = ElemStart;

	for (i=0; i<eqsize; i++,cnt+=sizeof(EqpInfoStruct))
	{
		eqp = (EqpInfoStruct *)&WorkArea[cnt];
		memcpy(eqp->ElemName,e->ElemName,sizeof(eqp->ElemName));
		memcpy(eqp->EqpModName,e->EqName,sizeof(eqp->EqpModName));
		e->EqNo = atoi(&e->DeviceName[1]);
		eqp->EqpModNo = e->EqNo;
		memcpy(eqp->Property,e->Property,sizeof(eqp->Property));
		eqp->Format   = e->formatOut;
		eqp->DataSize = (short)e->sizeOut;
    if (debug) 
		{
		  sprintf(strbuf,"Request: %s %s %d (%d %d) [%s] (%d ms) <CM_SINGLE>\n",
			  e->ElemName,e->Property,e->EqNo,e->sizeOut,e->formatOut,
			  RPCFec[e->FecIndex].Name,e->PollRate);
		  output(strbuf);
		}
		while (eqsize > 1 && (e=e->Next) != NULL && e->Acquire == 0);
	}
	if (rwflag<0)
	{
		e = ElemStart;
		for (i=0; i<eqsize; i++,cnt+=dsize)
		{
			dsize = MAX(e->sizeOut,e->sizeIn)*fmtsizeof(e->formatOut);
			memcpy(&WorkArea[cnt],rpcDATAIN(e),dsize);
			if (dsize%2) dsize++;                             // 16-bit boundaries
			while (eqsize > 1 && (e=e->Next) != NULL && e->Acquire == 0);
		}
	}
	return;
}

typedef struct tcpbckt
{
  int idx;                  // FEC index
  int sck;                  // TCP connection socket
  int ptr;                  // bucket pointer
  int siz;                  // bucket target size
  BYTE buf[UDP_BUFFER_SIZE];// bucket buffer
  struct tcpbckt *nxt;      // this is a linked list
} TCPBCKT;

TCPBCKT *bcktList = NULL;

TCPBCKT *findBucket(int sck)
{
  TCPBCKT *bckt=NULL;
  for (bckt=bcktList; bckt != NULL && bckt->sck != sck; bckt=bckt->nxt);
  return bckt;
}
TCPBCKT *getBucket(int sck)
{
  TCPBCKT *bckt=NULL;
  for (bckt=bcktList; bckt != NULL; bckt=bckt->nxt)
	if (bckt->sck == sck) return bckt;
  if ((bckt=(TCPBCKT *)calloc(1,sizeof(TCPBCKT))) != NULL)
  {
    bckt->sck = sck;
    bckt->nxt = bcktList;
    bcktList = bckt;
  }
  return bckt;
}
void freeBucket(int sck)
{
  TCPBCKT *bckt,*b;
  if ((bckt=findBucket(sck)) == NULL) return;
  if (bckt == bcktList) bcktList = bckt->nxt;
  else
  {
    for (b=bcktList; b != NULL && b->nxt != bckt; b = b->nxt);
    if (b == NULL || b->nxt == NULL) return;
    b->nxt = bckt->nxt;
  }
  free(bckt);
}

int connectTCP(int port,ElemDataStruct *e)
{
  int sck = 0,sckerr;
  static optval = 1;
  static u_long mode = 1;
  static struct sockaddr_in sck_name;
  time_t interim = time(NULL);
  struct timeval tv0,tv;
  int cc=0,fecindex;
  UINT16 poff;
  char *c;

  fecindex = e->FecIndex;

  if (!TCPloaded) return tcp_not_supported;

  if (!RPCFec[fecindex].iaddr) ccerr(non_existent_fec);
  memset(&sck_name,0,sizeof(sck_name));
  memcpy(&sck_name.sin_addr,&RPCFec[fecindex].iaddr,4);
  sck_name.sin_family=AF_INET;
  poff = GetPortOffset(&RPCFec[fecindex]);
  sck_name.sin_port = htons((UINT16)(port+poff));

  if ((sck=socket(AF_INET,SOCK_STREAM,0)) < 0) ccerr(tcp_socket_error);
//  if (setsockopt(sck,SOL_SOCKET,SO_REUSEADDR,(char *)&optval,sizeof(optval)))
//    ccerr(tcp_socket_error);
  // get maximum buffer size:
  optval = 0x7fff;
//  setsockopt(sck,SOL_SOCKET,SO_RCVBUF,(char *)&optval,sizeof(optval));

  if (soioctl(sck,FIONBIO,(char *)&mode)) ccerr(tcp_socket_error);
  gettimeofday(&tv0,(struct timezone *)NULL);  tv = tv0;
  while (connect(sck,(struct sockaddr *)&sck_name,sizeof(sck_name)) < 0)
  {
    gettimeofday(&tv,(struct timezone *)NULL);
    if (MSECS(tv,tv0) > DEFAULT_TCP_CONNECTION_TIMEOUT) ccerr(connection_timeout);
    if ((sckerr=GetErrno()) == WSAEISCONN) break;
  }
err: 
  if (cc) 
  {
    if (sck > 0) soclose(sck);
    e->TCPsocket = 0;
    sck = 0;
  }
  else
  {
    if (WSAAsyncSelect(sck,hDLLWnd,WM_RCVPKT_TCP,FD_READ|FD_CLOSE)) soerr("select");
  }
  if (debug)
  {
    if (cc == 0)
    {
      if ((c=inet_ntoa(sck_name.sin_addr)) != NULL) strncpy(clientaddr,c,16);
      sprintf(strbuf,"TCP: connecting socket %d to %s\n",sck,clientaddr);
    }
    else 
      sprintf(strbuf,"TCP: connection error -> %s\n",erlst[cc]);
    output(strbuf);
  }
  return cc ? -cc : sck;
}
void TCPSendData(int socket)
{
  int cnt = 0,msgsize,dsize;
  time_t interim = time(NULL);
  char *c;
  struct sockaddr_in IPfec;
  static int IPlen = sizeof(IPfec);

  msgsize = *(short *)WorkArea;
  while (cnt<msgsize && time(NULL) < interim + RPC_TIMEOUT*2)
  {
    if ((dsize=send(socket,(LPSTR)&WorkArea[cnt],msgsize-cnt,0)) > 0)
      cnt += dsize;
    if (debug && (getpeername(socket,(struct sockaddr *)&IPfec,&IPlen) == 0))
    {
      if ((c=inet_ntoa(IPfec.sin_addr)) != NULL) strncpy(clientaddr,c,16);
      sprintf(strbuf,"TCP: %d bytes sent to %s:%d\n",dsize,clientaddr,socket);
      output(strbuf);
    }
  }
  return;
}
int getTCPStream(int socket) // windows TCP sockets are non-blocking
{
  int to=RPC_TIMEOUT*2,d,bytesread=0,cc=0;
  UINT16 msgsize=(UINT16)WorkAreaSize;
  time_t interim = time(NULL);
  struct sockaddr_in IPfec;
  static int IPlen = sizeof(IPfec);
  char *c;

  while (bytesread<msgsize)
  {
    if (time(NULL) > interim+to) ccerr(remitted_data_lost);
    if ((d=recv(socket,(LPSTR)&WorkArea[bytesread],msgsize-bytesread,0)) > 0)
    {
      bytesread += d;
      if (debug && (getpeername(socket,(struct sockaddr *)&IPfec,&IPlen) == 0))
      {
        if ((c=inet_ntoa(IPfec.sin_addr)) != NULL) strncpy(clientaddr,c,16);
        sprintf(strbuf,"TCP: %d bytes received from %s:%d\n",d,clientaddr,socket);
        output(strbuf);
      }
    }
    if ((bytesread > 2) && (msgsize == WorkAreaSize)) // find out the total msgsize
    {
      if ((msgsize = *(UINT16 *)WorkArea) > WorkAreaSize) ccerr(buffer_too_small);
      to = RPC_TIMEOUT + msgsize/3000;
    }
  }

err: soclose(socket);
  return cc;
}
int decodeData(int cc,int size,ElemDataStruct *ElemStart)
{
  int b,el;
  UINT16 datasize,eqsize=abs(size),msgsize = *(short *)WorkArea-sizeof(short);
  ElemDataStruct *e = ElemStart;

  for (b=0,el=0; el<eqsize; el++)
  {
    if (cc) 
    {
      e->CompLoc = 0;
      e->CompCode = cc;
    }
    else
    {
      e->CompLoc = 1;
      e->CompCode = *(short *)&msgbuf[b]; b += 2;
      if (!(cc=e->CompCode) && b+4<=msgsize)
      {
        if (e->formatOut != *(short *)&msgbuf[b]) ccerr(illegal_format);
        b += 2;
        datasize = *(short *)&msgbuf[b]; b += 2;
        if (datasize > e->sizeOut*fmtsizeof(e->formatOut)) ccerr(out_of_range);
        memcpy(rpcDATAOUT(e),&msgbuf[b],datasize); b += datasize;
        if (debug) 
        {
          sprintf(strbuf,"%s %s (%d) [%d bytes (%d)]<%d>\n",
	          e->ElemName,e->Property,e->EqNo,datasize,e->formatOut,cc);
          output(strbuf);
        }
      }
    }
    do
    {
      if (!(e=e->Next)) goto out;
    } while (!e->Acquire);
  }

out: e = ElemStart;
  for (el=0; el<eqsize; el++)
  {
    SetErrorString(e->RPCLastErrorString,e->CompCode,e->CompLoc);
	  NotifyClients(e);
    do
    {
      if (!(e=e->Next)) return 0;
    } while (!e->Acquire);
  }
err: return cc;
}
void applyErrorValue(ElemDataStruct *e,void *errValue)
{
  int i,fmt = e->formatOut,len = fmtsizeof(fmt);
  BYTE *ptr;
  if (errValue == NULL) return;
  if (len < 1 || len > 64) return;
  for (i=0; i<(int)e->sizeOut; i++) 
  {
    ptr = rpcDATAOUT(e) + i*len;
    memcpy(ptr,errValue,len);
  }
}
typedef struct RPCQueueStruct
{
  BYTE *dataOut;
  int dataSize;
  long StatusCode;
  int  id;
  time_t timestamp;
  double dtimestamp;
  struct RPCQueueStruct *next;
} RPCQueue;
#define MAX_RPCQUEUE_DEPTH 10
int MaxRpcQueueDepth = MAX_RPCQUEUE_DEPTH;

VOID CALLBACK cbSendNotification(HWND hwnd,UINT uMsg,unsigned long dwData,LRESULT lResult)
{
  int *inside = (int *)dwData;
  (*inside)--;  // keep it simple: just decrement the reentrancy counter
}
void NotifyClients(ElemDataStruct *e)
{
  static RECT Rect;
  static int inside = 0;
  RPCQueue *rpcq, *qPtr, *q;
  static RPCQueue *qHead = NULL, *qTail = NULL;
  time_t timestamp = time(NULL);
  int i,id,cc,notified = FALSE,data_unread = FALSE,supress_notify=FALSE;
  int dataindex,fecindex;
  char lclbuf[256];
  REDIRECTED_LINK *r;

  e->isInitializing = FALSE;
  e->time = timestamp;
  for (i=0; i<MAXCOMMONLINKS && (id=e->links[i]) >= 0; i++)
  {
    lclbuf[0] = 0;
    if (link[id].active <= 0) continue;  // just a place holder
    notified = TRUE;
    if ((cc=e->CompCode) != 0) 
    {
      link[id].dataFlg = cc;
      if (!(cc & CE_SENDDATA) && link[id].useErrValue)
      {
        applyErrorValue(e,link[id].errValue);
      }
      if ((cc == illegal_property || cc == non_existent || cc == non_existent_elem || cc == non_existent_fec) &&
          (r=e->redirectedLink) != NULL)
      {
        if ((dataindex=getRPCDataIndex(e->Context,r->srcServerName)) >= 0 &&
            (fecindex=getRPCFecIndex(RPCData[dataindex].FecName)) >= 0)
        {
          strncpy(e->EqName,RPCData[dataindex].EqName,EQNAME_SIZE);
          strncpy(e->FecName,RPCFec[fecindex].Name,16);
          e->FecIndex = fecindex;
          strncpy(e->ElemName,r->srcServerName,16);
          strncpy(e->Property,r->srcProperty,32);
          e->redirectedLink = NULL;
          removeRedirectedLink(r,cc);
        }
      }
    }
    else 
    {
      //if (link[id].dataFlg == -1) data_unread = TRUE; <- this somehow leads to a lock-out !
      link[id].dataFlg = -1;
    }
    if (debug > 0 && debugTargetError > 0 && cc == debugTargetError) 
    {
      debugTargetError = 0;
      gMaxDebugTime = 5;
      OutputToDebugFile("NotifyClients","error target met");
    }
    if (debug) sprintf(lclbuf,"link %s %s (%d) notification : ",e->ElemName,e->Property,id);
    if (link[id].hWnd == hDLLWnd)                           // internal
    { 
      if (link[id].hCtrlWnd) 
      {
        if (debug) sprintf(&lclbuf[strlen(lclbuf)],"Synchronous\n");
        ReleaseRPCSemaphore(link[id].hCtrlWnd);
      }
    }
    else if (link[id].hWnd && IsWindow(link[id].hWnd))    // PAINT API
    {
      if (debug) sprintf(&lclbuf[strlen(lclbuf)],"Paint\n");
      PostMessage(link[id].hWnd, WM_PAINT, id, cc);
    }
    else if (link[id].hCtrlWnd && link[id].callback != NULL && link[id].hWnd == hNULL)
    {
      if (!inside)      // normal case
      {
        if (link[id].dataOut != NULL) cc = GetDataAndTime((short)id,link[id].dataOut,&gDataTimeStamp,NULL,&supress_notify);
        RPCtimestamp = (time_t)gDataTimeStamp;
      }
      else                  // chain this. I'm being re-entered
      { 
        if (inside > MaxRpcQueueDepth) return; // be reasonable ...
        if ((q=(RPCQueue *)calloc(1,sizeof(RPCQueue))) == NULL) return;
        q->dataSize = link[id].linkSizeOut;
        q->dataOut = (BYTE *)calloc(1,q->dataSize);
        q->id = id;
        // make the call as usual ...
        if (q->dataOut != NULL) q->StatusCode = GetDataAndTime((short)q->id,q->dataOut,&q->dtimestamp,NULL,NULL);
        q->timestamp = (time_t)q->dtimestamp;
        // forward ordered link-list ...
        if (qHead == NULL) qHead = q; 
        else
        {
          for (rpcq=qHead; rpcq; rpcq=rpcq->next) qPtr = rpcq;
          qPtr->next = q;
        }
        qTail = q;
      }
      if (inside++) return; // re-entrancy finished here

      while (inside > 0)
      {
        if ((q=qHead) != NULL) // there's a chain
        {
          e->RPCtimestamp = q->timestamp;
          e->RPCtimestampMSEC = (UINT16)((q->dtimestamp - (double)q->timestamp)*1000);
          if (q->dataOut) 
          {
            if (link[id].supressDuplicates) 
              supress_notify = !_datcmp(link[id].dataOut,q->dataOut,q->dataSize,e->formatOut,link[id].dtf);
            memcpy(link[i].dataOut,q->dataOut,q->dataSize);
            free(q->dataOut);
          }
          cc = q->StatusCode;
          id = q->id;
          qPtr = q; q = q->next; qHead = q; free(qPtr);
          if (!supress_notify) link[id].callback((int)link[id].hCtrlWnd,cc);
        }
        else   // normal case: just this one
        {
          if (!supress_notify) link[id].callback((int)link[id].hCtrlWnd,cc);
        }
        inside--;
      }
	    qHead = NULL; inside = 0;
//    link[id].callback((int)link[id].hCtrlWnd,cc);
    }
    else if (link[id].hCtrlWnd && IsWindow(link[id].hCtrlWnd)) // OCX API
    {
      if (inside)      // re-entering
      {
        if (inside > MaxRpcQueueDepth) return; // be reasonable ...
        if ((q=(RPCQueue *)calloc(1,sizeof(RPCQueue))) == NULL) return;
        if (debug) OutputToDebugFile("NotifyClients","add to notify queue");
        q->dataSize = link[id].linkSizeOut;
        q->dataOut = (BYTE *)calloc(1,q->dataSize);
        q->id = id;
        // make the call as usual ...
        if (q->dataOut != NULL) q->StatusCode = GetDataAndTime((short)q->id,q->dataOut,&q->dtimestamp,NULL,NULL);
        q->timestamp = (time_t)q->dtimestamp;
        // forward ordered link-list ...
        if (qHead == NULL) qHead = q; 
        else
        {
          for (rpcq=qHead; rpcq; rpcq=rpcq->next) qPtr = rpcq;
          qPtr->next = q;
        }
        qTail = q;
      }
      if (inside++) return; // re-entrancy finished here

      while (inside > 0)
      {
        if ((q=qHead) != NULL) // there's a chain
        {
          e->RPCtimestamp = q->timestamp;
          e->RPCtimestampMSEC = (UINT16)((q->dtimestamp - (double)q->timestamp)*1000);
          if (q->dataOut) 
          {
            memcpy(rpcDATAOUT(e),q->dataOut,q->dataSize);
            free(q->dataOut);
          }
          cc = q->StatusCode;
          id = q->id;
          qPtr = q; q = q->next; qHead = q; free(qPtr);
          if (debug) OutputToDebugFile("NotifyClients","remove from notify queue");
          if (gRPCSyncNotify)
          {
   	        SendMessage(link[id].hCtrlWnd, WM_SYSCOMMAND, id, cc);
            //inside--;
          }
          else 
          {
   	        if (!data_unread) PostMessage(link[id].hCtrlWnd, WM_SYSCOMMAND, id, cc);
            //SendMessageCallback(link[id].hCtrlWnd, WM_SYSCOMMAND, id, cc, cbSendNotification, (UINT32)&inside);
          }
        }
        else   // normal case: just this one
        {
          if (gRPCSyncNotify)
          {
            SendMessage(link[id].hCtrlWnd, WM_SYSCOMMAND, id, cc);
            //inside--;
          }
          else 
          {
            if (!data_unread) PostMessage(link[id].hCtrlWnd, WM_SYSCOMMAND, id, cc);
            //SendMessageCallback(link[id].hCtrlWnd, WM_SYSCOMMAND, id, cc, cbSendNotification, (UINT32)&inside);
          }
        }
        inside--;
      }
      qHead = NULL; inside = 0;
      if (debug) sprintf(&lclbuf[strlen(lclbuf)],"OLE control\n");
    }
    else 
    {
      if (debug) sprintf(&lclbuf[strlen(lclbuf)],"ERROR: Parent terminated !!\n");
      MessageBeep(0);
      RemoveRPC(id);
    }
    if (debug) output(lclbuf);
  }
  if (!notified) // active link with no desktop client !
  {
    if (debug) { sprintf(&lclbuf[strlen(lclbuf)],"ERROR: NO Desktop Parent !!\n"); output(lclbuf); }
    MessageBeep(0); MessageBeep(0); MessageBeep(0);
    e->mode = CM_CANCEL;
    if (e->TCPsocket > 0) e->mode |= CM_CONNECT; 
    e->heartbeat = 0;
  }
  return;
}

// =================================================
//      Hot link cycle from connection streams
// =================================================

void DoRPC(void)
{
  BOOL Acquire = FALSE;
  ElemDataStruct *e,*eStart,*eStop;
  int size, rwflag;
  time_t timestamp = time(NULL);
  HCURSOR OldCurs;

  if (WorkAreaSemaphore) return;
  for (e=ElemList; e != NULL; e=e->Next)
  {
    e->Acquire = FALSE;
    if (e->mode == CM_REGISTER || e->mode == CM_CANCEL) continue;
    if (e->RPCprotocol < 1 || e->RPCprotocol > 2) continue;
    if (e->PollRate < 1000) e->PollRate = 1000;
    if (timestamp >= (time_t)((e->PollRate/1000) + e->time))
    {
      e->Acquire = TRUE;
      Acquire = TRUE;
    }
  }
  if (!Acquire) return;               // nothing to do

  for (eStop = ElemList; eStop != NULL;)
  {
    size=0;  rwflag = 0;             // how many go out to same FEC at same time ?
    while(!eStop->Acquire) if (!(eStop = eStop->Next)) return;
    for (eStart = eStop; eStart->FecIndex == eStop->FecIndex;)
    {
      if (eStop->Acquire)
      {
        if (!rwflag) rwflag = eStop->access & CA_WRITE ? -1 : 1;
        if (eStop->access & CA_WRITE && rwflag == 1) break;
        if (!(eStop->access & CA_WRITE) && rwflag == -1) break;
        if (eStop->mode == CM_SINGLE) eStop->mode = CM_CANCEL;
        size++;
      }
      if (!(eStop = eStop->Next)) break;
    }
    OldCurs=SetCursor(WaitCurs);
    SendRequest(size*rwflag,eStart);
    SetCursor(OldCurs);
  }
}
void RemoveRPC(int ID)
{
  static ElemDataStruct *elem;
  int i, idx = 0;

  if (debug)
  {
    sprintf(strbuf,"Remove RPC link id %d\n",ID);
    output(strbuf);
  }
  if (ID == -1)
  {
    for (i=0,elem=ElemList; elem; elem=elem->Next, i++) elem->lockCount = 0; // count them
//    while(ElemList!=NULL && i--) CancelElem(ElemList);   // reassigns ElemList
    for (elem=ElemList; elem; ) elem = CancelElem(elem);
    while(ElemList!=NULL)
    {
      CheckSubscriptions();
      Cleanup();
    }
    return;
  }
  if ((elem=link[ID].Elem) == NULL) { link[ID].active = 0; return; } // already removed
  if (ID == 0) { RemoveElem(elem); return; }                         // sync. (deprecated)
  link[ID].Elem = NULL; 
  link[ID].mode = 0;
  if (link[ID].hWnd == hDLLWnd && link[ID].hCtrlWnd != NULL )
  { 
    //CloseHandle(link[ID].hCtrlWnd);
    CloseRPCSemaphore(link[ID].hCtrlWnd);
    link[ID].hCtrlWnd = 0;
  }
  // don't release the link ID until all clear
  link[ID].active = elem->ID == ID ? -1 : 0; 

  for (i=0; i<MAXCOMMONLINKS && elem->links[i] > 0; i++) if (elem->links[i] == ID) idx = i;

  if (i == 1) CancelElem(elem); // signal all clear
  else
  {
    for (i = idx; i<MAXCOMMONLINKS-1 && elem->links[i] >= 0; i++)   // reorder
      elem->links[i] = elem->links[i+1];
    elem->links[i] = -1;
  }
  return;
}

#define IsSynchronous(id) if (id == 0) {\
		link[0].hWnd      = hDLLWnd;\
		link[0].active    = 1;\
}
int maxmode(int m1, int m2)
{
  unsigned int hibyte,m;
  if (m1 == CM_REGISTER) return m2;
  if (m2 == CM_REGISTER) return m1;
  m = MAX(BASEMODE(m1),BASEMODE(m2));
  hibyte = MAX((m1 & 0xff00),(m2 & 0xff00));
  return m | hibyte;
}
ElemDataStruct *cloneElem(ElemDataStruct *e)
{
  int cc = 0, i, id, linkid;
  ElemDataStruct *eclone;
  char *c,clonetag[128],tag[128];

  if (e == NULL) return NULL;
  id = e->ID;
  strncpy(tag,link[id].linkTag,128);
  if ((c=strstr(tag,":CLONE")) != NULL) 
  {
    *c = 0; // search for the clone ...
	  for (i=1; i<MAXHOTLINKS; i++)
    {
      if (link[i].active <= 0 && !strncmp(tag,link[i].linkTag,128)) 
      {
        e->PrimeMode = CM_REGISTER;
        e->mode = CM_REGISTER;
        link[i].active = 1;
        return link[i].Elem;
      }
    }
  }
  strncpy(clonetag,link[id].linkTag,128);
  if (strlen(clonetag) < 120) strcat(clonetag,":CLONE");
  linkid = getNextLinkID(-1);
  memcpy(&link[linkid],&link[id],sizeof(linkType));
  if ((eclone=ContractAlloc(clonetag,link[id].linkSizeIn,link[id].linkSizeOut,&link[id].hContract)) == NULL) ccerr(out_of_client_memory);
  memcpy(eclone,e,sizeof(ElemDataStruct));
  eclone->ID = linkid;             //  let the clone have a dangling link id
  eclone->PrimeMode = CM_REGISTER; //  mark the clone as idle ...
  eclone->mode = CM_REGISTER;      //  mark the clone as idle ...
  link[linkid].Elem = eclone;
  link[linkid].active = 0;
  strncpy(link[linkid].linkTag,clonetag,128);
  e->TCPsocket = 0;              // the original will be the active link
  link[id].active = 1;
  eclone->Next = ElemList;
  ElemList = eclone;
err:
  return cc != 0 ? NULL : e;
}

int CreateElem(int ID)
{
  ElemDataStruct *e;
# ifdef USE_LEGACY_LIST
  ElemDataStruct *tag,*nxt;
# endif
  short i,cc = 0,fecindex,dataindex;
  LCLCONTRACT *con = lclContract;
  HANDLE hLclContract = 0;
  HANDLE hDataBlock = 0;
  UINT32 dinsize;
  UINT16 pktlen;
# ifdef USE_SHARED_MEMORY
  BYTE *DataIn;
# endif

  sprintf(shmDataTag,"%s:%d",DATABLOCKNAME,ID);
  sprintf(shmConTag,"%s:%d",CONTRACTNAME,ID);
  if ((con=(LCLCONTRACT *)lclContractAlloc(shmConTag,&hLclContract)) == NULL)
    return -out_of_shared_memory;

  redirectLink(con->EqpContext,con->EqpTagName,con->EqpProperty,con->EqpDeviceName);
  if ((dataindex=getRPCDataIndex(con->EqpContext,con->EqpTagName)) < 0) ccerr(-dataindex);
  if ((fecindex=getRPCFecIndex(RPCData[dataindex].FecName)) < 0) ccerr(-fecindex);
  if (!RPCFec[fecindex].Prot && (i=locateFecName(RPCFec[fecindex].Name)) < 0) ccerr(-i);
  strncpy(con->EqpName,RPCData[dataindex].EqName,EQNAME_SIZE);
  strncpy(con->FecName,RPCFec[fecindex].Name,16);

  if (ID != 0 && (e=GetElemPointer(con)) != NULL)
  {
    for(i=0;i<MAXCOMMONLINKS && e->links[i] >= 0; i++);
    if (i==MAXCOMMONLINKS) ccerr(buffer_too_small);
    // mode could have been set to CM_CANCEL :
    e->PrimeMode = maxmode(e->PrimeMode,e->mode);
    e->links[i] = ID;
    link[ID].Elem = e;
    MakeContractTag(link[ID].linkTag,con,e->ID,link[ID].linkSizeIn,link[ID].linkSizeOut);
    if (LFMT((con)->EqpFormatOut) == CF_SPECTRUM) link[ID].linkSizeOut += 96;
    if (debug) 
    {
      sprintf(strbuf,"Link %d (%s %s) found (instance %d)\n",ID,e->ElemName,e->Property,i);
      output(strbuf);
    }
    ccerr(0);
  }
  if (ID == 0) link[ID].Elem = NULL;
  MakeContractTag(link[ID].linkTag,con,ID,link[ID].linkSizeIn,link[ID].linkSizeOut);
  if (LFMT((con)->EqpFormatOut) == CF_SPECTRUM) link[ID].linkSizeOut += 96;
  if (ID == 0) strcat(link[0].linkTag,":SYNC");
  if ((e=ContractAlloc(link[ID].linkTag,link[ID].linkSizeIn,link[ID].linkSizeOut,&link[ID].hContract)) == NULL) ccerr(out_of_client_memory);
  memset(e,0,sizeof(ElemDataStruct)+link[ID].linkSizeIn+link[ID].linkSizeOut);

  e->hDataIn = sizeof(ElemDataStruct);
  e->hDataOut = e->hDataIn + link[ID].linkSizeIn;
  e->Next = 0;
  strncpy(e->ElemName,con->EqpTagName,16);
  e->sizeIn = con->EqpSizeIn;
  e->sizeOut = con->EqpSizeOut;
  e->PollRate = con->PollRate > 0 ? con->PollRate : _POLLRATE;
  e->formatIn = LFMT(con->EqpFormatIn);
  e->formatOut = LFMT(con->EqpFormatOut);
  strncpy(e->strTagOut,con->strTagOut,8);
  strncpy(e->strTagIn,con->strTagIn,8);
  e->access = con->EqpAccess;
  e->blknumIn = 1;
  e->numblksIn = 1;
  e->nextDataPtr = 0;
  e->blkidIn = 0;
  e->Bytesin = 0;
  pktlen = RPCFec[fecindex].Prot == IPX ? IPX_BUFFER_SIZE : UDP_BUFFER_SIZE;
  e->datamtu = pktlen - SUBSCRIPTION_SIZE - HEADERSTRUCT_SIZE;
  if (e->sizeIn > 0)
  {
    dinsize = e->sizeIn*fmtsizeof(e->formatIn);
#   ifdef USE_SHARED_MEMORY
    if ((DataIn=(BYTE *)DataBlockAlloc(shmDataTag,dinsize,&hDataBlock)) == NULL)
      ccerr(out_of_shared_memory);
    memcpy(rpcDATAIN(e),DataIn,dinsize);
    if (hDataBlock) DataBlockFree(DataIn,hDataBlock); 
#   else
    memcpy(rpcDATAIN(e),con->DataIn,dinsize);
#   endif
    e->BytesTotal = dinsize;
    e->BytesRemaining = dinsize;
    e->numblksIn = (BYTE)(dinsize/e->datamtu + (dinsize%e->datamtu ? 1 : 0));
    e->nextDataSize = (UINT16)MIN(e->datamtu,e->BytesTotal);
  }
  if (RPCFec[fecindex].MaxRPCProt == 0) RPCFec[fecindex].MaxRPCProt = 5;
  e->RPCprotocol = RPCFec[fecindex].MaxRPCProt;
  if (e->RPCprotocol == 4)
  {
    if (e->sizeIn*fmtsizeof(e->formatIn) > UDP_BUFFER_SIZE - SUBSCRIPTION4_SIZE) e->RPCprotocol = 1;
    else if (e->sizeOut*fmtsizeof(e->formatOut) > UDP_BUFFER_SIZE - PRODUCER4_SIZE) e->RPCprotocol = 1;
  }
  e->RPCtimestamp = 0;
  e->RPCtimestampMSEC = 0;
  e->heartbeat = 0;
  e->timeoutCount = 10;
  e->PrimeMode = CM_REGISTER;
  e->mode = CM_REGISTER;
  e->FecIndex = fecindex;
  e->protocol = (RPCFec[fecindex].Prot & IPX) ? IPX : UDP;
  strncpy(e->EqName,RPCData[dataindex].EqName,EQNAME_SIZE);
  strncpy(e->Property,con->EqpProperty,PROPERTY_SIZE);
  strncpy(e->DeviceName,con->EqpDeviceName,32);
  strncpy(e->Context,con->EqpContext,16);
  strncpy(e->FecName,RPCFec[fecindex].Name,16);
  e->EqNo = atoi(&e->DeviceName[1]);
  e->CompCode = link_not_open;
  e->LastCode = 0;
  e->isInitializing = TRUE;
  e->ID = ID;        // subscription ID tag
  e->links[0] = ID;
  e->starttime = time(NULL);
  for(i=1;i<MAXCOMMONLINKS; i++) e->links[i] = -1;
  link[ID].Elem = e;
  IsSynchronous(ID); // 0 is reserverd for cold links
  if (debug) 
  {
    sprintf(strbuf,"Link %d (%s %s %s %d) created\n",
		    ID,e->ElemName,e->DeviceName,e->Property,e->starttime);
    output(strbuf);
  }
# ifdef USE_LEGACY_LIST
  // 1st one is now out or order, find out where it belongs:
  if ((tag=ElemList) == NULL) ElemList = e; // list is empty
  else if (tag->FecIndex > e->FecIndex)     // look no further
  {
    e->Next = tag;
    ElemList = e;
  }
  else									  // find location
  {
    while ((nxt=tag->Next) != NULL && nxt->FecIndex <= e->FecIndex) tag = nxt;
    e->Next = nxt;
    tag->Next = e;
  }
# else
  e->Next = ElemList;
  ElemList = e;
# endif
err:
  lclContractFree(con,hLclContract); 
  return cc;
}

ElemDataStruct *GetElemPointer(LCLCONTRACT *c)
{
  ElemDataStruct *e = NULL;
  char lclElemName[17];
  int unmatched;
  HANDLE hDataBlock = 0;
  UINT32 dinsize;

  strncpy(lclElemName,c->EqpName,6); lclElemName[7] = 0;
  for (e=ElemList; e != NULL; e=e->Next)
  {
    if (!strncmp(c->FecName,e->FecName,16) && !strncmp(lclElemName,e->EqName,6) && 
	      !strncmp(c->EqpProperty,e->Property,32) && !strncmp(c->EqpDeviceName,e->DeviceName,32))
    {
//	  if (strlen(c->EqpContext) != 0 && strncmp(c->EqpContext,e->Context,16)) continue;
	    if (e->access != c->EqpAccess) continue;
      if (e->sizeOut > 0)
      {
        if (e->sizeOut != c->EqpSizeOut || e->formatOut != LFMT(c->EqpFormatOut)) continue;
        if (strncmp(e->strTagOut,c->strTagOut,8)) continue;
      }
      else if (c->EqpSizeOut) continue;
      if (e->sizeIn > 0)
      {
        if (c->DataIn == NULL || e->sizeIn != c->EqpSizeIn || e->formatIn != LFMT(c->EqpFormatIn)) 
          continue;
        if (strncmp(e->strTagIn,c->strTagIn,8)) continue;
        dinsize = e->sizeIn*fmtsizeof(e->formatIn);
#       ifdef USE_SHARED_MEMORY
        if ((c->DataIn=(BYTE *)DataBlockAlloc(shmDataTag,dinsize,&hDataBlock)) == NULL) continue;
#       endif
        unmatched = memcmp(c->DataIn,rpcDATAIN(e),dinsize);
        if (hDataBlock) DataBlockFree(c->DataIn,hDataBlock); 
        if (unmatched) continue;
      }
      else if (c->EqpSizeIn) continue;
      return e;         /* found it */
    }
  }
  return NULL;
}
ElemDataStruct *CancelElem(ElemDataStruct *e)
{
  ElemDataStruct *nxt = e->Next;
  if (debug > 1) { sprintf(strbuf,"Cancel %d (next at %d)\n",e,e->Next); output(strbuf); }
  e->lockCount = 0;
  if (e->RPCprotocol >= 4 && !(e->mode & (CM_MCAST|CM_BCAST)) &&
      BASEMODE(e->mode) > CM_SINGLE && BASEMODE(e->mode) < CM_REGISTER)
  {
    e->heartbeat = SUB_PENDING;
    e->mode = CM_CANCEL;
    if (e->TCPsocket > 0) e->mode |= CM_CONNECT; 
    e->links[0] = -1;
  }
  else RemoveElem(e);
  return nxt;
}
void RemoveElem(ElemDataStruct *e)
{
  int i,id,nConnectionsToFec = 0;
  ElemDataStruct *t;

  if (e == NULL) return;
  for (t=ElemList; t != NULL; t=t->Next)   
  {
    if (t->FecIndex == e->FecIndex && t->TCPsocket > 0) nConnectionsToFec++;
  }
  if (nConnectionsToFec <= 1 && e->TCPsocket > 0) 
  {
    if (EngineShuttingDown) CloseConnectionSocket(e->TCPsocket);
    if (debug > 2)
    {
      sprintf(strbuf,"mark connection as idle (sck %d)",e->TCPsocket);
      OutputToDebugFile("RemoveElem",strbuf);
    }
    AddIdleConnection(e->TCPsocket,e->FecIndex);
  }
  if (debug)
  {
    sprintf(strbuf,"remove %s %s (list @ %d, next @ %d\n",
		e->ElemName,e->Property,ElemList,e->Next);
    output(strbuf);
  }
  for (i=0; i<MAXCOMMONLINKS && (id=e->links[i]) > 0; i++)
  {
    link[id].Elem = 0; 
    link[id].active = 0; 
    if (debug) { sprintf(strbuf,"Link %d deactivated\n",id); output(strbuf); }
  }
  link[e->ID].active = 0;
  if (ElemList == e) ElemList = e->Next;
  else
  {
    for (t = ElemList; t && t->Next != e; t = t->Next);
    if (t == NULL || t->Next == NULL) return;
    t->Next = e->Next;
  }
  if (e->outBuf) free(e->outBuf);
  ContractFree(e,link[e->ID].hContract);
  return;
}
// =============================================
//       Network broadcast global routines
// =============================================
void doGlobalUpdate(BYTE *buf)
{
  int cc,i,id,j,num,size=sizeof(HeaderStruct),fmtsize,datasize;
  BrdcstData *brdcstdata;
  HeaderStruct *brdcstHdr = (HeaderStruct *)buf;
  ElemDataStruct  *e;
  HANDLE hContract=0;

  num = brdcstHdr->EqpSize;
  if (brdcstHdr->Protocol != 3) ccerr(illegal_protocol);

  for (i=0; i<num; i++)
  {
    brdcstdata = (BrdcstData *)&buf[size];
    size += sizeof(BrdcstData);
    fmtsize = getFormatSize(brdcstdata->format);
    if (fmtsize == 0) ccerr(illegal_format); // unknown format type
    for (j=0; j<nglobals; j++)
    {
      if (!stricmp(brdcstdata->name,GlobalList[j].keyword))
      {
        GlobalList[j].cTimeStamp = makeDataTimeStamp();
        GlobalList[j].dTimeStamp = (double)brdcstdata->time;
        datasize = MIN(GlobalList[j].size,brdcstdata->size);
        id = GlobalList[j].ID;
        if (!(e=ContractAlloc(link[id].linkTag,link[id].linkSizeIn,link[id].linkSizeOut,&hContract))) continue;
        e->time = brdcstdata->time;
        e->RPCtimestamp = (int)GlobalList[j].cTimeStamp;
        e->RPCtimestampMSEC = (int)((GlobalList[j].cTimeStamp - (double)e->RPCtimestamp)*1000);
        GlobalList[j].Data = rpcDATAOUT(e);
        link[id].dataFlg = -1;
        if ((cc=reformatData(GlobalList[j].Data,GlobalList[j].format,GlobalList[j].size,
                             &buf[size],brdcstdata->format,brdcstdata->size)) != 0) ccerr(cc);
        if (debug > 2)
        {
          sprintf(strbuf,"received global: %s (%d bytes ,%d>)\n",
          GlobalList[j].keyword,fmtsize*datasize,GlobalList[j].format);
          output(strbuf);
        }
        if (hContract) ContractFree(e,hContract);
        break;
      }   // keywords matched
    }
    size += brdcstdata->size*fmtsize;
  }
err: return;
}
short IncomingNetworkProtocol;
struct DGinfo
{
  int *sck;
  int sck_len;
  int blk_siz,
	  wm_msg;
  int type;
  char typeStr[8];  
} dg[] = 
{
  {&ConsumerSocket,sizeof(struct sockaddr_in),UDP_BUFFER_SIZE,WM_RCVPKT_UDP,UDP,"UDP"},
  {&MCastConsumerSocket,sizeof(struct sockaddr_in),UDP_BUFFER_SIZE,WM_RCVPKT_UDPBCST,UDP,"UDPBCST"},
  {&IPXConsumerSocket,sizeof(SOCKADDR_IPX),IPX_BUFFER_SIZE,WM_RCVPKT_IPX,IPX,"IPX"},
  {&IPXMCastConsumerSocket,sizeof(SOCKADDR_IPX),IPX_BUFFER_SIZE,WM_RCVPKT_IPXBCST,IPX,"IPXBCST"},
  {&GlobalSocket,sizeof(struct sockaddr_in),UDP_BUFFER_SIZE,WM_RCVPKT_GLB,UDP,"GLB"},
  {&ConsumerSocket,sizeof(struct sockaddr_in),WORK_SIZE,WM_RCVPKT_TCP,TCP,"TCP"},
};

#define getDGtype(sck) (\
	(sck) == ConsumerSocket ? 0 :\
	(sck) == MCastConsumerSocket ? 1 :\
	(sck) == (int)IPXConsumerSocket ? 2 :\
	(sck) == (int)IPXMCastConsumerSocket ? 3 :\
	(sck) == GlobalSocket ? 4 : 5\
)
#define getProtocolEntry(p) (\
  (p) == UDP ? 0 :\
  (p) == UDPBCST ? 1:\
  (p) == IPX ? 2 :\
  (p) == IPXBCST ? 3:\
  (p) == GLB ? 4 :\
  (p) == TCP ? 5 :-1\
)

char *ipxnet_ntoa(BYTE *node,int len)
{
  static char buf[13];
  int i;

  for (i=0; i<len; i++) sprintf(&buf[i*2],"%02X",node[i]);
  return buf;
}
char *getClientAddr(struct sockaddr *sa_ip,SOCKADDR_IPX *sa_ipx)
{
  char *c;

  strcpy(clientaddr,"UNKNOWN");
  if (sa_ip)
  {
    if ((c=inet_ntoa(((struct sockaddr_in *)sa_ip)->sin_addr)) != NULL) 
	    strncpy(clientaddr,c,16);
  }
  else if (sa_ipx)
  {
    if ((c=ipxnet_ntoa(sa_ipx->sa_nodenum,6)) != NULL) strncpy(clientaddr,c,16);
  }
  return clientaddr;
}
void closeIPConnectionToFec(int index)
{
  ElemDataStruct  *e;
  if (!TCPloaded) return;
  if ((RPCFec[index].Prot & IPX)) return;
  RPCFec[index].Prot = UDP;              
  for (e=ElemList; e != NULL; e=e->Next)   /* possible TCP connections */
  {
    if (index != e->FecIndex) continue;
    e->TCPsocket = 0;                      /* signal for new connection */
  }
  if (debug)
  {
    sprintf(strbuf,"TCP: close connection to %s\n",RPCFec[index].Name);
    output(strbuf);
  }
  return;
}
ElemDataStruct *CloseConnectionSocket(int sck)
{
  ElemDataStruct *e=NULL;

  if (sck > 0) 
  {
    shutdown(sck,2);
    soclose(sck);
  }
  freeBucket(sck);
  for (e=ElemList; e != NULL; e=e->Next)   
  {
    if (sck > 0 && e->TCPsocket == sck)
    {
      closeIPConnectionToFec(e->FecIndex);
      e->TCPsocket = 0;
      break;
    }
  }
  if (debug)
  {
    sprintf(strbuf,"TCP: close socket %d\n",sck);
    output(strbuf);
  }
  return e;
}
struct sockaddr_in IncomingIPfec;
SOCKADDR_IPX IncomingIPXfec;
int GetDatagram(int sck,int prot)
{
  int nread,nleft,n;
  BYTE *bufptr=WorkArea;
  int p=getProtocolEntry(prot);
  int IPlen = sizeof(IncomingIPfec);
  int pktlen = dg[p].sck_len;
  TCPBCKT *bckt;

  if (dg[p].type == IPX && !IPXloaded) return -1;
  if (WorkAreaSemaphore) return -1; else WorkAreaSemaphore = 1;

  IncomingNetworkProtocol = prot;
  if ((nread=recvfrom(sck,(char *)WorkArea,WORK_SIZE,0,
                      (dg[p].type == IPX ? (struct sockaddr *)&IncomingIPXfec : 
                                           (struct sockaddr *)&IncomingIPfec),
                      &pktlen)) > 0)
  {
    if (debug > 1)
    {
      switch (dg[p].type)
      {
        case IPX: 
          getClientAddr(NULL,&IncomingIPXfec); break;
        case TCP:
          getpeername(sck,(struct sockaddr *)&IncomingIPfec,&IPlen);
        case UDP: 
          getClientAddr((struct sockaddr *)&IncomingIPfec,NULL); break;
        default:  strcpy(clientaddr,"UNKNOWN");
      }
      sprintf(strbuf,"%s: %d bytes received from %s:%d\n",dg[p].typeStr,nread,clientaddr,sck);
      output(strbuf);
    }
	  switch (prot)
	  {
	    case GLB: 
		    if (nread >= (n = *(short *)WorkArea)) doGlobalUpdate(WorkArea); break;
      case TCP:
		    if ((bckt=findBucket(sck)) == NULL) return 0;
		    nleft = nread;
		    while (nleft > 0)
		    {
          if (bckt->ptr == 0) bckt->siz = *(short *)bufptr;
          n = bckt->siz - bckt->ptr;
          if (nleft >= n)  // at least enough
          {
            memcpy(&bckt->buf[bckt->ptr],bufptr,n);
            consumeData(bckt->buf);     // there's a complete block to read
            bufptr += n;                // move the read buffer pointer along
            nleft -= n;                 // decrement what's remaining to be read
            bckt->ptr = 0;              // reset the bucket pointer
          }    
          else                          // a few more bytes
          {
            memcpy(&bckt->buf[bckt->ptr],bufptr,nleft);
            bckt->ptr += nleft;
            nleft = 0;
          }
        }
        break;
      case UDP:
      case UDPBCST:
      case IPX:
      case IPXBCST:
        if (nread >= (n = *(short *)WorkArea)) consumeData(WorkArea); break;
//        WSAAsyncSelect(sck,hDLLWnd,dg[p].wm_msg,FD_READ);
      default: 
        n = 0; break;
	  }
    if (nread < n)
    {
      if (debug) 
      {
        sprintf(strbuf,"recvfrom: %d bytes received instead of %d\n",nread,n);
        output(strbuf);
      }
    }
  }
  WorkAreaSemaphore = 0;
  return nread;
}
int transportError(char *txt,CLIENT *cln)
{
  if (debug) soperror(txt);
  if (debug > 2)
  {
    sprintf(strbuf,"%s (sck %d)",txt,cln->sck);
    OutputToDebugFile("transportError",strbuf);
  }
  if (cln->transport == IPX) return ipx_socket_error;
  if (cln->transport == TCP)
  {
    CloseConnectionSocket(cln->sck);
  }
  return tcp_socket_error;
}
int sendDatagram(CLIENT *cln,BYTE *data)
{
  int msgsize = *(short *)data;
  int dgType, retry = 0;
  struct fd_set fdwset;
  struct timeval wait_to;
  int socket = cln->sck;
  HANDLE hShm;
  char shmTag[64];

  if (cln->transport == LCL) 
  {
    sprintf(shmTag,"_shmTContract:%d",hDLLWnd);
    if (debug)
    {
      sprintf(strbuf,"LCL: %d bytes sent to %s\n",msgsize,shmTag);
      output(strbuf);
    }
    return shmSndDataGram((HANDLE)cln->sck,shmTag,data,msgsize,&hShm);
  }
  dgType = getDGtype(socket);
  if (msgsize > dg[dgType].blk_siz) return use_stream_transport;
  if (cln->transport == IPX && !IPXloaded) return ipx_not_supported;
sendDatagramRetry:
  FD_ZERO(&fdwset); FD_SET(socket,&fdwset);
  wait_to.tv_sec=0;  wait_to.tv_usec=0;
  switch (select(32,NULL,&fdwset,NULL,&wait_to))
  {
    case 1:  break;
    case 0:  return cln->transport == IPX ? ipx_socket_error : tcp_socket_error;
    default: return transportError("select",cln);
  }
  if (sendto(socket,(char *)data,msgsize,0,
      (cln->transport == IPX ? (struct sockaddr *)&cln->IPXaddress : (struct sockaddr *)&cln->IPaddress),
      16) < 0)
  {
    if (retry++ < 3) goto sendDatagramRetry;
    return transportError("sendto",cln);
  }
  so_snderrcnt += retry;
  if (debug)
  {
    if (cln->transport == IPX) getClientAddr(NULL,&cln->IPXaddress); else getClientAddr((struct sockaddr *)&cln->IPaddress,NULL);
    sprintf(strbuf,"%s: %d bytes sent to %s:%d\n",dg[dgType].typeStr,msgsize,clientaddr,socket);
    output(strbuf);
  }
  return 0;
}

int getIncomingFecIndex(void)
{
  int idx;
  UINT16 poff;
  ElemDataStruct *e = NULL;

  if (IncomingNetworkProtocol == UDP || IncomingNetworkProtocol == UDPBCST)
  {
    for (e=ElemList; e != NULL; e=e->Next) if (e->protocol == UDP)
    {
      idx = e->FecIndex;
      poff = GetPortOffset(&RPCFec[idx]);
      if (IncomingIPfec.sin_port == htons((UINT16)(gtUDPPort+poff)) &&
          IncomingIPfec.sin_addr.s_addr == *(UINT32 *)&RPCFec[idx].iaddr)
        return idx;
    }
    return -1;
  }
  if (IncomingNetworkProtocol == IPX || IncomingNetworkProtocol == IPXBCST)
  {
    for (e=ElemList; e != NULL; e=e->Next) if (e->protocol == IPX)
    {
      idx = e->FecIndex;
      if (!memcmp(RPCFec[idx].Node,&IncomingIPXfec.sa_nodenum,6)) return idx;
    }
    return -1;
  }
  return -1;
}
#define bowout(txt) { strcat(strbuf,txt); strcat(strbuf,"\n"); tc = -1; goto bow; }
#define AssignFromPheader(p) {\
	msgsize = (p)->msgsize;\
	counter = (p)->counter;\
	if (e->starttime != (p)->starttime) {\
    cln_wrong_starttimecnt++;\
	  sprintf(scratch," wrong starttime (%d vs %d)",e->starttime,(p)->starttime);\
	  bowout(scratch);\
	}\
	if ((p)->timestamp < e->RPCtimestamp) {\
    cln_stalecnt++;\
	  sprintf(scratch," stale (%d vs %d)",(p)->timestamp,e->RPCtimestamp);\
	  bowout(scratch);\
	}\
	e->RPCtimestamp = (p)->timestamp;\
	e->RPCtimestampMSEC = (p)->timestampMSEC;\
	e->time = timestamp;\
	cc = (p)->CompletionCode;\
}

#define Pheader4to5(p4,p5) {\
  (p5)->msgsize = (p4)->msgsize;\
  (p5)->SubscriptionID = (p4)->SubscriptionID;\
  (p5)->CompletionCode = (p4)->CompletionCode;\
  (p5)->counter = (BYTE)(p4)->counter;\
  (p5)->timestamp = (p4)->timestamp;\
  (p5)->starttime = (p4)->starttime;\
  (p5)->numblks = 1;\
  (p5)->blknum = 1;\
  (p5)->mtu = UDP_BUFFER_SIZE;\
  (p5)->timestampMSEC = 0;\
}
short consumeData(BYTE *buf)
{
  short idx,prot,cc,rc,tc=0,fmtsize,counter,renewalMultiplier;
  UINT16 csize,pstepsize,msgsize,totalsize = *(short *)buf,bytesread=sizeof(totalsize);
  UINT32 datasize,dcmpsize;
  int dataPtr,dretsize,doutsize;
  long gapsize, gapptr;
  ProducerHeaderStruct *Pheader=(ProducerHeaderStruct *)&buf[bytesread];
  ProducerHeaderStruct4 *Pheader4=(ProducerHeaderStruct4 *)&buf[bytesread];
  ElemDataStruct *e;
  time_t timestamp = time(NULL);
  char namstr[64],devstr[64],str[32],scratch[48];
  int dataindex,fecindex;
  REDIRECTED_LINK *r;

  switch (cc=*(short *)&buf[6])
  {
    case server_redirection:
      for (e=ElemList; e!=NULL; e=e->Next) if (e->ID == *(short *)&buf[4]) break;     // primary ID
      if (!e) ccerr(non_existent);
      memcpy(namstr,&buf[bytesread+PRODUCER_SIZE],RPCERR_SIZE);
      strncpy(str,namstr,16); str[16] = 0;

      if (e->TCPsocket != 0)
      {
        AddIdleConnection(e->TCPsocket,e->FecIndex);
        e->TCPsocket = 0;
      }
      if ((dataindex=getRPCDataIndex(e->Context,str)) < 0) ccerr(-dataindex);
      if ((fecindex=getRPCFecIndex(RPCData[dataindex].FecName)) < 0) ccerr(-fecindex);
      if (!RPCFec[fecindex].Prot && (cc=locateFecName(RPCFec[fecindex].Name)) < 0) ccerr(-cc);
      r = appendRedirectedLinkList(e->Context,e->ElemName,e->Property,e->DeviceName,str,&namstr[16]);
      strncpy(e->ElemName,str,ELEM_NAME_SIZE);
      strncpy(e->EqName,RPCData[dataindex].EqName,EQNAME_SIZE);
      strncpy(e->FecName,RPCFec[fecindex].Name,16);
      e->FecIndex = fecindex;
      if (strlen(e->Context) > 0) sprintf(devstr,"/%s/%s/%s",e->Context,str,e->DeviceName);
      else sprintf(devstr,"%s/%s",str,e->DeviceName);
      strncpy(str,&namstr[16],16);
      if (strlen(str) > 0) strncpy(e->Property,str,32);
      e->redirectedLink = r;
      e->heartbeat = SUB_PENDING;
      return tc;
    case illegal_protocol:
      if ((idx=getIncomingFecIndex()) < 0) ccerr(invalid_index);
      for (e=ElemList; e != NULL; e=e->Next)
        if (e->FecIndex == idx && e->RPCprotocol == 5)
      {
	      datasize = (UINT16)e->sizeOut*fmtsizeof(e->formatOut);
    	  csize = e->access & CA_WRITE ? SUBSCRIPTION4_SIZE + HEADERSTRUCT_SIZE : PRODUCER4_SIZE;
    	  if (e->protocol == IPX) e->RPCprotocol = datasize > (UINT32)IPX_BUFFER_SIZE - csize ? 1 : 4;
    	  else e->RPCprotocol = (datasize > (UINT32)UDP_BUFFER_SIZE - csize) ? 1 : 4;
	      if (e->RPCprotocol < 4) 
        {
	        e->time = 0L;
          if (e->PollRate < 1000) e->PollRate = 1000;
        }
        e->heartbeat = SUB_PENDING;
	      if (debug)
        {
	        sprintf(strbuf,"%s %s %s : switch to protocol 4\n",e->ElemName,e->DeviceName,e->Property);
          output(strbuf);
        }
		    RPCFec[idx].MaxRPCProt = 4;
      }
      return tc;
    case get_subscription_id:
      if ((idx=getIncomingFecIndex()) < 0) ccerr(invalid_index);
      for (e=ElemList; e!=NULL; e=e->Next) if (e->ID == *(short *)&buf[4]) break;     // primary ID
      if (!e) ccerr(non_existent);
      e->srvID = *(short *)&buf[bytesread+PRODUCER_SIZE];
      if (debug)
      {
        sprintf(strbuf,"BCAST sub id %d from %s",e->srvID,RPCFec[idx].Name);
        output(strbuf);
      }
      return tc;
    default:
      break;
  }

  while (bytesread < totalsize)
  {
    if (debug > 1) 
    {
      sprintf(strbuf,"consumeData : processing %d from %d bytes ",totalsize-bytesread,totalsize);
	    output(strbuf);  
    }
    if (Pheader->starttime == BCAST_ID) 
    {
      if ((idx=getIncomingFecIndex()) < 0) return 0;         /* which FEC ? */
      for (e=ElemList; e!=NULL; e=e->Next) 
        if (e->srvID == Pheader->SubscriptionID && e->FecIndex == idx && e->RPCprotocol == 5)
        {
          Pheader->SubscriptionID = e->ID;
          Pheader->starttime = e->starttime;
          break;
        }
        if (!e) return 0; // not interested
    }

    strbuf[0] = 0;
	  msgsize = Pheader->msgsize;
    if (debug > 1) sprintf(strbuf,"ID %d : %d bytes ",Pheader->SubscriptionID,Pheader->msgsize);
    for (e=ElemList; e!=NULL; e=e->Next) if (e->ID == Pheader->SubscriptionID ) break;     // primary ID
    if (!e) 
    {
      cln_illegal_idcnt++;
      bowout(" illegal id");
    }

    if ((prot=e->RPCprotocol) < 4 || prot > 5) 
    {
      cln_illegal_protocolcnt++;
      bowout(" protocol");
    }
    pstepsize = prot == 4 ? PRODUCER4_SIZE : PRODUCER_SIZE;

    if (prot == 4) Pheader4to5(Pheader4,Pheader);
    AssignFromPheader(Pheader);

    fmtsize = fmtsizeof(e->formatOut);
    datasize = fmtsize*e->sizeOut; // expected size of call in bytes
    if (e->formatOut == CF_SPECTRUM) datasize += 96;
    if (datasize % 2) datasize++;  // even boundaries !!!
    doutsize = Pheader->msgsize - pstepsize; // data bytes in this datagram
    dcmpsize = datasize;
    e->lastDataSize = 0; gapsize = 0;  // always reset
    if (debug > 1 || (debug && BASEMODE(e->mode) <= CM_SINGLE)) 
    {
      sprintf(&strbuf[strlen(strbuf)],"%s %s %s [%d bytes (%d) p%d]<%d> (+%d)\n",
               e->ElemName,e->DeviceName,e->Property,datasize,e->formatOut,prot,cc,counter);
    }
    switch (cc)
    {
	    case non_existent_elem:
        counter = 0;
      default:
        rc = cc & 0x0fff;
        strncpy(RPCLastErrorString,rc > 0 && rc < numErr ? erlst[rc] : "error undefined",PREFIX+RPCERR_SIZE);
        if (prot == 4) 
        {
          memcpy(&(e->RPCLastErrorString[PREFIX]),RPCLastErrorString,RPCERR_SIZE-1);
          break;
        }
        if (doutsize < RPCERR_SIZE && e->blksin == 0)
        {
          e->Bytesin = 0;
          cln_partial_blockcnt++;
          bowout(" partial error block");
        }
        if (!(Pheader->CompletionCode & CE_SENDDATA)) datasize = 0;
        gapsize = 0;
        if (Pheader->blknum == Pheader->numblks || datasize == 0)
        {
		      memset(e->RPCLastErrorString,0,PREFIX+RPCERR_SIZE);
		      strncpy(e->RPCLastErrorString,"[RMT] ",PREFIX);
          gapsize = RPCERR_SIZE;
          if (doutsize < RPCERR_SIZE)
          {
            if (Pheader->numblks == 1)
            {
              cln_phantom_blockcnt++;
              bowout(" phantom block");
            }
            gapsize = doutsize;
          }
          gapptr = RPCERR_SIZE - gapsize;
          memcpy(&e->RPCLastErrorString[PREFIX+gapptr],&buf[bytesread+Pheader->msgsize-gapsize],gapsize);
          doutsize -= (UINT16)gapsize;
          e->Bytesin += (UINT16)gapsize;
        }
        if (!(Pheader->CompletionCode & CE_SENDDATA)) break;
	    case 0:
        strncpy(RPCLastErrorString,"success",32);
		    memset(e->RPCLastErrorString,0,PREFIX+RPCERR_SIZE);
		    strncpy(e->RPCLastErrorString,"[RMT] ",PREFIX);
        strcat(e->RPCLastErrorString,"success");
        if (datasize == 0) break;
        if (prot == 5)
        {
          if (!e->blksin) e->counter = Pheader->counter;   /* new set */
          if (Pheader->numblks > 1 && e->counter != Pheader->counter)   /* we're being passed */
          {
            if (Pheader->counter < e->counter || Pheader->counter > e->counter + 30)
            {
              e->blksin = 0; e->Bytesin = 0;
              e->counter = Pheader->counter;       /* more recent set */
            }
            else goto bow;                       /* old stuff coming in */
          }
          dataPtr = (Pheader->blknum-1)*Pheader->mtu;
          if ((int)dcmpsize < doutsize) 
          {
            cln_bad_alignmentcnt++;
            bowout(" data alignment");
          }
          if (dataPtr+doutsize > (int)datasize) bowout(" size mismatch");
          if (Pheader->numblks > 1)
          {
            if (e->outBuf == NULL && (e->outBuf=(BYTE *)calloc(1,datasize+RPCERR_SIZE)) == NULL) bowout(" no memory");
            if (doutsize > 0) memcpy(&e->outBuf[dataPtr],&buf[bytesread+pstepsize],doutsize);
          }
          else
          {
            if (doutsize > 0) memcpy(&(rpcDATAOUT(e))[dataPtr],&buf[bytesread+pstepsize],doutsize);
          }
          if (debug > 1 || (debug && BASEMODE(e->mode) <= CM_SINGLE)) 
		        sprintf(&strbuf[strlen(strbuf)],"Long datagram block %d of %d\n",Pheader->blknum,Pheader->numblks);
          e->Bytesin += doutsize;
		      if (++(e->blksin) < Pheader->numblks) goto bow;
          if (Pheader->numblks > 1 && !e->isBeingAccessed) 
          {
            memcpy(rpcDATAOUT(e),e->outBuf,dcmpsize);
            //if (e->RPCLastErrorString[PREFIX] == 0)
            //  memcpy(&e->RPCLastErrorString[PREFIX],&e->outBuf[],gapptr);
          }
        }
		    else
        {
		      if (doutsize > (int)datasize) 
          {
            cln_size_mismatchcnt++;
            bowout(" size mismatch");
          }
		      if (doutsize > 0) memcpy(rpcDATAOUT(e),&buf[bytesread+pstepsize],doutsize);
          e->Bytesin = datasize;
        }
        dretsize = e->Bytesin - (cc == 0 ? 0 : RPCERR_SIZE);
		    if (dretsize < (int)datasize) memset(&(rpcDATAOUT(e))[dretsize],0,dcmpsize-dretsize);
		    if (fmtsize > 0) 
        {
		      e->lastDataSize = dretsize/fmtsize;
		      if (e->formatOut == CF_SPECTRUM) e->lastDataSize -= 24;
        }
		    break;
      case use_stream_transport:
		    e->RPCprotocol = 1;
		    e->time = 0L;
		    e->CompCode = cc;
		    bowout(" use stream");
    }
    switch (BASEMODE(e->mode))
    {
      case CM_CANCEL : 
        bowout(" cancelled");
      default:
      case CM_SINGLE : 
        if (e->ID != 0) e->mode = CM_CANCEL;  // got reply
		    e->heartbeat = 0;
		    break;
      case CM_REFRESH: e->heartbeat = 5 + HEARTBEAT;
        break;
      case CM_POLL   : e->heartbeat = 2 + e->PollRate/1000;
        break;
    }
    e->CompCode = cc;
    e->blksin   = 0; e->Bytesin = 0;

    if (BASEMODE(e->mode)>CM_SINGLE && counter > 0)
    {
      renewalMultiplier = 1;
      if (e->PollRate < 500) renewalMultiplier = 3;
	    if (counter < REMINDER*renewalMultiplier) e->heartbeat = SUB_PENDING;
      else if (counter <= ACK_REQUEST*renewalMultiplier) e->heartbeat = ACK_PENDING;
    }

    NotifyClients(e);

  bow:bytesread += msgsize;
    if (debug && strlen(strbuf)) output(strbuf);
    if (msgsize == 0) return tc;  // avoid potential infinite loop
    Pheader = (ProducerHeaderStruct *)&buf[bytesread];
    Pheader4 = (ProducerHeaderStruct4 *)&buf[bytesread];
  }
  cc = 0;
  err:
  if (cc && debug)
  {
    sprintf(strbuf,"ConsumeData : %s",erlst[cc]);
    output(strbuf);
  }
  return tc;
}
void CheckConnections(void)
{
  ElemDataStruct *e;
  time_t timestamp;
  struct timeval tv;
  static struct timeval tv0 = {0, 0};
  static time_t lastaddrreq = 0;
  char str[128];
  int i, delta_t;

  if (WorkAreaSemaphore) return;
  gettimeofday(&tv,(struct timezone *)NULL);
  timestamp = tv.tv_sec;
  if (tv0.tv_sec == 0) tv0 = tv;
  delta_t = MSECS(tv,tv0);
  tv0 = tv;
  for (e = ElemList; e; e = e->Next)
  {
    if (e->RPCprotocol < 4 || e->mode == CM_REGISTER || e->mode == CM_CANCEL) continue;
    if (!e->isInitializing && BASEMODE(e->mode) > CM_SINGLE && e->CompCode != e->LastCode)
    {
      sprintf(str,"%s %s %s : %s",e->ElemName,e->DeviceName,e->Property,
        e->CompCode > 0 ?  e->RPCLastErrorString : "attached");
      messageLog(str,e->CompCode);
      e->LastCode = e->CompCode;
    }
    if (timestamp > (time_t)(e->time + e->heartbeat))
    {
      if (debug > 2)
      {
        sprintf(strbuf,"%s %s (id %d) timed out",e->ElemName,e->Property,e->ID);
        OutputToDebugFile("CheckConnections",strbuf);
      }
	    if (BASEMODE(e->mode))
	    {
        e->RPCtimestamp = 0;
        e->CompCode = link_not_open;
        e->CompLoc = 0;
        e->blksin = 0; e->Bytesin = 0;
        if (RPCFec[e->FecIndex].Prot == LCL) e->timeoutCount = -1; // force immediate address resolution
        if ((e->mode == CM_SINGLE || e->timeoutCount-- < 0) && lastaddrreq != timestamp) 
        {
          sprintf(str,"%s %s %s : re-acquire address",e->ElemName,e->DeviceName,e->Property);
          messageLog(str,e->CompCode);
	        RPCFec[e->FecIndex].Prot = 0;  // force address resolution
          locateTagName(e->Context,e->ElemName,FALSE);
	        e->timeoutCount = 30;
          if (e->TCPsocket > 0) 
          {
            if (debug > 2)
            {
              sprintf(strbuf,"remove TCP connection due to timeout (sck %d)",e->TCPsocket);
              OutputToDebugFile("CheckConnections",strbuf);
            }
            CloseConnectionSocket(e->TCPsocket);
          }
          lastaddrreq = timestamp;
        }
        SetErrorString(e->RPCLastErrorString,e->CompCode,e->CompLoc);
        if (BASEMODE(e->mode) > CM_SINGLE) e->heartbeat = SUB_PENDING;
        else
        {
	        if (e->ID != 0) e->mode = CM_CANCEL;
	        e->heartbeat = 0;
        }
        NotifyClients(e);
      }
      else if (e->heartbeat > 0) e->lockCount = 0;  // dangling link element
    }
  }
  for (i=0; i<nIdleConnections;i++)
  {
    IdleConnections[i].ttl -= delta_t;
    if (IdleConnections[i].ttl < 0)
    {
      if (debug > 2)
      {
        sprintf(strbuf,"remove idle TCP connection %d (sck %d)",i,IdleConnections[i].sck);
        OutputToDebugFile("CheckConnections",strbuf);
      }
	    e = CloseConnectionSocket(IdleConnections[i].sck);
	    RemoveIdleConnection(i);
      if (e != NULL) RemoveElem(e);
    }
  }
  return;
}
void Cleanup(void)
{
  int i;
  ElemDataStruct *e,*elem;
  double interim = (double)time(NULL);

  if (WorkAreaSemaphore) return;

  if (ControlNet) for (i=0; i<nglobals; i++)  // are the broadcasts coming in ?
  {
    if (GlobalList[i].ID > 0 && interim > GlobalList[i].cTimeStamp + GlobalList[i].heartbeat*3)
    {
      GlobalList[i].cTimeStamp = interim;
      link[GlobalList[i].ID].dataFlg = link_not_open;
      if (debug)
      {
	      sprintf(strbuf,"missing global: %s\n",GlobalList[i].keyword);
	      output(strbuf);
      }
    }
  }
  for (e=ElemList; e;)  // garbage collection
  {
    elem = e; e = e->Next;
    if (elem->RPCprotocol >= 4 && BASEMODE(elem->mode) == CM_CANCEL && elem->heartbeat != SUB_PENDING)
    {
      // CM_SINGLE requests are immediately marked for cancellation.
      // BUT we can't remove the link element before the APP has a chance to
      // call GETRPCDATA ...
      if (elem->PrimeMode > CM_SINGLE && elem->PrimeMode < CM_REGISTER) elem->lockCount = 0;
      if (elem->lockCount <= 0) RemoveElem(elem);
    }
  }
  for (i=1; i<MAXHOTLINKS; i++) if (link[i].active > 0) // garbage collection
  {
    if (link[i].callback == NULL && !IsWindow(link[i].hWnd) && 
        !IsWindow(link[i].hCtrlWnd) && link[i].hWnd != hDLLWnd) 
    {
      if (debug) { sprintf(strbuf,"removing stranded link %d\n",i); output(strbuf); }
      RemoveRPC(i);
    }
    if (BASEMODE(link[i].mode) == CM_SINGLE)
    {
      if (link[i].cnt-- <= 0 && link[i].hWnd != hDLLWnd) RemoveRPC(i);
      if (link[i].dataFlg == 0) RemoveRPC(i);
    }
  }
  if (!initialized) return;
  // check up on descriptor sets on the queues ...
  while (GetDatagram(ConsumerSocket,UDP) > 0);
  if (IPXloaded) while (GetDatagram(IPXConsumerSocket,IPX) > 0);
  while (GetDatagram(MCastConsumerSocket,UDPBCST) > 0);
  if (IPXloaded) while (GetDatagram(IPXMCastConsumerSocket,IPXBCST) > 0);
  for (e=ElemList; e; e=e->Next)  // pickup the TCP sockets ...
  {
    if (e->TCPsocket > 0) while (GetDatagram(e->TCPsocket,TCP) > 0);
  }
  while (GetDatagram(GlobalSocket,GLB) > 0);
  return;
}
int RetardClientCycle = 0;
int checkSubscriptionEngine(void)
{
  int i, retry = 2;
  if (WorkAreaSemaphore) return 0; else WorkAreaSemaphore = 1;
  i = PrepSubBuffer(WorkArea);
  WorkAreaSemaphore = 0;
  return i;
}
void CheckSubscriptions(void)
{
  while (checkSubscriptionEngine() >= 0) Sleep(RetardClientCycle);
  return;
}
void dumpData(BYTE *data,short size,short format)
{
  int i;
  sprintf(strbuf,"Sending %d elements <%d>: ",size,format);
  switch (format)
  {
    case CF_BYTE: 
      for (i=0; i<size && i < 10; i++)
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((BYTE *)data)[i]);
      break;
    case CF_SHORT:
      for (i=0; i<size && i < 10; i++)
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((short *)data)[i]);
      break;
    case CF_SI:
      for (i=0; i<size && i < 10; i++)
      {
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((short *)data)[i*6]);
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((long *)data)[i*6+2]);
      }
      break;
    case CF_LONG:
      for (i=0; i<size && i < 10; i++)
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((long *)data)[i]);
      break;
    case CF_II:
      for (i=0; i<size && i < 10; i++)
      {
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((long *)data)[i*8]);
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((long *)data)[i*8+4]);
      }
      break;
    case CF_FLOAT:
      for (i=0; i<size && i < 10; i++)
	      sprintf(&strbuf[strlen(strbuf)],"%g ",((float *)data)[i]);
      break;
    case CF_FI:
      for (i=0; i<size && i < 10; i++)
      {
	      sprintf(&strbuf[strlen(strbuf)],"%g ",((float *)data)[i*8]);
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((long *)data)[i*8+4]);
      }
      break;
    case CF_DOUBLE:
      for (i=0; i<size && i < 10; i++)
	      sprintf(&strbuf[strlen(strbuf)],"%g ",((double *)data)[i]);
      break;
    case CF_DI:
      for (i=0; i<size && i < 10; i++)
      {
	      sprintf(&strbuf[strlen(strbuf)],"%g ",((double *)data)[i*12]);
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((long *)data)[i*12+4]);
      }
      break;
    case CF_CHAR8:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*8],8);
	      strcat(strbuf," ");
      }
      break;
    case CF_CHAR8I:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*12],8);
	      sprintf(&strbuf[strlen(strbuf)]," %d ",((long *)data)[i*12+8]);
      }
      break;
    case CF_CHAR16:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*16],16);
	      strcat(strbuf," ");
      }
      break;
    case CF_CHAR16I:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*20],16);
	      sprintf(&strbuf[strlen(strbuf)]," %d ",((long *)data)[i*20+16]);
      }
      break;
    case CF_CHAR32:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*32],32);
	      strcat(strbuf," ");
      }
      break;
    case CF_CHAR32I:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*36],32);
	      sprintf(&strbuf[strlen(strbuf)]," %d ",((long *)data)[i*36+32]);
      }
      break;
    case CF_CHAR48:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*48],48);
	      strcat(strbuf," ");
      }
      break;
    case CF_CHAR48I:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*52],48);
	      sprintf(&strbuf[strlen(strbuf)]," %d ",((long *)data)[i*52+48]);
      }
      break;
    case CF_TEXT:
      strncpy(&strbuf[strlen(strbuf)],(char *)data,MIN(strlen(data),sizeof(strbuf)-strlen(strbuf)));
      break;
    default:
      case CF_STRUCT:
      for (i=0; i<size && i < 80; i++)
	      sprintf(&strbuf[strlen(strbuf)],"%x ",((BYTE *)data)[i]);
      break;
    case CF_CHAR16FI:
      for (i=0; i<size && i < 10; i++)
      {
	      strncpy(&strbuf[strlen(strbuf)],&((char *)data)[i*24],16);
	      sprintf(&strbuf[strlen(strbuf)]," %g ",((float *)data)[i*24+16]);
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((float *)data)[i*24+20]);
      }
      break;
    case CF_TDS:
      for (i=0; i<size && i < 10; i++)
      {
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((UINT32 *)data)[i*12]);
	      sprintf(&strbuf[strlen(strbuf)],"%g ",((float *)data)[i*12+4]);
	      sprintf(&strbuf[strlen(strbuf)],"%d ",((long *)data)[i*12+8]);
      }
      break;
  }
  output(strbuf);
}
char *modetoa[] = { "CANCEL","SINGLE","REFRESH","POLL","REGISTER" };
int PrepSubBuffer(BYTE *data)
{
  HeaderStruct *h = (HeaderStruct *)data;
  int FECindex=-1,i,j,sck,pktlen,dsize,totalsize=sizeof(HeaderStruct);
  struct subscription *s = (struct subscription *)&data[totalsize];
  struct subscription4 *s4 = (struct subscription4 *)&data[totalsize];
  ElemDataStruct *e,*el = NULL;
  time_t timestamp = time(NULL);
  short stepsize,prot = 0;
  TCPBCKT *bckt;
  int transport = 0,retry = 2,isDiscardable;

  if (data == NULL) return -1;
  for (e = ElemList,j=0; e; e = e->Next)
  {
     if (e->RPCprotocol < 4 || e->heartbeat < SUB_PENDING) continue; 
    if (e->mode == CM_REGISTER) continue;
    isDiscardable = 0;
    if (!j)
    {
      FECindex=e->FecIndex;
      pktlen = RPCFec[FECindex].Prot == IPX ? IPX_BUFFER_SIZE : UDP_BUFFER_SIZE;
      memset(data,0,pktlen);
      if (RPCFec[FECindex].MaxRPCProt == 0) e->RPCprotocol = RPCFec[FECindex].MaxRPCProt = 5;
      if ((prot=e->RPCprotocol) == 4)
      {
        stepsize = SUBSCRIPTION4_SIZE;
        e->datamtu = pktlen-stepsize-HEADERSTRUCT_SIZE;
        e->numblksIn = 1;
      }
      else stepsize = SUBSCRIPTION_SIZE;
    }
    else if (FECindex != e->FecIndex) continue;

    if (RPCFec[FECindex].Prot == LCL)
    {
      transport = LCL;
    }
    else if (e->mode & CM_CONNECT)
    {
      if (transport == UDP || transport == IPX) continue;
      if (e->TCPsocket == 0)                   /* not yet connected */
      {
         for (el=ElemList; el != NULL; el=el->Next)
          if (el->FecIndex == FECindex && el->TCPsocket != 0)
          {
            e->TCPsocket = el->TCPsocket;      /* some one else is ! */
            break;
          }
      }
      for (i=0; i<nIdleConnections; i++) 
      {
        if (IdleConnections[i].idx == FECindex)
        {
          if (debug > 2)
          {
            sprintf(strbuf,"reuse idle TCP connection %d (sck %d)",i,IdleConnections[i].sck);
            OutputToDebugFile("PrepSubBuffer",strbuf);
          }
          e->TCPsocket = IdleConnections[i].sck;
          RemoveIdleConnection(i);  // no longer idle
          break;
        }
      }
      if (e->TCPsocket == 0)                   /* still not connected */
      {
        if ((sck=connectTCP(gtTCPPort,e)) >= 0) /* success */
        {
          if (debug > 2)
          {
            sprintf(strbuf,"establish TCP connection (sck %d)",sck);
            OutputToDebugFile("PrepSubBuffer",strbuf);
          }
          if ((bckt=getBucket(sck)) != NULL) 
          {
            bckt->idx = FECindex;
            RPCFec[FECindex].Prot |= TCP;
            e->TCPsocket = sck;
            e->protocol = TCP;
          }
          else 
          {
            if (debug > 2)
            {
              sprintf(strbuf,"no free bucket, close TCP connection (sck %d)",sck);
              OutputToDebugFile("PrepSubBuffer",strbuf);
            }
            CloseConnectionSocket(sck);
          }
        }
      }
      sck = e->TCPsocket;
      transport = TCP;
    }
    else
    {
	    if (transport == TCP) continue;
	    sck = 0;  // let SendSubBuffer figure it out
	    transport = (RPCFec[FECindex].Prot & IPX) ? IPX : UDP;
    }

    if (prot == 4)
    {
      s4->PollingRate = (UINT16)e->PollRate;
      s4->id = (unsigned short)e->ID;
      s4->mode = BASEMODE(e->mode);
      s4->starttime = e->starttime;
      strncpy(s4->contract.EqpName,e->EqName,EQNAME_SIZE);
      strncpy(s4->contract.Property,e->Property,12);

      s4->contract.EqpNumber = e->EqNo;
      s4->contract.EqpSize = (UINT16)MAX(e->sizeOut,e->sizeIn);
      s4->contract.EqpFormat = e->formatOut == CF_TEXT ? 1 : e->formatOut;
 
      if (e->sizeIn > 0)
      {
          dsize = s4->contract.EqpSize*fmtsizeof(s4->contract.EqpFormat);
          if ((totalsize + stepsize + dsize) > pktlen)
          {
	          if (totalsize == sizeof(HeaderStruct)) e->RPCprotocol = 1;
	          break;
          }
          memcpy(&data[totalsize+stepsize],rpcDATAIN(e),dsize);
          s4->contract.EqpSize *= -1;
      }
      else dsize = 0;
      s4->msgsize = stepsize + dsize;
      totalsize += stepsize + dsize;
      s4 = (struct subscription4 *)&data[totalsize];
    }
    else
    {
      s->mtu = e->datamtu;
      s->numblks = (BYTE)e->numblksIn;
      s->blknum = (BYTE)e->blknumIn;
      s->blkid = e->blkidIn;
      s->PollingRate = e->PollRate;
      s->id = (unsigned short)e->ID;
      s->mode = TARGETMODE(e->mode);
      s->starttime = e->starttime;
      if (e->isDiscardable) s->starttime = 1;
      strncpy(s->contract.EqpName,e->EqName,6);
      strncpy(s->contract.EqpProperty,e->Property,32);
      strncpy(s->contract.EqpDeviceName,e->DeviceName,16);
      if (strlen(e->DeviceName) > 16 && strlen(e->Property) <= 16)
      {
        s->contract.EqpDeviceName[15] = '&';
        s->contract.EqpProperty[16] = 0;
        strncpy(&s->contract.EqpProperty[17],&e->DeviceName[15],15);
      }
      s->contract.EqpSizeOut = e->sizeOut;
      s->contract.EqpFormatOut = BFMT(e->formatOut);
      strncpy(s->contract.strTagOut,e->strTagOut,8);
      s->contract.EqpSizeIn = e->sizeIn;
      s->contract.EqpFormatIn = BFMT(e->formatIn);
      strncpy(s->contract.strTagIn,e->strTagIn,8);
      s->contract.EqpAccess = (BYTE)e->access;
      if (e->sizeIn > 0)
      {
        dsize =  e->nextDataSize;
        if ((totalsize + stepsize + dsize) > pktlen) break;
        memcpy(&data[totalsize+stepsize],&(rpcDATAIN(e))[e->nextDataPtr],dsize);
      }
      else dsize = 0;
      if (dsize % 2 != 0) dsize++;
      s->msgsize = stepsize + dsize;
      totalsize += stepsize + dsize;
      s = (struct subscription *)&data[totalsize];
    }
    if (e->mode == CM_CANCEL) e->lockCount = 0; // finished with the link

    j++;

    if (debug)
    {
      sprintf(strbuf,"Subscribe: %s %s %s (i:%d %d o:%d %d) p%d (%d of %d -%d-)[%s] (%d ms) <%s>\n",
              e->ElemName,e->DeviceName,e->Property,
              e->sizeIn,e->formatIn,e->sizeOut,e->formatOut,prot,
              e->blknumIn,e->numblksIn,e->blkidIn,
              RPCFec[FECindex].Name,e->PollRate,modetoa[BASEMODE(e->mode)]);
      output(strbuf);
    }
    if (e->blknumIn == e->numblksIn)
    {
      isDiscardable = e->isDiscardable;
      e->blknumIn = 1;
      e->nextDataPtr = 0;
      e->blkidIn = (++(e->blkidIn))%1000;
      e->BytesRemaining = e->BytesTotal;
      switch (BASEMODE(e->mode))
      {
        case CM_SINGLE:
          e->heartbeat = 1 + e->PollRate/1000;
          break;
        case CM_REFRESH:
          e->heartbeat = e->CompCode == link_not_open ? REPLY_PENDING : 5+HEARTBEAT;
          break;
        default:
          e->heartbeat = 2 + e->PollRate/1000;
          break;
      }
//      e->heartbeat = BASEMODE(e->mode) != CM_REFRESH ? 2+e->PollRate/1000 :
//                      e->CompCode == link_not_open ? REPLY_PENDING : 5+HEARTBEAT;
      e->time = timestamp;
//      RetardClientCycle = 1;
      RetardClientCycle = 0;
    }
    else if (e->sizeIn > 0)
    {
      if (prot != 5) 
      {
        if (debug)
        {
          sprintf(strbuf,"Long Datagrams can only be used with protocol 1 or 5\n");
          output(strbuf);
        }
        e->RPCprotocol = 1;
        return -1;
      }
      e->blknumIn++;
      e->nextDataPtr += e->nextDataSize;
      e->BytesRemaining = e->BytesTotal - e->nextDataPtr;
      RetardClientCycle = 10;
    }
    e->nextDataSize = (UINT16)MIN(e->datamtu,e->BytesRemaining);

    if (debug > 1 && e->sizeIn > 0 && e->blknumIn == e->numblksIn) 
      dumpData(rpcDATAIN(e),(short)e->sizeIn,e->formatIn);
    if (isDiscardable) { RemoveElem(e); break; }
    if ((totalsize + stepsize) > pktlen) break;  // no more packing possible
  }

  h->TotalSize = totalsize;
  memcpy(h->UserName,username,16);
  h->Protocol = prot;
  h->EqpSize = j;

  if (FECindex >= 0)
  {
    if (RPCFec[FECindex].Prot == 0) transport = 0; // signal address re-resolution!
    while (retry-- && SendSubBuffer(FECindex,sck,transport,WorkArea)) Sleep(10);
  }
  return FECindex;
}
int SendSubBuffer(int FECindex,int sck,int transport,BYTE *data)
{
  int cc=0,retrycnt=1;
  UINT16 poff;
  static CLIENT cln;
  static BYTE reg_sock[2];

  memset(&cln,0,sizeof(CLIENT));
  strncpy(cln.userName,RPCFec[FECindex].Name,16);
  cln.transport = transport;
  poff = GetPortOffset(&RPCFec[FECindex]);
retry:
  switch (transport)
  {
    case   0:
      if (locateFecName(RPCFec[FECindex].Name) < 0) ccerr(link_not_open);
      if (retrycnt-- > 0) goto retry; else ccerr(non_existent_fec);
    case LCL:
      memcpy(&cln.sck,RPCFec[FECindex].Network,4);
      break;
    case IPX:
      if (!IPXloaded) return ipx_not_supported;
      reg_sock[0] = REG_SOCKET + (BYTE)poff;
      reg_sock[1] = REG_SOCKET + (BYTE)poff;
      memset(&ipx_prod_name,0,sizeof(ipx_prod_name));
      memcpy(&ipx_prod_name.sa_netnum, &RPCFec[FECindex].Network, 4);
      memcpy(&ipx_prod_name.sa_nodenum, &RPCFec[FECindex].Node, 6);
      memcpy(&ipx_prod_name.sa_socket, &reg_sock, 2);
      ipx_prod_name.sa_family = AF_NS;
      memcpy(&cln.IPXaddress,&ipx_prod_name,sizeof(ipx_prod_name));
      cln.sck = IPXConsumerSocket;
      break;
    case UDP:
      if (!RPCFec[FECindex].iaddr) ccerr(non_existent_fec);
      memset(&prod_name,0,sizeof(prod_name));
      memcpy(&prod_name.sin_addr,&RPCFec[FECindex].iaddr,sizeof(struct in_addr));
      prod_name.sin_family=AF_INET;
      prod_name.sin_port = htons((UINT16)(gtUDPPort + poff));
      memcpy(&cln.IPaddress,&prod_name,sizeof(prod_name));
      cln.sck = ConsumerSocket;
      break;
   case TCP:
      if (!TCPloaded) return tcp_not_supported;
      if (sck == 0) ccerr(link_not_open);
      memset(&prod_name,0,sizeof(prod_name));
      memcpy(&prod_name.sin_addr,&RPCFec[FECindex].iaddr,sizeof(struct in_addr));
      prod_name.sin_family=AF_INET;
      prod_name.sin_port = htons((UINT16)(gtTCPPort + poff));
      memcpy(&cln.IPaddress,&prod_name,sizeof(prod_name));
      cln.sck = sck;
      break;
   default:
      ccerr(not_implemented);
  }
  cc = sendDatagram(&cln,data);
err:
  return cc;
}
int SendUDPData(CLIENT *cln,BYTE *data,int UDPsocket)
{
	int msgsize = *(short *)data;
	struct fd_set fdwset;
	struct timeval wait_to;
	char *c;

	if (!TCPloaded) return tcp_not_supported;
	if (msgsize > UDP_BUFFER_SIZE) return use_stream_transport;
	FD_ZERO(&fdwset); FD_SET(UDPsocket,&fdwset);
	wait_to.tv_sec=0;  wait_to.tv_usec=0;
	switch (select(32,NULL,&fdwset,NULL,&wait_to))
	{
    case 1:  break;
    case 0:  return tcp_socket_error;
    default: if (debug) soperror("select");
      return tcp_socket_error;
	}
  if (sendto(UDPsocket,(char *)data,msgsize,0,
             (struct sockaddr *)&cln->IPaddress,sizeof(cln->IPaddress)) < 0)
  {
    if (debug) soperror("sendto");
    return tcp_socket_error;
  }
  if (debug)
  {
    if ((c=inet_ntoa(cln->IPaddress.sin_addr)) != NULL) strncpy(clientaddr,c,16);
    sprintf(strbuf,"UDP: %d bytes sent to %s:%d\n",msgsize,clientaddr,UDPsocket);
    output(strbuf);
  }
  return 0;
}
#define RECENT_LINKS_DEPTH 20
int recentLinkIds[RECENT_LINKS_DEPTH];
int lastAssignedLinkID = -1;
int getNextLinkID(short id)
{
  int i,j,found;
  static int recentLinkPtr = -1;
  if (!initialized) return -not_accepted;
  if (recentLinkPtr < 0) memset(recentLinkIds,0,RECENT_LINKS_DEPTH*sizeof(int));
  if (id > 0 && id < MAXHOTLINKS && link[id].active <= 0) return id;
  for (i=1; i<MAXHOTLINKS; i++)
  {
    for (j=0, found=0; j<RECENT_LINKS_DEPTH && !found; j++) 
      if (i == recentLinkIds[j]) found = -1;
    if (!link[i].active && !found) break;
  }
  if (i == MAXHOTLINKS) return -link_exhausted;  // error: link table full
  recentLinkPtr = (recentLinkPtr+1)%RECENT_LINKS_DEPTH;
  recentLinkIds[recentLinkPtr] = i;
  link[i].active = -1;
  if (debug)
  {
    sprintf(strbuf,"Assigned link id %d\n",i);
    output(strbuf);
  }
  return i;
}
int ReleaseRPCSemaphore(HANDLE hSem)
{
//  return ReleaseSemaphore(hSem,1,NULL);
	return LeaveMeteredSection((LPMETERED_SECTION)hSem,1,NULL);
}
int OpenRPCSemaphore(char *lpszSemaphore)
{
//  return OpenSemaphore(SEMAPHORE_ALL_ACCESS,FALSE,lpszSemaphore);
	return (int)CreateMeteredSection(0,1,lpszSemaphore);
}
int CreateRPCSemaphore(char *lpszSemaphore)
{
//  return CreateSemaphore(NULL,0,1,lpszSemaphore);
	return (int)CreateMeteredSection(0,1,lpszSemaphore);
}
void CloseRPCSemaphore(HANDLE hSem)
{
//  CloseHandle(hSem);
	CloseMeteredSection((LPMETERED_SECTION)hSem);
}
int WaitRPCSemaphore(HANDLE hSemaphore,char *lpszSemaphore,int timout,int isLocal)
{
  int i, cc = 0, to = 0, sameThread = -1;
  MSG msg;
# ifdef USE_SHARED_MEMORY
  if (thisUsage != 1) sameThread = 0;
# endif
  if (sameThread)  // same thread as engine
  {
    if (isLocal) timout *= 20; // if local, can't stop Windows messages, so just spin ...
    for (i=0; (EnterMeteredSection((LPMETERED_SECTION)hSemaphore,to)==WAIT_TIMEOUT) && i < timout; i++)
    {
      while (PeekMessage(&msg, hDLLWnd, 0, 0, PM_REMOVE));
      SendMessage(hDLLWnd,WM_TIMER,0,0);
      if (to == 0 && !isLocal && i == timout - 1) 
      {
        to = breakingFactor;
        i = 1;
        timout /= breakingFactor;
      }
    }
    if (i >= timout) ccerr(not_ready);
  }
  else
  {
	  if (EnterMeteredSection((LPMETERED_SECTION)hSemaphore,timout) == WAIT_TIMEOUT) ccerr(semaphore_busy);
  }
err:
  if (cc && debug)
  {
    sprintf(strbuf,"Wait timeout for semaphore %s : Usage %d\n",lpszSemaphore,thisUsage);
    output(strbuf);
  }
  return cc;
}
int WaitForRPCSemaphore(HANDLE hSemaphore,char *lpszSemaphore,int timout)
{
  int i,cc=0,sameThread = -1;
# ifdef USE_SHARED_MEMORY
  if (thisUsage != 1) sameThread = 0;
# endif
  if (sameThread)  // same thread as engine
  {
    for (i=0; (i <= timout/5) && (WaitForSingleObject(hSemaphore,5)==WAIT_TIMEOUT); i++)
	  SendMessage(hDLLWnd,WM_TIMER,0,0); 
    if (i > timout/5) ccerr(not_ready);
  }
  else 
	if (WaitForSingleObject(hSemaphore,timout) == WAIT_TIMEOUT) ccerr(semaphore_busy);
err:
  if (cc && debug)
  {
    sprintf(strbuf,"Wait timeout for semaphore %s : Usage %d\n",lpszSemaphore,thisUsage);
    output(strbuf);
  }
  return cc;
}
__declspec(dllexport) short ExecLinkEx(char *devname,char *devprop,DTYPE *dout,DTYPE *din,short access,long pollrate)
{
  DBLK dbout,dbin,*dboutptr=NULL,*dbinptr=NULL;

  if (dout != NULL)
  {
    dbout.dArrayLength = dout->dArrayLength;
    dbout.dFormat = dout->dFormat;
    strncpy(dbout.dTag,dout->dTag,8);
    dboutptr = &dbout;
  }
  if (din != NULL)
  {
    dbin.dArrayLength = din->dArrayLength;
    dbin.dFormat = din->dFormat;
    strncpy(dbin.dTag,din->dTag,8);
    dbinptr = &dbin;
  }

  return dllExecLinkEx(devname,devprop,dboutptr,dout->data.vptr,dbinptr,din->data.vptr,access,pollrate);
}
__declspec(dllexport) short ExecLink(char *devname,char *devprop,DTYPE *dout,DTYPE *din,short access)
{
  return ExecLinkEx(devname,devprop,dout,din,access,1000);
}
__declspec(dllexport) short PASCAL SetNotificationTolerance(int i, float toleranceAbsolute, float tolerancePercent)
{
	if (i > MAXHOTLINKS || i < 1) return argument_list_error;
	if (!link[i].active) return ask_error;
  if (toleranceAbsolute <= 0 && tolerancePercent <= 0) return 0; /* no reason to allocate a dtf */
  link[i].dtf = (DataToleranceFactor *)calloc(1,sizeof(DataToleranceFactor));
  if (link[i].dtf == NULL) return out_of_local_memory;
  link[i].dtf->absolute = toleranceAbsolute;
  link[i].dtf->percent = tolerancePercent;
  return 0;
}
__declspec(dllexport) int AttachLink(char *devName,char *devprop,
				DTYPE *dout,DTYPE *din,short access,int pollrate,
        void (*callback)(int,int),int mode)
{
  DBLK dbout,dbin,*dboutptr=NULL,*dbinptr=NULL;
  void *inptr = NULL;
  int i, dsize = 0, wait = 0;
  ElemDataStruct *e = NULL;

  if (dout != NULL)
  {
    dbout.dArrayLength = dout->dArrayLength;
    dbout.dFormat = dout->dFormat;
    strncpy(dbout.dTag,dout->dTag,8);
    dboutptr = &dbout;
    dsize = dout->dArrayLength * fmtsizeof(dout->dFormat);
  }
  if (din != NULL)
  {
    dbin.dArrayLength = din->dArrayLength;
    dbin.dFormat = din->dFormat;
    strncpy(dbin.dTag,din->dTag,8);
    dbinptr = &dbin;
    inptr = din->data.vptr;
  }
  wait = mode & CM_WAIT; mode &= ~(CM_WAIT);
  if ((i=OpenLink(hDLLWnd,devName,devprop,dboutptr,dbinptr,inptr,access,pollrate,(short)mode)) < 0)
    goto err;

# ifdef USE_SHARED_MEMORY
  link[i].hWnd  = hWatchdogWnd;
# else
  if (wait)
  {
    link[i].dataFlg = tExecLink(link[i].Elem->FecIndex,link[i].Elem->EqName,link[i].Elem->DeviceName,devprop,
                                (short)dout->dArrayLength,dout->data.vptr,dout->dFormat,500);
    if ((e=link[i].Elem) != NULL)
    {
      e->CompCode = link[i].dataFlg;
      e->isBeingAccessed = -1;
      memcpy(rpcDATAOUT(e),dout->data.vptr,dsize); // success
      e->isBeingAccessed = 0;
      e->lastDataSize = dout->dArrayLength;
      e->RPCtimestamp = time(NULL);
    }
  }
# endif
  link[i].hCtrlWnd  = (HWND)i;
  link[i].callback  = callback;
  link[i].dataOut   = dout->data.vptr;

err:
  return i;
}
short OpenLink(HWND hWnd,char *devName,char *devprop,
				DBLK *dout,DBLK *din,void *datain,
				short access,long timer,short mode)
{
  LCLCONTRACT *con = lclContract;
  HANDLE hLclContract = 0;
  HANDLE hContract=0,hSubSema = 0;
  short cc = 0,fmtin,fmtout,baseMode,isDiscardable = FALSE,supressDuplication;
  int i = 0, n, id;
  ElemDataStruct *e;
  HANDLE hDataBlock = 0;
  UINT32 dinsize,doutsize,sizin,sizout;
  char fulname[72],str[256];
  struct structStruct *s;
  char *cn = NULL,*en = NULL,*dn = NULL, *ap = NULL;
	
  supressDuplication = mode & CM_NODUPLICATES; mode &= ~(CM_NODUPLICATES);
  if (SystemSupressHeartbeatNotification && (mode & CM_REFRESH)) supressDuplication = TRUE;
  if (access & CA_DISCARD) 
  {
    isDiscardable = TRUE;
    access &= ~CA_DISCARD;
  }
  if ((mode & CM_BCAST || mode & CM_MCAST) && !ListenForMCasts)
  {
    if ((cc=ListenForMulticasts()) != 0) return cc;
  }
  baseMode = BASEMODE(mode);
  if (baseMode > CM_REGISTER  || baseMode < CM_CANCEL) return -illegal_mode;
  if ((dout && dout->dArrayLength < 0) || (din  && din->dArrayLength < 0)) return -argument_list_error;
  if (dout && dout->dArrayLength > 0)
  {
    if ((doutsize = dout->dArrayLength*fmtsizeof(dout->dFormat)) == 0) return -illegal_format;
    fmtout = dout->dFormat; sizout = dout->dArrayLength;
    if (fmtout == CF_STRUCT && (s=getStructFromTag(dout->dTag)) != NULL) sizout *= s->size;
  }
  else 
  {
    doutsize = 0; fmtout = CF_NULL; sizout = 0;
  }
  if (din  && din->dArrayLength > 0)
  {
    if ((dinsize = din->dArrayLength*fmtsizeof(din->dFormat)) == 0) return -illegal_format;
    if (datain == NULL) return -argument_list_error;
    fmtin = din->dFormat; sizin = din->dArrayLength;
    if (fmtin == CF_STRUCT && (s=getStructFromTag(din->dTag)) != NULL)
    {
      sizin *= s->size;
      dinsize = sizin;
    }
  }
  else 
  {
    dinsize = 0; fmtin = CF_NULL; sizin = 0;
  }

	if (devName == NULL || strlen(devName) == 0) return -non_existent_elem;
	if (devprop == NULL || strlen(devprop) == 0) return -illegal_property;

  strncpy(fulname,devName,71); fulname[71] = 0;
  if ((cn=strtok(fulname,DELIMITER)) == NULL) ccerr(argument_list_error);
  if ((en=strtok(NULL,DELIMITER)) == NULL) /* only one given */
  {
    en = cn; cn = NULL; dn = &fulname[71];
  }
  else if ((dn=strtok(NULL,DELIMITER)) == NULL) /* only two given */
  {
    if (cn == fulname) /* no leading delimiter */
    {
      dn = en; en = cn; cn = NULL;
    }
    else dn = &fulname[71];
  }
  else if ((ap=strtok(NULL,"\0")) != NULL) /* a '/' in the device name */
  {
    dn[strlen(dn)] = '/';  /* put it back */
  }

  if (debug > 2 ) 
  {
    sprintf(strbuf,"Open semaphore %s\n",lpszSubSemaphore);
    OutputToDebugFile("Subscribe",strbuf);
  }

  if ((hSubSema=OpenSemaphore(SEMAPHORE_ALL_ACCESS,FALSE,lpszSubSemaphore)) == 0)
    ccerr(semaphore_error);
  if ((cc=WaitForRPCSemaphore(hSubSema,lpszSubSemaphore,60)) != 0) ccerr(cc);

  if (debug > 2 ) 
  {
    sprintf(strbuf,"Get Link ID for %s %s\n",devName,devprop);
    OutputToDebugFile("Subscribe",strbuf);
  }
  if (!strcmp(devName,GLBEQM)) id = numglobals; else id = -1;
  if ((i=SendMessage(hDLLWnd,WM_GETLINKID,id,0)) < 0) ccerr(-i);

  sprintf(shmConTag,"%s:%d",CONTRACTNAME,i);
  if ((con=(LCLCONTRACT *)lclContractAlloc(shmConTag,&hLclContract)) == NULL)
    ccerr(out_of_shared_memory);

  memset(con,0,sizeof(LCLCONTRACT));
  if (cn!= NULL) strncpy(con->EqpContext,cn,16); else con->EqpContext[0] = 0;
  strncpy(con->EqpTagName,en,16);  
  if (dn != NULL) strncpy(con->EqpDeviceName,dn,32); else con->EqpDeviceName[0] = 0;
  strncpy(con->EqpProperty,devprop,32);
  con->EqpSizeOut      = sizout;
  con->EqpFormatOut    = BFMT(fmtout);
  if (dout) strncpy(con->strTagOut,dout->dTag,8);
  con->EqpSizeIn       = sizin;
  con->EqpFormatIn     = BFMT(fmtin);
  con->EqpAccess       = (BYTE) access;
  if (din) strncpy(con->strTagIn,din->dTag,8);

  if (dinsize)
  {
    sprintf(shmDataTag,"%s:%d",DATABLOCKNAME,i);
    if ((con->DataIn=(BYTE *)DataBlockAlloc(shmDataTag,dinsize,&hDataBlock)) == NULL)
      ccerr(out_of_shared_memory);
    memcpy(con->DataIn,datain,dinsize);
  }

  con->PollRate = timer;
	//if (baseMode == CM_SINGLE && timer < (dinsize + doutsize)/5) con->PollRate += (dinsize + doutsize)/5;

  if (debug > 2 ) 
  {
    sprintf(strbuf,"Create link for %s %s\n",devName,devprop);
    OutputToDebugFile("Subscribe",strbuf);
  }
  if ((cc=(short)SendMessage(hDLLWnd,WM_CREATELINK,i,0)) != 0) ccerr(cc);
  if (debug > 2 ) 
  {
    sprintf(strbuf,"Release semaphore %s\n",lpszSubSemaphore);
    OutputToDebugFile("Subscribe",strbuf);
  }

  link[i].hWnd      = NULL;
  link[i].hCtrlWnd  = hWnd;
  link[i].callback  = NULL;
  link[i].dataOut   = NULL;
  link[i].useErrValue = FALSE;
  link[i].dataFlg   = -not_posted;
  link[i].active    = 1;
  link[i].mode      = mode;
  link[i].cnt       = (short)((con->PollRate+2*RPC_TIMEOUT*1000)/SYSTEM_DELAY); // default cleanup counter
  link[i].supressDuplicates = supressDuplication;

  if (!(e=ContractAlloc(link[i].linkTag,link[i].linkSizeIn,link[i].linkSizeOut,&hContract)))
    ccerr(un_allocated);

  for (n=0; n<MAXCOMMONLINKS && (id=e->links[n]) >= 0; n++)
  {
    if (id == i) continue;               // the new one is definitely in the list 
    if (link[id].active <= 0) continue;  // just a place holder
    if (link[id].hCtrlWnd == hWnd) ccerr(link_error); // same link to same control not allowed !
  }

  if (e->RPCprotocol == 0) e->RPCprotocol = 5;
  if (e->RPCprotocol == 1)
  {
    if (baseMode == CM_SINGLE) ccerr(use_stream_transport);
    if (timer < 1000) e->PollRate = 1000;
  }
  e->lockCount++;         // hold on to the link until the App calls GETRPCDATA or timeout
  e->PrimeMode = maxmode(e->PrimeMode,mode);
  e->mode = e->PrimeMode;                             // common links all get highest mode
  e->heartbeat = SUB_PENDING;
  e->time      = e->RPCprotocol == 1 ? 0 : time(NULL);
  e->RPCtimestamp = 0;
  e->isDiscardable = isDiscardable;

  link[i].cnt  = (short)((e->PollRate+2*RPC_TIMEOUT*1000)/SYSTEM_DELAY); // refresh cleanup counter
err:
  if (cc || mode != CM_REGISTER)
  {
    sprintf(str,"OpenLink [%d] %s %s (%d bytes read %d bytes sent) %s %s %d ms: %s",
      i,devName,devprop,doutsize,dinsize, access & CA_WRITE ? "WRITE" : "READ",
      modetoa[BASEMODE(mode)],timer,erlst[cc]);
    messageLog(str,cc);
  }
  DataBlockFree(con->DataIn,hDataBlock);
  if (hContract) ContractFree(e,hContract);
  if (hLclContract) lclContractFree(con,hLclContract);
  if (hSubSema)
  { 
    ReleaseSemaphore(hSubSema,1,NULL);
    CloseHandle(hSubSema);
  }
  if (cc && i > 0 && i < MAXHOTLINKS) SendMessage(hDLLWnd,WM_REMOVELINK,i,0);
  if (cc == link_error) return id;
  return cc == 0 ? i : -cc;
}
short dllExecLinkEx(char *devname,char *devprop,DBLK *dout,void *dataout,DBLK *din,void *datain,short access,long timeout)
{
  short id = 0,cc = 0,rc,sameThread = -1,isRetry = 0, isDiscardable = 0;
  int mode,dsize,dinsize=0,doutsize=0,retry,tgtPollingRate,isLocal=FALSE;
  HANDLE hContract=0,hSyncMutex=0;
  ElemDataStruct *e = NULL;
  char lpszSyncMutex[64],s[256];
  static DBLK thisDout, thisDin;
  DBLK *dblkout = &thisDout,*dblkin = &thisDin;
  static int localSyncSemaphore = 0;  // protect against local re-entrancy 
  static int localTimeoutCounter = 0;

  if (localSyncSemaphore) return not_ready; else localSyncSemaphore = 1;
  cln_numsynccalls++;
# ifdef USE_SHARED_MEMORY
  if (thisUsage != 1) sameThread = 0;
# endif
  if (din) 
  {
    if ((int)din->dArrayLength < 0) ccerr(invalid_data);
    dinsize  = din->dArrayLength*fmtsizeof(din->dFormat);
  }
  if (dout) 
  {
    if ((int)dout->dArrayLength < 0) ccerr(invalid_data);
    doutsize = dout->dArrayLength*fmtsizeof(dout->dFormat);
  }
  // catch inadvertent short default timeouts ...
  if (timeout == 1000 && (dinsize+doutsize) > 5000) timeout = 2000;
  retry = timeout >= 1000 ? 1 : 0;
  if (dout != NULL) thisDout = *dout; else dblkout = NULL;
  if (din != NULL) thisDin = *din; else dblkin = NULL;
UDPretry:
  hContract=0; hSyncMutex=0;
  if ((id=OpenLink(0,devname,devprop,dblkout,dblkin,datain,access,timeout,CM_REGISTER)) < 0) ccerr(-id);
  link[id].hWnd = hDLLWnd;
# ifdef USE_SHARED_MEMORY
  sprintf(lpszSyncMutex,"SyncRPC:%d",id);
# else
  sprintf(lpszSyncMutex,"SyncRPC:%d:%d:%d",thisUsage,thisUsageMsec,id);
# endif
  if (debug > 2 ) 
  {
    sprintf(strbuf,"create semaphore %s\n",lpszSyncMutex);
    OutputToDebugFile("dllExecLinkEx",strbuf);
  }
  if ((hSyncMutex=(HANDLE)CreateRPCSemaphore(lpszSyncMutex)) == NULL) ccerr(semaphore_error);
  
  if (!(e=ContractAlloc(link[id].linkTag,link[id].linkSizeIn,link[id].linkSizeOut,&hContract))) ccerr(un_allocated);
  if (debug > 2 ) 
  {
    sprintf(strbuf,"lock link %d\n",id);
    OutputToDebugFile("dllExecLinkEx",strbuf);
  }
  if (SendMessage(hDLLWnd,WM_LOCKLINK,id,0)) ccerr(serr2);
  mode = CM_SINGLE;
  if (access & CA_CONNECT) mode |= CM_CONNECT;
  if (isRetry) mode |= CM_RETRY;
  link[id].mode = mode;
  e->PrimeMode = maxmode(e->PrimeMode,mode);
  e->mode = e->PrimeMode;
  isDiscardable = e->isDiscardable;
  SendMessage(hDLLWnd,WM_TIMER,0,0);
  if (isDiscardable) 
  {
    e = NULL; id = 0;
    ccerr(0);
  }
  if (debug > 2 ) 
  {
    sprintf(strbuf,"wait for semaphore %s\n",lpszSyncMutex);
    OutputToDebugFile("dllExecLinkEx",strbuf);
  }
  tgtPollingRate = e->PollRate;
  isLocal = RPCFec[e->FecIndex].Prot == LCL ? TRUE : FALSE;
  if ((cc=WaitRPCSemaphore(hSyncMutex,lpszSyncMutex,tgtPollingRate,isLocal)) != 0) 
  {
    SetErrorString(e->RPCLastErrorString,link_not_open,0);
    ccerr(link_not_open);
  }
  if ((cc=e->CompCode) == 0 || (cc & CE_SENDDATA))
  {
    if (e->sizeOut > 0)
    {
      if (dataout == NULL || 
		      IsBadWritePtr(dataout,dsize=e->sizeOut*getFormatSize(e->formatOut)) ) 
        ccerr(buffer_too_small);
      memcpy(dataout,rpcDATAOUT(e),dsize);
    }
  }
  gDataTimeStamp = putDataTimeStamp(0,e->RPCtimestamp,e->RPCtimestampMSEC);
  RPCtimestamp = e->RPCtimestamp;
err:
  if ((rc = (cc & 0x0fff)))
  {
    if (e == NULL) 
    {
      sprintf(RPCLastErrorString,"[LCL] %s",rc > 0 && rc < numErr ? erlst[rc] : "error undefined");
      strncpy(RPCLastErrorSource,"[INTERNAL]",PREFIX+RPCERR_SIZE);
    }
    else 
    {
	    strncpy(RPCLastErrorString,e->RPCLastErrorString,PREFIX+RPCERR_SIZE);
      strncpy(RPCLastErrorSource,e->FecName,PREFIX+RPCERR_SIZE);
    }
    sprintf(s,"ExecLink %s %s (%d bytes read %d bytes sent) %s : [%s] %s",
      devname,devprop,doutsize,dinsize,access & CA_WRITE ? "WRITE" : "READ",
      RPCLastErrorSource,RPCLastErrorString);
    messageLog(s,rc);
  }
  if (debug > 2 ) 
  {
    sprintf(strbuf,"removing link %d\n",id);
    OutputToDebugFile("dllExecLinkEx",strbuf);
  }
  if (hSyncMutex) CloseRPCSemaphore(hSyncMutex);
  if (e != NULL) 
  {
    if (sameThread && retry == 0 && (cc == link_not_open || cc == non_existent_elem))
    {
      localTimeoutCounter++;
      if (localTimeoutCounter > 20)
      {
        localTimeoutCounter = 0;
        RPCFec[e->FecIndex].Prot = 0;  // force address resolution
      }
    }
    if (dout) dout->dArrayLength = e->lastDataSize;
    if (hContract) ContractFree(e,hContract);
  }
  if (id > 0) SendMessage(hDLLWnd,WM_REMOVELINK,id,0);
  if (retry-- > 0  && cc == link_not_open) 
  {
    cln_retrycnt++;
    isRetry = TRUE;
    sprintf(s,"retry ExecLink ...");
    messageLog(s,cc);
    goto UDPretry;
  }
  localSyncSemaphore = 0;
  if (debug > 2 ) 
  {
    sprintf(strbuf,"%s %s completed with error code %d\n",devname,devprop,cc);
    OutputToDebugFile("dllExecLinkEx",strbuf);
  }
  if (cc == 0 && access & CA_WRITE)
  {
    sprintf(s,"ExecLink %s %s (%d bytes requested %d bytes sent) %s access : success",
      devname,devprop,doutsize,dinsize,access & CA_WRITE ? "WRITE" : "READ");
    messageLog(s,cc);
  }
  return cc;
}
short dllExecLink(char *devname,char *devprop,DBLK *dout,void *dataout,DBLK *din,void *datain,short access)
{
  return dllExecLinkEx(devname,devprop,dout,dataout,din,datain,access,RPC_TIMEOUT*1000);
}
short Subscribe(HWND hWnd,HWND hCtrl,char *name,short EqNo,char *prop,
							long timer,short size,short format,short mode)
{
  LCLCONTRACT *con = lclContract;
  HANDLE hLclContract = 0;
  HANDLE hContract=0,hSubSema = 0;
  short cc = 0;
  int i = 0,fmtsize,dsize,id;
  ElemDataStruct *e;
  HANDLE hDataBlock = 0;
  UINT16 dinsize;
  char fulname[72],s[256];
  char *cn = NULL,*en = NULL;

  if (format == 0) format = CF_DOUBLE;
  if (format == 1) format = CF_TEXT;

  if ((fmtsize=getFormatSize(format)) == 0) return -illegal_format;
  mode = mode > CM_REGISTER   ? CM_REGISTER   :
         mode < CM_CANCEL ? CM_CANCEL : mode;
  if (name == NULL || strlen(name) == 0) return -non_existent_elem;
  if (prop == NULL || strlen(prop) == 0) return -illegal_property;
  if (strlen(prop) > 32) return -string_too_long;
  if (size == 0) return -argument_list_error;

	if (debug > 2 ) 
	{
	  sprintf(strbuf,"Open semaphore %s\n",lpszSubSemaphore);
	  OutputToDebugFile("Subscribe",strbuf);
	}
  if ((hSubSema=OpenSemaphore(SEMAPHORE_ALL_ACCESS,FALSE,lpszSubSemaphore)) == 0)
    ccerr(semaphore_error);
  if ((cc=WaitForRPCSemaphore(hSubSema,lpszSubSemaphore,60)) != 0) ccerr(cc);

  if (debug > 2 ) 
  {
    sprintf(strbuf,"Get Link ID for %s %s\n",name,prop);
    OutputToDebugFile("Subscribe",strbuf);
  }
  if (!strcmp(name,GLBEQM)) id = numglobals; else id = -1;
  if ((i=SendMessage(hDLLWnd,WM_GETLINKID,id,0)) < 0) ccerr(-i);

  sprintf(shmConTag,"%s:%d",CONTRACTNAME,i);
  if ((con=(LCLCONTRACT *)lclContractAlloc(shmConTag,&hLclContract)) == NULL)
    ccerr(out_of_shared_memory);

  strncpy(fulname,name,71); fulname[71] = 0;
  if ((cn=strtok(fulname,DELIMITER)) == NULL) ccerr(argument_list_error);
  if ((en=strtok(NULL,DELIMITER)) == NULL) /* only one given */
  {
    en = cn; cn = NULL;
  }

  memset(con,0,sizeof(LCLCONTRACT));
  if (cn != NULL) strncpy(con->EqpContext,cn,16);  
  strncpy(con->EqpTagName,en,16);  
  strncpy(con->EqpProperty,prop,32);
  sprintf(con->EqpDeviceName,"#%d",EqNo);
  // can't fill in the dataIn with this prototype for subscribe()
  con->EqpSizeOut      = abs(size);
  con->EqpFormatOut    = BFMT(format);
  if (size < 0)
  {
    con->EqpSizeIn = abs(size);
    con->EqpFormatIn = BFMT(format);
    con->EqpAccess = CA_READ|CA_WRITE;
    dinsize = (UINT16)con->EqpSizeIn*fmtsizeof(con->EqpFormatIn);
    sprintf(shmDataTag,"%s:%d",DATABLOCKNAME,i);
    if ((con->DataIn=(BYTE *)DataBlockAlloc(shmDataTag,dinsize,&hDataBlock)) == NULL)
      ccerr(out_of_shared_memory);
    memset(con->DataIn,0,dinsize); // give it something ...
  }
  else
  {
    con->EqpSizeIn = 0;
    con->EqpFormatIn = BFMT(CF_NULL);
    con->EqpAccess = CA_READ;
  }
  dsize = abs(size)*fmtsize;

  con->PollRate = timer;
//	if (mode == CM_SINGLE && timer < (2*dsize)/5)  con->PollRate += (2*dsize)/5;

  if (debug > 2 ) 
  {
    sprintf(strbuf,"Create link for %s %s\n",name,prop);
    OutputToDebugFile("Subscribe",strbuf);
  }
  if ((cc=(short)SendMessage(hDLLWnd,WM_CREATELINK,i,0)) != 0) ccerr(cc);
  if (debug > 2 ) 
  {
    sprintf(strbuf,"Release semaphore %s\n",lpszSubSemaphore);
    OutputToDebugFile("Subscribe",strbuf);
  }
  //    ReleaseSemaphore(hSubSema,1,NULL); // now we're finished with lclContract
//    CloseHandle(hSubSema); hSubSema = 0;

  link[i].hWnd      = hWnd;
  link[i].hCtrlWnd  = hCtrl;
  link[i].callback  = NULL;
  link[i].dataOut   = NULL;
  link[i].dataFlg   = -not_posted;
  link[i].useErrValue = FALSE;
  link[i].active    = 1;
  link[i].mode      = mode;
  link[i].cnt       = (short)((con->PollRate+2*RPC_TIMEOUT*1000)/SYSTEM_DELAY); // default cleanup counter
  link[i].supressDuplicates = 0;

  if (!(e=ContractAlloc(link[i].linkTag,link[i].linkSizeIn,link[i].linkSizeOut,&hContract)))
    ccerr(un_allocated);

  if (e->RPCprotocol == 0) e->RPCprotocol = 5;
  if (e->RPCprotocol == 1)
  {
    if (mode == CM_SINGLE) ccerr(use_stream_transport);
    if (timer < 1000) e->PollRate = _POLLRATE;
  }
  e->lockCount++;          // hold on to the link until the App calls GETRPCDATA or timeout
  e->PrimeMode = maxmode(e->PrimeMode,mode);
  e->mode = e->PrimeMode;                             // common links all get highest mode
  e->heartbeat = SUB_PENDING;
  e->time      = e->RPCprotocol == 1 ? 0 : time(NULL);
  e->RPCtimestamp = 0;

  link[i].cnt  = (short)(((e->PollRate+2*RPC_TIMEOUT*1000))/SYSTEM_DELAY); // refresh cleanup counter
err:
  if (cc || mode != CM_REGISTER)
  {
    sprintf(s,"Legacy Subscribe [%d] %s %s (%d bytes read) %s %d ms: %s",
      i,name,prop,dsize,modetoa[BASEMODE(mode)],timer,erlst[cc]);
    messageLog(s,cc);
  }
  DataBlockFree(con->DataIn,hDataBlock);
  if (hContract) ContractFree(e,hContract);
  if (hLclContract) lclContractFree(con,hLclContract);
  if (hSubSema)
  { 
    ReleaseSemaphore(hSubSema,1,NULL);
    CloseHandle(hSubSema);
  }
//	if (cc && i > 0 && i < MAXHOTLINKS) {SendMessage(hDLLWnd,WM_REMOVELINK,i,0); link[i].active = 0;}
  if (cc && i > 0 && i < MAXHOTLINKS) SendMessage(hDLLWnd,WM_REMOVELINK,i,0);
  return cc ? -cc : i;
}
short syncAsyncRPC(char *name,short EqNo,char *prop,
                   short size,void *data,short datasize,short format,unsigned short timout)
{
  short id,cc = 0,isRetry = 0;
  int dsize,retry = 1,dotcp = 0;
  HANDLE hContract=0,hSyncMutex=0;
  ElemDataStruct *e = NULL;
  char lpszSyncMutex[64],s[256];
  static localSyncSemaphore = 0;  // protect against local re-entrancy (the infamous
                                  // Cold link in a VB timer !!)
  if (localSyncSemaphore) return not_ready; else localSyncSemaphore = 1;
  cln_legacynumsynccalls++;
  if (timout == RPC_TIMEOUT) 
  {
	 dotcp = 1;  // trap at unusually low timout value
	 timout = RPC_TIMEOUT*1000;
  }
  dsize = abs(size)*fmtsizeof(format);
//  if (timout < (2*dsize)/20) timout += (2*dsize)/20;
//  if (dsize > 1440) retry = 0;
UDPretry:
  hContract=0; hSyncMutex=0;
  if ((id=Subscribe(hDLLWnd,0,name,EqNo,prop,timout,size,format,CM_REGISTER)) < 0) ccerr(-id);
# ifdef USE_SHARED_MEMORY
  sprintf(lpszSyncMutex,"SyncRPC:%d",id);
# else
  sprintf(lpszSyncMutex,"SyncRPC:%d:%d:%d",thisUsage,thisUsageMsec,id);
# endif
  if (debug > 2 ) 
  {
    sprintf(strbuf,"create semaphore %s\n",lpszSyncMutex);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  if ((hSyncMutex=(HANDLE)CreateRPCSemaphore(lpszSyncMutex)) == NULL) ccerr(semaphore_error);
  
  if (!(e=ContractAlloc(link[id].linkTag,link[id].linkSizeIn,link[id].linkSizeOut,&hContract))) ccerr(un_allocated);
  if (size < 0)
  {
    if (debug) 
    {
      sprintf(strbuf,"write %d elements\n",abs(size));
      OutputToDebugFile("syncAsyncRPC",strbuf);
    }
    if (data == NULL || 
		IsBadReadPtr(data,dsize=e->sizeIn*getFormatSize(e->formatIn)) ) ccerr(buffer_too_small);
    memcpy(rpcDATAIN(e),data,dsize);
    retry = 0;        // don't retry for write commands
  }
  if (debug > 2 ) 
  {
    sprintf(strbuf,"lock link %d\n",id);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  if (SendMessage(hDLLWnd,WM_LOCKLINK,id,0)) ccerr(serr2);
  if (dotcp) 
  {
	 e->RPCprotocol = 1;
	 e->time = 0L;
  }
  link[id].mode = CM_SINGLE;
//  e->mode = e->PrimeMode == CM_REGISTER ? CM_SINGLE : e->PrimeMode;
  e->PrimeMode = maxmode(e->PrimeMode,CM_SINGLE);
  e->mode = e->PrimeMode;
  if (isRetry) e->mode |= CM_RETRY;
  SendMessage(hDLLWnd,WM_TIMER,0,0); 
  if (debug > 2 ) 
  {
    sprintf(strbuf,"wait for semaphore %s\n",lpszSyncMutex);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  if ((cc=WaitRPCSemaphore(hSyncMutex,lpszSyncMutex,e->PollRate,0)) != 0) ccerr(link_not_open);

  if ((cc=e->CompCode) == 0)
  {
    if (data == NULL || 
		IsBadWritePtr(data,dsize=e->sizeOut*getFormatSize(e->formatOut)) ) ccerr(buffer_too_small);
    memcpy(data,rpcDATAOUT(e),dsize);
  }
  gDataTimeStamp = putDataTimeStamp(0,e->RPCtimestamp,e->RPCtimestampMSEC);
  RPCtimestamp = e->RPCtimestamp;
err:
  if (cc) 
  {
    if (e == NULL) 
    {
      sprintf(RPCLastErrorString,"[LCL] %s",cc > 0 && cc < numErr ? erlst[cc] : "error undefined");
      strncpy(RPCLastErrorSource,"[INTERNAL]",PREFIX+RPCERR_SIZE);
    }
    else 
    {
      strncpy(RPCLastErrorString,e->RPCLastErrorString,PREFIX+RPCERR_SIZE);
      strncpy(RPCLastErrorSource,e->FecName,PREFIX+RPCERR_SIZE);
    }
    sprintf(s,"Legacy RPC %s %s (%d bytes read %d bytes sent) : [%s] %s",
      name,prop,datasize,datasize < 0 ? -datasize: 0,
      RPCLastErrorSource,RPCLastErrorString);
    messageLog(s,cc);
  }
  if (debug > 2 ) 
  {
    sprintf(strbuf,"removing link %d\n",id);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  if (id > 0) SendMessage(hDLLWnd,WM_REMOVELINK,id,0);
  if (hContract) ContractFree(e,hContract);
  if (hSyncMutex) CloseRPCSemaphore(hSyncMutex);
  if (retry-- > 0 && cc == link_not_open && !dotcp) 
  {
    cln_retrycnt++;
    isRetry = TRUE;
    sprintf(s,"retry RPC ...");
    messageLog(s,cc);
    goto UDPretry;
  }
  localSyncSemaphore = 0;
  if (debug > 2 ) 
  {
    sprintf(strbuf,"%s %s completed with error code %d\n",name,prop,cc);
    OutputToDebugFile("syncAsyncRPC",strbuf);
  }
  return cc;
}
// trivial RPC call:
short tRPC(int fecindex, char *name,short EqNo,char *prop,
           short size,void *data,short format,short timout)
{
  static char dev[16];
  sprintf(dev,"#%d",EqNo);
  return tExecLink(fecindex,name,dev,prop,size,data,format,timout);
}
int tExecLinkReturnedDataSize = 0;
int tExecLink(int fecindex,char *name,char *dev,char *prop,
	   short size,char *data,short format,short timout)
{
  int fmtsize,n,pktlen,poff,retry = 2;
  short cc=0,EqNo,sstepsize,pstepsize;
  int dsize,dretsiz = 0;
  static struct sockaddr_in IPfec;
  static BYTE lclWorkArea[IPX_BUFFER_SIZE];
  static CLIENT cln;
  HeaderStruct *h = (HeaderStruct *)lclWorkArea;
  struct subscription *s = (struct subscription *)&lclWorkArea[sizeof(HeaderStruct)];
  struct subscription4 *s4 = (struct subscription4 *)&lclWorkArea[sizeof(HeaderStruct)];
  ProducerHeaderStruct *Pheader;
  static int NameServerProtocol = 5;

  if (debug)
  {
    sprintf(txtbuf,"trivial RPC: %s %s %s\n",name,dev,prop);
    output(txtbuf);
  }
  format = format ? format : CF_DOUBLE;
  fmtsize = getFormatSize(format);
  if (!fmtsize || strlen(name) > 8 || strlen(prop) > 32) return string_too_long;
  if ((dsize = abs(size)*fmtsize) < 1) return out_of_range;
  if (timout < 1) timout = 1;
  EqNo = dev[0] == '#' ? atoi(&dev[1]) : 0;
  if (NameServerProtocol != 5) return illegal_protocol;

tRETRY:
  // flush any input bytes that are somehow there ...
  FD_ZERO(&rwset); FD_SET(SyncSocket,&rwset);
  fec_to.tv_sec=0; fec_to.tv_usec=0;
  while (select(32,&rwset,NULL,NULL,&fec_to) > 0)
  {
    pktlen = sizeof(IPfec);
    recvfrom(SyncSocket,(char *)lclWorkArea,IPX_BUFFER_SIZE,0,(struct sockaddr *)&IPfec,&pktlen);
  }
  sstepsize = SUBSCRIPTION_SIZE;
  pstepsize = PRODUCER_SIZE;
  s->PollingRate = 0;
  s->id = 1;
  s->mode = CM_SINGLE;
  s->starttime = time(NULL);
  strncpy(s->contract.EqpName,name,8);
  strncpy(s->contract.EqpProperty,prop,32);
  strncpy(s->contract.EqpDeviceName,dev,16); 
  s->contract.EqpSizeOut = abs(size);
  s->contract.EqpFormatOut = BFMT(format);
  dsize = abs(size)*fmtsize;
  if ((2 + sstepsize + dsize) > IPX_BUFFER_SIZE) return use_stream_transport;
  if (size < 0)
  {
    memcpy(&lclWorkArea[2+sstepsize],data,dsize);
    s->msgsize = sstepsize + dsize;
    s->contract.EqpAccess = CA_WRITE|CA_READ;
    s->contract.EqpSizeIn = abs(size);
    s->contract.EqpFormatIn = BFMT(format);
  }
  else 
  {
    s->msgsize = sstepsize;
    s->contract.EqpSizeIn = 0;
    s->contract.EqpFormatIn = BFMT(CF_NULL);
    s->contract.EqpAccess = CA_READ;
  }
  s->blkid = 0;
  s->blknum = 1;
  s->numblks = 1;
  s->mtu = IPX_BUFFER_SIZE-SUBSCRIPTION_SIZE-HEADERSTRUCT_SIZE;
  h->TotalSize = sizeof(HeaderStruct) + s->msgsize;

  memcpy(h->UserName,username,16);
  h->Protocol = NameServerProtocol;
  h->EqpSize = 1;
  
  memset(&cln,0,sizeof(CLIENT));
  strncpy(cln.userName,RPCFec[fecindex].Name,16);
  if (!RPCFec[fecindex].iaddr) return non_existent_fec;
  memset(&prod_name,0,sizeof(prod_name));
  memcpy(&prod_name.sin_addr,&RPCFec[fecindex].iaddr,sizeof(struct in_addr));
  prod_name.sin_family=AF_INET;
  poff = GetPortOffset(&RPCFec[fecindex]);
  prod_name.sin_port = htons((UINT16)(gtUDPPort+poff));
  memcpy(&cln.IPaddress,&prod_name,sizeof(prod_name));
  // send request ...
  if ((cc=SendUDPData(&cln,lclWorkArea,SyncSocket)) != 0) return cc;
  // wait for response ...
  FD_ZERO(&rwset); FD_SET(SyncSocket,&rwset);
  fec_to.tv_sec=0; fec_to.tv_usec=timout*1000; pktlen = sizeof(IPfec);
  switch (select(32,&rwset,NULL,NULL,&fec_to))
  {
    case -1: return tcp_socket_error;
    case 0:  if (--retry) goto tRETRY;
		     return link_not_open;
    default: n = recvfrom(SyncSocket,(char *)lclWorkArea,IPX_BUFFER_SIZE,0,
			     	      (struct sockaddr *)&IPfec,&pktlen);
             if (debug)
             {
               sprintf(txtbuf,"tRPC: received %d bytes\n",n);
               output(txtbuf);
             }
  }
  if (n != *(short *)lclWorkArea) return remitted_data_lost;

  Pheader = (ProducerHeaderStruct *)&lclWorkArea[2];
  if ((cc=Pheader->CompletionCode) == 0)
  {
    if (dsize < (dretsiz=Pheader->msgsize-pstepsize)) return illegal_format;
    else memcpy(data,&lclWorkArea[2+pstepsize],dretsiz);
  } 
  if (Pheader->SubscriptionID != 1) return connection_timeout;
  tExecLinkReturnedDataSize = dretsiz / fmtsize;
  return cc;
}
__declspec(dllexport) short PASCAL GETELEMDATA (ElemQueryStruct *elem,short num)
{
  ElemDataStruct *e;
  short i;

  if (elem == NULL) return 0;
  for (e=ElemList,i=0; e != NULL; e=e->Next,i++)
  {
     if (i > num) continue;
	 strncpy(elem[i].ElemName,e->ElemName,16);
	 strncpy(elem[i].EqName,e->EqName,6);
	 strncpy(elem[i].Property,e->Property,32);
	 strncpy(elem[i].DeviceName,e->DeviceName,32);
	 elem[i].formatIn = e->formatIn;
	 elem[i].formatOut = e->formatOut;
   strncpy(elem[i].DeviceContext,e->Context,16);  // this is more important than the data tags!
	 //strncpy(elem[i].strTagIn,e->strTagIn,8);
	 //strncpy(elem[i].strTagOut,e->strTagOut,8);
	 elem[i].sizeIn = e->sizeIn;
	 elem[i].sizeOut = e->sizeOut;
	 elem[i].access = e->access;
	 elem[i].CompCode = e->CompCode;
	 elem[i].PollRate = (UINT16)e->PollRate;
	 elem[i].FecIndex = e->FecIndex;
	 memcpy(elem[i].links,e->links,MAXCOMMONLINKS);
	 elem[i].timeoutCount = e->timeoutCount;
	 elem[i].lockCount = e->lockCount;
	 elem[i].ID = e->ID;
	 elem[i].heartbeat = (UINT16)e->heartbeat;
	 elem[i].mode = e->mode;
	 elem[i].PrimeMode = e->PrimeMode;
	 elem[i].RPCprotocol = e->RPCprotocol;
	 elem[i].protocol = e->protocol;
	 elem[i].time = e->time;
	 elem[i].starttime = e->starttime;
	 elem[i].RPCtimestamp = e->RPCtimestamp;
  }
  return i;
}

__declspec(dllexport) void PASCAL GetEqpStatisticsCounters(long *stbuf)
{
  if (IsBadWritePtr(stbuf,12*sizeof(UINT32))) return; 
  stbuf[0] = so_snderrcnt;
  stbuf[1] = cln_retrycnt;
  stbuf[2] = cln_illegal_idcnt;
  stbuf[3] = cln_illegal_protocolcnt;
  stbuf[4] = cln_stalecnt;
  stbuf[5] = cln_wrong_starttimecnt;
  stbuf[6] = cln_partial_blockcnt;
  stbuf[7] = cln_phantom_blockcnt;
  stbuf[8] = cln_bad_alignmentcnt;
  stbuf[9] = cln_size_mismatchcnt;
  stbuf[10] = cln_numsynccalls;
  stbuf[11] = cln_legacynumsynccalls;
  return;
}
