// EqpCtl.h : Declaration of the CEqpCtrl OLE control class.

/////////////////////////////////////////////////////////////////////////////
// CEqpCtrl : See EqpCtl.cpp for implementation.

class CEqpCtrl : public COleControl
{
	DECLARE_DYNCREATE(CEqpCtrl)

// Constructor
public:
	CEqpCtrl();

// Overrides

	// Drawing function
	virtual void OnDraw(
				CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);

	// Persistence
	virtual void DoPropExchange(CPropExchange* pPX);

	// Reset control state
	virtual void OnResetState();

// Implementation
protected:
	~CEqpCtrl();

	DECLARE_OLECREATE_EX(CEqpCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CEqpCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CEqpCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CEqpCtrl)		// Type name and misc status

    BOOL m_bEnabled;   

// Message maps
	//{{AFX_MSG(CEqpCtrl)
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CEqpCtrl)
	CString m_eqpProperty;
	afx_msg void OnEqpPropertyChanged();
	CString m_eqpName;
	afx_msg void OnEqpNameChanged();
	short m_eqpSize;
	afx_msg void OnEqpSizeChanged();
	short m_eqpFormat;
	afx_msg void OnEqpFormatChanged();
	short m_eqpIndex;
	afx_msg void OnEqpIndexChanged();
	short m_eqpStatus;
	afx_msg void OnEqpStatusChanged();
	short m_eqpPollMode;
	afx_msg void OnEqpPollModeChanged();
	short m_eqpPollRate;
	afx_msg void OnEqpPollRateChanged();
	short m_eqpNumber;
	afx_msg void OnEqpNumberChanged();
	BOOL m_enabled;
	afx_msg void OnEnabledChanged();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CEqpCtrl)
	void FireReceive()
		{FireEvent(eventidReceive,EVENT_PARAM(VTS_NONE));}
	void FireSend()
		{FireEvent(eventidSend,EVENT_PARAM(VTS_NONE));}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CEqpCtrl)
	dispidEqpProperty = 1L,
	dispidEqpName = 2L,
	dispidEqpSize = 3L,
	dispidEqpFormat = 4L,
	dispidEqpIndex = 5L,
	dispidEqpStatus = 6L,
	dispidEqpPollMode = 7L,
	dispidEqpPollRate = 8L,
	dispidEqpNumber = 9L,
	eventidReceive = 1L,
	eventidSend = 2L,
	//}}AFX_DISP_ID
	};
protected:
	void OnSetClientSite();
};
