#include "project.def"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <malloc.h>
#include <time.h>
#include <winsock.h>
#include "errors.h"
#include "database.h"
#include "winsrv.h"
#include "almsrv.h"

extern char txtbuf[128];
extern int debug;
extern int isHistoryCall;
HANDLE hAlmList = 0;
ALARM *almList = NULL;
int gRequireReadFromCAS = FALSE;
int AlarmServerInitialized = 0;
int numStoredAlarms = 0;
int AlarmWindow = DEFAULT_ALARM_WINDOW;
int AlarmHeartbeat = DEFAULT_ALARM_HEARTBEAT;
int MaxNumberAlarms = MAXALARMS;
int AlarmInstantWindow = DEFAULT_INSTANT_WINDOW;
int TerminationWindow = DEFAULT_TERMINATION_WINDOW;
ExportListStruct *findTag(char *name);

ALARM_WATCH *almWatchList = NULL;
int nAlmWatchList = 0;

#define idx_too_high      0
#define idx_warn_too_high 1
#define idx_too_low       2
#define idx_warn_too_low  3
ADS almWatchTableADS[] = 
{
  { "Value Too HIGH",value_too_high,0,14,BFMT(CF_FLOAT),1,0,0,0,"measured value is above threshold","",0,"last measured value","",4 },
  { "Value Too High",warn_too_high,0,12,BFMT(CF_FLOAT),1,0,0,0,"measured value is above warn threshold","",0,"last measured value","",4 },
  { "Value Too LOW",value_too_low,0,14,BFMT(CF_FLOAT),1,0,0,0,"measured value is below threshold","",0,"last measured value","",4 },
  { "Value Too Low",warn_too_low,0,12,BFMT(CF_FLOAT),1,0,0,0,"measured value is below warn threshold","",0,"last measured value","",4 }
};
int csvAlmWatchFileGetFormat(char *fmtstr);
CSVCOLUMN csvAlmWatchFileColumns[] = 
{
  { "LOCALNAME","",0,CF_TEXT,6,(BYTE *)OFFSETIN(ALARM_WATCH,eqm),NULL },
  { "DEVICENAME","",0,CF_TEXT,32,(BYTE *)OFFSETIN(ALARM_WATCH,dev),NULL },
  { "PROPERTY","",0,CF_TEXT,32,(BYTE *)OFFSETIN(ALARM_WATCH,prp),NULL },
  { "SIZE","",0,CF_LONG,1,(BYTE *)OFFSETIN(ALARM_WATCH,siz),NULL },
  { "FORMAT","",0,CF_NULL,1,NULL,csvAlmWatchFileGetFormat },
  { "SEVERITY","",0,CF_LONG,1,(BYTE *)OFFSETIN(ALARM_WATCH,sev),NULL },
  { "ALARMSYSTEM","0",0,CF_LONG,1,(BYTE *)OFFSETIN(ALARM_WATCH,asys),NULL },
  { "HIGH","",0,CF_FLOAT,1,(BYTE *)OFFSETIN(ALARM_WATCH,hi),NULL },
  { "LOW","",0,CF_FLOAT,1,(BYTE *)OFFSETIN(ALARM_WATCH,lo),NULL },
  { "HIGHWARN","",0,CF_FLOAT,1,(BYTE *)OFFSETIN(ALARM_WATCH,hiwarn),NULL },
  { "LOWWARN","",0,CF_FLOAT,1,(BYTE *)OFFSETIN(ALARM_WATCH,lowarn),NULL }
};
CSVDB csvAlmWatchFileDb =
{
  csvAlmWatchFileColumns,
  sizeof(csvAlmWatchFileColumns)/sizeof(csvAlmWatchFileColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(ALARM_WATCH)
};
int csvAlmWatchFileGetFormat(char *fmtstr)
{
  almWatchList[csvAlmWatchFileDb.cnt].fmt = BFMT(ftoi(fmtstr));
  almWatchList[csvAlmWatchFileDb.cnt].atyp = getArrayType(fmtstr);
  if (csvAlmWatchFileDb.cnt < csvAlmWatchFileDb.siz - 1)
    almWatchList[csvAlmWatchFileDb.cnt].nxt = &almWatchList[csvAlmWatchFileDb.cnt+1];
  return 0;
}
int GetAlarmWatchTable(void)
{
  int i,cc;
  char str[256];
  if ((cc=csvReadFile(FecDBpath,ALMARM_WATCH_FILE,&csvAlmWatchFileDb,(void **)&almWatchList)) != 0) ccerr(cc);
  nAlmWatchList = csvAlmWatchFileDb.siz;
  for (i=0; i<nAlmWatchList; i++)
  {
    almWatchList[i].data = (BYTE *)calloc(almWatchList[i].siz,fmtsizeof(almWatchList[i].fmt));
    if (almWatchList[i].data == NULL) ccerr(out_of_server_memory);
  }
err:
  sprintf(str,"ALM: watch file : %s", cc ? erlst[cc] : "found");
  feclog(str);
  return cc;
}
int appendAlarmWatchTable(char *eqm,char *prp,char *dev,int siz,int fmt,int sev,int sys,ALARM_WATCH_THRESHOLDS *thr)
{
  int cc = 0;
  ALARM_WATCH *aw;

  if ((aw=(ALARM_WATCH *)calloc(1,sizeof(ALARM_WATCH))) == NULL) ccerr(out_of_server_memory);
  strncpy(aw->eqm,eqm,EQP_NAME_SIZE);
  strncpy(aw->prp,eqm,EQP_PROP_SIZE);
  strncpy(aw->dev,dev,32);
  aw->siz = siz;
  aw->fmt = fmt;
  aw->sev = sev;
  aw->asys = sys;
  aw->hi = thr->hi;
  aw->hiwarn = thr->hiwarn;
  aw->lo = thr->lo;
  aw->lowarn = thr->lowarn;
  aw->nxt = almWatchList;
  almWatchList = aw;
  nAlmWatchList++;
err:
  return cc;
}
void checkAlarmsInWatchTable(void)
{
  ALARM_WATCH *aw;
  int lid,i,j,cnt;
  short devNr;
  ExportListStruct *el;
  float fval;
  static BYTE almdata[6];

  for (i=0; i<nAlmWatchList; i++)
  {
    aw = &almWatchList[i];
    if ((el=findTagID(aw->eqm)) == NULL) continue;
    if (el->hEqpFcn == NULL) continue;
    lid = (long)MAKEPROTID(i,ALM_PROTOCOL);
    strcpy(clientName,"LOCAL ALARM"); strcpy(clientaddr,"THIS STATION");
    if (aw->interimCounter == 0) aw->interimStatus = not_posted;
    if (aw->interimStatus == not_posted)
    {
      interimStatus = not_posted;  // let the VB app. clear this
      isHistoryCall = TRUE;
      SendMessage(el->hEqpFcn,WM_SYSCOMMAND,lid,ALM_PROTOCOL);
      isHistoryCall = FALSE;
    }
    if (aw->interimStatus != 0) 
    {
      if (aw->interimStatus == not_posted || aw->interimStatus == not_ready)
      {
        aw->interimStatus = not_ready;
        if (aw->interimCounter++ > 10) aw->interimCounter = 0;
      }
      continue;
    }
    devNr = GetDeviceNumber(aw->eqm,aw->dev);
    cnt = 0;
    for (j=0; j<aw->siz; j++)
    {
      if (aw->atyp == AT_CHANNEL) devNr = j;
      if (aw->atyp != AT_WAVEFORM && aw->siz == el->EqpNumModules) devNr = j; /* assume array of devices */
      switch (LFMT(aw->fmt))
      {
        case CF_BYTE: fval = (float)((BYTE *)aw->data)[j]; break;
        case CF_SHORT:fval = (float)((short *)aw->data)[j]; break;
        case CF_LONG: fval = (float)((long *)aw->data)[j]; break;
        case CF_FLOAT:fval = (float)((float *)aw->data)[j]; break;
        case CF_DOUBLE:fval = (float)((double *)aw->data)[j]; break;
        default: fval = 0;
      }
      if (fval > aw->hiwarn) 
      {
        cnt++;
        memcpy(almdata,&fval,4);
        aw->cnt = cnt;
        almWatchTableADS[idx_too_high].alarmSystem = aw->asys;
        almWatchTableADS[idx_too_high].severity = aw->sev;
        almWatchTableADS[idx_warn_too_high].alarmSystem = aw->asys;
        almWatchTableADS[idx_warn_too_high].severity = aw->sev - 2;
        SetAlarm(aw->eqm,devNr,fval > aw->hi ? value_too_high : warn_too_high,almdata);
      }
      else if (fval < aw->lowarn) 
      {
        cnt++;
        memcpy(almdata,&fval,4);
        aw->cnt = cnt;
        almWatchTableADS[idx_too_low].alarmSystem = aw->asys;
        almWatchTableADS[idx_too_low].severity = aw->sev;
        almWatchTableADS[idx_warn_too_low].alarmSystem = aw->asys;
        almWatchTableADS[idx_warn_too_low].severity = aw->sev - 2;
        SetAlarm(aw->eqm,devNr,fval < aw->lo ? value_too_low : warn_too_low,almdata);
      }
      else 
      {
        if (aw->cnt) /* if there is or was an alarm somewhere, run through RemoveAlarm() for the others */
        {
          RemoveAlarm(aw->eqm,devNr,value_too_high);
          RemoveAlarm(aw->eqm,devNr,value_too_low);
          RemoveAlarm(aw->eqm,devNr,warn_too_high);
          RemoveAlarm(aw->eqm,devNr,warn_too_low);
        }
      }
    }
    /* only clear the watch table counter when a complete pass has no alarms */
    if (cnt == 0) aw->cnt = 0;
  }
  return;
}

__declspec(dllexport) short PASCAL SetMaximumAlarms(short MaxAlarms)
{
  if (MaxAlarms < 0) return out_of_range;
  MaxNumberAlarms = MaxAlarms;
  return 0;
}

ExportListStruct *getExportFromList(char *eqm)
{
  ExportListStruct *export;

  for (export = ExportList; export; export = export->next)
    if (!strncmp(eqm,export->EqpName,6)) break;
  return export;
}
void getAlarmInfo(void)
{
  ExportListStruct *export;

  for (export = ExportList; export; export = export->next)
    getAlarmInfoTable(export->EqpName);
}
__declspec(dllexport) short PASCAL appendAlarmInfoTable(char *eqm,ADS *ads)
{
  ADS *g_ads,*adsTable = NULL;
  ExportListStruct *export;
  int cc = 0;

  if (eqm == NULL || ads == NULL) ccerr(argument_list_error);
  if ((export=getExportFromList(eqm)) == NULL) ccerr(non_existent_elem);
  if ((g_ads=(ADS *)calloc(1,sizeof(ADS))) == NULL) ccerr(out_of_server_memory);
  memcpy(g_ads,ads,sizeof(ADS));
  g_ads->next = export->adsTable;
  export->adsTable  = g_ads;
  if (!export->alarmSystem) export->alarmSystem = 1;
err:
  return cc;
}
FILE *alarmFileOpen(char *eqm)
{
  char almFile[64];
  int i;
  FILE *fp=NULL;

  for (i=0; i<2; i++)
  {
    memset(almFile,0,sizeof(almFile));
    strncpy(almFile,eqm,6);
    strcat(strlwr(almFile),i == 0 ? "-alarms.csv" : "al.csv");
    FecPath[0] = 0; strcat(FecPath,FecDBpath); strcat(FecPath,almFile);
    if ((fp=fopen(FecPath,"r")) != NULL) return fp;
  }
  return NULL;
}
int getAlarmInfoTable(char *eqname)
{
  ADS *ads,*adsTable = NULL;
  FILE *fp = NULL;
  ExportListStruct *export;
  int cc=0,done=0,fmt;
  short alarmTag_col,alarmCode_col,alarmMask_col,severity_col,
        format_col,size_col,timeRes_col,hitsChannel_col,
        hitsModule_col,alarmText_col,deviceText_col,dataText_col,
        url_col,alarmSystem_col;
  char str[256],scratch[16];

  if ((fp=alarmFileOpen(eqname)) == NULL) ccerr(no_such_file);
  while (fgets(str,255,fp) != NULL)   /* scan file       */
  {
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      if ((alarmTag_col=findcol(str,"ALARMTAG")) < 0) ccerr(no_such_line);
      if ((alarmCode_col=findcol(str,"ALARMCODE")) < 0) ccerr(no_such_line);
      alarmMask_col = findcol(str,"ALARMMASK");
      if ((severity_col=findcol(str,"SEVERITY")) < 0) ccerr(no_such_line);
      format_col = findcol(str,"DATAFORMAT");
      size_col = findcol(str,"DATAARRAYSIZE");
      timeRes_col = findcol(str,"TIMERESOLUTION");
      hitsChannel_col = findcol(str,"HITSCHANNEL");
      hitsModule_col = findcol(str,"HITSMODULE");
      alarmText_col = findcol(str,"ALARMTEXT");
      deviceText_col = findcol(str,"DEVICETEXT");
      dataText_col = findcol(str,"DATATEXT");
      url_col = findcol(str,"URL");
      if ((alarmSystem_col=findcol(str,"ALARMSYSTEM")) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }
    if ((ads=(ADS *)calloc(1,sizeof(ADS))) == NULL) ccerr(out_of_server_memory);
    strncpy(ads->alarmTag,colptr(alarmTag_col,str),16);
    if (strlen(ads->alarmTag) == 0) strcpy(ads->alarmTag,"undefined");
    strncpy(scratch,colptr(alarmCode_col,str),16);
    ads->alarmCode = atoi(scratch);
    if (alarmMask_col < 0) ads->alarmMask = 0;
    else
    {
      strncpy(scratch,colptr(alarmMask_col,str),16);
      ads->alarmMask = atoi(scratch);
    }
    strncpy(scratch,colptr(severity_col,str),16);
    ads->severity = atoi(scratch);
    if (format_col < 0) fmt = CF_NULL;
    else
    {
      strncpy(scratch,colptr(format_col,str),16);
      fmt = ftoi(scratch);
    }
    ads->alarmDataFormat = BFMT(fmt);
    if (size_col < 0) ads->alarmDataArraySize = 0;
    else
    {
      strncpy(scratch,colptr(size_col,str),16);
      ads->alarmDataArraySize = MIN(atoi(scratch),6);
    }
    if (timeRes_col < 0) ads->timeRes = 1;
    else
    {
      strncpy(scratch,colptr(timeRes_col,str),16);
      ads->timeRes = (float)atof(scratch);
    }
    if (hitsChannel_col < 0) ads->hitsChannel = 0;
    else
    {
      strncpy(scratch,colptr(hitsChannel_col,str),16);
      ads->hitsChannel = atoi(scratch);
    }
    if (hitsModule_col < 0) ads->hitsModule = 0;
    else
    {
      strncpy(scratch,colptr(hitsModule_col,str),16);
      ads->hitsModule = atoi(scratch);
    }
    if (alarmText_col >= 0)
    {
      strncpy(ads->alarmText,colptr(alarmText_col,str),40);
    }
    if (deviceText_col >= 0)
    {
      strncpy(ads->deviceText,colptr(deviceText_col,str),38);
    }
    if (dataText_col >= 0)
    {
      strncpy(ads->dataText,colptr(dataText_col,str),40);
    }
    if (url_col >= 0)
    {
      strncpy(ads->url,colptr(url_col,str),40);
    }
    strncpy(scratch,colptr(alarmSystem_col,str),16);
    ads->alarmSystem = atoi(scratch);
    ads->next = adsTable;
    adsTable  = ads;
    cc |= ads->alarmSystem ? 1 : 0;
  }
  fclose(fp); fp = NULL;
  if ((export=getExportFromList(eqname)) != NULL)
  {
    export->adsTable = adsTable;
    export->alarmSystem = cc;
  }
  return cc;
err: if (fp) fclose(fp);
  return -cc;
}
static char gCASName[16] = "";
CSVCOLUMN csvCASNameColumns[] =
{
  { "CAS","",0,CF_TEXT,16,(BYTE *)gCASName,NULL,0 }
};
CSVDB csvCASNameDb =
{
  csvCASNameColumns,
  sizeof(csvCASNameColumns)/sizeof(csvCASNameColumns[0]),
  0,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0
};
char *getCASUserName(void)
{
  int cc = 0;
  FILE *fp = NULL;

  if ((cc=csvReadFile(FecDBpath,CASHOST_FILE,&csvCASNameDb,NULL)) != 0) ccerr(cc);
  sprintf(txtbuf,"ALM: recognizing %s as Central Alarm Server",gCASName);
  feclog(txtbuf);
err:
  return gCASName;
}
int isCASInUserList(void)
{
  NAME16 usr;
  if (strlen(gCASName) == 0) return 0;
  GetCallerInfo(usr.name,NULL);
  return strncmp(gCASName,usr.name,16) == 0 ? -1 : 0;
}

void enforceAlarm(short cc)
{
 /* method to make sure this alarm goes out */
  return;
}
short initAlarmServer(void)
{
 /* initialization ? */
  getCASUserName();
  GetAlarmWatchTable();
  AlarmServerInitialized = 1;
  return 0;
}
short verifyDeviceNr(ExportListStruct *export,short devNr)
{
 /* verify that the device number passed in the API is valid */
  if (devNr >= export->EqpNumModules || devNr < 0) return -1;
  return 0;
}
int findDeviceNr(char *name,char *devname)
{
  int i;
  ExportListStruct *el;

  if (name == NULL || devname == NULL) return -argument_list_error;
  if ((el=findTagID(name)) == NULL) return -non_existent_elem;
  if (el->EqpModuleName == NULL) return -un_allocated;

  for (i=0; i<el->EqpNumModules; i++)
  {
    if (!strncmp(devname,el->EqpModuleName[i].name,16)) return i;
  }
  return -device_not_connected;
}
__declspec(dllexport) short SetDeviceAlarm(char *name,char *devname,long almCode,BYTE *almData,BYTE flags)
{
  short devNr = findDeviceNr(name,devname);
  return SetAlarmEx(name,devNr,almCode,almData,flags);
}

__declspec(dllexport) short SetAlarm(char *name,short devNr,long almCode,BYTE *almData)
{
  return SetAlarmEx(name,devNr,almCode,almData,almNEWALARM);
}

#define RefreshMRT(t,e) {\
  if ((t) == (e)->almMRT) (e)->nAlmMRT++;\
  else {\
	 (e)->almMRCT = (e)->almMRT;\
	 (e)->nAlmMRCT = (e)->nAlmMRT;\
	 (e)->almMRT = t; (e)->nAlmMRT = 1;\
  }\
}
#define RefreshHSV(s,e) {\
  if ((s) == (e)->almHSV) (e)->nAlmHSV++;\
  else if ((s) > (e)->almHSV)\
  { (e)->almHSV = s; (e)->nAlmHSV = 1; }\
}

__declspec(dllexport) short SetAlarmEx(char *name,short devNr,long almCode,BYTE *almData,BYTE flags)
{
  short adatasize = 0,cc = 0;
  ALARM *alm = NULL;
  ALARM *lsa = NULL;  /* least significant alarm */
  short lsc,sc = findSeverity(name,almCode),tmpsc = sc;
  ADS *ads = NULL;
  ExportListStruct *el;

  // fill in ALARMStruct for the tag via link list:

  /* Instant alarms pickup the TERMINATE signal immediately */

  if (flags & almINSTANT) flags |= almTERMINATE;

  /* fill in ALARMStruct for the tag via link list: */

  if ((el=findTagID(name)) == NULL) ccerr(0);
  if (verifyDeviceNr(el,devNr)) ccerr(out_of_range);

  for (alm=el->almLst[devNr]; alm != NULL; alm=alm->next)
  {
    if ((lsc=findSeverity(name,alm->alarmCode)) < tmpsc) { lsa = alm; tmpsc = lsc; }
    if (almCode == alm->alarmCode &&          /* it's in the list */
        !(alm->alarmStatus & almTERMINATE))   /* and not marked for termination */
    {
      if (almData != NULL && memcmp(almData,alm->alarmData,6))
      {                                        /* alarm data have changed */
/*        flags |= almDATACHANGE; */
        alm->alarmStatus &= ~((BYTE)almNEWALARM); /* remove NEWALARM */
        alm->alarmStatus |= almDATACHANGE;
        alm->timestamp = time(NULL);
        RefreshMRT(alm->timestamp,el);
        memcpy(alm->alarmData,almData,6);      /* copy changed data !! */
        if (debug)
        {
          wsprintf(txtbuf,"ALM: data change set for %s <%d>\n>",el->tagName,alm->alarmCode);
          output(txtbuf);
        }
        alm->clrCount = 0;                     /* reset clear count      */
        return 0;                              /* already in list, so return */
      }
      else
      {                                        /* alarm has been reset */
        if (alm->clrCount > 1)
        {
          alm->alarmStatus |= almOSCILLATION;  /* appears to be oscillating */
          if (debug)
          {
            wsprintf(txtbuf,"ALM: alarm oscillation set for %s <%d>\n>",el->tagName,alm->alarmCode);
            output(txtbuf);
          }
        }
        alm->alarmStatus &= ~((BYTE)almNEWALARM); /* remove NEWALARM */
        alm->clrCount = 0;                     /* reset clear count      */
        return 0;                              /* already in list, so return */
      }
    }
  }
  
  flags |= almNEWALARM;                        /* alarm not in list */

  if ((ads=getAlarmTable(name,almCode)) != NULL)
    adatasize = ads->alarmDataArraySize*getFormatSize(LFMT(ads->alarmDataFormat));


  if (el->nalarms < MaxNumberAlarms)          /* still room to put the alarm in list */
  {
    if ((alm=(ALARM *)calloc(1,sizeof(ALARM))) == NULL) ccerr(out_of_server_memory);
    if (gRequireReadFromCAS) alm->removalBlocked = TRUE; /* must be cleared by CAS readout */
    alm->timestamp = time(NULL);
    alm->alarmCode = almCode;
    alm->alarmStatus |= flags;
    if (adatasize > 0) memcpy(alm->alarmData,almData,adatasize);
    alm->next = (ALARM *)el->almLst[devNr];
    el->almLst[devNr] = alm;
    el->nalarms++;
    RefreshMRT(alm->timestamp,el);
    RefreshHSV(sc,el);
    if (debug)
    {
      wsprintf(txtbuf,"ALM: alarm set for %s <%d>\n>",el->tagName,alm->alarmCode);
      output(txtbuf);
    }
    return 0;
  }
  else if (lsa != NULL)  /* replace the least significant alarm */
  {
    alm = lsa;
    if (debug)
    {
      wsprintf(txtbuf,"ALM: replace alarm %s (%ld) with %s (%ld)",
                el->EqpName,alm->alarmCode,el->EqpName,almCode);
      output(txtbuf);
    }
    alm->timestamp = time(NULL);
    alm->alarmCode = almCode;
    alm->alarmStatus = flags;
    if (adatasize > 0)
    {
      memset(alm->alarmData,0,6);
      memcpy(alm->alarmData,almData,adatasize);
    }
    RefreshMRT(alm->timestamp,el);
    RefreshHSV(sc,el);
  }
  ccerr(max_alarms_exceeded);
err:
  if (cc) enforceAlarm(cc);
  switch (cc)
  {
    case 0: return 0;
    case out_of_server_memory:
    case max_alarms_exceeded:
      enforceAlarm(cc);
      break;
    default: if (alm) free(alm);
      break;
  }
  return 0;
}
__declspec(dllexport) void ClearDeviceAlarm(char *name,char *devname)
{
  short devNr = -1;
  if (strcmp(devname,"ALL")) devNr = findDeviceNr(name,devname);
  ClearAlarm(name,devNr);
}

__declspec(dllexport) void ClearAlarm(char *name,short devNr)
{
  ALARM *alm;
  ExportListStruct *el;
  int start,stop,i;

  if (!AlarmServerInitialized) return;

  if ((el=findTagID(name)) == NULL) return;
  if (devNr == -1)                        /* clear them all */
  {
    start = 0; stop = el->EqpNumModules;
  }
  else
  {
    if (verifyDeviceNr(el,devNr)) return;
    start = devNr; stop = devNr + 1;
  }
  for (i=start; i<stop; i++)
  {
     for (alm=el->almLst[i]; alm != NULL; alm=alm->next)
     {
      if (alm->alarmStatus & almINSTANT) alm->clrCount = 8; /* it'll be cleared immediately */
      else alm->clrCount = MIN(alm->clrCount+1,8); /* increment the clear count */
     }
  }
  return;                                 /* wasn't set */
}
__declspec(dllexport) void RemoveDeviceAlarm(char *name,char *devname,long code)  /* clear it immediately */
{
  short devNr = findDeviceNr(name,devname);
  RemoveAlarm(name,devNr,code);
}

__declspec(dllexport) void RemoveAlarm(char *name,short devNr,long code)  /* clear it immediately */
{
  ALARM *alm;
  ExportListStruct *el;

  if (!AlarmServerInitialized) return;
  if ((el=findTagID(name)) == NULL) return;
  if (verifyDeviceNr(el,devNr)) return;

  for (alm=el->almLst[devNr]; alm != NULL; alm=alm->next)
  {
    if (code == alm->alarmCode)
    {
      alm->clrCount = 8;
    }
  }
  return;                                 /* wasn't set */
}

// and in the background...

ALARM *RemoveAlarmFromList(ExportListStruct *el, int n, ALARM *alm)
{
  ALARM *a0, *a1, *atmp = alm;
  short sc;

  if (el == NULL) return alm->next;
  if (n >= el->EqpNumModules) return alm->next;
  for (a1=a0=el->almLst[n]; a1 != NULL; a0=a1,a1=a1->next)
  {
    if (a1 == alm) /* found it */
    {
      if (a1 == el->almLst[n]) el->almLst[n] = a1->next;
      else a0->next = a1->next;
      atmp = a1->next;
      if (a1->timestamp == el->almMRT) el->nAlmMRT--;
	    if ((sc=findSeverity(el->EqpName,a1->alarmCode)) == el->almHSV) el->nAlmHSV--;
      free(a1); a1 = NULL;
      el->nalarms--;
      break;
    }
  }
  return atmp;    /* return the next link in the list */
}

void SurveyAlarms(void)
{
  int n;
  ALARM *alm;
  ExportListStruct *el;
  time_t t = time(NULL);
  static time_t interim = 0;

  if (!AlarmServerInitialized) return;
  if (t == interim) return;
  interim = t;

  if (nAlmWatchList > 0) checkAlarmsInWatchTable();
  for (el=ExportList; el != NULL; el=el->next)
  {
    if (t > el->almMRT) /* adjust most recent complete timestamp */
    {
      el->almMRCT = el->almMRT;
      el->nAlmMRCT = el->nAlmMRT;
    }
    for (n=0;el->nalarms && n<el->EqpNumModules; n++)
    {
      for (alm=el->almLst[n]; alm != NULL;)
      {
        if ((alm->alarmStatus & almTERMINATE)) /*  time to clear the alarm ? */
        {
          if (alm->removalBlocked) 
          {
            alm = alm->next;
            continue;
          }
          if (alm->timestamp + TerminationWindow < t) /* okay to clear the alarm */
          {
            if (debug)
            {
              wsprintf(txtbuf,"ALM: clearing alarm for %s <%d>\n>",el->tagName,alm->alarmCode);
              output(txtbuf);
            }
            alm = RemoveAlarmFromList(el,n,alm);
            continue;
          }
          else if ((alm->alarmStatus & almINSTANT) && alm->timestamp + AlarmInstantWindow < t)
          {
            if (debug)
            {
              wsprintf(txtbuf,"ALM: Instant clear %s <%ld> (0x%x)",el->EqpName,alm->alarmCode,alm->alarmStatus);
              output(txtbuf);
            }
            alm = RemoveAlarmFromList(el,n,alm);
            continue;
          }
        }
        else                                   /* check alarm status */
        {
          if ((alm->clrCount > 3) && alm->timestamp + AlarmWindow < t)
          {
            if (debug)
            {
              wsprintf(txtbuf,"ALM: termination for %s <%ld> (0x%x)",el->EqpName,alm->alarmCode,alm->alarmStatus);
              output(txtbuf);
            }
            alm->alarmStatus &= ~((BYTE)almNEWALARM); /* remove NEWALARM */
            alm->alarmStatus |= almTERMINATE;
            alm->timestamp = t;
            RefreshMRT(alm->timestamp,el);
          }
          else if (alm->timestamp + AlarmHeartbeat < t) /*  set the heartbeat */
          {
            if (debug)
            {
              wsprintf(txtbuf,"ALM: heartbeat set for %s <%d>\n>",el->tagName,alm->alarmCode);
              output(txtbuf);
            }
            alm->alarmStatus &= ~((BYTE)almNEWALARM); /* remove NEWALARM */
            alm->alarmStatus |= almHEARTBEAT;
            alm->timestamp = t;
            RefreshMRT(alm->timestamp,el);
          }
        }
        alm=alm->next;
      }
    }
  }
  return;
}

// caller subscribes to NALARMS which calls (REFRESH mode)

short numAlarmsEx(char *eqpname,time_t *almTimeStamp,short *almSeverity,short *NrAtAlmTimeStamp,short *NrAtAlmSeverity)
{
  ExportListStruct *el;

  *almTimeStamp = 0; *almSeverity = 0;

  if ((el=findTagID(eqpname)) == NULL) return 0;
  *almTimeStamp = el->almMRCT;
  *almSeverity  = el->almHSV;
  *NrAtAlmTimeStamp = el->nAlmMRCT;
  *NrAtAlmSeverity = el->nAlmHSV;
  return el->nalarms;
}

short numAlarms(char *eqpname,time_t *almTimeStamp,short *almSeverity)
{
  return numAlarmsEx(eqpname,almTimeStamp,almSeverity,NULL,NULL);
}

int numAlarmDefs(char *eqm)
{
  int n;
  ADS *ads;
  ExportListStruct *el;

  if ((el=findTagID(eqm)) == NULL) return 0;
  for (n=0,ads=el->adsTable; ads; ads=ads->next,n++);
  return n;
}
int getAlarmDefs(char *eqm,ADS *rads,int num)
{
  int j,n;
  ADS *ads;
  ExportListStruct *el;

  if ((el=findTagID(eqm)) == NULL) return 0;
  n = numAlarmDefs(eqm);
  for (j=0,ads=el->adsTable; ads && j<num; ads=ads->next,j++)
  {
    memcpy(&rads[j],ads,sizeof(ADS));
  }
  return n;
}

short findSeverity(char *eqm, long cc)
{
  ADS *ads;
  ExportListStruct *start,*stop,*el;

  if (eqm == NULL)
  {
    start = ExportList; stop = NULL;
  }
  else
  {
    if ((start=findTagID(eqm)) == NULL) return 0;
    stop = start->next;
  }
  for (el=start; el != stop; el=el->next)
  {
    for (ads=el->adsTable; ads && ads->alarmCode != cc; ads = ads->next);
    if (ads) return ads->severity;
  }
  switch (cc)
  {
    case value_too_high: return almWatchTableADS[idx_too_high].severity;
    case value_too_low: return almWatchTableADS[idx_too_low].severity;
    case warn_too_high: return almWatchTableADS[idx_warn_too_high].severity;
    case warn_too_low: return almWatchTableADS[idx_warn_too_low].severity;
  }
  return 0;
}

ADS *getAlarmTable(char *eqm,long code)
{
  ADS *ads;
  ExportListStruct *el;

  if ((el=findTagID(eqm)) != NULL)
  {
    for (ads=el->adsTable; ads; ads=ads->next)
    {
      if (code == ads->alarmCode) return ads;
    }
    switch (code)
    {
      case value_too_high: return &almWatchTableADS[idx_too_high];
      case value_too_low: return &almWatchTableADS[idx_too_low];
      case warn_too_high: return &almWatchTableADS[idx_warn_too_high];
      case warn_too_low: return &almWatchTableADS[idx_warn_too_low];
    }
  }
  return NULL;
}

short getAlarmsEx(char *eqpname,AMS *ams,short num,short minSeverity,time_t starttime,time_t stoptime,short startnum)
{
  int sc,dv,i=0,n=0;
  ALARM *alm;
  ADS *ads;
  ExportListStruct *el;

  if ((el=findTagID(eqpname)) == NULL) return 0;
  for (dv=0; el->nalarms && dv<el->EqpNumModules; dv++)
  {
    for (alm=el->almLst[dv]; alm != NULL; alm=alm->next)
    {
      if (alm->removalBlocked && isCASInUserList()) alm->removalBlocked = FALSE;
      if (alm->timestamp >= starttime && alm->timestamp <= stoptime &&
          (sc=findSeverity(eqpname,alm->alarmCode)) >= minSeverity )
      {
        if (i++ < startnum) continue;
        /* fill in ams[n] here ... */
        strcpy(ams[n].tag,el->tagName);
        if (el->EqpModuleName) strncpy(ams[n].device,el->EqpModuleName[dv].name,16);
        else sprintf(ams[n].device,"DEV %d",dv);
        if ((ads=getAlarmTable(eqpname,alm->alarmCode)) != NULL)
        {
          strcpy(ams[n].alarmTag,ads->alarmTag);
          ams[n].alarmMask = ads->alarmMask;
          ams[n].alarmDataFormat = ads->alarmDataFormat;
          ams[n].alarmDataArraySize = ads->alarmDataArraySize;
          ams[n].alarmSystem = ads->alarmSystem;
        }
        ams[n].timestamp = alm->timestamp;
        ams[n].alarmCode = alm->alarmCode;
        memcpy(ams[n].alarmData,alm->alarmData,6);
        ams[n].severity = sc;
        ams[n].descriptor = alm->alarmStatus;
        if (++n >= num) break;
      }
    }
  }
  return n;
}

short getAlarms(char *eqpname,AMS *ams,short num,short minSeverity)
{
  return getAlarmsEx(eqpname,ams,num,minSeverity,0,0x7fffffffL,0);
}
