#define STR 0
#define INT 1
#define FLT 2
#define HEX 3

typedef struct
{
  char *nam;
  char *def;
  int  pos;
  int  fmt;
  int  siz;
  BYTE *ptr;
  int (*fcn)(char *);
  BYTE *start;
} CSVCOLUMN;

typedef struct CSVDBStruct
{
  CSVCOLUMN *col;
  int ncols;
  int siz;
  void (*ini)(struct CSVDBStruct *);
  int  (*itr)(struct CSVDBStruct *);
  void (*exi)(struct CSVDBStruct *);
  int cnt;
  BYTE *tgt;
  int tgt_siz;
} CSVDB;

typedef struct
{
  char OS[12];
  char desc[64];
  char loc[32];
  char hdw[32];
  char sub[16];
  char resp[32];
} RPCFecExStruct;

extern RPCFecExStruct RPCFecEx;

extern char FecDBpath[80];
extern char FecPath[128];

int csvAssignValue(void *ptr,int fmt,int siz,char *str);
int csvReadFile(char *path,char *file,CSVDB *db,void **target);
int csvWriteFile(char *path,char *file,CSVDB *db);
void csvStdInit(struct CSVDBStruct *db);
int  csvStdIterator(struct CSVDBStruct *db);
void csvStdExit(struct CSVDBStruct *db);

short GetDataBaseSize(char *filename);
short MoveAndReformat(char *dst, short dstFmt, char *src, short srcFmt, unsigned long num);
short reformat(char *data,short num,short dstFmt,short srcFmt);
short RegisterExport(char *expname,char *lclname,short numModules);
short getFecName(char *expName,char *lclName);
short GetNameServerAddress(void);
short sndRegisteredExports(void);
short findcol(char *str,char *tag);
char *colptr(short col,char *str);
short mtoi(char *mod);
char *strtrm(char *s);
__declspec(dllexport) short PASCAL RegisterFecNameEx(char *name,char *desc,char *loc,char *hdw,char *resp,short port,char *context);



