#ifndef _RPCDEFS_H_
#define _RPCDEFS_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#ifndef CNTXT_PREFIX
#define CNTXT_PREFIX "\\\\"
#endif

#ifndef DELIMITER
#define DELIMITER "/\\"
#endif
#ifndef RTOL
#define RTOL    0  /* Direction: Remote to Local */
#define LTOR    1  /* Direction: Local to Remote  */
#endif
#ifndef MAX
#define MAX(a,b)  ((a) > (b) ? a : b)
#endif
#ifndef MIN
#define MIN(a,b)  ((a) < (b) ? a : b)
#endif
#ifndef BYTE
#define BYTE unsigned char
#endif
#ifndef WORD
#define WORD unsigned short
#endif
#ifndef DWORD
#define DWORD unsigned long
#endif
#ifndef UINT8
#define UINT8 unsigned char
#endif
#ifndef UINT16
#define UINT16 unsigned short
#endif
#ifndef UINT32
#define UINT32 unsigned long
#endif

#ifndef TRUE
#define TRUE -1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#undef CF_TEXT
#define CF_DOUBLE       512
#define CF_UINT16       513
#define CF_SHORT        513
#define CF_INTEGER      513
#define CF_UINT8        514
#define CF_BYTE         514
#define CF_UINT32       515
#define CF_INT4         515
#define CF_LONG         515
#define CF_TEXT         516
#define CF_FLOAT        517
#define CF_POCALBLK     518
#define CF_STRUCT       519
#define CF_CHAR8        520
#define CF_NAME8        520
#define CF_STRING8      520
#define CF_CHAR16       521
#define CF_NAME16       521
#define CF_STRING16     521
#define CF_CHAR16FI     522
#define CF_NAME16FI     522
#define CF_BIT          523
#define CF_HITTS        524
#define CF_CHAR32       525
#define CF_NAME32       525
#define CF_STRING32     525
#define CF_FI           526
#define CF_FLTINT       526
#define CF_II           527
#define CF_LI           527
#define CF_LL           527
#define CF_INTINT       527
#define CF_LNGINT       527
#define CF_DI           528
#define CF_DBLINT       528
#define CF_SI           529
#define CF_SHTINT       529
#define CF_TDS          530
#define CF_IFI          530
#define CF_INTFLTINT    530
#define CF_CHAR48       531
#define CF_NAME48       531
#define CF_STRING48     531
#define CF_CHAR8I       532
#define CF_NAME8I       532
#define CF_CHAR16I      533
#define CF_NAME16I      533
#define CF_CHAR32I      534
#define CF_NAME32I      534
#define CF_CHAR48I      535
#define CF_NAME48I      535

#define CF_USTRING      536
#define CF_XYS          537
#define CF_FFI          537
#define CF_FLTFLTINT    537
#define CF_FII          538
#define CF_FLTINTINT    538
#define CF_FIS          538
#define CF_FILTER       539
#define CF_IFFF         539
#define CF_INTFLTFLTFLT 539
#define CF_SPECTRUM     540
#define CF_ADDRESS      541
#define CF_IIII         541
#define CF_INTINTINTINT 541
#define CF_WINDOW       542
#define CF_TTII         542
#define CF_POINT        543
#define CF_FF           543
#define CF_XY           543
#define CF_FLTFLT       543
#define CF_TDSI         544
#define CF_INTFLTSHTSHT 544
#define CF_BOOLEAN      545
#define CF_IIFF         546
#define CF_INTINTFLTFLT 546
#define CF_FWINDOW      546
#define CF_FIFI         547
#define CF_FLTINTFLTINT 547
#define CF_CHAR64       548
#define CF_NAME64       548
#define CF_STRING64     548
#define CF_CHAR64I      549
#define CF_NAME64I      549
#define CF_INTDBL       550
#define CF_LNGDBL       550
#define CF_FLTDBL       551
#define CF_DBLDBL       552
#define CF_NAMEDBLDBL   553
#define CF_NAME16DBLDBL 553

#define CF_DEFAULT      766
#undef CF_NULL
#define CF_NULL     767

#define getFormatSize(fmt)\
 ( fmt == CF_DOUBLE  ? 8 :\
   fmt == CF_SHORT   ? 2 :\
   fmt == CF_BYTE    ? 1 :\
   fmt == CF_LONG    ? 4 :\
   fmt == CF_FLOAT   ? 4 :\
   fmt == CF_STRUCT  ? 1 :\
   fmt == CF_CHAR8   ? 8 :\
   fmt == CF_CHAR16  ? 16:\
   fmt == CF_CHAR32  ? 32:\
   fmt == CF_CHAR48  ? 48:\
   fmt == CF_CHAR64  ? 64:\
   fmt == CF_CHAR16FI? 24:\
   fmt == CF_SI      ? 6 :\
   fmt == CF_FI      ? 8 :\
   fmt == CF_II      ? 8 :\
   fmt == CF_DI      ? 12:\
   fmt == CF_TDS     ? 12:\
   fmt == CF_HITTS   ? 6 :\
   fmt == CF_CHAR8I  ? 12:\
   fmt == CF_CHAR16I ? 20:\
   fmt == CF_CHAR32I ? 36:\
   fmt == CF_CHAR48I ? 52:\
   fmt == CF_CHAR64I ? 68:\
   fmt == CF_USTRING ? 96:\
   fmt == CF_FFI     ? 12:\
   fmt == CF_FII     ? 12:\
   fmt == CF_IFFF    ? 16:\
   fmt == CF_IIII    ? 16:\
   fmt == CF_TTII    ? 16:\
   fmt == CF_IIFF    ? 16:\
   fmt == CF_FIFI    ? 16:\
   fmt == CF_XY      ?  8:\
   fmt == CF_TDSI    ? 12:\
   fmt == CF_SPECTRUM?  4:\
   fmt == CF_TEXT    ?  1:\
   fmt == CF_BOOLEAN ?  4:\
   fmt == CF_BIT     ?  4:\
   fmt == CF_LNGDBL  ?  12:\
   fmt == CF_FLTDBL  ?  12:\
   fmt == CF_DBLDBL  ?  16:\
   fmt == CF_NAMEDBLDBL ?  32:\
   fmt == CF_DEFAULT ?  1: 0 )

#define fmtsizeof(fmt)\
 ( (short)(fmt) < CF_DOUBLE ? getFormatSize((short)(fmt+CF_DOUBLE)) : getFormatSize((short)(fmt)) )

#define LFMT(fmt) ((fmt)+CF_DOUBLE)
#define BFMT(fmt) ((fmt)-CF_DOUBLE)

#define getSimpleFormatType(txt) (\
	!strcmp(txt,"BYTE")     ? CF_BYTE :\
	!strcmp(txt,"SHORT")    ? CF_SHORT :\
	!strcmp(txt,"INT")      ? CF_SHORT :\
	!strcmp(txt,"INTEGER")  ? CF_SHORT :\
	!strcmp(txt,"LONG")     ? CF_LONG :\
	!strcmp(txt,"FLOAT")    ? CF_FLOAT :\
	!strcmp(txt,"SINGLE")   ? CF_FLOAT :\
	!strcmp(txt,"DOUBLE")   ? CF_DOUBLE :\
	!strcmp(txt,"STRUCT")   ? CF_STRUCT :\
	!strcmp(txt,"TEXT")     ? CF_TEXT :\
	!strcmp(txt,"CHAR")     ? CF_TEXT :\
	!strcmp(txt,"STRING")   ? CF_TEXT :\
	!strcmp(txt,"NAME8")    ? CF_CHAR8 :\
	!strcmp(txt,"CHAR8")    ? CF_CHAR8 :\
	!strcmp(txt,"NAME16")   ? CF_CHAR16 :\
	!strcmp(txt,"CHAR16")   ? CF_CHAR16 :\
	!strcmp(txt,"CHAR32")   ? CF_CHAR32 :\
	!strcmp(txt,"NAME32")   ? CF_CHAR32 :\
	!strcmp(txt,"CHAR48")   ? CF_CHAR48 :\
	!strcmp(txt,"NAME48")   ? CF_CHAR48 :\
	!strcmp(txt,"CHAR64")   ? CF_CHAR64 :\
	!strcmp(txt,"NAME64")   ? CF_CHAR64 :\
	!strcmp(txt,"BIT")      ? CF_BIT :\
	CF_NULL )

#define getCompoundFormatType(txt) (\
	!strcmp(txt,"NAME16FI") ? CF_CHAR16FI :\
	!strcmp(txt,"CHAR16FI") ? CF_CHAR16FI :\
	!strcmp(txt,"NAME8I")   ? CF_CHAR8I :\
	!strcmp(txt,"CHAR8I")   ? CF_CHAR8I :\
	!strcmp(txt,"NAME16I")  ? CF_CHAR16I :\
	!strcmp(txt,"CHAR16I")  ? CF_CHAR16I :\
	!strcmp(txt,"NAME32I")  ? CF_CHAR32I :\
	!strcmp(txt,"CHAR32I")  ? CF_CHAR32I :\
	!strcmp(txt,"NAME48I")  ? CF_CHAR48I :\
	!strcmp(txt,"CHAR48I")  ? CF_CHAR48I :\
	!strcmp(txt,"NAME64I")  ? CF_CHAR64I :\
	!strcmp(txt,"CHAR64I")  ? CF_CHAR64I :\
	!strcmp(txt,"HITTS")    ? CF_HITTS :\
	!strcmp(txt,"FI")       ? CF_FI :\
	!strcmp(txt,"FLTINT")   ? CF_FI :\
	!strcmp(txt,"FLTDBL")   ? CF_FLTDBL :\
	!strcmp(txt,"II")       ? CF_II :\
	!strcmp(txt,"INTINT")   ? CF_II :\
	!strcmp(txt,"LI")       ? CF_II :\
	!strcmp(txt,"LNGINT")   ? CF_II :\
	!strcmp(txt,"LNGDBL")   ? CF_LNGDBL :\
	!strcmp(txt,"INTDBL")   ? CF_LNGDBL :\
	!strcmp(txt,"DI")       ? CF_DI :\
	!strcmp(txt,"DBLINT")   ? CF_DI :\
	!strcmp(txt,"DBLDBL")   ? CF_DBLDBL :\
	!strcmp(txt,"NAMEDBLDBL") ? CF_NAMEDBLDBL :\
	!strcmp(txt,"NAME16DBLDBL") ? CF_NAMEDBLDBL :\
	!strcmp(txt,"SI")       ? CF_SI :\
	!strcmp(txt,"SHTINT")   ? CF_SI :\
	!strcmp(txt,"TDS")      ? CF_TDS :\
	!strcmp(txt,"IFI")      ? CF_TDS :\
	!strcmp(txt,"INTFLTINT")? CF_TDS :\
	!strcmp(txt,"USTRING")  ? CF_USTRING :\
	!strcmp(txt,"XYS")      ? CF_XYS :\
	!strcmp(txt,"FFI")      ? CF_XYS :\
	!strcmp(txt,"FLTFLTINT")? CF_XYS :\
	!strcmp(txt,"FLTINTINT")? CF_FII :\
	!strcmp(txt,"FIS")      ? CF_FII :\
	!strcmp(txt,"FILTER")   ? CF_FILTER :\
	!strcmp(txt,"IFFF")     ? CF_IFFF :\
	!strcmp(txt,"INTFLTFLTFLT")? CF_IFFF :\
	!strcmp(txt,"SPECTRUM") ? CF_SPECTRUM :\
	!strcmp(txt,"ADDRESS")  ? CF_ADDRESS  :\
	!strcmp(txt,"INTINTINTINT")? CF_ADDRESS  :\
	!strcmp(txt,"IIII")     ? CF_ADDRESS  :\
	!strcmp(txt,"WINDOW")   ? CF_WINDOW  :\
	!strcmp(txt,"TTII")     ? CF_WINDOW  :\
	!strcmp(txt,"POINT")    ? CF_POINT  :\
	!strcmp(txt,"XY")       ? CF_POINT  :\
	!strcmp(txt,"FLTFLT")   ? CF_POINT  :\
	!strcmp(txt,"TDSI")     ? CF_TDSI  :\
	!strcmp(txt,"INTFLTSHTSHT")? CF_TDSI  :\
	!strcmp(txt,"BOOLEAN")? CF_BOOLEAN  :\
	!strcmp(txt,"DEFAULT")  ? CF_DEFAULT :\
	!strcmp(txt,"IIFF")     ? CF_IIFF :\
	!strcmp(txt,"INTINTFLTFLT")? CF_IIFF :\
	!strcmp(txt,"FIFI")     ? CF_FIFI :\
	!strcmp(txt,"FLTINTFLTINT")? CF_FIFI :\
	!strcmp(txt,"FWINDOW")   ? CF_FWINDOW  :\
	CF_NULL )

#define CM_NULL         0x00
#define CM_CANCEL       0x00
#define CM_SINGLE       0x01
#define CM_REFRESH      0x02
#define CM_POLL         0x03
#define CM_REGISTER     0x04
#define CM_NODUPLICATES 0x10
#define CM_BCAST        0x100
#define CM_NETWORK      0x200
#define CM_MCAST        0x200
#define CM_USE_ON_ERROR 0x400
#define CM_USEONERROR   0x400
#define CM_RETRY        0x800
#define CM_GROUPED      0x1000
#define CM_CONNECT      0x2000
#define CM_WAIT         0x4000
#define CM_SYNCNOTIFY   0x8000

#define BASEMODE(m)  ((m) & 0xff)
#define TARGETMODE(m)  ((m) & 0x0fff)

#define getAccessMode(txt) (\
	strstr(txt,"READ")    ? CM_SINGLE :\
	strstr(txt,"WRITE")   ? CM_SINGLE :\
	strstr(txt,"SINGLE")  ? CM_SINGLE :\
	strstr(txt,"REFRESH") ? CM_REFRESH :\
	strstr(txt,"POLL")    ? CM_POLL :\
	strstr(txt,"REGISTER")? CM_REGISTER :\
	CM_CANCEL )

#define CA_NULL         0x00
#define CA_READ         0x01
#define CA_WRITE        0x02
#define CA_ASYNC        0x04
#define CA_SYNC         0x08
#define CA_ALARM        0x10
#define CA_HIST         0x20
#define CA_FIRST        0x40
#define CA_LAST         0x80
#define CA_CONNECT      0x2000
#define CA_SYNCNOTIFY   0x8000

#define getAccessType(txt) ( strstr(txt,"WRITE") ? CA_WRITE : CA_READ )

short ftoi(char *fmt);
short mtoi(char *mod);
char *itom(short accessMode);

#define GT_LIN  0
#define GT_LOG  1
#define GT_SLOG 2
#define GT_TD   3
#define GT_BIT  4
#define GT_TEXT 5
#define GT_ABS  6
#define GT_HEX  7

#define getGraphType(txt) (\
  txt == NULL           ? GT_LIN:\
  strstr(txt,"LIN")     ? GT_LIN :\
  strstr(txt,"LOG")     ? GT_LOG :\
  strstr(txt,"SLOG")    ? GT_SLOG :\
  strstr(txt,"TD")      ? GT_TD :\
  strstr(txt,"BIT")     ? GT_BIT :\
  strstr(txt,"TEXT")    ? GT_TEXT :\
  strstr(txt,"ABS")     ? GT_ABS :\
  strstr(txt,"HEX")     ? GT_HEX :\
  GT_LIN )

#define AT_UNKNOWN      0x00
#define AT_SCALAR       0x01
#define AT_SINGLE       0x02
#define AT_DOUBLE       0x04
#define AT_CHANNEL      0x10
#define AT_SPECTRUM     0x20
#define AT_TRACE        0x20
#define AT_WAVEFORM     0x20
#define AT_STRUCTURED   0x40
#define AT_COLLECTION   0x40
#define AT_UNSTRUCTURED 0x80
#define AT_BLOB         0x80
#define AT_IMAGE        0x80
#define AT_JPEG        0x100
#define AT_MPEG        0x200
#define AT_BMP         0x400
#define AT_GIF         0x800
#define AT_WAV        0x1000
#define AT_MP3        0x2000

short getArrayType(char *fmt);
short getArrayRowLength(char *fmt);

#define CSHOSTS           "ENSEQM"
#define CSHOSTS_FILE      "cshosts.csv"
#define FECID_FILE        "fecid.csv"
#define EXPORT_FILE       "exports.csv"
#define EQPDB_FILE        "eqpdbase.csv"
#define FECDB_FILE        "fecaddr.csv"
#define USERS_FILE        "users.csv"
#define IPNETS_FILE       "ipnets.csv"
#define IPBCASTNETS_FILE  "ipbcast.csv"
#define IPXNETS_FILE      "ipxnets.csv"
#define IPXBCASTNETS_FILE "ipxbcast.csv"
#define DENYUSER_FILE     "denyuser.csv"
#define ALIAS_FILE        "alias.csv"

#define MAJOR_VERSION 3
#define MINOR_VERSION 31
#define VERSION_REVISION 14

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* _RPCDEFS_H_ */
