#if !defined(AFX_SRVCTL_H__4727FEE1_D8EC_11D0_B104_0000E80D9CC1__INCLUDED_)
#define AFX_SRVCTL_H__4727FEE1_D8EC_11D0_B104_0000E80D9CC1__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// SrvCtl.h : Declaration of the CSrvCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CSrvCtrl : See SrvCtl.cpp for implementation.

#define MAXLISTDEPTH 256

class CSrvCtrl : public COleControl
{
	DECLARE_DYNCREATE(CSrvCtrl)

private:
	short VariantToVoid( VARIANT& vData, void ** vp, SAFEARRAY **psaRet, void ** strPtr );
	short VoidToVariant( void * vp, VARIANT& d );
	short VoidToVariant( void * vp,VARIANT& vData, VARIANT dataSize );

// Constructor
public:
	CSrvCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSrvCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual void OnSetClientSite();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CSrvCtrl();

  DECLARE_OLECREATE_EX(CSrvCtrl)    // Class factory and guid
  DECLARE_OLETYPELIB(CSrvCtrl)      // GetTypeInfo
  DECLARE_PROPPAGEIDS(CSrvCtrl)     // Property page IDs
  DECLARE_OLECTLTYPE(CSrvCtrl)		// Type name and misc status

  char m_devname[16];
  char m_property[32];
  char m_strTagIn[8];
  char m_strTagOut[8];
  char m_eqpErrorString[32];
  BOOL m_busy;
  BOOL m_bEnabled;
  short m_rpcProtocol;
  short m_eqpIndex;
  short m_eqpNumber;
  short m_eqpFormatIn;
  short m_eqpFormatOut;
  long m_eqpSizeIn;
  long m_eqpSizeOut;
  short m_access;
  short EqpFcnEventIndexList[MAXLISTDEPTH];
  int EqpFcnEventHead;
  int EqpFcnEventTail; 
  double m_dataTimeStamp;

// Message maps
	//{{AFX_MSG(CSrvCtrl)
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CSrvCtrl)
	CString m_eqpName;
	afx_msg void OnEqpNameChanged();
	CString m_exportName;
	afx_msg void OnExportNameChanged();
	short m_eqpStatus;
	afx_msg void OnEqpStatusChanged();
	long m_eqpTime;
	afx_msg void OnEqpTimeChanged();
	short m_eqpNumberModules;
	afx_msg void OnEqpNumberModulesChanged();
	afx_msg short EqpSend(long data);
	afx_msg short EqpRecv(long data);
	afx_msg void EqpClearAlarm(short devNumber);
	afx_msg short EqpSetAlarm(short devNumber, long almCode, long almData, short almFlags);
	afx_msg short EqpRegisterProperty(LPCTSTR property, short size, short fmt, short access, LPCTSTR dsc);
	afx_msg short EqpRegisterModule(LPCTSTR devName, short devNumber);
	afx_msg short EqpRegisterPropertyEx(LPCTSTR devProperty, long inMaxArrayLength, short inFormat, LPCTSTR inStructureTag, long outMaxArrayLength, short outFormat, LPCTSTR outStructureTag, short access, LPCTSTR description);
	afx_msg short EqpSetDeviceAlarm(LPCTSTR devName, long almCode, long almData, short almFlags);
	afx_msg void EqpClearDeviceAlarm(LPCTSTR devName);
	afx_msg void EqpSetCompletion(short CompCode, LPCTSTR CompString);
	afx_msg short EqpGetModuleNumber(LPCTSTR DevName);
	afx_msg BSTR EqpGetModuleName(short DevNumber);
	afx_msg short EqpGetPropertyId(LPCTSTR devProperty);
	afx_msg short EqpRecvData(const VARIANT FAR& data);
	afx_msg short EqpSendData(const VARIANT FAR& data);
	afx_msg short EqpSendDataEx(const VARIANT FAR& data, const VARIANT FAR& size);
	afx_msg short GetCallerInformation(const VARIANT FAR& ClientName,const VARIANT FAR& ClientAddress);
	afx_msg double GetDataTimeStamp();
	afx_msg void SetDataTimeStamp(double dataTime);
	afx_msg short _ScheduleProperty(LPCTSTR PropertyList);
	BOOL m_enabled;
	afx_msg void OnEnabledChanged();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CSrvCtrl)
	void FireEqpFcn(LPCTSTR devName, LPCTSTR devProperty, long outArrayLen, long inArrayLen, short devAccess)
		{FireEvent(eventidEqpFcn,EVENT_PARAM(VTS_BSTR  VTS_BSTR  VTS_I4  VTS_I4  VTS_I2), devName, devProperty, outArrayLen, inArrayLen, devAccess);}
	void FireReceive(LPCTSTR EqpProperty, short EqpNumber, short EqpDataArraySize, short EqpAccessMode, short EqpFormat)
		{FireEvent(eventidReceive,EVENT_PARAM(VTS_BSTR  VTS_I2  VTS_I2  VTS_I2  VTS_I2), EqpProperty, EqpNumber, EqpDataArraySize, EqpAccessMode, EqpFormat);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CSrvCtrl)
	dispidEqpName = 1L,
	dispidExportName = 2L,
	dispidEqpStatus = 3L,
	dispidEqpTime = 4L,
	dispidEqpNumberModules = 5L,
	dispidEqpSend = 6L,
	dispidEqpRecv = 7L,
	dispidEqpClearAlarm = 8L,
	dispidEqpSetAlarm = 9L,
	dispidEqpRegisterProperty = 10L,
	dispidEqpRegisterModule = 11L,
	dispidEqpRegisterPropertyEx = 12L,
	dispidEqpSetDeviceAlarm = 13L,
	dispidEqpClearDeviceAlarm = 14L,
	dispidEqpSetCompletion = 15L,
	dispidEqpGetModuleNumber = 16L,
	dispidEqpGetModuleName = 17L,
	dispidEqpGetPropertyId = 18L,
	dispidEqpRecvData = 19L,
	dispidEqpSendData = 20L,
	dispidEqpSendDataEx = 21L,
	dispidGetCallerInformation = 22L,
	dispidGetDataTimeStamp = 23L,
	dispidSetDataTimeStamp = 24L,
	dispidScheduleProperty = 25L,
	eventidEqpFcn = 1L,
	eventidReceive = 2L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SRVCTL_H__4727FEE1_D8EC_11D0_B104_0000E80D9CC1__INCLUDED)
