Attribute VB_Name = "PrintForm"
'--------------------------------------------------------------------
'
'   PrintForm.Bas
'
'   Aus: Microsoft Knowledge Base (mit leichten Modifikationen)
'
'
'
'   Exportierte Fnuktionen:
'       prfPrintForm         -       Form mit oder ohne Kopf ausdruchen
'       prfPrintScreen       -       Bildschirm ausdrucken
'       prfPrintActive       -       Aktives Fenster ausdrucken
'       prfSetMargins         -       Randbreiten einstellen
'
'--------------------------------------------------------------------


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Visual Basic 4.0 16/32 Capture Routines
'
' This module contains several routines for capturing windows into a
' picture.  All the routines work on both 16 and 32 bit Windows
' platforms.
' The routines also have palette support.
'
' CreateBitmapPicture - Creates a picture object from a bitmap and
' palette
' CaptureWindow - Captures any window given a window handle
' CaptureActiveWindow - Captures the active window on the desktop
' CaptureForm - Captures the entire form
' CaptureClient - Captures the client area of a form
' CaptureScreen - Captures the entire screen
' PrintPictureToFitPage - prints any picture as big as possible on
' the page
'
' NOTES

'    - No error trapping is included in these routines
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'

Global TTFLOGBOOKPRN
Global HERALOGBOOKPRN
Global HERAQPLOGBOOKPRN
Global PETRALOGBOOKPRN
Global DESYLOGBOOKPRN
Global DESY3LOGBOOKPRN
Global DESY2LOGBOOKPRN
Global LINAC3LOGBOOKPRN
Global LINAC2LOGBOOKPRN
Global DORISLOGBOOKPRN

Global DefaultPrinter As Printer
Global useRawImage As Boolean
Option Explicit
Option Base 0

'//
'// Randbreiten
'//
Dim m_left As Integer
Dim m_right As Integer
Dim m_top As Integer
Dim m_btm As Integer
Dim m_orient As Integer


Public Declare Function PrintPictureAsJpegA Lib "PrtSpool" (ByVal pPrinterQueue As String, ByVal hdcPicture As Long, ByVal lWidth As Long, ByVal lHeight As Long, ByVal iJpegQuality As Long) As Boolean
Public Declare Function CreateJpegFileA Lib "PrtSpool" (ByVal pFilename As String, ByVal hdcPicture As Long, ByVal lWidth As Long, ByVal lHeight As Long, ByVal iJpegQuality As Long) As Boolean

Private Type PALETTEENTRY
    peRed As Byte
    peGreen As Byte
    peBlue As Byte
    peFlags As Byte
End Type
Private Type LOGPALETTE
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(255) As PALETTEENTRY  ' Enough for 256 colors
End Type
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type
#If Win32 Then
    Private Const RASTERCAPS As Long = 38
    Private Const RC_PALETTE As Long = &H100
    Private Const SIZEPALETTE As Long = 104
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Declare Function CreateCompatibleDC Lib "GDI32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "GDI32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetDeviceCaps Lib "GDI32" (ByVal hdc As Long, ByVal iCapabilitiy As Long) As Long
Private Declare Function GetSystemPaletteEntries Lib "GDI32" (ByVal hdc As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Private Declare Function CreatePalette Lib "GDI32" (lpLogPalette As LOGPALETTE) As Long
Private Declare Function SelectObject Lib "GDI32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "GDI32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "GDI32" (ByVal hdc As Long) As Long
Public Declare Function GetForegroundWindow Lib "user32" () As Long
Public Declare Function BringWindowToTop Lib "user32" (ByVal hWnd As Long) As Boolean
Private Declare Function SelectPalette Lib "GDI32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function RealizePalette Lib "GDI32" (ByVal hdc As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Type PicBmp
    size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type
Private Declare Function OleCreatePictureIndirect _
        Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, _
                            ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long

Private Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, _
        ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
        
#End If
Global Const MaxInstalledPrinters = 10
Global LogbookContext$
Global InstalledPrinters(MaxInstalledPrinters - 1) As String
Global nInstalledPrinters As Integer
Global PictureToPageScaleFactor As Double, MaxNPrinters%

Public Function getSnapshot()
  Call keybd_event(vbKeySnapshot, 0, 0, 0)
End Function
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' CreateBitmapPicture
'    - Creates a bitmap type Picture object from a bitmap and palette
'
' hBmp
'    - Handle to a bitmap
'
' hPal
'    - Handle to a Palette
'    - Can be null if the bitmap doesn't use a palette
'
' Returns
'    - Returns a Picture object containing the bitmap
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Public Function CreateBitmapPicture(ByVal hBmp As Long, _
                                    ByVal hPal As Long) As Picture
    
    Dim r As Long
    Dim pic As PicBmp
    ' IPicture requires a reference to "Standard OLE Types"
    Dim IPic As IPicture
    Dim IID_IDispatch As GUID
    ' Fill in with IDispatch Interface ID
With IID_IDispatch
    .Data1 = &H20400
    .Data4(0) = &HC0
    .Data4(7) = &H46
    End With
    ' Fill Pic with necessary parts
With pic
    .size = Len(pic)          ' Length of structure
    .Type = vbPicTypeBitmap   ' Type of Picture (bitmap)
    .hBmp = hBmp              ' Handle to bitmap
    .hPal = hPal              ' Handle to palette (may be null)
    End With
    ' Create Picture object
    r = OleCreatePictureIndirect(pic, IID_IDispatch, 1, IPic)
    ' Return the new Picture object
    Set CreateBitmapPicture = IPic

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' CaptureWindow
'    - Captures any portion of a window
'
' hWndSrc
'    - Handle to the window to be captured
'
' Client
'    - If True CaptureWindow captures from the client area of the
'      window
'    - If False CaptureWindow captures from the entire window
'
' LeftSrc, TopSrc, WidthSrc, HeightSrc
'    - Specify the portion of the window to capture
'    - Dimensions need to be specified in pixels
'
' Returns
'    - Returns a Picture object containing a bitmap of the specified
'      portion of the window that was captured
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''
'
Private Function CaptureWindow(ByVal hWndSrc As Long, _
                               ByVal Client As Boolean, ByVal LeftSrc As Long, _
                               ByVal TopSrc As Long, ByVal WidthSrc As Long, _
                               ByVal HeightSrc As Long) As Picture
    Dim hDCMemory As Long
    Dim hBmp As Long
    Dim hBmpPrev As Long
    Dim r As Long
    Dim hDCSrc As Long
    Dim hPal As Long
    Dim hPalPrev As Long
    Dim RasterCapsScrn As Long
    Dim HasPaletteScrn As Long
    Dim PaletteSizeScrn As Long
    Dim LogPal As LOGPALETTE
    
    ' Depending on the value of Client get the proper device context
    If Client Then
        hDCSrc = GetDC(hWndSrc) ' Get device context for client area
    Else
        hDCSrc = GetWindowDC(hWndSrc) ' Get device context for entire
        ' window
    End If
    
    ' Create a memory device context for the copy process
    hDCMemory = CreateCompatibleDC(hDCSrc)
    ' Create a bitmap and place it in the memory DC
    hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
    hBmpPrev = SelectObject(hDCMemory, hBmp)
    
    ' Get screen properties
    RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS) ' Raster
    'capabilities
    HasPaletteScrn = RasterCapsScrn And RC_PALETTE       ' Palette
    'support
    PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE) ' Size of
    ' palette
    ' If the screen has a palette make a copy and realize it
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        ' Create a copy of the system palette
        LogPal.palVersion = &H300
        LogPal.palNumEntries = 256
        r = GetSystemPaletteEntries(hDCSrc, 0, 256, _
                                    LogPal.palPalEntry(0))
        hPal = CreatePalette(LogPal)
        ' Select the new palette into the memory DC and realize it
        hPalPrev = SelectPalette(hDCMemory, hPal, 0)
        r = RealizePalette(hDCMemory)
    End If
    
    ' Copy the on-screen image into the memory DC
    r = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, hDCSrc, _
               LeftSrc, TopSrc, vbSrcCopy)
    ' Remove the new copy of the  on-screen image
    hBmp = SelectObject(hDCMemory, hBmpPrev)
    ' If the screen has a palette get back the palette that was
    ' selected in previously
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        hPal = SelectPalette(hDCMemory, hPalPrev, 0)
    End If
    ' Release the device context resources back to the system
    r = DeleteDC(hDCMemory)
    r = ReleaseDC(hWndSrc, hDCSrc)
    ' Call CreateBitmapPicture to create a picture object from the
    ' bitmap and palette handles.  Then return the resulting picture
    ' object.
    Set CaptureWindow = CreateBitmapPicture(hBmp, hPal)
End Function
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' CaptureScreen
'    - Captures the entire screen
'
' Returns
'    - Returns a Picture object containing a bitmap of the screen
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Private Function CaptureScreen() As Picture
    #If Win32 Then
        Dim hWndScreen As Long
    #ElseIf Win16 Then
        Dim hWndScreen As Integer
    #End If
    ' Get a handle to the desktop window
    hWndScreen = GetDesktopWindow()
    ' Call CaptureWindow to capture the entire desktop give the handle
    ' and return the resulting Picture object
    Set CaptureScreen = CaptureWindow(hWndScreen, False, 0, 0, _
                                      Screen.Width \ Screen.TwipsPerPixelX, _
                                      Screen.Height \ Screen.TwipsPerPixelY)
End Function
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' CaptureForm
'    - Captures an entire form including title bar and border
'
' frmSrc
'    - The Form object to capture
'
' Returns
'    - Returns a Picture object containing a bitmap of the entire
'      form
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Public Function CaptureForm(frmSrc As Form) As Picture
    ' Call CaptureWindow to capture the entire form given it's window
    ' handle and then return the resulting Picture object
    Set CaptureForm = CaptureWindow(frmSrc.hWnd, False, 0, 0, _
                                    frmSrc.ScaleX(frmSrc.Width, vbTwips, vbPixels), _
                                    frmSrc.ScaleY(frmSrc.Height, vbTwips, vbPixels))
End Function
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' CaptureClient
'    - Captures the client area of a form
'
' frmSrc
'    - The Form object to capture
'
' Returns
'    - Returns a Picture object containing a bitmap of the form's
' client area
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Public Function CaptureClient(frmSrc As Form) As Picture
    ' Call CaptureWindow to capture the client area of the form given
    ' it's window handle and return the resulting Picture object
    Set CaptureClient = CaptureWindow(frmSrc.hWnd, True, 0, 0, _
                                      frmSrc.ScaleX(frmSrc.ScaleWidth, frmSrc.ScaleMode, vbPixels), _
                                      frmSrc.ScaleY(frmSrc.ScaleHeight, frmSrc.ScaleMode, vbPixels))
End Function
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' CaptureActiveWindow
'    - Captures the currently active window on the screen
'
' Returns
'    - Returns a Picture object containing a bitmap of the active
'      window
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Public Function CaptureActiveWindow() As Picture
    
    Dim hWndActive As Long
    Dim r As Long
    Dim n As Integer

    Dim RectActive As RECT
    ' Get a handle to the active/foreground window
    hWndActive = GetForegroundWindow()
    BringWindowToTop (hWndActive)
    n = DoEvents()
    ' Get the dimensions of the window
    r = GetWindowRect(hWndActive, RectActive)
    ' Call CaptureWindow to capture the active window given it's
    ' handle and return the Resulting Picture object
    Set CaptureActiveWindow = CaptureWindow(hWndActive, False, 0, 0, _
                                            RectActive.Right - RectActive.Left, _
                                            RectActive.Bottom - RectActive.Top)

End Function
Public Sub SaveDCToFile(jpgFileName As String, frm As Form)
Dim br As Boolean

br = CreateJpegFileA(jpgFileName, frm.hdc, frm.ScaleWidth, frm.ScaleHeight, 80)
End Sub
Public Function PrintDeskTopToLogbook(pname As String) As Boolean
Dim X As Printer, lgb As Printer, dfprn As Printer
Dim br As Boolean
Dim hdc As Long
Dim lWidth As Long, lHeight As Long
Dim lgbPrinterName As String
Dim canPrintToPrinter As Boolean

lgbPrinterName = pname
For Each X In Printers
  If X.DeviceName = lgbPrinterName Then
    canPrintToPrinter = True
    Set lgb = X
  End If
  If X.DeviceName = Printer.DeviceName Then
    Set dfprn = X
  End If
Next
If canPrintToPrinter Then
  Set Printer = lgb
  hdc = GetDC(GetDesktopWindow())
  lWidth = Screen.Width \ Screen.TwipsPerPixelX
  lHeight = Screen.Height \ Screen.TwipsPerPixelY
  PrintDeskTopToLogbook = PrintPictureAsJpegA(lgb.DeviceName, hdc, lWidth, lHeight, 80)
  Set Printer = dfprn  ' don't take any chances -> set it back !!!
  Exit Function
Else
  MsgBox "Please add " + lgbPrinterName + " to your list of installed printers", vbOKOnly, "Print to Logbook"
  PrintDeskTopToLogbook = False
  Exit Function
End If
PrintDeskTopToLogbook = False
End Function

Public Function PrintDCToFitPage(Prn As Printer, frm As Form, Client As Boolean) As Boolean
Dim br As Boolean
Dim hdc As Long
Dim lWidth As Long, lHeight As Long, padding As Long


On Error GoTo PrintDCToFitPageError

If Client Then
  hdc = GetDC(frm.hWnd)
  padding = 1
Else
  hdc = GetWindowDC(frm.hWnd)
  padding = 2
End If

lWidth = frm.ScaleX(frm.ScaleWidth, frm.ScaleMode, vbPixels) + padding
lHeight = frm.ScaleY(frm.ScaleHeight, frm.ScaleMode, vbPixels) + padding

PrintDCToFitPage = PrintPictureAsJpegA(Prn.DeviceName, hdc, lWidth, lHeight, 80)

Exit Function
PrintDCToFitPageError:
PrintDCToFitPage = False
Exit Function
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' PrintPictureToFitPage
'    - Prints a Picture object as big as possible
'
' Prn
'    - Destination Printer object
'
' Pic
'    - Source Picture object
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Public Sub PrintPictureToFitPage(Prn As Printer, pic As Picture)
    
    Const vbHiMetric As Integer = 8
    Dim PicRatio As Double
    Dim PrnWidth As Double
    Dim PrnHeight As Double
    Dim PrnRatio As Double
    Dim PrnPicWidth As Double
    Dim PrnPicHeight As Double
    
    Dim PrnX As Double
    Dim PrnY As Double
    Dim buffer As Double
        
    ' Determine if picture should be printed in landscape or portrait
    ' and set the orientation
    If m_orient = 0 Then
        If pic.Height >= pic.Width Then
            Prn.Orientation = vbPRORPortrait   ' Taller than wide
        Else
            Prn.Orientation = vbPRORLandscape  ' Wider than tall
        End If
    Else
        Prn.Orientation = m_orient
    End If
    ' Calculate device independent Width to Height ratio for picture
    PicRatio = pic.Width / pic.Height
    ' Calculate the dimentions of the printable area in HiMetric
    PrnWidth = Prn.ScaleX(Prn.ScaleWidth, Prn.ScaleMode, vbHiMetric) '* 1.2
    PrnHeight = Prn.ScaleY(Prn.ScaleHeight, Prn.ScaleMode, vbHiMetric)
    

m_right = 10
    
    If (m_left + m_right > 0) Then
        PrnWidth = PrnWidth * (1# - (CDbl(m_left + m_right) * 0.01))
    End If
    
    If (m_top + m_btm > 0) Then
        PrnHeight = PrnHeight * (1# - (CDbl(m_top + m_btm) * 0.01))
    End If
        
    ' Calculate device independent Width to Height ratio for printer
    PrnRatio = PrnWidth / PrnHeight
    ' Scale the output to the printable area
    If PicRatio >= PrnRatio Then
        ' Scale picture to fit full width of printable area
        PrnPicWidth = Prn.ScaleX(PrnWidth, vbHiMetric, Prn.ScaleMode)
        PrnPicHeight = Prn.ScaleY(PrnWidth / PicRatio, vbHiMetric, _
                                  Prn.ScaleMode)
    Else
        ' Scale picture to fit full height of printable area
        PrnPicHeight = Prn.ScaleY(PrnHeight, vbHiMetric, Prn.ScaleMode)
        PrnPicWidth = Prn.ScaleX(PrnHeight * PicRatio, vbHiMetric, _
                                 Prn.ScaleMode)
    End If
    
    PrnX = CDbl(m_left) * 0.01 * Prn.ScaleWidth
    PrnY = CDbl(m_top) * 0.01 * Prn.ScaleHeight
        
    'last minute adjustments ...
    If PictureToPageScaleFactor < 0.1 Then PictureToPageScaleFactor = 1#
    PrnPicWidth = PrnPicWidth * PictureToPageScaleFactor
    PrnPicHeight = PrnPicHeight * PictureToPageScaleFactor
    
    ' Print the picture using the PaintPicture method
    Prn.PaintPicture pic, PrnX, PrnY, PrnPicWidth, PrnPicHeight
    
    Prn.EndDoc
End Sub
'--------------------------------------------------------------------



'
'   prfPrintForm
'
'   Form ausdrucken
'
'   Parameter:
'       frm as form        -    auszudruckende Form
'       client as boolean  -    Nur Client-Area (true) oder
'                               ganze Form (false)
Public Sub prfPrintForm(frm As Form, Client As Boolean)

    Dim pic As Picture
    Static done As Boolean
    
    If Not done Then
      useRawImage = True
      done = True
    End If
    
    If PictureToPageScaleFactor < 0.01 Then
      If frm.Width >= 7500 Then
        PictureToPageScaleFactor = 1#
      ElseIf frm.Width >= 3750 Then
        PictureToPageScaleFactor = 0.5
      Else
        PictureToPageScaleFactor = 0.25
      End If
    End If
    
    If Client Then
        Set pic = CaptureClient(frm)
    Else
        Set pic = CaptureForm(frm)
    End If
    
prfPrintFormRetry:
    If Not (pic Is Nothing) Then
      If useRawImage And UCase(Right$(Printer.DeviceName, 3)) = "LOG" Then
        If PrintDCToFitPage(Printer, frm, Client) = False Then
          MsgBox "Cannot send Raw JPEG to Printer !", vbOKOnly, "Print Snapshot Image"
          useRawImage = False
          GoTo prfPrintFormRetry
        End If
      Else
        PrintPictureToFitPage Printer, pic
      End If
    End If
    
End Sub
Public Sub prfPrintRawForm(frm As Form, Client As Boolean)
  PrintDCToFitPage Printer, frm, Client
End Sub
'
'   prfPrintScreen
'
'   Bildschirm ausdrucken
'
Public Sub prfPrintScreen()

    Dim pic As Picture
    
    Set pic = CaptureScreen()
    
    If Not (pic Is Nothing) Then
        PrintPictureToFitPage Printer, pic
    End If

End Sub
'
'   prfPrintActive
'
'   Aktives Fenster ausdrucken
'
Public Sub prfPrintActive()

    Dim pic As Picture

    Set pic = CaptureActiveWindow()
    
    If Not (pic Is Nothing) Then
        PrintPictureToFitPage Printer, pic
    End If
    
End Sub


'
'   prfSetMargins
'
'   Randbreiten in % setzen
'
'   Parameter:
'
'       mleft, mright, mtop, mbtm  - Randbreiten links, rechts, oben, unten in %
'
'
'   Limits:
'       0 <= any_margin <= 30%
'
Public Sub prfSetMargins(mleft As Integer, mright As Integer, mtop As Integer, mbtm As Integer)


    m_left = mleft
    m_right = mright
    m_top = mtop
    m_btm = mbtm
    
    Call forceRange(m_left, 0, 30)
    Call forceRange(m_right, 0, 30)
    Call forceRange(m_top, 0, 30)
    Call forceRange(m_btm, 0, 30)
                    
End Sub


Private Sub forceRange(X As Integer, imin As Integer, imax As Integer)

    If (X < imin) Then
        X = imin
    ElseIf (X > imax) Then
        X = imax
    End If

End Sub


'
'   Seitenausrichtung einstellen
'
'   Parameter
'
'       orient as integer   - Seitenausruichtung: vbPRORLandscape
'                             oder vbPRORPortrait oder 0 (default).
'                             Bei 0 automatische Bestimmung nach
'                             Seitenverhltnis des Fensters.
Public Sub prfSetOrientation(Orient As Integer)

    If Orient = vbPRORLandscape Or Orient = vbPRORPortrait Then
        m_orient = Orient
    Else
        m_orient = 0
    End If

End Sub
Public Sub PrintToLogbook(f As Form, facility As String, PageOrientation As Integer, PrintClientArea As Boolean)
  Dim lgbQueue As String
  
  FindLogbookPrinters
  
  Select Case UCase(facility)
    Case "TTFLOG", "TTF": lgbQueue = TTFLOGBOOKPRN
    Case "HERALOG", "HERA", "HERAP", "HERAE": lgbQueue = HERALOGBOOKPRN
    Case "HERAQPLOG", "HERAQP", "QUENCH": lgbQueue = HERAQPLOGBOOKPRN
    Case "PETRALOG", "PETRA": lgbQueue = PETRALOGBOOKPRN
    Case "DESYLOG", "DESY": lgbQueue = DESYLOGBOOKPRN
    Case "DESY3LOG", "DESY3": lgbQueue = DESY3LOGBOOKPRN
    Case "DESY2LOG", "DESY2": lgbQueue = DESY2LOGBOOKPRN
    Case "LINAC3LOG", "LINAC3": lgbQueue = LINAC3LOGBOOKPRN
    Case "LINAC2LOG", "LINAC2": lgbQueue = LINAC2LOGBOOKPRN
    Case "DORISLOG", "DORIS": lgbQueue = DORISLOGBOOKPRN
    Case Else:
      MsgBox "facility " + facility + " Undefined", vbOKOnly, "Print to Logbook"
      Exit Sub
  End Select
  PrintToPrinter f, lgbQueue, PageOrientation, PrintClientArea
End Sub
Public Sub FindLogbookPrinters()
Dim X As Printer
Dim XName As String
Static done As Boolean

If done Then Exit Sub
useRawImage = True
done = True
For Each X In Printers
  XName = UCase(X.DeviceName)
  If Right$(XName, 6) = "TTFLOG" Then TTFLOGBOOKPRN = X.DeviceName
  If Right$(XName, 7) = "HERALOG" Then HERALOGBOOKPRN = X.DeviceName
  If Right$(XName, 9) = "HERAQPLOG" Then HERAQPLOGBOOKPRN = X.DeviceName
  If Right$(XName, 8) = "PETRALOG" Then PETRALOGBOOKPRN = X.DeviceName
  If Right$(XName, 7) = "DESYLOG" Then DESYLOGBOOKPRN = X.DeviceName
  If Right$(XName, 8) = "DESY3LOG" Then DESY3LOGBOOKPRN = X.DeviceName
  If Right$(XName, 8) = "DESY2LOG" Then DESY2LOGBOOKPRN = X.DeviceName
  If Right$(XName, 8) = "LINAC3LOG" Then LINAC3LOGBOOKPRN = X.DeviceName
  If Right$(XName, 8) = "LINAC2LOG" Then LINAC2LOGBOOKPRN = X.DeviceName
  If Right$(XName, 8) = "DORISLOG" Then DORISLOGBOOKPRN = X.DeviceName
Next
  
End Sub
' assumes pnames has been dimensioned to at least nprinters - 1
' takes nprinters as input and sets it as output !
Public Sub FindPrinters(pnames() As String, nprinters As Integer)
Dim X As Printer
Dim i As Integer
Static done As Boolean

On Error GoTo FindPrintersError
' Does one REALLY need this?
If Not done Then
  done = True
  nInstalledPrinters = MaxInstalledPrinters
End If

For Each X In Printers
    If i > nprinters - 1 Then
        Exit For
    End If
    
    ' Find the default printer
    If X.DeviceName = Printer.DeviceName Then
        Set DefaultPrinter = X
    End If
  
    pnames(i) = X.DeviceName
    If LCase$(Right$(pnames(i), 6)) <> "-ascii" Then i = i + 1
Next
FindPrintersError:
nprinters = i
End Sub
Public Sub PrintToPrinter(f As Form, pname As String, Orient As Integer, PrintClientArea As Boolean)
Dim X As Printer
Static lgbPrinterName As String
Static canPrintToPrinter As Boolean
Static done As Boolean
Static lgb As Printer, dfprn As Printer

'If Not done Then
'  done = True
  lgbPrinterName = pname
  For Each X In Printers
    If X.DeviceName = lgbPrinterName Then
      canPrintToPrinter = True
      Set lgb = X
    End If
    If X.DeviceName = Printer.DeviceName Then
      Set dfprn = X
    End If
  Next
'End If
If canPrintToPrinter Then
  Set Printer = lgb
  prfSetOrientation Orient
  prfPrintForm f, PrintClientArea
  Set Printer = dfprn  ' don't take any chances -> set it back !!!
  Exit Sub
Else
  MsgBox "Please add " + lgbPrinterName + " to your list of installed printers", vbOKOnly, "Print to Logbook"
  Exit Sub
End If

End Sub

Function determineContext() As String
Dim t$
t$ = Environ("DEFAULT_LOGBOOK")
FindLogbookPrinters
If Len(t$) > 0 Then
  determineContext = t$
  Exit Function
End If
t$ = Environ("ACC_TYPE")
If Len(t$) > 0 Then
  Select Case UCase(t$)
    Case "HERA": determineContext = "HERA"
    Case "PETRA": determineContext = "PETRA"
    Case "DESY": determineContext = "DESY3"
    Case "DESY3": determineContext = "DESY3"
    Case "DESY2": determineContext = "DESY2"
    Case "LINAC3": determineContext = "LINAC3"
    Case "LINAC2": determineContext = "LINAC2"
    Case "DORIS": determineContext = "DORIS"
    Case Else: determineContext = "NONE"
  End Select
  Exit Function
End If
determineContext = "NONE"

End Function

