Attribute VB_Name = "Sedac"
    Option Explicit
    
' Vor der ersten Benutzung einer Funktion aus diesem Modul:
'    Load SedFun

' Falls ein Protokoll gewnscht wird, mu auf dem Device-Server-PC mca\sbin\sedac\sedprot.exe laufen,
' auf der lokalen Platte des Device-Server-PCs die Directory c:\prot\sedac vorhanden sein
    
' MyLanAl$ enthlt den RemotePC-Namen fr Broadcasts in diesem Lan
' wird benutzt, um SEDPC-Fehler zentral zu protokollieren
    Global MyLanAll$
    
    
    Global Const MAX_NUMBER_OF_LINES = 10 ' pro PC
    
    Global StatusLastReset$

' Verschiedene Moduleigne Konstanten
        
    Const MAX_REMOTE_PACK_SIZE = 233   ' ins IPack passen 700 Integers, pro Telegram braucht man 3 Integer
    Const MINDEST_FIFO_LENGTH = 4095
    Const MAX_PACKET_SIZE = &H7FFF     ' jetzt wird die Lnge nur durch Typ Integer begrenzt, indem die PackRoutinen
                                       '    mehrfach hintereinander ausgefhrt werden
    
    Const SEDAC_READ = &H80
    Const SEDAC_WRITE = &H40


' Fehlernummern, die an den Sedac-Protokoll-Server geschickt werden

    Const ERR_SEDPC = 255
    Const ERR_SEDTST = 254
    Const ERR_SEDCLR = 253
    Const ERR_SEDDLY = 252
    Const ERR_SEDLCS = 251
    Const ERR_SEDCNT = 250
    Const ERR_SEDERRCNT = 249
    
' Fehlermeldungen, die ber die Check$-Variable bergeben werden

    Global Const SERVER_IS_BUSY = "Server is busy"       ' der Sedac-Treiber auf dem Device-Server-Rechner bearbeitet gerade Sedput/Sedget
    Global Const SUBR_IS_BUSY = "Subroutine is busy"     ' die Routinen in diesem Modul duerfen nicht rekursiv aufgerufen werden
    Global Const SERVER_TIMEOUT = "Timeout vom Server"   ' der Sedac-Treiber auf dem Device-Server-Rechner antwortet nicht
    Global Const sedac_error = "Sedac Error # "          ' die FehlerNr aus der dll wird angehaengt
    Global Const dimension_error = "Dimension Error"     ' die Arrays fuer SedPack... muessen alle gleich lang sein
    Global Const PACKET_TOO_LONG = "Packet too long"     ' Arrays duerfen nicht laenger sein als MAX_PACK_SIZE_READ bzw. MAX_PACK_SIZE_WRITE
    Global Const RANGE_ERROR = "Value out of range"      ' Datenformat in SedacWrite oder SedacPackMix
    Global Const ADRESS_ERROR = "Address out of range"   ' Crate < 0, crate > 63, Subadresse < 0 oder Subadresse > 255
    Global Const ENVIRONMENT = "No SEDPC Environment Variable!"
    Global Const NO_GIVEIO = "GiveIO not running!"
    Global Const LINE_RESERVED = "Sedac Line reserved by "
    Global Const no_such_line = "Keine Sedac-Line"
    
    Global Const I_SEDAC_ERROR_BASE = 20000
    Global Const I_SERVER_IS_BUSY = 20001         ' der Sedac-Treiber auf dem Device-Server-Rechner bearbeitet gerade Sedput/Sedget
    Global Const I_SUBR_IS_BUSY = 20002           ' die Routinen in diesem Modul duerfen nicht rekursiv aufgerufen werden
    Global Const I_SERVER_TIMEOUT = 20003         ' der Sedac-Treiber auf dem Device-Server-Rechner antwortet nicht
    Global Const I_SEDAC_ERROR = 20004            ' die FehlerNr aus der dll wird angehaengt
    Global Const I_DIMENSION_ERROR = 20005        ' die Arrays fuer SedPack... muessen alle gleich lang sein
    Global Const I_PACKET_TOO_LONG = 20006        ' Arrays duerfen nicht laenger sein als MAX_PACK_SIZE_READ bzw. MAX_PACK_SIZE_WRITE
    Global Const I_RANGE_ERROR = 20007            ' Datenformat in SedacWrite oder SedacPackMix
    Global Const I_ADRESS_ERROR = 20008           ' Crate < 0, crate > 63, Subadresse < 0 oder Subadresse > 255
    Global Const I_ENVIRONMENT = 20009
    Global Const I_NO_GIVEIO = 20010
    Global Const I_LINE_RESERVED = 20011
    Global Const I_UNKNOWN_ERROR = 20099
    Global Const I_NO_SUCH_LINE = 20012

' Masken fr Fehlerbits

    Const MASK_RESERV_ERR = &H300
    
    Type SedacReadArg
        Crate As Integer
        SubAdress As Integer
    End Type
    
    Type SedacWriteArg
        Crate As Integer
        SubAdress As Integer
        Value As Long
    End Type
                
    Type SedacErcArg
        Crate As Integer
        Class As Integer
    End Type
                
    Type SedacPackReadArg
        Crate(MAX_REMOTE_PACK_SIZE) As Integer
        SubAdress(MAX_REMOTE_PACK_SIZE) As Integer
        PackLen As Integer
    End Type
    
    Type SedacPackReadRet
        Reply(MAX_REMOTE_PACK_SIZE) As Integer
        PackReadData(MAX_REMOTE_PACK_SIZE) As Integer
    End Type

    Type SedacPackWriteArg
        Crate(MAX_REMOTE_PACK_SIZE) As Integer
        SubAdress(MAX_REMOTE_PACK_SIZE) As Integer
        PackWriteData(MAX_REMOTE_PACK_SIZE) As Integer
        PackLen As Integer
    End Type
    
    Type SedacPackWriteRet
        Reply(MAX_REMOTE_PACK_SIZE) As Integer
    End Type

    Type SedacPackMixArg
        Crate(MAX_REMOTE_PACK_SIZE) As Integer
        SubAdress(MAX_REMOTE_PACK_SIZE) As Integer
        PackWriteData(MAX_REMOTE_PACK_SIZE) As Integer
        mode(MAX_REMOTE_PACK_SIZE) As Integer
        PackLen As Integer
    End Type
    
    Type SedacPackMixRet
        Reply(MAX_REMOTE_PACK_SIZE) As Integer
        PackReadData(MAX_REMOTE_PACK_SIZE) As Integer
    End Type

Sub SedacGetDatStr(Serv$, lin%, DatStr$, check$)
    
    Dim i%, j%
    Dim ReplyFlag%
    Dim SedacGetDatReturn(30) As Byte
    Dim StrArr$(), FilNo%, Filna$
    
    If Serv$ = LocalPC$ Then
      
    ' Local: Get Date of last clear counters
        
        On Error Resume Next
        Err = 0
        FilNo% = FreeFile
        Filna$ = "c:\prot\Sedac\LClrDat.txt"
        Open Filna$ For Input As FilNo%
            If Err = 76 Then
                Err = 0
                ChDir "c:\prot"
                If Err = 76 Then
                    Err = 0
                    MkDir "c:\prot"
                End If
                MkDir "c:\prot\Sedac"
                If Err <> 0 Then check$ = Error(Err) Else check$ = "ok"
            Else
                If Err <> 0 Then check$ = Error(Err) Else check$ = "ok"
            End If
            Err = 0
            Input #FilNo%, DatStr$
            If Err = 52 Then check$ = Error(Err) & " ;File: " & Filna$
        Close FilNo%
        
        On Error GoTo 0
        
    Else
        
    ' Remote: Get Date of last clear counters
        frmSedFun!ACOP1.DeviceProperty = "GetClDat"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetDatReturn, 30, "BYTE")
        
        If ReplyFlag% = 0 Then
            If SedacGetDatReturn(0) > 0 Then
                StrArr$() = Split(BSTR(SedacGetDatReturn), Chr$(10))
                check$ = StrArr$(0)
                DatStr$ = StrArr$(1)
            Else
                check$ = "No Line"
            End If
        Else
            check$ = frmSedFun!ACOP1.status
        End If
   End If


End Sub

Function ConvIntErrToCheck$(ier%)
    Dim check$
    
    Select Case ier%
        Case 0
            check$ = "ok"
        Case I_SERVER_IS_BUSY
            check$ = SERVER_IS_BUSY
        Case I_SUBR_IS_BUSY
            check$ = SUBR_IS_BUSY
        Case I_SERVER_TIMEOUT
            check$ = SERVER_TIMEOUT
        Case I_DIMENSION_ERROR
            check$ = dimension_error
        Case I_PACKET_TOO_LONG
            check$ = PACKET_TOO_LONG
        Case I_RANGE_ERROR
            check$ = RANGE_ERROR
        Case I_ADRESS_ERROR
            check$ = ADRESS_ERROR
        Case I_NO_GIVEIO
            check$ = NO_GIVEIO
        Case I_NO_SUCH_LINE
            check$ = no_such_line
        Case Is < I_SEDAC_ERROR_BASE
            check$ = sedac_error & str$(ier%)
    End Select
        
    ConvIntErrToCheck$ = check$
        
End Function
Function ConvSmallChecktoCheck$(SCheck$)
Dim check$
    Select Case Left$(SCheck$, 1)
        Case "o"
            check$ = "ok"
        Case "G"
            check$ = sedac_error & Replace(SCheck$, "G", "") & " in SedGet"
        Case "P"
            check$ = sedac_error & Replace(SCheck$, "P", "") & " in SedPut"
        Case Else
            check$ = ConvIntErrToCheck$(CInt(SCheck$))
    End Select
   ConvSmallChecktoCheck = check$

End Function
Function ConvChecktoSmallCheck$(check$)
Dim SCheck$
    Select Case check$
         Case "ok"
            SCheck$ = "ok"
         Case SERVER_IS_BUSY
            SCheck$ = str$(I_SERVER_IS_BUSY)
         Case SUBR_IS_BUSY
            SCheck$ = str$(I_SUBR_IS_BUSY)
         Case SERVER_TIMEOUT
            SCheck$ = str$(I_SERVER_TIMEOUT)
         Case sedac_error
            SCheck$ = Replace(check$, sedac_error, "")
            If InStr(SCheck$, " in SedPut") > 0 Then
                SCheck$ = "P" & Replace(SCheck$, " in SedPut", "")
            End If
            If InStr(SCheck$, " in SedGet") > 0 Then
                SCheck$ = Replace(SCheck$, " in SedGet", "")
            End If
         Case dimension_error
            SCheck$ = str$(I_DIMENSION_ERROR)
         Case PACKET_TOO_LONG
            SCheck$ = str$(I_PACKET_TOO_LONG)
         Case RANGE_ERROR
            SCheck$ = str$(I_RANGE_ERROR)
         Case ADRESS_ERROR
            SCheck$ = str$(I_ADRESS_ERROR)
         Case NO_GIVEIO
            SCheck$ = str$(I_NO_GIVEIO)
    End Select
    ConvChecktoSmallCheck = SCheck$

End Function
Function ConvCheckToIntErr%(check$)
    Dim ier%
    Select Case check$
         Case "ok"
            ier% = 0
         Case SERVER_IS_BUSY
            ier% = I_SERVER_IS_BUSY
         Case SUBR_IS_BUSY
            ier% = I_SUBR_IS_BUSY
         Case SERVER_TIMEOUT
            ier% = I_SERVER_TIMEOUT
         Case dimension_error
            ier% = I_DIMENSION_ERROR
         Case PACKET_TOO_LONG
            ier% = I_PACKET_TOO_LONG
         Case RANGE_ERROR
            ier% = I_RANGE_ERROR
         Case ADRESS_ERROR
            ier% = I_ADRESS_ERROR
         Case NO_GIVEIO
            ier% = I_NO_GIVEIO
         Case no_such_line
            ier% = I_NO_SUCH_LINE
         Case Else
            If InStr(check$, sedac_error) > 0 Then
                ier% = Val(Replace(check$, sedac_error, ""))
            Else
                ier% = I_UNKNOWN_ERROR
            End If
    End Select
    ConvCheckToIntErr = ier%
End Function

Sub SedacGetErrorStatistics(Serv$, lin%, cra%, Class%, ErrArr%(), check$)
    
        
    Dim SedacGetErcArgument As SedacErcArg
    Dim SedacGetErcReturn(256) As Integer
    Dim ReplyFlag%, iSedErr%
    Dim i%
    
    If UBound(ErrArr%) < 256 Then check = dimension_error: Exit Sub
    
    If Serv$ = LocalPC$ Then
    
        ' Local: Get Sedac error statistics
        
        Call SedErc(lin%, cra%, Class%, ErrArr%(0), iSedErr%)
        Call ErrorHandling(iSedErr%, "SedErc", Serv$, lin%, lin%, lin%, check$)
   
        If frmSedFun.Check1 Then
            Call SedErrProt("GetCounters", lin, ERR_SEDERRCNT, ERR_SEDERRCNT, iSedErr%)
        End If
    
    
    Else
    
        ' Remote: Get Sedac error statistics
        frmSedFun!ACOP1.DeviceProperty = "GtErrCnt"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetErcReturn, 256, "INTEGER", SedacGetErcArgument.Crate, Len(SedacGetErcArgument), "STRUCT")
        
        If ReplyFlag% = 0 Then
            For i% = 1 To 32
                ErrArr%(i%) = SedacGetErcReturn(i%)
            Next i%
            check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
    End If
    

End Sub
Sub SedacGetStatistics(Serv$, lin%, lArray&(), check$)
    
        
    Dim SedacGetCntReturn(16) As Integer
    Dim ReplyFlag%, iSedErr%
    Dim i%
    
    If UBound(lArray&) < 16 Then check = dimension_error: Exit Sub
    
    If Serv$ = LocalPC$ Then
    
        ' Local: Get Sedac statistics
        Call SedCnt(lin%, lArray&(1), iSedErr%)
        Call ErrorHandling(iSedErr%, "SedDly", Serv$, lin%, lin%, lin%, check$)
    
        If frmSedFun.Check1 Then
            Call SedErrProt("GetCounters", lin, ERR_SEDCNT, ERR_SEDCNT, iSedErr)
        End If
    
    
    Else
    
        ' Remote: Get Sedac statistics


        frmSedFun!ACOP1.DeviceProperty = "GetCount"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetCntReturn, 16, "Integer")
        
        If ReplyFlag% = 0 Then
            For i% = 1 To 16
                lArray&(i%) = CLng(SedacGetCntReturn(i%))
            Next i%
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
        
    End If
    
End Sub

    

Sub clr_and_prot(Serv$, Fun$, lin%, cra%, Sua%, iSedErr%)
    Dim SndStr$
    Dim iclearerr%, SedacDelayTime%

    Call SedClr(lin%, SedacDelayTime%, iclearerr%)
    
    SndStr$ = Format$(Now, "dd.mm.yyyy hh:mm:ss") & " " & Serv$ & " " & Fun$
    SndStr$ = SndStr$ & ",  Line " & str$(lin%)
    If Fun$ = "SedRd" Or Fun$ = "SedWr" Then SndStr$ = SndStr$ & ", Crate " & str$(cra%) & ", Subadr " & str$(Sua%)
    SndStr$ = SndStr$ & ",SedacError " & Hex$(iSedErr%)
    If iclearerr% <> 0 Then SndStr$ = SndStr$ & " (hex),Error in Clear " & Hex$(iclearerr%)
    SndStr$ = SndStr$ & " (hex), App.Title: " & App.Title
 
    
'    frmSedFun!Send1.String1 = SndStr$
'    frmSedFun!Send1.Property = Serv$
'    frmSedFun!Send1.RemoteID = "Sed_PcEr"
'    frmSedFun!Send1.RemotePC = MyLanAll$
'    frmSedFun!Send1.StringMsg = 1
'
    iSedErr% = iclearerr%
End Sub

Sub ErrPackProt(Serv$, lin%, Length%, cra%(), reg%(), sederr%())
    Dim Leng%, i%, Li%

    If Length% > 233 Then
       Li% = 233
    Else
       Li% = Length%
    End If
    Leng% = 3 * Li%

    ReDim IPArr%(Leng%)
    For i% = 1 To Li%
      IPArr%((i% - 1) * 3 + 1) = cra%(i%)
      IPArr%((i% - 1) * 3 + 2) = reg%(i%)
      IPArr%((i% - 1) * 3 + 3) = sederr%(i%)
    Next i%

'    frmSedFun!Send1.Ipacklen = leng%
'    frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'    frmSedFun!Send1.Ipackindex = lin%
'    frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'    frmSedFun!Send1.RemoteID = "SedProt"
'    frmSedFun!Send1.Property = "SedPErr"
'    frmSedFun!Send1.IpackMsg = 1

    If Length% > 233 Then
      Li% = Length% - Li%
      Leng% = 3 * Li%
  
      ReDim IPArr%(Leng%)
      For i% = 1 To Li%
        IPArr%((i% - 1) * 3 + 1) = cra%(i%)
        IPArr%((i% - 1) * 3 + 2) = reg%(i%)
        IPArr%((i% - 1) * 3 + 3) = sederr%(i%)
      Next i%
  
'      frmSedFun!Send1.Ipacklen = leng%
'      frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'      frmSedFun!Send1.Ipackindex = lin%
'      frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'      frmSedFun!Send1.RemoteID = "SedProt"
'      frmSedFun!Send1.Property = "SedPErr"
'      frmSedFun!Send1.IpackMsg = 1
    End If

End Sub

Sub ErrMultiPackProt(Serv$, lin%, Length%, cra%(), reg%(), sederr%())
    Dim Leng%, i%, Li%

    If Length% > 233 Then
       Li% = 233
    Else
       Li% = Length%
    End If
    Leng% = 3 * Li%

    ReDim IPArr%(Leng%)
    For i% = 1 To Li%
      IPArr%((i% - 1) * 3 + 1) = cra%(i%, lin%)
      IPArr%((i% - 1) * 3 + 2) = reg%(i%, lin%)
      IPArr%((i% - 1) * 3 + 3) = sederr%(i%, lin%)
    Next i%

'    frmSedFun!Send1.Ipacklen = leng%
'    frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'    frmSedFun!Send1.Ipackindex = lin%
'    frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'    frmSedFun!Send1.RemoteID = "SedProt"
'    frmSedFun!Send1.Property = "SedPErr"
'    frmSedFun!Send1.IpackMsg = 1

    If Length% > 233 Then
      Li% = Length% - Li%
      Leng% = 3 * Li%
  
      ReDim IPArr%(Leng%)
      For i% = 1 To Li%
        IPArr%((i% - 1) * 3 + 1) = cra%(i%, lin%)
        IPArr%((i% - 1) * 3 + 2) = reg%(i%, lin%)
        IPArr%((i% - 1) * 3 + 3) = sederr%(i%, lin%)
      Next i%
  
'      frmSedFun!Send1.Ipacklen = leng%
'      frmSedFun!Send1.WIAdr = IAdr(IPArr%(1))
'      frmSedFun!Send1.Ipackindex = lin%
'      frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'      frmSedFun!Send1.RemoteID = "SedProt"
'      frmSedFun!Send1.Property = "SedPErr"
'      frmSedFun!Send1.IpackMsg = 1
    End If

End Sub



'
'************************************ Call Sedac Clear *********************************************
'
'
Sub SedacClear(Serv$, lin%, Delay%, check$)
    
    
    
    Dim iSedErr%
    Dim ReplyFlag%
    Dim SedacClrReturn As Integer
    
        If Serv$ = LocalPC$ Then
      
    ' Local Sedac Clear

        Call SedClr(lin%, Delay%, iSedErr%)
        If iSedErr <> 0 Then
            check$ = " Error # " & str$(iSedErr%)
        Else
            check$ = "ok"
        End If

        If frmSedFun.Check1 Then
            Call SedErrProt("Clear", lin%, ERR_SEDCLR, ERR_SEDCLR, iSedErr%)
        End If
    
    Else
        
    ' Remote Sedac Clear
  
        frmSedFun!ACOP1.DeviceProperty = "SedacClear"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacClrReturn, 1, "INTEGER")
        
        If ReplyFlag% = 0 Then
            Delay% = SedacClrReturn
            check$ = "ok"
        Else
            check$ = frmSedFun!ACOP1.status
        End If
    End If
End Sub
Sub ErrorHandling(iSedErr%, funct$, Serv$, lin%, cra%, Sua%, check$)
    Dim ModUse&, ResHandle&, ResCnt&, ResTim&
    Dim ResString As String * 32

    If iSedErr% > 7 Then
         check$ = sedac_error & " " & str(iSedErr%) & " in " & funct$
         If iSedErr% And MASK_RESERV_ERR Then
            Call SedGsh(ModUse&, ResHandle&, ResString$, ResCnt&, ResTim&)
            check$ = LINE_RESERVED & ResString$ & "; ModuleUse " & ModUse&
            check$ = check$ & "; by Handle " & ResHandle&
            check$ = check$ & "; ResCount " & ResCnt& & "; ResTime " & ResTim& & " msec"
         Else
            Call clr_and_prot(Serv$, funct$, lin%, cra%, Sua%, iSedErr%)
            If iSedErr% <> 0 Then check$ = check$ & " & Error in SedClr!!!"
         End If
    Else
         check$ = "ok"
    End If

End Sub
'
'************************************ Call Sedac Delay *********************************************
'
'
Sub SedacDelay(Serv$, lin%, Delay%, check$)
    
    
    
    Dim LinID$, iSedErr%
    Dim ReplyFlag%
    Dim SedacDlyArgument  As Integer
    Dim SedacDlyReturn As Integer
    
    If Serv$ = LocalPC$ Then
      
    ' Local Sedac Delay
        
        Call SedDly(lin%, Delay%, iSedErr%)
        
        Call ErrorHandling(iSedErr%, "SedDly", Serv$, lin%, lin%, lin%, check$)
        
        If frmSedFun.Check1 Then
            Call SedErrProt("Delay", lin, ERR_SEDDLY, ERR_SEDDLY, iSedErr)
        End If
    
    
    Else
        
    ' Remote Sedac Delay

        SedacDlyArgument = Delay%
        
        frmSedFun!ACOP1.DeviceProperty = "SedacDelay"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacDlyReturn, 1, "INTEGER", SedacDlyArgument, 1, "INTEGER")
        
        If ReplyFlag% = 0 Then
            Delay% = SedacDlyReturn
            check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
   End If
End Sub

Sub SedacDlyForCC4(server$, lin%, check$)
  Call SedacDelay(server$, lin%, 2673, check$)
End Sub

Sub SedacDlyForPSC(server$, lin%, check$)
  Call SedacDelay(server$, lin%, 0, check$)
End Sub
Sub ConvfromPutArr(SedCnt%, PutArr%(), cra%(), Sua%(), Data%(), mode%(), Reply%())
    Dim i%
            
    ReDim cra%(SedCnt%), Sua%(SedCnt%), mode%(SedCnt%), Data%(SedCnt%), Reply%(SedCnt%)
    For i% = 1 To SedCnt%
           cra%(i%) = PutArr((i% - 1) * 3 + 1) And &H3F
           Sua%(i%) = PutArr((i% - 1) * 3 + 2)
           Data%(i%) = PutArr((i% - 1) * 3 + 3)
           mode%(i%) = PutArr((i% - 1) * 3 + 1) And &HC0
    Next i%

End Sub
Sub ConvToGetArr(SedCnt%, GetArr%(), Data%(), Reply%())
    Dim i%
    
    ReDim GetArr%(2 * SedCnt%)
    For i% = 1 To SedCnt%
        GetArr%(2 * (i% - 1) + 1) = Reply%(i%)
        GetArr%(2 * (i% - 1) + 2) = Data%(i%)
    Next i%
    
End Sub
'
'************************************ Call SedacPackMix *********************************************
'  Fuehrt SedPut/SedGet mit beliebig sortierten Read- und Write- Telegrammen aus
'
Sub SedacSinglePackMix(Serv$, lin%, cra%(), reg%(), ReadWriteData%(), ReadWriteMode%(), Reply%(), check$)
'
'
'  Parameter:
'     Serv              I/O     Name des PCs, an dem die Sedac-Line haengt
'     lin               I/O     Sedac-Line-Nummer
'     cra               I/O     Array, der die Crate-Nummern enthaelt
'     reg               I/O     Array, der die SubAdressen enthaelt
'     ReadWriteMode     I/O     enthaelt die Konstanten SEDAC_READ, bzw. SEDAC_WRITE, je nachdem, ob  an dieser Stelle ein
'                                  Read- oder ein Write Telegramm behandelt werden soll
'     ReadWriteData     I/      enthaelt der Array ReadWriteMode an dieser Stelle SEDAC_READ, steht hier ein Dummy-Wert,
'                                  enthaelt er SEDAC_WRITE, steht hier der zu schreibende SedacValue
'                        /O     enthaelt der Array ReadWriteMode an dieser Stelle SEDAC_Write, steht hier ein Dummy-Wert,
'                                  enthaelt er SEDAC_READ, steht hier der gelesene SedacValue
'     Reply              /O     enthaelt den StatusArray aus SedGet
'     Check              /O     Fehlerstring, ist "ok", wenn alles stimmt
'

    Dim iSedErr%
    Dim ReplyFlag%
    Dim Length%
    Dim PackLength%, i%, j%
    Dim SedacPackMxArgument As SedacPackMixArg
    Dim SedacPackMxReturn As SedacPackMixRet
    
    Length% = UBound(cra%)
    
    If Length% = UBound(reg%) Then Else check$ = dimension_error:               Exit Sub
    If Length% = UBound(ReadWriteData%) Then Else check$ = dimension_error:     Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:             Exit Sub
  
    If Serv$ = LocalPC$ Then
    ' Local Sedac Read
        
        PackLength% = 3 * Length%
        ReDim PutArr%(1 To PackLength)
  
        j% = 0
        For i% = 1 To Length%
            If cra%(i) < 0 Or cra%(i) > 63 Then check$ = ADRESS_ERROR: Exit Sub
            If reg%(i) < 0 Or reg%(i) > 255 Then check$ = ADRESS_ERROR: Exit Sub
            Select Case ReadWriteMode%(i)
            Case SEDAC_READ, SEDAC_WRITE
                PutArr%(j + 1) = cra%(i) + ReadWriteMode%(i)  '+ &H80 is SedPC DLL SedacReadFunction Code
                PutArr%(j + 2) = reg%(i)                      'Sedac Subadress
                PutArr%(j + 3) = ReadWriteData%(i)            'will be ignored by SedPC
                j = j + 3
            Case Else
                check$ = RANGE_ERROR: Exit Sub
            End Select
        Next i%
  
    
         
         ReDim ReplyArr%(1 To PackLength)
         
         Call SedPut(lin%, Length%, PutArr%(1), iSedErr%)
         Call ErrorHandling(iSedErr%, "SedPut", Serv$, lin%, lin%, lin%, check$)
         If check$ = "ok" Then
            Call SedGet(lin%, Length%, ReplyArr%(1), iSedErr%)
            Call ErrorHandling(iSedErr%, "SedGet", Serv$, lin%, lin%, lin%, check$)
            For i% = 1 To Length%
                ReadWriteData%(i%) = ReplyArr%(2 * i%)
                Reply%(i) = ReplyArr%(2 * i% - 1) And &HFFDF
            Next i%
        End If
      
        If frmSedFun.Check1 Then
            Call SedErrProt("PackMix", lin%, ERR_SEDPC, ERR_SEDPC, iSedErr%)
            If iSedErr <> 0 Then
                Call ErrPackProt(Serv$, lin%, Length%, cra%(), reg%(), Reply%())
            End If
        End If
      
  
  
    Else
    ' Remote Sedac PackMix
        For i% = 1 To Length%
            SedacPackMxArgument.Crate(i%) = cra%(i%)
            SedacPackMxArgument.SubAdress(i%) = reg%(i%)
            SedacPackMxArgument.mode(i%) = ReadWriteMode%(i%)
            SedacPackMxArgument.PackWriteData(i%) = ReadWriteData%(i%)
        Next i%
        SedacPackMxArgument.PackLen = Length%
        
        frmSedFun!ACOP1.DeviceProperty = "SedPacMX"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacPackMxReturn.Reply(0), Len(SedacPackMxReturn), "STRUCT", SedacPackMxArgument.Crate(0), Len(SedacPackMxArgument), "STRUCT")
      
        For i% = 1 To Length%
            ReadWriteData%(i%) = SedacPackMxReturn.PackReadData(i%)
            Reply%(i%) = SedacPackMxReturn.Reply(i%)
        Next i%
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
End Sub
Sub SedacGetCrates(Serv$, lin%, CrArr%(), CrCnt%, check$)
      
          
    Dim iSedErr%
    Dim ReplyFlag%
    Dim SedacGetCraReturn(32) As Integer
    Dim Length%, i%
    
      Length% = 32
      If Length% > UBound(CrArr%) Then check$ = dimension_error:     Exit Sub
          
          If Serv$ = LocalPC$ Then
        
         ' Local Sedac Read
             
        Call SedLcs(lin%, 128, CrCnt%, CrArr%(1), iSedErr%)
        Call ErrorHandling(iSedErr%, "SedLcs", Serv$, lin%, lin%, lin%, check$)
      
      
       If frmSedFun.Check1 Then
            Call SedErrProt("GetCrates", lin%, ERR_SEDLCS, ERR_SEDLCS, iSedErr%)
        End If
    
      
      Else
        
         ' Remote Sedac Read
         
        frmSedFun!ACOP1.DeviceProperty = "LookCra"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetCraReturn, 32, "Integer")
        
        CrCnt% = 0
        If ReplyFlag% = 0 Then
            For i% = 1 To 32
                CrArr%(i%) = SedacGetCraReturn(i%)
                If CrArr%(i%) > 0 Then CrCnt% = CrCnt% + 1
            Next i%
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If

    End If
End Sub

Sub SedacGetSubadresses(Serv$, lin%, cr%, SuArr%(), SuCnt%, check$)
      
        
    Dim iSedErr%
    Dim ReplyFlag%
    Dim SedacGetSuaReturn(256) As Integer
    Dim Length%, i%
    
    Length% = 256
    If Length% > UBound(SuArr%) Then check$ = dimension_error:     Exit Sub
        
    If Serv$ = LocalPC$ Then
      
           ' Local Sedac Read
               
            Call SedLcs(lin%, cr%, SuCnt%, SuArr%(1), iSedErr%)
            Call ErrorHandling(iSedErr%, "SedLcs", Serv$, lin%, lin%, lin%, check$)
        
        
            If frmSedFun.Check1 Then
              Call SedErrProt("GetCrates", lin%, ERR_SEDLCS, ERR_SEDLCS, iSedErr%)
            End If
    
    
    Else
      
           ' Remote Sedac Read
           
        frmSedFun!ACOP1.DeviceProperty = "LookSua"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetSuaReturn, 256, "INTEGER", cr%, 1, "INTEGER")
        
        SuCnt% = 0
        If ReplyFlag% = 0 Then
            For i% = 1 To 256
                SuArr%(i%) = SedacGetSuaReturn(i%)
                If SuArr%(i%) > 0 Then SuCnt% = SuCnt% + 1
            Next i%
            check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If

    End If
End Sub
Sub SedacPackMix(Serv$, lin%, cra%(), reg%(), ReadWriteData%(), ReadWriteMode%(), Reply%(), check$)

    Dim Length%, MaxPackLen%, i%, Count%, TypArr%(6)
    Dim CraS%(), RegS%(), ReadWriteDataS%(), ReadWriteModeS%(), RePlyS%()

    Length% = UBound(cra)
      
    If Length% > &H7FFF Then check$ = PACKET_TOO_LONG:      Exit Sub
    If Length% = UBound(reg%) Then Else check$ = dimension_error:               Exit Sub
    If Length% = UBound(ReadWriteData%) Then Else check$ = dimension_error:     Exit Sub
    If Length% = UBound(ReadWriteMode%) Then Else check$ = dimension_error:     Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:             Exit Sub

        If Serv$ = LocalPC$ Then

        If Length% > MINDEST_FIFO_LENGTH / 5 Then
            Call SedacGetTyps(Serv$, lin%, TypArr%(), check$)
            MaxPackLen% = Int(TypArr%(5) / 5)
        Else
            MaxPackLen% = Int(MINDEST_FIFO_LENGTH / 5)
        End If
        
     Else
         MaxPackLen% = MAX_REMOTE_PACK_SIZE
     End If
     
     If Length% < MaxPackLen% Then
        Call SedacSinglePackMix(Serv$, lin%, cra%(), reg%(), ReadWriteData%(), ReadWriteMode%(), Reply%(), check$)
     Else
        Do While Length% > MaxPackLen%
            ReDim CraS%(MaxPackLen%), RegS%(MaxPackLen%), ReadWriteDataS%(MaxPackLen%), ReadWriteModeS%(MaxPackLen%), RePlyS%(MaxPackLen%)
            For i% = 1 To MaxPackLen%
                CraS%(i%) = cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                ReadWriteDataS%(i%) = ReadWriteData%(i% + Count% * MaxPackLen%)
                ReadWriteModeS%(i%) = ReadWriteMode%(i% + Count% * MaxPackLen%)
            Next i%
            Call SedacSinglePackMix(Serv$, lin%, CraS%(), RegS%(), ReadWriteDataS%(), ReadWriteModeS%(), RePlyS%(), check$)
            check$ = check$ & check$
            For i% = 1 To MaxPackLen%
                ReadWriteData%(i% + Count% * MaxPackLen%) = ReadWriteDataS%(i%)
                RePlyS%(i% + Count% * MaxPackLen%) = Reply%(i%)
            Next i%
            Length% = Length% - MaxPackLen%
            Count% = Count% + 1
        Loop
        If Length% > 0 Then
            ReDim CraS%(Length%), RegS%(Length%), ReadWriteDataS%(Length%), ReadWriteModeS%(Length%), RePlyS%(Length%)
            For i% = 1 To Length%
                CraS%(i%) = cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                ReadWriteDataS%(i%) = ReadWriteData%(i% + Count% * MaxPackLen%)
                ReadWriteModeS%(i%) = ReadWriteMode%(i% + Count% * MaxPackLen%)
            Next i%
            Call SedacSinglePackMix(Serv$, lin%, CraS%(), RegS%(), ReadWriteDataS%(), ReadWriteModeS%(), RePlyS%(), check$)
            check$ = check$ & check$
            For i% = 1 To Length%
                ReadWriteDataS%(i% + Count% * MaxPackLen%) = ReadWriteData%(i%)
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
            Count% = Count% + 1
        End If
        For i% = 1 To Count%
            check$ = Replace(check$, "ok", "")
            If check$ = "" Then check$ = "ok"
        Next i%
     End If
End Sub
Sub SedacPackRead(Serv$, lin%, cra%(), reg%(), ReadData%(), Reply%(), check$)

    Dim CraS%(), RegS%(), ReadDataS%(), RePlyS%()
    Dim Length%, MaxPackLen%, i%, Count%, TypArr%(6)
    
    Length% = UBound(cra)
      
    If Length% > &H7FFF Then check$ = PACKET_TOO_LONG:      Exit Sub
    If Length% = UBound(reg%) Then Else check$ = dimension_error:       Exit Sub
    If Length% = UBound(ReadData%) Then Else check$ = dimension_error:  Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:     Exit Sub

        If Serv$ = LocalPC$ Then

        If Length% > MINDEST_FIFO_LENGTH / 5 Then
            Call SedacGetTyps(Serv$, lin%, TypArr%(), check$)
            MaxPackLen% = Int(TypArr%(5) / 5)
        Else
            MaxPackLen% = Int(MINDEST_FIFO_LENGTH / 5)
        End If
        
     Else
         MaxPackLen% = MAX_REMOTE_PACK_SIZE
     End If
     
     If Length% < MaxPackLen% Then
        Call SedacSinglePackRead(Serv$, lin%, cra%(), reg%(), ReadData%(), Reply%(), check$)
     Else
        Do While Length% > MaxPackLen%
            ReDim CraS%(MaxPackLen%), RegS%(MaxPackLen%), ReadDataS%(MaxPackLen%), RePlyS%(MaxPackLen%)
            For i% = 1 To MaxPackLen%
                CraS%(i%) = cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
            Next i%
            Call SedacSinglePackRead(Serv$, lin%, CraS%(), RegS%(), ReadDataS%(), RePlyS%(), check$)
            For i% = 1 To MaxPackLen%
                ReadData%(i% + Count% * MaxPackLen%) = ReadDataS%(i%)
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
            Length% = Length% - MaxPackLen%
            Count% = Count% + 1
        Loop
        If Length% > 0 Then
            ReDim CraS%(Length%), RegS%(Length%), ReadDataS%(Length%), RePlyS%(Length%)
            For i% = 1 To Length%
                CraS%(i%) = cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
            Next i%
            Call SedacSinglePackRead(Serv$, lin%, CraS%(), RegS%(), ReadDataS%(), RePlyS%(), check$)
            For i% = 1 To Length%
                ReadData%(i% + Count% * MaxPackLen%) = ReadDataS%(i%)
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
        End If
     
     End If
End Sub
Sub SedacPackWrite(Serv$, lin%, cra%(), reg%(), WriteData%(), Reply%(), check$)
    
    Dim CraS%(), RegS%(), WriteDataS%(), RePlyS%()
    Dim Length%, MaxPackLen%, i%, Count%, TypArr%(6)
    
    Length% = UBound(cra)
      
    If Length% > &H7FFF Then check$ = PACKET_TOO_LONG:      Exit Sub
    If Length% = UBound(reg%) Then Else check$ = dimension_error:       Exit Sub
    If Length% = UBound(WriteData%) Then Else check$ = dimension_error:  Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:     Exit Sub

        If Serv$ = LocalPC$ Then

        If Length% > MINDEST_FIFO_LENGTH / 5 Then
            Call SedacGetTyps(Serv$, lin%, TypArr%(), check$)
            MaxPackLen% = Int(TypArr%(5) / 5)
        Else
            MaxPackLen% = Int(MINDEST_FIFO_LENGTH / 5)
        End If
        
     Else
         MaxPackLen% = MAX_REMOTE_PACK_SIZE
     End If
     
     If Length% < MaxPackLen% Then
        Call SedacSinglePackWrite(Serv$, lin%, cra%(), reg%(), WriteData%(), Reply%(), check$)
     Else
        Do While Length% > MaxPackLen%
            ReDim CraS%(MaxPackLen%), RegS%(MaxPackLen%), WriteDataS%(MaxPackLen%), RePlyS%(MaxPackLen%)
            For i% = 1 To MaxPackLen%
                CraS%(i%) = cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                WriteDataS%(i%) = WriteData%(i% + Count% * MaxPackLen%)
            Next i%
            Call SedacSinglePackWrite(Serv$, lin%, CraS%(), RegS%(), WriteDataS%(), RePlyS%(), check$)
            For i% = 1 To MaxPackLen%
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
            Length% = Length% - MaxPackLen%
            Count% = Count% + 1
        Loop
        If Length% > 0 Then
            ReDim CraS%(Length%), RegS%(Length%), WriteDataS%(Length%), RePlyS%(Length%)
            For i% = 1 To Length%
                CraS%(i%) = cra%(i% + Count% * MaxPackLen%)
                RegS%(i%) = reg%(i% + Count% * MaxPackLen%)
                WriteDataS%(i%) = WriteData%(i% + Count% * MaxPackLen%)
            Next i%
            Call SedacSinglePackWrite(Serv$, lin%, CraS%(), RegS%(), WriteDataS%(), RePlyS%(), check$)
            For i% = 1 To Length%
                Reply%(i% + Count% * MaxPackLen%) = RePlyS%(i%)
            Next i%
        End If
     
     End If
End Sub
'
'************************************ Call SedacPackRead *********************************************
'
'
Sub SedacSinglePackRead(Serv$, lin%, cra%(), reg%(), ReadData%(), Reply%(), check$)
        
    Dim ReplyFlag%, iSedErr%
    Dim Length%
    Dim PackLength%, i%, FifoLen%, TypArr%(6), RepeatCount%, Flen%
    Dim SedacPackRdArgument As SedacPackReadArg
    Dim SedacPackRdReturn As SedacPackReadRet
    
    Length = UBound(cra%)
      
    If Length% = UBound(reg%) Then Else check$ = dimension_error:       Exit Sub
    If Length% = UBound(ReadData%) Then Else check$ = dimension_error:  Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:     Exit Sub
    
    
    If Serv$ = LocalPC$ Then
    ' Local Sedac Pack Read
         
        PackLength% = 3 * Length
        ReDim PutArr%(1 To PackLength%)
    
        For i% = 1 To Length%                                       'Fill Ipackarray PutArr with UserData
          If cra%(i%) < 0 Or cra(i%) > 63 Then check = ADRESS_ERROR: Exit Sub
          If reg%(i%) < 0 Or reg(i%) > 255 Then check = ADRESS_ERROR: Exit Sub
          PutArr%((i% - 1) * 3 + 1) = cra(i%) + SEDAC_READ          '+ &H80 is SedPC DLL SedacReadFunction Code
          PutArr%((i% - 1) * 3 + 2) = reg(i%)                       'Sedac Subadress
        Next i%
                     
        ReDim ReplyArr%(1 To PackLength%)
           
        Call SedPut(lin%, Length%, PutArr%(1), iSedErr%)
        Call ErrorHandling(iSedErr%, "SedPut", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
            Call SedGet(lin%, Length%, ReplyArr%(1), iSedErr%)
            Call ErrorHandling(iSedErr%, "SedGet", Serv$, lin%, lin%, lin%, check$)
             For i% = 1 To Length%
               ReadData%(i%) = ReplyArr%(2 * i)
               Reply%(i%) = ReplyArr%(2 * i - 1) And &HFFDF
             Next i%
        End If
    
        If frmSedFun.Check1 Then
          Call SedErrProt("PackRead", lin%, ERR_SEDPC, ERR_SEDPC, iSedErr%)
          If iSedErr <> 0 Then
              Call ErrPackProt(Serv$, lin%, Length%, cra%(), reg%(), Reply%())
          End If
        End If
    
    Else
          
    ' Remote Sedac PackRead
        
        For i% = 1 To Length%
            SedacPackRdArgument.Crate(i%) = cra%(i%)
            SedacPackRdArgument.SubAdress(i%) = reg%(i%)
        Next i%
        SedacPackRdArgument.PackLen = Length%
        
        frmSedFun!ACOP1.DeviceProperty = "SedPacRD"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacPackRdReturn.Reply(0), Len(SedacPackRdReturn), "STRUCT", SedacPackRdArgument.Crate(0), Len(SedacPackRdArgument), "STRUCT")
      
        For i% = 1 To Length%
            ReadData%(i%) = SedacPackRdReturn.PackReadData(i%)
            Reply%(i%) = SedacPackRdReturn.Reply(i%)
        Next i%
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
    
End Sub

'
'************************************ Call SedacPackRead *********************************************
'
'
Sub SedacMultiRead(Serv$, LinCnt%, lin%(), cra%(), reg%(), ReadData%(), Reply%(), check$)
    
    
    ' linCnt%           Zahl der Lines

    ' Dim lin%(linCnt%,2)
    ' lin%(i%,1)        Line Nummer
    ' lin%(i%,2)        Zahl der Telegramme auf der Line lin(i%,1)

    ' Length%=Maximum von  lin%(i%,2) ber alle i%

    ' Dim cra%(Length%,linCnt%)
    ' cra%(i%,j%)       CrateAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim reg%(Length%,linCnt%)
    ' reg%(i%,j%)       SubAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim ReadData%(Length%,linCnt%)
    ' ReadData%(i%,j%)  DatenWort des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim Reply%(Length%,linCnt%)
    ' Reply%(i%,j%)     Antwort des i-ten Telegrams auf der Line lin%(j%,1)
    '

    Dim iSedErr%()
    Dim Check1$, check2$
    Dim i%, j%
    
    For i% = 1 To LinCnt%
        For j% = 1 To lin(i%, 2)                                      'Fill Ipackarray PutArr with UserData
            If cra%(j%, i%) < 0 Or cra(j%, i%) > 63 Then check = ADRESS_ERROR: Exit Sub
            If reg%(j%, i%) < 0 Or reg(j%, i%) > 255 Then check = ADRESS_ERROR: Exit Sub
        Next j%
    Next i%
    
        If Serv$ = LocalPC$ Then
          
        ' Local Sedac Read
           
           
        ReDim iSedErr%(LinCnt%)
    
        For i% = 1 To LinCnt%
            ReDim PutArr%(3 * lin(i%, 2))
            For j% = 1 To lin%(i%, 2)
                PutArr%((j% - 1) * 3 + 1) = cra(j%, i%) + SEDAC_READ        '+ &H80 is SedPC DLL SedacReadFunction Code
                PutArr%((j% - 1) * 3 + 2) = reg(j%, i%)                     'Sedac Subadress
            Next j%
            Call SedPut(lin%(i%, 1), lin%(i%, 2), PutArr%(1), iSedErr%(i%))
        Next i%
        For i% = 1 To LinCnt%
            Call ErrorHandling(iSedErr%(i%), "SedPut", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), Check1$)
            If Check1$ = "ok" Then
                ReDim ReplyArr%(3 * lin(i%, 2))
                Call SedGet(lin%(i%, 1), lin%(i%, 2), ReplyArr%(1), iSedErr%(i%))
                Call ErrorHandling(iSedErr%(i%), "SedGet", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), check2$)
                For j% = 1 To lin%(i%, 2)
                  ReadData%(j%, i%) = ReplyArr%(2 * j%)
                  Reply%(j%, i%) = ReplyArr%(2 * j% - 1) And &HFFDF
                Next j%
                If frmSedFun.Check1 Then
                    Call SedErrProt("PackRead", lin%(i%, 1), ERR_SEDPC, ERR_SEDPC, iSedErr%(i%))
                    If iSedErr(i%) <> 0 Then
                        Call ErrMultiPackProt(Serv$, lin%(i%, 1), lin(i%, 2), cra%(), reg%(), Reply%())
                    End If
                End If
                If check2$ <> "ok" Then check$ = check$ & ";Get: Line=" & lin%(i%, 1) & "," & check2$
            Else
                Check1$ = Replace(Check1$, " & Error in SedClr!!!", "")
                check$ = check$ & ";Put: Line=" & lin%(i%, 1) & "," & Check1$
            End If
        
        Next i%
        
        If check$ = "" Then
            check$ = "ok"
        Else
            check$ = Replace(check$, ";", "", 1, 1)
        End If
    
    Else
        check$ = "No remote Sedac-Access by multi-line functions"
    End If

End Sub
'
'************************************ Call SedacPackRead *********************************************
'
'
Sub SedacMultiMix(Serv$, LinCnt%, lin%(), cra%(), reg%(), ReadWriteData%(), ReadWriteMode%(), Reply%(), check$)
    
    
    ' linCnt%           Zahl der Lines

    ' Dim lin%(linCnt%,2)
    ' lin%(i%,1)            Line Nummer
    ' lin%(i%,2)            Zahl der Telegramme auf der Line lin(i%,1)

    ' Length%=Maximum von lin%(i%,2) ber alle i%

    ' Dim cra%(Length%,linCnt%)
    ' cra%(i%,j%)           CrateAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim reg%(Length%,linCnt%)
    ' reg%(i%,j%)           SubAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim ReadWriteData%(Length%,linCnt%)
    ' ReadWriteData%(i%,j%) DatenWort des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim ReadWriteMode%(Length%,linCnt%)
    ' ReadWriteMode%(i%,j%) SEDAC_READ oder SEDAC_WRITE, je nachdem ob das i-te Telegram
    '                       auf der Line lin%(j%,1) gelesen oder geschrieben werden soll

    ' Dim Reply%(Length%,linCnt%)
    ' Reply%(i%,j%)     Antwort des i-ten Telegrams auf der Line lin%(j%,1)
    '

    Dim iSedErr%()
    Dim Check1$, check2$
    Dim i%, j%
    
    For i% = 1 To LinCnt%
        For j% = 1 To lin(i%, 2)                                      'Fill Ipackarray PutArr with UserData
            If cra%(j%, i%) < 0 Or cra(j%, i%) > 63 Then check = ADRESS_ERROR: Exit Sub
            If reg%(j%, i%) < 0 Or reg(j%, i%) > 255 Then check = ADRESS_ERROR: Exit Sub
        Next j%
    Next i%
    
    If Serv$ = LocalPC$ Then
          
        ' Local Sedac Read
           
           
        ReDim iSedErr%(LinCnt%)
    
        For i% = 1 To LinCnt%
            ReDim PutArr%(3 * lin(i%, 2))
            For j% = 1 To lin%(i%, 2)
                PutArr%((j% - 1) * 3 + 1) = cra(j%, i%) + ReadWriteMode%(j%, i%) '+ &H80 is SedPC DLL SedacReadFunction Code
                PutArr%((j% - 1) * 3 + 2) = reg(j%, i%)                      'Sedac Subadress
                PutArr%((j% - 1) * 3 + 3) = ReadWriteData%(j%, i%)              'User Sedac data as VB integer format
            Next j%
            Call SedPut(lin%(i%, 1), lin%(i%, 2), PutArr%(1), iSedErr%(i%))
        Next i%
        For i% = 1 To LinCnt%
            Call ErrorHandling(iSedErr%(i%), "SedPut", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), Check1$)
            If Check1$ = "ok" Then
                ReDim ReplyArr%(3 * lin(i%, 2))
                Call SedGet(lin%(i%, 1), lin%(i%, 2), ReplyArr%(1), iSedErr%(i%))
                Call ErrorHandling(iSedErr%(i%), "SedGet", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), check2$)
                For j% = 1 To lin%(i%, 2)
                  ReadWriteData%(j%, i%) = ReplyArr%(2 * j%)
                  Reply%(j%, i%) = ReplyArr%(2 * j% - 1) And &HFFDF
                Next j%
                If frmSedFun.Check1 Then
                    Call SedErrProt("PackRead", lin%(i%, 1), ERR_SEDPC, ERR_SEDPC, iSedErr%(i%))
                    If iSedErr(i%) <> 0 Then
                        Call ErrMultiPackProt(Serv$, lin%(i%, 1), lin(i%, 2), cra%(), reg%(), Reply%())
                    End If
                End If
                If check2$ <> "ok" Then check$ = check$ & ";Get: Line=" & lin%(i%, 1) & "," & check2$
            Else
                check$ = check$ & ";Put: Line=" & lin%(i%, 1) & "," & Check1$
            End If
        
        Next i%
        
        If check$ = "" Then
            check$ = "ok"
        Else
            check$ = Replace(check$, ";", "", 1, 1)
        End If
    
    Else
        check$ = "No remote Sedac-Access by multi-line functions"
    End If

End Sub

'
'************************************ Call SedacPackRead *********************************************
'
'
Sub SedacMultiWrite(Serv$, LinCnt%, lin%(), cra%(), reg%(), WriteData%(), Reply%(), check$)
    
    
    ' linCnt%           Zahl der Lines

    ' Dim lin%(linCnt%,2)
    ' lin%(i%,1)        Line Nummer
    ' lin%(i%,2)        Zahl der Telegramme auf der Line lin(i%,1)

    ' Length%=Maximum von  lin%(i%,2) ber alle i%

    ' Dim cra%(Length%,linCnt%)
    ' cra%(i%,j%)       CrateAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim reg%(Length%,linCnt%)
    ' reg%(i%,j%)       SubAdresse des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim WriteData%(Length%,linCnt%)
    ' ReadData%(i%,j%)  DatenWort des i-ten Telegrams auf der Line lin%(j%,1)

    ' Dim Reply%(Length%,linCnt%)
    ' Reply%(i%,j%)     Antwort des i-ten Telegrams auf der Line lin%(j%,1)
    '

    Dim iSedErr%()
    Dim Check1$, check2$
    Dim i%, j%
  
    For i% = 1 To LinCnt%
        For j% = 1 To lin(i%, 2)                                      'Fill Ipackarray PutArr with UserData
            If cra%(j%, i%) < 0 Or cra(j%, i%) > 63 Then check$ = ADRESS_ERROR: Exit Sub
            If reg%(j%, i%) < 0 Or reg(j%, i%) > 255 Then check$ = ADRESS_ERROR: Exit Sub
        Next j%
    Next i%
    
        If Serv$ = LocalPC$ Then
          
        ' Local Sedac Read
           
           
        ReDim iSedErr%(LinCnt%)
    
        For i% = 1 To LinCnt%
            ReDim PutArr%(3 * lin(i%, 2))
            For j% = 1 To lin%(i%, 2)
                PutArr%((j% - 1) * 3 + 1) = cra(j%, i%) + SEDAC_WRITE       '+ &H40 is SedPC DLL SedacReadFunction Code
                PutArr%((j% - 1) * 3 + 2) = reg(j%, i%)                     'Sedac Subadress
                PutArr%((j% - 1) * 3 + 3) = WriteData%(j%, i%)                 'User Sedac data as VB integer format
            Next j%
            Call SedPut(lin%(i%, 1), lin%(i%, 2), PutArr%(1), iSedErr%(i%))
        Next i%
        check$ = ""
        For i% = 1 To LinCnt%
            Call ErrorHandling(iSedErr%(i%), "SedPut", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), Check1$)
            If Check1$ = "ok" Then
                ReDim ReplyArr%(3 * lin(i%, 2))
                Call SedGet(lin%(i%, 1), lin%(i%, 2), ReplyArr%(1), iSedErr%(i%))
                Call ErrorHandling(iSedErr%(i%), "SedGet", Serv$, lin%(i%, 1), lin%(i%, 1), lin%(i%, 1), check2$)
                For j% = 1 To lin%(i%, 2)
                  Reply%(j%, i%) = ReplyArr%(2 * j% - 1) And &HFFDF
                Next j%
                If frmSedFun.Check1 Then
                    Call SedErrProt("PackWrite", lin%(i%, 1), ERR_SEDPC, ERR_SEDPC, iSedErr%(i%))
                    If iSedErr(i%) <> 0 Then
                        Call ErrMultiPackProt(Serv$, lin%(i%, 1), lin(i%, 2), cra%(), reg%(), Reply%())
                    End If
                End If
                If check2$ <> "ok" Then check$ = check$ & ";Get: Line=" & lin%(i%, 1) & "," & check2$
            Else
                Check1$ = Replace(Check1$, " & Error in SedClr!!!", "")
                check$ = check$ & ";Put: Line=" & lin%(i%, 1) & "," & Check1$
            End If
        
        Next i%
        
        If check$ = "" Then
            check$ = "ok"
        Else
            check$ = Replace(check$, ";", "", 1, 1)
        End If
    
    Else
        check$ = "No remote Sedac-Access by multi-line functions"
    End If

End Sub


'
'******************************** Call SedacPackWrite **********************************************
'
'
Sub SedacSinglePackWrite(Serv$, lin%, cra%(), reg%(), WriteData%(), Reply%(), check$)
    
    Dim ReplyFlag%, iSedErr%
    Dim Length%
    Dim PackLength%, i%
    Dim SedacPackWrArgument As SedacPackWriteArg
    Dim SedacPackWrReturn As SedacPackWriteRet
    
    Length% = UBound(cra%)
    If Length% = UBound(reg%) Then Else check$ = dimension_error:           Exit Sub
    If Length% = UBound(WriteData%) Then Else check$ = dimension_error:     Exit Sub
    If Length% = UBound(Reply%) Then Else check$ = dimension_error:         Exit Sub
      
    If Serv$ = LocalPC$ Then
        ' Local Sedac PackWrite
    
        PackLength% = 3 * Length%
        ReDim PutArr%(1 To PackLength%)                        'Dimension for Putarr
          
        For i% = 1 To Length%                                   'Fill Ipackarray PutArr with UserData
            If cra%(i%) < 0 Or cra(i) > 63 Then check = ADRESS_ERROR: Exit Sub
            If reg%(i%) < 0 Or reg(i) > 255 Then check = ADRESS_ERROR: Exit Sub
            PutArr%((i% - 1) * 3 + 1) = cra%(i%) + SEDAC_WRITE    '+ &H40 is DLL SedacWriteFunctionCode
            PutArr%((i% - 1) * 3 + 2) = reg%(i%)                  'Sedac Subadress
            PutArr%((i% - 1) * 3 + 3) = WriteData%(i%)            'User Sedac data as VB integer format
        Next i%
       
        
        ReDim ReplyArr%(1 To PackLength%)                       'Dimension for ReplyArr
        
        Call SedPut(lin%, Length%, PutArr%(1), iSedErr%)
        Call ErrorHandling(iSedErr%, "SedPut", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
           Call SedGet(lin%, Length%, ReplyArr%(1), iSedErr%)
           Call ErrorHandling(iSedErr%, "SedGet", Serv$, lin%, lin%, lin%, check$)
            For i% = 1 To Length%
                Reply%(i) = ReplyArr%(2 * i% - 1) And &HFFDF
            Next i%
       End If
    
       If frmSedFun.Check1 Then
         Call SedErrProt("Packwrit", lin%, ERR_SEDPC, ERR_SEDPC, iSedErr%)
         If iSedErr% <> 0 Then
             Call ErrPackProt(Serv$, lin%, Length%, cra%(), reg%(), Reply%())
         End If
       End If
    
    Else
        
    ' Remote Sedac PackWrite
    
        For i% = 1 To Length%
            SedacPackWrArgument.Crate(i%) = cra%(i%)
            SedacPackWrArgument.SubAdress(i%) = reg%(i%)
            SedacPackWrArgument.PackWriteData(i%) = WriteData%(i%)
        Next i%
        SedacPackWrArgument.PackLen = Length%
        
        frmSedFun!ACOP1.DeviceProperty = "SedPacWR"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacPackWrReturn.Reply(0), Len(SedacPackWrReturn), "STRUCT", SedacPackWrArgument.Crate(0), Len(SedacPackWrArgument), "STRUCT")
      
        For i% = 1 To Length%
            Reply%(i%) = SedacPackWrReturn.Reply(i%)
        Next i%
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
        
End Sub

'
' ************************** Call Sedac Read ***********************************************
'
'
 Sub SedacRead(Serv$, lin%, cra%, reg%, SedVal&, check$)
                
    Dim iSedErr%
    Dim isedval%
    Dim Li%, cr%, rg%
    Dim ReplyFlag%
    Dim SedacRdArgument As SedacReadArg
    Dim SedacRdReturn As Long

    If cra% < 0 Or cra% > 63 Then check$ = ADRESS_ERROR: Exit Sub
    If reg% < 0 Or reg% > 255 Then check$ = ADRESS_ERROR: Exit Sub
    
    If Serv$ = LocalPC$ Then
      
    ' Local Sedac Read
        
        Li% = lin%: cr% = cra%: rg% = reg%
        Call SedRd(Li%, cr%, rg%, isedval%, iSedErr%)
        Call ErrorHandling(iSedErr%, "SedRd", Serv$, lin%, cra%, reg%, check$)
        If check$ = "ok" Then
            If isedval% >= 0 Then
                SedVal& = CLng(isedval%)
            Else
                SedVal& = CLng(isedval%) + &HFFFF& + 1
            End If
            check$ = "ok"
        End If

    
        If frmSedFun.Check1 Then
            Call SedErrProt("SingRead", lin%, cra%, reg%, iSedErr%)
        End If
    Else
        
    ' Remote Sedac Read
        
        check$ = ""
    
        SedacRdArgument.Crate = cra%
        SedacRdArgument.SubAdress = reg%
        
        frmSedFun!ACOP1.DeviceProperty = "SedacRead"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacRdReturn, 1, "LONG", SedacRdArgument.Crate, Len(SedacRdArgument), "STRUCT")
        
        If ReplyFlag% = 0 Then
            SedVal& = SedacRdReturn
            check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
    
    End If
    

End Sub

'
'************************************ Call Sedac TestTel Off *********************************************
'
'
Sub SedacTestTelOff(Serv$, lin%, check$)
    
    Dim ReplyFlag%, iSedErr%

    If Serv$ = LocalPC$ Then
      
    ' Local Sedac Read
        
        Call SedTst(lin%, 0, 0, 0, 0, iSedErr%)
        Call ErrorHandling(iSedErr%, "SedTst", Serv$, lin%, lin%, lin%, check$)
    
        If frmSedFun.Check1 Then
        Call SedErrProt("TestTelOff", lin%, ERR_SEDTST, ERR_SEDTST, iSedErr%)
        End If

    Else
        
    ' Remote TestTelegamme off
        
        frmSedFun!ACOP1.DeviceProperty = "TstTelOff"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
     
End Sub
Sub SedacGetTyps(Serv$, lin%, TypArr%(), check$)
    
        
    Dim ReplyFlag%, iSedErr%
    Dim i%, HardWareTyp%, ReleaseNr%, FirmWareVersion%, FirmWareRelease%, FiFoLength%
    Dim SedacGetTypsReturn(6) As Integer

    If Serv$ = LocalPC$ Then
      
    ' Local Sedac Read
    
    
        Call SedTyp(lin%, HardWareTyp%, ReleaseNr%, FirmWareVersion%, FirmWareRelease%, FiFoLength%, iSedErr%)
        Call ErrorHandling(iSedErr%, "SedTyp", Serv$, lin%, lin%, lin%, check$)
        TypArr%(1) = HardWareTyp%
        TypArr%(2) = ReleaseNr%
        TypArr%(3) = FirmWareVersion%
        TypArr%(4) = FirmWareRelease%
        TypArr%(5) = FiFoLength%
        TypArr%(6) = iSedErr%
    
        If frmSedFun.Check1 Then
        Call SedErrProt("SedTyp", lin%, ERR_SEDTST, ERR_SEDTST, iSedErr%)
        End If
   
   Else
        
    ' Remote Sedac Read
        
        frmSedFun!ACOP1.DeviceProperty = "GetTyp"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetTypsReturn, 6, "Integer")
        
        If ReplyFlag% = 0 Then
            For i% = 1 To 6
                TypArr%(i%) = SedacGetTypsReturn(i%)
            Next i%
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
        
    End If
    
End Sub

Sub GetAllStatus(Serv$, lin%, a$, B$, c$, CrStr$(), check$)
    Dim iSedErr%, HardWareTyp%, ReleaseNr%, FirmWareVersion%, FirmWareRelease%, FiFoLength%, cr%, su%, iva%
    Dim i%, Clr%, Class%, Dlay%, Stat%
    Dim CntArr&(16), ErrArr%(256)
    Dim Version As String * 128, DllVersio As String * 64, Vers$, DVers$
    Dim SCheck$
    
    Call SedVer(lin%, Version$, iSedErr%)
    Call ErrorHandling(iSedErr%, "SedVer", Serv$, lin%, lin%, lin%, check$)
    
    Call SedDll(DllVersio)
    
    Call SedTyp(lin%, HardWareTyp%, ReleaseNr%, FirmWareVersion%, FirmWareRelease%, FiFoLength%, iSedErr%)
    Call ErrorHandling(iSedErr%, "SedTyp", Serv$, lin%, lin%, lin%, SCheck$)
    If SCheck$ <> "ok" Then check$ = check$ & SCheck$
    
    Call SedTst(lin%, 8, cr%, su%, iva%, iSedErr%)
    Call ErrorHandling(iSedErr%, "SedTsT", Serv$, lin%, lin%, lin%, SCheck$)
    If SCheck$ <> "ok" Then check$ = check$ & SCheck$
    
    Clr% = 1
    Call SedSta(lin%, Clr%, Stat%, iSedErr%)
    Call ErrorHandling(iSedErr%, "SedSta", Serv$, lin%, lin%, lin%, SCheck$)
    If SCheck$ <> "ok" Then check$ = check$ & SCheck$
    
    If HardWareTyp% > 0 Then
        Call SedCnt(lin%, CntArr&(1), iSedErr%)
        Call ErrorHandling(iSedErr%, "SedCnt", Serv$, lin%, lin%, lin%, SCheck$)
        If SCheck$ <> "ok" Then check$ = check$ & SCheck$
        If check$ = "" Then check$ = "ok"
    End If
    
    c$ = "Updated: " & date$ & " " & time$ & Chr$(13) & Chr$(10)
    Vers$ = Trim$(Replace(Version$, Chr$(0), " "))
    Vers$ = Replace(Vers$, Chr$(13) & Chr$(10), "   ", 1, 1)
    DVers$ = Trim$(Replace(DllVersio$, Chr$(0), " "))
    B$ = "Status of Sedac-Line " & lin% & " at " & LocalPC$
    a$ = "Updated: " & date$ & " " & time$ & Chr$(13) & Chr$(10)
    a$ = a$ & Vers$ & Chr$(13) & Chr$(10)
'    a$ = a$ & "Version der Dll:" & Chr$(13) & Chr$(10)
    a$ = a$ & DVers$ & Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10)
'    a$ = a$ & "Hardware Typ:" & Chr$(9) & Chr$(9) & HardWareTyp% & Chr$(13) & Chr$(10)
'    a$ = a$ & "ReleaseNr:" & Chr$(9) & Chr$(9) & ReleaseNr% & Chr$(13) & Chr$(10)
'    a$ = a$ & "Firmware Version:" & Chr$(9) & Chr$(9) & FirmWareVersion% & Chr$(13) & Chr$(10)
'    a$ = a$ & "Firmware Release:" & Chr$(9) & Chr$(9) & FirmWareRelease% & Chr$(13) & Chr$(10)
    a$ = a$ & "FiFo Length: " & Chr$(9) & Chr$(9) & FiFoLength% & Chr$(13) & Chr$(10)
    If cr% = 0 Then
        a$ = a$ & "Test Telegrams disabled" & Chr$(13) & Chr$(10)
    Else
        a$ = a$ & "Test Telegrams enabled, Param.: " & cr% & "," & su% & "," & iva% & Chr$(13) & Chr$(10)
    End If
    c$ = c$ & "Status(Hex):" & Chr$(9) & Hex$(Stat%) & Chr$(13) & Chr$(10)
    c$ = c$ & "d.h."
    If (Stat% And 1) = 1 Then c$ = c$ & Space$(3) & "Delay <> 0" & Chr$(13) & Chr$(10) Else c$ = c$ & Space$(3) & "Delay = 0" & Chr$(13) & Chr$(10)
    If (Stat% And 2) = 2 Then c$ = c$ & Space$(9) & "TestTel enabled " & Chr$(13) & Chr$(10) Else c$ = c$ & Space$(9) & "TestTel disabled " & Chr$(13) & Chr$(10)
    If HardWareTyp% > 0 Then
        If (Stat% And 8) = 8 Then c$ = c$ & Space$(9) & "There were Sedac-Errors" & Chr$(13) & Chr$(10) Else c$ = c$ & Space$(9) & "No Errors" & Chr$(13) & Chr$(10)
        If (Stat% And &HC0) <> 0 Then
            StatusLastReset$ = "Last Reset of SedPC at " & time$ & " " & date$
        End If
        c$ = c$ & Space$(9) & StatusLastReset$ & Chr$(13) & Chr$(10)
    End If
    a$ = a$ & Chr$(13) & Chr$(10)
    If HardWareTyp% > 0 Then
      a$ = a$ & "User Read Telegrams:" & Chr$(9) & CntArr&(1) & Chr$(13) & Chr$(10)
      a$ = a$ & "User Write Telegrams:" & Chr$(9) & CntArr&(2) & Chr$(13) & Chr$(10)
      a$ = a$ & "Test Telegrams:" & Chr$(9) & Chr$(9) & CntArr&(3) & Chr$(13) & Chr$(10)
      a$ = a$ & "Special Function Telegrams:" & Chr$(9) & CntArr&(4) & Chr$(13) & Chr$(10)
      a$ = a$ & "Cp's send, Progr. or Hardw.:" & Chr$(9) & CntArr&(5) & Chr$(13) & Chr$(10)
      a$ = a$ & "Progr. changes of Delay:" & Chr$(9) & CntArr&(6) & Chr$(13) & Chr$(10)
      a$ = a$ & "Progr. changes of TestTel.:" & Chr$(9) & CntArr&(7) & Chr$(13) & Chr$(10)
      a$ = a$ & Chr$(13) & Chr$(10)
      a$ = a$ & "Response Errors:" & Chr$(9) & Chr$(9) & CntArr&(9) & Chr$(13) & Chr$(10)
      a$ = a$ & "Framing Errors: " & Chr$(9) & Chr$(9) & CntArr&(10) & Chr$(13) & Chr$(10)
      a$ = a$ & "Fifo Errors: " & Chr$(9) & Chr$(9) & CntArr&(11) & Chr$(13) & Chr$(10)
      a$ = a$ & "Internal Errors: " & Chr$(9) & Chr$(9) & CntArr&(12) & Chr$(13) & Chr$(10)
      
      For i% = 0 To 30
          If (CntArr&(13) And 2 ^ i%) = 2 ^ i% Then CrStr$(1) = CrStr$(1) & "," & i%
          If (CntArr&(14) And 2 ^ i%) = 2 ^ i% Then CrStr$(2) = CrStr$(2) & "," & i%
          If (CntArr&(15) And 2 ^ i%) = 2 ^ i% Then CrStr$(3) = CrStr$(3) & "," & i%
      Next i%
      If CntArr&(13) < 0 Then CrStr$(1) = CrStr$(1) & "," & i%
      If CntArr&(14) < 0 Then CrStr$(2) = CrStr$(2) & "," & i%
      If CntArr&(15) < 0 Then CrStr$(3) = CrStr$(3) & "," & i%
      If CrStr$(1) <> "" Then CrStr$(1) = Right$(CrStr$(1), Len(CrStr$(1)) - 1)
      If CrStr$(2) <> "" Then CrStr$(2) = Right$(CrStr$(2), Len(CrStr$(2)) - 1)
      If CrStr$(3) <> "" Then CrStr$(3) = Right$(CrStr$(3), Len(CrStr$(3)) - 1)
    
      a$ = a$ & "Resp. Error in Crates:" & Chr$(9) & CrStr$(1) & Chr$(13) & Chr$(10)
      a$ = a$ & "Fram. Error in Crates:" & Chr$(9) & CrStr$(2) & Chr$(13) & Chr$(10)
      a$ = a$ & "Fifo Error in Crates:" & Chr$(9) & Chr$(9) & CrStr$(3) & Chr$(13) & Chr$(10)
    Else
        a$ = a$ & Chr$(13) & Chr$(10)
        a$ = a$ & " Old SEDPC doesn't give more Information!"
    End If
End Sub

Function LocalPC$()
    Dim ServPC$
    ServPC$ = Environ$("computername")
    If (Left$(ServPC$, 3) = "MST") Then ServPC$ = Replace$(ServPC$, "MST", "", 1, 1)
    If (Left$(ServPC$, 5) = "ACCNT") Then ServPC$ = Replace$(ServPC$, "ACCNT", "", 1, 1)
    If (Left$(ServPC$, 5) = "ACCXP") Then ServPC$ = Replace$(ServPC$, "ACCXP", "", 1, 1)
    LocalPC$ = ServPC$
End Function
Sub SedacGetLines(Serv$, LinStr$, LinCnt%, LinAr$(), Lins%(), check$)
    
    Dim Ad%(MAX_NUMBER_OF_LINES)
    Dim hWnd&, i%, j%, ModNo%, lin%
    Dim iSedErr%
    Dim ReplyFlag%
    Dim LinArr$(), Stri$
    Dim SedacLinStrReturn(500) As Byte
    
    If Serv$ = LocalPC$ Then
      
    '   Local: Get Sedac Lines of this PC
        
        hWnd& = frmSedFun.hWnd   ' Window handle number
        LinStr$ = ""
        ReDim Lins%(MAX_NUMBER_OF_LINES)
        
        Call SedIni(hWnd&, App.EXEName, LinCnt%, Lins%(1), Ad%(1), iSedErr%)
        check$ = "ok"
        If LinCnt% = 0 Then check$ = "No SEDPC Environment Variable!": Exit Sub
        If iSedErr% = 2048 Then check$ = "GiveIO not running!" Else If iSedErr% <> 0 Then check$ = "Error #" & iSedErr% & " in SedIni"
        
        If (LinCnt% > 0) Then
            ReDim LinAr$(LinCnt%)
            For i% = 1 To LinCnt%
              If Ad(i%) > 0 Then
                LinAr$(i%) = "Line " & Lins(i%) & " [" & Hex$(Ad(i%) And &HFFF) & "], Module Type: SEDPC"
              Else
                ModNo% = (Ad(i%) And &H7000) / &H1000
                LinAr$(i%) = "Line " & Lins(i%) & " [" & Hex$(Ad(i%) And &HFFF) & "." & ModNo% & "]; d.h. Module Number " & ModNo% & ", Module Type: SED1PC or SED2PC"
              End If
              If i = 1 Then
                LinStr$ = LinAr$(i%)
              Else
                LinStr$ = LinStr$ & Chr$(10) & LinAr$(i%)
              End If

'              If Lins%(i% - 1) = Lin% Then Found% = True
            Next i%
        End If
        
    Else
        
    ' Remote: Get Sedac Lines of this PC
        For j% = 1 To MAX_NUMBER_OF_LINES
            frmSedFun!ACOP1.DeviceContext = "HERA.SEDAC"
            frmSedFun!ACOP1.DeviceProperty = "GetLines"
            frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(j%, "0") & "_SedL"
            frmSedFun!ACOP1.AccessMode = "READ"
            ReplyFlag% = frmSedFun!ACOP1.Execute(SedacLinStrReturn, 500, "BYTE")
            
            If ReplyFlag% = 0 Then
                i% = 0
                Do While SedacLinStrReturn(i%) <> 0 And i% < 500
                    LinStr$ = LinStr$ & Chr$(SedacLinStrReturn(i%))
                    i% = i% + 1
                Loop
                LinArr$() = Split(LinStr$, Chr$(10))
                LinCnt% = UBound(LinArr$) + 1
                ReDim Lins%(LinCnt%), LinAr$(LinCnt%)
    
                For i% = 1 To LinCnt% - 1
                    Stri$ = Trim$(Replace(LinArr$(j%), "Line", ""))
                    Lins%(i%) = Val(Stri$)
                    LinAr$(i%) = LinArr$(i%)
                Next i%
                If LinCnt% > 0 Then
                    check$ = LinArr$(0)
                    Exit For
                Else
                    check$ = no_such_line
                End If
            Else
                check$ = no_such_line
            End If
        Next j%
    End If


End Sub
Sub SedacClearAllCounters(Serv$, lin%, check$)
           
    Dim iSedErr%
    Dim ReplyFlag%
    Dim FilNo%, Filna$
    
    If Serv$ = LocalPC$ Then
      
    ' Local Sedac Clear
        
       
        Call SedCac(lin%, iSedErr%)
        
        Call ErrorHandling(iSedErr%, "SedCac", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
            On Error Resume Next
            FilNo% = FreeFile
            Filna$ = "c:\prot\Sedac\LClrDat.txt"
            Open Filna$ For Output As FilNo%
                If Err <> 0 Then check$ = Error(Err)
                Print #FilNo%, Now
            Close FilNo%
            On Error GoTo 0

        End If

    
        If frmSedFun.Check1 Then
            Call SedErrProt("ClearCnt", lin, ERR_SEDDLY, ERR_SEDDLY, iSedErr)
        End If
    
    
    Else
        
        frmSedFun!ACOP1.DeviceProperty = "ClrCount"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute
        check$ = frmSedFun!ACOP1.status
    End If
'
End Sub
Sub SedacGetAllStatus(Serv$, lin%, a$, B$, c$, CrStr$(), check$)
            
    Dim LinID$, iSedErr%
    Dim ReplyFlag%
    Dim fcr%, su%, dat%
    Dim StrArr$()
    Dim SedacLiStatReturn As String * 1200

        If Serv$ = LocalPC$ Then
      
    ' Local Sedac Read
        
        Call GetAllStatus(Serv$, lin%, a$, B$, c$, CrStr$(), check$)

        If frmSedFun.Check1 Then
            Call SedErrProt("GetAllStatus", lin%, ERR_SEDTST, ERR_SEDTST, iSedErr%)
        End If

    Else
        
    ' Remote Sedac Read
        
        
        frmSedFun!ACOP1.DeviceProperty = "AllStat"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacLiStatReturn, 1200, "TEXT")
        
        If ReplyFlag% = 0 Then
'            Dim i%, d$
'            i% = 0
'            Do While SedacLiStatReturn(i%) <> 0 And i% < 1200
'                d$ = d$ & Chr$(SedacLiStatReturn(i%))
'                i% = i% + 1
'            Loop
            
            StrArr$() = Split(SedacLiStatReturn$, "@")
            check$ = StrArr$(0)
            B$ = StrArr$(1)
            a$ = StrArr$(2)
            c$ = StrArr$(3)
        Else
            check$ = frmSedFun!ACOP1.status
        End If
    End If
End Sub


'
'************************************ Call Get Sedac TestTel  *********************************************
'
'
Sub SedacGetTestTel(Serv$, lin%, sval$, check$)
    
    Dim fcr%, su%, dat%
    Dim ReplyFlag%
    Dim iSedErr%
    Dim StrArr$()
    Dim SedacGetTestTelReturn(50) As Byte
    
    If Serv$ = LocalPC$ Then
      
    ' Local Sedac Read
        
        Call SedTst(lin%, 8, fcr%, su%, dat%, iSedErr%)
        Call ErrorHandling(iSedErr%, "SedTst", Serv$, lin%, lin%, lin%, check$)
        If check$ = "ok" Then
            If fcr% = 0 Then
                sval$ = "Keine Testtelegramme"
            Else
                sval$ = "Testtelegramme mit fcr=" & fcr% & ",su=" & su% & ",dat=" & dat%
            End If
        End If
    
    
        If frmSedFun.Check1 Then
            Call SedErrProt("TestTelOff", lin, ERR_SEDTST, ERR_SEDTST, iSedErr)
        End If
    
    
    Else
        
    ' Remote Sedac Read
        
        frmSedFun!ACOP1.DeviceProperty = "GetTstTl"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(SedacGetTestTelReturn, 50, "BYTE")
        
        If ReplyFlag% = 0 Then
            
            StrArr$() = Split(BSTR(SedacGetTestTelReturn), Chr$(10))
            check$ = StrArr$(0)
            sval$ = StrArr$(1)
        Else
            check$ = frmSedFun!ACOP1.status
        End If
   End If
     
End Sub


'
'************************************ Call Sedac TestTel On *********************************************
'
'
Sub SedacTestTelOn(Serv$, lin%, check$)
        
    Dim ReplyFlag%, iSedErr%
    
    If Serv$ = LocalPC$ Then
      
    ' Local Sedac Read
        
        Call SedTst(lin%, 3, &HC0, 0, 0, iSedErr%)
        Call ErrorHandling(iSedErr%, "SedTst", Serv$, lin%, lin%, lin%, check$)
    
        If frmSedFun.Check1 Then
            Call SedErrProt("TestTelOn", lin%, ERR_SEDTST, ERR_SEDTST, iSedErr%)
        End If

    Else
        
    ' Remote TestTelegamme on
        
        frmSedFun!ACOP1.DeviceProperty = "TstTelOn"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute
        check$ = frmSedFun!ACOP1.status
        If check$ = "" Then check$ = "ok"
    End If
     
End Sub

'
'*****************************  Call Sedac Write ***************************************
'
'
Sub SedacWrite(Serv$, lin%, cra%, reg%, SedVal&, check$)
                
    Dim iSedErr%
    Dim isedval%
    Dim Li%, cr%, rg%
    Dim ReplyFlag%
    Dim SedacWrArgument As SedacWriteArg
    
    If cra% < 0 Or cra% > 63 Then check$ = ADRESS_ERROR:    Exit Sub
    If reg% < 0 Or reg% > 255 Then check$ = ADRESS_ERROR:   Exit Sub
    If SedVal& > 65535 Then check$ = RANGE_ERROR:           Exit Sub    'check data format
    If SedVal& < 0 Then check$ = RANGE_ERROR:               Exit Sub
    
    If Serv$ = LocalPC$ Then
    
        ' Local Sedac Write

        If SedVal& > &H7FFF& Then
          isedval% = CInt(SedVal& - &HFFFF& - 1)
        Else
          isedval% = CInt(SedVal&)
        End If
        Li% = lin%: cr% = cra%: rg% = reg%
        Call SedWr(Li%, cr%, rg%, isedval%, iSedErr%)
        Call ErrorHandling(iSedErr%, "SedWr", Serv$, lin%, cra%, reg%, check$)

        If frmSedFun.Check1 Then
            Call SedErrProt("SingWrit", lin, cra, reg, iSedErr)
        End If
    
    Else

    ' Remote Sedac Write
      
        check$ = ""
    
        SedacWrArgument.Crate = cra%
        SedacWrArgument.SubAdress = reg%
        SedacWrArgument.Value = SedVal&
        
        frmSedFun!ACOP1.DeviceProperty = "SedacWrite"
        frmSedFun!ACOP1.DeviceName = Serv$ & "_" & Format$(lin%, "0") & "_SedL"
        frmSedFun!ACOP1.AccessMode = "READ"
        ReplyFlag% = frmSedFun!ACOP1.Execute(, , , SedacWrArgument.Crate, Len(SedacWrArgument), "STRUCT")
            
        If ReplyFlag% = 0 Then
                check$ = "ok"
        Else
            check$ = ConvIntErrToCheck$(ReplyFlag%)
        End If
    End If
         
End Sub

Sub SedErrProt(Serv$, lin%, cra%, reg%, sederr%)
        
'    frmSedFun!Send1.RemotePC = frmSedFun!Send1.LocalPC
'    frmSedFun!Send1.RemoteID = "SedProt"
'    frmSedFun!Send1.Property = "SedSErr"
'    frmSedFun!Send1.LineAdr(1) = lin%
'    frmSedFun!Send1.CrateAdr(1) = cra%
'    frmSedFun!Send1.SubAdr(1) = reg%
'    frmSedFun!Send1.SValue(1) = 0
'    frmSedFun!Send1.SFlag(1) = sederr%
'    frmSedFun!Send1.SedacMsg = 1

End Sub


