Attribute VB_Name = "VBEQPLib"
'==========================================================
'==                                                      ==
'==        Global constants of general use               ==
'==                                                      ==
'==========================================================

Global Const RED = &HFF&
Global Const DRED = &H80&
Global Const BLUE = &HFF0000
Global Const DBLUE = &H800000
Global Const GREEN = &HFF00&
Global Const DGREEN = &H8000&
Global Const WHITE = &HFFFFFF
Global Const BLACK = &H0&
Global Const YELLOW = &HFFFF&
Global Const PINK = &HF000F0
Global Const LPINK = &HFF00FF
Global Const DPURPLE = &HFF00FF
Global Const LGREY = &HC0C0C0
Global Const DGREY = &H808080
'Half Saturated: (256 Color Palette)
Global Const LRED = &H8080FF
Global Const LGREEN = &H80FF80
Global Const LBLUE = &HFF8080
Global Const LYELLOW = &H80FFFF
Global Const LCYAN = &HFFFF80
Global Const LMAGENTA = &HFF80FF
'Very Light (256 Color Palette) S. Herb 25.09.98
Global Const VLGREEN = &HC0FFC0
Global Const VLORANGE = &HC0E0FF

Global Const CF_DOUBLE = 512
Global Const CF_INTEGER = 513
Global Const CF_SHORT = 513
Global Const CF_BYTE = 514
Global Const CF_LONG = 515
Global Const CF_TEXT = 516
Global Const CF_FLOAT = 517
Global Const CF_POCALBLK = 518
Global Const CF_STRUCT = 519
Global Const CF_CHAR8 = 520
Global Const CF_STRING8 = 520
Global Const CF_NAME8 = 520
Global Const CF_CHAR16 = 521
Global Const CF_STRING16 = 521
Global Const CF_NAME16 = 521
Global Const CF_CHAR16FI = 522
Global Const CF_BIT = 523
Global Const CF_HITTS = 524
Global Const CF_CHAR32 = 525
Global Const CF_STRING32 = 525
Global Const CF_NAME32 = 525
Global Const CF_FI = 526
Global Const CF_FLTINT = 526
Global Const CF_II = 527
Global Const CF_LI = 527
Global Const CF_LL = 527
Global Const CF_INTINT = 527
Global Const CF_LNGINT = 527
Global Const CF_DI = 528
Global Const CF_DBLINT = 528
Global Const CF_SI = 529
Global Const CF_SHTINT = 529
Global Const CF_TDS = 530
Global Const CF_IFI = 530
Global Const CF_CHAR48 = 531
Global Const CF_NAME48 = 531
Global Const CF_STRING48 = 531
Global Const CF_CHAR8I = 532
Global Const CF_NAME8I = 532
Global Const CF_CHAR16I = 533
Global Const CF_NAME16I = 533
Global Const CF_CHAR32I = 534
Global Const CF_NAME32I = 534
Global Const CF_CHAR48I = 535
Global Const CF_NAME48I = 535

Global Const CF_USTRING = 536
Global Const CF_XYS = 537
Global Const CF_FFI = 537
Global Const CF_FLTFLTINT = 537
Global Const CF_FILTER = 538
Global Const CF_IFFF = 539
Global Const CF_INTFLTFLTFLT = 539
Global Const CF_SPECTRUM = 540

Global Const CF_NULL = 767

Global Const CM_CANCEL = 0
Global Const CM_SINGLE = 1
Global Const CM_REFRESH = 2
Global Const CM_POLL = 3
Global Const CM_REGISTER = 4

Type FLTINT
 fval As Single
 ival As Long
End Type

Type SHTINT
 sval As Integer
 ival As Long
End Type

Type LNGINT
 lval As Long
 ival As Long
End Type

Type DBLINT
 dval As Double
 ival As Long
End Type

Type NAME8
  nam(7) As Byte
End Type

Type NAME16
  nam(15) As Byte
End Type

Type NAME16I
  nam(15) As Byte
  ival As Long
End Type

Type NAME32
  nam(31) As Byte
End Type

Type NAME32I
  nam(31) As Byte
  ival As Long
End Type

Type CHAR16FI 'S. Herb, 25.09.98
  nam(15) As Byte
  f As Single
  i As Long
End Type

Type FSTRUCT
  date As Integer
  time As Integer
  fname(7) As Byte
End Type

'==========================================================
'==                                                      ==
'==       Kernel routines for determining multiple usage ==
'==                                                      ==
'==========================================================

'Declare Function GetModuleHandle% Lib "Kernel" (ByVal IpProgramName$)
'Declare Function GetModuleUsage% Lib "Kernel" (ByVal hProgram%)
' Please use
'
'    ActivatePrevInstance in the WIN32 World !!
'    (Preferred over App.PrevInstance)
'
'    e.g. :  In form_load include something like:
'
'If ActivatePrevInstance(Me.hWnd, Me.Caption) Then End ' Found and activated previous instance
'
'

'==========================================================
'==                                                      ==
'==         Work Station Environment Routines            ==
'==                                                      ==
'==========================================================
Type nameList
  name As String * 48
End Type

'==========================================================
'==                                                      ==
'==         network routines for data acquisition        ==
'==                                                      ==
'==========================================================

Type rpctext
  text As String * 80
End Type
Dim netuser As String * 16

Type DBLK
  dArrayLength As Long
  dFormat As Integer
  reserved As Integer
  dTag(7) As Byte
End Type

'Direct inteface routines: (But use ACOP if you can)
'Note: the direction "in" and "out" are in the context of the Server,
'      that is: datain is input to the server (what you are sending to it)
'      and dataout is output from the server (what you are receiving from it)

Declare Function T_EXECLINK Lib "tinecln32.dll" (ByVal devName$, ByVal devprop$, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal acc%, ByVal timeout&) As Integer
Declare Function T_OPENLINK Lib "tinecln32.dll" (ByVal hWnd&, ByVal devName$, ByVal devprop$, dout As DBLK, din As DBLK, datain As Any, ByVal acc%, ByVal timer&, ByVal mode%) As Integer

'
' Legacy routines:
'
'Define Arguments in function call RPC (13.08.97)
'Eqm$ "EQPNAME" (points to REC and Server Task) [ now max of 16 characters ]
'Eqno% Equipment number (if server supports multiple devices)
'prop$ "PROPERTY"  VB string with up to 32 characters (now)
'num%  (number of data requested (ie array dimension for dat) SIGN, next line !!
'For READ, num%>0  , for WRITE, num% = -1*(array dimension) !!!!
'dat   (user defined array for data transfer - must be big enough !!)
'datasize (size of data transfer array in bytes ( for VB, use len(dat) )
'format  ( pktr datatype - CF_SHORT, CF_LONG, etc, see definitions above)
Declare Function RPC Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function RPCEx Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%, ByVal timeout&) As Integer
Declare Function HOTRPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%) As Integer
Declare Function CLOSERPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal id%) As Integer
Declare Function GETRPC Lib "tinecln32.dll" (ByVal id%, dat As Any) As Integer
Declare Function PUTRPC Lib "tinecln32.dll" (ByVal id%, dat As Any) As Integer
Declare Function GETRPCDATA Lib "tinecln32.dll" (ByVal id%, dat As Any, ts&) As Integer
Declare Function RPCERR Lib "tinecln32.dll" (ByVal errno%, ByVal errstr$) As Integer
Declare Function GETGLOBAL Lib "tinecln32.dll" (ByVal Keyword$, dat As Any, ByVal size%, ByVal fmt%) As Integer
Declare Function GETUSER Lib "tinecln32.dll" (ByVal user$) As Integer
Declare Function SUBSCRIBE Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%, ByVal mode%) As Integer
Declare Function A_RPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function SA_RPC Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function S_RPC Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function FILLSTRUCT Lib "tinecln32.dll" (ByVal structTag$, ByVal structSize%, ByVal maxArraySize%, ByVal fmt%) As Integer
Declare Function GETSTRUCTSIZE Lib "tinecln32.dll" (ByVal structTag$) As Long
Declare Function RPCGETLASTERR Lib "tinecln32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTERROR Lib "tinecln32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTSOURCE Lib "tinecln32.dll" (ByVal srcstr$) As Integer

' This is the original (ugh!) 'PAINT' API :  (use ACOP if you can)
' --------------------------------------------------------
' | to get the client username, you can also use the call:
' |
' |     user$ = username()
' |
' --------------------------------------------------------

' -----------------------------------------
' | Hot Link example (Asynchronous Call): |
' -----------------------------------------
'
' -----------------------------------------
' | 1). Register Link (e.g. in form_load) |
' -----------------------------------------
'      hotID% = HOTRPC(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER)
' OR:
'      hotID% = SUBSCRIBE(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER, CM_REFRESH)
'
' '    registers a Hot Link for:
' '       equipment function EQP$, equipment number EqNo%,
' '       property prop$, polling rate 5000 milliseconds,
' '       equipment size of 100 data elements,
' '       data element format CF_INTEGER
' '    SUBSCRIBE is a more general routine in that you can
' '       also specify the data acquisition mode:
' '       CM_SINGLE  - is a one-shot (i.e. COLD link)
' '                    asynchronous call
' '       CM_REFRESH - specifies a polling rate to the FEC
' '                    but receives data only when they have
' '                    changed (with a heartbeat of 60 sec)
' '                    good for status calls, etc.
' '       CM_POLL    - receives data at the given polling
' '                    rate.
' '       CM_CANCEL  - cancels the subscription
' '    HOTRPC   is identical to SUBSCRIBE with CM_POLL
' '    CLOSERPC is identical to SUBSCRIBE with CM_CANCEL
'
' -----------------------------------------
' | 2). In the paint routine of given form
' |     (here form1) include:
' -----------------------------------------
'
'      If hotID% > 0 Then
'        hotrc% = GETRPC(hotID%, dat%(0))
'        Select Case hotrc%
'          Case Is > 0: rpcerrbox.visible = True 'signal RPC error
'          Case 0: rpcerrbox.visible = False
'                  call updateData               'called when there are new data
'        End Select
'      End If
'
' '    retrieves the incoming data and puts them into array
' '    dat%(), beginning at dat%(0).  You must insure that
' '    dat%() is large enought to hold the amount of data
' '    you request
'
' --------------------------------------------------------
' | rpcerrbox is a picture box with a red RPC icon        |
' | when clicked you can give the most recent return code:|
' --------------------------------------------------------
'
'     rc% = RPCERR(hotrc%, errstr)
'     If rc% Then MsgBox "RPC: " + RPCERROR(rc%)
'
' ----------------------------------------
' | in form_unload() be sure to include: |
' ----------------------------------------
'
'    If CLOSERPC(form1.hWnd, hotID%) Then
'       msgbox"Error closing hot link!"
'    End If
'    End
'
'
' ----------------------------------------
' | Cold Link Example (Synchronous Call): |
' ----------------------------------------
'
'    rc% = RPC(EQP$, EqNo%, prop$, NPOINTS, data%(0), 8 * NPOINTS, CF_DOUBLE)
'    If rc% Then
'      MsgBox "RPC: " + RPCERROR(rc%)
'    Else
'      Call updataData
'    End If
'

'==========================================================
'==                                                      ==
'==         General purpose plotting routines            ==
'==                                                      ==
'==========================================================

' -------------------------------------------------
'   For quick plotting, it is strongly suggested that
'   you use the routine DRAWXY described below
'   Several other routines are also given (for historical
'   reasons)
' -------------------------------------------------

Declare Sub drawtrace Lib "utils32.dll" (ByVal hdc&, l%, ByVal n%, ByVal ym%)

' -------------------------------------------------
' | plots the trace array (e.g. x%()) vs its index |
' | from 0 to NPOINTS - 1                          |
' |  e.g.                                          |
' -------------------------------------------------
'
'    Call DRAWTRACE(picture1.hDC, x%(0), NPOINTS, YMAX)
'

Declare Sub drawtime Lib "utils32.dll" (ByVal hdc&, ByVal X%, ByVal Y%)
Declare Sub HISTOGRAM Lib "utils32.dll" Alias "HISTO" (ByVal hdc&, a!, ByVal aMAX!, ByVal npts%, ByVal wdth%, ByVal offset%, ByVal mode%)

' ---------------------------------------------------
' | mode% = 0 plots positive values only            |
' | mode% = 1 plots negative and positive values    |
' | wdth% gives the spacing between histogram lines |
' | offset% gives the starting position             |
' | e.g.                                            |
' ---------------------------------------------------
'
'    Call HISTO(picture1.hDC, loss(2), ymax, numBLM%, 2, 0, 0)
'
'
Declare Sub PLOTXY Lib "utils32.dll" (ByVal hdc&, Y!, ByVal ymax!, ByVal ymin!, X!, ByVal npts%)

' ----------------------------------------
' | plots array x() vs array y(), e.g.   |
' ----------------------------------------
'
'    Call PLOTXY(picture1.hDC, y(0), ymax, ymin, x(0), npts%)
'
Declare Sub DRAWXY Lib "utils32.dll" (ByVal hdc&, Y!, ByVal ymax!, ByVal ymin!, X!, ByVal npts%, ByVal mode%)
Declare Sub WINDOWXY Lib "utils32.dll" (ByVal hdc&, Y!, ByVal ymax!, ByVal ymin!, X!, ByVal xmax!, ByVal xmin!, ByVal npts%, ByVal mode%)

' ---------------------------------------------------------------
' | plots array x() vs array y() according to given mode, e.g.   |
' | x() and y() both float arrays
' |
' |  MODE:  type of display:
' |     0     connect-the-dots
' |     1     bar-graph
' |     2     histogram
' |     3     individual points
' ---------------------------------------------------------------
'
'    Call DRAWXY(picture1.hDC, y(0), ymax, ymin, x(0), npts%, 0)
'
' ---------------------------------------------------------------
' | WINDOWXY allows you to specify the x-axis window through
' | the xmax and xmin parameters, DRAWXY calculates them for you
' ---------------------------------------------------------------
'
Declare Sub ARRMULT Lib "utils32.dll" (ByVal typ%, a As Any, ByVal v As Double, ByVal num%)
'
' -----------------------------------------------------
' | multiplies given array by given value according to |
' | specified type: CF_INTEGER,CF_FLOAT,CF_LONG,       |
' | CF_DOUBLE                                          |
' -----------------------------------------------------
'
'   Call ARRMULT(CF_FLOAT, f(0), x!, npts%)
'
Declare Sub MEMCPY Lib "utils32.dll" (dst As Any, src As Any, ByVal nBytes%)
Declare Function MEMCMP Lib "utils32.dll" (dst As Any, src As Any, ByVal nBytes%) As Integer
Declare Sub ITOF Lib "utils32.dll" (dst!, src%, ByVal num%, ByVal scl!)
Declare Sub LTOF Lib "utils32.dll" (dst!, src&, ByVal num%, ByVal scl!)
Declare Function MEAN Lib "utils32.dll" (arr!, avearr!, ByVal num%, ByVal depth%) As Integer
Declare Function NORM Lib "utils32.dll" (newarr!, avearr!, ByVal num%) As Integer

' ---------------------------------------
' | scales integer array ix%() (ITOF) or |
' | lx&() (LTOF) by xscale!              |
' | puts the result in float array fx()  |
' ----------------------------------------
'
'    call ITOF(fx!(0), ix%(0), npts%, xscale!)
'    call LTOF(fx!(0), lx&(0), npts%, xscale!)
'
Declare Function GETBIT Lib "utils32.dll" (ByVal wrd%, ByVal BIT%) As Integer
Declare Function GET32BIT Lib "utils32.dll" (ByVal wrd&, ByVal BIT%) As Integer

' --------------------------------------------
' |   returns value of specified bit (0 or 1) |
' --------------------------------------------

Declare Function SETBIT Lib "utils32.dll" (ByVal wrd%, ByVal BIT%) As Integer

' -----------------------------------------------------
' |   sets specified bit to 1 and returns the new word |
' -----------------------------------------------------

Declare Function CLEARBIT Lib "utils32.dll" (ByVal wrd%, ByVal BIT%) As Integer

' -----------------------------------------------------
' |   sets specified bit to 0 and returns the new word |
' -----------------------------------------------------

Type TM
  tm_sec As Long   '0 - 59
  tm_min As Long   '0 - 59
  tm_hour As Long  '0 - 23
  tm_mday As Long  'day of month (1 - 31)
  tm_mon As Long   'use 1 = Jan., 12 = Dec.
  tm_year As Long  'either 1998 or 98 will work
  tm_wday As Long  ' not used
  tm_yday As Long  ' not used
  tm_isdst As Long ' not used
End Type

Declare Function CONVTIME Lib "utils32.dll" (ByVal dat$, ByVal LONGtime&) As Integer
Declare Sub CTIME Lib "utils32.dll" (ByVal dat As String, ByVal LONGtime As Long)
Declare Function MKTIME Lib "utils32.dll" (t As TM) As Long

' -----------------------------------------------------
' | returns ascii time string with current time and date |
' | given the unix time constant LONGtime&               |
' | be sure to reserve space for dat$ in global.bas      |
' -----------------------------------------------------
'      global dat as string * 25
'
'      rc% = CONVTIME(dat, timen&)

Declare Function UNIXTIME Lib "utils32.dll" () As Long

' -----------------------------------------------------
' | converts Byte array to UNICODE string and vice versa |
' -----------------------------------------------------

Declare Sub Bytes2String Lib "utils32.dll" (ByVal S$, byteArray As Byte, ByVal numBytes%)
Declare Sub String2Bytes Lib "utils32.dll" (byteArray As Byte, ByVal S$, ByVal numBytes%)

'==========================================================
'==                                                      ==
'==     archive retrieval routines following LPC format  ==
'==                                                      ==
'==========================================================
Type ADRB
  eventNumber As Long
  StartTime As Long
  StopTime As Long
  deviceServerName(15) As Byte
  deviceProperty(15) As Byte
  deviceName(15) As Byte
  dataFormat As Integer
  dataDimension As Integer
End Type

Type APCBLK
  sessionID As Long
  Event As Long
  Ext(3) As Byte
  EqpName(15) As Byte
  devName(15) As Byte
  devProperty(31) As Byte
  dsize As Integer
  dFormat As Integer
End Type

Type ARS
  StartTime As Long
  idx As Integer
  mins As Integer
  Keyword(15) As Byte
End Type

Type PropertyQuery
  prpName(31) As Byte
  prpDesc(31) As Byte
  prpSize As Integer
  prpFormat As Byte
  prpAccess As Byte
End Type

Type AMS            ' Alarm Message Structure
Tag(15) As Byte
device(15) As Byte
almTag(15) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmData(5) As Byte
alarmDataFormat As Byte
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
alarmSystem As Integer
End Type

Type DHS
channelID(31) As Byte
eventCode As Long
arraySize As Integer
dataType As Integer
samplingRate As Single
preTrigger As Long
timeOffset As Long
lowCount As Long
highCount As Long
egu(15) As Byte
eguLow As Single
eguHigh As Single
reserved(3) As Byte
desc(255) As Byte
End Type

Declare Function LOADEQP Lib "apc32.dll" (ByVal fileName$, ByVal yr%) As Integer
Declare Function CLOSEEQP Lib "apc32.dll" () As Integer
Declare Function LPC Lib "apc32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal size%, d As Any, ByVal dsize%, ByVal fmt%) As Integer
Declare Function apc Lib "apc32.dll" Alias "APC" (ByVal eqm$, ByVal dev$, ByVal prop$, ByVal size%, d As Any, ByVal fmt%) As Integer
Declare Function A_LPC Lib "apc32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function FILER Lib "apc32.dll" (ByVal fname$, f As FSTRUCT, ByVal num%, ByVal yr%) As Integer
Declare Function READCMT Lib "apc32.dll" (ByVal cmt$, ByVal fileName$, ByVal yr%) As Integer
Declare Function WRITECMT Lib "apc32.dll" (ByVal cmt$, ByVal fileName$, ByVal yr%) As Integer
Declare Function REMOVE Lib "apc32.dll" (ByVal fileName$, ByVal yr%) As Integer

'==========================================================
'==                                                      ==
'==         HERA DATA Retrieval routines                 ==
'==                                                      ==
'==========================================================

Declare Function FETCH Lib "apc32.dll" (ByVal Keyword$, ByVal Index%, ByVal start&, ByVal Minutes%, ByVal size%, dat As Any, tstamp&) As Integer
Declare Sub FTIME Lib "apc32.dll" (dst!, src&, ByVal shft&, ByVal num%)
Declare Sub ARRLOG Lib "apc32.dll" (dst!, src!, ByVal num%)
Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer

'==========================================================
'==                                                      ==
'==         windows unzipping routine                    ==
'==                                                      ==
'==========================================================

Declare Function UNZIP Lib "unzip32.dll" (ByVal filenm$, ByVal outpath$) As Integer

'==========================================================
'==                                                      ==
'==         Network utilities                            ==
'==                                                      ==
'==========================================================

Declare Function PingRemoteHost Lib "ping32.dll" (ByVal hostname$) As Long

'==========================================================
'==                                                      ==
'==            Math routines                             ==
'==                                                      ==
'==========================================================

Declare Function FFT Lib "utils32.dll" (ByVal num%, x_arr!, f_arr!, q_max!, ByVal percent!, ByVal cut!) As Integer

'==========================================================
'==
'==              Net Globals
'==
'==========================================================

Global HPENERGY As Integer   'Hera Proton energy
Global HPCURRENT As Double   'Hera Proton Beam Current
Global HPTAU     As Double   'Hera Proton Beam Lifetime
Global HEENERGY As Integer   'Hera Electron energy
Global HECURRENT As Double   'Hera Electron Beam Current
Global HETAU     As Double   'Hera Electron Beam Lifetime

' The associated get routines are:
'     HERAGetEnergy(typ$)
'     HERAGetCurrent(typ$)
'     HERAGetLifetime(typ$)
' where typ$ is either "PROTON" or "ELECTRON"
' the above varables are then updated
'
' e.g. To get the current HERA Proton magnet energy:
'
'    rc% = HERAGetEnergy("PROTON")
'    If rc% Then
'      MsgBox "RPC Error : " + RPCERROR(rc%)
'    Else
'      MsgBox "Then energy in HERA P is: " + str$(HPENERGY)
'    End If
'

'===========================================================
'==
'==        Some Win32 API Declares ....
'==
'===========================================================
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function FindWindow Lib "USER32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function FindWindowEx Lib "USER32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Declare Function GetWindowText Lib "USER32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Declare Function SetForegroundWindow Lib "USER32" (ByVal hWnd As Long) As Long
Declare Function ShowWindow Lib "USER32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Declare Function ShowWindowAsync Lib "USER32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Public Const SW_RESTORE = 9
'==========================================================
'==
'==              Printer & GDI Routines
'==
'==========================================================


    ' Paperorientation Portrait <-> Landscape
    Type OrientStructure
      Orientation As Long
      pad As String * 16
    End Type
    '
    Declare Function Escape% Lib "GDI" (ByVal hdc&, ByVal nEsc%, ByVal nLen%, lpData As OrientStructure, lpOut As Any)
    

Function MAPFIRSTDRIVE(ByVal fs$, ByVal Path$) As Integer
 MAPFIRSTDRIVE = 8
End Function
Function GETFIRSTDRIVE() As Integer
 GETFIRSTDRIVE = 8
End Function
Function MAP(ByVal drive%, ByVal fs$, ByVal Path$) As Integer
 MAP = 0
End Function
Function FINDMAP(ByVal fs$, ByVal Path$) As Integer
FINDMAP = 8
End Function
Function ATTACH(ByVal fs$, ByVal un$, ByVal pw$) As Integer
' this is a KLUGE
ATTACH = 0
End Function
Function GETCURRENT() As Double
Static er As String * 80
rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
If rc% = 0 Then
  GETCURRENT = HPCURRENT
Else
  rc% = RPCERR(rc%, er$)
  MsgBox "GETCURRENT: " + er$
End If
End Function

Function GETENERGY() As Integer
Static er As String * 80
rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
If rc% = 0 Then
  GETENERGY = HPENERGY
Else
  rc% = RPCERR(rc%, er$)
  MsgBox "GETENERGY: " + er$
End If
End Function

Function HERAGetCurrent(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
       If HPCur < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HECur", HECURRENT, 1, CF_DOUBLE)
       If HECur < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetCurrent = rc%
End Function

Function HERAGetEnergy(ByVal t$) As Integer
Static hemagen As Single
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
       If HPENERGY < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEMAGEN", hemagen, 1, CF_FLOAT)
       HEENERGY = CInt(hemagen)
       If HEENERGY < 0 Then rc% = 91
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetEnergy = rc%
End Function

Function HERAGetLifetime(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPtau", HPTAU, 1, CF_DOUBLE)
       If HPTAU < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEtau", HETAU, 1, CF_DOUBLE)
       If HETAU < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetLifetime = rc%
End Function


Function IsCleared(UserFile$, UserName$) As Integer
Dim a$
FileNumber = FreeFile   ' Get unused file
On Error GoTo OpenError
Open App.Path$ + "\" + UserFile$ For Input Access Read Shared As #FileNumber
On Error GoTo 0
Input #1, a$  ' Header
done = False: IsCleared = False
While Not EOF(1) And Not done
  Input #1, a$
  If a$ = UserName$ Then
    IsCleared = True
    done = True
  End If
Wend
Close (FileNumber)
Exit Function
OpenError:
MsgBox "File " + UserFile$ + " does not exist"
Exit Function
End Function
Function GetPMArchivedData(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal devName$, ByVal devProperty$, npoints As Integer, DataBuffer As Variant)
Static sessionID As Integer
Static eventTag As String
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8
Dim id() As Integer, ld() As Long, fd() As Single, dd() As Double
Static done As Boolean

If Not done Then
  FILLSTRUCT "APCBLK", Len(apc), 1, CF_NULL
  done = True
End If

rc& = 0

If eventTag <> evnTag Then ' new session
  eventTag = evnTag
  If sessionID > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK("APC/" & pmArchiveGroup$, "CLOSE", dout, 0, din, sessionID, 1, 1000)
    If rc& Then GoTo GetPMArchivedDataError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedDataError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK("APC/" & pmArchiveGroup$, "OPEN", dout, sessionID, din, evn, 2, 1000)
  If rc& Then GoTo GetPMArchivedDataError
End If
If eventTag = "" Then GoTo GetPMArchivedDataError

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

apc.sessionID = sessionID
BARR apc.EqpName(), dServerName$
BARR apc.devName(), dName$
BARR apc.devProperty(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLK"

If UBound(DataBuffer) - LBound(DataBuffer) < npoints Then
  rc& = 2
  GoTo GetPMArchivedDataError
End If

dout.dArrayLength = npoints
Select Case VarType(DataBuffer) - vbArray
  Case vbInteger:
       ReDim id(npoints)
       dout.dFormat = CF_SHORT
       rc& = T_EXECLINK("APC", "READDATA", dout, id(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = id(i%): Next
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       rc& = T_EXECLINK("APC", "READDATA", dout, ld(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ld(i%): Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       rc& = T_EXECLINK("APC", "READDATA", dout, fd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = fd(i%): Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       rc& = T_EXECLINK("APC", "READDATA", dout, dd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = dd(i%): Next
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDataError

GetPMArchivedDataError:
GetPMArchivedData = rc&
End Function

Function GetPMEventList(ByVal pmArchiveGroup$, ByVal StartTime&, ByVal StopTime&, evnList() As String, evnTime() As String) As Integer
Dim dout As DBLK, din As DBLK
Dim nevents As Integer
Dim lStartStopArray(1) As Long
Dim eventNames() As NAME8
Dim i%, rc&, tmpTime As String * 32

devName$ = "APC/" + pmArchiveGroup$
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 2: din.dFormat = CF_LONG
lStartStopArray(0) = StartTime&
lStartStopArray(1) = StopTime&
rc& = T_EXECLINK(devName, "QUERY.NFILES", dout, nevents, din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetPMEventListError

If nevents = 0 Then GoTo GetPMEventListError
ReDim eventNames(nevents - 1)

dout.dArrayLength = nevents: dout.dFormat = CF_NAME8
rc& = T_EXECLINK(devName, "QUERY.FILES", dout, eventNames(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetPMEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = BSTR(eventNames(i%).nam())
  CTIME tmpTime, CLng(Val("&H" & evnList(i%)))
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMEventListError:
GetPMEventList = IIf(rc&, -rc&, nevents)
End Function
Function ASCTIME(timestamp As Long) As String
Static tmpTime As String * 26
If timestamp < 0 Then Exit Function
CTIME tmpTime, timestamp
ASCTIME = Left$(tmpTime, 24)
End Function

Function MAKETIME(yr As Integer, mo As Integer, da As Integer, hr As Integer, se As Integer) As Long
Static t As TM
t.tm_hour = hr Mod 24
t.tm_mday = da
t.tm_mon = mo
t.tm_year = yr
t.tm_sec = se
MAKETIME = MKTIME(t)
End Function

Function GetArchivedData(ByVal Keyword As String, ByVal KeywordIndex As Integer, ByVal StartTime As Long, ByVal StopTime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean

lStartStopArray(0) = StartTime
lStartStopArray(1) = StopTime
lStartStopArray(2) = KeywordIndex

npts = StopTime - StartTime ' won't be any worse than this
npts = 150 ' start off at a reasonable number
LaunchArchiveLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK("HERAARCH", Keyword, dout, fiDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo ArchiveError
If (fiDataArray(0).ival <= npts) Or (npts > 150) Then done = True
npts = fiDataArray(0).ival
If npts > 16000 Then npts = 16000
If Not done Then GoTo LaunchArchiveLink
ReDim fDataArray(npts - 1)
ReDim lTimeArray(npts - 1)
For i = 0 To npts - 1
  fDataArray(i) = fiDataArray(i + 1).fval
  lTimeArray(i) = fiDataArray(i + 1).ival
Next
npoints = npts
ArchiveError:
GetArchivedData = rc&
End Function
Function GetEquipmentDeviceProperties(devName As String, properties() As String, nProperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQuery
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devName, "NPROPS", dbout, n, dbin, Null, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim prps(n)
dbout.dArrayLength = n * Len(prps(0)): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(devName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim properties(n)
For i% = 0 To n - 1
  properties(i%) = Trim$(BSTR(prps(i).prpName))
Next
exitFunction:
nProperties = n
GetEquipmentDeviceProperties = rc%
End Function
Function GetEquipmentDeviceNames(EqpName As String, devNames() As String, nDevices As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim nms() As NAME16
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(EqpName, "NDEVICES", dbout, n, dbin, Null, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim nms(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(EqpName, "DEVICES", dbout, nms(0), dbin, Null, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim devNames(n)
For i% = 0 To n - 1
  devNames(i%) = Trim$(BSTR(nms(i%).nam()))
Next
exitFunction:
nDevices = n
GetEquipmentDeviceNames = rc%
End Function
Sub Paperorient(to_land As Integer)

    Const PORTRAIT = 1
    Const LANDSCAPE = 2
    Const GETSETPAPERORIENT = 30
    Const myNULL = 0&
    
    Dim Orient As OrientStructure

    '* Specify the orientation
    If to_land Then Orient.Orientation = LANDSCAPE Else Orient.Orientation = PORTRAIT

    '* Send escape sequence to change orientation
    Dim dummy
    dummy = Escape(Printer.hdc, GETSETPAPERORIENT, Len(Orient), Orient, myNULL)

    Printer.EndDoc 'printer mu jetzt neue initialisiert werden

End Sub

Function RPCERROR(ByVal rc%) As String
Static rpcerrbuff As String * 80
cc% = RPCERR(rc%, rpcerrbuff)
If cc% Then
  RPCERROR = "Error undefined"
Else
  RPCERROR = Left$(rpcerrbuff, InStr(rpcerrbuff, Chr(0)) - 1)
End If
End Function

Function UserName() As String
cc% = GETUSER(netuser$)
UserName = UCase(Left$(netuser$, InStr(netuser$, Chr(0)) - 1))
End Function

Function BSTR(B() As Byte) As String
Dim S As String * 2048
Dim numBytes%
numBytes% = UBound(B) - LBound(B) + 1
If numBytes% > 2048 Then numBytes% = 2048
Call Bytes2String(S, B(LBound(B)), numBytes%)
BSTR = Left$(S, InStr(S, Chr(0)) - 1)
End Function
Function BARR(B() As Byte, S As String) As Integer
Dim numBytes%, strlen%, i%
numBytes% = UBound(B) - LBound(B) + 1
strlen% = Len(S)
If strlen% > numBytes% Then
  BARR = 0
Else
  Call String2Bytes(B(LBound(B)), S, strlen%)
  If numBytes% > strlen% Then B(strlen%) = 0
  BARR = strlen%
End If
End Function
Function colptr(S$, colstr$) As Integer
Dim tmpstr$
Dim ncommas As Integer
Dim pos As Long

ncommas = 0: tmpstr$ = S$
pos = InStr(tmpstr$, ",") - 1
If pos = -1 Then pos = Len(tmpstr$)
While (pos > 0) And (Left$(tmpstr$, pos) <> colstr$)
  ncommas = ncommas + 1
  tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
  If Left$(tmpstr$, 1) = Chr(34) Then ' trap '"'
    pos = InStr(Right$(tmpstr$, Len(tmpstr$) - 1), Chr(34)) + 1
  Else
    pos = InStr(tmpstr$, ",") - 1
  End If
  If pos = -1 Then pos = Len(tmpstr$)
Wend
colptr = ncommas
End Function
Function getcol(S$, ByVal col%) As String
Dim tmpstr$
Dim ncommas As Integer
Dim pos As Long

ncommas = 0: tmpstr$ = S$
pos = InStr(tmpstr$, ",") - 1
If pos = -1 Then pos = Len(tmpstr$)
While (pos >= 0) And (ncommas <> col%)
  ncommas = ncommas + 1
  tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
  If Left$(tmpstr$, 1) = Chr(34) Then ' trap '"'
    pos = InStr(Right$(tmpstr$, Len(tmpstr$) - 1), Chr(34)) + 1
  Else
    pos = InStr(tmpstr$, ",") - 1
  End If
  If pos = -1 Then pos = Len(tmpstr$)
Wend
getcol = IIf(ncommas = col%, Left$(tmpstr$, pos), "")
End Function
Function ActivatePrevInstance(hThisWnd As Long, WindowText As String) As Boolean
Dim i As Integer, hw&
hw& = FindWindowEx(0, hw&, vbNullString, WindowText)
For i = 0 To 1
    If hw& And hw& <> hThisWnd Then
      ShowWindowAsync hw&, SW_RESTORE
      SetForegroundWindow hw&
      ActivatePrevInstance = True
      Exit Function
    End If
    hw& = FindWindowEx(0, hw&, vbNullString, WindowText)
Next
ActivatePrevInstance = False
End Function

