Attribute VB_Name = "Alarm"
Option Explicit

Global Const almNEWALARM = &H1
Global Const almHEARTBEAT = &H2
Global Const almOSCILLATION = &H4
Global Const almDATACHANGE = &H8
Global Const almINSTANT = &H10
Global Const almTERMINATE = &H40
Global Const almTEST = &H80

Type AMS            ' Alarm Message Structure
tag(15) As Byte
device(15) As Byte
almTag(15) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmData(5) As Byte
alarmDataFormat As Byte
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
AlarmSystem As Integer
End Type

Type AMRB         ' Alarm Message Request Block
starttime As Long
stoptime As Long
severity As Long
reservered As Long
End Type

Type ASB        ' Alarm Status Block
nalarms As Long
mostRecentAlarmTime As Long
highestSeverity As Long
nalarmsAtMostRecentAlarmTime As Long
nalarmsAtHighestSeverity As Long
End Type

Type ADS
tag(15) As Byte
code As Long
mask As Long
severity As Integer
DataFormat As Byte
dataDim As Byte
timeRes As Long
hitsChannel As Integer
hitsModule As Integer
AlarmText(39) As Byte
deviceText(37) As Byte
AlarmSystem As Integer
dataText(39) As Byte
url(39) As Byte
Reserved As Long
End Type

Type CASQS
devContext(15) As Byte
devServer(15) As Byte
subSystem(15) As Byte
arcExt(15) As Byte
SeverityLevel As Long
ArchiveLevel As Long
Retention As Long
AlarmLevel As Long
AlarmSystem As Long
End Type

Declare Function appendAlarmInfoTable Lib "winsrv32.dll" (ByVal localname, localADS As ADS) As Integer
Declare Function SetMaximumAlarms Lib "winsrv32.dll" (ByVal maxnum As Integer) As Integer

Function GetAlarmDefinitions(devServer As String, adefs() As ADS, nadefs As Integer) As Integer
Dim devName$, rc%, i%, n%
Dim dout As DBLK, din As DBLK
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(devServer, "NALMDEFS", dout, n%, din, 0, CA_READ, 200)
If rc% Or n% = 0 Then GoTo GetAlarmDefinitionsError
ReDim adefs(n%)
dout.dArrayLength = n * Len(adefs(0)): dout.dFormat = CF_STRUCT
rc% = T_EXECLINK(devServer, "ALMDEFS", dout, adefs(0), din, 0, CA_READ, 200)
If rc% Then GoTo GetAlarmDefinitionsError
GetAlarmDefinitionsError:
nadefs = n%
GetAlarmDefinitions = rc%
End Function
