Attribute VB_Name = "api32"
Option Explicit

Public Type Process_def
    phandle As Long
    thandle As Long
    pid As Long
    tid As Long
    name As String
    running As Boolean
    auto_restart As Boolean
    started As Date
    stopped As Date
    hMainWindow As Long
    hMailslot As Long
    hwnds As Collection
    heart_beat As Long
    check_hbeat As Boolean
End Type

Public Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type

Public Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Public Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

Type OVERLAPPED
    Internal As Long
    InternalHigh As Long
    offset As Long
    OffsetHigh As Long
    hEvent As Long
End Type


Public Declare Function CreateProcess Lib "kernel32" _
        Alias "CreateProcessA" _
                 (ByVal lpApplicationName As String, _
                 ByVal lpCommandLine As String, _
                 lpProcessAttributes As Any, _
                 lpThreadAttributes As Any, _
                 ByVal bInheritHandles As Long, _
                 ByVal dwCreationFlags As Long, _
                 lpEnvironment As Any, _
                 ByVal lpCurrentDriectory As String, _
                 lpStartupInfo As STARTUPINFO, _
                 lpProcessInformation As PROCESS_INFORMATION) As Long

Public Declare Function OpenProcess Lib "kernel32.dll" _
                 (ByVal dwAccess As Long, _
                 ByVal fInherit As Integer, _
                 ByVal hObject As Long) As Long

Public Declare Function TerminateProcess Lib "kernel32" _
                 (ByVal hProcess As Long, _
                 ByVal uExitCode As Long) As Long

Public Declare Function CloseHandle Lib "kernel32" _
                 (ByVal hObject As Long) As Long

Public Declare Function WaitForSingleObject Lib "kernel32" _
    (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Public Declare Function WaitForInputIdle Lib "user32" (ByVal hProcess As Long, ByVal miliseconds As Long) As Long
Public Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Public Declare Function SendMessageTimeout Lib "user32" _
                        Alias "SendMessageTimeoutA" (ByVal hWnd As Long, _
                        ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long, _
                        ByVal fuFlags As Long, ByVal uTimeout As Long, _
                        pdwResult As Long) As Long
Public Declare Function CreateMailslot Lib "kernel32" _
                        Alias "CreateMailslotA" (ByVal name As String, _
                        ByVal maxMsgSize As Long, ByVal readTimeout As Long, _
                        ByVal securityAttr As Long) As Long  '''SECURITY_ATTRIBUTES) As Long
Declare Function GetMailslotInfo Lib "kernel32" (ByVal hMailslot As Long, lpMaxMessageSize As Long, _
                                                 lpNextSize As Long, lpMessageCount As Long, _
                                                 lpReadTimeout As Long) As Long
Declare Function SetMailslotInfo Lib "kernel32" (ByVal hMailslot As Long, _
                                                 ByVal lReadTimeout As Long) As Long
Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Byte, _
                                                 ByVal nNumberOfBytesToRead As Long, _
                                                 lpNumberOfBytesRead As Long, _
                                                 ByVal lpOverlapped_passNULL As Long) As Long
Public Declare Function WriteFile Lib "kernel32" _
                                         (ByVal hFile As Long, ByVal lpBuffer As String, _
                                          ByVal nNumberOfBytesToWrite As Long, _
                                          lpNumberOfBytesWritten As Long, _
                                          ByVal lpOverlapped As Long) As Long

Public Const SMTO_BLOCK = &H1
Public Const SMTO_ABORTIFHUNG = &H2
Public Const NORMAL_PRIORITY_CLASS = &H20&
Public Const WM_CLOSE = &H10
Public Const WM_NULL = &H0
Public Const WM_DESTROY = &H2


Public Const WAIT_FAILED = -1&
Public Const WAIT_OBJECT_0 = 0
Public Const WAIT_ABONDONED = &H80&
Public Const WAIT_ABONDONED_0 = &H80&
Public Const WAIT_TIMEOUT = &H102&

Public Const ERROR_TIMEOUT = &H5B4&   '1460 dec

Public Const MAILSLOT_NO_MESSAGE = (-1)
Public Const MAILSLOT_WAIT_FOREVER = (-1)

Public Nproc As Long
Public ProcList() As Process_def


Public Function findAllWindowsCallBack(ByVal hWnd As Long, ByVal pd_indx As Long) As Long
Dim lParent    As Long
Dim lThreadId  As Long
Dim lProcessId As Long
Dim err As Long

findAllWindowsCallBack = 1  ' continue EnumWindows
lThreadId = GetWindowThreadProcessId(hWnd, lProcessId)
'ignore threadID
If ProcList(pd_indx).pid = lProcessId Then
    lParent = GetParent(hWnd)
    If lParent = 0 Then
        err = GetLastError()
        If err <> 0 Then MsgBox Str(err)
        ProcList(pd_indx).hwnds.Add hWnd
    End If
End If

End Function

Public Function findMainWindowCallBack(ByVal hWnd As Long, ByVal pd_indx As Long) As Long
Dim lParent    As Long
Dim lThreadId  As Long
Dim lProcessId As Long
Dim err As Long
'
' This callback function is called by Windows (from the EnumWindows
' API call) for EVERY top-level window that exists.  It populates a
' collection with the handles of all parent windows owned by the
' process that we started.
'
findMainWindowCallBack = 1   ' continue EnumWindows
lThreadId = GetWindowThreadProcessId(hWnd, lProcessId)

If (ProcList(pd_indx).pid = lProcessId) And _
   (ProcList(pd_indx).tid = lThreadId) Then
    lParent = GetParent(hWnd)
    If lParent = 0 Then
        err = GetLastError()
        If err <> 0 Then MsgBox Str(err)
        ProcList(pd_indx).hMainWindow = hWnd
    End If
End If

End Function

Public Function findWindows(pd_indx As Long) As Boolean
'
' The EnumWindows function enumerates all top-level windows
' by passing the handle of each window, in turn, to an
' application-defined callback function. EnumWindows
' continues until the last top-level window is enumerated or
' the callback function returns FALSE.
'
Call EnumWindows(AddressOf findAllWindowsCallBack, pd_indx)
End Function

Public Function findMainWindow(pd_indx As Long) As Boolean
Call EnumWindows(AddressOf findMainWindowCallBack, pd_indx)
End Function



'add horizontal scroll to list box
''API/Global Declarations
' Declare Function SendMessage Lib "user32" Alias_
' "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long,_
' ByVal wParam As Long, lParam As Long) As Long
'
'       Const WM_USER = &H400
'       Const LB_SETHORIZONTALEXTENT = WM_USER + 21'

 'Call this procedure everytime the content of the listbox has changed
' Sub CheckListBox()

 '      Dim i%, res&
  '     Dim Scrollwidth&
'
 '  For i% = 0 To Form1.List1.ListCount
  '    If Form1.TextWidth(Form1.List1.List(i%)) > Scrollwidth& Then_
 'Scrollwidth& = Form1.TextWidth(Form1.List1.List(i%))
  ' Next i%

 'res& = SendMessage(Form1.List1.hwnd, LB_SETHORIZONTALEXTENT, _
 'Scrollwidth&, 0&)
 'End Sub
 

